-- Team6 startup script
Resolutions = { 
	n3ds = { x = 640, y = 480 },
	wii = { x = 832, y = 456},
	iphone = {x = 960, y = 640},
	ios = {x = 1024, y = 768},
	pc = {x = 1024, y = 768},
	--pc = {x = 880, y = 495},
	ps3 = {x = 1280, y = 720},
	xbox360 = {x = 1280, y = 720},
	tegra = {x = 1366, y = 768},
	custom = {x = 1024, y = 576},
	vincent = {x = 1920, y = 1080}
}

local WindowSizeMultiplier = 1

FullScreen = false
ShowIntroLogo = true
VSync = 1
Debug = true
Demo = false
UseLiveServer = true
ScreenSize = Resolutions.custom

WIN32_GLES = false
WIN32_DX11 = false
WIN32_OGL = true

MONSTERJAM_THEME1 = 1
MONSTERJAM_THEME2 = 2
MONSTERJAM_THEME3 = 3
MONSTERJAM_THEME4 = 4	--Las Vegas
MONSTERJAM_THEME5 = 5
MONSTERJAM_THEME6 = 6
MONSTERJAM_THEME7 = 7
MONSTERJAM_THEME_SETTING = MONSTERJAM_THEME5

var("outputfiles", 0)
var("Writefontfiles", 1)
var("HQFonts", 1)
--var ("Videomode", "Desktop")

if (PS3()) then
	string.format = function() return "Time" end
end

function TouchInput()
	local Platform = GetPlatform() 
	
	return Platform == "IOS" or Platform == "Android" or Platform == "WindowsPhone8" or Platform == "Win32"
end

function Main(Parameter, Parameter2, Parameter3)	
	local UseObbPackageFiles = true
	
	var("FxVolume", 0.5)
	var("MusicVolume", 0.5)
	
	Demo = Demo or Parameter
	
	-- Debug stuff
	if (Win32()) then
		MonitorFileChanges("Lua\\", true, "*.lua", LuaMonitorCallback)
		MonitorFileChanges("Misc\\", true, "*.txt", LanguageMonitorCallback)
		MonitorFileChanges("Menu\\", true, "*.dcMenu", MenuMonitorCallback)
		MonitorFileChanges("Fonts\\", true, "*.xml", FontMonitorCallback)
		MonitorFileChanges("Shaders_GL\\", true, "*.DCS", ShaderMonitorCallback)
		MonitorFileChanges("Shaders_GL\\", true, "*.vs", ShaderMonitorCallback)
		MonitorFileChanges("Shaders_GL\\", true, "*.fs", ShaderMonitorCallback)
	end
	
	if (GetPlatform() == "3DS") then
		GetFS():AddFS(Create3DSFS("SDMC:", "/DIRTRIDER"))

		local InternalPath = "D:\\Team6\\Dirt_Rider\\__3DSROOT"
		GetFS():AddFS(Create3DSFS("Debug:", InternalPath))
	end

	if (GetPlatform() == "Android") then
		-- FS voor savegames
		local InternalPath = Android.GetInternalStoragePath()
		GetFS():AddFS(CreateNativeFS(InternalPath, InternalPath))
	
		-- FS voor data
		if (UseObbPackageFiles) then
			local ObbPath = Android.GetExternalStoragePath() .. Android.GetObbPath(true);
			print("Obbpath1 = " .. Android.GetObbPath(true))
			print("Obbpath2 = " .. ObbPath)
			GetFS():AddFS(CreateZipFS(ObbPath))
		else
			local ExternalPath = Android.GetExternalStoragePath() .. "/MONSTERJAM/"
			print("ExternalPath = " .. ExternalPath)
			GetFS():AddFS(CreateNativeFS(ExternalPath, nil))
		end
	end

	-- Set debug flag
	SetDebug(true)

	-- Init the console
	SetWarningLevel(0)

	if (Win32() or PS3()) then
		TXTConsole("Console.txt")
		
		RTFConsole("Console.rtf")

		--GUIConsole()
	end

	-- Create a window
	--CreateWindow("Monster Jam", false, 880, 495, true)
	CreateWindow("Monster Jam", FullScreen, ScreenSize.x * WindowSizeMultiplier, ScreenSize.y * WindowSizeMultiplier, true)
	
	VideoDriver = 0
	if (GetPlatform() == "Win32") then
		if (WIN32_GLES) then
			VideoDriver = 1
		elseif (WIN32_DX11) then
			VideoDriver = 2
		elseif (WIN32_OGL) then
			VideoDriver = 3
		end
	end
	var("VideoDriver", VideoDriver)

	-- Add dirs
	SetShaderDirs()
	SetTextureDirs()

	-- Create devices
	CreateVideo(VideoDriver, ScreenSize.x, ScreenSize.y, true)
	CreateAudio()
	CreateInput()
	loadoptions()
	
	var("videomode", "1366x768")

	SetVirtualRT(GetResolution())

	-- Init language file
	SetLanguage("English")

	-- Laad hier alle lua files
	--dofile("Lua\\InputDevices\\Input.lua")
	dofile("Gamesettings.lua")
	dofile("Config.cfg")
	var("VideoDriver", VideoDriver)
	
	dofile("Lua\\VideoPreset3.lua")

	var("intpause", 0)
	var("oldstuff", 0)
	var("AllowDriver", 1)
	
	if (GetPlatform() == "3DS") then
		var("inputdevice0", "N3DS")
	elseif ios() or GetPlatform() == "Android" or GetPlatform() == "WindowsPhone8" then	-- Dit heeft de voorkeur
		var("InputDevice0", "Touch")
	elseif GetPlatform() == "Wii" then
		var("InputDevice0", "WiiRemote0")
	else
        var("InputDevice0", "Keyboard")
	end
	
	var("ForceNewEmitter", 0)

	if (Debug) then
		DebugFile("Lua\\LuaMain.lua")
	else
		dofile("Lua\\LuaMain.lua")
	end

	dofile("ExtraConfig.lua");
	dofile("devkeys.lua")	
	
	if (GetPlatform() == "Wii") then
		loadhomemenu()
	end
	
	if (GetPlatform() == "Wii") then
		CreateMenu("New_Menu", false)
		--LoadGame()
		LoadStrapReminder()
	else
		CreateMenu("New_Menu", true)
		--LoadStrapReminder()
		LoadGame(Parameter, Parameter2, Parameter3)
	end

	-- Main loop
	while (true) do
		-- Hier alle lua frame stuff doen. o.a. gamethread scheduler aanroepen
		
		-- Doe iets
		if (not DoFrame()) then
			break;
		end
	end
end

function LoadStrapReminder()
	PrepareScript = function()
		ClearMenuStack()
		ActiveMenu = StrapReminder()
	end
	
	loadscript("StrapReminder")
end

function LoadGame(Parameter, Parameter2, Parameter3)
	-- Load fonts
	LoadFonts("Fonts\\Fonts.xml")

	if (Win32()) then
		CreateEngine();
		ActiveConsole = Console()
	end

	-- Zet hier nog de prepare script functie
	PrepareScript = function()
		-- First create a file cache for faster loading
		if (GetPlatform() == "Android" or GetPlatform() == "Wii" or GetPlatform() == "3DS") then
			CreateFileCache()
		end
	
		-- Preload de plaatjes
		ClearMenuStack()
		
		ActiveMission = MenuMission()
		
		if (ShowIntroLogo) then
			if (GetPlatform() == "Wii") then
				ActiveMenu = WiiNANDMenu(LogoMenu)
			else
				ActiveMenu = LogoMenu()
			end
		else
			if (GetPlatform() == "Wii") then
				ActiveMenu = WiiNANDMenu(IntroMenu)
			else
				ActiveMenu = IntroMenu()
			end
		end
	end
	
	if (Demo) then
		LoadGlobalTextures()
		LoadGameTextures()
		--LoadTextures()
		-- Any video resources created beyond here will not survive a map reload
		ActivateResourceBarrier()
		
		local GameMode = _G[Parameter]
		print("Test, gamemode: " .. tostring(GameMode))
		if (GameMode ~= nil) then
			print("Test, gamemodename: " .. tostring(GameMode.Name))
			AICount = 0
			ActiveGameMode = GameMode
		else
			print("Test, failed")
			ActiveGameMode = Test
		end
		
		if (Parameter2 ~= nil) then
			SelectedRace = Parameter2
		else
			SelectedRace = "TestPlane"
		end
		
		if (Parameter3 ~= nil) then
			SelectedCar = Parameter3
		else
			SelectedCar = "BlueThunder"
		end
		
		SelectedCharacter = "Player01"
		
		AddTexDir("Textures\\NonMenuTextures")
		
		ActiveGameMode:StartRace(SelectedRace, SelectedCar, SelectedCharacter)
	else
		loadscript("menu")
		LoadGlobalTextures()
		LoadMenuTextures()
		--LoadTextures()
	end
	
	-- Stuff
	loadracinghudfunctions()
	
	--fps()
	--poly()
end

function SetShaderDirs()
	if (VideoDriver == 1) then
		AddShaderDir("Shaders_GL")
		
		AddShaderDir("Shaders_GL\\Legacy")
		AddShaderDir("Shaders_GL\\Sprite")
		AddShaderDir("Shaders_GL\\Utils")
		AddShaderDir("Shaders_GL\\Scene")
		AddShaderDir("Shaders_GL\\Null")
	elseif (VideoDriver == 2) then
		AddShaderDir("Shaders_DX11")
		
		AddShaderDir("Shaders_DX11\\Legacy")
		AddShaderDir("Shaders_DX11\\Sprite")
		AddShaderDir("Shaders_DX11\\Utils")
		AddShaderDir("Shaders_DX11\\Scene")
		AddShaderDir("Shaders_DX11\\Null")
	elseif (VideoDriver == 3) then
		AddShaderDir("Shaders_GL")
		
		AddShaderDir("Shaders_GL\\Legacy")
		AddShaderDir("Shaders_GL\\Sprite")
		AddShaderDir("Shaders_GL\\Utils")
		AddShaderDir("Shaders_GL\\Scene")
		AddShaderDir("Shaders_GL\\Null")
	else
		AddShaderDir("Shaders")
		
		AddShaderDir("Shaders\\Legacy")
		AddShaderDir("Shaders\\Sprite")
		AddShaderDir("Shaders\\Utils")
		AddShaderDir("Shaders\\Scene")
		AddShaderDir("Shaders\\Null")
	end
end

function SetTextureDirs()
	AddTexDir("Textures")
	
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME7) then
		AddTexDir("Textures_Theme7")
	end
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME6) then
		AddTexDir("Textures_Theme6")
	end
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
		AddTexDir("Textures_Theme5")
	end
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME4) then
		AddTexDir("Textures_Theme4")
	end
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME3) then
		AddTexDir("Textures_Theme3")
	end
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME2) then
		AddTexDir("Textures_Theme2")
	end
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME1) then
		AddTexDir("Textures_Theme1")
	end
	
	AddTexDir("Textures\\Cars")
	AddTexDir("Textures\\Characters")
	AddTexDir("Textures")
	AddTexDir("Menu\\Images")
end

function SetVirtualRT(x , y)
	local MinRes = {x = 1366, y = 768}
	local MaxRes = {x = 1366, y = 768}

	-- if (x < MinRes.x) then
		-- y = (MinRes.x / x) * y;
		-- x = MinRes.x;
	-- end

	if (y < MinRes.y) then
		x = (MinRes.y / y) * x;
		y = MinRes.y;
	end

	-- if (x > MaxRes.x) then
		-- y = (MaxRes.x / x) * y;
		-- x = MaxRes.x;
	-- end

	if ( y > MaxRes.y) then
		x = (MaxRes.y / y) * x;
		y = MaxRes.y;
	end

	var("VirtualRTx", x)
	var("VirtualRTy", y)
	
	print("Current VirtualRT: " .. x .. " " .. y)

	if (GetPlatform() == "Wii" or testingwii) then
		SafeFrameMultiplier = 0.8
	elseif (GetPlatform() == "Android" or GetPlatform() == "IOS" or ScreenSize == Resolutions.iphone) then
		SafeFrameMultiplier = 0.95
	else
		SafeFrameMultiplier = 0.95
		--SafeFrameMultiplier = 0.85
	end

	ScreenWidth = getvar("VirtualRTx")
	ScreenHeight = getvar("VirtualRTy")

	SafeFrameWidth = math.floor(getvar("VirtualRTx") * SafeFrameMultiplier)
	SafeFrameHeight = math.floor(getvar("VirtualRTy") * SafeFrameMultiplier)

	-- safeframe afronden (naar beneden) op heel getal. Safeframe word gecentreerd, oneven geeft halve pixels
	if (SafeFrameWidth % 2) ~= 0 then --Odd?
		SafeFrameWidth = SafeFrameWidth - 1 -- Even!
	end

	if (SafeFrameHeight % 2) ~= 0 then --Odd?
		SafeFrameHeight = SafeFrameHeight - 1 --Even!
	end
	-- offsets safeframe -> schermrand
	SafeFrameOffsetX = (ScreenWidth - SafeFrameWidth) / 2 
	SafeFrameOffsetY = (ScreenHeight - SafeFrameHeight) / 2 

	print("Current SafeFrame: " .. SafeFrameWidth .. " " .. SafeFrameHeight)
end

function LuaMonitorCallback(FileName)
	FileName = "Lua\\" .. FileName

	print("Reloading " .. FileName)

	DebugFile(FileName)
end

function FontMonitorCallback(FileName)
	FileName = "Fonts\\" .. FileName

	print("Reloading " .. FileName)

	initfonts(FileName)
end

function LanguageMonitorCallback(FileName)
	--
end

function MenuMonitorCallback(FileName)
	print("Reloading " .. FileName)

	menurefresh()
	ActiveMenu_Refresh()
end

function ShaderMonitorCallback(FileName)
	print("Reloading " .. FileName)

	ReloadShaders()
end

