AgentAI_SteeringDriver = class(function(self, Car)
	self.Car = Car
	self.Agent = LuaAgent()
	
	self.MaxVelocity = 2000
	self.Agent:SetMaxVelocity(self.MaxVelocity)
	
	self.SwitchDirectionTimer = 0
	self.ReverseTimer = 0
	
	
	self.Destination = nil
end)





function AgentAI_SteeringDriver:Update(ElapsedTime)
	local CarMatrix = self.Car:GetMatrix()
	local CarVelocity = self.Car:GetVelocity()
	self.Agent:UpdateData(CarMatrix, CarVelocity)
	

	--local CarForwardVelocity = CarVelocity.z
	--local CarForwardVelocity = -(CarMatrix:GetRotationTranspose() * CarVelocity).z
	local CarForwardVelocity = self.Car:GetLocalSpeed() * -1
	
	--print("CarForwardVelocity: " .. tostring(CarForwardVelocity))
	
	local Destination = self.Agent:GetPathDestination()
	if (CarForwardVelocity > 300.0) then
		local NodeSkip = math.abs(10 * (CarVelocity:Magnitude() / 2000.0))
		Destination = self.Agent:GetPathAheadDestination(NodeSkip)
	end
	
	local NodeAhead = math.abs(30 * (CarVelocity:Magnitude() / 2000.0))
	local DestinationAhead = self.Agent:GetPathAheadDestination(NodeAhead)
	
	local SteeringForce = Vector(0, 0, 0)
	SteeringForce = SteeringForce + self.Agent:Seek(Destination)
	SteeringForce = SteeringForce + self.Agent:CornerBraking(DestinationAhead)
	--SteeringForce = SteeringForce + self.Agent:Arrive(Destination)
	
	
	local SteeringForce_Flat = Vector(SteeringForce.x, 0, SteeringForce.z)
	local DriveDir_Magnitude =  SteeringForce_Flat:Magnitude()
	local DriveDir = SteeringForce:Normalize()
	--local DriveDir_Local = CarMatrix:GetRotationTranspose() * DriveDir
	local DriveDir_Local = (CarMatrix:GetRotation():Inverse()) * DriveDir
	--local DriveDir_Local = DriveDir * CarMatrix:Inverse()
	
	--print("DriveDir: " .. tostring(DriveDir))
	
	-- ===========================================
	-- Choose direction - Forward(1) or Reverse(-1)?
	-- ===========================================
	-- Stand-still (because we want it)
	if (DriveDir_Magnitude < 500.0) then
		self.Direction = 0
		self.SwitchDirectionTimer = 0.2;
		--StandstillTimer = 0.0;
		--NextTryTimer = 0.0;
	-- Drive forward (because we want it)
	elseif ( DriveDir_Local.z <= -0.0 and self.SwitchDirectionTimer <= 0.0) then -- && ) then
		self.Direction = 1
		self.SwitchDirectionTimer = 1.2;
		--NextTryTimer = 0.0;
	-- Drive in reverse (because we want it)
	elseif (DriveDir_Local.z > -0.4 and self.SwitchDirectionTimer <= 0.0) then -- && SwitchDirectionTimer <= 0.0f) then
		self.Direction = -1
		self.SwitchDirectionTimer = 0.8;
		
		--NextTryTimer = 0.0;
	-- Drive forward (because we want it and (we allready were))
	elseif (DriveDir_Local.z <= -0.4 and self.Direction == 1 and self.SwitchDirectionTimer <= 0.0) then-- && SwitchDirectionTimer <= 0.0) then
		self.Direction = 1
		self.SwitchDirectionTimer = 0.0;
		--NextTryTimer = 0.0;
	-- Drive in reverse (because we want it and (we allready were))
	--elseif (DriveDir_Local.z > -0.0 and self.Direction == -1 and self.SwitchDirectionTimer <= 0.0) then-- && SwitchDirectionTimer <= 0.0) then
		--self.Direction = -1
		--self.SwitchDirectionTimer = 0.0;
		--NextTryTimer = 0.0;
	end
	-- ===========================================
	--print('dir: '..tostring(DriveDir_Local.x))
	
	local ClampedSteer = 0.0
	local ClampedAccel = 0.0
	local Gear = 0
	local ClampedBrake = 0.0
	local ClampedHandBrake = 0.0
	local UseBoost = false

	if (self.Direction == 0) then
		ClampedBrake = 1.0
		ClampedHandBrake = 1.0
	end
	
	-- ===========================================
	-- Steering : Dependable how far the vector is pointing left or right
	-- ===========================================
	
	--print("self.ReverseTimer: " .. tostring(self.ReverseTimer))
	if (self.ReverseTimer > 3) then
		--DriveDir_Local.x = -1000 ---DriveDir_Local.x * 10000
		
		print("DriveDir_Local.x: " .. tostring(DriveDir_Local.x))
	end
	
	--if (self.Direction == 1) then
	if (CarForwardVelocity > 0) then
		--Forward
		--ClampedSteer = ClampMinMax(-DriveDir_Local.x, -1.0, 1.0)
	--elseif (self.Direction == -1) then
	elseif (CarForwardVelocity < 0) then
		--Reverse
		--ClampedSteer = ClampMinMax(DriveDir_Local.x, -1.0, 1.0)
	end
	
	ClampedSteer = self.Car:GetSteerDir(-DriveDir)
	
	--if (CarForwardVelocity < 0) then
	if (self.Direction == -1) then
		ClampedSteer = ClampedSteer * -1
	end
	--print(ClampedSteer)
	-- ===========================================
	--print('ClampedSteer: '..tostring(ClampedSteer))
	
	if (self.ReverseTimer > 3) then
		--ClampedSteer = -1 ---DriveDir_Local.x * 10000
	end
	
	-- ===========================================
	-- Acceleration + Gear:
	-- ===========================================
	if (self.Direction == 1) then
		--Forward
		ClampedAccel = ClampMinMax( DriveDir_Magnitude / (self.MaxVelocity * 0.8), -1.0, 1.0);
		Gear = self.Car:GetBestGear()
	elseif (self.Direction == -1) then
		--Reverse
		ClampedAccel = ClampMinMax( DriveDir_Magnitude / (self.MaxVelocity * 0.8), -1.0, 1.0);
		Gear = -1;
	end
	-- ===========================================
	
	-- ===========================================
	-- Braking : 
	-- ===========================================
	if (self.Direction == 1) then
		--Hard braking because we are going backwards
		if (CarForwardVelocity < -5.0) then
			ClampedBrake = ClampMinMax(ClampedBrake + (-CarForwardVelocity), 0.0, 1.0)
			ClampedAccel = 0.0
			ClampedHandBrake = 1.0
		--Brake a 'little' during a sharp turn
		elseif (CarForwardVelocity > 500.0) then
			if (DriveDir_Local.x > 0.7) then
				ClampedBrake = DriveDir_Local.x - 0.7
				ClampedAccel = 0.0
				ClampedAccel = 0.0
			elseif (DriveDir_Local.x < -0.7) then
				ClampedBrake = -DriveDir_Local.x - 0.7
				ClampedAccel = 0.0
			end
		end
	elseif (self.Direction == -1) then
		--Hard braking because we are going foward
		if (CarForwardVelocity > 5.0) then
			ClampedBrake = ClampMinMax(CarForwardVelocity, 0.0, 1.0)
			ClampedAccel = 0.0
			ClampedHandBrake = 1.0
		end
	end
	-- ===========================================
	
	
	self.Car:Steer(ClampedSteer)
	self.Car:Accelerate(ClampedAccel)
	self.Car:Brake(ClampedBrake)
	self.Car:ChangeGear(Gear)
	self.Car:Handbrake(ClampedHandBrake)
	
	if (self.SwitchDirectionTimer >= 0) then
		self.SwitchDirectionTimer = self.SwitchDirectionTimer - ElapsedTime
	end
	
	if (self.Direction == -1) then
		self.ReverseTimer = self.ReverseTimer + ElapsedTime
	else
		self.ReverseTimer = 0
	end
	
	
	--[[ local SteerValue = self.Car:GetSteerDir(Dir)
	local ClampedSteer = ClampMinMax(SteerValue, -1.0, 1.0)
	local Steer = math.abs(SteerValue)
	self.Car:Steer(ClampedSteer)
	
	if (CarVelocity:Magnitude() < AIMaxSpeed) then
		if (CarVelocity:Magnitude() > AIMinSpeed) then
			local Accel = SpeedScalar * 1 * ClampMinMax(1.0 - (Steer * 8), 0.0, 1.0)
			self.Car:Accelerate(Accel)
			
			local Brake = ClampMinMax((Steer - 0.25) * 3.0, 0.0, 1.0)
			self.Car:Brake(Brake)
		else
			self.Car:Accelerate(1)
			self.Car:Brake(0)
		end
	else
		self.Car:Accelerate(0)
		local Brake = ClampMinMax((Steer * 0.5), 0.0, 1.0)
		self.Car:Brake(Brake)
	end
	
	self.Car:ChangeGear(self.Car:GetBestGear())
	
	self.Car:Handbrake(0) ]]--
end

-- LuaDriver functions

function AgentAI_SteeringDriver:Init()
	print("AgentAI_SteeringDriver:Init TODO")
end

function AgentAI_SteeringDriver:Enable()
	print("AgentAI_SteeringDriver:Enable TODO")
end

function AgentAI_SteeringDriver:Disable()
	print("AgentAI_SteeringDriver:Disable TODO")
end

function AgentAI_SteeringDriver:EnableBoost()
	print("AgentAI_SteeringDriver:EnableBoost TODO")
end

function AgentAI_SteeringDriver:DisableBoost()
	print("AgentAI_SteeringDriver:DisableBoost TODO")
end

function AgentAI_SteeringDriver:SetSpeedMult()
	print("AgentAI_SteeringDriver:SetSpeedMult TODO")
end

-- 

function AgentAI_SteeringDriver:Checkpoint()
	print("AgentAI_SteeringDriver:Checkpoint")
end

function AgentAI_SteeringDriver:NextCheckpoint(Checkpoint)
	print("AgentAI_SteeringDriver:NextCheckpoint")
	
	local CheckpointPos = Checkpoint:GetMatrix():GetTranslation()
	--print(CheckpointPos)
	
	self.Agent:FindPath(CheckpointPos.x, CheckpointPos.y, CheckpointPos.z)
end