-- Game modes
CareerRace = class(function(self)
	--Settings
	self.Skin = 0;
	self.Tuning = 0
	
	self.Character = Player01
	
	self.LapCount = 1;
	self.Difficulty = 1.0
	
	self.AIPlayers = AIPlayers;
	
	--Progress data
	self.HumanPos = -1
end)

function CareerRace:SetGameMode(GameMode)
	self.GameMode = GameMode
end

function CareerRace:SetChapter(Chapter)
	self.Chapter = self.GameMode:FindChapter(Chapter)
end

function CareerRace:SetRace(Race)
	self.Race = self.Chapter:FindRace(Race)
end

function CareerRace:SetPlayerCar(PlayerCar)
	self.PlayerCar = PlayerCar
end

function CareerRace:SetSkin(Skin)
	self.Skin = Skin
end

function CareerRace:SetTuning(Tuning)
	self.Tuning = Tuning
end

function CareerRace:SetCharacter(Character)
	self.Skin = Character
end

function CareerRace:SetLapCount(LapCount)
	self.LapCount = LapCount
end

function CareerRace:SetDifficulty(Difficulty)
	self.Difficulty = Difficulty
end

function CareerRace:SetAICount(AICount)
	self.AICount = AICount
end

function CareerRace:SetAICarClasses(AICarClasses)
	self.AICarClasses = AICarClasses
end

function CareerRace:SetAIPlayers(AIPlayers)
	self.AIPlayers = AIPlayers
end

function CareerRace:GetHumanPos(HumanIndex)
	return self.HumanPos
end

function CareerRace_Win(Place, Score, TestOnly)
	local Result = CareerRaces[CurrentCareerRace + 1].Win(Place, Score)
	if (Result) then
		if (CareerRaces[CurrentCareerRace + 1].Won ~= nil) then
			CareerRaces[CurrentCareerRace + 1].Won(Place, Score)
		end
		
		if (not TestOnly) then
			CurrentCareerRace = Inc(CurrentCareerRace)
			
			WriteGameSettings()
		end
	end
	
	return Result
end

function StartCareer(MaxRaceCount)
	EndCareer()
	CurrentCareerMaxRaceCount = MaxRaceCount
	
	local CareerRace = CareerRaces[CurrentCareerRace + 1]
	ActiveGameMode = CareerRace.GameMode
	
	Career_Players = {}
	
	local Car = MonsterTruckCar01					-- << Aanpassen
	local Character = "Characters\\Player01"	-- << Aanpassen
	
	local AIPool = ActiveGameMode:FillAIPool(CareerRace.Difficulty)
	for i = 1, CareerRace.AICount do
		if (#AIPool == 0) then
			AIPool = ActiveGameMode:FillAIPool(CareerRace.Difficulty)
		end
		
		local Index = math.random(#AIPool)
		
		local AIPlayer = AIPool[Index];
		AIPlayer.Points = 0
		AIPlayer.Human = false
		Career_Players[i] = AIPlayer
					
		table.remove(AIPool, Index)
	end
	
	local HumanPlayer = {}
	HumanPlayer.Name = "Player 1"
	HumanPlayer.Car = Car
	HumanPlayer.Skin = 0
	HumanPlayer.Tuning = "Default"
	HumanPlayer.Character = Character
	HumanPlayer.CharacterSkin = 0
	HumanPlayer.CarType = _G[Car]
	HumanPlayer.Points = 0
	HumanPlayer.Human = true
	HumanPlayer.ID = #Career_Players + 1
	table.insert(Career_Players, HumanPlayer)
end

function EndCareer()
	CurrentCareerMaxRaceCount = nil
	CurrentCareerRace = 0
	for i, CareerRace in ipairs(CareerRaces) do
		CareerRace.HumanPos = -1
	end
end

function StartCareerRace()
	LoadingScreen = nil
	
	-- Stack leegmaken
	ClearMenuStack()
			
	-- Weg met het menu
	ActiveMenu = nil
	UnloadMenuTextures()
	
	-- Haal race op
	if CurrentCareerRace >= #CareerRaces then
		CurrentCareerRace = 0
	end
	
	local CareerRace = CareerRaces[CurrentCareerRace + 1]
	
	-- Voor hud etc
	ActiveGameMode = CareerRace.GameMode
	ActiveGameMode.ActiveChapter = CareerRace.Chapter
	ActiveGameMode.ActiveChapter.ActiveRace = CareerRace.Race
	
	local Car = MonsterTruckCar01						-- << Aanpassen
	local Character = "Characters\\Player01" 		-- << Aanpassen
	
	--ActiveGameMode:StartRace(ActiveGameMode.ActiveChapter.ActiveRace.Name, Car.Name, Character, CareerRace.LapCount, CareerRace.AICount, CareerRace.Difficulty, true)
	ActiveGameMode:StartRaceCareer(ActiveGameMode.ActiveChapter.ActiveRace.Name, Car.Name, Character, CareerRace.LapCount, Career_Players)
end

function EndCareerRace(PlayerResults)
	local CareerRace = CareerRaces[CurrentCareerRace + 1]
	CurrentCareerRace = Inc(CurrentCareerRace)
	
	for i, PlayerResult in ipairs(PlayerResults) do
		if (PlayerResult.Human == true) then
			CareerRace.HumanPos = i - 1
		end
		
		for j, Player in ipairs(Career_Players) do
			if (PlayerResult.ID == Player.ID) then
				if (CareerScores[i] ~= nil) then
					Player.Points = Player.Points + CareerScores[i]
				end
			end
		end
		
	end
end