function GetAnimations(FullPath, Print)
	local Animations = {}
	
	local Files = { GetFS():Find(FullPath .. "\\*.DCA") }
	for i, File in ipairs(Files) do
		if (false) then --Print) then
			print("Loading animation: " .. File)
		end
		table.insert(Animations, Animation(File))
	end
	
	return Animations
end

function LoadAnimations()
	if (Animations == nil) then
		Animations = {}
		
		LoadAnimations_Female()
		LoadAnimations_Male()
		LoadAnimations_Child()
	end
end

function UnloadAnimations()
	UnloadAnimations_Female()
	UnloadAnimations_Male()
	UnloadAnimations_Child()
end

function UnloadAnimations_Female()
	Animations.Female = nil
end

function LoadAnimations_Female()
	if (Animations.Female == nil) then
		Animations.Female = {}

		local AnimationPath = "Characters\\Animations\\" .. "Female"
		
		if (Animations.Female.IdleNeutral == nil) then
			Animations.Female.IdleNeutral = {}
			Animations.Female.IdleNeutral = GetAnimations(AnimationPath .. "\\Idle\\Neutral", true)
		end
		
		if (Animations.Female.IdlePositive == nil) then
			Animations.Female.IdlePositive = {}
			--Animations.Female.IdlePositive = GetAnimations(AnimationPath .. "\\Idle\\Positive", true)
			Animations.Female.IdlePositive = Animations.Female.IdleNeutral										-- Positieve en neutrale idle's combineren
		end
		
		if (Animations.Female.IdleNegative == nil) then
			Animations.Female.IdleNegative = {}
			--Animations.Female.IdleNegative = GetAnimations(AnimationPath .. "\\Idle\\Negative", true)
		end
		
		if (Animations.Female.WalkInNeutral == nil) then
			Animations.Female.WalkInNeutral = {}
			Animations.Female.WalkInNeutral = GetAnimations(AnimationPath .. "\\WalkIn\\Neutral", true)
		end
		
		if (Animations.Female.WalkInPositive == nil) then
			Animations.Female.WalkInPositive = {}
			Animations.Female.WalkInPositive = GetAnimations(AnimationPath .. "\\WalkIn\\Positive", true)
		end
		
		if (Animations.Female.WalkOutNegative == nil) then
			Animations.Female.WalkOutNegative = {}
			Animations.Female.WalkOutNegative = GetAnimations(AnimationPath .. "\\WalkOut", true)
		end
		
		if (Animations.Female.CheerPositive == nil) then
			Animations.Female.CheerPositive = {}
			Animations.Female.CheerPositive = GetAnimations(AnimationPath .. "\\Cheer\\Positive", true)
		end
		
		if (Animations.Female.CheerNegative == nil) then
			Animations.Female.CheerNegative = {}
			Animations.Female.CheerNegative = GetAnimations(AnimationPath .. "\\Cheer\\Negative", true)
			
			Animations.Female.IdleNegative = Animations.Female.CheerNegative									-- Negatief idle weg en combineren met negatief cheer
		end
		
		if (Animations.Female.SpecialMove_SeeSaw == nil) then
			Animations.Female.SpecialMove_SeeSaw = {}
			table.insert(Animations.Female.SpecialMove_SeeSaw, Animation(AnimationPath .. "\\SpecialMoves\\SeeSaw.DCA"))
		end
		
		if (Animations.Female.SpecialMove_AroundTheWorld == nil) then
			Animations.Female.SpecialMove_AroundTheWorld = {}
			table.insert(Animations.Female.SpecialMove_AroundTheWorld, Animation(AnimationPath .. "\\SpecialMoves\\AroundTheWorld.DCA"))
		end
		
		if (Animations.Female.SpecialMove_Pancake == nil) then
			Animations.Female.SpecialMove_Pancake = {}
			table.insert(Animations.Female.SpecialMove_Pancake, Animation(AnimationPath .. "\\SpecialMoves\\Pancake.DCA"))
		end
		
		if (Animations.Female.SpecialMove_SpecialHop == nil) then
			Animations.Female.SpecialMove_SpecialHop = {}
			table.insert(Animations.Female.SpecialMove_SpecialHop, Animation(AnimationPath .. "\\SpecialMoves\\SpecialHop.DCA"))
		end
		
		if (Animations.Female.SpecialMove_SpecialSide == nil) then
			Animations.Female.SpecialMove_SpecialSide = {}
			table.insert(Animations.Female.SpecialMove_SpecialSide, Animation(AnimationPath .. "\\SpecialMoves\\SpecialSide.DCA"))
		end
	end
end

function UnloadAnimations_Male()
	Animations.Male = nil
end

function LoadAnimations_Male()
	if (Animations.Male == nil) then
		Animations.Male = {}

		local AnimationPath = "Characters\\Animations\\" .. "Male"
		
		if (Animations.Male.IdleNeutral == nil) then
			Animations.Male.IdleNeutral = {}
			Animations.Male.IdleNeutral = GetAnimations(AnimationPath .. "\\Idle\\Neutral", true)
		end
		
		if (Animations.Male.IdlePositive == nil) then
			Animations.Male.IdlePositive = {}
			--Animations.Male.IdlePositive = GetAnimations(AnimationPath .. "\\Idle\\Positive", true)
			
			Animations.Male.IdlePositive = Animations.Male.IdleNeutral										-- Positieve en neutrale idle's combineren
		end
		
		if (Animations.Male.IdleNegative == nil) then
			Animations.Male.IdleNegative = {}
			--Animations.Male.IdleNegative = GetAnimations(AnimationPath .. "\\Idle\\Negative", true)
		end
		
		if (Animations.Male.WalkInNeutral == nil) then
			Animations.Male.WalkInNeutral = {}
			Animations.Male.WalkInNeutral = GetAnimations(AnimationPath .. "\\WalkIn\\Neutral", true)
		end
		
		if (Animations.Male.WalkInPositive == nil) then
			Animations.Male.WalkInPositive = {}
			Animations.Male.WalkInPositive = GetAnimations(AnimationPath .. "\\WalkIn\\Positive", true)
		end
		
		if (Animations.Male.WalkOutNegative == nil) then
			Animations.Male.WalkOutNegative = {}
			Animations.Male.WalkOutNegative = GetAnimations(AnimationPath .. "\\WalkOut", true)
		end
		
		if (Animations.Male.CheerPositive == nil) then
			Animations.Male.CheerPositive = {}
			Animations.Male.CheerPositive = GetAnimations(AnimationPath .. "\\Cheer\\Positive", true)
		end
		
		if (Animations.Male.CheerNegative == nil) then
			Animations.Male.CheerNegative = {}
			Animations.Male.CheerNegative = GetAnimations(AnimationPath .. "\\Cheer\\Negative", true)
			
			Animations.Male.IdleNegative = Animations.Male.CheerNegative									-- Negatief idle weg en combineren met negatief cheer
		end
		
		-- Man en kind moeten bij een special move een positive cheer afspelen
		if (Animations.Male.SpecialMove_SeeSaw == nil) then
			Animations.Male.SpecialMove_SeeSaw = {}
			--table.insert(Animations.Male.SpecialMove_SeeSaw, Animation(AnimationPath .. "\\SpecialMoves\\SeeSaw.DCA"))
			
			Animations.Male.SpecialMove_SeeSaw = Animations.Male.CheerPositive
		end
		
		if (Animations.Male.SpecialMove_AroundTheWorld == nil) then
			Animations.Male.SpecialMove_AroundTheWorld = {}
			--table.insert(Animations.Male.SpecialMove_AroundTheWorld, Animation(AnimationPath .. "\\SpecialMoves\\AroundTheWorld.DCA"))
			
			Animations.Male.SpecialMove_AroundTheWorld = Animations.Male.CheerPositive
		end
		
		if (Animations.Male.SpecialMove_Pancake == nil) then
			Animations.Male.SpecialMove_Pancake = {}
			--table.insert(Animations.Male.SpecialMove_Pancake, Animation(AnimationPath .. "\\SpecialMoves\\Pancake.DCA"))
			
			Animations.Male.SpecialMove_Pancake = Animations.Male.CheerPositive
		end
		
		if (Animations.Male.SpecialMove_SpecialHop == nil) then
			Animations.Male.SpecialMove_SpecialHop = {}
			--table.insert(Animations.Male.SpecialMove_SpecialHop, Animation(AnimationPath .. "\\SpecialMoves\\SpecialHop.DCA"))
			
			Animations.Male.SpecialMove_SpecialHop = Animations.Male.CheerPositive
		end
		
		if (Animations.Male.SpecialMove_SpecialSide == nil) then
			Animations.Male.SpecialMove_SpecialSide = {}
			--table.insert(Animations.Male.SpecialMove_SpecialSide, Animation(AnimationPath .. "\\SpecialMoves\\SpecialSide.DCA"))
			
			Animations.Male.SpecialMove_SpecialSide = Animations.Male.CheerPositive
		end
	end
end

function UnloadAnimations_Child()
	Animations.Child = nil
end

function LoadAnimations_Child()
	if (Animations.Child == nil) then
		Animations.Child = {}

		local AnimationPath = "Characters\\Animations\\" .. "Child"
		
		if (Animations.Child.IdleNeutral == nil) then
			Animations.Child.IdleNeutral = {}
			Animations.Child.IdleNeutral = GetAnimations(AnimationPath .. "\\Idle\\Neutral", true)
		end
		
		if (Animations.Child.IdlePositive == nil) then
			Animations.Child.IdlePositive = {}
			--Animations.Child.IdlePositive = GetAnimations(AnimationPath .. "\\Idle\\Positive", true)
			
			Animations.Child.IdlePositive = Animations.Child.IdleNeutral										-- Positieve en neutrale idle's combineren
		end
		
		if (Animations.Child.IdleNegative == nil) then
			Animations.Child.IdleNegative = {}
			--Animations.Child.IdleNegative = GetAnimations(AnimationPath .. "\\Idle\\Negative", true)
		end
		
		if (Animations.Child.WalkInNeutral == nil) then
			Animations.Child.WalkInNeutral = {}
			Animations.Child.WalkInNeutral = GetAnimations(AnimationPath .. "\\WalkIn\\Neutral", true)
		end
		
		if (Animations.Child.WalkInPositive == nil) then
			Animations.Child.WalkInPositive = {}
			Animations.Child.WalkInPositive = GetAnimations(AnimationPath .. "\\WalkIn\\Positive", true)
		end
		
		if (Animations.Child.WalkOutNegative == nil) then
			Animations.Child.WalkOutNegative = {}
			Animations.Child.WalkOutNegative = GetAnimations(AnimationPath .. "\\WalkOut", true)
		end
		
		if (Animations.Child.CheerPositive == nil) then
			Animations.Child.CheerPositive = {}
			Animations.Child.CheerPositive = GetAnimations(AnimationPath .. "\\Cheer\\Positive", true)
		end
		
		if (Animations.Child.CheerNegative == nil) then
			Animations.Child.CheerNegative = {}
			Animations.Child.CheerNegative = GetAnimations(AnimationPath .. "\\Cheer\\Negative", true)
			
			Animations.Child.IdleNegative = Animations.Child.CheerNegative									-- Negatief idle weg en combineren met negatief cheer
		end
		
		-- Man en kind moeten bij een special move een positive cheer afspelen
		if (Animations.Child.SpecialMove_SeeSaw == nil) then
			Animations.Child.SpecialMove_SeeSaw = {}
			--table.insert(Animations.Child.SpecialMove_SeeSaw, Animation(AnimationPath .. "\\SpecialMoves\\SeeSaw.DCA"))
			
			Animations.Child.SpecialMove_SeeSaw = Animations.Child.CheerPositive
		end
		
		if (Animations.Child.SpecialMove_AroundTheWorld == nil) then
			Animations.Child.SpecialMove_AroundTheWorld = {}
			--table.insert(Animations.Child.SpecialMove_AroundTheWorld, Animation(AnimationPath .. "\\SpecialMoves\\AroundTheWorld.DCA"))
			
			Animations.Child.SpecialMove_AroundTheWorld = Animations.Child.CheerPositive
		end
		
		if (Animations.Child.SpecialMove_Pancake == nil) then
			Animations.Child.SpecialMove_Pancake = {}
			--table.insert(Animations.Child.SpecialMove_Pancake, Animation(AnimationPath .. "\\SpecialMoves\\Pancake.DCA"))
			
			Animations.Child.SpecialMove_Pancake = Animations.Child.CheerPositive
		end
		
		if (Animations.Child.SpecialMove_SpecialHop == nil) then
			Animations.Child.SpecialMove_SpecialHop = {}
			--table.insert(Animations.Child.SpecialMove_SpecialHop, Animation(AnimationPath .. "\\SpecialMoves\\SpecialHop.DCA"))
			
			Animations.Child.SpecialMove_SpecialHop = Animations.Child.CheerPositive
		end
		
		if (Animations.Child.SpecialMove_SpecialSide == nil) then
			Animations.Child.SpecialMove_SpecialSide = {}
			--table.insert(Animations.Child.SpecialMove_SpecialSide, Animation(AnimationPath .. "\\SpecialMoves\\SpecialSide.DCA"))
			
			Animations.Child.SpecialMove_SpecialSide = Animations.Child.CheerPositive
		end
	end
end