CharacterEntity = class(function(self, CharacterName, SkinIndex, ScriptMatrix, AnimationDirectory, AltWalkInNeutral, AltWalkInPositive, AltWalkOutNegative)

	self.Name = CharacterName .. tostring(SkinIndex)
	self.EnableWalkout = true

	--Character
	local CharacterDir = "Characters\\" .. CharacterName
	local Character = SimpleCharacter(CharacterDir, SkinIndex)
	
	--Tijdelijk
	ScriptMatrix = ScriptMatrix:RotateLocal(Vector(0,1,0), math.rad(180))
	
	LoadAnimations()
	local AnimationsList = nil
	
	if (AnimationDirectory == "Female") then
		ScriptMatrix = ScriptMatrix:TranslateLocal(Vector(0,1.4,0))
		AnimationsList = Animations.Female
	elseif (AnimationDirectory == "Male") then
		ScriptMatrix = ScriptMatrix:TranslateLocal(Vector(0,1.0,0))
		AnimationsList = Animations.Male
	elseif (AnimationDirectory == "Child") then
		ScriptMatrix = ScriptMatrix:TranslateLocal(Vector(0,4.6,0))
		AnimationsList = Animations.Child
	end
	
	GetEntityScene():AddEntity(Character)
	Character:SetMatrix(ScriptMatrix);
	
	-- Get Animations
	self.Animations_IdlePositive = {}
	self.Animations_IdlePositive = AnimationsList.IdlePositive
	
	self.Animations_IdleNeutral = {}
	self.Animations_IdleNeutral = AnimationsList.IdleNeutral

	self.Animations_IdleNegative = {}
	self.Animations_IdleNegative = AnimationsList.IdleNegative
	
	self.Animations_AanloopNeutral = {}
	if (AltWalkInNeutral ~= nil) then
		for i, Animation in ipairs(AnimationsList.WalkInNeutral) do
			local Path, LocalFilename, Extension = string.match(Animation:GetFilename(), "(.-)([^\\/]-%.?([^%.\\/]*))$")
			
			if (LocalFilename == AltWalkInNeutral) then
				table.insert(self.Animations_AanloopNeutral, Animation)
				--print("Inserted: " .. tostring(LocalFilename))
			end
		end
		
		if (#self.Animations_AanloopNeutral == 0) then
			print("Could not find: " .. tostring(AltWalkInNeutral))
			self.Animations_AanloopNeutral = AnimationsList.WalkInNeutral
		end
	else
		self.Animations_AanloopNeutral = AnimationsList.WalkInNeutral
	end
	
	self.Animations_AanloopPositive = {}
	if (AltWalkInPositive ~= nil) then
		for i, Animation in ipairs(AnimationsList.WalkInPositive) do
			local Path, LocalFilename, Extension = string.match(Animation:GetFilename(), "(.-)([^\\/]-%.?([^%.\\/]*))$")
			
			if (LocalFilename == AltWalkInPositive) then
				table.insert(self.Animations_AanloopPositive, Animation)
				--print("Inserted: " .. tostring(LocalFilename))
			end
		end
		
		if (#self.Animations_AanloopPositive == 0) then
			print("Could not find: " .. tostring(AltWalkInPositive))
			self.Animations_AanloopPositive = AnimationsList.WalkInPositive
		end
	else
		self.Animations_AanloopPositive = AnimationsList.WalkInPositive
	end
	
	self.Animations_WeglopenNegative = {}
	if (AltWalkOutNegative ~= nil) then
		for i, Animation in ipairs(AnimationsList.WalkOutNegative) do
			local Path, LocalFilename, Extension = string.match(Animation:GetFilename(), "(.-)([^\\/]-%.?([^%.\\/]*))$")
			
			if (LocalFilename == AltWalkOutNegative) then
				table.insert(self.Animations_WeglopenNegative, Animation)
				--print("Inserted: " .. tostring(LocalFilename))
			end
		end
		
		if (#self.Animations_WeglopenNegative == 0) then
			print("Could not find: " .. tostring(AltWalkOutNegative))
			self.Animations_WeglopenNegative = AnimationsList.WalkOutNegative
		end
	else
		self.Animations_WeglopenNegative = AnimationsList.WalkOutNegative
	end
	
	self.Animations_CheerPositive = {}
	self.Animations_CheerPositive = AnimationsList.CheerPositive
	
	self.Animations_CheerNegative = {}
	self.Animations_CheerNegative = AnimationsList.CheerNegative
	
	self.Animations_SpecialMove_SeeSaw = {}
	self.Animations_SpecialMove_SeeSaw = AnimationsList.SpecialMove_SeeSaw
	
	self.Animations_SpecialMove_AroundTheWorld = {}
	self.Animations_SpecialMove_AroundTheWorld = AnimationsList.SpecialMove_AroundTheWorld
	
	self.Animations_SpecialMove_Pancake = {}
	self.Animations_SpecialMove_Pancake = AnimationsList.SpecialMove_Pancake
	
	self.Animations_SpecialMove_SpecialHop = {}
	self.Animations_SpecialMove_SpecialHop = AnimationsList.SpecialMove_SpecialHop
	
	self.Animations_SpecialMove_SpecialSide = {}
	self.Animations_SpecialMove_SpecialSide = AnimationsList.SpecialMove_SpecialSide
	
	for i, Animation in ipairs(self.Animations_IdlePositive) do
		Character:BindAnimation(Animation)
	end
	
	for i, Animation in ipairs(self.Animations_IdleNeutral) do
		Character:BindAnimation(Animation)
	end
	
	for i, Animation in ipairs(self.Animations_IdleNegative) do
		Character:BindAnimation(Animation)
	end
	
	for i, Animation in ipairs(self.Animations_AanloopNeutral) do
		Character:BindAnimation(Animation)
	end
	
	for i, Animation in ipairs(self.Animations_AanloopPositive) do
		Character:BindAnimation(Animation)
	end
	
	for i, Animation in ipairs(self.Animations_WeglopenNegative) do
		Character:BindAnimation(Animation)
	end
	
	for i, Animation in ipairs(self.Animations_CheerPositive) do
		Character:BindAnimation(Animation)
	end
	
	for i, Animation in ipairs(self.Animations_CheerNegative) do
		Character:BindAnimation(Animation)
	end
	
	for i, Animation in ipairs(self.Animations_SpecialMove_SeeSaw) do
		Character:BindAnimation(Animation)
	end
	for i, Animation in ipairs(self.Animations_SpecialMove_AroundTheWorld) do
		Character:BindAnimation(Animation)
	end
	for i, Animation in ipairs(self.Animations_SpecialMove_Pancake) do
		Character:BindAnimation(Animation)
	end
	for i, Animation in ipairs(self.Animations_SpecialMove_SpecialHop) do
		Character:BindAnimation(Animation)
	end
	for i, Animation in ipairs(self.Animations_SpecialMove_SpecialSide) do
		Character:BindAnimation(Animation)
	end

	
	self.Character = Character
	self.CurrentState = nil
	
	
	--State_Positive_WalkIn
	--State_Neutral_WalkIn
	
	--State_Neutral_Idle
	--State_Positive_Idle
	--State_Negative_Idle
	
	--State_Negative_WalkOut
	--State_Negative_IdleOutside
	
	--State_SpecialMove_SeeSaw
	--State_SpecialMove_AroundTheWorld
	--State_SpecialMove_Pancake
	--State_SpecialMove_SpecialHop
	--State_SpecialMove_SpecialSide
	
	PhysicsThread:Spawn(function()
		while (true) do
			local rand = math.random(2, 50)
			self:Update(rand)
			PhysicsThread:Sleep(rand)
		end
	end)
end)

function CharacterEntity:GetAnimations(FullPath)
	local Animations = {}
	
	local Files = { GetFS():Find(FullPath .. "\\*.DCA") }
	for i, File in ipairs(Files) do
		--print("Adding: " .. File)
		table.insert(Animations, Animation(File))
	end
	
	return Animations
end

function CharacterEntity:ChangeState(State)
	if (self.CurrentState ~= State) then
		PhysicsThread:Spawn(function()
			if (self.CurrentState ~= nil) then
				--print('Exit: ' .. self.CurrentState.Name)
				self.CurrentState:Exit(self)
			end
			
			if (State:Enter(self)) then
				self.CurrentState = State
			end
			
			
			--self.CurrentState = State
			--print('Enter: ' .. self.CurrentState.Name)
			--self.CurrentState:Enter(self)
		end)
	end
end

function CharacterEntity:Update(Time)
	if (self.CurrentState ~= nil) then
		self.CurrentState:Update(self, Time)
	end
end

--

State = class(function(self, Name)
	self.Name = Name
end)

function State:Enter(CharacterEntity)
	print('No Enter function')
	return true
end

function State:Update(CharacterEntity)
	--print('No Update function')
end

function State:Exit(CharacterEntity)
	print('No exit function')
end

--



-- =======================================================
State_Negative_IdleOutside = State("Negative_IdleOutside")
function State_Negative_IdleOutside:Enter(CharacterEntity)
	return true
end
function State_Negative_IdleOutside:Update(CharacterEntity)
	if (ActiveMission.MoodMeter > 0.5) then
		CharacterEntity:ChangeState(State_Positive_WalkIn)
	elseif (ActiveMission.MoodMeter > -0.5) then
		CharacterEntity:ChangeState(State_Neutral_WalkIn)
	end
end
function State_Negative_IdleOutside:Exit(CharacterEntity)
	--
end
-- =======================================================


-- =======================================================
State_Positive_WalkIn = State("Positive_WalkIn")
function State_Positive_WalkIn:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_AanloopPositive[1]
	local Rand = math.random(1, #CharacterEntity.Animations_AanloopPositive)
	Animation = CharacterEntity.Animations_AanloopPositive[Rand]
	
	CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
		local LastSec = 0.5
		if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
			CharacterEntity:ChangeState(State_Positive_Idle)
		end
		
		return 1
	end)
	
	return true
end
function State_Positive_WalkIn:Update(CharacterEntity)
	
end
function State_Positive_WalkIn:Exit(CharacterEntity)
	
end
-- =======================================================


-- =======================================================
State_Neutral_WalkIn = State("Neutral_WalkIn")
function State_Neutral_WalkIn:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_AanloopNeutral[1]
	local Rand = math.random(1, #CharacterEntity.Animations_AanloopNeutral)
	Animation = CharacterEntity.Animations_AanloopNeutral[Rand]
	
	CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
		local LastSec = 0.5
		if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
			CharacterEntity:ChangeState(State_Neutral_Idle)
		end
		
		return 1
	end)
	
	return true
end
function State_Neutral_WalkIn:Update(CharacterEntity)
	
end
function State_Neutral_WalkIn:Exit(CharacterEntity)
	
end
-- =======================================================



-- =======================================================
State_Positive_Idle = State("Positive_Idle")
function State_Positive_Idle:Enter(CharacterEntity)

	local Animation = CharacterEntity.Animations_IdlePositive[1]
	local Rand = math.random(1, #CharacterEntity.Animations_IdlePositive)
	Animation = CharacterEntity.Animations_IdlePositive[Rand]
	
	CharacterEntity.Timer = 0
	CharacterEntity.TimerDelay = math.random(2, 10)
	
	CharacterEntity.Character:PlayAnimation(Animation, -1, function(Character, Time, LoopedTime, Animation)
		local Blend = 1
		
		local BlendInDuration = 0.5
		if (LoopedTime < BlendInDuration) then
			Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
		end
		
		local LastSec = 0.5
		if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
			--CharacterEntity:ChangeState(State_Positive)
		end
		
		return Blend
	end)
	
	return true
end
function State_Positive_Idle:Update(CharacterEntity)
	if (CharacterEntity.Timer == nil) then
		CharacterEntity.Timer = 0
	end
	CharacterEntity.Timer = CharacterEntity.Timer + 1
	--print(CharacterEntity.Timer .. ' - ' .. CharacterEntity.TimerDelay)

	if (ActiveMission.MoodMeter < -0.5) then
		--CharacterEntity:ChangeState(State_Negative_Idle)
		CharacterEntity:ChangeState(State_Negative_Cheer)
	elseif (ActiveMission.MoodMeter < 0.5) then
		CharacterEntity:ChangeState(State_Neutral_Idle)
	elseif (ActiveMission.MoodMeter > 0.5 and CharacterEntity.Timer > CharacterEntity.TimerDelay) then
		CharacterEntity:ChangeState(State_Positive_Cheer)
	end
end
function State_Positive_Idle:Exit(CharacterEntity)
	
end
-- =======================================================


-- =======================================================
State_Positive_Cheer = State("Positive_Cheer")
function State_Positive_Cheer:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_CheerPositive[1]
	local Rand = math.random(1, #CharacterEntity.Animations_CheerPositive)
	Animation = CharacterEntity.Animations_CheerPositive[Rand]
	
	CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
		local Blend = 1
		
		local BlendInDuration = 0.5
		if (LoopedTime < BlendInDuration) then
			Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
		end
		
		local LastSec = 0.5
		if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
			CharacterEntity:ChangeState(State_Positive_Idle)
		end
		
		return Blend
	end)
	
	return true
end
function State_Positive_Cheer:Update(CharacterEntity)
	
end
function State_Positive_Cheer:Exit(CharacterEntity)
	
end
-- =======================================================


-- =======================================================
State_Neutral_Idle = State("Neutral_Idle")
function State_Neutral_Idle:Enter(CharacterEntity)

	local Animation = CharacterEntity.Animations_IdleNeutral[1]
	local Rand = math.random(1, #CharacterEntity.Animations_IdleNeutral)
	Animation = CharacterEntity.Animations_IdleNeutral[Rand]
	
	CharacterEntity.Character:PlayAnimation(Animation, -1, function(Character, Time, LoopedTime, Animation)
		local Blend = 1
		
		local BlendInDuration = 0.5
		if (LoopedTime < BlendInDuration) then
			Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
		end
		
		local LastSec = 1
		if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
			--CharacterEntity:ChangeState(State_Positive)
		end
		
		return Blend
	end)
	
	return true
end
function State_Neutral_Idle:Update(CharacterEntity)
	if (ActiveMission.MoodMeter > 0.5) then
		--CharacterEntity:ChangeState(State_Positive_Idle)
		CharacterEntity:ChangeState(State_Positive_Cheer)
	elseif (ActiveMission.MoodMeter < -0.5) then
		--CharacterEntity:ChangeState(State_Negative_Idle)
		CharacterEntity:ChangeState(State_Negative_Cheer)
	end
end
function State_Neutral_Idle:Exit(CharacterEntity)
	
end
-- =======================================================


-- =======================================================
State_Negative_Idle = State("Negative_Idle")
function State_Negative_Idle:Enter(CharacterEntity)

	local Animation = CharacterEntity.Animations_IdleNegative[1]
	local Rand = math.random(1, #CharacterEntity.Animations_IdleNegative)
	Animation = CharacterEntity.Animations_IdleNegative[Rand]

	CharacterEntity.Character:PlayAnimation(Animation, -1, function(Character, Time, LoopedTime, Animation)
		local Blend = 1
		
		local BlendInDuration = 0.5
		if (LoopedTime < BlendInDuration) then
			Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
		end
		
		local LastSec = 0.5
		if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
			--CharacterEntity:ChangeState(State_Positive)
		end
		
		return Blend
	end)
	
	return true
end
function State_Negative_Idle:Update(CharacterEntity)
	if (ActiveMission.MoodMeter > 0.5) then
		--CharacterEntity:ChangeState(State_Positive_Idle)
		CharacterEntity:ChangeState(State_Positive_Cheer)
	elseif (ActiveMission.MoodMeter > -0.5) then
		CharacterEntity:ChangeState(State_Neutral_Idle)
	elseif (ActiveMission.MoodMeter < -0.8 and CharacterEntity.EnableWalkout) then
		CharacterEntity:ChangeState(State_Negative_WalkOut)
	end
end
function State_Negative_Idle:Exit(CharacterEntity)
	
end
-- =======================================================


-- =======================================================
State_Negative_Cheer = State("Negative_Cheer")
function State_Negative_Cheer:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_CheerNegative[1]
	local Rand = math.random(1, #CharacterEntity.Animations_CheerNegative)
	Animation = CharacterEntity.Animations_CheerNegative[Rand]
	
	CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
	
		local Blend = 1
		
		local BlendInDuration = 0.5
		if (LoopedTime < BlendInDuration) then
			Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
		end
		
		local LastSec = 0.5
		if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
			CharacterEntity:ChangeState(State_Negative_Idle)
		end
		
		return Blend
	end)
	
	return true
end
function State_Negative_Cheer:Update(CharacterEntity)
	
end
function State_Negative_Cheer:Exit(CharacterEntity)
	
end
-- =======================================================



-- =======================================================
State_Negative_WalkOut = State("Negative_WalkOut")
function State_Negative_WalkOut:Enter(CharacterEntity)

	local Animation = CharacterEntity.Animations_WeglopenNegative[1]
	local Rand = math.random(1, #CharacterEntity.Animations_WeglopenNegative)
	Animation = CharacterEntity.Animations_WeglopenNegative[Rand]
	
	CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
	 
		local Blend = 1
		
		local BlendInDuration = 0.5
		if (LoopedTime < BlendInDuration) then
			Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
		end
		
		local LastSec = 0.5
		if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
			CharacterEntity:ChangeState(State_Negative_IdleOutside)
		end
		
		return Blend
	end)
	
	return true
end
function State_Negative_WalkOut:Update(CharacterEntity)
	
end
function State_Negative_WalkOut:Exit(CharacterEntity)
	
end
-- =======================================================



-- =======================================================
State_SpecialMove_SeeSaw = State("SpecialMove_SeeSaw")
function State_SpecialMove_SeeSaw:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_SpecialMove_SeeSaw[1]
	local Rand = math.random(1, #CharacterEntity.Animations_SpecialMove_SeeSaw)
	Animation = CharacterEntity.Animations_SpecialMove_SeeSaw[Rand]
	
	if (Animation ~= nil) then
		--print("Animation TotalTime: " .. tostring(Animation:GetTotalTime()))
	
		CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
			local Blend = 1
			
			local BlendInDuration = 0.5
			if (LoopedTime < BlendInDuration) then
				Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
			end
			
			local LastSec = 0.5
			if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
				if (ActiveMission ~= nil and ActiveMission.MoodMeter ~= nil) then
					if (ActiveMission.MoodMeter > 0.5) then
						CharacterEntity:ChangeState(State_Positive_Idle)
					elseif (ActiveMission.MoodMeter > -0.5) then
						CharacterEntity:ChangeState(State_Neutral_Idle)
					elseif (ActiveMission.MoodMeter < -0.5) then
						CharacterEntity:ChangeState(State_Negative_Idle)
					end
				else
					CharacterEntity:ChangeState(State_Neutral_Idle)
				end
			end
			
			return Blend
		end)
		
		return true
	end
	return false
end
function State_SpecialMove_SeeSaw:Update(CharacterEntity)
	
end
function State_SpecialMove_SeeSaw:Exit(CharacterEntity)
	
end
-- =======================================================

State_SpecialMove_AroundTheWorld = State("SpecialMove_AroundTheWorld")
function State_SpecialMove_AroundTheWorld:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_SpecialMove_AroundTheWorld[1]
	local Rand = math.random(1, #CharacterEntity.Animations_SpecialMove_AroundTheWorld)
	Animation = CharacterEntity.Animations_SpecialMove_AroundTheWorld[Rand]
	
	if (Animation ~= nil) then
		--print("Animation TotalTime: " .. tostring(Animation:GetTotalTime()))
	
		CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
			local Blend = 1
			
			local BlendInDuration = 0.5
			if (LoopedTime < BlendInDuration) then
				Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
			end
			
			local LastSec = 0.5
			if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
				if (ActiveMission ~= nil and ActiveMission.MoodMeter ~= nil) then
					if (ActiveMission.MoodMeter > 0.5) then
						CharacterEntity:ChangeState(State_Positive_Idle)
					elseif (ActiveMission.MoodMeter > -0.5) then
						CharacterEntity:ChangeState(State_Neutral_Idle)
					elseif (ActiveMission.MoodMeter < -0.5) then
						CharacterEntity:ChangeState(State_Negative_Idle)
					end
				else
					CharacterEntity:ChangeState(State_Neutral_Idle)
				end
			end
			
			return Blend
		end)
		
		return true
	end
	return false
end
function State_SpecialMove_AroundTheWorld:Update(CharacterEntity)
	
end
function State_SpecialMove_AroundTheWorld:Exit(CharacterEntity)
	
end
-- =======================================================

State_SpecialMove_Pancake = State("SpecialMove_Pancake")
function State_SpecialMove_Pancake:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_SpecialMove_Pancake[1]
	local Rand = math.random(1, #CharacterEntity.Animations_SpecialMove_Pancake)
	Animation = CharacterEntity.Animations_SpecialMove_Pancake[Rand]
	
	if (Animation ~= nil) then
		--print("Animation TotalTime: " .. tostring(Animation:GetTotalTime()))
	
		CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
			local Blend = 1
			
			local BlendInDuration = 0.5
			if (LoopedTime < BlendInDuration) then
				Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
			end
			
			local LastSec = 0.5
			if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
				if (ActiveMission ~= nil and ActiveMission.MoodMeter ~= nil) then
					if (ActiveMission.MoodMeter > 0.5) then
						CharacterEntity:ChangeState(State_Positive_Idle)
					elseif (ActiveMission.MoodMeter > -0.5) then
						CharacterEntity:ChangeState(State_Neutral_Idle)
					elseif (ActiveMission.MoodMeter < -0.5) then
						CharacterEntity:ChangeState(State_Negative_Idle)
					end
				else
					CharacterEntity:ChangeState(State_Neutral_Idle)
				end
			end
			
			return Blend
		end)
		
		return true
	end
	return false
end
function State_SpecialMove_Pancake:Update(CharacterEntity)
	
end
function State_SpecialMove_Pancake:Exit(CharacterEntity)
	
end
-- =======================================================

State_SpecialMove_SpecialHop = State("SpecialMove_SpecialHop")
function State_SpecialMove_SpecialHop:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_SpecialMove_SpecialHop[1]
	local Rand = math.random(1, #CharacterEntity.Animations_SpecialMove_SpecialHop)
	Animation = CharacterEntity.Animations_SpecialMove_SpecialHop[Rand]
	
	if (Animation ~= nil) then
		--print("Animation TotalTime: " .. tostring(Animation:GetTotalTime()))
	
		CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
			local Blend = 1
			
			local BlendInDuration = 0.5
			if (LoopedTime < BlendInDuration) then
				Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
			end
			
			local LastSec = 0.5
			if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
				if (ActiveMission ~= nil and ActiveMission.MoodMeter ~= nil) then
					if (ActiveMission.MoodMeter > 0.5) then
						CharacterEntity:ChangeState(State_Positive_Idle)
					elseif (ActiveMission.MoodMeter > -0.5) then
						CharacterEntity:ChangeState(State_Neutral_Idle)
					elseif (ActiveMission.MoodMeter < -0.5) then
						CharacterEntity:ChangeState(State_Negative_Idle)
					end
				else
					CharacterEntity:ChangeState(State_Neutral_Idle)
				end
			end
			
			return Blend
		end)
		
		return true
	end
	return false
end
function State_SpecialMove_SpecialHop:Update(CharacterEntity)
	
end
function State_SpecialMove_SpecialHop:Exit(CharacterEntity)
	
end
-- =======================================================

State_SpecialMove_SideHop = State("SpecialMove_SideHop")
function State_SpecialMove_SideHop:Enter(CharacterEntity)
	local Animation = CharacterEntity.Animations_SpecialMove_SpecialSide[1]
	local Rand = math.random(1, #CharacterEntity.Animations_SpecialMove_SpecialSide)
	Animation = CharacterEntity.Animations_SpecialMove_SpecialSide[Rand]
	
	if (Animation ~= nil) then
		--print("Animation TotalTime: " .. tostring(Animation:GetTotalTime()))
	
		CharacterEntity.Character:PlayAnimation(Animation, 1, function(Character, Time, LoopedTime, Animation)
			local Blend = 1
			
			local BlendInDuration = 0.5
			if (LoopedTime < BlendInDuration) then
				Blend = Lerp(0, 1, LoopedTime / BlendInDuration)
			end
			
			local LastSec = 0.5
			if (CharacterEntity.CurrentState == self and Time > Animation:GetTotalTime() - LastSec) then
				if (ActiveMission ~= nil and ActiveMission.MoodMeter ~= nil) then
					if (ActiveMission.MoodMeter > 0.5) then
						CharacterEntity:ChangeState(State_Positive_Idle)
					elseif (ActiveMission.MoodMeter > -0.5) then
						CharacterEntity:ChangeState(State_Neutral_Idle)
					elseif (ActiveMission.MoodMeter < -0.5) then
						CharacterEntity:ChangeState(State_Negative_Idle)
					end
				else
					CharacterEntity:ChangeState(State_Neutral_Idle)
				end
			end
			
			return Blend
		end)
		
		return true
	end
	return false
end
function State_SpecialMove_SideHop:Update(CharacterEntity)
	
end
function State_SpecialMove_SideHop:Exit(CharacterEntity)
	
end
-- =======================================================
