CoinManager = class(function(self)
	self.CoinCount = 0
	self.GoloCoinCount = 0
	
	-- if (true) then
		-- self.CoinCount = 1000000
		-- self.GoloCoinCount = 500
	-- end
	
	self.CoinProducts = {}
	self.GoloCoinProducts = {}
end)

function CoinManager:AddCoinProduct(CoinProduct, Golo, SpecialRedeem)
	if (Golo) then
		table.insert(self.GoloCoinProducts, CoinProduct)
	else
		table.insert(self.CoinProducts, CoinProduct)
	end
	
	if (SpecialRedeem == nil) then
		SpecialRedeem = false
	end
	
	CoinProduct.CoinManager = self
	CoinProduct.SpecialRedeem = SpecialRedeem
end

function CoinManager:GetCoinProduct(ID)
	for i, CoinProduct in ipairs(self.CoinProducts) do
		if (CoinProduct.ShopID == ID) then
			return CoinProduct
		end
	end
	
	for i, CoinProduct in ipairs(self.GoloCoinProducts) do
		if (CoinProduct.ShopID == ID) then
			return CoinProduct
		end
	end
	
	return nil
end

function CoinManager:GetCoinCount()
	local TotalCoinCount = 0
	if (TapJoy ~= nil) then
		TotalCoinCount = self.CoinCount + TapJoy:GetCoinCount()
	else
		TotalCoinCount = self.CoinCount
	end
	
	return TotalCoinCount
end

function CoinManager:GetGoloCoinCount()
	local TotalCoinCount = 0
	
	TotalCoinCount = self.GoloCoinCount
	
	return TotalCoinCount
end

function CoinManager:SetCoinCount(CoinCount)
	self.CoinCount = CoinCount
	
	self:UpdateCoincount()
end

function CoinManager:SetGoloCoinCount(CoinCount)
	self.GoloCoinCount = CoinCount
	
	self:UpdateCoincount()
end

function CoinManager:AddCoinCount(Amount, SendProgress)
	self.CoinCount = self.CoinCount + Amount
	
	self:UpdateCoincount()
	
	if (SendProgress == nil) then
		SendProgress = true
	end
	WriteGameSettings(SendProgress) -- dus de coins die je krijgt worden niet eens opgeslagen? tell me if i'm wrong!
end

function CoinManager:AddGoloCoinCount(Amount, SendProgress)
	self.GoloCoinCount = self.GoloCoinCount + Amount
	
	self:UpdateCoincount()

	if (SendProgress == nil) then
		SendProgress = true
	end
	WriteGameSettings(SendProgress) -- dus de coins die je krijgt worden niet eens opgeslagen? tell me if i'm wrong!
end

function CoinManager:UpdateCoincount()
	if (ActiveMenu ~= nil and ActiveMenu.UpdateCoincount ~= nil) then
		ActiveMenu:UpdateCoincount()
	end
	
	if (ActiveForeground ~= nil and ActiveForeground.UpdateCoincount ~= nil) then
		ActiveForeground:UpdateCoincount()
	end
end

function CoinManager:BuyProduct(Amount, BuyFunction)
	if (self:GetCoinCount() >= Amount) then
	
		local CoinsRemaining = 0
		if (self.CoinCount >= Amount) then		--First use own virtual coins
			self.CoinCount = self.CoinCount - Amount
			
			BuyFunction()
			return true
		elseif (TapJoy ~= nil) then				--Not enough? Use TapJoyCoins for the remaining coins
			CoinsRemaining = Amount - self.CoinCount
			
			TapJoy:SpendCoin(CoinsRemaining, BuyFunction)
			self.CoinCount = 0				--Only substract/reset coincount when we completed the purchase
			
			return true
		end
	end
	
	return false
end

function CoinManager:BuyGoloProduct(Amount, BuyFunction)
	if (self:GetGoloCoinCount() >= Amount) then
	
		local CoinsRemaining = 0
		if (self.GoloCoinCount >= Amount) then		--First use own virtual coins
			self.GoloCoinCount = self.GoloCoinCount - Amount
			
			BuyFunction()
			return true
		end
	end
	
	return false
end

function CoinManager:SendInAppPurchasesStats(ProductID, Valuta, CurrentPrice, CoinsGained, GearsGained)
	print("CoinManager:SendInAppPurchasesStats")

	-- Send InAppPurchases Stats
	
	local FailureFunction = function(Data)
		print("Error sending InAppPurchases stats")
	end
	
	local SuccessFunction = function(Data)
		print('AddInAppPurchasesStats')
	end
	
	local UserID = 0
	if (FBManager:IsLoginValid()) then
		UserID = FBManager.UserinfoTable['HighscoresID']
	else
		UserID = Scores.UserID
	end
	
	ScoresUser:AddInAppPurchasesStats(UserID, ProductID, Valuta, CurrentPrice, CoinsGained, GearsGained, SuccessFunction, FailureFunction)
end

function CoinManager:SendCollectedCoinsStats(Type, CoinsGained, GearsGained)
	--Types
	--$Types[] = "InGame";
	--$Types[] = "DailyChallenge";
	--$Types[] = "FriendCollect";
	--$Types[] = "LiveEvent";
	--$Types[] = "FacebookAward";
	--$Types[] = "RateGame";
	--$Types[] = "LikeDev";
	--$Types[] = "LikeGame";
	--$Types[] = "VisitWebsite";
	--$Types[] = "Other";

	print("CoinManager:SendCollectedCoinsStats")

	-- Send InAppPurchases Stats
	
	local FailureFunction = function(Data)
		print("Error sending CollectedCoins stats")
	end
	
	local SuccessFunction = function(Data)
		print('AddCollectedCoinsStats')
	end
	
	local UserID = 0
	if (FBManager:IsLoginValid()) then
		UserID = FBManager.UserinfoTable['HighscoresID']
	else
		UserID = Scores.UserID
	end
	
	ScoresUser:AddCollectedCoinsStats(UserID, Type, CoinsGained, GearsGained, SuccessFunction, FailureFunction)
end

-- ============

ShopCoins = class(function(self, Amount, Price, ShopID, Texture, GoloAmount)
	self.Texture = texture("Menu\\Images\\" .. Texture .. ".DCT")
	
	self.CoinsAmount = Amount
	self.GoloCoinsAmount = GoloAmount
	
	--Shop standard vars
	self.ShopPrice = Price -- moet ook een language key kunnen zijn! (like us on facebook!)
	self.ShopID = ShopID
	self.SpecialRedeem = false
end)

function ShopCoins:Buy()
	--print("ShopCoins:Buy")
	if (self.CoinManager ~= nil) then
		self.CoinManager:AddCoinCount(self.CoinsAmount, false)
		if (self.GoloCoinsAmount ~= nil) then
			self.CoinManager:AddGoloCoinCount(self.GoloCoinsAmount, false)
		end
		WriteGameSettings(true)
		print('Coins: ' .. self.CoinManager:GetCoinCount())
		
		
		local ProductPrice = self.ShopPrice
		local ValutaStr = "USD"
		for j, StoreProduct in ipairs(StoreProducts) do
			if (self.ShopID == StoreProduct.ID) then
				local SpaceLoc = string.find(StoreProduct.Price, " ")
				if (SpaceLoc > 0) then
					ValutaStr = string.sub(StoreProduct.Price, 0, SpaceLoc - 1)
					ProductPrice = string.sub(StoreProduct.Price, SpaceLoc + 1)
					ProductPrice = string.gsub(ProductPrice, ",", ".")
				end
			end
		end
		self.CoinManager:SendInAppPurchasesStats(self.ShopID, ValutaStr, ProductPrice, self.CoinsAmount, self.GoloCoinsAmount)
	end
end

ShopCoinsGolo = class(function(self, Amount, Price, ShopID, Texture)
	self.Texture = texture("Menu\\Images\\" .. Texture .. ".DCT")
	
	self.CoinsAmount = Amount
	
	--Shop standard vars
	self.ShopPrice = Price -- moet ook een language key kunnen zijn! (like us on facebook!)
	self.ShopID = ShopID
end)

function ShopCoinsGolo:Buy()
	--print("ShopCoins:Buy")
	if (self.CoinManager ~= nil) then
		self.CoinManager:AddGoloCoinCount(self.CoinsAmount)
		print('Coins: ' .. self.CoinManager:GetGoloCoinCount())
		
		local ProductPrice = self.ShopPrice
		local ValutaStr = "USD"
		for j, StoreProduct in ipairs(StoreProducts) do
			if (self.ShopID == StoreProduct.ID) then
				local SpaceLoc = string.find(StoreProduct.Price, " ")
				if (SpaceLoc > 0) then
					ValutaStr = string.sub(StoreProduct.Price, 0, SpaceLoc - 1)
					ProductPrice = string.sub(StoreProduct.Price, SpaceLoc + 1)
					ProductPrice = string.gsub(ProductPrice, ",", ".")
				end
			end
		end
		self.CoinManager:SendInAppPurchasesStats(self.ShopID, ValutaStr, ProductPrice, self.CoinsAmount, self.GoloCoinsAmount)
	end
end

-- ============

function PaymentCancelled()
	print("NOT Bought product ")
	
	if (ActiveMenu ~= nil and ActiveMenu.PaymentCancelled ~= nil) then
		ActiveMenu:PaymentCancelled()
	end
end

function BoughtProduct(ID, Signature, Token)
	print("Bought product " .. ID)

	--Data afhandeling
	if (Shop_BuyItem(ID, Signature, Token)) then
		MessageBox(Translate("Purchase1"), Translate("Purchase2"), Translate("Purchase3"))
	end

	-- Dit vind ik nog steeds eng
	if (ActiveMenu ~= nil and ActiveMenu.BoughtProduct ~= nil) then
		ActiveMenu:BoughtProduct(ID)
	end
	
	if (ActiveMenu ~= nil and ActiveMenu.UpdateCoincount ~= nil) then
		ActiveMenu:UpdateCoincount()
	end
	
	if (ActiveForeground ~= nil and ActiveForeground.UpdateCoincount ~= nil) then
		ActiveForeground:UpdateCoincount()
	end
	
	if (ActiveMenu ~= nil and ActiveMenu.EnableCoinButtons ~= nil) then
		ActiveMenu:EnableCoinButtons()
	end
end

function Shop_BuyItem(ID, Signature, Token)
	--Fake
	if (ID == "android.test.purchased") then
		ID = "shop_coins_14000"
		--ID = "shop_purchase_all_1"
	end
	
	--local ShopItem = TempShopItem	-- dit fixen
	local ShopItem = VirtualCoins:GetCoinProduct(ID)
	
	local ReturnValue = true
	
	--[[ if (ID == "shop_purchase_all_1") then
		ShopItem = PackageLimitedBundle1
		PackageBundle1.Bought = true
		
		ReturnValue = not ShopItem.Bought
		Token = nil
	end
	
	if (ID == "shop_coinmultiplier_25") then	-- hier straks de special coin mult van maken
		ShopItem = PackageLimitedBundle2
		
		ReturnValue = not ShopItem.Bought
		Token = nil
	end ]]

	if (ShopItem ~= nil) then
		--Buy item
		if (ShopItem.Buy ~= nil) then
			if (Token ~= nil and ConsumeProduct ~= nil) then
				if (ConsumeProduct(ID, Signature, Token)) then
					ShopItem:Buy()

					if (TapJoy ~= nil) then
						TapJoy.DisableAds = true
					end
				end
			else
				ShopItem:Buy()
			end
		else
			if (not ShopItem.Bought) then
				print("Item was nog niet gekocht");
			else
				print("Item was al wel gekocht");
			end
			
			ShopItem.Bought = true
		end  
		
		if (TapJoy ~= nil) then
			TapJoy.DisableAds = true
		end
		
		WriteGameSettings(false)
		  
		--Hier stats sturen
		print('send stats')	
		print('BuyGoogleProduct')		--ShopAction
		print(ID)						--ItemID				
		print(ShopItem.ShopPrice)		--ItemPrice
     else  
          print("Shop_BuyItem: Can't find coin product")  
     end
	 
	 return ReturnValue
end

-- ============

VirtualCoins = CoinManager()

local ValutaStr = ""--Translate("valuta_euro") .. " "
VirtualCoins:AddCoinProduct(ShopCoins(GetBundle("Gold", "Gold", 7), ValutaStr .. 0.99, "shop_coins_10000_gears_0", "Purchase_Gold1", GetBundle("Gold", "MJ", 7)))
VirtualCoins:AddCoinProduct(ShopCoins(GetBundle("Gold", "Gold", 8), ValutaStr .. 1.99, "shop_coins_22000_gears_0", "Purchase_Gold2", GetBundle("Gold", "MJ", 8)))
VirtualCoins:AddCoinProduct(ShopCoins(GetBundle("Gold", "Gold", 9), ValutaStr .. 4.99, "shop_coins_60000_gears_0", "Purchase_Gold3", GetBundle("Gold", "MJ", 9)))
VirtualCoins:AddCoinProduct(ShopCoins(GetBundle("Gold", "Gold", 10), ValutaStr .. 7.99, "shop_coins_100000_gears_0", "Purchase_Gold4", GetBundle("Gold", "MJ", 10)))
VirtualCoins:AddCoinProduct(ShopCoins(GetBundle("Gold", "Gold", 11), ValutaStr .. 9.99, "shop_coins_140000_gears_0", "Purchase_Gold5", GetBundle("Gold", "MJ", 11)))
VirtualCoins:AddCoinProduct(ShopCoins(GetBundle("Gold", "Gold", 12), ValutaStr .. 19.99, "shop_coins_300000_gears_0", "Purchase_Gold6", GetBundle("Gold", "MJ", 12)))
VirtualCoins:AddCoinProduct(ShopCoins(GetBundle("Gold", "Gold", 13), ValutaStr .. 29.99, "shop_coins_500000_gears_40", "Purchase_Gold7", GetBundle("Gold", "MJ", 13)))
VirtualCoins:AddCoinProduct(ShopCoins(GetBundle("Gold", "Gold", 14), ValutaStr .. 49.99, "shop_coins_1000000_gears_100", "Purchase_Gold8", GetBundle("Gold", "MJ", 14)))

VirtualCoins:AddCoinProduct(ShopCoinsGolo(GetBundle("MJ", "MJ", 1), ValutaStr .. 1.99, "new_shop_coinsgolo_3", "Purchase_Golo1"), true)
VirtualCoins:AddCoinProduct(ShopCoinsGolo(GetBundle("MJ", "MJ", 2), ValutaStr .. 2.99, "new_shop_coinsgolo_6", "Purchase_Golo2"), true)
VirtualCoins:AddCoinProduct(ShopCoinsGolo(GetBundle("MJ", "MJ", 3), ValutaStr .. 5.99, "new_shop_coinsgolo_14", "Purchase_Golo3"), true)
VirtualCoins:AddCoinProduct(ShopCoinsGolo(GetBundle("MJ", "MJ", 4), ValutaStr .. 11.99, "new_shop_coinsgolo_30", "Purchase_Golo4"), true)

VirtualCoins.RateAmount = 500
VirtualCoins.IsRated = false
VirtualCoins.LikeAmount_Game = 500
VirtualCoins.IsLiked_Game = false
VirtualCoins.LikeAmount_Developer = 500
VirtualCoins.IsLiked_Developer = false
VirtualCoins.VisitAmount_Website = 150
VirtualCoins.IsVisited_Website = false
VirtualCoins.FirstAmount_Facebook = 1500
VirtualCoins.IsFirst_Facebook = false


if (GetPlatform() == "Android") then
	print(table.empty(StoreProducts))
	if (table.empty(StoreProducts)) then
		print("Requesting Products")
		
		local Products = {}
		for i, CoinProduct in ipairs(VirtualCoins.CoinProducts) do
			table.insert(Products, CoinProduct.ShopID)
		end
		for i, CoinProduct in ipairs(VirtualCoins.GoloCoinProducts) do
			table.insert(Products, CoinProduct.ShopID)
		end
		
		RequestProduct(Products)
	end
end