DestroyableObject = class(function(self, WorldObject)
	self.WorldObject = WorldObject
	self.ObjectName = self.WorldObject:GetName();
	self.ObjectScoreValue = self.WorldObject:GetScore();
	self.ObjectTime = self.WorldObject:GetTime();
	self.Destroyed = false
	
	-- Print initialized object names
	--print(self.WorldObject:GetName())
	
	self.Thread = PhysicsThread:Spawn(function()	
		-- Spawn stuff
	end)
end)

DestroyableObjectsManager = class(function(self)
	self.Objects = {} 			-- Each object name/type saved separately.
	self.ObjectCount = {}		-- The amount of times each vehicle is hit, saved separately.
	self.ScoreValues = {} 		-- The amount of points for each vehicle type.
	self.Scores = {}			-- The total score for each destroyed vehicle type saved separately.
	--self.TotalScore = 0 		-- The total score of all scores added up
	self.TotalObjectCount = 0	-- The total amount of objects that have been hit of all scores added up
end)

function DestroyableObjectsManager:AddObject(Object, ScoreValue, AdditionalTime)
	if(self:InList(Object))then
		for i, EachObject in ipairs(self.Objects)do
			if(Object == self.Objects[i])then
				self.ObjectCount[i] = self.ObjectCount[i] + 1
				self.Scores[i] = self.Scores[i] + self.ScoreValues[i]
			end
		end		
	else
		table.insert(self.Objects, Object)
		table.insert(self.ObjectCount, 1)
		table.insert(self.ScoreValues, ScoreValue)
		table.insert(self.Scores, ScoreValue)
	end
	
	--self:AddTime(AdditionalTime)
end

function DestroyableObjectsManager:InList(Object)
	for i, EachObject in ipairs(self.Objects)do
		if(Object == self.Objects[i])then
			return true
		end
	end
	return false
end

function DestroyableObjectsManager:AddTime(AdditionalTime)
	if (ActiveMission:is_a(DestroyerMission) and ActiveMission.RaceTimer ~= nil) then
		ActiveMission.RaceTimer = ActiveMission.RaceTimer + AdditionalTime
	end
end

function DestroyableObjectsManager:GetTotalScore()
	local TotalScore = 0
	for i, EachScore in ipairs(self.ObjectCount)do
		TotalScore = TotalScore + self.Scores[i]
	end
	
	return TotalScore
end

function DestroyableObjectsManager:GetTotalObjectsHit()
	for i, EachHit in ipairs(self.ObjectCount)do
		self.TotalObjectCount = self.TotalObjectCount + self.ObjectCount[i]
	end
	
	return self.TotalObjectCount
end

function InitDamageObject(WorldObject)
	local Object = DestroyableObject(WorldObject)
	
	return Object
end

function CollideDamageObject(LuaObject, Entity)
	if(LuaObject.Destroyed == false)then
		local Name = LuaObject.ObjectName
		local Score = LuaObject.ObjectScoreValue
		local Time = LuaObject.ObjectTime
		
		--print("Name = "..(Name)..", score = "..(Score).." , time = "..(Time))
		
		LuaObject.Destroyed = true
		
		if (ActiveMission ~= nil and ActiveMission.WorldObjectManager ~= nil) then
			ActiveMission.WorldObjectManager:AddObject(Name, Score, Time)		
		end
	end
end