HTTPClient = class(function(self)
	self.Client = CreateHTTPClient()
	self.Connections = {}

	self.FunctionTable = {}
end)

function HTTPClient:SetFunction(Name, Function)
	self.FunctionTable[self.Client:GetFunctionID(Name)] = Function
end

function HTTPClient:Connect()
	--self.Client:Connect("192.168.1.123", 1236,
	--self.Client:Connect("www.team6-games.com", 1236,
	--self.Client:Connect("192.168.1.113", 1337,
	self.Client:Connect("www.team6-games.com", 80,
		function(...)
			self:Connected(...)
		end,

		function(...)
			self:NotConnected(...)
		end,

		function(...)
			self:Disconnected(...)
		end,

		function(...)
			self:Receive(...)
		end)
end


function HTTPClient:Disconnect()
	self.Client:Disconnect(
		function(...)
			self:Disconnected(...)
		end)
	self.IsConnected = false
end

function HTTPClient:Connected()
	print("HTTPClient:Connected")
	self.IsConnected = true
end

function HTTPClient:NotConnected()
	print("HTTPClient:NotConnected")
	self.IsConnected = false
end

function HTTPClient:Disconnected()
	print("HTTPClient:Disconnected")
	self.IsConnected = false
end

function HTTPClient:Receive(HTTPData)
	--print(HTTPData)
	print('HTTPClient:Receive_HTTPData')

	LuaData = UnSerialize(HTTPData);
	
	if (LuaData) then
		local FunctionID = self.Client:GetFunctionID(LuaData.Function)
		local Function = self.FunctionTable[FunctionID];
		
		if (Function ~= nil) then
			Function(LuaData)
		end
	else
		print('No Correct LuaData received')
	end
end

function HTTPClient:Send(Function, Data)
	self.Client:Send(Function, Data)
end