function AddKeyListenerInternal(Listeners, KeyCode, Type, Listener)
	if (type(KeyCode) == "string") then
		KeyCode = GetKeyCode(KeyCode)
	end

	table.insert(Listeners, AddKeyListener(KeyCode, Type, function()
		Listener(Listeners)
	end))
end

function AddKeyListenersInternal(Listeners, KeyCodes, Type, Listener)
	if (type(KeyCodes) == "table") then
		for i = 1, #KeyCodes do
			AddKeyListenerInternal(Listeners, KeyCodes[i], Type, Listener)
		end
	else 
		AddKeyListenerInternal(Listeners, KeyCodes, Type, Listener)
	end
end

-- Hier kunnen tabellen van/of strings of numbers in
function AddKeyListeners(KeyCodes, Type, Listener)
	local Listeners = {}

	local Timer = nil

	if (Type == "TimedDown") then
		AddKeyListenersInternal(Listeners, KeyCodes, "Down", function(Listeners)
			Timer = 15	-- 0.25 * 60

			RepeatListeners = Listeners

			Listener(Listeners)
		end)

		AddKeyListenersInternal(Listeners, KeyCodes, "Up", function(Listeners)
			Timer = nil

			if (RepeatListeners == Listeners) then
				RepeatListeners = nil
			end
		end)

		AddKeyListenersInternal(Listeners, KeyCodes, "Pressed", function(Listeners)
			if (RepeatListeners == Listeners) then
				Timer = Timer - 1

				if (Timer == 0) then
					Timer = 3	-- 0.05 * 60

					Listener(Listeners)
				end
			end
		end)
	else
		AddKeyListenersInternal(Listeners, KeyCodes, Type, Listener)
	end

	return Listeners;
end
			
function DelKeyListeners(Listeners)
	if (Listeners ~= nil) then
		for i = 1, #Listeners do
			DelKeyListener(Listeners[i])
		end
	end
end

-- Laag 2
function SetKeyListener(KeyCodes, Type, Listener)
	local Listeners = AddKeyListeners(KeyCodes, Type, function(Listeners)
		DelKeyListeners(Listeners)

		Listener()
	end)

	return Listeners
end

-- Laag 3
function ClickedEvent(KeyNames, Listener)
	return SetKeyListener(KeyNames, "Down", Listener)
end

function ReleasedEvent(KeyNames, Listener)
	return SetKeyListener(KeyNames, "Up", Listener)
end