ObjectManager = class(function(self)
	self.Object = nil
end)

function ObjectManager:Destroy()
	if (self.Object ~= nil) then		
		-- Remove the Object from the EntityScene
		GetEntityScene():DestroyEntity(self.Object);	-- Dit gebeurt vanzelf wel
		
		-- Remove the Object reference
		self.Object = nil
	end
end

function ObjectManager:ShowObject(Object)
	-- Zinloze check
	if (Object == nil) then
		print("Waarom stuur je een ShowObject(nil) door?")
		return
	end
	
	-- Check of we toevallig deze auto al geladen hadden
	if (self.Object == Object) then
		return
	end
	
	-- Gooi de huidige auto weg
	if (self.Object ~= nil) then
		self:Destroy()
	end
	
	-- Assign de nieuwe auto
	self.Object = Object
	
	PhysicsThread:Run(function()			
		self.Object = Object
		GetEntityScene():AddEntity(self.Object)
	
		-- Gooi object in de scene met een offset
		local Matrix = GetScriptMatrix("Object"):Translate(Vector(0,15,0))
		self.Object:Update(Matrix, VectorZero, VectorZero)

		-- Set de lookat
		if (ActiveMission.ObjectRender ~= nil) then
			ActiveMission.ObjectRender:LookAt(GetScriptMatrix("Object"):GetTranslation() + Vector(0, 15, 0))
		end
	
		-- Update de Camera
		if (ActiveMission.ObjectRender ~= nil) then
			ActiveMission.ObjectRender.CamHelper:Update() 
		end
	end)
end