function SetScreenButtonMenu(Panel, KeyName, x, y, Width, Height, AlignX, AlignY, PanelAlignX, PanelAlignY, Color, Template, Name)
	local PrintDebugLog = false

	Panel:SetSize(getvar("VirtualRTx"), getvar("VirtualRTy"))

	if (PrintDebugLog) then
		print("---^2Start^7---")
	end
	
	local PanelPosX, PanelPosY = Panel:GetPos()
	local PanelWidth, PanelHeight = Panel:GetSize()

	if (PrintDebugLog) then
		print("PanelPosX = " .. PanelPosX .. " PanelPosY = " .. PanelPosY)
		print("PanelWidth = " .. PanelWidth .. " PanelHeight = " .. PanelHeight)
	end

	x = x - Width * AlignX
	y = y - Height * AlignY

	x = x + PanelWidth * PanelAlignX
	y = y + PanelHeight * PanelAlignY

	if (PrintDebugLog) then
		print("X = " .. x .. " Y = " .. y)
	end

	SetScreenButton(KeyName, x, y, Width, Height, 0.5, 0.5)

	local ShowScreenButtons = false
	if (ShowScreenButtons) then
		local Item = Panel:AddItem(Template)
		Item:SetPos(x, y)
		Item:SetSize(Width, Height)
		
		local ItemName = Item:GetChild("ItemName")
		
		if (Name == nil) then
			if (PrintDebugLog) then
				print("^1Name = nil")
			end
			
			Name = "Undefined"
		else
			if (PrintDebugLog) then
				print("Name = OK")
			end
		end
		
		if (PrintDebugLog) then
			print("Name = " .. Name)
		end
		
		ItemName:SetText(Translate(Name))

		if (Color == nil) then
			Color = color(1,0,1,1)
		end
		
		Item:SetColor(Color)
		
		if (PrintDebugLog) then
			print("---^2Done^7---")
		end
		
		return Item
	end
	
	if (PrintDebugLog) then
		print("---^2Done^7---")
	end
end

function SetAnalogueStickMenu(Panel, KeyName, x, y, Width, Height, AlignX, AlignY, PanelAlignX, PanelAlignY, Color, Template, Name)
	local PrintDebugLog = false

	Panel:SetSize(getvar("VirtualRTx"), getvar("VirtualRTy"))
	
	local Radius = Max(Width, Height)

	if (PrintDebugLog) then
		print("---^2Start^7---")
	end
	
	local PanelPosX, PanelPosY = Panel:GetPos()
	local PanelWidth, PanelHeight = Panel:GetSize()

	if (PrintDebugLog) then
		print("PanelPosX = " .. PanelPosX .. " PanelPosY = " .. PanelPosY)
		print("PanelWidth = " .. PanelWidth .. " PanelHeight = " .. PanelHeight)
		print("Width = " .. Width .. " Height = " .. Height)
	end

	x = x - (Width) * AlignX
	y = y - (Height) * AlignY

	x = x + PanelWidth * PanelAlignX
	y = y + PanelHeight * PanelAlignY

	if (PrintDebugLog) then
		print("X = " .. x .. " Y = " .. y)
	end

	local SquareAnalogueStick = true
	if (SquareAnalogueStick) then
		--Square stick
		local Mode = 1
		AddAnalogStick(KeyName, Mode, x + (Width / 2), y + (Height / 2), Width / 2, Height / 2, 0, 0, 1)
	else
		--Round stick
		local Mode = 0
		AddAnalogStick(KeyName, Mode, x + (Width / 2), y + (Height / 2), Radius / 2, 0, 0, 1)
	end

	local ShowScreenButtons = false
	if (ShowScreenButtons) then
		local Item = Panel:AddItem(Template)
		Item:SetPos(x, y)
		Item:SetSize(Width, Height)
		
		local ItemName = Item:GetChild("ItemName")
		
		if (Name == nil) then
			if (PrintDebugLog) then
				print("^1Name = nil")
			end
			
			Name = "Undefined"
		else
			if (PrintDebugLog) then
				print("Name = OK")
			end
		end
		
		if (PrintDebugLog) then
			print("Name = " .. Name)
		end
		
		ItemName:SetText(Translate(Name))

		if (Color == nil) then
			Color = color(1,0,1,1)
		end
		
		Item:SetColor(Color)
		
		if (PrintDebugLog) then
			print("---^2Done^7---")
		end
		
		local Y_Axis_Top_Panel = Item:GetChild("Y_Axis_Top")
		Y_Axis_Top_Panel:SetSize(Width, (Height / 2))
		
		local Y_Axis_Bottom_Panel = Item:GetChild("Y_Axis_Bottom")
		Y_Axis_Bottom_Panel:SetPos(0, (Height / 2))
		Y_Axis_Bottom_Panel:SetSize(Width, (Height / 2))
		
		local X_Axis_Left_Panel = Item:GetChild("X_Axis_Left")
		X_Axis_Left_Panel:SetSize((Width / 2), Height)
		
		local X_Axis_Right_Panel = Item:GetChild("X_Axis_Right_Panel")
		X_Axis_Left_Panel:SetPos((Width / 2), 0)
		X_Axis_Left_Panel:SetSize((Width / 2), Height)
		
		
		return Item
	end
	
	if (PrintDebugLog) then
		print("---^2Done^7---")
	end
end