Server = class(function(self)
	self.Server = CreateServer()
	self.Connections = {}

	self.FunctionTable = {}
end)

function Server:SetFunction(Name, Function)
	local FunctionID = self.Server:GetFunctionID(Name);

	self.FunctionTable[FunctionID] = Function
end

function Server:Listen()
	self.Server:Listen(" ", 1236,
		function(...)
			self:Created(...)
		end,

		function(...)
			self:Failed(...)
		end,

		function(...)
			self:Connect(...)
		end,

		function(...)
			self:Disconnect(...)
		end,

		function(...)
			self:Receive(...)
		end)
end

function Server:Created()
	print("Created server")
end 

function Server:Failed()
	print("Failed creating server")
end

function Server:Connect(Socket)
	local Connection = {}
	Connection.Socket = Socket;

	self.Connections[Socket] = Connection

	print("Server:Connect" .. " " .. Socket);
end

function Server:Disconnect(Socket)
	table[Socket] = nil

	print("Server:Disconnect" .. " " .. Socket);
end

function Server:Receive(Socket, FunctionID, Data)
	local Connection = self.Connections[Socket];

	if (Connection ~= nil) then
		local Function = self.FunctionTable[tonumber(FunctionID)];

		if (Function ~= nil) then
			Function(Connection, Data)
		else
			print("Invalid function data received" .. FunctionID)
		end
	else
		print("Invalid socket data received")
	end
end

function Server:Send(Connection, Function, Data)
	self.Server:Send(Connection.Socket, Function, Data)
end