Audio = class(function(self)
	self.TempSounds = {}
	self.PausedEvent = Event()
	self.FXGroup = GetFXGroup();
	MusicGroup = GetMusicGroup()
end)

function Audio:CreateSound(FileName, Spatial, Loaded)
	CreateSound(FileName, Spatial, function(Sound)
		self.FXGroup:Add(Sound)

		Loaded(Sound)
	end)
end

function Audio:PlaySound(FileName, Volume)
	if (Volume == nil) then
		Volume = 1.0
	end

	self:CreateSound(FileName, false, function(Sound)
		--print("Playing " .. FileName)
		
		Sound:SetVolume(Volume)
		Sound:Play(false, function()
			--print("Destroying " .. FileName)
		
			Sound:Destroy()
		end)
	end)
end

function Audio:PlaySound3D(FileName, Volume, Pos, Min, Max)
	if (Volume == nil) then
		Volume = 1.0
	end

	self:CreateSound(FileName, true, function(Sound)
		Sound:SetMinMaxDistance(Min, Max)
		Sound:Set3DAttributes(Pos, Vector())
		Sound:Play(false, function()
			Sound:Destroy()
		end)
	end)
end

function Audio:Pause()
	for i, Sound in ipairs(self.TempSounds) do
		Sound:Pause()
	end
end

function Audio:Resume()
	for i, Sound in ipairs(self.TempSounds) do
		Sound:Play(false)
	end
end

-- Singleton
Audio = Audio()	-- kan dit?

-- Legacy
function playsound(Wildcard, Volume)
	local FileName = GetRandomFile(Wildcard);

	Audio:PlaySound(FileName, Volume)
end

-- Audio
function FadeMusicVolume(Value)
	if (FadeMusicThread ~= nil) then
		PhysicsThread:Stop(FadeMusicThread)
	end

	FadeMusicThread = PhysicsThread:Spawn(function()
		
		local LerpVolume = MusicGroup:GetVolume()
		local GotoValue = Value * getvar('MusicVolume')
		
		while(true) do
		
			--print('MusicLerpVolume: ' .. LerpVolume)
			GotoValue = Value * getvar('MusicVolume')
			
			PhysicsThread:Wait(3)
			MusicGroup:SetVolume(LerpVolume)
			LerpVolume = Lerp(LerpVolume, GotoValue, 0.1)
			
			local Test1 = tonumber(string.format("%." .. (2 or 0) .. "f", LerpVolume))	-- maik., kun je me uitleggen wat dit doet?   >> Simpele afrond functie, http://lua-users.org/wiki/SimpleRound
			local Test2 = tonumber(string.format("%." .. (2 or 0) .. "f", GotoValue))
			
			if (Test1 == Test2) then
				MusicGroup:SetVolume(GotoValue)
				--print('MusicVolume BREAK: ' .. GotoValue)
				FadeMusicThread = nil
				break
			end
		end
	end)
end
