Spline = class(function(self, p, res)
	self.Points = {}
	if (p ~= nil) then
		self.GuidePoints = p
		
		if (res ~= nil) then
			self:Make(res)
		end
	else
		self.GuidePoints = {}
	end
end)

function Spline:AddGuidePoint(Position)
	table.insert(self.GuidePoints, Position)
end

function Spline:Make(res)
	local p = self.GuidePoints
	local px = 0
    local py = 0
    local pIter = #p
    local m = {}
	
    m[1] = tangent(p[2], p[1])
	for i = 2, pIter - 1 do
        m[i] = tangent(p[i + 1], p[i - 1]);
    end
    m[pIter] = tangent(p[pIter - 1], p[pIter - 1]);
	
	
	local TmpPoints = {}
	for k = 1, pIter - 1 do
		local Dots = {}
		table.insert(TmpPoints, Dots)
	end
	
	for t = 0, 1, res do
         local t_2 = t * t;
         local _1_t = 1 - t;
         local _2t = 2 * t;
		 
         local h00 =  (1 + _2t) * (_1_t) * (_1_t);
         local h10 =  t  * (_1_t) * (_1_t);
         local h01 =  t_2 * (3 - _2t);
         local h11 =  t_2 * (t - 1);
		 
		 for k = 1, pIter - 1 do
             local k1 = k + 1;
             local pk = p[k];
             local pk1 = p[k1];
             local mk = m[k];
             local mk1 = m[k1];
             px = h00 * pk.x + h10 * mk.x + h01 * pk1.x + h11 * mk1.x;
             py = h00 * pk.y + h10 * mk.y + h01 * pk1.y + h11 * mk1.y;
			 table.insert(TmpPoints[k], Vector(px, py, 0))
         end
    end
	
	self.Points = {}
	for k = 1, pIter - 1 do
		for t, Point in ipairs(TmpPoints[k]) do
			table.insert(self.Points, Point)
		end
	end
	
	return self.Points
end

function Spline:GetPos(T)
	T = ClampMinMax(T, 0, 1)
	
	local Count = #self.Points - 1
	local Index = math.ceil(Count * T)
	
	local Pos = self.Points[Index]
	if (Pos ~= nil) then
		return Pos.x, Pos.y
	else
		local Pos = self.Points[1]
		return Pos.x, Pos.y
	end
end

function tangent(pk1, pk_1)
    return Vector((pk1.x - pk_1.x) / 2, (pk1.y - pk_1.y) / 2, 0);
end