-- Laad gamemode
dofile("Lua\\GameMode.lua");

dofile("Lua\\Highscores.lua");

-- Laad alle gamemodes
dofiles("Lua\\GameModes\\*.lua");

-- Alle game modes
GameModes = { FreestyleFest, SingleRace, TowTest, SkillGame, Destroyer, FrameTwister, DeathMatch, HillClimb, TankTrap }
MPGameModes = deepcopy(GameModes)
Scores = Highscores()

-- Theme 1
FreestyleFest.Locked = false
SingleRace.Locked = false
TowTest.Locked = false
SkillGame.Locked = false

-- Theme 2
if (MONSTERJAM_THEME_SETTING >= MONSTERJAM_THEME2) then
	Destroyer.Locked = false
	FrameTwister.Locked = false
else
	Destroyer.Locked = true
	FrameTwister.Locked = true
end

--Theme4
if (MONSTERJAM_THEME_SETTING >= MONSTERJAM_THEME4) then
	TankTrap.Locked = false
else
	TankTrap.Locked = true
end
--Theme3
if (MONSTERJAM_THEME_SETTING >= MONSTERJAM_THEME3) then
	TankTrap.Locked = false
else
	TankTrap.Locked = true
end
DeathMatch.Locked = true
HillClimb.Locked = true

-- Earned mj coin?
MJCoinEarned = false

if (ActiveGameMode == nil) then
	ActiveGameMode = SingleRace
end

for i, GameMode in ipairs(MPGameModes) do
	GameMode.MP = true
	
	GameMode.CarClasses = copy(GameModes[i].CarClasses)

	for j, Chapter in ipairs(GameMode.Chapters) do
		for k, Race in ipairs(Chapter.Races) do
			Race.Available = true
		end
	end	
end

table.remove(MPGameModes, 1)

function FindMPGameMode(Name)
	for i, GameMode in ipairs(MPGameModes) do
		if (GameMode.Name == Name) then
			return GameMode;
		end
	end
	
	return MPGameModes[1]
end

-- Configuratie voor de races
RaceConfig = {}
RaceConfig.LapCount = nil
RaceConfig.Win = nil

function ActiveGameMode_Win(Place, Score, TestOnly)
	return ActiveGameMode:Win(Place, Score, TestOnly)
end

function UnlockSelectedRace()
	if (ActiveGameMode.ActiveChapter.ActiveRace.Unlock ~= nil) then
		ActiveGameMode.ActiveChapter.ActiveRace.WinCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.WinCount)
		ActiveGameMode.ActiveChapter.ActiveRace:Unlock()
	end
end

function UnlockSelectedChapter()
	local ActiveRace = ActiveGameMode.ActiveChapter.ActiveRace
	
	for i, Race in ipairs(ActiveGameMode.ActiveChapter.Races) do
		ActiveGameMode.ActiveChapter.ActiveRace = Race
		
		UnlockSelectedRace()
	end
	
	ActiveGameMode.ActiveChapter.ActiveRace = ActiveRace
end

function UnlockSelectedGameMode()
	local Chapter = ActiveGameMode.ActiveChapter
	
	for i, Chapter in ipairs(ActiveGameMode.Chapters) do
		ActiveGameMode.ActiveChapter = Chapter
		
		UnlockSelectedChapter()
	end
	
	if (ActiveGameMode.Won ~= nil) then
		ActiveGameMode:Won()
	end
	
	ActiveGameMode.ActiveChapter = Chapter
end

function UnlockAll()
	--[[ local GameMode = ActiveGameMode
	
	for i, GameMode in ipairs(GameModes) do
		ActiveGameMode = GameMode
		
		UnlockSelectedGameMode()
	end
	
	ActiveGameMode = GameMode
	
	WriteGameSettings() ]]
	
	DebugUnlockAll = true
end

function GetLoadingText()
	if (ActiveGameMode ~= nil) then
		return Translate(ActiveGameMode.LoadingText)
	else
		return ""
	end
end