Destroyer = GameMode("Destroyer")
function Destroyer:HUD(...)
	return HUD_Destroyer(...)
end

Destroyer.Configuration = {}

--Add TrackScores
local TrackScores = { TrackScore("1"), TrackScore("3"), TrackScore("5") }

Destroyer.RaceUnlockText = "NEW_RACE_UNLOCKED"

Destroyer:AddCarClass(MonsterTruckCars);

function Destroyer:PrepareScript(RaceData)
	ActiveMission = DestroyerMission(RaceData)
end

function Destroyer:Won()
	--
end

-- Add chapters
local Chapter1 = Destroyer:AddChapter(Chapter("Race_Chapter1")) 

-- Add chapter 1 races
local PrefMission = nil
if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME8) then
	PrefMission = Mission("MJ_THEME8_DESTROYER")
	--var("foliagerange", "20")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME7) then
	PrefMission = Mission("MJ_Theme7_DESTROYER")
	--var("foliagerange", "2000")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME6) then
	PrefMission = Mission("MJ_Theme6_DESTROYER")
	--var("foliagerange", "2000")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
	PrefMission = Mission("MJ_Theme5_DESTROYER")
	--var("foliagerange", "2000")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME4) then
	PrefMission = Mission("MJ_Theme4_DESTROYER")
	--var("foliagerange", "2000")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME3) then
	PrefMission = Mission("MJ_Theme3_DESTROYER")
	var("foliagerange", 2000)
else
	PrefMission = Mission("MJ_THEME2_DESTROYER")
	--var("foliagerange", "2000")
end

local NewRace = Chapter1:AddRace(PrefMission)
NewRace.TrackScores = deepcopy(TrackScores)
NewRace.Available = false
NewRace.Unlock = function()
	-- Doe iets hier
end
NewRace.Won = function(self, Place, Score)
	return Place <= 3
end

function Destroyer:StartRace(Race, Car, Character, Career)
	local RaceData = {}

	if (Career == nil) then
		RaceData.Career = false
	else
		RaceData.Career = Career
	end

	-- De speler
	RaceData.Name = GetPlayername() 
	RaceData.Car = Car
	RaceData.Skin = 0
	RaceData.LapCount = 1
	RaceData.Tuning = "Default"
	RaceData.Character = Character
	RaceData.CharacterSkin = 0
	RaceData.CarType = _G[Car]
	
	-- AI data
	RaceData.AI = {}

	-- Dit moet om de mission te maken
	PrepareScript = function()
		self:PrepareScript(RaceData)
	end

	-- Laad
	loadmap(Race)
end