FreestyleFest = GameMode("FreestyleFest")

function FreestyleFest:HUD(...)
	return HUD_FreestyleFest(...)
end

FreestyleFest.Configuration = {}
FreestyleFest:AddCarClass(MonsterTruckCars)

FreestyleFest.RaceUnlockText = "NEW_STUNT_UNLOCKED"
FreestyleFest.PhysicsSpeedValues = {"0.84"}
FreestyleFest.ActivePhysicsSpeed = 0

FreestyleFest.DamageMult = 0

function FreestyleFest:PrepareScript(RaceData)
	ActiveMission = FreestyleFestMission(RaceData)
end

function FreestyleFest:Won()
	--
end

-- Add chapters
local Chapter1 = FreestyleFest:AddChapter(Chapter("Race_Chapter1")) 

-- Add chapter 1 races
local PrefMission = nil
if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME8) then
	PrefMission = Mission("MJ_THEME8_FREESTYLE")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME7) then
	PrefMission = Mission("MJ_THEME7_FREESTYLE")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME6) then
	PrefMission = Mission("MJ_THEME6_FREESTYLE")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
	PrefMission = Mission("MJ_THEME5_FREESTYLE")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME4) then
	PrefMission = Mission("MJ_THEME4_FREESTYLE")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME3) then
	PrefMission = Mission("MJ_THEME3_FREESTYLE")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME2) then
	PrefMission = Mission("MJ_Theme2_Freestyle")
else
	PrefMission = Mission("MJ_Theme1_Freestyle")
end
local NewRace = Chapter1:AddRace(PrefMission)
NewRace.TrackScores = {}
NewRace.Available = true

NewRace.Unlock = function()
	
end

NewRace.Won = function(self, Place, Score)
	return Place <= 3
end

function FreestyleFest:StartRace(Race, Car, Character, Career)
	local RaceData = {}
	
	if (LapCount == nil) then
		LapCount = 1
	end
	
	if (Career == nil) then
		RaceData.Career = false
	else
		RaceData.Career = Career
	end

	-- De speler
	RaceData.Name = GetPlayername()
	RaceData.Car = Car
	RaceData.Skin = 0
	RaceData.LapCount = LapCount
	RaceData.Tuning = "Default"
	RaceData.Character = Character
	RaceData.CharacterSkin = 0
	RaceData.CarType = _G[Car]
	
	-- AI data
	RaceData.AI = {}
	
	-- Dit moet om de mission te maken
	PrepareScript = function()
		self:PrepareScript(RaceData)
	end

	-- Laad
	loadmap(Race)
end

function FreestyleFest:StartRaceCareer(Race, Car, Character, LapCount, Players)
	local RaceData = {}
	
	if (LapCount == nil) then
		LapCount = 1
	end
	
	
	RaceData.Career = true

	-- De speler
	RaceData.Name = GetPlayername()
	RaceData.Car = Car
	RaceData.Skin = 0
	RaceData.LapCount = LapCount
	RaceData.Tuning = "Default"
	RaceData.Character = Character
	RaceData.CharacterSkin = 0
	RaceData.CarType = _G[Car]
	RaceData.PlayerID = #Players

	-- AI data
	RaceData.AI = {}

	-- Dit moet om de mission te maken
	PrepareScript = function()
		self:PrepareScript(RaceData)
	end

	-- Laad
	loadscript(Race)
end