SkillGame = GameMode("SkillGame")
function SkillGame:HUD(...)
	return HUD_HillJump(...)
end

SkillGame.Configuration = {}

--Add TrackScores
local TrackScores = { TrackScore("1"), TrackScore("3"), TrackScore("5") }

SkillGame.RaceUnlockText = "NEW_RACE_UNLOCKED"

SkillGame:AddCarClass(MonsterTruckCars);

--SkillGame.DamageMult = 3.5	-- MJ_THEME1_HILLJUMP	
SkillGame.DamageMult = 5		-- MJ_THEME4_HILLJUMP	(Las Vegas)

SkillGame.UseAccelerateSlider = true

function SkillGame:PrepareScript(RaceData)
	ActiveMission = HillJumpMission(RaceData)
	
	--betere plek zoeken?
	--Camera = LuaCamera("naam")
	--Camera:DisableLerp()
	--Camera:Disable(false)
	
	--local LookFrom = TriggerTargetID("IngameBook")
	--Camera:SetLookFrom(LookFrom)
	--Camera:SetLookAt(0)
end

function SkillGame:Won()
	--Steam_SetAchievement("STUNTFINISHED")
end

-- Add chapters
local Chapter1 = SkillGame:AddChapter(Chapter("Race_Chapter1")) 

-- Add chapter 1 races
local PrefMission = nil
if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME8) then
	PrefMission = Mission("MJ_THEME8_HILLJUMP")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME7) then
	PrefMission = Mission("MJ_THEME7_HILLJUMP")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME6) then
	PrefMission = Mission("MJ_THEME6_HILLJUMP")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
	PrefMission = Mission("MJ_THEME5_HILLJUMP")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME4) then
	PrefMission = Mission("MJ_THEME4_HILLJUMP")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME3) then
	PrefMission = Mission("MJ_THEME3_HILLJUMP")
else
	PrefMission = Mission("MJ_THEME1_HILLJUMP")
end
local NewRace = Chapter1:AddRace(PrefMission)
NewRace.TrackScores = deepcopy(TrackScores)
NewRace.Available = false;
NewRace.Unlock = function()
	-- Doe iets hier
end
NewRace.Won = function(self, Place, Score)
	return Place <= 3
end


function SkillGame:StartRace(Race, Car, Character, Career)
	local RaceData = {}
	-- Race data
	RaceData.LapCount = 3
	
	if (Career == nil) then
		Career = false
	end
	RaceData.Career = Career

	-- De speler
	RaceData.Name = GetPlayername() --steam_getname();
	RaceData.Car = Car
	RaceData.Skin = 0
	RaceData.Tuning = "Default"
	RaceData.Character = "Characters\\" .. Character
	RaceData.CharacterSkin = 0
	RaceData.CarType = _G[Car]

	--MessageBox(tostring(RaceData.CarType), tostring(RaceData.CarType), 1)
	
	-- AI data
	RaceData.AI = {}
	
	local AIPool = {}
	--[[ for i, AIPlayer in ipairs(AIPlayers) do
		local AI = {}
		AI.Name = Translate(AIPlayer.Name)
		AI.Character = AIPlayer.Character.Name
		AI.CharacterSkin = AIPlayer.CharacterSkin
		AI.Car, AI.Skin = AIPlayer:GetCar({MonsterTruckCar})
		AI.Difficulty = 1 * AIPlayer.Skill
							
		--if (AI.Car ~= Car) then	--Niet dezelfde auto gebruiken tijdens een race
			table.insert(AIPool, AI)
		--end
	end ]]
	
	--[[ for i = 1, 5 do		
		local Index = math.random(#AIPool)
					
		local AIPlayer = AIPool[Index];
		RaceData.AI[i] = AIPlayer
					
		table.remove(AIPool, Index)
	end ]]

	-- Dit moet om de mission te maken
	PrepareScript = function()
		self:PrepareScript(RaceData)
	end

	-- Laad
	loadscript(Race)
end