TowTest = GameMode("TowTest")
function TowTest:HUD(...)
	return HUD_TowTest(...)
end

TowTest.Configuration = {}

--Add TrackScores
local TrackScores = { TrackScore("1"), TrackScore("3"), TrackScore("5") }

TowTest.RaceUnlockText = "NEW_RACE_UNLOCKED"

TowTest:AddCarClass(MonsterTruckCars);

TowTest.UseAccelerateSlider = true

function TowTest:PrepareScript(RaceData)
	ActiveMission = TowTestMission(RaceData)
end

function TowTest:Won()
	--
end

-- Add chapters
local Chapter1 = TowTest:AddChapter(Chapter("Race_Chapter1")) 

-- Add chapter 1 races
local PrefMission = nil
if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME8) then
	PrefMission = Mission("MJ_THEME8_TOWTEST")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME7) then
	PrefMission = Mission("MJ_THEME7_TOWTEST")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME6) then
	PrefMission = Mission("MJ_THEME6_TOWTEST")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
	PrefMission = Mission("MJ_THEME5_TOWTEST")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME4) then
	PrefMission = Mission("MJ_Theme4_Towtest")
elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME3) then
	PrefMission = Mission("MJ_Theme3_Towtest")
else
	PrefMission = Mission("MJ_Theme1_Towtest")
end
local NewRace = Chapter1:AddRace(PrefMission)
NewRace.TrackScores = deepcopy(TrackScores)
NewRace.Available = false
NewRace.Unlock = function()
	-- Doe iets hier
end
NewRace.Won = function(self, Place, Score)
	return Place <= 3
end

-- Add chapter 1 races
local NewRace = Chapter1:AddRace(Mission("TestPlane"))
NewRace.TrackScores = deepcopy(TrackScores)
NewRace.Available = false
NewRace.Unlock = function()
	-- Doe iets hier
end
NewRace.Won = function(self, Place, Score)
	return Place <= 3
end

function TowTest:StartRace(Race, Car, Character, Career)
	local RaceData = {}
	
	local LapCount = 1
	
	if (Career == nil) then
		RaceData.Career = false
	else
		RaceData.Career = Career
	end

	-- De speler
	RaceData.Name = GetPlayername() 
	RaceData.Car = Car
	RaceData.Skin = 0
	RaceData.LapCount = LapCount
	RaceData.Tuning = "Default"
	RaceData.Character = Character
	RaceData.CharacterSkin = 0
	RaceData.CarType = _G[Car]
	
	-- AI data
	RaceData.AI = {}

	-- Dit moet om de mission te maken
	PrepareScript = function()
		self:PrepareScript(RaceData)
	end

	-- Laad
	loadmap(Race)
end