Highscores = class(function(self)
	self.UserID = nil		--UserID afkomstig van server-database
	self.Scores = {}
end)

function Highscores:Read(File, Version)
	local UserID = File:ReadInt()
	if (UserID > 0) then
		self.UserID = UserID
	end
	
	local Count = File:ReadInt()
	
	for i = 1, Count do
		self.Scores[i] = ScoreEntry()
		self.Scores[i]:Read(File, Version)
	end
	
	--sort
	table.sort(self.Scores, function(a,b) return a.Score > b.Score end)
	
	--and remove after 10
	for i = 11, #self.Scores do
		table.remove(self.Scores, i)
	end
end

function Highscores:Write(File, Version)
	if (self.UserID ~= nil) then
		File:WriteInt(self.UserID)
	else
		File:WriteInt(0)
	end

	File:WriteInt(#self.Scores)
	
	for i = 1, #self.Scores do
		self.Scores[i]:Write(File, Version)
	end
end

function Highscores:AddScore(ScoreEntry)
	table.insert(self.Scores, ScoreEntry)
	
	--sort
	table.sort(self.Scores, function(a,b) return a.Score > b.Score end)
	
	--and remove after 10
	for i = 11, #self.Scores do
		table.remove(self.Scores, i)
	end
	
	return ScoreEntry;
end

function Highscores:GetScore(Index)
	if (self.Scores[Index] ~= nil) then
		return self.Scores[Index];
	else
		return ScoreEntry(0, translate("results_noentry"))
	end
end

ScoreEntry = class(function(self, Score, Name)
	self.Score = Score
	self.Name = Name
end)

function ScoreEntry:Read(File, Version)
	self.Score = File:ReadFloat()
	self.Name = File:ReadString()
	
	return self
end

function ScoreEntry:Write(File, Version)
	File:WriteFloat(self.Score)
	File:WriteString(self.Name)
end