HighscoresUser = class(function(self)
	if (UseLiveServer) then
		self.Host = "http://www.team6-games.com"
	else
		self.Host = "http://downloads.team6-games.com"
		if (GetPlatform() == "Win32") then
			MessageBox("Warning", "HighScoreHost: "..self.Host)
		else
			print("!!!Warning!!! HighScoreHost: "..self.Host)
		end
	end
	self.Directory = "/gms/monsterjam/"
	
	self.Online = false
end)

function HighscoresUser:SuccessFunction(Data)
	print("HighscoresUser: ^2Success!")
end

function HighscoresUser:FailFunction(Data)
	print("HighscoresUser: ^1Failure!")
end

function HighscoresUser:Post(Page, PostData, OutputFunction, FailureFunction)
	local URL = self.Host .. self.Directory .. Page .. "?dummy=1"
	
	-- URL doorsturen
	print("POST() URL: " .. tostring(URL) .. " PostData: " .. tostring(PostData))

	if (FailureFunction == nil) then
		FailureFunction = self.FailFunction
	end
	
	self.Connection = HttpConnection()
	self.Connection:Post(URL, PostData, function(Data)
		OutputFunction(Data)
		self.Connection = nil
	end, FailureFunction)
end

function HighscoresUser:Get(Page, OutputFunction, FailureFunction)
	local URL = self.Host .. self.Directory .. Page .. "?dummy=1"

	-- URL doorsturen
	print("GET() URL: " .. URL)
	
	if (FailureFunction == nil) then
		FailureFunction = self.FailFunction
	end
	
	self.Connection = HttpConnection()
	self.Connection:Get(URL, function(Data)
		OutputFunction(Data)
		self.Connection = nil
	end, FailureFunction)
end

function HighscoresUser:Cancel()
	if (self.Connection ~= nil) then
		self.Connection:Cancel()
		self.Connection = nil
	end
end

-- ===================================================================== --

function HighscoresUser:TestConnection(SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		self.Online = true
		SuccessFunction(Data)
	end
	
	local InternalFailureFunction = function(Data)
		self.Online = false
		FailureFunction(Data)
	end
	
	self:Get("OnGetDate.php", InternalSuccessFunction, InternalFailureFunction)
end

function HighscoresUser:GetFacebookUser(UserID, FacebookID, Name, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	if (UserID ~= nil) then
		--PostData["UserID"] = UserID
	end
	PostData["FacebookID"] = FacebookID
	PostData["Name"] = Name

	SetPlayername(Name);
	
	self:Post("OnGetUser.php", PostData, InternalSuccessFunction, InternalFailureFunction)
end

function HighscoresUser:CreateSimpleUser(Name, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["Name"] = Name

	SetPlayername(Name);
	
	self:Post("OnGetUser.php", PostData, InternalSuccessFunction, InternalFailureFunction)
end

function HighscoresUser:GetSimpleUser(UserID, Name, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	--PostData["Name"] = Name
	
	--SetPlayername(Name);
	
	self:Post("OnGetUser.php", PostData, InternalSuccessFunction, InternalFailureFunction)
end

function HighscoresUser:ChangeSimpleUser(UserID, Name, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["Name"] = Name
	
	SetPlayername(Name);
	
	self:Post("OnGetUser.php", PostData, InternalSuccessFunction, InternalFailureFunction)
end

function HighscoresUser:AddScore(UserID, Script, Score, CarID, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["Script"] = Script
	PostData["Score"] = Score
	PostData["CarID"] = CarID
	
	local FriendsCounter = 0
	if (FBManager:IsLoginValid() and FBManager.UserFriendsTable ~= nil) then
		for i, Friend in pairs(FBManager.UserFriendsTable) do
			PostData["Friend" .. FriendsCounter] = Friend['id']
			FriendsCounter = Inc(FriendsCounter)
		end
	end
	PostData["FriendsCounter"] = FriendsCounter
	
	--OnAddScore.php
	if (UserID ~= nil) then
		self:Post("OnAddScore.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

function HighscoresUser:AddScriptStats(UserID, Script, Score, CarID, PlayingTime, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["Script"] = Script
	PostData["FinalScore"] = Score
	PostData["CarID"] = CarID
	PostData["ScriptPlayingTime"] = PlayingTime
	
	local SelectedCar = MonsterTruckCars.Cars[CarID]
	if (SelectedCar ~= nil) then
		PostData["UpgradeLevel_Weight"] = SelectedCar.Upgrades["garage_weight"].CurrentLevel
		PostData["UpgradeLevel_Suspension"] = SelectedCar.Upgrades["garage_suspension"].CurrentLevel
		PostData["UpgradeLevel_AirShocks"] = SelectedCar.Upgrades["garage_airshocks"].CurrentLevel
		PostData["UpgradeLevel_Engine"] = SelectedCar.Upgrades["garage_engine"].CurrentLevel
		PostData["UpgradeLevel_Armor"] = SelectedCar.Upgrades["garage_armor"].CurrentLevel
		PostData["UpgradeLevel_Tires"] = SelectedCar.Upgrades["garage_tires"].CurrentLevel
	end
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	--OnAddScriptStats.php
	if (UserID ~= nil) then
		self:Post("OnAddScriptStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

function HighscoresUser:GetFriendsPlayed(UserID, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	
	local FriendsCounter = 0
	if (FBManager:IsLoginValid() and FBManager.UserFriendsTable ~= nil) then
		for i, Friend in pairs(FBManager.UserFriendsTable) do
			PostData["Friend" .. FriendsCounter] = Friend['id']
			FriendsCounter = Inc(FriendsCounter)
		end
	end
	PostData["FriendsCounter"] = FriendsCounter
	
	--OnGetFriendsPlayed.php
	if (UserID ~= nil) then
		self:Post("OnGetFriendsPlayed.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

-- ===================================================================== --

function HighscoresUser:GetOnlineProgressVersion(UserID, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	
	self:Post("OnGetProgressVersion.php", PostData, InternalSuccessFunction, InternalFailureFunction)
end

function HighscoresUser:GetOnlineProgress(UserID, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	
	self:Post("OnGetProgress.php", PostData, InternalSuccessFunction, InternalFailureFunction)
end

function HighscoresUser:AddOnlineProgress(UserID, ProgressData, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		local LuaData = UnSerialize(Data)
		SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	
	for Key, Value in pairs(ProgressData) do
		--print(Key)
		--print(Value)
		PostData[Key] = tostring(Value)
	end
	
	self:Post("OnAddProgress.php", PostData, InternalSuccessFunction, InternalFailureFunction)
end

-- ===================================================================== --

function HighscoresUser:AddFuelStats(UserID, BoughtFuel, FreeFuel, CoinsUsed, GearsUsed, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["BoughtFuel"] = BoughtFuel
	PostData["FreeFuel"] = FreeFuel
	PostData["CoinsUsed"] = CoinsUsed
	PostData["GearsUsed"] = GearsUsed
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddFuelStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

function HighscoresUser:AddInAppPurchasesStats(UserID, ProductID, Valuta, CurrentPrice, CoinsGained, GearsGained, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["ProductID"] = ProductID
	PostData["Valuta"] = Valuta
	PostData["CurrentPrice"] = CurrentPrice
	PostData["CoinsGained"] = CoinsGained
	PostData["GearsGained"] = GearsGained
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddInAppPurchasesStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

function HighscoresUser:AddCollectedCoinsStats(UserID, Type, CoinsGained, GearsGained, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["Type"] = Type
	PostData["CoinsGained"] = CoinsGained
	PostData["GearsGained"] = GearsGained
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddCollectedCoinsStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end


function HighscoresUser:AddBoughtCarStats(UserID, CarID, CoinsUsed, GearsUsed, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["CarID"] = CarID
	PostData["CoinsUsed"] = CoinsUsed
	PostData["GearsUsed"] = GearsUsed
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddBoughtCarStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

function HighscoresUser:AddBoughtCarDeliveryStats(UserID, CarID, CoinsUsed, GearsUsed, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["CarID"] = CarID
	PostData["CoinsUsed"] = CoinsUsed
	PostData["GearsUsed"] = GearsUsed
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddBoughtCarDeliveryStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end


function HighscoresUser:AddBoughtCarUpgradeStats(UserID, CarID, CarUpgradeTypeID, CarUpgradeLevel, CoinsUsed, GearsUsed, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["CarID"] = CarID
	PostData["CarUpgradeTypeID"] = CarUpgradeTypeID
	PostData["CarUpgradeLevel"] = CarUpgradeLevel
	PostData["CoinsUsed"] = CoinsUsed
	PostData["GearsUsed"] = GearsUsed
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddBoughtCarUpgradeStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

function HighscoresUser:AddBoughtCarUpgradeDeliveryStats(UserID, CarID, CarUpgradeTypeID, CarUpgradeLevel, CoinsUsed, GearsUsed, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["CarID"] = CarID
	PostData["CarUpgradeTypeID"] = CarUpgradeTypeID
	PostData["CarUpgradeLevel"] = CarUpgradeLevel
	PostData["CoinsUsed"] = CoinsUsed
	PostData["GearsUsed"] = GearsUsed
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddBoughtCarUpgradeDeliveryStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

function HighscoresUser:AddBoughtPowerupStats(UserID, PowerupTypeID, CoinsUsed, GearsUsed, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["PowerupTypeID"] = PowerupTypeID
	PostData["CoinsUsed"] = CoinsUsed
	PostData["GearsUsed"] = GearsUsed
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddBoughtPowerupStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end

function HighscoresUser:AddBoughtConsumableStats(UserID, ConsumableTypeID, CoinsUsed, GearsUsed, SuccessFunction, FailureFunction)
	local InternalSuccessFunction = function(Data)
		--self.Online = true
		--print(Data)
		--local LuaData = UnSerialize(Data)
		--SuccessFunction(LuaData)
	end
	
	local InternalFailureFunction = function(Data)
		--self.Online = false
		FailureFunction(Data)
	end
	
	local PostData = {}
	PostData["UserID"] = UserID
	PostData["ConsumableTypeID"] = ConsumableTypeID
	PostData["CoinsUsed"] = CoinsUsed
	PostData["GearsUsed"] = GearsUsed
	
	local PlatformID = 6
	if (GetPlatform() == "IOS") then
		PlatformID = 3
	elseif (GetPlatform() == "Android") then
		PlatformID = 4
	elseif (GetPlatform() == "Win32") then
		PlatformID = 6
	end
	PostData["PlatformID"] = PlatformID
	
	if (UserID ~= nil) then
		self:Post("OnAddBoughtConsumableStats.php", PostData, InternalSuccessFunction, InternalFailureFunction)
	else
		print("Invalid UserID")
		InternalFailureFunction()
	end
end