HUD_E_Base = class(function(self, HUD, Panel, Element, LocationData, ScreenButtonKey, AnalogueStickKey)
	self.HUD = HUD
	self.Panel = Panel
	self.Element = Element
	self.ScreenButtonkey = ScreenButtonkey
	
	-- TestListener
	AddKeyListeners("DCK_F", "Down", function(Listeners)
		--self:Flash(3)
	end)
	
	-- Add Item
	if (self.Panel ~= nil and self.Element ~= nil) then
		self.Item = self.Panel:AddItem("hud\\elements\\" .. self.Element .. ".dcmenu")
	end
	
	-- Add Screenbutton
	if (ScreenButtonKey ~= nil and ScreenButtonKey ~= "" and LocationData ~= nil and #LocationData >= 6) then		
		local Width, Height = self.Item:GetSize()
		
		self.ScreenButton = SetScreenButtonMenu(self.Panel, ScreenButtonKey, LocationData[1], LocationData[2], Width, Height, LocationData[3], LocationData[4], LocationData[5], LocationData[6], color(1,1,1,0.25), "elements\\WhiteItem.dcmenu", ScreenButtonKey)
	end
	
	-- Add AnalogueStick
	if (AnalogueStickKey ~= nil and AnalogueStickKey ~= "" and LocationData ~= nil and #LocationData >= 6) then		
		local Width, Height = self.Item:GetSize() 
    
		self.ScreenButton = SetAnalogueStickMenu(self.Panel, AnalogueStickKey, LocationData[1], LocationData[2], Width, Height, LocationData[3], LocationData[4], LocationData[5], LocationData[6], color(1,1,1,0.25), "elements\\Debug_AnalogStick.dcmenu", AnalogueStickKey)
	end
	
	-- Setting default pos
	if (LocationData ~= nil and #LocationData >= 6) then
		self:SetPosData(LocationData[1], LocationData[2], LocationData[3], LocationData[4], LocationData[5], LocationData[6], 0, 0, nil)
	end
end)

--=== PRIMARY HUD FUNCTIONS ===--
function HUD_E_Base:Destroy()
	if (self.TutorialThread ~= nil) then
		PhysicsThread:Spawn(function()
			print("DESTROY :D")
			PhysicsThread:Stop(self.TutorialThread)
			self.TutorialThread = nil
		end)
	end
end

function HUD_E_Base:Show(Force)
	if (Force) then
		self.Item:SetColorImmediate(self.HUD.BaseTextColor)
	else
		self.Item:SetColor(self.HUD.BaseTextColor)
		self.Item:SetColorFade(1,10)
	end
end

function HUD_E_Base:Hide(Force)
	if (Force) then
		self.Item:SetColorImmediate(Invisible)
	else
		self.Item:SetColor(Invisible)
		self.Item:SetColorFade(1,10)
	end
end

function HUD_E_Base:Update(ElapsedTime)
	--
end

function HUD_E_Base:UpdatePhysics(ElapsedTime)
	--
end

--=== SECONDARY HUD FUNCTIONS ===--
function HUD_E_Base:Flash(FadeSpeed)
	--
end

function HUD_E_Base:SetText(Text)
	--
end

function HUD_E_Base:SetPosData(x, y, AlignX, AlignY, PanelAlignX, PanelAlignY, Delay, Speed, Loop)
	self.Item:SetPosData(x, y, AlignX, AlignY, PanelAlignX, PanelAlignY, Delay, Speed, Loop)
end

function HUD_E_Base:SetFont(Font)
	--
end

function HUD_E_Base:ShowDebug(Force)
	--
end

function HUD_E_Base:ShowIcon()
	--
end

function HUD_E_Base:ShowTutorial(CallbackFunction)
	if (self.TutorialThread ~= nil) then
		PhysicsThread:Spawn(function()
			PhysicsThread:Stop(self.TutorialThread)
			self.TutorialThread = nil
		end)
	end

	if (self.HUD.Menu ~= nil) then
		self.HUD.Menu:SetClickedFunc(function()		
			if (self.TutorialThread ~= nil) then
				PhysicsThread:Spawn(function()
					PhysicsThread:Stop(self.TutorialThread)
					self.TutorialThread = nil
				end)
			end
			
			self:EndTutorial(CallbackFunction)
		end)
	end
end

function HUD_E_Base:EndTutorial(CallbackFunction)
	if (self.HUD.TutorialText ~= nil) then
		self.HUD.TutorialText:SetText("")
	end
	
	if (self.Tutorial_Hand ~= nil) then
		self.Tutorial_Hand:SetColor(Invisible)
	end
	
	if (self.HUD.Menu ~= nil) then
		self.HUD.Menu:SetClickedFunc(nil)
	end
	
	if (CallbackFunction ~= nil) then
		CallbackFunction()
	end
end

dofile("Lua\\Huds\\Elements\\HUD_E_AccelerateSlider.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_SteerSlider.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_BoostButton.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_JoyStick.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_BonusTime.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_Checkpoint.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_Countdown.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_DebugText.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_HealthBar.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_MapBar.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_PowerUpButton.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_ScoreElement.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_SimpleScreenButton.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_SlipIndicator.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_SpecialScorePopup.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_ConfirmMenu.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_StuntList.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_Timer.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_TutorialText.lua")
dofile("Lua\\Huds\\Elements\\HUD_E_WarningPopupTimer.lua")
