HUD_E_BoostButton = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.SimpleScreenButton = self.Item:GetChild("SimpleScreenButton")
	
	self.Button_Activate = self.Item:GetChild("Button_Activate")
	
	self.Tutorial_Hand = self.Item:GetChild("Tutorial_Hand")
	
	self.Text = self.Item:GetChild("Text")
	
	if (ActiveMission.HumanPlayers[1].PowerupManager ~= nil) then
		if (ActiveMission.HumanPlayers[1].PowerupManager.BoostPowerup.Enabled) then
			self.Item:GetChild("Normal"):SetColorImmediate(Invisible)
			self.Item:GetChild("Normal_Activated"):SetColorImmediate(Invisible)
			
			self.Item:GetChild("Extra"):SetColorImmediate(White)
			self.Item:GetChild("Extra_Activated"):SetColorImmediate(White)
		end
	end
end)

function HUD_E_BoostButton:Show(Force)
	self.Super.Show(self, Force)
	
	if (Force) then
		self.SimpleScreenButton:SetColorImmediate(White)
		self.Text:SetColorImmediate(self.HUD.BaseTextColor)
	else
		self.SimpleScreenButton:SetColor(White)
		self.SimpleScreenButton:SetColorFade(1,3)
		
		self.Text:SetColorImmediate(White)
		self.Text:SetColor(self.HUD.BaseTextColor)
		self.Text:SetColorFade(1,3)
	end
end

function HUD_E_BoostButton:Hide(Force)
	self.Super.Hide(self, Force)

	if (Force) then
		self.SimpleScreenButton:SetColorImmediate(Invisible)
	else
		self.SimpleScreenButton:SetColor(Invisible)
		self.SimpleScreenButton:SetColorFade(1,3)
	end
end

function HUD_E_BoostButton:SetText(Text)
	self.Text:SetText(Text)
end

function HUD_E_BoostButton:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)
	
	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		local SizeX, SizeY = self.Tutorial_Hand:GetSize()
		self.Tutorial_Hand:SetSize(-SizeX, SizeY)
		
		if (self.HUD.TutorialText ~= nil) then
			self.HUD.TutorialText:SetText(Translate("tutorial_Stunt"))
		else
			print("No TutorialText element found")
		end
		
		PhysicsThread:Wait(60 * 5)
		
		self:EndTutorial(CallbackFunction)
	end)
end

function HUD_E_BoostButton:UpdatePhysics(ElapsedTime)
	--if (KeyPressure(self.ScreenButtonkey) > 0) then
	if (KeyPressure(GetKeyCode("DCK_SCREENBUTTON_6")) > 0) then		--Ugly
		self.Button_Activate:SetColorFade(1, 10)
		self.Button_Activate:SetColor(White)
	else
		self.Button_Activate:SetColor(Invisible)
	end
end