HUD_E_ConfirmMenu = class(HUD_E_Base, function(self, HUD, Panel, Element)
-- Pak het hoofdpanel en overige panels
	self.Main = self.Item:GetChild("Main")
	
	-- Fade in items
	self.Main:SetColorImmediate(Invisible)
	self.Main:SetColorFade(2, 10.0)
	
	-- Panels leegmaken en lijst aanmaken
	local Items = NewItemList(self, LeftButtons, RightButtons)
	self.Items = Items

	self.HeaderText = self.Item:GetChild("Header_text")
	self.TextPanel = self.Item:GetChild("Text")
	self.NoButtonPanel = self.Item:GetChild("NoButton")
	self.YesButtonPanel = self.Item:GetChild("YesButton")
	
	self.NoButtonPanel:Clear()
	self.YesButtonPanel:Clear()
	
	self.IsActive = false
	-- Items toevoegen
	
	--self.ProceedButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonProceed.dcMenu", "button_install"))
	
	self.NoButton = Items:AddItem(self.NoButtonPanel, MenuElements.Label(Items, "Elements\\MenuButton_Small.dcMenu", "button_no"))
	self.YesButton = Items:AddItem(self.YesButtonPanel, MenuElements.Label(Items, "Elements\\MenuButton_Small.dcMenu", "button_yes"))
	
	self.ProceedFunction = nil
	self.CancelFunction = nil
	
	self.YesButton.Item:SetReleasedFunc(function()
		if (self.IsActive) then
			self:HideMenu()
		end
		
		if (self.ProceedFunction ~= nil) then
			self:ProceedFunction()
		end
	end)
	
	self.NoButton.Item:SetReleasedFunc(function()
		if (self.IsActive) then
			self:HideMenu()
		end
		
		if (self.CancelFunction ~= nil) then
			self:CancelFunction()
		end
	end)
end)

function HUD_E_ConfirmMenu:ShowConfirmMenu(Title, Text, ProceedFunction, CancelFunction)
	self.Main:SetColor(White)
	self.HeaderText:SetText(Title)
	self.TextPanel:SetText(Text)
	self.ProceedFunction = ProceedFunction
	self.CancelFunction = CancelFunction
	self.IsActive = true
end

function HUD_E_ConfirmMenu:HideMenu()
	self.Main:SetColor(Invisible)
	self.IsActive = false
end