HUD_E_Countdown = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.Countdown = self.Item:GetChild("Countdown")
	self.Image = self.Item:GetChild("Image")
	
	--self.Countdown:SetColorImmediate(Invisible)
	--self.Image:SetColorImmediate(Invisible)
	
	self:SetFont("ArialBlack70")
	self:SetText("3")
	
	self.UseImages = true
end)

function HUD_E_Countdown:Show(Force)
	--
end

function HUD_E_Countdown:Flash(FadeSpeed)
	if (FadeSpeed == nil) then
		FadeSpeed = 3
	end
	
	if (self.UseImages) then
		self.Image:SetColorImmediate(White)
		self.Image:SetColor(Invisible)
		self.Image:SetColorFade(1,FadeSpeed)
	else
		self.Countdown:SetColorImmediate(self.HUD.BaseTextColor)
		self.Countdown:SetColor(Invisible)
		self.Countdown:SetColorFade(1,FadeSpeed)
	end
end

function HUD_E_Countdown:SetText(Text)
	if (self.UseImages) then
		if (Text == "1") then
			self.Image:SetImage(CountdownTexture1)
		elseif (Text == "2") then
			self.Image:SetImage(CountdownTexture2)
		elseif (Text == "3") then
			self.Image:SetImage(CountdownTexture3)
		elseif (Text == "go!") then
			self.Image:SetImage(CountdownTextureGo)
		else
			self.Image:SetImage(CountdownTextureGo)
		end
	else
		self.Countdown:SetText(Text)
	end
end

function HUD_E_Countdown:SetFont(Font)
	if (self.UseImages) then
		if (Font == "ArialBlack90") then
			self.Image:SetSize(512, 256)
		elseif (Font == "ArialBlack80") then
			self.Image:SetSize(448, 224)
		else
			self.Image:SetSize(384, 192)
		end
	else
		self.Countdown:SetFont(Font)
	end
end