HUD_E_HealthBar = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.HealthBack = self.Item:GetChild("HealthBack")
	self.Hud_HealthBar = self.Item:GetChild("Hud_HealthBar")
	self.Hud_HealthBarSlide = self.Item:GetChild("Hud_HealthBarSlide")
	
	self.Tutorial_Hand = self.Item:GetChild("Tutorial_Hand")
	
	self:TurnOff()
	
	self.Hud_HealthBar:SetSize(256, 32)
	self.DestroyerColor = color(0.78, 0.27, 0, 1)
	
	self.HealthBarWidth = self.Hud_HealthBar:GetWidth()
	self.HealthBarHeight = self.Hud_HealthBar:GetHeight()
	
	self.CurrentSize = self.HealthBarWidth
	self.SizeGoTo = self.HealthBarWidth
	
	self.LerpSpeed = 0.05
	self.ColorVal1 = 0.9
	self.ColorVal2 = 0.9
end)

function HUD_E_HealthBar:FlashHealthBar()
	local FlashVal = 0.9
	self.ColorVal1 = FlashVal
	self.ColorVal2 = FlashVal
	
	if (self.FlashThread ~= nil) then
		PhysicsThread:Stop(self.FlashThread)
		self.FlashThread = nil
	end
	
	if (ActiveMission.HumanPlayers[1].PowerupManager ~= nil) then
		self.Hud_HealthBar:SetColorData(White, 0, None, false)
		self.Hud_HealthBar:SetColorData(self.DestroyerColor, 8, Sine, false)
	end
	
	self.FlashThread = PhysicsThread:Spawn(function()	
		for i = 10, 0, -1 do
			self.ColorVal1 = FlashVal
			self.ColorVal2 = FlashVal
		end
		
		self.SizeGoTo = math.floor(ActiveMission.HumanPlayers[1].Car:GetHP() / ActiveMission.HumanPlayers[1].MaxHP * 256)
	end)
end

function HUD_E_HealthBar:TurnOn()
	print("Healthbar: Ik ben nu oranje")
	self.Hud_HealthBar:SetColorImmediate(self.DestroyerColor)
end

function HUD_E_HealthBar:TurnOff()
	print("Healthbar: Ik ben nu rood")
	self.Hud_HealthBar:SetColorImmediate(Red)
end

function HUD_E_HealthBar:UpdatePhysics(ElapsedTime)	
	self.CurrentSize = Lerp(self.CurrentSize, self.SizeGoTo, self.LerpSpeed)
	self.ColorVal1 = Lerp(self.ColorVal1, 1, self.LerpSpeed)
	self.ColorVal2 = Lerp(self.ColorVal2, 0, self.LerpSpeed)
	
	local Color = color(self.ColorVal1, self.ColorVal2, self.ColorVal2, 1)
	
	if (ActiveMission.HumanPlayers[1].PowerupManager ~= nil) then
		self.Hud_HealthBarSlide:SetWidth(math.floor(self.CurrentSize))
		self.Hud_HealthBar:SetWidth(math.floor(self.SizeGoTo))
	end
	
	self.Hud_HealthBarSlide:SetColor(Color)
end

function HUD_E_HealthBar:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)
	
	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		if (self.HUD.TutorialText ~= nil) then
			self.HUD.TutorialText:SetText(Translate("tutorial_HealthBar"))
		else
			print("No TutorialText element found")
		end

		PhysicsThread:Wait(60 * 5)
		
		self:EndTutorial(CallbackFunction)
	end)
end