HUD_E_JoyStick = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.Hud_SlideArea = self.Item:GetChild("JoystickBackground")
	self.Hud_SlideArrow = self.Item:GetChild("Joystick")
	
	self.Tutorial_Hand = self.Hud_SlideArea:GetChild("Tutorial_Hand")
	
	self.OriginalSizeX, self.OriginalSizeY = self.Hud_SlideArea:GetSize()
end)

function HUD_E_JoyStick:Show(Force)
	self.Super.Show(self, Force)
	
	local InputManager = nil
	if (ActiveMission.HumanPlayers ~= nil and #ActiveMission.HumanPlayers > 0) then
		InputManager = ActiveMission.HumanPlayers[1].InputManager
	end
	
	local PercX = 0
	local PercY = 0
	
	if (InputManager ~= nil and InputManager.Input ~= nil) then
		PercX = InputManager.Input.Steer
		PercY = InputManager.Input.RawAccel
	end
	
	local Dir = Vector(PercX, PercY, 0):Normalize()
	local Power = ClampMax(math.sqrt(PercX * PercX + PercY * PercY), 1)
	Dir = Dir * Power
	
	self.Hud_SlideArrow:SetPos(( (self.OriginalSizeX / 2) * Dir.x) + 1, (self.OriginalSizeY / 2) * Dir.y)
end

function HUD_E_JoyStick:UpdatePhysics(ElapsedTime)
	local InputManager = nil
	if (ActiveMission.HumanPlayers ~= nil and #ActiveMission.HumanPlayers > 0) then
		InputManager = ActiveMission.HumanPlayers[1].InputManager
	end
	
	local PercX = 0
	local PercY = 0
	
	if (InputManager ~= nil and InputManager.Input ~= nil) then
		PercX = InputManager.Input.Steer
		PercY = InputManager.Input.RawAccel
	end
	
	local Dir = Vector(PercX, PercY, 0):Normalize()
	local Power = ClampMax(math.sqrt(PercX * PercX + PercY * PercY), 1)
	Dir = Dir * Power
	
	self.Hud_SlideArrow:SetPos(( (self.OriginalSizeX / 2) * Dir.x) + 1, (self.OriginalSizeY / 2) * Dir.y)
end

function HUD_E_JoyStick:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)

	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		if (self.HUD.TutorialText ~= nil) then
			self.HUD.TutorialText:SetText(Translate("tutorial_AccelerateSlider1"))
		else
			print("No TutorialText element found")
		end
		
		local Steps = 125
		for i = 0, Steps do
			j = Steps - i
			
			self.Tutorial_Hand:SetPos(0, self.OriginalSizeY * (j / (Steps * 1.2)))
			
			PhysicsThread:Wait(1)
		end
		
		PhysicsThread:Wait(60 * 3)
		
		self:EndTutorial(CallbackFunction)
	end)
end