HUD_E_MapBar = class(HUD_E_Base, function(self, HUD, Panel, Element)

	self.Hud_MapBarBack = self.Item:GetChild("Hud_MapBarBack")
	self.PlayerArrow1 = self.Item:GetChild("PlayerArrow1")
	self.PlayerArrow2 = self.Item:GetChild("PlayerArrow2")
	
	self.PlayerArrow1:SetColorData(White, 0, None, false)
	self.PlayerArrow2:SetColorData(Red, 0, None, false)
	
	self.PlayerArrow1Origina2X, self.PlayerArrow2OriginalY = self.PlayerArrow2:GetPos()
	self.MapBarOriginalSizeX, self.MapBarOriginalSizeY = self.Hud_MapBarBack:GetSize()
	
	self.Tutorial_Hand = self.Item:GetChild("Tutorial_Hand")
	
	self.FinishPerc = 0.85
	
	self.HumanPerc = 0
	self.AIPerc = 0
	
	self.LerpSpeed = 0.02
end)

function HUD_E_MapBar:UpdatePhysics(ElapsedTime)	
	local HumanPlayer = nil
	local AIPlayer = nil
	
	for i, Player in ipairs(ActiveMission.Players) do
		if (Player.Human) then
			HumanPlayer = Player
		else
			AIPlayer = Player
		end
	end
	
	--TODO: Is mooier/netter als dit in 1 functie staat, anders staat hier dubbele code
	-- Volgorde is aangepast zodat men op de AIPlayer kan checken, die kan niet altijd bestaan met bv opnemen van een replay
	if (HumanPlayer ~= nil) then
		local HumanPerc = HumanPlayer.Progress
		self.HumanPerc = Lerp(self.HumanPerc, HumanPerc, self.LerpSpeed)
		
		local Perc1 = Lerp(0, self.MapBarOriginalSizeX * self.FinishPerc, self.HumanPerc)
		Perc1 = ClampMinMax(Perc1, 0, self.MapBarOriginalSizeX * self.FinishPerc)
		
		self.PlayerArrow1:SetPos(Perc1, self.PlayerArrow1OriginalY)
	end
	
	if (AIPlayer ~= nil) then
		local AIPerc = AIPlayer.Progress
		self.AIPerc = Lerp(self.AIPerc, AIPerc, self.LerpSpeed)
		
		local Perc2 = Lerp(0, self.MapBarOriginalSizeX * self.FinishPerc, self.AIPerc)
		Perc2 = ClampMinMax(Perc2, 0, self.MapBarOriginalSizeX * self.FinishPerc)
		
		self.PlayerArrow2:SetPos(Perc2, self.PlayerArrow2OriginalY)
	else
		self.PlayerArrow2:SetColor(Invisible)
	end
end

function HUD_E_MapBar:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)
	
	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		local SizeX, SizeY = self.Tutorial_Hand:GetSize()
		self.Tutorial_Hand:SetSize(SizeX, -SizeY)
		
		if (self.HUD.TutorialText ~= nil) then
			self.HUD.TutorialText:SetText(Translate("tutorial_MapBar"))
		else
			print("No TutorialText element found")
		end
		
		PhysicsThread:Wait(60 * 5)
		
		self:EndTutorial(CallbackFunction)
	end)
end