HUD_E_PowerUpButton = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.PowerupButton = self.Item:GetChild("PowerupButton")
	self.PowerupButtonImageOn = self.Item:GetChild("PowerupButton_Image_On")
	self.PowerupButtonImageOff = self.Item:GetChild("PowerupButton_Image_Off")
	
	self.Tutorial_Hand = self.PowerupButton:GetChild("Tutorial_Hand")
	
	self.Enabled = false
	self:TurnOff()
end)

function HUD_E_PowerUpButton:Show(Force)
	self.Super.Show(self, Force)
	
	if (Force) then
		self.PowerupButton:SetColorImmediate(White)
	else
		self.PowerupButton:SetColor(White)
		self.PowerupButton:SetColorFade(1,3)
	end
end

function HUD_E_PowerUpButton:Hide(Force)
	self.Super.Hide(self, Force)

	if (Force) then
		self.PowerupButton:SetColorImmediate(Invisible)
	else
		self.PowerupButton:SetColor(Invisible)
		self.PowerupButton:SetColorFade(1,3)
	end
end

function HUD_E_PowerUpButton:TurnOn()
	self.Enabled = true
	self.PowerupButtonImageOn:SetColorImmediate(White)
	self.PowerupButtonImageOff:SetColorImmediate(Invisible)
end

function HUD_E_PowerUpButton:TurnOff()
	self.Enabled = false
	self.PowerupButtonImageOn:SetColorImmediate(Invisible)
	self.PowerupButtonImageOff:SetColorImmediate(White)
end

function HUD_E_PowerUpButton:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)

	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		local SizeX, SizeY = self.Tutorial_Hand:GetSize()
		self.Tutorial_Hand:SetSize(-SizeX, SizeY)
		
		if (self.HUD.TutorialText ~= nil) then
			self.HUD.TutorialText:SetText(Translate("tutorial_Powerups"))
		else
			print("No TutorialText element found")
		end
		
		self.Tutorial_Hand:SetPos(self.Item:GetPos())
		
		PhysicsThread:Wait(60 * 3)
		
		self:EndTutorial(CallbackFunction)
	end)
end
