HUD_E_ScoreElement = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.ScoreElement = self.Item:GetChild("ScoreElement")
	self.ScoreText = self.Item:GetChild("ScoreText")
	self.ScoreText_Flash = self.Item:GetChild("ScoreText_Flash")
	self.Icon = self.Item:GetChild("Icon")
	
	self.Tutorial_Hand = self.Item:GetChild("Tutorial_Hand")
	
	self.ScoreElement:SetColorImmediate(White)
	
	self.Lerp = false
	self.LerpSpeed = 0.25
	self.Score = 0
	self.ScoreToGo = 0
	self.Negative = false
	self.FormatTimeVar = false
	
	self:Flash(3)
end)

function HUD_E_ScoreElement:Hide(Force)
	Force = true
	
	self.Super.Hide(self, Force)
end

function HUD_E_ScoreElement:Flash(FadeSpeed)
	if (FadeSpeed == nil) then
		FadeSpeed = 3
	end

	self.ScoreText:SetColorImmediate(self.HUD.BaseTextColor_Flash)
	self.ScoreText:SetColor(self.HUD.BaseTextColor)
	self.ScoreText:SetColorFade(1,FadeSpeed)
	
	self.ScoreText_Flash:SetColorImmediate(self.HUD.BaseTextColor_Flash)
	self.ScoreText_Flash:SetColor(Invisible)
	self.ScoreText_Flash:SetColorFade(1,FadeSpeed)
end

function HUD_E_ScoreElement:SetText(Text)
	self.ScoreText:SetText(Text)
	self.ScoreText_Flash:SetText(Text)
end

function HUD_E_ScoreElement:SetFont(Font, Flash)
	if (Flash == nil) then
		Flash = false
	end

	self.ScoreText:SetFont(Font)
	self.ScoreText_Flash:SetFont(Font)
	
	if (Flash) then
		self:Flash(3)
	end
end

function HUD_E_ScoreElement:SetScore(Score, LerpBool, FormatTimeVar)
	if (LerpBool == nil) then
		LerpBool = false
	end
	
	if (FormatTimeVar == nil) then
		FormatTimeVar = false
	end
	
	self.FormatTimeVar = FormatTimeVar
	--self.Lerp = LerpBool Moest van Erwin!!
	
	local PrevNegative = self.Negative
	
	if (self.Score < 0) then
		self.Negative = true
	else
		self.Negative = false
	end
	
	if (self.Negative ~= PrevNegative) then
		self:Flash()
	end
	
	self.ScoreToGo = Score
end

function HUD_E_ScoreElement:UpdatePhysics(ElapsedTime)
	if (self.Lerp) then
		self.Score = Lerp(self.Score, self.ScoreToGo, self.LerpSpeed)
	else
		self.Score = self.ScoreToGo
	end
	
	local Text = ""
	
	if (self.FormatTimeVar) then
		if (self.Negative) then
			Text = Text .. "-"
		end
	
		Text = Text .. FormatTime(math.abs(self.Score))
	else
		Text = Text .. self.Score
	end
	
	self:SetText(Text)
end

function HUD_E_ScoreElement:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)
	
	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		if (self.HUD.TutorialText ~= nil) then
			if (ActiveGameMode == TowTest) then
				self.HUD.TutorialText:SetText(Translate("tutorial_ScoreElement_TowTest"))
			else
				self.HUD.TutorialText:SetText(Translate("tutorial_ScoreElement"))
			end
		else
			print("No TutorialText element found")
		end
		
		PhysicsThread:Wait(60 * 5)
		
		self:EndTutorial(CallbackFunction)
	end)
end

function HUD_E_ScoreElement:ShowIcon()
	self.Icon:SetColorImmediate(White)
end