HUD_E_SlipIndicator = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.SlipImage = self.Item:GetChild("SlipImage")
	
	self.VisibleColor = color(0,0,0,1)
	self.InvisibleColor = color(0,0,0,0)
	
	self.SlipTimer = 0
	self.SlipTimerMax = ActiveMission.SlipSeconds*60
	
	self:SetColor(Invisible)
end)

function HUD_E_SlipIndicator:SetColor(Color)
	self.SlipImage:SetColorImmediate(Color)
end

function HUD_E_SlipIndicator:UpdatePhysics(ElapsedTime)
	if (ActiveMission.IsSlipping) then -- Slipping? GetSlip-function -> C++
		self.SlipTimer = Inc(self.SlipTimer)
	else
		self.SlipTimer = Dec(self.SlipTimer)
	end
	
	if (self.SlipTimer > self.SlipTimerMax and ActiveMission.Chain ~= nil) then
		ActiveMission.Chain:BreakChain()
	end
	
	self.SlipTimer = ClampMinMax(self.SlipTimer, 0, self.SlipTimerMax)

	local Perc = self.SlipTimer / self.SlipTimerMax

	self:SetColor(Lerp(self.InvisibleColor, self.VisibleColor, Perc))
end