HUD_E_SpecialScorePopup = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.Background = self.Item:GetChild("Background")
	self.Header = self.Item:GetChild("Header")
	self.Description = self.Item:GetChild("Description")
	self.LocalPanel = self.Item:GetChild("Container")
	self.StartPos = self.Background:GetPos()
	self.LerpSpeed = 1

	self.ShowPanel = false
	self.Duration = 3
	self.CurrentDuration = 0
	self.Background:SetPosData(0, 0, 0, 0.5, 1, 0.3, 2, 0, false)
	
	self.Stars = MenuElements.Stars(nil, "hud\\elements\\hud_Star.dcMenu", HUD, self.LocalPanel, 3, -5, 60)
	self.Stars:ShowStars(0)
	self.Description:SetText("")
end)

function HUD_E_SpecialScorePopup:UpdatePhysics(ElapsedTime)
	if (self.ShowPanel) then
		self.Background:SetPosData(0, 0, 1, 0.5, 1, 0.3, 2, self.LerpSpeed, false)
		self.CurrentDuration = self.CurrentDuration + (1/60)
		
		if (self.CurrentDuration >= self.Duration) then
			self.CurrentDuration = 0
			self.ShowPanel = false
		end
	else
		self.Background:SetPosData(0, 0, 0, 0.5, 1, 0.3, 2, self.LerpSpeed, false)
	end
end

function HUD_E_SpecialScorePopup:ShowPopup(Title, Description, StarScore)
	self.Background:SetPosData(0, 0, 0, 0.5, 1, 0.3, 2, 0, false)
	self.Header:SetText(Title)
	self.Description:SetText(Description)
	self.Stars:ShowStars(StarScore)
	self.ShowPanel = true
end