HUD_E_SteerSlider = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.Hud_SlideArea = self.Item:GetChild("Hud_SlideArea")
	self.Hud_SlideArrow = self.Item:GetChild("Hud_SlideArrow")
	self.BoostImageOn = self.Item:GetChild("BoostImageOn")
	self.BoostImageOff = self.Item:GetChild("BoostImageOff")
	
	self.Tutorial_Hand = self.Hud_SlideArea:GetChild("Tutorial_Hand")
	
	self.OriginalSizeX, self.OriginalSizeY = self.Hud_SlideArea:GetSize()
	
	self.OriginalSizeX = self.OriginalSizeX + 16
	
	self:TurnBoostOff()
end)

function HUD_E_SteerSlider:Show(Force)
	self.Super.Show(self, Force)
	
	local InputManager = nil
	if (ActiveMission.HumanPlayers ~= nil and #ActiveMission.HumanPlayers > 0) then
		InputManager = ActiveMission.HumanPlayers[1].InputManager
	end
	
	local Perc = 0
	
	if (InputManager ~= nil) then
		Perc = InputManager.SteerValue_Raw
	end
	
	self.Hud_SlideArrow:SetPos(( (self.OriginalSizeX / 2) * Perc) + 4, -8)
end

function HUD_E_SteerSlider:TurnBoostOn()
	--print("A powerupbutton has been turned on")
	self.BoostImageOn:SetColorImmediate(White)
	self.BoostImageOff:SetColorImmediate(Invisible)
end

function HUD_E_SteerSlider:TurnBoostOff()
	--print("A powerupbutton has been turned off")
	self.BoostImageOn:SetColorImmediate(Invisible)
	self.BoostImageOff:SetColorImmediate(White)
end

function HUD_E_SteerSlider:UpdatePhysics(ElapsedTime)
	local InputManager = nil
	if (ActiveMission.HumanPlayers ~= nil and #ActiveMission.HumanPlayers > 0) then
		InputManager = ActiveMission.HumanPlayers[1].InputManager
	end
	
	local Perc = 0
	
	if (InputManager ~= nil) then
		Perc = InputManager.SteerValue_Raw
	end
	
	self.Hud_SlideArrow:SetPos(( (self.OriginalSizeX / 2) * Perc) + 4, -8)
end

function HUD_E_SteerSlider:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)

	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		if (self.HUD.TutorialText ~= nil) then
			self.HUD.TutorialText:SetText(Translate("tutorial_AccelerateSlider1"))
		else
			print("No TutorialText element found")
		end
		
		local Steps = 125
		for i = 0, Steps do
			j = Steps - i
			
			self.Tutorial_Hand:SetPos(0, self.OriginalSizeY * (j / (Steps * 1.2)))
			
			PhysicsThread:Wait(1)
		end
		
		PhysicsThread:Wait(60 * 3)
		
		self:EndTutorial(CallbackFunction)
	end)
end



--Demonstratie van de slider balk, uitgezet, maar aub laten staan als het er weer in moet:
		
-- Dit hieronder in de UpdatePhysics;
--self.Tutorial_Hand:SetPos(0, self.OriginalSizeY * Perc)
		
-- De rest in de ShowTutorial;
--[[ ActiveMission.HumanPlayers[1].Car:EnableInput()
ActiveMission.HumanPlayers[1].Car:Enable()
ActiveMission.HumanPlayers[1].InputManager:Enable()
ActiveMission.HumanPlayers[1].InputManager:DisableInput()

self.HUD.TutorialText:SetText("Gas geven uitleg")

local Steps = 25
for i = 0, Steps do
	--ActiveMission.HumanPlayers[1].InputManager.InputSpeedY = ClampMax(ActiveMission.HumanPlayers[1].InputManager.BrakeLimit + (i / (Steps * 1.2)), 0.8)
	ActiveMission.HumanPlayers[1].InputManager.InputSpeedY = ClampMax(ActiveMission.HumanPlayers[1].InputManager.BrakeLimit + (i / (Steps * 1.2)), 0.8)
	PhysicsThread:Wait(1)
end

PhysicsThread:Wait(60)

self.HUD.TutorialText:SetText("Extra boost geven uitleg")

local Steps = 25
for i = 0, Steps do
	ActiveMission.HumanPlayers[1].InputManager.InputSpeedY = ClampMin(ActiveMission.HumanPlayers[1].InputManager.BrakeLimit + (i / (Steps * 1.2)), 0.8)
	PhysicsThread:Wait(1)
end

PhysicsThread:Wait(60)

local Steps = 25
local j = Steps
for i = 0, Steps do
	j = Steps - i
	ActiveMission.HumanPlayers[1].InputManager.InputSpeedY = ActiveMission.HumanPlayers[1].InputManager.BrakeLimit + (j / (Steps * 1.2))
	PhysicsThread:Wait(1)
end

PhysicsThread:Wait(60)

self.HUD.TutorialText:SetText("Remmen uitleg")

local Steps = 25
for i = 0, Steps do
	j = Steps - i + 1
	ActiveMission.HumanPlayers[1].InputManager.InputSpeedY = ActiveMission.HumanPlayers[1].InputManager.BrakeLimit * (j / Steps)
	PhysicsThread:Wait(1)
end

ActiveMission.HumanPlayers[1].InputManager.InputSpeedY = 0.0

local Speed = ActiveMission.HumanPlayers[1].Car:GetLocalSpeed() * -1
while (Speed > 300) do
	Speed = ActiveMission.HumanPlayers[1].Car:GetLocalSpeed() * -1
	PhysicsThread:Wait(4)
end

self.HUD.TutorialText:SetText("")

local Steps = 35
for i = 1, Steps do
	ActiveMission.HumanPlayers[1].InputManager.InputSpeedY = ActiveMission.HumanPlayers[1].InputManager.BrakeLimit * (i / Steps)
	PhysicsThread:Wait(1)
end

self.HUD.TutorialText:SetText("Now you try!")

ActiveMission.HumanPlayers[1].InputManager:Disable()
--ActiveMission.HumanPlayers[1].InputManager:EnableInput()
]]