HUD_E_Timer = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.TimeText = self.Item:GetChild("TimeText")
	self.TimeText_Flash = self.Item:GetChild("TimeText_Flash")
	self.TimePanel = self.Item:GetChild("TimePanel")
	
	self.Tutorial_Hand = self.Item:GetChild("Tutorial_Hand")
	
	self.TimeText:SetColorImmediate(White)
	
	self:Flash(3)
	
	self.UseShortTime = false
end)

function HUD_E_Timer:Flash(FadeSpeed)
	if (FadeSpeed == nil) then
		FadeSpeed = 10
	end

	self.TimeText:SetColorImmediate(self.HUD.BaseTextColor_Flash)
	self.TimeText:SetColor(self.HUD.BaseTextColor)
	self.TimeText:SetColorFade(1,FadeSpeed)
	
	self.TimeText_Flash:SetColorImmediate(self.HUD.BaseTextColor_Flash)
	self.TimeText_Flash:SetColor(Invisible)
	self.TimeText_Flash:SetColorFade(1,FadeSpeed)
end

function HUD_E_Timer:SetText(Text)
	self.TimeText:SetText(Text)
	self.TimeText_Flash:SetText(Text)
end

function HUD_E_Timer:SetFont(Font)
	self.TimeText:SetFont(Font)
	self.TimeText_Flash:SetFont(Font)
end

function HUD_E_Timer:UpdatePhysics(ElapsedTime)
	if (ActiveMission.RaceTimer ~= nil) then
		local TimeText = ""
		if (self.UseShortTime) then
			TimeText = FormatTimeShort(ActiveMission.RaceTimer)
		else
			TimeText = FormatTime(ActiveMission.RaceTimer)
		end
		
		self:SetText(TimeText)
	else
		local TimeText = ""
		if (self.UseShortTime) then
			TimeText = FormatTimeShort(ActiveMission.RaceTimerStart)
		else
			TimeText = FormatTime(ActiveMission.RaceTimerStart)
		end
		
		self:SetText(TimeText)
	end
end

function HUD_E_Timer:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)
	
	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		if (self.HUD.TutorialText ~= nil) then
			if (ActiveGameMode == FreestyleFest) then
				self.HUD.TutorialText:SetText(Translate("tutorial_Timer_dec"))
			else
				self.HUD.TutorialText:SetText(Translate("tutorial_Timer"))
			end
		else
			print("No TutorialText element found")
		end
		
		PhysicsThread:Wait(60 * 5)
		
		self:EndTutorial(CallbackFunction)
	end)
end