HUD_E_WarningPopupTimer = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.Panel = self.Item:GetChild("Panel")
	self.WarningText = self.Item:GetChild("WarningText")
	self.WarningText_Flash = self.Item:GetChild("WarningText_Flash")
	self.ValueText = self.Item:GetChild("ValueText") 
	self.ValueText_Flash = self.Item:GetChild("ValueText_Flash")
	
	self.Tutorial_Hand = self.Item:GetChild("Tutorial_Hand")
	
	self.StartColor = self.HUD.BaseTextColor
	self.EndColor = color(1,0,0,0) 
	
	self.LastDuration = 3.0
	
	self:End()
end)

function HUD_E_WarningPopupTimer:Show(Force)
	self.Item:SetColorImmediate(self.HUD.BaseTextColor)
	self.ValueText:SetColorImmediate(self.HUD.BaseTextColor)
	self.ValueText_Flash:SetColorImmediate(self.HUD.BaseTextColor)
end

function HUD_E_WarningPopupTimer:Hide(Force)
	self.Item:SetColorImmediate(Invisible)
end

function HUD_E_WarningPopupTimer:Start(Duration)
	self.Item:SetColorImmediate(self.HUD.BaseTextColor)
	
	self.ValueText:SetColorImmediate(self.HUD.BaseTextColor_Flash)
	self.ValueText_Flash:SetColorImmediate(self.HUD.BaseTextColor_Flash)
	self.WarningText:SetColor(White)
	
	self.LastDuration = Duration
	
	self:Pulse(White, self.EndColor)
end

function HUD_E_WarningPopupTimer:Pulse(PulseColor, InvisiblePulseColor) 
	self.WarningText_Flash:SetColorData(PulseColor, 0, None, false)
	self.WarningText_Flash:SetColorData(InvisiblePulseColor, 1, Sine, true) 
end

function HUD_E_WarningPopupTimer:SetText(Text)
	self.ValueText:SetText(Text)
	self.ValueText_Flash:SetText(Text)
end

function HUD_E_WarningPopupTimer:End()
	if self.EndColor ~= nil then
		self.WarningText_Flash:SetColorData(self.EndColor, 1, Sine, false)
	else
		self.WarningText_Flash:SetColorData(Invisible, 1, Sine, false)
	end
	
	self.ValueText:SetColorImmediate(self.HUD.BaseTextColor)
	self.ValueText_Flash:SetColorImmediate(self.HUD.BaseTextColor)
	self.WarningText:SetColor(self.HUD.BaseTextColor)

	self:SetText(FormatTime(self.LastDuration))
end

function HUD_E_WarningPopupTimer:UpdatePhysics(ElapsedTime)
	if (ActiveMission.CountdownTimer > 0) then
		self:SetText(FormatTime(ActiveMission.CountdownTimer / 60))
	end
end

function HUD_E_WarningPopupTimer:ShowTutorial(CallbackFunction)
	self.Super.ShowTutorial(self, CallbackFunction)
	
	self.TutorialThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(60)
		
		self.Tutorial_Hand:SetColorFade(1, 10)
		self.Tutorial_Hand:SetColorImmediate(Invisible)
		self.Tutorial_Hand:SetColor(White)
		
		local SizeX, SizeY = self.Tutorial_Hand:GetSize()
		self.Tutorial_Hand:SetSize(-SizeX, SizeY)
		
		if (self.HUD.TutorialText ~= nil) then
			self.HUD.TutorialText:SetText(Translate("tutorial_Countdown"))
		else
			print("No TutorialText element found")
		end
		
		PhysicsThread:Wait(60 * 5)
		
		self:EndTutorial(CallbackFunction)
	end)
end