HUD_Race = class(HUD_Base, function(self, Mission, Player)
	-- Checkpoint Element
	local LocationData = {0,0,0.5,0,0.5,0.35}
	self.Checkpoint = HUD_E_Checkpoint(self, self.SafeFrame, "hud_Checkpoint", LocationData)
	table.insert(self.HUDElements, self.Checkpoint)
	
	-- Map bar
	local LocationData = {0,-48,0.5,1,0.5,1}
	self.MapBar = HUD_E_MapBar(self, self.SafeFrame, "hud_MapBar", LocationData)
	table.insert(self.HUDElements, self.MapBar)
	
	-- HealthBar Element
	local LocationData = {128,64,0,0,0,0}
	self.HealthBar = HUD_E_HealthBar(self, self.SafeFrame, "hud_HealthBar", LocationData)
	table.insert(self.HUDElements, self.HealthBar)
	
	-- Time Element
	local LocationData = {128,0,0,0,0,0}
	self.Timer = HUD_E_Timer(self, self.SafeFrame, "hud_Timer", LocationData)
	table.insert(self.HUDElements, self.Timer)
	
	-- Score Element
	local LocationData = {-128,0,1,0,1,0}
	self.ScoreElement = HUD_E_ScoreElement(self, self.SafeFrame, "hud_Score", LocationData)
	table.insert(self.HUDElements, self.ScoreElement)
	
	-- TutorialText Element
	local LocationData = {0, 0, Center, Center, Center, 0.3}
	self.TutorialText = HUD_E_TutorialText(self, self.SafeFrame, "hud_TutorialText", LocationData)
	table.insert(self.HUDElements, self.TutorialText)
end)

function HUD_Race:ShowCheckpoint(Checkpoint)
	self.Checkpoint:Flash(1)

	-- Making the Score's font bigger as the player nears the finish
	local Length = Checkpoint:GetLength()
	
	-- Getting the right Checkpoints, calculated by the fact a race track has two seperate tracks, and thus checkpoints
	local CounterCheckpoint1 = ActiveMission.Checkpoints[#ActiveMission.Checkpoints / 2 + 1] -- 14 / 2 + 1 = 8 -> 90
	local CounterCheckpoint2 = ActiveMission.Checkpoints[#ActiveMission.Checkpoints / 2] -- 14 / 2 = 7 -> 80
	
	-- 3 Stages; Finish - 2 -> 80. Finish - 1 -> 90. Finish -> 70 (default)
	if (CounterCheckpoint1 ~= nil and Length == CounterCheckpoint1:GetLength()) then
		self:SetScoreFont("ArialBlack90", true)
	elseif (CounterCheckpoint2 ~= nil and Length == CounterCheckpoint2:GetLength()) then
		self:SetScoreFont("ArialBlack80", true)
	else
		self:SetScoreFont("ArialBlack70", false)
	end
end