InputKey = class(function(self, Keys)
	self.Keys = Keys
	
	self.KeyCodes = {}
	for i, Key in ipairs(self.Keys) do
		table.insert(self.KeyCodes, GetKeyCode(Key))
	end
end)

function InputKey:KeyPressed()
	for i, KeyCode in ipairs(self.KeyCodes) do
		if (KeyPressed(KeyCode)) then
			return true
		end
	end
	
	return false
end

dofile("Lua\\InputDevices\\Keyboard.lua")
dofile("Lua\\InputDevices\\Android.lua")
dofile("Lua\\InputDevices\\Touch.lua")
dofile("Lua\\InputDevices\\XboxController0.lua")
dofile("Lua\\InputDevices\\Sixense.lua")
dofile("Lua\\InputDevices\\N3DS.lua")
dofile("Lua\\InputDevices\\Wii.lua")
dofile("Lua\\InputDevices\\InputManager.lua")

JoystickPressures = {}

function CheckPressure()
	for i = 200000, 200025 do
		JoystickPressures[i] = GetPressure(i)
	end
end

function PressureChanged(KeyCode)
	if KeyCode < 200000 or KeyCode > 200025 then
		return true
	end

	if JoystickPressures[KeyCode] ~= nil then
		local newPressure = GetPressure(KeyCode)
		local testPressure = newPressure - JoystickPressures[KeyCode]
		JoystickPressures[KeyCode] = newPressure
		if testPressure > 0.1 then
			return true
		end
	end
	
	return false
end