dofile("lua\\Menu_Properties.lua")
dofile("lua\\Menu_Utils.lua")
dofile("lua\\MenuElements.lua")

-- Menu stuff
ActiveBackground = nil
ActiveMenu = nil
ActiveForeground = nil

ResetFuncs = {}

function ActiveMenu_Refresh()
	--local ActiveBackgroundCopy = ActiveBackground
	local ActiveMenuCopy = ActiveMenu
	--local ActiveForegroundCopy = ActiveForeground
	local CutsceneBarsCopy = CutsceneBars
	--local HUDCopy = HUD
	local ActiveMissionCopy = ActiveMission
	
	dofile("lua\\Menu.lua")
	
	if (ActiveMissionCopy ~= nil and ActiveMissionCopy.Refresh ~= nil) then
		ActiveMissionCopy:Refresh()
	end
	
	if (ActiveBackgroundCopy ~= nil) then
		--ActiveBackgroundCopy:Refresh()
	end
	
	if (ActiveMenuCopy ~= nil) then
		ActiveMenuCopy:Refresh()
	end
	
	if (ActiveForegroundCopy ~= nil) then
		--ActiveForegroundCopy:Refresh()
	end
	
	if (CutsceneBarsCopy ~= nil) then
		CutsceneBarsCopy:Refresh()
	end
	
	--if (HUDCopy ~= nil) then
		--HUDCopy:Refresh()
	--end
	
end
refreshactivemenu = ActiveMenu_Refresh

function ActiveMenu_PushMenu(MenuFile, ForegroundState)
	ClearKeyListeners()

	if (ActiveBackground == nil) then
		ActiveBackground = BackgroundMenu()
	end
	local Menu = PushMenu(MenuFile)
	if (ActiveForeground ~= nil) then
		ActiveForeground:PushMenu(ForegroundState)
	else
		ActiveForeground = ForegroundMenu(ForegroundState)
	end
	return Menu
end

function ActiveMenu_PushMenuAsync(MenuFile, ForegroundState, Callback)
	ClearKeyListeners()

	if (ActiveBackground == nil) then
		ActiveBackground = BackgroundMenu()
	end
	local Menu = CreateMenuAsync(MenuFile, function(Menu)
		PushMenuRef(Menu)

		if (ActiveForeground ~= nil) then
			ActiveForeground:PushMenu(ForegroundState)
		else
			ActiveForeground = ForegroundMenu(ForegroundState)
		end

		Callback(Menu)
	end)

	return Menu
end

--function ActiveMenu_LoadBackground()
	--if Background == nil then
		--Background = pushmenu("Background")
	--end
--end

-- Functie mag weg als deze ook uit de code is gehaald
function MenuInput(ElapsedTime)
	InputThread:Select(1)
end

EngineThread = Scheduler(1)
GameThread = Scheduler(1)
PhysicsThread = Scheduler(getvar("StepSize"))
PostPhysicsThread = Scheduler(getvar("StepSize"))
PreRenderThread = Scheduler(1)
InputThread = Scheduler(60)

function Reset()
	GameThread = Scheduler(1)
	PhysicsThread = Scheduler(getvar("StepSize"))
	PostPhysicsThread = Scheduler(getvar("StepSize"))
	PreRenderThread = Scheduler(1)
	InputThread = Scheduler(60)
	
	-- Reset
	for i = 1, #ResetFuncs do
		ResetFuncs[i]()
	end
	ResetFuncs = {}
end

function ResetScript()
	print( "ResetScript", #ResetFuncs )
	--[[for i = 1, #ResetFuncs do
		ResetFuncs[i]()
	end
	ResetFuncs = {}]]
end

function MenuUpdatePhysics(ElapsedTime)
	PhysicsThread:Select(1);

	--print("TotalPhysicsThread: " .. #PhysicsThread.Threads)
	
	local Handler = nil
	
	if (ActiveMenu ~= nil) then
		Handler = ActiveMenu
	--elseif (CutsceneBars ~= nil) then
		--Handler = CutsceneBars;
	--elseif (HUD ~= nil) then
		--Handler = HUD;
	elseif (ActiveMission ~= nil) then
		Handler = ActiveMission;
	end
	
	if (Handler ~= nil) then
		if (Handler.UpdatePhysics ~= nil) then
			Handler:UpdatePhysics(ElapsedTime)
		end
	end
end

function MenuUpdatePostPhysics(ElapsedTime)
	PostPhysicsThread:Select(1);
	
	--print("TotalPostPhysicsThread: " .. #PostPhysicsThread.Threads)
end

function PreRender()
	PreRenderThread:Select(1);
	
	--print("TotalPostPhysicsThread: " .. #PostPhysicsThread.Threads)
end

--In code aanpassen naar "MenuUpdate" ipv "OnUpdate" ???
function OnUpdate(ElapsedTime)
	MenuUpdate(ElapsedTime)
end

function MenuUpdate(ElapsedTime)
	local Handler = nil
	
	if (ActiveMenu ~= nil) then
		Handler = ActiveMenu
	--elseif (CutsceneBars ~= nil) then
		--Handler = CutsceneBars;
	--elseif (HUD ~= nil) then
		--Handler = HUD;
	elseif (ActiveMission ~= nil) then
		Handler = ActiveMission;
	end
	
	if (Handler ~= nil) then
		if (Handler.Update ~= nil) then
			Handler:Update(ElapsedTime)
		end
	end
	
	EngineThread:Select(ElapsedTime)
	GameThread:Select(ElapsedTime);
	--print("TotalGameThread: " .. #GameThread.Threads)
	
	if (DebugScheduler ~= nil) then
		DebugScheduler:Select(ElapsedTime)
	end
end

function ProcessChar(Character)
	local Handler = nil
	
	if (ActiveMenu ~= nil) then
		Handler = ActiveMenu
	--elseif (CutsceneBars ~= nil) then
		--Handler = CutsceneBars;
	--elseif (HUD ~= nil) then
		--Handler = HUD;
	end
	
	if (Handler ~= nil) then
		if (Handler.ProcessChar ~= nil) then
			Handler:ProcessChar(Character)
		end
	end
end

function KeyInput(KeyCode)
	local Handler = nil
	
	if (ActiveMenu ~= nil) then
		Handler = ActiveMenu
	--elseif (CutsceneBars ~= nil) then
		--Handler = CutsceneBars;
	--elseif (HUD ~= nil) then
		--Handler = HUD;
	end
	
	if (Handler ~= nil) then
		if (Handler.KeyInput ~= nil) then
			Handler:KeyInput(KeyCode)
		end
	end
end

-- Items
dofiles("lua\\Menu\\Support\\*.lua")
dofiles("lua\\Menu\\Elements\\*.lua")

-- Impl
dofiles("lua\\Menu\\*.lua")
dofile("lua\\MenuTextures.lua")
	