AudioOptions = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenu("AudioOptions")
	
	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")
	
	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	--
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")

	--Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()

	-- Panels leegmaken en lijst aanmaken
	ActiveForeground:HideInfoText()
	self.Items = NewItemList(self, UpButtons, DownButtons)
	self.ItemsPanel = self.Menu:GetChild("Items")
	self.ItemsPanel:Clear()
	
	self.ButtonTemplate = "Elements\\MenuButton.dcMenu"
	self.SliderTemplate = "Elements\\MenuSlider_Horizontal.dcMenu"
	local ItemColor = color(3, 2.5, 0, 1)
	
	
	-- Add Normal buttons
	self.TotalNormalButtons = 0
	
	--[[ local OnFXChangeFunc = function(Value) var("fxvolume", Value) end
	self.FxVolumeButton = self.Items:AddItem(self.ItemsPanel, MenuElements.MenuSlider(self.Items, self.SliderTemplate, "menu_fxvolume", OnFXChangeFunc, getvar("fxvolume"), 0, 1, 0.05, nil, nil, false))
	self.FxVolumeButton:SetColor(ItemColor)
	self.FxVolumeButton.OnClicked = function()
	end
	
	local OnMusicChangeFunc = function(Value) var("musicvolume", Value) end
	self.MusicVolumeButton = self.Items:AddItem(self.ItemsPanel, MenuElements.MenuSlider(self.Items, self.SliderTemplate, "menu_musicvolume", OnMusicChangeFunc, getvar("musicvolume"), 0, 1, 0.05, nil, nil, false))
	self.MusicVolumeButton:SetColor(ItemColor)
	self.MusicVolumeButton.OnClicked = function()
	end ]]
	
	local FxVolumeEnabled = false
	if (getvar("fxvolume") == 1 or getvar("fxvolume") == "1") then
		FxVolumeEnabled = true
	end
	
	self.FxVolumeCheckBox = self.Items:AddItem(self.ItemsPanel, MenuElements.Checkbox(self.Items, "Elements\\MenuCheckbox.dcMenu", "menu_fxvolume", FxVolumeEnabled))
	self.FxVolumeCheckBox.OnChange = function(Checked)
		if (Checked) then
			var("fxvolume", 1)
		else
			var("fxvolume", 0)
		end
	end
	
	
	local MusicVolumeEnabled = false
	if (getvar("musicvolume") == 1 or getvar("musicvolume") == "1") then
		MusicVolumeEnabled = true
	end
	
	self.MusicVolumeCheckBox = self.Items:AddItem(self.ItemsPanel, MenuElements.Checkbox(self.Items, "Elements\\MenuCheckbox.dcMenu", "menu_musicvolume", MusicVolumeEnabled))
	self.MusicVolumeCheckBox.OnChange = function(Checked)
		if (Checked) then
			var("musicvolume", 1)
		else
			var("musicvolume", 0)
		end
	end
	
	
	self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	
	-- Add back button
	self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	self.TotalBackButtons = self.TotalBackButtons + 1
	table.insert(self.MenuDelItem_Queue, self.BackButton)
	self.BackButton.OnReleased = function()
		print("^3AudioOptions ^7> ^2OptionsMenu")
		
		self.BackButton.OnReleased = nil
		--self:Goto(self.PreviousMenu)
		self:Goto(OptionsMenu)
	end
	
	
	-- Settings voor formatting
	self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 16
	local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	-- Format normal buttons
	self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
	self.Items:FormatTween(ALIGN_NS, 0 ,0 , 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
	
	-- Format back button
	self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
	self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
	
	self.Items:SetSelection(self.FxVolumeButton)
	
	
	-- KeyListeners
	AddKeyListeners(LeftButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():Left()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(RightButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():Right()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(BackButtons, "Down", function(Listeners)
		if (self:Active()) then
			self:Goto(self.PreviousMenu)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
end)

function AudioOptions:Goto(Target)
	configsave()
	ActiveMenu = Target(AudioOptions)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function AudioOptions:Active()
	return ActiveMenu == self
end

function AudioOptions:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = AudioOptions(PreviousMenu)
end

function AudioOptions:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function AudioOptions:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function AudioOptions:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end