CarSelect_ItemListActive = nil

CarSelect = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	AnalyticsSendScreenName("CarSelect")
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("CarSelect", nil, function()
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		ActiveForeground:HideInfoText()
		self.Items = NewItemList(self, nil, nil)
		self.Items_GameModes = NewItemList(self, LeftButtons, RightButtons) --, function() self:UpdateInfoText() end)
		--self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel = ActiveForeground.Menu:GetChild("OverlayItemList"):GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ItemsPanel:SetColorImmediate(Invisible)
		self.ItemsPanel:SetColorFade(1, 2)
		self.ItemsPanel:SetColor(White)
		
		self.ItemsArrows = self.Menu:GetChild("ItemsArrows")
		
		self.ButtonTemplate = "Elements\\CarSelect_Template.dcMenu"
		
		-- Add Normal buttons
		self.TotalCarButtons = 0
		
		for i, Car in ipairs(MonsterTruckCars.Cars) do
			if (IsCarVisibleInStore(Car.Name) or Car.Bought) then
				self.Element = self.Items_GameModes:AddItem(self.ItemsPanel, CarSelect_Template(self.Items_GameModes, self.ButtonTemplate, Car))
			
				if (CarSelect_ItemListActive == nil) then
					if (i == 3) then
						CarSelect_ItemListActive = i - 1
					end
				else
					--local SelectedCar = ActiveMission.CarManager:GetCarSelection()
					local SelectedCar = ActiveGameMode:GetSelectedCar()
					if (SelectedCar ~= nil) then
						if (SelectedCar == Car) then
							CarSelect_ItemListActive = i - 1
							--print("CarSelect_ItemListActive:", CarSelect_ItemListActive)
						end
					end
				end
			end
		end
		
		--self.Items_GameModes:SetSelection(self.FreestyleFestButton)
		
		if (CarSelect_ItemListActive == nil) then
			CarSelect_ItemListActive = #self.Items_GameModes.Items - 1
		end
		
		self.Items_GameModes.Active = CarSelect_ItemListActive
		self.TotalCarButtons = #self.Items_GameModes.Items
		
		-- Add Normal buttons
		self.TotalNormalButtons = 0	
		
		self.ItemsPanelRight = self.Menu:GetChild("Items")
		self.ItemsPanelRight:Clear()
		self.GotoGarageButton = self.Items:AddItem(self.ItemsPanelRight, MenuElements.Label(self.Items, "Elements\\MenuButtonView.dcMenu", "menu_garage"))
		self.OrderBoostButton = self.Items:AddItem(self.ItemsPanelRight, MenuElements.Label(self.Items, "Elements\\MenuButtonBoost.dcMenu", "menu_boost"))
		self.TotalNormalButtons = self.TotalNormalButtons + 2

		if (GetPlatform() == "IOS") then
			local OrderBoostButtonSizeX, OrderBoostButtonSizeY = self.OrderBoostButton.Item:GetSize()
			local GotoGarageButtonnSizeX, GotoGarageButtonSizeY = self.GotoGarageButton.Item:GetSize()
			local x, y = self.ItemsPanel:GetSize()
			self.OrderBoostButton.Item:SetSize(x - (OrderBoostButtonSizeX*0.8) , OrderBoostButtonSizeY)
			self.GotoGarageButton.Item:SetSize(x - (GotoGarageButtonnSizeX*0.8) , GotoGarageButtonSizeY)
		end
		--self.OrderBoostButton.Item:GetChild("Name"):SetText("menu_boost")
		--self.OrderBoostButton.Item:GetChild("Description"):SetText("Boost your monster- truck to improve your steering, speed, power, suspension and more!")
		
		self.OrderBoostButton:ChangeBackgroundColor(color(0.513, 0.247, 0.635, 1), color(0.513 + 0.5, 0.247 + 0.5, 0.635 + 0.5, 1))
		
		--self.GotoGarageButton:Disable()
		self.GotoGarageButton.OnReleased = function()
			--self:Goto(Garage)
			
			local CarButton = self.Items_GameModes:GetSelection()
			if (CarButton.Car ~= nil) then
				self:Goto(Garage_Viewer, CarButton.Car)
			end
		end
		
		-- Add back button
		self.TotalBackButtons = 0
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			print("^3CarSelect ^7> ^2MainMenu")
			
			self.BackButton.OnReleased = nil
			self:Goto(GameModeSelect)
			WriteGameSettings()
		end
		
		self.TotalProceedButtons = 0
		
		-- Add proceed button
		self.Items.ProceedButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonProceed.dcMenu", "menu_play"))
		self.TotalProceedButtons = self.TotalProceedButtons + 1
		table.insert(self.MenuDelItem_Queue, self.Items.ProceedButton)
		self.Items.ProceedButton.OnReleased = function()
			
		end
		self.Items.ProceedButton:ChangeBackgroundColor(color(0.513, 0.247, 0.635, 1), color(0.513 + 0.5, 0.247 + 0.5, 0.635 + 0.5, 1))
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items
		local ButtonOffset = 0
		local ButtonSpace = 0 -- op de y as
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items_GameModes:Format(ALIGN_WE, 0, 0, 64, 0, Right, Center, Right, Center, 0, self.TotalCarButtons)
		
		--self.TotalNormalButtons = 0
		
		self.GotoGarageButton:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, -50, Left, Center, Right, Center + 0.25)
		self.GotoGarageButton:FormatTween(ALIGN_NS, 22, 0, 0, -50, Right, Center, Right, Center + 0.25)
		
		self.OrderBoostButton:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 50, Left, Center, Right, Center - 0.05)
		self.OrderBoostButton:FormatTween(ALIGN_NS, 22, 0, 0, 50, Right, Center, Right, Center - 0.05)
		
		
		--self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 50, Left, Center, Right, Center, 0, self.TotalNormalButtons)
		--self.Items:FormatTween(ALIGN_NS, -65, 0, 0, 50, Center, Center, 0.65, Center, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		--self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Center, Top, Center, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + 1)
		--self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Center, Top, Center, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + 1)
		
		self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
		--self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
		self:ShowProceedButton()
		
		
		local ItemsPanel = self.ItemsPanel
		--local ClickArea = self.Menu:GetChild("ClickArea")
		local ClickArea = ActiveForeground.Menu:GetChild("OverlayItemList"):GetChild("ClickArea")
		local ButtonSize = 256 + 64
		local ListSpace = SafeFrameWidth
		local ChangedFunc = function(NewActive)
			
			GameThread:Spawn(function()
				--self:UpdateArrows((not self.Items_GameModes:OnTop()), (not self.Items_GameModes:OnBottom()))
				
				local x,y = ItemsPanel:GetPos()
				local width,height = ClickArea:GetSize()
				local width = 4800
				--local width = ListSpace
				local Perc = (-x) / width
				--print(Perc)
				--print(ItemsPanel:GetPos())
				
				--<Size x="256" y="460"/>
				
				for i, Element in ipairs(self.Items_GameModes.Items) do
					--if (i == 2) then
						local ItemPosX, ItemPosY = Element.Item:GetPos()
						
						--print(ItemPosX)
						--print(x)
						
						local ItemRealPosX = (x + ItemPosX)
						--print(ItemRealPosX)
						
						
						if (ItemRealPosX > 0) then
							--Wordt steeds onzichtbaarder
							
							--if (i == 2) then
								local ExtraAlpha = ClampMin(Lerp(1, 0, ((ItemRealPosX) / 320)), 0)
								--print(ExtraAlpha)
								
								Element.Item:SetAlpha(ExtraAlpha)
							--end
							
							
							--Element.Item:SetColor(Invisible)
							
							local ExtraWidth = 128 * 1
							local ExtraHeight = 230 * 1
							--Element.Item:SetSize(256 + 64 + ExtraWidth, 460 + ExtraHeight)
							
							Element:Scale(0.4)
							
						else
							Element.Item:SetColor(White)
							
							--Wordt steeds kleiner
							
							-- -640 = kleinste
							-- 0 = grootste
							
							local ExtraSize = ClampMin(Lerp(1, 0, ((-ItemRealPosX) / 640)), 0)
							--print(ExtraSize)
							
							local ExtraWidth = 128 * ExtraSize
							local ExtraHeight = 230 * ExtraSize
							
							--Element.Item:SetSize(256 + 64 + ExtraWidth, 460 + ExtraHeight)
							
							
							Element:Scale(ExtraSize * 0.4)
							
						end
						
					--end
					
					--Element.Item:SetSize(256, 460)
					
					--if (i > NewActive + 1) then
						--Element.Item:SetColor(Invisible)
					--else
						--Element.Item:SetColor(White)
					--end
				end
			end)
		end
		
		local StartedFunc = function(NewActive)
			if (self.ShowButtonsThread ~= nil) then
				GameThread:Stop(self.ShowButtonsThread)
			end
			
			self.Items:FormatTween(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
			
			--self.OrderBoostButton:FormatTween(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Center, Right, Center)
			self.OrderBoostButton:FormatTween(ALIGN_NS, SafeFrameOffsetX, 0, 0, 50, Left, Center, Right, Center - 0.05)
			
			--self.GotoGarageButton:Disable()
		end
		
		local StoppedFunc = function(NewActive)
			--print(NewActive)
			
			self:UpdateSideButtons()
			
			if (NewActive ~= nil) then
				CarSelect_ItemListActive = NewActive
			
				--print(self.Items_GameModes.Items[NewActive + 1].Item)
				
				--self.Items_GameModes.Items[NewActive + 1].Item:SetSize(350, 650)
				
				local CarButton = self.Items_GameModes:GetSelection()
				if (CarButton.Car ~= nil) then
					ActiveMission.CarManager:SaveCarSelection(CarButton.Car)
					
					ActiveForeground:SetCarName(ActiveGameMode:GetSelectedCar().Name, ActiveGameMode:GetSelectedCar().TierNumber)
				end
			end
			
			self.ShowButtonsThread = GameThread:Spawn(function()
				
				--self:UpdateSideButtons()
				
				GameThread:Wait(0.4)
				
				self:ShowProceedButton()
				
				--self.OrderBoostButton:FormatTween(ALIGN_NS, 0, 0, 0, 0, Right, Center, Right, Center)
				if (self.OrderBoostButton.Enabled) then
					self.OrderBoostButton:FormatTween(ALIGN_NS, 22, 0, 0, 50, Right, Center, Right, Center - 0.05)
				end
				
				self.ShowButtonsThread = nil
			end)
		end
		
		self.Items_GameModes:EnableSliding(ItemsPanel, ClickArea, ButtonSize, ListSpace, true, StartedFunc, StoppedFunc, ChangedFunc, true)
		
		--self.Items_GameModes:SetSelection(self.Items_GameModes.Items[self.Items_GameModes.Active + 1])
		--self.Items_GameModes:SetSelection(self.Items_GameModes.Items[1])
		
		self.Items_GameModes:SnapSliding(true)
		
		GameThread:Spawn(function()
			--local x,y = ItemsPanel:GetPos()
			--print("sss", x)
			--ChangedFunc(self.Items_GameModes.Active)
			--GameThread:Wait(1)
			--local x,y = ItemsPanel:GetPos()
			--print("sss", x)
			--ChangedFunc(self.Items_GameModes.Active)
			--StoppedFunc(self.Items_GameModes.Active)
		end)
		
		--Add KeyListeners
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				self:Goto(GameModeSelect)
				WriteGameSettings()
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.Items_GameModes:GetSelection() ~= nil) then
					self.Items_GameModes:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		--playsound("GameMode_GameMode.wav")
		
		
		GameThread:Spawn(function()
			if (not FirstPlayOffer) then
				FirstPlayOffer = true
				local FreeCoins = 7000
				ShowConfirm_Intro(FreeCoins)
			end
		end)
	
	end)
end)

function CarSelect:Goto(Target, Car)
	self.Items_GameModes:DisableSliding()
	
	ActiveMenu = Target(CarSelect, Car)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function CarSelect:Active()
	return ActiveMenu == self
end

function CarSelect:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = CarSelect(PreviousMenu)
end

function CarSelect:ShowMenu()
	GameThread:Spawn(function()
		self:UpdateCarButtons()
		self:UpdateSideButtons()
		self:ShowProceedButton()
	end)
	
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function CarSelect:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function CarSelect:DeleteButtons()
	ActiveForeground.Menu:GetChild("OverlayItemList"):GetChild("Items"):Clear()
	
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
		self.MenuDelItem_Queue = {}
	end)
end

function CarSelect:Back()
	self:Goto(GameModeSelect)
end

-- ==========================================
-- Custom functions below here
-- ==========================================
function CarSelect:UpdateCarButtons()
	if (self.Items_GameModes ~= nil) then
		for i, Element in ipairs(self.Items_GameModes.Items) do
			Element:Update()
		end
	end
end

function CarSelect:UpdateSideButtons()
	self.Items.ProceedButton.OnReleased = nil

	self.OrderBoostButton:Enable()
	self.OrderBoostButton:ChangeBackgroundColor(color(0.513, 0.247, 0.635, 1), color(0.513 + 0.5, 0.247 + 0.5, 0.635 + 0.5, 1))
	
	if (self.Items_GameModes ~= nil) then
		--print("CarSelect:UpdateSideButtons", self.Items_GameModes.Active)
		local CarButton = self.Items_GameModes:GetSelection()
		if (CarButton ~= nil and CarButton.Car ~= nil) then
			if (CarButton.Car.Bought) then
				if (CarButton.Car.Available) then
					self.GotoGarageButton:Enable()
					
					ActiveMission.CarManager:SaveCarSelection(CarButton.Car)
					
					
					-- =============
					--Calc UpgradeCost
					local LowestCurrentLevel = 9999
					local LowestBoughtLevel = 9999
					local LowestDeliveryLevel = 9999
					local LowestDeliveryTime = 999999999999
					for i, Upgrade in pairs(CarButton.Car.Upgrades) do
						LowestCurrentLevel = Min(LowestCurrentLevel, Upgrade.CurrentLevel)
						LowestBoughtLevel = Min(LowestBoughtLevel, Upgrade.BoughtLevel)
						LowestDeliveryLevel = Min(LowestDeliveryLevel, Upgrade.DeliveryLevel)
						LowestDeliveryTime = Min(LowestDeliveryTime, Upgrade.DeliveryTime)
					end
					--print("LowestCurrentLevel", LowestCurrentLevel)
					--print("LowestBoughtLevel", LowestBoughtLevel)
					--print("LowestDeliveryLevel", LowestDeliveryLevel)
					--print("LowestDeliveryTime", LowestDeliveryTime)
					
					
					local TotalCoinsPrice = 0
					local TotalGearsPrice = 0
					if (LowestDeliveryLevel ~= LowestBoughtLevel) then
						--Buy upgrade
						print("Buy upgrade")
						
						for i, Upgrade in pairs(CarButton.Car.Upgrades) do
							if (Upgrade.BoughtLevel <= LowestBoughtLevel) then
								
								for j, ShopUpgradeItem in ipairs(ShopUpgradeItems) do
									if (ShopUpgradeItem.Name == i) then
										--print(ShopUpgradeItem.Name, i)
										local CoinsPrice = ShopUpgradeItem:GetPrice(CarButton.Car)
										if (CoinsPrice ~= nil) then
											TotalCoinsPrice = TotalCoinsPrice + CoinsPrice
										end
										
										local GearsPrice = ShopUpgradeItem:GetGoloPrice(CarButton.Car)
										if (GearsPrice ~= nil) then
											TotalGearsPrice = TotalGearsPrice + GearsPrice
										end
									end
								end
							end
						end
					else
						--Buy upgrade delivery
						print("Buy upgrade delivery")
						
						for i, Upgrade in pairs(CarButton.Car.Upgrades) do
							if (Upgrade.BoughtLevel <= LowestCurrentLevel) then
								
								for j, ShopUpgradeItem in ipairs(ShopUpgradeItems) do
									if (ShopUpgradeItem.Name == i) then
										--print(ShopUpgradeItem.Name, i)
										--local CoinsPrice = ShopUpgradeItem:GetPrice(CarButton.Car)
										--if (CoinsPrice ~= nil) then
											--TotalCoinsPrice = TotalCoinsPrice + CoinsPrice
										--end
										
										local GearsPrice = ShopUpgradeItem:GetDeliveryGoloPrice(CarButton.Car)
										if (GearsPrice ~= nil) then
											TotalGearsPrice = TotalGearsPrice + GearsPrice
										end
									end
								end
							end
						end
						
						--- timer
						local DeliveryTime = LowestDeliveryTime
						
						if (self.DeliveryClockThread ~= nil) then
							GameThread:Stop(self.DeliveryClockThread)
						end
						
						self.DeliveryClockThread = GameThread:Spawn(function()
							local CurrentTime = os.time()
							local WaitTime = DeliveryTime - CurrentTime
							
							print(FormatTimeShort(WaitTime))
							
							while (WaitTime > 0) do
								CurrentTime = os.time()
								WaitTime = DeliveryTime - CurrentTime
								
								--self.DeliverTimeValue:SetText(FormatTimeShort(WaitTime))
								self.OrderBoostButton.Item:GetChild("DeliverTimerPanel"):GetChild("DeliverTimeValue"):SetText(FormatTimeShort(WaitTime))
								self.OrderBoostButton.Item:GetChild("DeliverTimerPanel"):GetChild("DeliverTimeValueFlash"):SetText(FormatTimeShort(WaitTime))
								
								GameThread:Wait(1)
							end
							
							if (ActiveMenu.ShowMenu ~= nil) then
								--ActiveMenu:ShowMenu()
							end
							
							self.DeliveryClockThread = nil
						end)
					end
					-- =============
					--if (TotalCoinsPrice == 0 and TotalGearsPrice == 0) then
					if (LowestCurrentLevel >= 6 and CarButton.Car.MechanicActiveRaces > 0) then
						self.OrderBoostButton:Disable()
						self.OrderBoostButton:FormatTween(ALIGN_NS, SafeFrameOffsetX, 0, 0, 50, Left, Center, Right, Center - 0.05)
					end
					
					if (LowestCurrentLevel >= 6) then
						
						self.OrderBoostButton.Item:GetChild("Name"):SetText(Translate("carselect_mechanic_name"))
						self.OrderBoostButton.Item:GetChild("NameFlash"):SetText(Translate("carselect_mechanic_name"))
						self.OrderBoostButton.Item:GetChild("Description"):SetText(Translate("carselect_mechanic_description"))
						self.OrderBoostButton.Item:GetChild("BoostPricePanel"):SetAlpha(0)
						--self.OrderBoostButton.Item:GetChild("BoostPricePanel"):GetChild("CoinsPrice"):SetText(TotalCoinsPrice)
						self.OrderBoostButton.Item:GetChild("DeliverTimerPanel"):SetAlpha(0)
						
						self.OrderBoostButton:ChangeBackgroundColor(color(1, 0.75, 0.25, 1), color(2, 1.75, 1.25, 1))
						
						self.OrderBoostButton.OnReleased = function()
							--ShowConfirm_UpgradeItemPackNotAvailable(CarButton.Car)
							ShowConfirm_Mechanic(1, CarButton.Car)
						end
						
					else
					
						self.OrderBoostButton.Item:GetChild("Name"):SetText(Translate("carselect_boost_name"))
						self.OrderBoostButton.Item:GetChild("NameFlash"):SetText(Translate("carselect_boost_name"))
						if (LowestDeliveryLevel ~= LowestBoughtLevel) then
							self.OrderBoostButton.Item:GetChild("Description"):SetText(Translate("carselect_boost_description"))
							self.OrderBoostButton.Item:GetChild("BoostPricePanel"):SetAlpha(1)
							self.OrderBoostButton.Item:GetChild("BoostPricePanel"):GetChild("CoinsPrice"):SetText(TotalCoinsPrice)
							self.OrderBoostButton.Item:GetChild("DeliverTimerPanel"):SetAlpha(0)
							
							self.OrderBoostButton.OnReleased = function()
								ShowConfirm_BuyUpgradeItemPack(CarButton.Car)
							end
						else
							self.OrderBoostButton.Item:GetChild("Description"):SetText(Translate("carselect_boost_description_deliver"))
							self.OrderBoostButton.Item:GetChild("BoostPricePanel"):SetAlpha(0)
							self.OrderBoostButton.Item:GetChild("BoostPricePanel"):GetChild("CoinsPrice"):SetText(TotalCoinsPrice)
							self.OrderBoostButton.Item:GetChild("DeliverTimerPanel"):SetAlpha(1)
							
							self.OrderBoostButton.OnReleased = function()
								ShowConfirm_UpgradeItemPackNotAvailable(CarButton.Car)
							end
						end
					end
					
					
					self.Items.ProceedButton.OnReleased = function()
						if (FuelEnergy:IsPowerAvailable() or DebugUnlockAll) then
							local SelectedCar = ActiveGameMode:GetSelectedCar()
							
							if (SelectedCar ~= nil) then
								local StartFunc = function() 
									self.Items.ProceedButton.OnReleased = nil
									self:HideMenu()
									self:DeleteButtons()
									ActiveForeground = ForegroundMenu(FOREGROUNDSTATE_LOADING)
									
									GameThread:Spawn(function()
										GameThread:Wait(0.5)	-- waarom wachten we per defintie 0.5 seconde?
										
										--while (not ActiveMission.CarManager.CarLoaded) do
											--GameThread:Wait(0.01)
										--end
										
										GameThread:Destroy()
										ActiveMenu = nil
										ClearMenuStack()
										UnloadMenuTextures()
										
										SelectedCar.DriveCount = Inc(SelectedCar.DriveCount)
										WriteGameSettings()
										
										AnalyticsSendScreenName(ActiveGameMode.Name)
										
										ActiveGameMode:StartRace(ActiveGameMode.ActiveChapter.ActiveRace.Name, SelectedCar.Name, "")
									end)
								end
								
								StartFunc()
							end
						else
							-- hier melding geven dat men geen power heeft
							ShowConfirm_Refuel()
						end
					end
				else
					self.OrderBoostButton.Item:GetChild("Name"):SetText(Translate("carselect_delivercar_name"))
					self.OrderBoostButton.Item:GetChild("NameFlash"):SetText(Translate("carselect_delivercar_name"))
					self.OrderBoostButton.Item:GetChild("Description"):SetText(Translate("carselect_delivercar_description"))
					self.OrderBoostButton.Item:GetChild("BoostPricePanel"):SetAlpha(0)
					self.OrderBoostButton.Item:GetChild("DeliverTimerPanel"):SetAlpha(0)
					self.OrderBoostButton.Item:GetChild("Name"):SetFont("ArialBlack40")
					
					self.OrderBoostButton.OnReleased = function()
						ShowConfirm_CarNotAvailable(CarButton.Car)
					end
					
					self.Items.ProceedButton.OnReleased = function()
						--
					end
				end
			else
				local CarName = Translate(CarButton.Car.Name.."_Name")
				self.OrderBoostButton.Item:GetChild("Name"):SetText(Translate("carselect_buycar_name"))
				self.OrderBoostButton.Item:GetChild("NameFlash"):SetText(Translate("carselect_buycar_name"))
				self.OrderBoostButton.Item:GetChild("Description"):SetText(string.format(Translate("carselect_buycar_description"), CarName))
				self.OrderBoostButton.Item:GetChild("BoostPricePanel"):SetAlpha(0)
				self.OrderBoostButton.Item:GetChild("DeliverTimerPanel"):SetAlpha(0)
				
				self.OrderBoostButton.OnReleased = function()
					ShowConfirm_BuyCar_Choice(CarButton.Car)
				end
				
				self.Items.ProceedButton.OnReleased = function()
					--
				end
			end
		end
	end
end

function CarSelect:AddArrows(ItemList)	
	self.ItemsArrows:Clear()

	self.ArrowUpButtonItem = MenuElements.Label(nil, "Elements\\CoinShop_LeftArrow.dcMenu", "button_back")
	self.ItemsArrows:AddItem(self.ArrowUpButtonItem.Item)
	
	self.ArrowUpButtonItem.Item:SetColorImmediate(Invisible)
	self.ArrowUpButtonItem.Selectable = false

	self.ArrowDownButtonItem = MenuElements.Label(nil, "Elements\\CoinShop_RightArrow.dcMenu", "button_back")
	self.ItemsArrows:AddItem(self.ArrowDownButtonItem.Item)
	
	self.ArrowDownButtonItem.Item:SetColorImmediate(Invisible)
	self.ArrowDownButtonItem.Selectable = false	
end

function CarSelect:UpdateArrows(UpArrow_Visible, DownArrow_Visible)
	if (self.ArrowUpButtonItem == nil or self.ArrowDownButtonItem == nil) then
		self:AddArrows(nil)
	end

	if (self.ArrowUpButtonItem ~= nil) then
		self.ArrowUpButtonItem.Item:SetColorFade(1, 10)
		if (UpArrow_Visible) then
			self.ArrowUpButtonItem.Item:SetColor(White)
		else
			self.ArrowUpButtonItem.Item:SetColor(Invisible)
		end
	end
	
	if (self.ArrowDownButtonItem ~= nil) then
		self.ArrowDownButtonItem.Item:SetColorFade(1, 10)
		if (DownArrow_Visible) then
			self.ArrowDownButtonItem.Item:SetColor(White)
		else
			self.ArrowDownButtonItem.Item:SetColor(Invisible)
		end
	end
end

function CarSelect:ShowProceedButton()
	local CarButton = self.Items_GameModes:GetSelection()
	if (CarButton ~= nil and CarButton.Car ~= nil) then
		if (CarButton.Car.Bought) then
			if (CarButton.Car.Available) then
				self.Items.ProceedButton:SetText(Translate("menu_play"))
				self.Items:FormatTween(ALIGN_NS, 0, 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
			else
				--self.Items.ProceedButton:SetText(Translate("button_deliverNow"))
			end
		else
			--self.Items.ProceedButton:SetText(Translate("menu_order"))
		end
	end

	--self.Items:FormatTween(ALIGN_NS, 0, 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
end