CoinShop = class(function(self, PreviousMenu, ParentPreviousMenu)
	self.PreviousMenu = PreviousMenu
	self.ParentPreviousMenu = ParentPreviousMenu
	
	CheckOnlineProgress()
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenu("CoinShopMenu")
	
	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")
	
	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	--
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	
	--Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()
	
	-- Panels leegmaken en lijst aanmaken
	ActiveForeground:HideInfoText()
	self.Items = NewItemList(self, nil, nil)
	self.ItemsProducts = NewItemList(self, LeftButtons, RightButtons)
	self.ItemsProducts.Wrapping = false
	self.ItemsPanel = self.Menu:GetChild("Items")
	self.ItemsPanel:Clear()
	
	self.ItemsArrows = self.Menu:GetChild("ItemsArrows")
	
	self.ButtonTemplate = "Elements\\MenuButton.dcMenu"
	
	-- Add Normal buttons
	self.TotalNormalButtons = 0
	
	---hier butts maken
	local RedeemEnabled = false --GetRedeemData("Enabled")
	local PriceRatio = nil
	
	for i, CoinProduct in ipairs(VirtualCoins.CoinProducts) do
		local Name = NumberCommas(CoinProduct.CoinsAmount) .. " " .. Translate("menu_coins")
		local Name2 = "+ "..CoinProduct.GoloCoinsAmount .. " " .. Translate("menu_freegolocoins")
		
		if (CoinProduct.CoinsAmount == 1) then
			Name = CoinProduct.CoinsAmount .. " " .. Translate("menu_coin")
		end
				
		if (CoinProduct.GoloCoinsAmount == 1) then
			Name2 = "+ "..CoinProduct.GoloCoinsAmount .. " " .. Translate("menu_golocoin")
		elseif (CoinProduct.GoloCoinsAmount < 1) then
			Name2 = ""
		end
		
		--Get real ProductPrice
		local ProductPrice = CoinProduct.ShopPrice
		local ValutaStr = "USD"
		--local ValutaStr = Translate("valuta_dollar")
		--local ValutaStr = ProductPrice --Translate("valuta_euro")
		for j, StoreProduct in ipairs(StoreProducts) do
			if (CoinProduct.ShopID == StoreProduct.ID) then
				--[[ local StoreProduct = {}
				StoreProduct.Price = "EUR 11,22" ]]
				--ValutaStr = StoreProduct.Price
				
				--print(type(StoreProduct.Price))
				
				local SpaceLoc = string.find(StoreProduct.Price, " ")
				if (SpaceLoc ~= nil and SpaceLoc > 0) then
					--ValutaStr = string.sub(StoreProduct.Price, 0, SpaceLoc - 1)
					ProductPrice = string.sub(StoreProduct.Price, SpaceLoc + 1)
					ProductPrice = string.gsub(ProductPrice, ",", ".")
					ProductPrice = tonumber(ProductPrice)
				elseif (type(StoreProduct.Price) == "string") then
					local SpaceLoc = string.find(StoreProduct.Price, "%d+")
					--ValutaStr = string.sub(StoreProduct.Price, 0, SpaceLoc - 1)
					ProductPrice = string.sub(StoreProduct.Price, SpaceLoc)
					ProductPrice = string.gsub(ProductPrice, ",", ".")
				else
					--ValutaStr = ""
					ProductPrice = StoreProduct.Price
				end
			end
		end
		
		local LabelCoin = MenuElements.LabelCoin(self.ItemsProducts, "Elements\\BuyCoins_TemplateBig.dcMenu", Name, ValutaStr, ProductPrice, CoinProduct.Texture, Name2)
		local Item = self.ItemsProducts:AddItem(self.ItemsPanel, LabelCoin)
		Item.OnReleased = function()
			self:DisableCoinButtons()
			TempShopItem = CoinProduct
			
			--BuyProduct("android.test.purchased")
			--print("We gaan " .. CoinProduct.ShopID .. " kopen")
			BuyProduct(CoinProduct.ShopID)
		end
		
		if (type(ProductPrice) == "string") then
			local SpaceLoc = string.find(ProductPrice, "%d+")
			ProductPrice = string.sub(ProductPrice, SpaceLoc)
			ProductPrice = string.gsub(ProductPrice, ",", ".")
			ProductPrice = tonumber(ProductPrice)
		end
		
		if (type(ProductPrice) == "number") then
			if (PriceRatio == nil) then
				PriceRatio = ProductPrice / CoinProduct.CoinsAmount
			else
				local CurrentPriceRatio = ProductPrice / CoinProduct.CoinsAmount
				local Rate = 100 - (100 * CurrentPriceRatio) / PriceRatio
				Rate = math.ceil(Rate)
				
				if (Rate > 0) then
					local Discount = tostring(Rate) .. "%"
					local DiscountStr = string.format(Translate("menu_discount"), Discount)
					Item:SetDiscountText(DiscountStr)
					
					GameThread:Spawn(function()
						Item.NameItem2_Flash:SetText(Name2)
						while(true) do
							GameThread:Sleep(0.2)
							Item.NameItem2:SetColor(color(236 / 255,197/255,33/255,1))
							Item.NameItem2_Flash:SetColor(Invisible)
							GameThread:Sleep(2.5)
							Item.NameItem2:SetColor(color(236 / 255,197/255,33/255,1))
							Item.NameItem2_Flash:SetColor(color(236 / 255,197/255,33/255,0.7))
						end
					end)
				end
			end
		else
			print("ProductPrice is not a number")
		end
	end	
	
	self.TotalNormalButtons = #self.ItemsProducts.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	
	-- Add back button
	self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	self.TotalBackButtons = self.TotalBackButtons + 1
	table.insert(self.MenuDelItem_Queue, self.BackButton)
	self.BackButton.OnReleased = function()
		self.BackButton.OnReleased = nil
		if (self.PreviousMenu ~= nil) then
			self:Goto(self.PreviousMenu)
		else
			self:Goto(MainMenu)
		end
	end
	
	
	-- Settings voor formatting
	self.TotalListButtons = #self.ItemsProducts.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 16
	local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	-- Format normal buttons
	--self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
	--self.Items:Format(ALIGN_NS, 0, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
	
	-- Format normal buttons in columns and rows
	--[[ local ItemHeight = 72
	local ItemOffsetY = 4
	local Columns = 2
	local ItemCount = self.TotalNormalButtons --#self.Items.Items
	if (ItemCount % 2) ~= 0 then
		ItemCount = ItemCount - 1
	end
	local Rows = ItemCount / Columns
	local Y = 0
	for i = 1, Rows do
		local Start = (i - 1) * Columns
		local End = ((i * Columns) - 1)
		Y = (i - 1) * (ItemHeight + ItemOffsetY)
		
		self.Items:Format(ALIGN_WE, -SafeFrameOffsetX, Y, 10, 0, Right, Top, Left, Top, Start, End)
		self.Items:Format(ALIGN_WE, SafeFrameOffsetX, Y, 10, 0, Left, Top, Right, Top, Start + 1, End + 1)
		
		self.Items:FormatTween(ALIGN_WE, -2, Y, 10, 0, Right, Top, Center, Top, Start, End)
		self.Items:FormatTween(ALIGN_WE, 2, Y, 10, 0, Left, Top, Center, Top, Start + 1, End + 1)
	end
	Y = Y + (ItemHeight + ItemOffsetY)
	if (self.TotalNormalButtons % 2) ~= 0 then
		self.Items:Format(ALIGN_NS, 0, Y, 0, 0, Center, 0, Center, Bottom, ItemCount, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0, Y, 0, 0, Center, 0, Center, 0, ItemCount, self.TotalNormalButtons)
	end ]]
	
	self.ItemsProducts:Format(ALIGN_WE, 32, 0, ButtonSpace, 0, Left, Center, Left, Center, 0, self.TotalNormalButtons)
	self.ItemsProducts:FormatTween(ALIGN_WE, 32, 0, ButtonSpace, 0, Left, Center, Left, Center, 0, self.TotalNormalButtons)
	
	
	
	-- Format back button
	--self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
	--self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
	
	self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, 0, 1)
	self.Items:FormatTween(ALIGN_NS, 0, 0, 0, 0, Left, Top, Left, Top, 0, 1)
	
	self.Items:SetSelection(self.StartGame)
	
	
	
	--Enable sliding
	local ItemsPanel = self.ItemsPanel --self.Items.Panel
	local ClickArea = self.Menu:GetChild("ClickArea") --self.Main --self.CategoryPanel
	local ButtonSize = 360 + ButtonSpace
	local ListSpace = SafeFrameWidth --ActiveForeground:GetContentHeight()
	local ChangedFunc = function(NewActive)
		self:UpdateArrows((not self.ItemsProducts:OnTop()), (not self.ItemsProducts:OnBottom()))
	end
	self.ItemsProducts:EnableSliding(ItemsPanel, ClickArea, ButtonSize, ListSpace, true, nil, nil, ChangedFunc)
	
	
	--Add KeyListeners
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	self:UpdateCoincount()
	
	AddKeyListeners({"DCK_ENTER", "DCK_RETURN"}, "Down", function(Listeners)
		if (not self.ConfirmVisible) then
			if (self:Active()) then
				if (self.Items:GetSelection() ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end
	end)
end)

function CoinShop:Goto(Target)
	ActiveMenu = Target(CoinShop)
	ActiveMenu.PreviousMenu = ParentPreviousMenu
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function CoinShop:Active()
	return ActiveMenu == self
end

function CoinShop:Refresh()
	local PreviousMenu = self.PreviousMenu
	local ParentPreviousMenu = self.ParentPreviousMenu
	ActiveMenu = CoinShop()
	ActiveMenu.PreviousMenu = PreviousMenu
	ActiveMenu.ParentPreviousMenu = ParentPreviousMenu
end

function CoinShop:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function CoinShop:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function CoinShop:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function CoinShop:Back()
	if (self.PreviousMenu ~= nil) then
		self:Goto(self.PreviousMenu)
	else
		self:Goto(MainMenu)
	end
end

-- ==========================================
-- Custom functions below here
-- ==========================================

function CoinShop:BoughtProduct(ItemID)
	print(ItemID)
	self:EnableCoinButtons()
	self:UpdateCoincount()
end

function CoinShop:PaymentCancelled()
	self:EnableCoinButtons()
	self:UpdateCoincount()
end

function CoinShop:GainedFocus()
	self:EnableCoinButtons()
end

function CoinShop:OnUpdateTapPoints()
	self:EnableCoinButtons()
	self:UpdateCoincount()
end

function CoinShop:UpdateCoincount()
	if (ActiveForeground ~= nil and ActiveForeground.UpdateCoincount ~= nil) then
		ActiveForeground:UpdateCoincount()
	end
end

function CoinShop:EnableCoinButtons()
	--for i = 1, #self.Items.Items do
	for i = 1, self.TotalNormalButtons do
		self.ItemsProducts.Items[i].Enabled = true
	end
end

function CoinShop:DisableCoinButtons()
	--for i = 1, #self.Items.Items do
	for i = 1, self.TotalNormalButtons do
		self.ItemsProducts.Items[i]:Deactivate()
		self.ItemsProducts.Items[i].Enabled = false
	end
end

function CoinShop:AddArrows(ItemList)
	--print("AddArrows: " .. tostring(self.CategoryPanel:GetItemCount()))
	
	self.ItemsArrows:Clear()

	--if (self.ArrowUpButtonItem == nil) then
		self.ArrowUpButtonItem = MenuElements.Label(nil, "Elements\\CoinShop_LeftArrow.dcMenu", "button_back")
		self.ItemsArrows:AddItem(self.ArrowUpButtonItem.Item)
		
		self.ArrowUpButtonItem.Item:SetColorImmediate(Invisible)
		self.ArrowUpButtonItem.Selectable = false
	--end
	
	--if (self.ArrowDownButtonItem == nil) then
		self.ArrowDownButtonItem = MenuElements.Label(nil, "Elements\\CoinShop_RightArrow.dcMenu", "button_back")
		self.ItemsArrows:AddItem(self.ArrowDownButtonItem.Item)
		
		self.ArrowDownButtonItem.Item:SetColorImmediate(Invisible)
		self.ArrowDownButtonItem.Selectable = false
	--end
	
end

function CoinShop:UpdateArrows(UpArrow_Visible, DownArrow_Visible)
	if (self.ArrowUpButtonItem == nil or self.ArrowDownButtonItem == nil) then
		self:AddArrows(nil)
	end

	if (self.ArrowUpButtonItem ~= nil) then
		self.ArrowUpButtonItem.Item:SetColorFade(1, 10)
		if (UpArrow_Visible) then
			self.ArrowUpButtonItem.Item:SetColor(White)
		else
			self.ArrowUpButtonItem.Item:SetColor(Invisible)
		end
	end
	
	if (self.ArrowDownButtonItem ~= nil) then
		self.ArrowDownButtonItem.Item:SetColorFade(1, 10)
		if (DownArrow_Visible) then
			self.ArrowDownButtonItem.Item:SetColor(White)
		else
			self.ArrowDownButtonItem.Item:SetColor(Invisible)
		end
	end
end