CoinTypeSelect = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	CheckOnlineProgress()
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenu("CoinTypeSelect")

	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")

	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	--
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	
	--Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()
	
	-- Panels leegmaken en lijst aanmaken
	ActiveForeground:HideInfoText()
	self.Items = NewItemList(self, UpButtons, DownButtons)
	self.ItemsPanel = self.Menu:GetChild("Items")
	self.ItemsPanel:Clear()
	
	--self.ButtonTemplate = "Elements\\MenuButton.dcMenu"
	self.ButtonTemplate = "Elements\\MenuButton_CoinType.dcMenu"
	
	
	-- Add Normal buttons
	self.TotalNormalButtons = 0

	self.CreditsButton = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "menu_golocoins"))
	self.CreditsButton.OnReleased = function()
		print("^3CoinTypeSelect ^7> ^2ExtraCredits")
		self.CreditsButton.OnReleased = nil
		self:Goto(CoinShop_Golo)
	end
	
	self.CreditsButton.Item:GetChild("GoloLogo"):SetColor(White)
	self.CreditsButton.Item:GetChild("FlatCoin"):SetColor(Invisible)
	
	self.AudioButton = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "menu_coins"))
	self.AudioButton.OnReleased = function()
		print("^3CoinTypeSelect ^7> ^2AudioOptions")
		self.AudioButton.OnReleased = nil
		self:Goto(CoinShop)
	end
	
	self.AudioButton.Item:GetChild("GoloLogo"):SetColor(Invisible)
	self.AudioButton.Item:GetChild("FlatCoin"):SetColor(White)
	
	self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	
	-- Add back button
	self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	self.TotalBackButtons = self.TotalBackButtons + 1
	table.insert(self.MenuDelItem_Queue, self.BackButton)
	self.BackButton.OnReleased = function()
		print("^3CoinTypeSelect ^7> ^2Mainmenu")
		self.BackButton.OnReleased = nil
		
		if (self.PreviousMenu ~= nil) then
			self:Goto(self.PreviousMenu)
		else
			self:Goto(MainMenu)
		end
	end
	
	
	-- Settings voor formatting
	self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 16
	local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	-- Format normal buttons
	--self.Items:Format(ALIGN_WE, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
	--self.Items:FormatTween(ALIGN_WE, 0, 0, ButtonSpace, 0, Left, 0, Left, 0, 0, self.TotalNormalButtons)
	
	local SpaceLeft = SafeFrameWidth - (350 * 2)
	local CenterSpace = SpaceLeft / 2
	
	self.Items:Format(ALIGN_WE, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, 1)
	self.Items:FormatTween(ALIGN_WE, -(CenterSpace / 2), 0, ButtonSpace, 0, Right, 0, Center, 0, 0, 1)
	
	self.Items:Format(ALIGN_EW, SafeFrameOffsetX, 0, 0, ButtonSpace, Left, 0, Right, 0, 1, 2)
	self.Items:FormatTween(ALIGN_EW, (CenterSpace / 2), 0, ButtonSpace, 0, Left, 0, Center, 0, 1, 2)
	
	-- Format back button
	self.Items:Format(ALIGN_WE, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
	self.Items:FormatTween(ALIGN_WE, 0, 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
	
	self.Items:SetSelection(self.AudioButton)
	
	--Add KeyListeners
	AddKeyListeners(BackButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.PreviousMenu ~= nil) then
				self:Goto(self.PreviousMenu)
			else
				self:Goto(MainMenu)
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
end)

function CoinTypeSelect:Goto(Target)
	--ActiveMenu = Target(CoinTypeSelect)
	ActiveMenu = Target(self.PreviousMenu)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function CoinTypeSelect:Active()
	return ActiveMenu == self
end

function CoinTypeSelect:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = CoinTypeSelect(PreviousMenu)
end

function CoinTypeSelect:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function CoinTypeSelect:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function CoinTypeSelect:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function CoinTypeSelect:Back()
	if (self.PreviousMenu ~= nil) then
		self:Goto(self.PreviousMenu)
	else
		self:Goto(MainMenu)
	end
end