ConfirmMenu = class(function(self, PreviousMenu, CreateCheckBox, DifferentMenuFile, DifferentYesTemplate, DifferentNoTemplate)
	if (DifferentMenuFile ~= nil) then
		self.MenuFile = DifferentMenuFile
	else
		self.MenuFile = "Confirm_Lowrider"
	end
		
	-- gooi menu er op
	--self.Menu = PushMenu("ConfirmMenu")
	self.Menu = PushMenu(self.MenuFile)
	self.PreviousMenu = PreviousMenu
	self.CreateCheckBox = CreateCheckBox
	if (self.PreviousMenu ~= nil) then
		if (self.PreviousMenu.HideMenu ~= nil) then
			self.PreviousMenu:HideMenu()
		end
	end
	if (self.CreateCheckBox == nil) then
		self.CreateCheckBox = false
	end

	--AnalyticsSendScreenName("ConfirmMenu")
	
	-- Pak het hoofdpanel en overige panels
	self.Main = self.Menu:GetChild("Main")
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	-- Fade in items
	self.Main:SetColorImmediate(Invisible)
	self.Main:SetColorFade(2, 10.0)
	self.Main:SetColor(White)
	
	-- Panels leegmaken en lijst aanmaken
	local Items = NewItemList(self, LeftButtons, RightButtons)
	self.Items = Items

	self.HeaderText = self.Menu:GetChild("Header_text")
	self.TextPanel = self.Menu:GetChild("Text")
	self.NoButtonPanel = self.Menu:GetChild("NoButton")
	self.YesButtonPanel = self.Menu:GetChild("YesButton")
	self.CheckboxButtonPanel = self.Menu:GetChild("CheckboxButton")
	
	self.CharacterImage = self.Menu:GetChild("Character_Image")
	self.CharacterText = self.Menu:GetChild("Character_Text")
	
	self.NoButtonPanel:Clear()
	self.YesButtonPanel:Clear()
		
	-- Items toevoegen
	
	if (DifferentYesTemplate ~= nil) then
		self.YesTemplate = DifferentYesTemplate
	else
		self.YesTemplate = "MenuButton_Small"
	end
	
	if (DifferentNoTemplate ~= nil) then
		self.NoTemplate = DifferentNoTemplate
	else
		self.NoTemplate = "MenuButton_Small"
	end
	
	--self.ProceedButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonProceed.dcMenu", "button_install"))
	--self.NoButton = Items:AddItem(self.NoButtonPanel, MenuElements.Label(Items, "Elements\\MenuButton_Small.dcMenu", "button_no"))
	--self.YesButton = Items:AddItem(self.YesButtonPanel, MenuElements.Label(Items, "Elements\\MenuButton_Small.dcMenu", "button_yes"))
	self.NoButton = Items:AddItem(self.NoButtonPanel, MenuElements.Label(Items, "Elements\\".. self.NoTemplate .. ".dcMenu", "button_no"))
	self.YesButton = Items:AddItem(self.YesButtonPanel, MenuElements.Label(Items, "Elements\\".. self.YesTemplate .. ".dcMenu", "button_yes"))
	self.YesButton:Flash(1, true, true, 0.5)
	
	if (self.CreateCheckBox) then
		self.CheckBoxButton = Items:AddItem(self.CheckboxButtonPanel, MenuElements.Checkbox(Items, "Elements\\MenuCheckbox.dcMenu", "button_fastDelivery", false))
	end
	
	self.Items:SetSelection(self.NoButton)
	
	local ButtonOffset = 9
	local TotalButtonOffset = #self.Items.Items * ButtonOffset
	
	self.Items:Format(ALIGN_NS, 0, 0, 0, -128, Center, Bottom, Center, Bottom, 0, #self.Items.Items)
	
	self.NoButton.OnReleased = function()
		self.NoButton.OnReleased = nil
		self.YesButton.OnReleased = nil
		if (self.CheckBoxButton ~= nil) then
			self.CheckBoxButton.OnReleased = nil
		end
		GameThread:Spawn(function()
			if (self.CancelAction ~= nil) then
				self:CancelAction(self:IsChecked())
			end
			
			--WriteGameSettings()
			self:HideMenu()
			GameThread:Wait(1)
		end)
	end
	
	self.YesButton.OnReleased = function()
		self.NoButton.OnReleased = nil
		self.YesButton.OnReleased = nil
		if (self.CheckBoxButton ~= nil) then
			self.CheckBoxButton.OnReleased = nil
		end
		GameThread:Spawn(function()
			if (self.ProceedAction ~= nil) then
				self:ProceedAction(self:IsChecked())
			end
			
			WriteGameSettings()
			self:HideMenu()
			GameThread:Wait(1)
		end)
	end
	
	self.Listeners_Back = AddKeyListeners(BackButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.NoButton.OnReleased ~= nil) then
				self.NoButton:OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	self.Listeners_Select = AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	self.CancelAction = nil
	self.ProceedAction = nil
end)

function ConfirmMenu:Goto(Target)
	--ActiveMenu = Target(ConfirmMenu)

	--self.Main:SetColor(Invisible)
end

function ConfirmMenu:Active()
	return ActiveMenu == self
end

function ConfirmMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = ConfirmMenu(PreviousMenu)
end

function ConfirmMenu:HideMenu()
	self.Main:SetColorImmediate(Invisible)
	--ClearKeyListeners()
	DelKeyListeners(self.Listeners_Back)
	DelKeyListeners(self.Listeners_Select)
	
	PopMenu(self.MenuFile)
	
	if (self.PreviousMenu ~= nil) then
		ActiveMenu = self.PreviousMenu
		
		if (ActiveMenu.Items ~= nil) then
			ActiveMenu.Items.Clicked = false
		end	
		
		if (ActiveMenu.Items_Categories ~= nil) then
			ActiveMenu.Items_Categories.Clicked = false
		end	
		
		if (ActiveMenu ~= nil) then
			if (ActiveMenu.ShowMenu ~= nil) then
				ActiveMenu:ShowMenu()
			end
		end
	end
end

function ConfirmMenu:SetTitle(Text)
	self.HeaderText:SetText(string.upper(Text))
end

function ConfirmMenu:SetText(Text)
	--self.TextPanel:SetText(string.upper(Text))
	self.TextPanel:SetText(Text)
end

function ConfirmMenu:SetCharacter(Image, Text)
	if (Image ~= nil) then
		self.CharacterImage:SetImage(Image)
	end
	self.CharacterText:SetText(Text)
end

function ConfirmMenu:SetCancelText(Text)
	self.NoButton:SetText(Text)
end

function ConfirmMenu:SetProceedText(Text)
	self.YesButton:SetText(Text)
end

function ConfirmMenu:SetCheckBoxText(Text)
	if (self.CheckBoxButton ~= nil) then
		self.CheckBoxButton:SetText(Text)
	end
end

function ConfirmMenu:IsChecked()
	if (self.CheckBoxButton ~= nil and self.CheckBoxButton.GetValue ~= nil) then
		return self.CheckBoxButton:GetValue()
	end
	
	return false
end