DailyMissionMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	AnalyticsSendScreenName("DailyMissionsMenu")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("DailyMission", nil, function()
	
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		
		self.DailyChallengeText = self.Menu:GetChild("Text_DailyChallenge")
		self.DailyChallengeName = self.Menu:GetChild("Text_ChallengeName")
		self.NextChallengeText = self.Menu:GetChild("Text_NextChallenge")
		self.DailyChallengeTime = self.Menu:GetChild("DailyChallengeTime")


		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		self.Items = NewItemList(self, UpButtons, DownButtons)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ButtonTemplate = "Elements\\MenuButton.dcMenu"

		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			--self:Goto(self.PreviousMenu)
			self:Goto(MainMenu)
		end
		
		self:LoadMissions()
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		self.Items:SetSelection(self.FreeGoodsLikeDevButton)
		
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				--self:Goto(self.PreviousMenu)
				self:Goto(MainMenu)
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		self:SetDailyMission()
		
		GameThread:Spawn(function()
			while (self:Active()) do
				self:SetDailyMission()
				GameThread:Wait(1)
			end
		end)
	end)
end)

function DailyMissionMenu:LoadMissions()
	
	self.DailyMissionItemsPanel = self.Menu:GetChild("DailyMissionItemsPanel")
	self.DailyMissionItemsPanel:Clear()
	self.DailyMissionItems = NewItemList(self, nil, nil)
	
	local Day = 1
	local i = 1
	
	while (Day <= 5) do
		
		local Mission = DailyMissionsManager.DailyMissions[i]
		
		if (Mission.Day == Day) then
			print("Found day! i = ^2" .. i .. " ^7day = ^2" .. Day .. "^5Mission achieved = ^2 ", Mission.Achieved)
			self.DailyMissionItems:AddItem(self.DailyMissionItemsPanel, MenuElements.DailyMission(self.Items, "elements\\DailyMission_Template.dcMenu", Mission, Day))
			Day = Inc(Day)
			i = 1
		end
		
		i = Inc(i)
		
		if(i >= #DailyMissionsManager.DailyMissions) then
			print("Couldn't find days breaking search")
			break
		end
	end
	
	--for i = 1, 5 do
--		self.DailyMissionItems:AddItem(self.DailyMissionItemsPanel, MenuElements.DailyMission(self.Items, "elements\\DailyMission_Template.dcMenu", DailyMissionsManager.DailyMissions[i], i))
--	end
	
	self.DailyMissionItems:Format(ALIGN_WE, 0, 0, 8, 0, Left, Top, Left, Top, 0)
	WriteGameSettings()
end

function DailyMissionMenu:ValidateMenuLabels()
	self:LoadMissions()
end

function DailyMissionMenu:Goto(Target)
	ActiveMenu = Target(DailyMissionMenu)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function DailyMissionMenu:Active()
	return ActiveMenu == self
end

function DailyMissionMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = DailyMissionMenu(PreviousMenu)
end

function DailyMissionMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function DailyMissionMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function DailyMissionMenu:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function DailyMissionMenu:Back()
	self:Goto(MainMenu)
end

function DailyMissionMenu:SetDailyMission()
	self.DailyChallengeName:SetText(translate(self.DailyMissionItems.Items[DailyMissionsManager.CurrentMission].Name))--translate("Challenge_1"))
	self.NextChallengeText:SetText(translate("menu_NextChallenge"))
	self.DailyChallengeTime:SetText(DailyMissionsManager:GetDailyChallengeTime())
end