DailyRewardsMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	self.TotalDays = 20	--Setting
	
	GetServerTime("FullDate", function(Data)
		ServerTime = Data
		ServerTimeDiff = os.time() - Data
		if (ServerTimeDiff < -(60 * 60 * 24)) then
			ServerTimeDiff = 0
		end
		
		if (LastTimeReward == nil or (LastTimeReward + 86400 < Data) ) then
			local RewardStatus = nil
			if (LastTimeReward == nil or (LastTimeReward + 86400 > Data - 86400) or DayCounter == 0) then	-- 1 day
				LastTimeReward = Data
				DayCounter = Mod(DayCounter, self.TotalDays)	--Reset total days
				DayCounter = Inc(DayCounter)
				print("Great! You've received the reward for day: " .. DayCounter)
				
				RewardStatus = 1
			elseif (LastTimeReward == nil or (LastTimeReward + 86400 > Data - (86400 * 2)) ) then	-- 2 day (mulligan)
				-- 1 day too late, chance to buy mulligan
				print("Oh oh! You're one day behind... Do you want to buy the mulligan?")
				
				RewardStatus = 2
			else
				-- too late, reset DayCounter to 0
				print("Oh no! You've lost your streak!")
				
				LastTimeReward = Data
				DayCounter = 0
				
				RewardStatus = 3
			end
			
			self:LoadMenu(RewardStatus)
		else
			--Geen reward nog, gewoon naar mainmenu
			self:Goto(MainMenu)
			
			--self:LoadMenu()
		end
	end,
	function()
		--Could not fetch ServerTime, skip this menu
		print("^1ERROR! Could not fetch ServerTime")
		self:Goto(MainMenu)
	end)
	
end)

function DailyRewardsMenu:LoadMenu(RewardStatus)
	--AnalyticsSendScreenName("DailyMissionsMenu")
			
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("DailyRewardsMenu", nil, function()
	
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		
		self.ContentPanel = self.Menu:GetChild("Content")
		
		self.DailyChallengeText = self.Menu:GetChild("Text_DailyChallenge")
		self.DailyChallengeName = self.Menu:GetChild("Text_ChallengeName")
		self.NextChallengeText = self.Menu:GetChild("Text_NextChallenge")
		self.DailyChallengeTime = self.Menu:GetChild("DailyChallengeTime")


		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		self.Items = NewItemList(self, UpButtons, DownButtons)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ButtonTemplate = "Elements\\MenuButton.dcMenu"

		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		self.TotalProceedButtons = 0
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonProceed.dcMenu", "button_proceed"))
		--self.TotalBackButtons = self.TotalBackButtons + 1
		self.TotalProceedButtons = self.TotalProceedButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			--self:Goto(self.PreviousMenu)
			self:Goto(MainMenu)
		end
		
		self.ContentPanel:SetColorImmediate(Invisible)
		self.ContentPanel:SetColorFade(1, 3)
		self.ContentPanel:SetColor(White)
		
		self.DailyMissionItemsPanel = self.Menu:GetChild("DailyMissionItemsPanel")
		self.DailyMissionItemsPanel:Clear()
		self.DailyMissionItems = NewItemList(self, nil, nil)
		
		for i = 1, self.TotalDays do
			local DailyRewardButton = self.DailyMissionItems:AddItem(self.DailyMissionItemsPanel, MenuElements.DailyReward(self.DailyMissionItems, "elements\\DailyReward_Template.dcMenu", nil, i))
			if (i <= DayCounter) then
				DailyRewardButton:SetCompleted(true)
			elseif (i == DayCounter + 1) then
				DailyRewardButton:Activate()
			end
		end
		
		self.DailyMissionItems:Format(ALIGN_WE, 0, 0, 8, 0, Left, Top, Left, Top, 0)
		
		local ClickArea = self.Main
		local ButtonSize = 186 + 8
		local Width, Height = self.DailyMissionItemsPanel:GetSize()
		local ListSpace = Width --SafeFrameWidth
		local CheckGameModesFunc = nil
		local ChangedFunc = function(NewActive)
			self:UpdateArrows((not self.DailyMissionItems:OnTop()), (not self.DailyMissionItems:OnBottom()))
		end
		if (self.TotalDays > 6) then
			self.DailyMissionItems:EnableSliding(self.DailyMissionItemsPanel, ClickArea, ButtonSize, ListSpace, true, nil, CheckGameModesFunc, ChangedFunc)
			ChangedFunc()
		end
		
		if (DayCounter > 0) then
			self.DailyMissionItems:SetSelection(self.DailyMissionItems.Items[DayCounter])
		end
		self.DailyMissionItems:SnapSliding(true)
		
		self:UpdateRewardTime()
		self.ClockThread = GameThread:Spawn(function()
			while (true) do
				self:UpdateRewardTime()
				GameThread:Wait(1)
			end
		end)
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
		
		self.Items:SetSelection(self.FreeGoodsLikeDevButton)
		
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				--self:Goto(self.PreviousMenu)
				self:Goto(MainMenu)
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		if (RewardStatus == 1) then			--Won daily reward
			--VirtualCoins:AddCoinCount(1000)
			
			local GoldReward = GetDailyReward(DayCounter).Gold
			local GearReward = GetDailyReward(DayCounter).Gears
			
			local Text = ""
			if (GoldReward > 0) then
				VirtualCoins:AddCoinCount(GoldReward)
				Text = GoldReward .. " " .. (Translate("menu_gold"))
			end
			
			if (GearReward > 0) then
				VirtualCoins:AddGoloCoinCount(GearReward)
				if (Text ~= "") then
					Text = Text .. Translate("newline")
				end
				Text = Text .. GearReward .. " " .. (Translate("menu_golocoin"))
			end
			
			ShowConfirm_DailyReward_ReceiveReward(string.format(Translate("confirm_DailyReward_ReceiveReward_text"), Text))
		elseif (RewardStatus == 2) then		--Mulligan question
			
			local CancelAction = function()
				LastTimeReward = ServerTime
				DayCounter = 0
				WriteGameSettings()
				
				self:Goto(DailyRewardsMenu)
			end
			
			local GearPrice = 2
			local ProceedAction = function()
				--local CoinsPrice = 1000
				--local genoegcredits = (VirtualCoins:GetCoinCount() >= CoinsPrice)
				local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= GearPrice)
				if not genoegcredits then																--==== Player has not enough gold, go buy some gold
					local CreditsNeeded = (GearPrice - VirtualCoins:GetGoloCoinCount())
					GameThread:Spawn(function()
						--ShowConfirm_NoGold(CreditsNeeded, DailyRewardsMenu, CancelAction)
						ShowConfirm_NoGolo(CreditsNeeded, DailyRewardsMenu, CancelAction)
					end)
				else
					LastTimeReward = nil
					--VirtualCoins:AddCoinCount(-(CoinsPrice))
					VirtualCoins:AddGoloCoinCount(-(GearPrice))
					self:Goto(DailyRewardsMenu)
				end
			end
			
			ShowConfirm_DailyReward_Mulligan(ProceedAction, CancelAction, tostring(GearPrice))
		elseif (RewardStatus == 3) then		--Lost streak
			ShowConfirm_DailyReward_LostStreak()
		end
		
	end)
end

function DailyRewardsMenu:Goto(Target)
	ActiveMenu = Target(DailyRewardsMenu)
	self:HideMenu()
	
	if (self.ClockThread ~= nil) then
		GameThread:Stop(self.ClockThread)
		self.ClockThread = nil
	end
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function DailyRewardsMenu:Active()
	return ActiveMenu == self
end

function DailyRewardsMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = DailyRewardsMenu(PreviousMenu)
end

function DailyRewardsMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function DailyRewardsMenu:HideMenu()
	if (self.Main ~= nil) then
		self.Main:SetColorFade(1, 4)
		self.Main:SetColor(Invisible)
	end
	
	if (self.MenuDelItem_Queue ~= nil) then
		--Fade MenuItems
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColorFade(1, 4)
			MenuItem.Item:SetColor(Invisible)
		end
	end
end

function DailyRewardsMenu:DeleteButtons()
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.OnReleased = nil
		end

		--Delete MenuItems
		GameThread:Spawn(function()
			GameThread:Wait(0.4)
			for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
				self.BottomBarItems:DelItem(MenuItem.Item)
				MenuItem.Item:Destroy()
			end
		end)
	end
end

function DailyRewardsMenu:Back()
	self:Goto(MainMenu)
end

function DailyRewardsMenu:UpdateRewardTime()
	local Text = ""
	if (LastTimeReward ~= nil) then
		local NextRewardDate = LastTimeReward + 86400
		local WaitTime = NextRewardDate - os.time() + ServerTimeDiff
		--Text = os.date("!%X", WaitTime)
		
		if (WaitTime > 0) then
			local Hours = math.floor(WaitTime / 60 / 60)
			Text = tostring(Hours) .. os.date(":%M:%S", WaitTime)
		end
		
		--self.DailyChallengeTime:SetText(tostring(os.date("Last: %x %X", LastTimeReward)) .. " - " .. tostring(os.date("Next: %x %X", NextRewardDate)) .. " - " .. tostring(os.date("Server: %x %X", ServerTime)))
	end
	self.DailyChallengeTime:SetText(Text)
end

function DailyRewardsMenu:AddArrows()
	self.ItemsArrows = self.Menu:GetChild("ItemsArrows")
	self.ItemsArrows:Clear()

	self.ArrowUpButtonItem = MenuElements.Label(nil, "Elements\\CoinShop_LeftArrow.dcMenu", "button_back")
	self.ItemsArrows:AddItem(self.ArrowUpButtonItem.Item)
	
	self.ArrowUpButtonItem.Item:SetColorImmediate(Invisible)
	self.ArrowUpButtonItem.Selectable = false

	self.ArrowDownButtonItem = MenuElements.Label(nil, "Elements\\CoinShop_RightArrow.dcMenu", "button_back")
	self.ItemsArrows:AddItem(self.ArrowDownButtonItem.Item)
	
	self.ArrowDownButtonItem.Item:SetColorImmediate(Invisible)
	self.ArrowDownButtonItem.Selectable = false	
end

function DailyRewardsMenu:UpdateArrows(UpArrow_Visible, DownArrow_Visible)
	if (self.ArrowUpButtonItem == nil or self.ArrowDownButtonItem == nil) then
		self:AddArrows()
	end

	if (self.ArrowUpButtonItem ~= nil) then
		self.ArrowUpButtonItem.Item:SetColorFade(1, 10)
		if (UpArrow_Visible) then
			self.ArrowUpButtonItem.Item:SetColor(White)
		else
			self.ArrowUpButtonItem.Item:SetColor(Invisible)
		end
	end
	
	if (self.ArrowDownButtonItem ~= nil) then
		self.ArrowDownButtonItem.Item:SetColorFade(1, 10)
		if (DownArrow_Visible) then
			self.ArrowDownButtonItem.Item:SetColor(White)
		else
			self.ArrowDownButtonItem.Item:SetColor(Invisible)
		end
	end
end