CarSelect_Template = class(function(self, ItemList, Template, Car)
	self.Item = MenuItem(Template)
	self.ItemList = ItemList
	self.Enabled = true
	self.Selectable = true
	
	--Init car stuff
	self.Car = Car
	self.CarImage = texture("MonsterTrucksCards\\" .. self.Car.Name .. "_CardImage.DCT")
	self.Image = texture("MonsterTrucksCards\\" .. self.Car.Name .. "_CardLogo.DCT")
	
	--Get panels
	self.DeliverTimerPanel = self.Item:GetChild("DeliverTimerPanel")
	self.DeliverTimeValue = self.Item:GetChild("DeliverTimeValue")
	
	self.UpgradesPanel = self.Item:GetChild("UpgradesPanel")
	self.Tires = self.Item:GetChild("Upgrade_Tires")
	self.AirShocks = self.Item:GetChild("Upgrade_AirShocks")
	self.Armor = self.Item:GetChild("Upgrade_Armor")
	self.Engine = self.Item:GetChild("Upgrade_Engine")
	self.Suspension = self.Item:GetChild("Upgrade_Suspension")
	self.Weight = self.Item:GetChild("Upgrade_Weight")
	
	self.Upgrade_Level = self.Item:GetChild("Upgrade_Level")
	
	self.SelectionOutline = self.Item:GetChild("SelectionOutline")
	
	self.BackgroundImage = self.Item:GetChild("BackgroundImage")
	self.CarLogoImage = self.Item:GetChild("CarLogoImage")
	self.BlackOverlay = self.Item:GetChild("BlackOverlay")
	
	self.CarValuePanel = self.Item:GetChild("CarValuePanel")
	self.GearsPanel = self.CarValuePanel:GetChild("GearsPanel")
	self.GearsValue = self.CarValuePanel:GetChild("GearsValue")
	self.CoinsPanel = self.CarValuePanel:GetChild("CoinsPanel")
	self.CoinsValue = self.CarValuePanel:GetChild("CoinsValue")
	
	-- Init
	self:Update()
	
	if (self.CarImage ~= nil) then
		self.BackgroundImage:SetImage(self.CarImage)
	end
	
	if (self.Image ~= nil) then
		self.CarLogoImage:SetImage(self.Image)
	end
	self.CarLogoWidth, self.CarLogoHeight = self.CarLogoImage:GetSize()
	
	-- Functions
	if (self.ItemList ~= nil) then
		self.Item:SetActivateFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					--self.ItemList:SetSelection(self)
				end
				
				if (self.OnActivate ~= nil) then
					self.OnActivate()
				end
			end
		end)

		self.Item:SetDeactivateFunc(function()
			--[[ if (self.Enabled) then
				self.ItemList:UnsetSelection(self)
					
				if (self.OnDeactivate ~= nil) then
					self.OnDeactivate()
				end
			end ]]--
		end)
		
		self.Item:SetClickedFunc(function()
			--print("GMClick")
			if (self.Enabled) then
				if (self.Selectable) then
					--self.ItemList:SetSelection(self)
				end

				if (self.OnClicked ~= nil and not self.ItemList.Clicked) then				
					self.OnClicked()
				end				
			end
		end)

		self.Item:SetReleasedFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					--self.ItemList:SetSelection(self)
				end

				if (self.OnReleased ~= nil and not self.ItemList.Clicked) then					
					self.OnReleased()
				end
			end
		end)

		self.Item:SetScrollFunc(function(Value)
			if (self.Enabled) then
				if (self.OnScroll ~= nil) then
					self.OnScroll(Value)
				end
			end
		end)
	end
end)

function CarSelect_Template:Activate()
	--
	self:Flash(2)
end

function CarSelect_Template:Deactivate()
	--
end

function CarSelect_Template:Flash(Speed)
	--
end

function CarSelect_Template:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function CarSelect_Template:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		--
		self:Deactivate()
	end
end

function CarSelect_Template:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		--
	end
end

function CarSelect_Template:Scale(ScaleX, ScaleY)
	if (ScaleY == nil) then
		ScaleY = ScaleX
	end

	local ExtraWidth = 128 * ScaleX
	local ExtraHeight = 230 * ScaleY
	
	self.Item:SetSize(256 + 64 + ExtraWidth, 460 + ExtraHeight)
	
	
	--local Perc = ExtraWidth / (256 + 64)
	--print(Perc)
	--local Width, Height = self.Item:GetSize()
	
	--self.CarLogoImage:SetSize(self.CarLogoWidth * (0.55 + Perc), self.CarLogoHeight * (0.55 + Perc))
	--self.CarLogoImage:SetSize(256 + 64 + ExtraWidth, 460 + ExtraHeight)
end

function CarSelect_Template:Format(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:Format(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex)
		end
	end
end

function CarSelect_Template:FormatTween(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ReverseDelay)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:FormatTween(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex, ReverseDelay)
		end
	end
end

function CarSelect_Template:FormatList(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, TweenEasing, TweenDelay, TweenTime, ReverseDelay)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:FormatList(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex, TweenEasing, TweenDelay, TweenTime, ReverseDelay)
		end
	end
end

-- ===================

function CarSelect_Template:Update()
	if (self.Car.Available) then
		self:CalcStats()
		
		self.DeliverTimerPanel:SetAlpha(0)
		self.BlackOverlay:SetAlpha(0)
		self.CarValuePanel:SetAlpha(0)
	elseif (self.Car.Bought) then
		self:ShowTimer()
		
		self.BlackOverlay:SetAlpha(0.8)
		self.CarValuePanel:SetAlpha(0)
	else
		self.DeliverTimerPanel:SetAlpha(0)
		self.BlackOverlay:SetAlpha(0.8)
		self.CarValuePanel:SetAlpha(1)
		
		local CoinsPrice = self.Car.ShopPriceCoins
		local GearsPrice = self.Car.ShopPriceSpecialCoins
		
		if (GearsPrice > 0) then
			self.GearsPanel:SetAlpha(1)
			self.GearsValue:SetText(GearsPrice)
		end
		
		if (CoinsPrice > 0) then
			self.CoinsPanel:SetAlpha(1)
			self.CoinsValue:SetText(CoinsPrice)
		end
	end
	
	if (self.Car.MechanicActiveRaces > 0) then
		self.SelectionOutline:SetColorImmediate(color(1, 0.75, 0.25, 1))
	end
end

function CarSelect_Template:CalcStats()
	local Acceleration_Current = 0
	local Topspeed_Current = 0
	local Strenght_Current = 0
	local Weight_Current = 0
	local Grip_Current = 0
	
	local Acceleration_Add = 0
	local Topspeed_Add = 0
	local Strenght_Add = 0
	local Weight_Add = 0
	local Grip_Add = 0
	
	local Acceleration_Max = 0
	local Topspeed_Max = 0
	local Strenght_Max = 0
	local Weight_Max = 0
	local Grip_Max = 0
	
	local SelectedUpgrade = nil
	if (self.ItemList_Upgrades ~= nil) then
		SelectedUpgrade = self.ItemList_Upgrades:GetSelection()
	end
	
	local UpgradeItem = UpgradeItem_Weight
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.WeightUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]

	local UpgradeItem = UpgradeItem_Suspension
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.SuspensionUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	local UpgradeItem = UpgradeItem_AirShocks
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.AirShocksUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	local UpgradeItem = UpgradeItem_Engine
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.EngineUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	local UpgradeItem = UpgradeItem_Armor
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.ArmorUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	local UpgradeItem = UpgradeItem_Tires
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.TiresUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	
	local Seed1 = string.byte(string.sub(self.Car.Name, 1, 1))
	local Seed2 = string.byte(string.sub(self.Car.Name, 2, 2))
	local Seed3 = string.byte(string.sub(self.Car.Name, string.len(self.Car.Name) - 1, string.len(self.Car.Name) - 1))
	local Seed4 = string.byte(string.sub(self.Car.Name, string.len(self.Car.Name), string.len(self.Car.Name)))
	local RandomSeed = math.floor(tonumber(Seed1..""..Seed2..""..Seed3..""..Seed4) * Seed1 / Seed4)
	math.randomseed(RandomSeed)
	local Factor = self.Car.TierNumber
	
	local ExtraLevel = 0
	if (self.Car.MechanicActiveRaces > 0) then
		ExtraLevel = 1
	end
	
	local MinLevel = 999
	
	local Level = self.Car.Upgrades[UpgradeItem_Tires.Name].CurrentLevel + ExtraLevel
	MinLevel = Min(Level, MinLevel)
	local Value = math.floor(Level * 100)
	local AddUp = Mod(math.floor(Level * 100 * ((math.random() / Factor) + 1)), 100)
	local Value = Value + AddUp
	self.Tires:SetText(Value)
	
	local Level = self.Car.Upgrades[UpgradeItem_AirShocks.Name].CurrentLevel + ExtraLevel
	MinLevel = Min(Level, MinLevel)
	local Value = math.floor(Level * 100)
	local AddUp = Mod(math.floor(Level * 100 * ((math.random() / Factor) + 1)), 100)
	local Value = Value + AddUp
	self.AirShocks:SetText(Value)
	
	local Level = self.Car.Upgrades[UpgradeItem_Armor.Name].CurrentLevel + ExtraLevel
	MinLevel = Min(Level, MinLevel)
	local Value = math.floor(Level * 100)
	local AddUp = Mod(math.floor(Level * 100 * ((math.random() / Factor) + 1)), 100)
	local Value = Value + AddUp
	self.Armor:SetText(Value)
	
	local Level = self.Car.Upgrades[UpgradeItem_Engine.Name].CurrentLevel + ExtraLevel
	MinLevel = Min(Level, MinLevel)
	local Value = math.floor(Level * 100)
	local AddUp = Mod(math.floor(Level * 100 * ((math.random() / Factor) + 1)), 100)
	local Value = Value + AddUp
	self.Engine:SetText(Value)
	
	local Level = self.Car.Upgrades[UpgradeItem_Suspension.Name].CurrentLevel + ExtraLevel
	MinLevel = Min(Level, MinLevel)
	local Value = math.floor(Level * 100)
	local AddUp = Mod(math.floor(Level * 100 * ((math.random() / Factor) + 1)), 100)
	local Value = Value + AddUp
	self.Suspension:SetText(Value)
	
	local Level = self.Car.Upgrades[UpgradeItem_Weight.Name].CurrentLevel + ExtraLevel
	MinLevel = Min(Level, MinLevel)
	local Value = math.floor(Level * 100)
	local AddUp = Mod(math.floor(Level * 100 * ((math.random() / Factor) + 1)), 100)
	local Value = Value + AddUp
	self.Weight:SetText(Value)
	
	self.Upgrade_Level:SetText(string.format(Translate("garage_level"), MinLevel))
	
	self.UpgradesPanel:SetAlpha(1)
end

function CarSelect_Template:ShowTimer()
	self.DeliverTimerPanel:SetAlpha(1)
	
	--- timer
	local DeliveryTime = self.Car.DeliveryTime
	--local DeliveryTime = os.time() + 1000
	
	if (self.DeliveryClockThread ~= nil) then
		GameThread:Stop(self.DeliveryClockThread)
	end
	
	self.DeliveryClockThread = GameThread:Spawn(function()
		local CurrentTime = os.time()
		local WaitTime = DeliveryTime - CurrentTime
		
		while (WaitTime > 0) do
			CurrentTime = os.time()
			WaitTime = DeliveryTime - CurrentTime
			
			self.DeliverTimeValue:SetText(FormatTimeShort(WaitTime))
			
			GameThread:Wait(1)
		end
		
		--self:UpdateCategoryButtons()
		
		--ActiveMission.CarManager:SaveCarSelection(Car)
		--ActiveForeground:SetCarName(ActiveGameMode:GetSelectedCar().Name, ActiveGameMode:GetSelectedCar().TierNumber)
		
		--self:Update()
		if (ActiveMenu.ShowMenu ~= nil) then
			ActiveMenu:ShowMenu()
		end
		
		self.DeliveryClockThread = nil
	end)
end