MenuElements.InfoButton = class(function(self, ItemList, Template, Panel)
	self.Panel = Panel
	self.ItemList = ItemList
	self.Enabled = true

	self.Item = self.Panel:AddItem(Template)

	self.Background = self.Item:GetChild("Background")

	-- Functions
	self.Item:SetActivateFunc(function()
		--print("InfoActivate")
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		--print("InfoDeactive")
		if (self.Enabled) then
			ItemList:UnsetSelection(self)

			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	end)

	self.Item:SetClickedFunc(function()
		print("InfoClicked")
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnClicked ~= nil and not self.ItemList.Clicked) then			
				self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		print("InfoReleased")
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnReleased ~= nil and not self.ItemList.Clicked) then
				self.ItemList.Clicked = true
				
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.InfoButton:DelItem(Index)
	self.Panel:DelItem(self.Item)
end

--[[function MenuElements.InfoButton:Activate()
	if (self.Enabled) then
		--print('^3Select (MenuButton): ^7' .. self.Item:GetIntName())

		--self.NameItemFlash:SetColorImmediate(color(1, 1, 1, 0.8))
		--self.NameItemFlash:SetColorData((color(0, 0, 0, 0) 1, Sine, false)
		
		self.NameItem:SetColorData((color(0, 0, 0, 0.95)), 0.75, FullSine, true)
		
		self.Selection_Stars:SetColorImmediate(White)
		
		self.Selection_Stars_Flash:SetColorImmediate(color(1, 1, 1, 0.8))
		self.Selection_Stars_Flash:SetColorData(Invisible, 2, Sine, false)
	end
end--]]

function MenuElements.InfoButton:Deactivate()
	if (self.Enabled) then
		--print('^3Deselect (MenuButton): ^7' .. self.Item:GetIntName())

		--self.Selection_Stars:SetColorData(Invisible, 2, Sine, false)
		--self.NameItem:SetColorData((color(0, 0, 0, 0.6)), 3, Sine, false)
	end
end

function MenuElements.InfoButton:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.Item:SetColorImmediate(White)
		self:Deactivate()
	end
end

function MenuElements.InfoButton:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.Item:SetColorImmediate(Invisible)
		self.OnReleased = nil
	end
end