HUDMapElement = class(function(self, HUDMap)
	self.HUDMap = HUDMap
end)

function HUDMapElement:SetMatrix(Matrix)
	self:SetPos(Matrix:GetTranslation())
	self.Item:SetRotation(Matrix)
end

function HUDMapElement:SetPos(Pos)
	Pos = Pos - self.HUDMap.Box.Center
	Pos = Pos / self.HUDMap.Box.Extents

	local Width = self.HUDMap.Width - 32
	local Height = self.HUDMap.Height - 32

	local x = (Pos.x * Width / 2)
	local y = (-Pos.z * Height / 2)

	self.Item:SetPos(x, y)
end

HUDMap = class(function(self, Panel, Width, Height, Box)
	self.Panel = Panel
	self.Width = Width;
	self.Height = Height
	self.Box = Box

	self.Panel:SetSize(Width, Height)
end)

function HUDMap:AddElement(Template, Image)
	local Element = HUDMapElement(self)
	Element.Item = MenuItem(Template)
	Element.Item:SetImage(Image)

	self.Panel:AddItem(Element.Item)

	return Element
end

function HUDMap:DelElement(Element)
	self.Panel:DelItem(Element.Item)
end