Hud_Moveindicator = class(function(self, ItemList, Template, Color, ItemSize, Image)
	self.Item = MenuItem(Template)
	self.Enabled = true
	self.Selectable = true
	self.Activated = true
	
	self.Color = Color
	self.ItemSize = ItemSize
	self.Image = Image
	
	self.Background = self.Item:GetChild("IndicatorBack")
	self.Indicator = self.Item:GetChild("IndicatorLight")
	self.IndicatorGlow = self.Item:GetChild("IndicatorGlow")
	self.IndicatorFlare = self.Item:GetChild("IndicatorFlare")
	
	self.IndicatorText = self.Item:GetChild("IndicatorText")

	-- Init

	self.Item:SetSize(ItemSize, ItemSize)
	print("ItemSize = " .. ItemSize)
	self.Background:SetColorData(White, 0, None, false)
	self.Indicator:SetColorData(Invisible, 0, None, false)
	self.IndicatorGlow:SetColorData(Invisible, 0, None, false)
	self.IndicatorFlare:SetColorData(Invisible, 0, None, false)

	self.UseFlare = false
	
	if (self.UseFlare) then
		--self.IndicatorFlare:SetImage(texture(self.Image))
		self.IndicatorFlare:SetPos(0, 0)
		self.IndicatorFlare:SetOffset(ItemSize * 2, ItemSize * 2)
		--self.IndicatorFlare:SetOffset(ItemSize * 2, ItemSize * 2)

		--[[ self.RotateIndicatorFlare = GameThread:Spawn(function() -- draaien draaien!
			while (true) do
				
				if (self.RotateAngle ~= nil) then
					self.RotateAngle = self.RotateAngle +3
					if self.RotateAngle >= 360 then
						self.RotateAngle = 0
					end

				else
					self.RotateAngle = 0
				end
				
				PhysicsThread:Wait(1 / 120)
				self.IndicatorFlare:SetRot(-self.RotateAngle)
		
			end
		end) ]]
	else
		self.IndicatorFlare:SetColor(Invisible)
	end

	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				--ItemList:SetSelection(self)
			end
			
			if (self.OnActivate ~= nil) then
				--self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		--[[ if (self.Enabled) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end ]]--
	end)
	
	self.Item:SetClickedFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				--ItemList:SetSelection(self)
			end

			if (self.OnClicked ~= nil) then
				--self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				--ItemList:SetSelection(self)
			end

			if (self.OnReleased ~= nil) then
				--self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				--self.OnScroll(Value)
			end
		end
	end)
end)

function Hud_Moveindicator:SetText(Text)
	-- we hebben geen text :)
end

function Hud_Moveindicator:Activate(Alpha)
	--if (not self.Activated) then
		if (Alpha == nil) then
			Alpha = 1
		end
		local NewColor = color(self.Color:getr(), self.Color:getg(), self.Color:getb(), Alpha)
		self.Color = NewColor
	
		self.Indicator:SetColorData(self.Color, 999999999, Sine, false)
		self:Flash(999999999)
	--end
	self.Activated = true
end

function Hud_Moveindicator:Deactivate()
	if (self.Activated) then
		--self.Indicator:SetColorData(color(0, 0, 0, 0), 0, None, false)
		--self.IndicatorGlow:SetColorData(color(0, 0, 0, 0), 0, None, false)
		--self.IndicatorFlare:SetColorData(color(0, 0, 0, 0), 0, None, false)
		
		local Speed = 4
		self.Indicator:SetColorData(color(0, 0, 0, 0), Speed, QuarterSine, false)
		self.IndicatorGlow:SetColorData(color(0, 0, 0, 0), Speed, QuarterSine, false)
		
		if (self.UseFlare) then
			self.IndicatorFlare:SetColorData(color(0, 0, 0, 0), Speed, QuarterSine, false)
		end
	end
	
	self.Activated = false
end

function Hud_Moveindicator:Flash(Speed)
	--self.IndicatorGlow:SetColorData(self.Color, 0, None, false)
	self.IndicatorGlow:SetColorData(self.Color, Speed, QuarterSine, false)
	
	if (self.UseFlare) then
		self.IndicatorFlare:SetColorData(self.Color, Speed, QuarterSine, false)
	end
end

function Hud_Moveindicator:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function Hud_Moveindicator:Enable()
	-- if (not self.Enabled) then
		-- self.Enabled = true
		
		-- self.NameItem:SetColorData(White, 1, Sine, false)
		-- self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
		-- self:Deactivate()
	-- end
end

function Hud_Moveindicator:Disable()
	-- if (self.Enabled) then
		-- self.Enabled = false
		
		-- self.NameItem:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		-- self.Background:SetColorData(color(0.2, 0.2, 0.2, 0.5), 0, None, false)
	-- end
end