-- Rating messages

-- Deze strings meegeven in de parameter 'Text'

-- "Perfect": if (inPerfectRange)
-- "Nice": if (inScoreRange)
-- "Casual": if (moveDetected)
-- "Better": if (moveNOTDetected) (aan het einde van een 'gefaalde' move)
-- "Almost": if (combo.1 succeeded and combo.2 failed)
-- "Toolate": if (comboExpired and not "Almost!")
-- 
-- Publiek gerelateerd;
-- "CrowdInsane!": if (state becomes green)
-- "CrowdLeaving": if (state becomes red)
HUDElements.RatingScreenMessage = class(function(self, HUDTexture, AnimationSpeed, Spline, DestroyCallback)
	self.Item = MenuItem("hud\\elements\\hud_ScreenMessage_Image.dcMenu")
	self.T = 0
	self.Spline = Spline
	self.DestroyCallback = DestroyCallback
	
	local X, Y = self.Spline:GetPos(self.T)
	self.Item:SetPosData(0, 0, 0.5, 0.5, X, Y, 0, None, false)
	
	self.MessageImage = self.Item:GetChild("MessageImage")
	if (HUDTexture ~= nil) then
		self.MessageImage:SetImage(HUDTexture)
	end
	
	self.MessageImage:SetColorImmediate(Invisible)
	self.MessageImage:SetColorFade(1,2)
	self.MessageImage:SetColor(White)
	
	self.Thread = PhysicsThread:Spawn(function()
		local Check = false
		while (self.Item ~= nil) do
			self.T = self.T + AnimationSpeed
			local X, Y = self.Spline:GetPos(self.T)
			self.Item:SetPosData(0, 0, 0.5, 0.5, X, Y, 0, None, false)
			
			if (self.T > 0.5 and not Check) then
				Check = true
				PhysicsThread:Sleep(1)
			end
			
			local X, Y = self.MessageImage:GetSize()
			
			if (self.T < 0.5) then
				self.MessageImage:SetSize(X + 8, Y + 3)
			else
				self.MessageImage:SetSize(X - 8, Y - 3)
				
				local Alpha = ClampMinMax(1 + ((0.5 - self.T) * 2), 0, 1)
				self.MessageImage:SetColorImmediate(color(1,1,1, Alpha))
			end
			
			if (self.T > 1) then
				self.MessageImage:SetColorImmediate(Invisible)
				
				self.Item = nil
				
				if (self.DestroyCallback ~= nil) then
					self:DestroyCallback(self)
				end
			end
			
			PhysicsThread:Wait(1)
		end
	end)
end)

-- ============================