HUDElements.ScoreScreenMessage = class(function(self, Text, AnimationSpeed, Spline, DestroyCallback)
	self.Item = MenuItem("hud\\elements\\hud_ScreenMessage.dcMenu")
	self.T = 0
	self.Spline = Spline
	self.DestroyCallback = DestroyCallback
	
	local X, Y = self.Spline:GetPos(self.T)
	self.Item:SetPosData(0, 0, 0.5, 0.5, X, Y, 0, None, false)
	
	self.Item:SetText(Text)
	
	self.Item:SetColorImmediate(Invisible)
	self.Item:SetColorFade(1,2)
	self.Item:SetColor(White)
	
	self.Thread = PhysicsThread:Spawn(function()
		while (self.Item ~= nil) do
			self.T = self.T + AnimationSpeed
			local X, Y = self.Spline:GetPos(self.T)
			self.Item:SetPosData(0, 0, 0.5, 0.5, X, Y, 0, None, false)
			
			if (self.T < 0.5) then
				
			else
				local Alpha = ClampMinMax(1 + ((0.5 - self.T) * 2), 0, 1)
				self.Item:SetColorImmediate(color(1,1,1, Alpha))
			end
			
			if (self.T > 1) then
				self.Item:SetColorImmediate(Invisible)
				
				self.Item = nil
				
				if (self.DestroyCallback ~= nil) then
					self:DestroyCallback(self)
				end
			end
			
			PhysicsThread:Wait(1)
		end
	end)
end)