MenuElements.Button = class(function(self, ItemList, Template, Name)
	self.Panel = ItemList.Panel
	self.Enabled = true

	self.Item = self.Panel:AddItem(Template)

	-- Init
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	self.NameItem:SetText(translate(Name))
	self.NameItemFlash:SetText(translate(Name))

	self.NameItem:SetColorData((color(0, 0, 0, 0.6)), 0, None, false)	
	
	self.Selection_Stars = self.Item:GetChild("Selection_Stars")
	self.Selection_Stars_Flash = self.Item:GetChild("Selection_Stars_Flash")
	self.SelectedPanel = self.Item:GetChild("Selected")
	self.HighlightPanel = self.Item:GetChild("Highlight")
	self.DisabledImage = self.Item:GetChild("DisabledImage")
	
	self.Selection_Stars:SetColorImmediate(Invisible)
	self.Selection_Stars_Flash:SetColorImmediate(Invisible)
	self.NameItemFlash:SetColorImmediate(Invisible)

	-- Functions
	--[[self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)--]]

	--[[self.Item:SetDeactivateFunc(function()
		if (self.Enabled) then
			ItemList:UnsetSelection(self)

			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	end)--]]

	--[[self.Item:SetClickedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)--]]
end)

function MenuElements.Button:DelItem(Index)
	self.Panel:DelItem(self.Item)
end

--[[function MenuElements.Button:Activate()
	if (self.Enabled) then
		--print('^3Select (MenuButton): ^7' .. self.Item:GetIntName())

		--self.NameItemFlash:SetColorImmediate(color(1, 1, 1, 0.8))
		--self.NameItemFlash:SetColorData((color(0, 0, 0, 0) 1, Sine, false)
		
		self.NameItem:SetColorData((color(0, 0, 0, 0.95)), 0.75, FullSine, true)
		
		self.Selection_Stars:SetColorImmediate(White)
		
		self.Selection_Stars_Flash:SetColorImmediate(color(1, 1, 1, 0.8))
		self.Selection_Stars_Flash:SetColorData(Invisible, 2, Sine, false)
	end
end--]]

function MenuElements.Button:Deactivate()
	if (self.Enabled) then
		--print('^3Deselect (MenuButton): ^7' .. self.Item:GetIntName())

		self.Selection_Stars:SetColorData(Invisible, 2, Sine, false)
		self.NameItem:SetColorData((color(0, 0, 0, 0.6)), 3, Sine, false)
	end
end

function MenuElements.Button:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.DisabledImage:SetColorImmediate(Invisible)
	end
end

function MenuElements.Button:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.DisabledImage:SetColorImmediate(White)
		
		self.Selection_Stars:SetColorData(Invisible, 2, Sine, false)
		self.NameItem:SetColorData((color(0, 0, 0, 0.60)), 3, Sine, false)
	end
end