MenuElements.CategoryButton = class(function(self, ItemList, Template, MeshName, Name, Texture)
	self.Item = MenuItem(Template)
	self.ItemList = ItemList
	self.Enabled = true
	self.Name = Name
	self.Texture = Texture
	
	-- self.Item = self.Panel:AddItem(Template);
	self.Item:SetColorFade(1, 8)
	
	self.ImageItem = self.Item:GetChild("Image")
	self.Background = self.Item:GetChild("Background")
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	
	self.MeshName = MeshName
	
	self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
	
	if (self.Texture ~= nil) then
		self.ImageItem:SetImage(self.Texture)
	end

	self.NameItem:SetText(Translate(self.Name))
	self.NameItemFlash:SetText(Translate(self.Name))

	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		if (self.Enabled) then
			--ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	end)
	
	self.Item:SetClickedFunc(function()
		if (ActiveForeground ~= nil and ActiveForeground.MouseOver > 0) then
			return false
		end
		
		if (not ItemList:IsSliding()) then
			if (self.Enabled) then
				--ItemList:SetSelection(self)

				if (self.OnClicked ~= nil) then
					self.OnClicked()
				end
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (ActiveForeground ~= nil and ActiveForeground.MouseOver > 0) then
			return false
		end
		
		if (not ItemList:IsSliding()) then
			if (self.Enabled) then
				ItemList:SetSelection(self)

				if (self.OnReleased ~= nil) then
					self.OnReleased()
				end
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.CategoryButton:Activate()
	if (self.Enabled) then
		self.Background:SetColorData(color(0.775, 0.75, 0.75, 1), 0, None, false)
		if(self.ItemList.Menu.UpdateMenuStats ~= nil) then
			self.ItemList.Menu:UpdateMenuStats()
		end
	end

	--self.ImageItem:SetColorImmediate(White)
	--self.Background:SetColorImmediate(Invisible)
	
	
	-- self.SelectionPijl:SetColorImmediate(color(0, 0, 0, 1))
	-- self:Flash(2)
end

function MenuElements.CategoryButton:Deactivate()
	if (self.Enabled) then
		self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
	end
	
	-- self.ImageItem:SetColorImmediate(Invisible)
	--self.Background:SetColorImmediate(color(0.5, 0.5, 0.5, 1))
	-- self.SelectionPijl:SetColorImmediate(color(0, 0, 0, 0))
end

function MenuElements.CategoryButton:Flash(Speed)
	--self.NameItemFlash:SetColorImmediate(White)
	--self.NameItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
end

function MenuElements.CategoryButton:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.CategoryButton:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.NameItem:SetColorData(White, 1, Sine, false)
		self.Background:SetColorData(White, 1, Sine, false)
		self.ImageItem:SetColorData(White, 1, Sine, false)
		
		self:Deactivate()
	end
end

function MenuElements.CategoryButton:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.NameItem:SetColorData(color(1, 1, 1, 0.25), 1, Sine, false)
		self.Background:SetColorData(color(0.2, 0.2, 0.2, 0.5), 1, Sine, false)
		self.ImageItem:SetColorData(color(1, 1, 1, 0.25), 1, Sine, false)
	end
end

function MenuElements.CategoryButton:Disappear()	
	if (not self.Enabled) then
		self.NameItem:SetColorImmediate(Invisible)
		self.Background:SetColorImmediate(Invisible)
		self.ImageItem:SetColorImmediate(Invisible)
	end
end