MenuElements.Checkbox = class(function(self, ItemList, Template, Name, Checked, Image, HoverImage)
	--self.Panel = Panel
	self.Item = MenuItem(Template)
	
	self.Selected = false
	self.Enabled = true
	
	self.Checked = Checked
	
	-- Init
	self.Item:SetColorFade(1, 8)
	
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	self.HoverImage = self.Item:GetChild("HoverImage")
	self.Background = self.Item:GetChild("Background")
	
	self.Color = White;
	self.FlashColor = Red;
	
	if (Image ~= nil) then
		self.Background:SetImage(Image)
	end
	
	if (HoverImage ~= nil) then
		self.HoverImage:SetImage(HoverImage)
	end
	
	-- Init
	self.Item:SetColorImmediate(Halfblack)
	
	self:SetText(Translate(Name))
	
	self.HoverImage:SetColorFade(1, 1)
	self.HoverImage:SetColorImmediate(Invisible);
	
	GameThread:Spawn(function()
		GameThread:Wait(0.5)			--Dit moet eigenlijk de MenuList regelen voor mooiere volgorde
		self.NameItem:SetColor(White)
		self:Flash(2)
	end)
	
	
	--self.CheckItem = self.Item:GetChild("Check")
	--self.UnCheckItem = self.Item:GetChild("UnCheck")
	--self.CheckAreaPanel = self.Item:GetChild("CheckArea")
	self.CheckBoxItem = self.Item:GetChild("CheckBox")
	self.CheckItem = self.Item:GetChild("Check")
	self.UnCheckItem = self.Item:GetChild("UnCheck")
	
	self:UpdateCheckbox()
	
	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		--[[ if (self.Enabled) then
			ItemList:UnsetSelection(self)

			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end ]]--
	end)
	
	self.CheckBoxItem:SetClickedFunc(function()
		if (self.Enabled) then
			--ItemList:SetSelection(self)
			
			--if (self.OnClicked ~= nil) then
				--self.OnClicked()
			--end
			
			self:Toggle()
		end
	end)
	
end)

function MenuElements.Checkbox:SetText(Text)
	self.NameItem:SetText(Text)
	self.NameItemFlash:SetText(Text)
end

function MenuElements.Checkbox:Activate()
	self.HoverImage:SetColorImmediate(White)
	self:Flash(2)
end

function MenuElements.Checkbox:Deactivate()
	self.HoverImage:SetColorImmediate(Invisible)
end

function MenuElements.Checkbox:Flash(Speed)
	self.NameItemFlash:SetColorImmediate(White)
	self.NameItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
end

function MenuElements.Checkbox:DelItem(Index)
	--self.Panel:DelItem(self.Item)
end

function MenuElements.Checkbox:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		--
	end
end

function MenuElements.Checkbox:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		--
	end
end

function MenuElements.Checkbox:Proceed()
	self:Toggle()
end

function MenuElements.Checkbox:GetValue()
	return self.Checked
end

function MenuElements.Checkbox:UpdateCheckbox()
	if self.Checked then
		self.UnCheckItem:SetColor(Invisible)
		--self.CheckItem:SetColor(White)
		self.CheckItem:SetColor(color(0.4, 0.9, 0, 1))
	else
		self.UnCheckItem:SetColor(White)
		self.CheckItem:SetColor(Invisible)
	end
	
	if (self.OnChange ~= nil) then
		self.OnChange(self.Checked)
	end
end

function MenuElements.Checkbox:Toggle()
	--print('^3Toggle (MenuElements.Checkbox): ^7' .. self.Item:GetIntName())
	if self.Checked then
		self.Checked = false
	else
		self.Checked = true
	end
	
	self:UpdateCheckbox()
end

function MenuElements.Checkbox:Check()
	self.Checked = true
	self:UpdateCheckbox()
end

function MenuElements.Checkbox:Uncheck()
	self.Checked = false
	self:UpdateCheckbox()
end