-- text item
MenuElements.HighScores = class(function(self, ItemList, Template, Rank, Name, Vehicle, Score, Player)
	self.Item = MenuItem(Template)
	self.Item:SetColorFade(1, 8)
	
	self.Background = self.Item:GetChild("Background")
	
	self.RankText = self.Item:GetChild("RankText")
	self.RankTextFlash = self.Item:GetChild("RankTextFlash")
	
	self.PlayerNameText = self.Item:GetChild("PlayerNameText")
	self.PlayerNameTextFlash = self.Item:GetChild("PlayerNameTextFlash")
	
	self.VehicleNameText = self.Item:GetChild("VehicleNameText")
	self.ScoreText = self.Item:GetChild("ScoreText")
	self.ScoreTextFlash = self.Item:GetChild("ScoreTextFlash")
	
	self.Background:SetColorData(Invisible, 0, None, false)

	-- Init
	if (Rank ~= nil and type(Rank) == "string" or type(Rank) == "number") then
		self.RankText:SetText(tostring(Rank))
		self.RankTextFlash:SetText(tostring(Rank))
	end
	
	if (Rank ~= nil and type(Rank) == "number") then
		if Rank < 100 then
			self.RankText:SetFont("ArialBlack30")
			self.RankTextFlash:SetFont("ArialBlack30")
			self.RankText:SetPos(32, -4)
			self.RankTextFlash:SetPos(32, -4)
		elseif Rank < 1000 then
			self.RankText:SetFont("ArialBlack24")
			self.RankTextFlash:SetFont("ArialBlack24")
			self.RankText:SetPos(32, -4)
			self.RankTextFlash:SetPos(32, -4)
		elseif Rank < 10000 then
			self.RankText:SetFont("ArialBlack20")
			self.RankTextFlash:SetFont("ArialBlack20")
			self.RankText:SetPos(32, 0)
			self.RankTextFlash:SetPos(32, 0)
		else
			self.RankText:SetFont("ArialBlack17")
			self.RankTextFlash:SetFont("ArialBlack17")
			self.RankText:SetPos(32, 1)
			self.RankTextFlash:SetPos(32, 1)
		end
	end
	
	self.PlayerNameText:SetText(Name)
	
	if (false) then
		local RandomValue = math.random(1, 11)
		if RandomValue < 10 then
			self.VehicleNameText:SetText(translate("MonsterTruckCar0" .. RandomValue .."_Name"))
		else
			self.VehicleNameText:SetText(translate("MonsterTruckCar" .. RandomValue .."_Name"))
		end
	end
	
	self.VehicleNameText:SetText(Vehicle)
	self.ScoreText:SetText(tostring(Score))
	self.ScoreTextFlash:SetText(tostring(Score))
	
	if Player then
		self.Background:SetColorData(color(1,1,1,0.25), 0, None, false)
		self.Background:SetColorData(color(1,1,1,0.5), 1, FullSine, true)

		self.RankTextFlash:SetColorData(White, 0, None, false)
		self.RankTextFlash:SetColorData(Invisible, 1, Sine, true)
		
		self.ScoreTextFlash:SetColorData(White, 0, None, false)
		self.ScoreTextFlash:SetColorData(Invisible, 1, Sine, true)
	end
end)

function MenuElements.HighScores:SetText(Text)
	--
end

function MenuElements.HighScores:Activate() 
	--
end

function MenuElements.HighScores:Clicked() 
	--
end

function MenuElements.HighScores:Deactivate()
	--
end

function MenuElements.HighScores:DelItem(Index)
	--
end

function MenuElements.HighScores:Enable()
	--
end

function MenuElements.HighScores:Disable()
	--
end