MenuElements.ImageButton = class(function(self, ItemList, Template, Name, Texture)
	self.Item = MenuItem(Template)
	self.ItemList = ItemList
	self.Enabled = true
	self.Selectable = true
	self.Name = Name
	--self.Description = Description
	self.Texture = Texture
	
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	self.Background = self.Item:GetChild("Background")
	self.SelectionPijl = self.Item:GetChild("SelectionPijl")
	self.ImageItem = self.Item:GetChild("Image")

	-- Init
	self:SetText(Translate(Name))
	
	if (self.Texture ~= nil) then
		self.ImageItem:SetImage(self.Texture)
	end
	
	self.NameItem:SetColorData(White, 0, None, false)
	self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)

	-- Functions
	if (self.ItemList ~= nil) then
		self.Item:SetActivateFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end
				
				if (self.OnActivate ~= nil) then
					self.OnActivate()
				end
			end
		end)

		self.Item:SetDeactivateFunc(function()
			--[[ if (self.Enabled) then
				self.ItemList:UnsetSelection(self)
					
				if (self.OnDeactivate ~= nil) then
					self.OnDeactivate()
				end
			end ]]--
		end)
		
		self.Item:SetClickedFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end

				if (self.OnClicked ~= nil) then
					self.OnClicked()
				end
			end
		end)

		self.Item:SetReleasedFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end

				if (self.OnReleased ~= nil and not self.ItemList.Clicked) then
					self.ItemList.Clicked = true
					
					self.OnReleased()
				end
			end
		end)

		self.Item:SetScrollFunc(function(Value)
			if (self.Enabled) then
				if (self.OnScroll ~= nil) then
					self.OnScroll(Value)
				end
			end
		end)
	end
end)

function MenuElements.ImageButton:SetText(Text)
	self.NameItem:SetText(Text)
	self.NameItemFlash:SetText(Text)
end

function MenuElements.ImageButton:Activate()
	self.ImageItem:SetColorData(color(1.2, 1.2, 1.2, 1), 0, None, false)

	--self.Background:SetColorData(color(0.75, 0.75, 0.75, 1), 0, None, false)
	--self.SelectionPijl:SetColorData(White, 0, None, false)
	--self:Flash(2)
end

function MenuElements.ImageButton:Deactivate()
	self.ImageItem:SetColorData(White, 0, None, false)

	--self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
	--self.SelectionPijl:SetColorData(color(0, 0, 0, 0), 0, None, false)
end

function MenuElements.ImageButton:Flash(Speed)
	--self.NameItemFlash:SetColorData(White, 0, None, false)
	--self.NameItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
end

function MenuElements.ImageButton:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.ImageButton:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.NameItem:SetColorData(White, 1, Sine, false)
		self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
		self:Deactivate()
	end
end

function MenuElements.ImageButton:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.NameItem:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.Background:SetColorData(color(0.2, 0.2, 0.2, 0.5), 0, None, false)
	end
end

function MenuElements.ImageButton:Format(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:Format(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex)
		end
	end
end

function MenuElements.ImageButton:FormatTween(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ReverseDelay)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:FormatTween(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex, ReverseDelay)
		end
	end
end

function MenuElements.ImageButton:FormatList(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, TweenEasing, TweenDelay, TweenTime, ReverseDelay)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:FormatList(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex, TweenEasing, TweenDelay, TweenTime, ReverseDelay)
		end
	end
end