-- text item
MenuElements.LabelButtonTab = class(function(self, ItemList, Template, Name, LevelName, Price)
	self.Item = MenuItem(Template)
	self.Enabled = true
	self.Visible = true
	self.IsClockVisible = false
	self.PriceIsGolo = false
	
	self.NameItem = self.Item:GetChild("ItemNameText") -- naam
	self.NameItemFlash = self.Item:GetChild("ItemNameTextFlash")
	
	self.LevelItem = self.Item:GetChild("ItemLevelText") -- level
	self.LevelItemFlash = self.Item:GetChild("ItemLevelTextFlash")
	
	self.TabPanel = self.Item:GetChild("TabPanel") -- tab met prijs
	self.ValueCoin = self.Item:GetChild("ValueCoin") -- coin plaatje
	self.ValueCoinGolo = self.Item:GetChild("ValueCoinGolo") -- coin plaatje
	self.ValueClock = self.Item:GetChild("ValueClock") -- coin plaatje
	
	self.PriceText = self.Item:GetChild("PriceText") -- prijs text
	self.PriceTextFlash = self.Item:GetChild("PriceTextFlash")
	
	self.MinimumSizePanel = self.Item:GetChild("MinimumSizePanel") -- minum size item (zodat de tab niet groter word dan de knop zelf)
	
	self.Background = self.Item:GetChild("Background")
	self.SelectionPijl = self.Item:GetChild("SelectionPijl") -- geen pijl..
	-- Init

	self:SetText(Translate(Name))
	self:SetText_Level(Translate(LevelName))
	self:SetText_Price(Translate(Price))
	
	self.NameItem:SetColorData(White, 0, None, false)
	self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
	self.TabPanel:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)

	self:SetMinimumSize() -- zorg dat de tab niet groter is dan de knop zelf
	
	
	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled and self.Visible) then
			ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		--[[ if (self.Enabled and self.Visible) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end ]]--
	end)
	
	self.Item:SetClickedFunc(function()
		if (self.Enabled and self.Visible) then
			ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled and self.Visible) then
			ItemList:SetSelection(self)

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled and self.Visible) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.LabelButtonTab:SetMinimumSize()	
	self.BackgroundSizeX, self.BackgroundSizeY = self.Background:GetSize() -- haal size van item op
	self.TabSizeX, self.TabSizeY = self.TabPanel:GetSize() -- haal size van tab op
	if self.TabSizeX >= self.BackgroundSizeX then -- tab groter dan 
		self.MinimumSizePanel:SetSize(self.TabSizeX +( self.TabSizeX - self.BackgroundSizeX) + 8 , self.TabSizeY)
	end
end

function MenuElements.LabelButtonTab:SetText(Text)
	self.NameItem:SetText(Text)
	self.NameItemFlash:SetText(Text)
end

function MenuElements.LabelButtonTab:SetText_Level(Text)
	self.LevelItem:SetText(Text)
	self.LevelItemFlash:SetText(Text)
end

function MenuElements.LabelButtonTab:SetText_Price(Text)
	self.PriceText:SetText(Text)
	self.PriceTextFlash:SetText(Text)
	
	if (self.PriceIsGolo) then
		self.ValueCoinGolo:SetColorData(White, 1, Sine, false)
		self.ValueCoin:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	else
		self.ValueCoinGolo:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		self.ValueCoin:SetColorData(White, 1, Sine, false)
	end
end

function MenuElements.LabelButtonTab:Activate()
	if (self.Enabled) then
		self.Background:SetColorData(color(0.35, 0.35, 0.35, 1), 0, None, false)
		self.Background:SetColorData(color(0.75, 0.75, 0.75, 1), 1, FullSine, true)

		self.TabPanel:SetColorData(color(0.35, 0.35, 0.35, 1), 0, None, false)
		self.TabPanel:SetColorData(color(0.75, 0.75, 0.75, 1), 1, FullSine, true)

		self.SelectionPijl:SetColorData(White, 0, None, false)
		self:Flash(2)
	end
end

function MenuElements.LabelButtonTab:Deactivate()
	if (self.Enabled) then
		self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
		self.TabPanel:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
		self.SelectionPijl:SetColorData(color(0, 0, 0, 0), 0, None, false)
	end
end

function MenuElements.LabelButtonTab:Flash(Speed)
	self.NameItemFlash:SetColorData(White, 0, None, false)
	self.NameItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)

	self.LevelItemFlash:SetColorData(White, 0, None, false)
	self.LevelItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
end

function MenuElements.LabelButtonTab:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.LabelButtonTab:Enable()
	if (not self.Enabled) then
		self.Enabled = true

		self.NameItem:SetColorData(White, 1, Sine, false)
		self.LevelItem:SetColorData(White, 1, Sine, false)
		self.PriceText:SetColorData(White, 1, Sine, false)
		
		if (self.PriceIsGolo) then
			self.ValueCoinGolo:SetColorData(White, 1, Sine, false)
			self.ValueCoin:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		else
			self.ValueCoinGolo:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
			self.ValueCoin:SetColorData(White, 1, Sine, false)
		end
		
		self.Background:SetColorFade(color(0.2, 0.2, 0.2, 1), 1, Sine, false)
		self.TabPanel:SetColorFade(color(0.2, 0.2, 0.2, 1), 1, Sine, false)
		self:Deactivate()
	end
end

function MenuElements.LabelButtonTab:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.Item:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		
		self.NameItem:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.LevelItem:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.PriceText:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.ValueCoinGolo:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.ValueCoin:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		
		self.Background:SetColorData(color(0.2, 0.2, 0.2, 0.5), 0, None, false)
		self.TabPanel:SetColorData(color(0.2, 0.2, 0.2, 0.5), 0, None, false)
	end
end

function MenuElements.LabelButtonTab:Hide()
	--if (self.Visible) then
		self.Visible = false
		self.Selectable = false
		
		self:Deactivate()
		
		self.Item:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		
		self.NameItem:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		self.LevelItem:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		self.PriceText:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		self.ValueCoin:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		self.ValueCoinGolo:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		self.ValueClock:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		
		self.Background:SetColorData(color(0.2, 0.2, 0.2, 0), 0, None, false)
		self.TabPanel:SetColorData(color(0.2, 0.2, 0.2, 0), 0, None, false)
	--end
end

function MenuElements.LabelButtonTab:Show()
	if (not self.Visible) then
		self.Visible = true
		self.Selectable = true
		
		self.NameItem:SetColorData(White, 1, Sine, false)
		self.LevelItem:SetColorData(White, 1, Sine, false)
		self.PriceText:SetColorData(White, 1, Sine, false)
		
		if (self.IsClockVisible) then
			self.ValueClock:SetColorData(White, 1, Sine, false)
		else
			if (self.PriceIsGolo) then
				self.ValueCoinGolo:SetColorData(White, 1, Sine, false)
				self.ValueCoin:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
			else
				self.ValueCoinGolo:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
				self.ValueCoin:SetColorData(White, 1, Sine, false)
			end
		end
		
		self.Background:SetColorFade(color(0.2, 0.2, 0.2, 1), 1, Sine, false)
		self.TabPanel:SetColorFade(color(0.2, 0.2, 0.2, 1), 1, Sine, false)
		self:Deactivate()
	end
end

function MenuElements.LabelButtonTab:ShowClock()
	self.IsClockVisible = true
	if (self.Visible) then
		self.ValueCoinGolo:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		self.ValueCoin:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		self.ValueClock:SetColorData(White, 1, Sine, false)
	end
end