MenuElements.LabelGarageUnlock = class(function(self, ItemList, Template, Name, Price, Description)
	self.Item = MenuItem(Template)
	self.ItemList = ItemList
	self.Enabled = true
	self.Selectable = true
	self.Name = Name
	self.Description = Description
	
	self.CostGear = false
	
	--self.Main = self.Item:GetChild("Main")
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	self.Background = self.Item:GetChild("Background")
	self.NamePanel = self.Item:GetChild("NamePanel")
	self.PricePanel = self.Item:GetChild("PricePanel")
	self.PriceText = self.Item:GetChild("PriceText")
	self.PriceTextFlash = self.Item:GetChild("PriceTextFlash")
	
	self.ValueCoin = self.Item:GetChild("ValueCoin")
	self.ValueCoinGolo = self.Item:GetChild("ValueCoinGolo")
	-- Init
	self:SetText(Translate(Name), Price)
	
	self.NameItem:SetColorData(White, 0, None, false)
	
	local unlock = true
	
	if unlock then
		ActivateColor = color(0.6, 0.55, 1, 1)
		--DeActivateColor = color(0.3, 0.27, 0.5, 1)
		DeActivateColor = color(0.6, 0.55, 1, 1)
	else
		ActivateColor = color(0.6, 0.55, 1, 1)
		DeActivateColor = color(0.6, 0.55, 1, 1)
	end

	self.Background:SetColorData(DeActivateColor, 0, None, false)

	-- Functions
	if (self.ItemList ~= nil) then
		self.Item:SetActivateFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end
				
				if (self.OnActivate ~= nil) then
					self.OnActivate()
				end
			end
		end)

		self.Item:SetDeactivateFunc(function()
			--[[ if (self.Enabled) then
				self.ItemList:UnsetSelection(self)
					
				if (self.OnDeactivate ~= nil) then
					self.OnDeactivate()
				end
			end ]]--
		end)
		
		self.Item:SetClickedFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end

				if (self.OnClicked ~= nil) then
					self.OnClicked()
				end
			end
		end)

		self.Item:SetReleasedFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end

				if (self.OnReleased ~= nil) then
					self.OnReleased()
				end
			end
		end)

		self.Item:SetScrollFunc(function(Value)
			if (self.Enabled) then
				if (self.OnScroll ~= nil) then
					self.OnScroll(Value)
				end
			end
		end)
	end
end)

function MenuElements.LabelGarageUnlock:SetTemplate(template)
	self.Item = MenuItem(template)
end

function MenuElements.LabelGarageUnlock:SetText(Text, MoneyText, costgear)
	if (MoneyText ~= nil and costgear ~= nil) then
		self.CostGear = costgear
		self.NameItem:SetText(Text)
		self.PriceText:SetText(MoneyText)
		self.PriceTextFlash:SetText(MoneyText)
		local Offset = self.NamePanel:GetWidth()
		self.PricePanel:SetPos(Offset, 0)
		self.NameItemFlash:SetText(Text)
		if(self.CostGear == true) then
			self.ValueCoin:SetColorImmediate(Invisible)
			self.ValueCoinGolo:SetColorImmediate(White)
		elseif(self.CostGear == false) then
			self.ValueCoin:SetColorImmediate(White)
			self.ValueCoinGolo:SetColorImmediate(Invisible)
		else
			self.ValueCoin:SetColorImmediate(Invisible)
			self.ValueCoinGolo:SetColorImmediate(Invisible)
		end
	else
		self.ValueCoin:SetColorImmediate(Invisible)
		self.ValueCoinGolo:SetColorImmediate(Invisible)
		self.NameItem:SetColorImmediate(White)
		self.NameItem:SetText(Text)
		self.NameItemFlash:SetText(Text)
	end
end

function MenuElements.LabelGarageUnlock:Activate()
	self.Background:SetColorData(White, 0, None, false)
	self.Background:SetColorData(ActivateColor, 2, QuarterSine, false)
	
	self:Flash(2)
end

function MenuElements.LabelGarageUnlock:Deactivate()
	--self.Background:SetColorData(DeActivateColor, 0, None, false)
	
end

function MenuElements.LabelGarageUnlock:Flash(Speed)
	self.NameItemFlash:SetColorData(White, 0, None, false)
	self.NameItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
end

function MenuElements.LabelGarageUnlock:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.LabelGarageUnlock:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.NameItem:SetColorData(White, 1, None, false)
		self.Background:SetColorData(color(0.6, 0.55, 1, 1), 0, None, false)
		self:Deactivate()
	end
end

function MenuElements.LabelGarageUnlock:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.NameItem:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.Background:SetColorData(color(1, 0.2, 0.2, 0.5), 0, None, false)
	end
end

function MenuElements.LabelGarageUnlock:Format(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:Format(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex)
		end
	end
end

function MenuElements.LabelGarageUnlock:FormatTween(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ReverseDelay)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:FormatTween(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex, ReverseDelay)
		end
	end
end

function MenuElements.LabelGarageUnlock:FormatList(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, TweenEasing, TweenDelay, TweenTime, ReverseDelay)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:FormatList(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex, TweenEasing, TweenDelay, TweenTime, ReverseDelay)
		end
	end
end