-- text item
MenuElements.LabelFreeGoods = class(function(self, ItemList, Template, Name, Value, Alternative)
	self.Item = MenuItem(Template)
	self.Enabled = true
	self.Alternative = Alternative
	
	if (self.Alternative == nil) then
		self.Alternative = false
	end
	
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	
	self.CoinsValue = self.Item:GetChild("CoinsValue")
	self.AddSymbol = self.Item:GetChild("AddSymbol")
	self.CoinImage = self.Item:GetChild("CoinImage")
	self.CheckImage = self.Item:GetChild("CheckImage")
	
	self.CoinsValueFlash = self.Item:GetChild("CoinsValueFlash")
	self.AddSymbolFlash = self.Item:GetChild("AddSymbolFlash")
	self.CoinImageFlash = self.Item:GetChild("CoinImageFlash")
	
	self.Background = self.Item:GetChild("Background")
	self.CoinBackground = self.Item:GetChild("CoinBackground")
	self.HoverArea = self.Item:GetChild("HoverArea")
	self.SelectionPijl = self.Item:GetChild("SelectionPijl")
	-- Init

	self.CoinBackgroundEnabled = true
	
	self.NameItem:SetText(Translate(Name))
	self.NameItemFlash:SetText(Translate(Name))
	
	self.CoinsValue:SetText(Value)
	self.CoinsValueFlash:SetText(Value)
	
	self.NameItem:SetColorData(White, 0, None, false)
	self.Background:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
	self.CoinBackground:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
	
	-- Functions
	self.HoverArea:SetActivateFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.HoverArea:SetDeactivateFunc(function()
		--[[ if (self.Enabled) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end ]]--
	end)
	
	self.HoverArea:SetClickedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.HoverArea:SetReleasedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.HoverArea:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.LabelFreeGoods:SetText(Text)
	
end

function MenuElements.LabelFreeGoods:Activate()
	if (self.Enabled) then
		self.Background:SetColorData(White, 0, None, false)
		
		if (self.CoinBackgroundEnabled) then
			self.CoinBackground:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
		end
		
		self.SelectionPijl:SetPosData(0, 0, 0, 0.5, 0, 0.5, 0, 0, false)
		
		if (not self.Alternative) then
			self.SelectionPijl:SetPosData(48, 0, 0, 0.5, 0, 0.5, 8, QuarterSine, false)
			
			self.NameItem:SetPos(16, -6)
			self.NameItemFlash:SetPos(16, -6)
		else
			self.SelectionPijl:SetPosData(70, 0, 0, 0.5, 0, 0.5, 8, QuarterSine, false)	
			
			self.NameItem:SetPos(32, -6)
			self.NameItemFlash:SetPos(32, -6)
		end
		
		self.SelectionPijl:SetColorData(White, 0, None, false)
		self:Flash(2)
	end
end

function MenuElements.LabelFreeGoods:Deactivate()
	if (self.Enabled) then
		self.Background:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
		self.SelectionPijl:SetColorData(color(0, 0, 0, 0), 0, None, false)
	end
end

function MenuElements.LabelFreeGoods:Flash(Speed)
	self.NameItemFlash:SetColorData(White, 0, None, false)
	self.NameItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
	
	if (self.CoinBackgroundEnabled) then
		self.CoinsValueFlash:SetColorData(White, 0, None, false)
		self.CoinsValueFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
			
		self.AddSymbolFlash:SetColorData(White, 0, None, false)
		self.AddSymbolFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
			
		self.CoinImageFlash:SetColorData(White, 0, None, false)
		self.CoinImageFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
	end
end

function MenuElements.LabelFreeGoods:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.LabelFreeGoods:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.NameItem:SetColorData(White, 1, Sine, false)
		self.Background:SetColorFade(White, 1, Sine, false)
		self:Deactivate()
	end
end

function MenuElements.LabelFreeGoods:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		--self.NameItem:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.Background:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.CheckImage:SetColorData(color(0.25, 1, 0, 1), 0, None, false)
		self:HideCoinBackground()
	end
end

function MenuElements.LabelFreeGoods:HideCoinBackground()
	self.CoinBackgroundEnabled = false
	self.CoinBackground:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	self.CoinsValue:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	self.AddSymbol:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	self.CoinImage:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	
	self.CheckImage:SetColorData(color(0.25, 1, 0, 1), 0, None, false)
end