MenuElements.GetCoinButton = class(function(self, ItemList, Template, Name)
	self.Item = MenuItem(Template)
	self.ItemList = ItemList
	self.Enabled = true
	self.Selectable = true

	self.Background = self.Item:GetChild("Image")
	self.BackgroundFlash = self.Item:GetChild("ImageFlash")
	
	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				ItemList:SetSelection(self)
			end
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()

		if (self.Enabled) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	
	end)
	
	self.Item:SetClickedFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				ItemList:SetSelection(self)
			end

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				ItemList:SetSelection(self)
			end

			if (self.OnReleased ~= nil and not self.ItemList.Clicked) then				
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.GetCoinButton:Activate()
	--self.Background:SetColorData(White, 0, None, false)
	self.BackgroundFlash:SetColorData(color(1,1,1,0.5), 0, None, false)
	self.BackgroundFlash:SetColorData(Invisible, 1, Sine, false)
	self:Flash(2)
end

function MenuElements.GetCoinButton:Deactivate()
	--self.Background:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
end

function MenuElements.GetCoinButton:Flash(Speed)
		
end

function MenuElements.GetCoinButton:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.GetCoinButton:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		self.Background:SetColorFade(White, 1, Sine, false)
		self:Deactivate()
	end
end

function MenuElements.GetCoinButton:Disable()
	if (self.Enabled) then
		self.Enabled = false
		self.Background:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
	end
end