MenuElements.MenuSliderItem = class(function(self, ItemList, Template, Text, Var, Configuration, ItemColor)
	self.Item = MenuItem(Template)
	self.Enabled = true
	self.Selected = false
	
	self.Var = Var
	
	self.ItemColor = ItemColor

	self.Configuration = Configuration
	self.Items = self.Configuration.Options
	
	self.Min = 0
	self.Max = 1	
	self.Precision =  1 / (#self.Items - 1)
	self.Perc = 0
	
	if (#self.Items == 1) then
		self.Precision =  1
	end
	
	--[[if (MinPerc ~= nil) then
		self.MinPerc = MinPerc
	else
		self.MinPerc = 0
	end
	
	if (MaxPerc ~= nil) then
		self.MaxPerc = MaxPerc
	else
		self.MaxPerc = 1
	end--]]
	
	-- Init
	self.NameItem = self.Item:GetChild("Name")
	self.NameItem:SetText(translate(Text))
	self.SettingsItems = self.Item:GetChild("Settings")
	
	--self.SelectedPanel = self.Item:GetChild("Selected")
	--self.HighlightPanel = self.Item:GetChild("Highlight")
	
	self.ClickableArea = self.Item:GetChild("ClickableArea")
	self.SliderPanel = self.Item:GetChild("Slider")
	self.NameItem2 = self.Item:GetChild("HoverImage")
	self.RightButtonInside = self.Item:GetChild("RightButtonInside")
	self.LeftButtonInside = self.Item:GetChild("LeftButtonInside")
	--self.SliderBlock = self.Item:GetChild("SliderBlock")
	--self.SliderValue = self.Item:GetChild("SliderValue")
	
	self.SliderMaxWidth, self.SliderMaxHeight = self.SliderPanel:GetSize()
	self.SliderMinWidth = 33
	self.SliderMinHeight = self.SliderMaxHeight
	--self.BlockWidth, selfBlockHeight = self.SliderBlock:GetSize()
	
	self.RightButtonInside:SetColorImmediate(Invisible)
	self.LeftButtonInside:SetColorImmediate(Invisible)
	
	
	self.SliderPanel:SetColor(color(0.75, 0.75, 0.75, 1))
	
	
	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self:OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		if (self.Enabled) then
			--ItemList:UnsetSelection(self)
			
			if (self.OnDeactivate ~= nil) then
				--self:OnDeactivate()
			end
		end
	end)

	self.ClickableArea:SetClickedFunc(function(Item, X, Y)
		if (self.Enabled) then
			ItemList:SetSelection(self)
		
			self.OffsetPosX = MousePos(0):getx() - X
			
			self.SliderThread = PhysicsThread:Spawn(function()
				while (MouseKeyPressed(0)) do
					local Perc = (MousePos(0):getx() - self.OffsetPosX) / self.SliderMaxWidth
					Perc = ClampMinMax(Perc, 0, 1)
					
					self.Perc = Perc
					self:UpdateSlider(true)
					
					PhysicsThread:Wait(1)
				end
			end)
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Item, Delta)
		if (self.Enabled) then
			if (self.Precision ~= 0) then
				self.Perc = self.Perc + ((Delta / 120) * -self.Precision)
			else
				self.Perc = self.Perc + ((Delta / 120) * -0.05)
			end
			self:UpdateSlider()
		
			if (self.OnScroll ~= nil) then
				self.OnScroll(Item, Delta)
			end
		end
	end)
	
	--self:SetValue(getvar(self.Var))
	self:SetSelection(Configuration.Selection)
	self:UpdateSlider(true)
	self:UpdateVarItems()
end)

function MenuElements.MenuSliderItem:DelItem(Index)
	self.Panel:DelItem(self.Item)
end

function MenuElements.MenuSliderItem:Activate()
	if (self.Enabled) then
		--self.NameItem2:SetColorImmediate(White)
		self.RightButtonInside:SetColorImmediate(color(1, 1, 1, 1))
		self.LeftButtonInside:SetColorImmediate(color(1, 1, 1, 1))
		self.SliderPanel:SetColorFade(1, 5)
		self.SliderPanel:SetColor(self.ItemColor)
	end
end

function MenuElements.MenuSliderItem:Deactivate()
	if (self.Enabled) then
		--self.NameItem2:SetColorImmediate(Invisible)
		self.SliderPanel:SetColor(color(0.75, 0.75, 0.75, 1))
	
		self.RightButtonInside:SetColorImmediate(color(1, 1, 1, 0))
		self.LeftButtonInside:SetColorImmediate(color(1, 1, 1, 0))
	end
end

function MenuElements.MenuSliderItem:Select()
	
end

function MenuElements.MenuSliderItem:Deselect()
	
end

function MenuElements.MenuSliderItem:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.NameItem:SetColorImmediate(color(1, 1, 1, 1))
		self.SliderPanel:SetColorImmediate(color(0.75, 0.75, 0.75, 1))
	end
end

function MenuElements.MenuSliderItem:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.NameItem:SetColorImmediate(color(0.75, 0.75, 0.75, 0.2))
		self.SliderPanel:SetColorImmediate(color(0.75, 0.75, 0.75, 0.2))
		self:SetSliderSize(self.SliderMaxWidth, true)
		self.SettingsItems:SetColorImmediate(Invisible)
	end
end

function MenuElements.MenuSliderItem:Left()
	if (self.Perc > 0) then
		if (self.Precision ~= 0) then
			self.Perc = self.Perc - self.Precision
		else
			self.Perc = self.Perc - 0.05
		end
		self:UpdateSlider()
		self:UpdateVarItems()
	end
end

function MenuElements.MenuSliderItem:Right()
	if (self.Perc < 1) then
		if (self.Precision ~= 0) then
			self.Perc = self.Perc + self.Precision
		else
			self.Perc = self.Perc + 0.05
		end
		self:UpdateSlider()
		self:UpdateVarItems()
	end
end

function MenuElements.MenuSliderItem:SetValue()
	self.Perc = self:GetPerc(Value)	
end

function MenuElements.MenuSliderItem:GetPerc(Value)
	return (Value - self.Min) / (self.Max - self.Min)
end

function MenuElements.MenuSliderItem:GetValue()
	return Lerp(self.Min, self.Max, self.Perc)
end

function MenuElements.MenuSliderItem:SetSelection(Selection)
	--Selection = Selection - 1
	--self.Perc = Selection / (#self.Items - 1)
	
	if (#self.Items > 1) then
		self.Perc = self.Precision * Selection
	else
		self.Perc = 1
	end
	self:UpdateSlider()
	self:UpdateVarItems()
	--print(self.Perc .. "hallo")
end

function MenuElements.MenuSliderItem:GetSelection()
	local Selection = self.Perc * (#self.Items - 1)
	Selection = math.floor(Selection + 0.5)
	return Selection + 1
end

function MenuElements.MenuSliderItem:GetValueItem()
	local Selection = self:GetSelection()
	local Text = self.Items[Selection]
	
	return Text
end

function MenuElements.MenuSliderItem:UpdateSlider(Force)
	if (#self.Items <= 1) then
		self.Perc = 1
	end

	--self.Perc = ClampMinMax(self.Perc, self.MinPerc, self.MaxPerc)
	
	--Precision chopping
	if (self.Precision ~= 0) then
		local Chopped = math.floor((self.Perc + (self.Precision / 2)) / self.Precision);
		self.Perc = Chopped * self.Precision;
	end
	
	local Value = self:GetValue()
	
	--Set SliderPanel Size
	local SliderSize = self.SliderMaxWidth * self.Perc
	local Alpha = 1
	--print(self.Perc)
	--if (self.Perc < 0.4) then
		--Alpha = ClampMin(SliderSize / 200, 0)
	--end
	SliderSize = ClampMinMax(SliderSize, self.SliderMinWidth, self.SliderMaxWidth)
	
	self:SetSliderSize(SliderSize, Force)
	
	self.SliderPanel:SetAlpha(Alpha)
	
	local Selection = self.Perc * (#self.Items - 1)
	Selection = math.floor(Selection + 0.5)
	self.Configuration.Selection = Selection
	
	if (self.PrevPerc == nil or self.PrevPerc ~= self.Perc) then
		self:UpdateVarItems()
	end
	
	self.PrevPerc = self.Perc

	--self:SetSelection()
	
	--Set SliderBlock Position
	--self.SliderBlock:setpos( (self.BarMaxWidth * self.Perc) - (self.BlockWidth / 2), 0)
	
	--Set SliderValue Text
	--self.SliderValue:settext(Value)
	
	--var(self.Var, Value)
end

function MenuElements.MenuSliderItem:SetSliderSize(SliderSize, Force)
	if (self.SliderThread ~= nil) then
		PhysicsThread:Stop(self.SliderThread);
	end
	
	local SliderWidth, SliderHeight = self.SliderPanel:GetSize()
	local LerpVal = 0
	
	if (Force) then
		self.SliderPanel:SetSize(SliderSize, self.SliderMaxHeight)
	else
		self.SliderThread = PhysicsThread:Run(function()
		
			while(LerpVal < 1.2) do
				local NewSliderWidth = Lerp(SliderWidth, SliderSize, LerpVal)
				self.SliderPanel:SetSize(NewSliderWidth, self.SliderMaxHeight)
				LerpVal = LerpVal + 0.2
			
				PhysicsThread:Wait(1)
			end
		end)
	end
end

function MenuElements.MenuSliderItem:UpdateVarItems()
	local Text = self:GetValueItem()
	self.SettingsItems:SetColorImmediate(White)
	if (Text ~= nil) then
		self.SettingsItems:SetText(Text)
	end
end