MenuElements.TileButton = class(function(self, ItemList, Template, Car, Index, Texture)
	self.Item = MenuItem(Template)
	self.Enabled = true

	-- self.Item = self.Panel:AddItem(Template);
	self.Item:SetColorFade(1, 8)
	
	self.ImageItem = self.Item:GetChild("Image")
	self.BoughtImage = self.Item:GetChild("BoughtImage")
	self.Background = self.Item:GetChild("Background")
	--self.Background:SetColorImmediate(Invisible)
	
	self.Texture = Texture
	
	if (self.Texture ~= nil) then
		self.ImageItem:SetImage(self.Texture) -- ToDo; OPRUIMEN
	end

	self.Index = Index
	if (self.Index == nil) then
		self.Index = 1
	end
	
	self.Car = Car
	
	if (not self.Car.Bought) then
		self.BoughtImage:SetColorImmediate(Invisible)
	end
	
	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			--[[ ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end ]]--
		end
	end)

	self.Item:SetDeactivateFunc(function()
		--[[ if (self.Enabled) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end ]]--
	end)
	
	self.Item:SetClickedFunc(function()
		if (ActiveForeground.MouseOver <= 0 and not ItemList:IsSliding()) then
			if (self.Enabled) then
				--ItemList:SetSelection(self)

				if (self.OnClicked ~= nil) then
					self.OnClicked()
				end
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (ActiveForeground.MouseOver <= 0 and not ItemList:IsSliding()) then
			if (self.Enabled) then
				ItemList:SetSelection(self)

				if (self.OnReleased ~= nil) then
					self.OnReleased()
				end
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
	
	local ImageSizeX, ImageSizeY = self.ImageItem:GetSize()
	
	local ImageWidth = math.floor((SafeFrameWidth / 4) - (48 / 4)) -- size van item
	
	local ImageHeight = (ImageSizeY / ImageSizeX) * ImageWidth
	
	local ImageItemX, ImageItemY = self.ImageItem:GetSize()
	
	if ImageHeight <= ImageItemY then
		self.ImageItem:SetSize(ImageWidth, ImageHeight)
	end
end)

function MenuElements.TileButton:Activate()
	self.Background:SetColorData(color(0.775, 0.75, 0.75, 1), 0, None, false)
end

function MenuElements.TileButton:Deactivate()
	self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
end

function MenuElements.TileButton:Flash(Speed)
	self.Background:SetColorData(White, 0, None, false)
	self.Background:SetColorData(Invisible, Speed, Sine, false)
end

function MenuElements.TileButton:DelItem(Index)
	--
end

function MenuElements.TileButton:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.ImageItem:SetColorData(White, 1, Sine, false)
		
		self:Deactivate()
	end
end

function MenuElements.TileButton:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.ImageItem:SetColorData(color(1, 1, 1, 0.25), 1, Sine, false)
	end
end