MenuElements.UpdatePopup = class(function(self, Template, Panel)
	self.Item = MenuItem(Template)
	self.Panel = Panel
	self.ItemList = NewItemList(self, nil, nil)
	self.ItemList:AddItem(self.Panel, MenuElements.Label(self.ItemList, Template))
	self.MainPanel = self.ItemList.Items[1].Item
	self:ValidateVersion()
end)


function MenuElements.UpdatePopup:ValidateVersion()
	if(GetLatestFileVersion() ~= FileVersion) then
		local HeaderText = GetUpdateDetails("Header", "Text")
		local NotesText = GetUpdateDetails("Notes", "Text")
		local ExtraText = GetUpdateDetails("Extra", "Text")
	
		self.MainPanel:GetChild("UpdateHeader"):SetText(HeaderText)
		self.MainPanel:GetChild("UpdateHeader"):SetFont(GetUpdateDetails("Header", "Font"))
		
		self.MainPanel:GetChild("UpdateNotes"):SetText(NotesText)
		self.MainPanel:GetChild("UpdateNotes"):SetFont(GetUpdateDetails("Notes", "Font"))
		
		self.MainPanel:GetChild("UpdateExtra"):SetText(ExtraText)
		self.MainPanel:GetChild("UpdateExtra"):SetFont(GetUpdateDetails("Extra", "Font"))
		
		if (HeaderText == "" and NotesText == "" and ExtraText == "") then
			self.Panel:SetColor(Invisible)
		end
	else
		self.MainPanel:GetChild("UpdateHeader"):SetText(Translate("Coming_Soon"))
		self.MainPanel:SetColor(Invisible)
	end
end