MenuElements.WheelButton = class(function(self, ItemList, Template, Wheel, Index)
	self.Item = MenuItem(Template)
	self.Enabled = true

	-- self.Item = self.Panel:AddItem(Template);
	self.Item:SetColorFade(1, 8)
	
	self.ImageItem = self.Item:GetChild("Image")
	self.Background = self.Item:GetChild("Background")	
	
	self.NameItem = self.Item:GetChild("Name")
	self.NameFlashItem = self.Item:GetChild("NameFlash")
	
	self.ItemNumberItem = self.Item:GetChild("ItemNumber")
	self.ItemNumberFlashItem = self.Item:GetChild("ItemNumberFlash")
	
	self.StatusTextItem = self.Item:GetChild("StatusText")
	self.StatusTextFlashItem = self.Item:GetChild("StatusTextFlash")
	
	self.PricePanelItem = self.Item:GetChild("PricePanel")
	self.CoinImage = self.Item:GetChild("CoinImage")
	self.CoinImageFlash = self.Item:GetChild("CoinImageFlash")
	self.ValueItem = self.Item:GetChild("Value")
	self.ValueFlashItem = self.Item:GetChild("ValueFlash")
	
	self.DeliveryPanelItem = self.Item:GetChild("DeliveryPanel")
	self.DeliveryImage = self.Item:GetChild("DeliveryImage")
	self.DeliveryImageFlash = self.Item:GetChild("DeliveryImageFlash")
	self.DeliveryValueItem = self.Item:GetChild("DeliveryValue")
	self.DeliveryValueFlashItem = self.Item:GetChild("DeliveryValueFlash")
	
	self.LockedImage = self.Item:GetChild("LockedImage")
	
	self.Index = Index
	if (self.Index == nil) then
		self.Index = 1
	end
	
	self.Wheel = Wheel
	self:UpdateInfo()

	self.Texture = Texture
	
	self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
	
	if (self.Texture ~= nil) then
		self.ImageItem:SetImage(self.Texture)
	end


	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			--[[ ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end ]]--
		end
	end)

	self.Item:SetDeactivateFunc(function()
		--[[ if (self.Enabled) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end ]]--
	end)
	
	self.Item:SetClickedFunc(function()
		if (ActiveForeground.MouseOver <= 0 and not ItemList:IsSliding()) then
			if (self.Enabled) then
				--ItemList:SetSelection(self)

				if (self.OnClicked ~= nil) then
					self.OnClicked()
				end
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (ActiveForeground.MouseOver <= 0 and not ItemList:IsSliding()) then
			if (self.Enabled) then
				ItemList:SetSelection(self)

				if (self.OnReleased ~= nil) then
					self.OnReleased()
				end
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)



function MenuElements.WheelButton:SetText(Text)
	--
end

function MenuElements.WheelButton:Select()
	
end

function MenuElements.WheelButton:Unselect()
	
end

function MenuElements.WheelButton:Activate() -- standaard multilist selectie kleuren 
	self.Background:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
	-- self:Flash(2)
end

function MenuElements.WheelButton:Deactivate()
	self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
end

function MenuElements.WheelButton:Flash(Speed)
	
end

function MenuElements.WheelButton:DelItem(Index)
	--
end

function MenuElements.WheelButton:UpdateInfo()
	if (self.Wheel ~= nil) then
		self.ItemNumberItem:SetText(self.Index .. ".")
		self.ItemNumberFlashItem:SetText(self.Index .. ".")
	
		self.NameItem:SetText(Translate(self.Wheel.Title))
		self.NameFlashItem:SetText(Translate(self.Wheel.Title))
		
		if (self.Wheel.Bought or DebugUnlockAll) then
		
			local SelectedWheel = ActiveGameMode:GetSelectedWheel(ActiveGameMode:GetSelectedCar())
			if (SelectedWheel == self.Wheel) then
				self.PricePanelItem:SetColorImmediate(White)
				self.CoinImage:SetColorImmediate(Invisible)
				self.CoinImageFlash:SetColorImmediate(Invisible)
				
				self.ValueItem:SetText(Translate("menu_INSTALLED"))
				self.ValueFlashItem:SetText(Translate("menu_INSTALLED"))
				
				self.DeliveryPanelItem:SetColor(Invisible)
			else
				-- Hide price
				self.PricePanelItem:SetColorImmediate(Invisible)
				self.DeliveryPanelItem:SetColor(Invisible)
				
				if (self.Wheel.Available or DebugUnlockAll) then
					--
				else
					if (self.ClockThread ~= nil) then
						GameThread:Stop(self.ClockThread)
						self.ClockThread = nil
					end
					
					self.ClockThread = GameThread:Spawn(function()
						while (true) do
							
							local CurrentTime = os.time()
							if (self.Wheel.DeliveryTime ~= nil) then
								local WaitTime = self.Wheel.DeliveryTime - CurrentTime
								
								if (WaitTime >= 0) then
									--print("CurrentTime: " .. os.date("%d/%m/%Y %H:%M:%S", CurrentTime) .. " (" .. CurrentTime .. ")")
									
									--self.DeliveryValueItem:SetText(os.date("%d/%m/%Y %H:%M:%S", CurrentTime))
									self.DeliveryValueItem:SetText(os.date("%M:%S", WaitTime))
									self.DeliveryValueFlashItem:SetText(os.date("%M:%S", WaitTime))
								end
							end
							
							GameThread:Wait(1)
						end
					end)
				
					self.DeliveryPanelItem:SetColor(White)
					self.DeliveryValueItem:SetText("")
					self.DeliveryValueFlashItem:SetText("")
				end
			end
			
			self.LockedImage:SetColor(Invisible)
		else
			-- Show price
			self.PricePanelItem:SetColorImmediate(White)
			self.CoinImage:SetColorImmediate(White)
			self.CoinImageFlash:SetColorImmediate(Invisible)
				
			self.ValueItem:SetText(self.Wheel.ShopPriceCoins)
			self.ValueFlashItem:SetText(self.Wheel.ShopPriceCoins)
			
			self.LockedImage:SetColor(White)
			
			self.DeliveryPanelItem:SetColor(Invisible)
		end
	end
end