MenuElements.DailyReward = class(function(self, ItemList, Template, Mission, DayValue)--, Name, DayValue, Reward, Achieved)
	self.Item = MenuItem(Template)
	self.ItemList = ItemList
	self.Enabled = true
	self.Selectable = false
	self.Name = "Name" --Mission.Name
	self.DayValue = DayValue
	--self.Reward = 1000 --GetDailyRewardReward(self.DayValue)
	self.GoldReward = GetDailyReward(self.DayValue).Gold
	self.GearReward = GetDailyReward(self.DayValue).Gears
	self.Achieved = false --Mission.Achieved
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	self.Selection_Background = self.Item:GetChild("Selection_Background")
	self.DailyRewardImage = self.Item:GetChild("DailyMissionImage")
	self.DailyRewardText = self.Item:GetChild("DailyMissionText")
	self.DailyRewardTextValue = self.Item:GetChild("DailyMissionTextValue")
	
	self.DailyRewardPanelRand = self.Item:GetChild("DailyMissionPanelRand")
	self.DailyRewardCheck = self.Item:GetChild("DailyMissionCheck")
	
	-- Init
	self:SetText(self.DayValue)
	--self:SetValue(self.Reward * self.DayValue)
	self:SetValue()
	self:SetDailyImage(self.DayValue)
	self:SetDefaultLook()
	--self:Validate()
	self.NameItem:SetColorData(White, 0, None, false)
	
	--self:SetCompleted(true)
	--self:Activate()
	
	-- Functions
	if (self.ItemList ~= nil) then
		self.Item:SetActivateFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end
				
				if (self.OnActivate ~= nil) then
					self.OnActivate()
				end
			end
		end)

		self.Item:SetDeactivateFunc(function()
			--[[ if (self.Enabled) then
				self.ItemList:UnsetSelection(self)
					
				if (self.OnDeactivate ~= nil) then
					self.OnDeactivate()
				end
			end ]]--
		end)
		
		self.Item:SetClickedFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end

				if (self.OnClicked ~= nil) then
					self.OnClicked()
				end
			end
		end)

		self.Item:SetReleasedFunc(function()
			if (self.Enabled) then
				if (self.Selectable) then
					self.ItemList:SetSelection(self)
				end

				if (self.OnReleased ~= nil) then
					self.OnReleased()
				end
			end
		end)

		self.Item:SetScrollFunc(function(Value)
			if (self.Enabled) then
				if (self.OnScroll ~= nil) then
					self.OnScroll(Value)
				end
			end
		end)
	end
	
end)

function MenuElements.DailyReward:Validate()
	--if (DailyRewardsManager.CurrentMission == self.DayValue) then
		--self:Activate()
	--end
	
	--if(self.Achieved and self.DayValue <= DailyRewardsManager.CurrentMission) then
		--self:SetCompleted(true)
	--end
end

function MenuElements.DailyReward:SetText(DayValue)
	self.DailyRewardText:SetText(translate("DailyMission_Day") .. " " .. DayValue)
end

function MenuElements.DailyReward:SetValue(Reward)
	--self.DailyRewardTextValue:SetText(Reward .. " " .. (Translate("menu_gold")))
	
	local Text = ""
	if (self.GoldReward > 0) then
		Text = self.GoldReward .. " " .. (Translate("menu_gold"))
	end
	
	if (self.GearReward > 0) then
		if (Text ~= "") then
			Text = Text .. Translate("newline")
		end
		Text = Text .. self.GearReward .. " " .. (Translate("menu_golocoin"))
	end
	
	--self.DailyRewardTextValue:SetText(Reward .. " " .. (Translate("menu_gold")) .. Translate("newline") .. Reward .. " " .. (Translate("menu_gold")))
	self.DailyRewardTextValue:SetText(Text)
end

function MenuElements.DailyReward:SetDefaultLook()
	self.Selection_Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
	self.DailyRewardCheck:SetColorData(Invisible, 0, None, false)
end

function MenuElements.DailyReward:SetCompleted(Achieved)
	if Achieved then
		self.DailyRewardCheck:SetColorData(White, 0, None, false)
		self.Selection_Background:SetColorData(color(0, 0.5, 0, 1), 0, None, false)
		
		self.DailyRewardText:SetText(translate("DailyMission_Day") .. " " .. self.DayValue)
	else
		self.DailyRewardCheck:SetColorData(Invisible, 0, None, false)
		self.Selection_Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
	end
	self.Achieved = Achieved
end

function MenuElements.DailyReward:SetDailyImage(DayValue)
	--local Image = Image + 0 
	--self.DailyRewardImage:SetImage(DailyRewardsManager.Textures[Image])
	
	--DayValue = Mod(DayValue - 1, 5) + 1
	if (DayValue > 5) then
		DayValue = 5
	end
	
	local Texture1 = texture("Daily_Moneh"..DayValue..".dct")
	self.DailyRewardImage:SetImage(Texture1)
end


function MenuElements.DailyReward:Activate()
	--self.Selection_Background:SetColorData(color(0, 1, 0, 1), 0, None, false)
	--self.Selection_Background:SetColorData(color(0, 0.5, 0, 1), 1, Sine, false)
	
	self.Selection_Background:SetColorData(color(0, 0.5, 0, 1), 0, None, false)
	
	--self.DailyRewardText:SetText(translate("DailyMission_Today"))
	
	if (not self.Achieved) then
		self.DailyRewardText:SetText("> "..translate("DailyMission_Day") .. " " .. self.DayValue .. " <")
	end
	
	-- self.Selection_Background:SetColorData(color(0.75, 0.75, 0.75, 1), 0, None, false)
	-- self:Flash(2)
end

function MenuElements.DailyReward:Deactivate() -- in dit geval is het even "Achieved"
	self.DailyRewardCheck:SetColorData(White, 0, None, false)
	self.Selection_Background:SetColorData(color(0, 0.3, 0, 1), 0, None, false)
	self:SetText(self.DayValue)
end

function MenuElements.DailyReward:Flash(Speed)
	self.NameItemFlash:SetColorData(White, 0, None, false)
	self.NameItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
end

function MenuElements.DailyReward:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.DailyReward:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		
		self.NameItem:SetColorData(White, 1, Sine, false)
		self.Selection_Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
		self:Deactivate()
	end
end

function MenuElements.DailyReward:Disable()
	if (self.Enabled) then
		self.Enabled = false
		
		self.NameItem:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.Selection_Background:SetColorData(color(0.2, 0.2, 0.2, 0.5), 0, None, false)
	end
end

function MenuElements.DailyReward:Format(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:Format(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex)
		end
	end
end

function MenuElements.DailyReward:FormatTween(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ReverseDelay)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:FormatTween(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex, ReverseDelay)
		end
	end
end

function MenuElements.DailyReward:FormatList(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, TweenEasing, TweenDelay, TweenTime, ReverseDelay)
	if (self.ItemList ~= nil) then
		local ItemIndex = self.ItemList:GetItemIndex(self)
		if (ItemIndex ~= nil) then
			self.ItemList:FormatList(Alignment, OffsetX, OffsetY, ItemOffsetX, ItemOffsetY, AlignX, AlignY, ScreenAlignX, ScreenAlignY, ItemIndex - 1, ItemIndex, TweenEasing, TweenDelay, TweenTime, ReverseDelay)
		end
	end
end