-- text item
MenuElements.FriendCoinCollect = class(function(self, ItemList, Template, Friend, Value)
	self.Item = MenuItem(Template)
	self.Enabled = true
	
	self.Friend = Friend
	
	self.CurrentPlayed = 0
	self.NextCollectPlayed = 50
	
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	
	self.CoinsValue = self.Item:GetChild("CoinsValue")
	self.AddSymbol = self.Item:GetChild("AddSymbol")
	self.CoinImage = self.Item:GetChild("CoinImage")
	self.CheckImage = self.Item:GetChild("CheckImage")
	
	self.CoinsValueFlash = self.Item:GetChild("CoinsValueFlash")
	self.AddSymbolFlash = self.Item:GetChild("AddSymbolFlash")
	self.CoinImageFlash = self.Item:GetChild("CoinImageFlash")
	
	self.Background = self.Item:GetChild("Background")
	self.CoinBackground = self.Item:GetChild("CoinBackground")
	self.HoverArea = self.Item:GetChild("HoverArea")
	self.SelectionPijl = self.Item:GetChild("SelectionPijl")
	-- Init

	self.CoinBackgroundEnabled = true
	
	self.NameItem:SetText(Translate(Friend['name']))
	self.NameItemFlash:SetText(Translate(Friend['name']))
	
	self.CoinsValue:SetText(Value)
	self.CoinsValueFlash:SetText(Value)
	
	self.NameItem:SetColorData(White, 0, None, false)
	self.Background:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
	self.CoinBackground:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
	
	-- Functions
	self.HoverArea:SetActivateFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.HoverArea:SetDeactivateFunc(function()
		--[[ if (self.Enabled) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end ]]--
	end)
	
	self.HoverArea:SetClickedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.HoverArea:SetReleasedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.HoverArea:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.FriendCoinCollect:SetText(Text)
	
end

function MenuElements.FriendCoinCollect:Activate()
	if (self.Enabled) then
		self.Background:SetColorData(White, 0, None, false)
		
		if (self.CoinBackgroundEnabled) then
			self.CoinBackground:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
		end
		
		self.SelectionPijl:SetPosData(0, 0, 0, 0.5, 0, 0.5, 0, 0, false)
		self.SelectionPijl:SetPosData(48, 0, 0, 0.5, 0, 0.5, 8, QuarterSine, false)
		
		self.SelectionPijl:SetColorData(White, 0, None, false)
		self:Flash(2)
	end
end

function MenuElements.FriendCoinCollect:Deactivate()
	if (self.Enabled) then
		self.Background:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
		self.SelectionPijl:SetColorData(color(0, 0, 0, 0), 0, None, false)
	end
end

function MenuElements.FriendCoinCollect:Flash(Speed)
	self.NameItemFlash:SetColorData(White, 0, None, false)
	self.NameItemFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
	
	if (self.CoinBackgroundEnabled) then
		self.CoinsValueFlash:SetColorData(White, 0, None, false)
		self.CoinsValueFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
			
		self.AddSymbolFlash:SetColorData(White, 0, None, false)
		self.AddSymbolFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
			
		self.CoinImageFlash:SetColorData(White, 0, None, false)
		self.CoinImageFlash:SetColorData(color(1, 1, 1, 0), Speed, QuarterSine, false)
	end
end

function MenuElements.FriendCoinCollect:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.FriendCoinCollect:Enable()
	--if (not self.Enabled) then
		self.Enabled = true
		
		self.AddSymbol:SetText(Translate("menu_coin_collect"))
		self.AddSymbolFlash:SetText(Translate("menu_coin_collect"))
		
		self.CoinsValue:SetText(tostring(400))
		self.CoinsValueFlash:SetText(tostring(400))
		
		self.AddSymbol:SetColorData(White, 0, None, false)
		self.CoinImage:SetColorData(White, 0, None, false)
		
		self.NameItem:SetColorData(White, 1, Sine, false)
		self.CoinBackground:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
		self.Background:SetColorFade(White, 1, Sine, false)
		self:Deactivate()
	--end
end

function MenuElements.FriendCoinCollect:Disable()
	--if (self.Enabled) then
		self.Enabled = false
		
		--local StrPlayed = string.format(Translate("menu_played"), self.CurrentPlayed, self.NextCollectPlayed)
		
		local CurMod = self.NextCollectPlayed - 50
		local StrPlayed = string.format(Translate("menu_played"), (self.CurrentPlayed - CurMod), 50)
		
		self.AddSymbol:SetText(StrPlayed)
		self.AddSymbolFlash:SetText(StrPlayed)
		
		self.CoinsValue:SetText("")
		self.CoinsValueFlash:SetText("")
		
		self.AddSymbol:SetColorData(color(0.5, 0.5, 0.5, 1), 0, None, false)
		self.CoinImage:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
		
		--self.NameItem:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.CoinBackground:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		self.Background:SetColorData(color(0.5, 0.5, 0.5, 0.5), 0, None, false)
		--self.CheckImage:SetColorData(color(0.25, 1, 0, 1), 0, None, false)
	--end
end

function MenuElements.FriendCoinCollect:HideCoinBackground()
	self.CoinBackgroundEnabled = false
	self.CoinBackground:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	self.CoinsValue:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	self.AddSymbol:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	self.CoinImage:SetColorData(color(0.5, 0.5, 0.5, 0), 0, None, false)
	
	self.CheckImage:SetColorData(color(0.25, 1, 0, 1), 0, None, false)
end