MenuElements.FuelItem = class(function(self, ItemList, Template, Full)
	self.Item = MenuItem(Template)
	self.Enabled = true
	self.Selectable = true

	self.FuelItemBack = self.Item:GetChild("FuelItemBack")
	self.FuelItem = self.Item:GetChild("FuelItem")
	self.FuelItemFlash = self.Item:GetChild("FuelItemFlash")
	
	self.Debug = false
	
	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				ItemList:SetSelection(self)
			end
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		if (self.Enabled) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	
	end)
	
	self.Item:SetClickedFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				ItemList:SetSelection(self)
			end

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			if (self.Selectable) then
				ItemList:SetSelection(self)
			end

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	--[[ self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end) ]]
	
	if (Full) then
		self.FuelItem:SetColorData(White, 0, None, false)
	else
		self.FuelItem:SetColorData(Invisible, 0, None, false)
	end
	
end)

function MenuElements.FuelItem:Activate()
	-- self.FuelItemFlash:SetColorData(color(1,1,1,0.5), 0, None, false)
	-- self.FuelItemFlash:SetColorData(Invisible, 1, Sine, false)
end

function MenuElements.FuelItem:Deactivate()
	--
end

function MenuElements.FuelItem:Flash(Speed)

end

function MenuElements.FuelItem:DelItem(Index)
	--self.Panel:DelItem(Index)
end

function MenuElements.FuelItem:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		self.FuelItem:SetColorData(White, 1, Sine, false)
		self:Deactivate()
	end
end

function MenuElements.FuelItem:Disable()
	if (self.Enabled) then
		self.Enabled = false
		self.FuelItem:SetColorData(InvisibleBlack, 0, None, false)
	end
end

--==================================

function MenuElements.FuelItem:StartLowFuel()
	if (self.LowFuel == nil) then
		self.LowFuel = GameThread:Spawn(function()
			local Block = self.Blocks[1]
			while (self.BlocksVisible == 1) do
				if (Block ~= nil) then
					Block.Item:SetColorData(Red, 0 , None, false)
					PhysicsThread:Wait(1)
					Block.Item:SetColorData(Invisible, 0, None, false)
				end
				PhysicsThread:Wait(1)
			end
		end)
	end
end

function MenuElements.FuelItem:StopLowFuel()
	if (self.LowFuel ~= nil) then
		GameThread:Stop(self.LowFuel)
		self.LowFuel = nil
	end
	
	local Block = self.Blocks[1]
	if (Block ~= nil) then
		--Block.Item:SetColorData(White, 0 , None, false)
	end
end

function MenuElements.FuelItem:StartEmptyFuel()
	if (self.EmptyFuel == nil) then
		self.EmptyFuel = GameThread:Spawn(function()
			while (self.BlocksVisible == 0) do
				self.FuelItem:SetColor(Red)
				PhysicsThread:Wait(1)
				self.FuelItem:SetColor(Invisible)
				PhysicsThread:Wait(0.2)
			end
			self.FuelItem:SetColor(White)
		end)
	end
end

function MenuElements.FuelItem:StopEmptyFuel()
	if (self.EmptyFuel ~= nil) then
		GameThread:Stop(self.EmptyFuel)
		self.EmptyFuel = nil
	end
	
	self.FuelItem:SetColor(White)
end