SpecialPopup = class(function(self, Panel, Template)
	self.Panel = Panel
	self.Template = Template	
	
	ReDirected = false
	
	self.FadeColor = color(0,0,0,0.75)
	
	self.Goloprice = 14
	
	-- Check if the cars are already bought and thus, if the offer is applicable
	self.Cars = {GraveDiggerTheLegend, SonUvaDigger, MonsterMuttRottweiler}
	local AlreadyBought = true
	
	for i = 1, 3 do
		if (not self.Cars[i].Bought or not self.Cars[i].Available) then
			AlreadyBought = false
		end
	end
	
	if (AlreadyBought) then
		return nil
	end

	-- Add fadescreen
	if (ActiveForeground ~= nil and ActiveForeground.Main ~= nil) then
		self.FadeScreen = ActiveForeground.Main:AddItem("Elements\\WhiteItem.dcmenu")
		self.FadeScreen:SetSize(9999, 9999)
		self.FadeScreen:SetPosData(0, 0, Center, Center, Center, Center, 0, 0, false)
		self.FadeScreen:SetColorImmediate(Invisibleblack)
		self.FadeScreen:SetColor(self.FadeColor)
		self.FadeScreen:SetColorFade(1,3)
	end
	
	-- Add item
	if (self.Panel ~= nil and self.Template ~= nil) then	
		self.Item = self.Panel:AddItem(self.Template)
	end
	
	-- Disable buttons
	if (ActiveMenu ~= nil) then
		if (ActiveForeground.Items ~= nil) then
			ActiveForeground.Items.Clicked = true
		end
		if (ActiveMenu.Items ~= nil) then
			ActiveMenu.Items.Clicked = true
		end
		if (ActiveMenu.Items_GameModes ~= nil) then
			ActiveMenu.Items_GameModes.Clicked = true
		end
	end
	
	-- Init
	self.Image = self.Item:GetChild("Image")
	local XSize, YSize = self.Image:GetSize()
	local ImageAspectRatio = YSize / XSize
	
	local X, Y = self.Item:GetSize()
	X = X * ImageAspectRatio
	
	X = X * 0.9
	Y = Y * 0.9
	
	self.Item:SetSize(X, Y)
	self.Image:SetSize(X, Y)
	
	self.CloseButton = self.Item:GetChild("CloseButton")
	self.CloseButton:SetSize(X * 0.1, Y * 0.1)
	
	local Offset = 6
	self.PanelButton = self.Item:GetChild("PanelButton")
	self.PanelButton:SetPos(-(X * 0.1) - Offset, 0)
	self.PanelButton:SetSize(X * 0.9 - Offset, Y)
	
	self.CloseButton:SetReleasedFunc(function()
		AnalyticsSendEvent("SpecialOffer", "Clicking", "Closed", "1")
		self:Decline()
	end)
	
	self.PanelButton:SetReleasedFunc(function()
		AnalyticsSendEvent("SpecialOffer", "Clicking", "Continue", "1")
		self:Buy()
	end)
	
	-- Center the image
	self.Item:SetPosData(0, 0, Center, Center, Center, Center, 0, 0, false)
end)

function SpecialPopup:Destroy()
	print("Be gone")
	
	GameThread:Spawn(function()	
		self.Item:Clear()
		
		GameThread:Wait(0.1)
		
		self.FadeScreen:SetColorImmediate(self.FadeColor)
		self.FadeScreen:SetColor(Invisibleblack)
		self.FadeScreen:SetColorFade(1,3)
		
		GameThread:Wait(1)
		
		if (ActiveForeground ~= nil and ActiveForeground.Main ~= nil) then
			if (self.FadeScreen ~= nil) then
				ActiveForeground.Main:DelItem(self.FadeScreen)
			end
		end
	end)
end

function SpecialPopup:Decline()
	self:CleanUp()
	self:Destroy()
end

function SpecialPopup:Buy()	
	-- Kopen hier
	local SufficientCredits = (VirtualCoins:GetGoloCoinCount() >= self.Goloprice)
	if (not SufficientCredits) then	
		local CreditsNeeded = (self.Goloprice - VirtualCoins:GetGoloCoinCount())
		ShowConfirm_NoGolo(CreditsNeeded, GameModeSelect)
		ActiveMenu.YesButton.OnReleased()
	else
		ShowConfirm_ThanksForPurchase()
		local CleanUp = function()
			self:CleanUp()
		end
		
		ActiveMenu.ProceedAction = CleanUp
		ActiveMenu.CancelAction = CleanUp
		
		local BuyFunction = function()
			-- All upgrades
			local Upgrades = {UpgradeItem_Weight, UpgradeItem_Suspension, UpgradeItem_AirShocks, UpgradeItem_Engine, UpgradeItem_Armor, UpgradeItem_Tires}
			
			for i = 1, #self.Cars do
				local Car = self.Cars[i]
				Car.Bought = true
				Car.Available = true
				Car.DeliveryTime = os.time()
				
				for i = 1, #Upgrades do
					local Upgrade = Car.Upgrades[Upgrades[i].Name]
					local MaxLevel = #Upgrades[i].ItemLevels
					Upgrade.CurrentLevel = MaxLevel
					Upgrade.BoughtLevel = MaxLevel
				end
			end
		end
		
		if (VirtualCoins:BuyGoloProduct(self.Goloprice, BuyFunction)) then
			WriteGameSettings()
			VirtualCoins:UpdateCoincount()
		end
	end				
	
	-- Haal dit klote ding weer weg
	self:Destroy()
end

function SpecialPopup:CleanUp()
	-- Wacht een frame zodat het activemenu weer terug staat op GameModeSelect ipv ConfirmMenu en zet alles dan weer aan
	GameThread:Spawn(function()
		if (ActiveMenu ~= nil) then
			if (ActiveForeground.Items ~= nil) then
				ActiveForeground.Items.Clicked = false
			end
			if (ActiveMenu.Items ~= nil) then
				ActiveMenu.Items.Clicked = false
			end
			if (ActiveMenu.Items_GameModes ~= nil) then
				ActiveMenu.Items_GameModes.Clicked = false
			end
		end
	end)
end