FOREGROUNDSTATE_DEFAULT = 0
FOREGROUNDSTATE_INTRO = 1
FOREGROUNDSTATE_INGAME = 2
FOREGROUNDSTATE_LOADING = 3
FOREGROUNDSTATE_SIMPLE = 4

ForegroundMenu = class(function(self, ForegroundState)
	-- gooi menu er op
	self:PushMenu(ForegroundState)

	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")
	
	-- safe frame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	self.SafeFrame_Bottom = self.Menu:GetChild("SafeFrame_Bottom")
	self.SafeFrame_Bottom:SetWidth(SafeFrameWidth)
	
	--overige panels pakken
	self.RechargeItem = self.Menu:GetChild("RechargeItem")
	
	self.CoinButtonPanel = self.Menu:GetChild("CoinButtonPanel")
	
	self.FuelBuyPanel = self.Menu:GetChild("FuelBuyButton")
	self.FuelImage = self.Menu:GetChild("FuelItem")
	self.FuelImageGlow = self.Menu:GetChild("FuelGlowItem")
	
	self.FuelItemsPanel = self.Menu:GetChild("FuelItemsPanel")	
	
	self.InfoTextPanel = self.Menu:GetChild("InfoTextPanel")
	self.InfoText = self.Menu:GetChild("InfoText")
	
	self.DebugInfoPanel = self.Menu:GetChild("DebugInfoPanel")
	
	self.DescriptionPanel = self.Menu:GetChild("DescriptionTextPanel")
	self.DescriptionText = self.Menu:GetChild("DescriptionText")
	
	self.NamePanel = self.Menu:GetChild("NamePanel")
	self.PlayerTier =  self.Menu:GetChild("PlayerTier")
	self.PlayerTruckName = self.Menu:GetChild("PlayerTruckName")
	
	-- Fade in items
	self.Main:SetColorImmediate(White)
	
	self.Items = NewItemList(self)
	
	self.CoinButtonPanel:Clear()
	self.CoinsButton = self.Items:AddItem(self.CoinButtonPanel, MenuElements.GetCoinButton(self.Items, "Elements\\GetCoinButton_Template.dcMenu", "empty"))
	self.CoinsButton.OnClicked = function()
	--self.CoinsButton.OnReleased = function()
		--if (ActiveMenu ~= nil and ActiveMenu.Goto and not ActiveMenu:is_a(CoinShop)) then
			--ActiveMenu:Goto(CoinShop, ActiveMenu.PreviousMenu)
		--end
		
		if (ActiveMenu ~= nil and ActiveMenu.Goto and not ActiveMenu:is_a(CoinTypeSelect)) then
			ActiveMenu:Goto(CoinTypeSelect, ActiveMenu)
		end
	end
	
	self.FuelBuyButton = self.Items:AddItem(self.FuelBuyPanel, MenuElements.GetCoinButton(self.Items, "Elements\\MenuButton_Empty_NoSize.dcMenu", "empty"))
	self.FuelBuyButton.OnReleased = function()
		if (KeyPressed(GetKeyCode("DCK_LSHIFT"))) then
			FuelEnergy:DecreaseFuel(1)
		elseif (KeyPressed(GetKeyCode("DCK_LCONTROL"))) then
			FuelEnergy:AddFuel(1)
		else
			if (FuelEnergy:GetCurrentCapacity() < FuelEnergy:GetTotalCapacity()) then
				ShowConfirm_Refuel()
			end
		end
	end
	
	if (not UseLiveServer) then
	--if (true) then
		self.DebugItems = NewItemList(self)
		self.DebugInfo1 = self.DebugItems:AddItem(self.DebugInfoPanel, MenuElements.Label(self.DebugItems, "Elements\\MenuLabelSmall.dcMenu", "PlayerName: ^2" .. GetPlayername()))
		--if (FBManager:IsLoginValid()) then
			self.DebugInfo1 = self.DebugItems:AddItem(self.DebugInfoPanel, MenuElements.Label(self.DebugItems, "Elements\\MenuLabelSmall.dcMenu", "Facebook Name: ^2" .. tostring(FBManager.UserinfoTable['name'])))
			self.DebugInfo1.OnReleased = function()
				self.DebugInfo1:SetText("Facebook Name: ^2" .. tostring(FBManager.UserinfoTable['name']))
				self.DebugItems.Clicked = false
			end
			
			self.DebugInfo2 = self.DebugItems:AddItem(self.DebugInfoPanel, MenuElements.Label(self.DebugItems, "Elements\\MenuLabelSmall.dcMenu", "Facebook UserID: ^2" .. tostring(FBManager.UserinfoTable['HighscoresID'])))
			self.DebugInfo2.OnReleased = function()
				self.DebugInfo2:SetText("Facebook UserID: ^2" .. tostring(FBManager.UserinfoTable['HighscoresID']))
				self.DebugItems.Clicked = false
			end
		--else
			self.DebugInfo3 = self.DebugItems:AddItem(self.DebugInfoPanel, MenuElements.Label(self.DebugItems, "Elements\\MenuLabelSmall.dcMenu", "Simple UserID: ^2" .. tostring(Scores.UserID)))
		--end
		
			self.DebugInfo4 = self.DebugItems:AddItem(self.DebugInfoPanel, MenuElements.Label(self.DebugItems, "Elements\\MenuLabelSmall.dcMenu", "KeyChain UserID: ^2" .. tostring(GetKeychainValue("UserID"))))
		
		self.DebugInfo_SavedOnlineVersion = self.DebugItems:AddItem(self.DebugInfoPanel, MenuElements.Label(self.DebugItems, "Elements\\MenuLabelSmall.dcMenu", "Saved ProgressVersion: ^2" .. tostring(OnlineVersion)))
		
		self.DebugInfo_SavedOnlineVersion.OnReleased = function()
			self.DebugInfo_SavedOnlineVersion:SetText("Saved ProgressVersion: ^2" .. tostring(OnlineVersion))
			self.DebugItems.Clicked = false
		end
		
		self.DebugInfo_ServerOnlineVersion = self.DebugItems:AddItem(self.DebugInfoPanel, MenuElements.Label(self.DebugItems, "Elements\\MenuLabelSmall.dcMenu", "Online ProgressVersion: ^3" .. tostring("-")))
		
		local SuccesFunc = function(Data)
			if (Data ~= nil) then
				GameThread:Spawn(function(Thread)
					local Value = tonumber(Data['ProgressVersion'])
					self.DebugInfo_ServerOnlineVersion:SetText("Online ProgressVersion: ^2" .. tostring(Value))
				end)
			end
		end
		
		self.DebugInfo_ServerOnlineVersion.OnReleased = function()
			self.DebugInfo_ServerOnlineVersion:SetText("Online ProgressVersion: ^3" .. tostring("-"))
			CheckOnlineProgress(SuccesFunc)
			self.DebugItems.Clicked = false
		end
		
		CheckOnlineProgress(SuccesFunc)
		
		self.DebugItems:Format(ALIGN_NS, 0, 0, 0, 0, 0, 0, 0, 0)
	end
	
	self:ShowMenu()
	
	self.MouseOver = 0
	self.BalkOnder:SetActivateFunc(function()
		self.MouseOver = self.MouseOver + 1
	end)
	self.BalkOnder:SetDeactivateFunc(function()
		self.MouseOver = self.MouseOver - 1
	end)
	
	self.TitleBarBackGround = self.Menu:GetChild("TitleBarBackGround")
	self.TitleBarBackGround:SetActivateFunc(function()
		self.MouseOver = self.MouseOver + 1
	end)
	self.TitleBarBackGround:SetDeactivateFunc(function()
		self.MouseOver = self.MouseOver - 1
	end)
	
	self.ForegroundTireTracks:SetPosData(0, 0, Center, 0, Center, 0, 0, None, false)
	self.ForegroundTireTracks:SetPosData(512, 0, Center, 0, Center, 0, 0.1, Linear, true)
	
	self:UpdateCoincount()
	self:UpdateFuel()
	self:SetFuelImageGlow(false) -- true = rood flitsen
end)

function ForegroundMenu:Active()
	return ActiveForeground == self
end

function ForegroundMenu:Refresh()
	local State = self.State
	ActiveForeground = ForegroundMenu(State)
	self:ShowMenu()
	self:UpdateFuel()
end

function ForegroundMenu:PushMenu(ForegroundState)
	self.Menu = PushMenu("ForegroundMenu")
	if (ForegroundState == nil) then
		ForegroundState = FOREGROUNDSTATE_DEFAULT
	end
	
	if (self.State ~= ForegroundState) then
		self.State = ForegroundState
		self:ShowMenu()
	end
end

function ForegroundMenu:ShowMenu(ForegroundState)
	if (ForegroundState ~= nil) then
		self.State = ForegroundState
	end

	self.BalkOnder = self.Menu:GetChild("BalkOnder")
	self.ForegroundTireTracks = self.Menu:GetChild("ForegroundTireTracks")
	self.TitleBarBackGround = self.Menu:GetChild("TitleBarBackGround")
	self.Logo = self.Menu:GetChild("Logo")
	--self.Go_Lo_Logo = self.Menu:GetChild("Go_Lo_Logo")
	self.PowerBar = self.Menu:GetChild("PowerBar")
	
	if (self.State == FOREGROUNDSTATE_INTRO) then
		print('FOREGROUNDSTATE_INTRO')
		self.BalkOnder:SetColorFade(1, 4)
		self.BalkOnder:SetColor(Invisibleblack)
		
		self.ForegroundTireTracks:SetColorData(Invisibleblack, 4, Linear, false)
		
		self.TitleBarBackGround:SetPosData(-SafeFrameOffsetX, -50, Left, Bottom, Left, Top, 8, 1)
		self.Logo:SetPosDataTween(0, 60, Center, Center, Center, Center, 1, 0, false, EASE_OUT_BOUNCE)
		
		GameThread:Spawn(function()
			GameThread:Wait(0.2)
			local PanelWidth, PanelHeight = self.Logo:GetSize()
			--self.Go_Lo_Logo:SetPosDataTween(-(PanelWidth / 2) - 20, 40, Right, Center, Center, Center, 1, 0, false, EASE_OUT_ELASTIC, 1, 0.2)
		end)
		self.PowerBar:SetPosData(50, 0, Left, Bottom, Right, Bottom, 4, 1)
		
	elseif (self.State == FOREGROUNDSTATE_DEFAULT) then
		print('FOREGROUNDSTATE_DEFAULT')
		self.BalkOnder:SetColorFade(1, 4)
		self.BalkOnder:SetColorData(color(0, 0, 0, 0.75), 0, None, false)
		self.ForegroundTireTracks:SetColorData(color(0, 0, 0, 0.5), 4, Linear, false)
				
		self.TitleBarBackGround:SetPosData(-SafeFrameOffsetX, 0, Left, Top, Left, Top, 8, 1)
		
		GameThread:Spawn(function()
			self.Logo:SetPosDataTween(112, 0, Left, Center, Left, Center, 1, 0, false, EASE_OUT_BOUNCE)
			GameThread:Wait(0.1)
			--self.Go_Lo_Logo:SetPosDataTween(0, 0, Left, Center, Left, Center, 1, 0, false, EASE_OUT_ELASTIC, 1, 0.2)
			self.PowerBar:SetPosDataTween(0, 0, Right, Bottom, Right, Bottom, 1, 0, false, EASE_OUT_ELASTIC, 1, 1)
		end)
		
	elseif (self.State == FOREGROUNDSTATE_INGAME) then
		print('FOREGROUNDSTATE_INGAME')
		
		self.BalkOnder:SetColorFade(1, 4)
		self.BalkOnder:SetColor(Invisibleblack)
		self.ForegroundTireTracks:SetColorData(Invisibleblack, 4, Linear, false)
		
		self.TitleBarBackGround:SetColorImmediate(Invisible)
		self.Logo:SetColorImmediate(Invisible)
		
		--self.Go_Lo_Logo:SetColorImmediate(Invisible)
		
		self.PowerBar:SetPosData(50, 0, Left, Bottom, Right, Bottom, 4, 1)
		self.PowerBar:SetColorImmediate(Invisible)
		
	elseif (self.State == FOREGROUNDSTATE_LOADING) then
		print('FOREGROUNDSTATE_LOADING')
		
		self.BalkOnder:SetColorFade(1, 4)
		self.BalkOnder:SetColor(Invisibleblack)
		self.ForegroundTireTracks:SetColorData(Invisibleblack, 4, Linear, false)
		
		self.TitleBarBackGround:SetPosData(-SafeFrameOffsetX, -50, Left, Bottom, Left, Top, 8, 1)
		self.Logo:SetPosDataTween(96, -SafeFrameOffsetY - 100, Left, Bottom, Left, Top, 1, 0, false, EASE_OUT_BOUNCE)
		
		--self.Go_Lo_Logo:SetPosDataTween(-SafeFrameOffsetX - 50, 0, Right, Center, Left, Center, 1, 0, false, EASE_OUT_ELASTIC, 1, 0.2)
		
		self.PowerBar:SetPosData(50, 0, Left, Bottom, Right, Bottom, 4, 1)
	elseif (self.State == FOREGROUNDSTATE_SIMPLE) then		
		self.BalkOnder:SetColorFade(1, 4)
		self.BalkOnder:SetColor(Invisibleblack)
		self.ForegroundTireTracks:SetColorData(Invisibleblack, 4, Linear, false)
		
		self.TitleBarBackGround:SetPosData(-SafeFrameOffsetX, -50, Left, Bottom, Left, Top, 8, 1)
		
		self.Logo:SetPosDataTween(0, 0, Left, Top, Left, Top, 1, 0, false, EASE_OUT_BOUNCE)
		
		self.PowerBar:SetPosData(50, 0, Left, Bottom, Right, Bottom, 4, 1)
	end
end

-- ==========================================
-- Custom functions below here
-- ==========================================
function ForegroundMenu:GetTitlebarHeight()
	if (self.TitleBarBackGround ~= nil) then
		return self.TitleBarBackGround:GetHeight()
	else
		return 0
	end
end

function ForegroundMenu:GetContentHeight()
	local BottombarHeight = self:GetBottombarHeight()
	local TitlebarHeight = self:GetTitlebarHeight()
	return SafeFrameHeight - BottombarHeight - TitlebarHeight
end

function ForegroundMenu:GetBottombarHeight()
	if (self.BalkOnder ~= nil) then
		return self.BalkOnder:GetHeight()
	else
		return 0
	end
end

function ForegroundMenu:UpdateCoincount()
	local TextPanel = self.Menu:GetChild("Details_Text_Coins_LEFT")
	local TextFlashPanel = self.Menu:GetChild("Details_Text_Coins_LEFT_Flash")
	local CoinCount = VirtualCoins:GetCoinCount()
	TextPanel:SetText(CoinCount)
	TextFlashPanel:SetText(CoinCount)
	
	
	local TextPanel_Golo = self.Menu:GetChild("Details_Text_GoloCoins_LEFT")
	local TextFlashPanel_Golo = self.Menu:GetChild("Details_Text_GoloCoins_LEFT_Flash")
	local CoinCount_Golo = VirtualCoins:GetGoloCoinCount()
	TextPanel_Golo:SetText(CoinCount_Golo)
	TextFlashPanel_Golo:SetText(CoinCount_Golo)
end

function ForegroundMenu:ShowInfoText()
	self.InfoTextPanel:SetColorData(Black, 4, Sine, false)
	self.InfoText:SetColorData(White, 4, Sine, false)
end

function ForegroundMenu:SetInfoText(Text)
	self:ShowInfoText()
	self.InfoText:SetText(Text)
end

function ForegroundMenu:HideInfoText()
	self.InfoTextPanel:SetColorData(Invisibleblack, 4, Sine, false)
	self.InfoText:SetColorData(Invisible, 4, Sine, false)
end

function ForegroundMenu:ShowDescriptionText()
	self.DescriptionPanel:SetColorData(Black, 4, Sine, false)
	self.DescriptionText:SetColorData(White, 4, Sine, false)
end

function ForegroundMenu:SetDescriptionText(Text)
	self:ShowDescriptionText()
	self.DescriptionText:SetText(Text)
end

function ForegroundMenu:HideDescriptionText()
	self.DescriptionPanel:SetColorData(Invisibleblack, 4, Sine, false)
	self.DescriptionText:SetColorData(Invisible, 4, Sine, false)
end

function ForegroundMenu:ShowCarName()
	self.NamePanel:SetColorData(Black, 4, Sine, false)
	self.NamePanel:SetColorData(White, 4, Sine, false)
end

function ForegroundMenu:SetCarName(Name, Tier)
	self:ShowCarName()
	self.PlayerTruckName:SetText(Translate(Name .. "_Name"))
	
	local TierStr = ""
	if (Tier ~= nil) then
		TierStr = string.format(Translate("menu_tier"), Tier)
	end
	self.PlayerTier:SetText(TierStr)
end

function ForegroundMenu:HideCarName()
	self.NamePanel:SetColorData(Invisibleblack, 4, Sine, false)
	self.NamePanel:SetColorData(Invisible, 4, Sine, false)
end

-- ==========================================
-- Fuel stuff
-- ==========================================

function ForegroundMenu:UpdateFuel()
	self.FuelItems = NewItemList(self)
	self.FuelItemsPanel:Clear()
	self.blob = {}

	for i = 1, FuelEnergy:GetTotalCapacity() do
		if(i <= FuelEnergy:GetCurrentCapacity()) then
			self.blob[i] = self.FuelItems:AddItem(self.FuelItemsPanel, MenuElements.FuelItem(self.FuelItems, "Elements\\FuelBarItem_Template.dcMenu", true))
		else
			self.blob[i] = self.FuelItems:AddItem(self.FuelItemsPanel, MenuElements.FuelItem(self.FuelItems, "Elements\\FuelBarItem_Template.dcMenu", false))
		end
	end
	
	self.FuelItems:Format(ALIGN_WE, 0, 0, 0, 0, 0, 0, 0, 0)
end

--[[ function ForegroundMenu:StartRecharging()
	if self.Recharging == nil then
		print("IK NU LAAD OP")
		StoppedRecharging = false
		local RechargeValue = 0.1
		self.Recharging = GameThread:Spawn(function()
			while (true) do
				if FuelPower < 1 then
					--FuelPower = FuelPower + RechargeValue
					print("Power = " .. FuelPower)
					
					self.RechargeItem:SetColorData(color(0.2, 0.8, 1, 1), 0, None, false) -- bliksem icoontje pulse
					self.RechargeItem:SetColorData(color(0.1, 0.4, 0.5, 1), 1, 5, true)	-- bliksem icoontje pulse
					
				elseif FuelPower >= 1 then
					if not StoppedRecharging then
						FuelPower = 1
						self:StopRecharging()
					end
				end

				PhysicsThread:Wait(1)
			end
		end)
	end
end

function ForegroundMenu:StopRecharging()
	GameThread:Stop(self.Recharging)
	self.Recharging = nil
	if (self.RechargeItem ~= nil) then
		self.RechargeItem:SetColorData(color(0.2, 0.8, 1, 0), 0, None, false) -- batterij vol, recharge uit
	end
	print("IK LAAD NIET MEER OP")
	StoppedRecharging = true
end ]]
-- ==========================================


-- ==========================================
-- Fuel stuff
-- ==========================================

function ForegroundMenu:SetFuelImageGlow(Empty)
	if Empty then
		self.FuelImageGlow:SetColorData(Red, 0, None, false)
		self.FuelImageGlow:SetColorData(color(0,0,0,0.25), 1, Sine, true)
	else
		self.FuelImageGlow:SetColorData(color(0,0,0,0.25), 0, None, false)
	end

end
