FriendsMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("FriendsMenu", nil, function()
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		self.Items = NewItemList(self, UpButtons, DownButtons)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		self.Items.Panel = self.ItemsPanel
		
		self.CategoryPanel = self.Menu:GetChild("CategoryPanel")
		
		self.ButtonTemplate = "Elements\\FriendCoinCollectButton.dcMenu"

		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		
		--GameThread:Spawn(function(Thread)
		
			for i, Friend in pairs(FBManager.UserFriendsTable) do
				if (Friend ~= nil) then
					
					local FriendButton = self.Items:AddItem(self.ItemsPanel, MenuElements.FriendCoinCollect(self.Items, self.ButtonTemplate, Friend, ""))
					FriendButton.OnReleased = function()
						if (self.MouseOver > 0 and not self.Items:IsSliding()) then
							FriendButton.OnReleased = nil
							
							GameThread:Spawn(function(Thread)
								
								local FriendFacebookID = Friend['id']
								
								local NewCollectLimit = FriendButton.CurrentPlayed + 50
								
								local Found = false
								for i, FriendPlayed in pairs(FBManager.FriendsPlayed_Collected) do
									if (FriendPlayed['id'] == FriendFacebookID) then
										FriendPlayed['collected'] = NewCollectLimit
										Found = true
										break
									end
								end
								
								if (not Found) then
									local FriendData = {}
									FriendData['id'] = FriendFacebookID
									FriendData['collected'] = NewCollectLimit
									table.insert(FBManager.FriendsPlayed_Collected, FriendData)
								end
								
								local CoinsGained = 400
								VirtualCoins:AddCoinCount(CoinsGained)
								VirtualCoins:SendCollectedCoinsStats("FriendCollect", CoinsGained, 0)
								
								WriteGameSettings()
								
								FriendButton.NextCollectPlayed = NewCollectLimit
								
								FriendButton:Disable()
							end)
						end
					end
					FriendButton:Disable()
				end
			end
			
			self:GetFriendsPlayedStats()
		--end)
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			--self:Goto(self.PreviousMenu)
			--self:Goto(MainMenu)
			self:Goto(FreeGoodsMenu)
		end
		
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Center, 0, Center, 0, 0, self.TotalNormalButtons)
		
		--self.Items:SetSelection(self.FreeGoodsLikeDevButton)
		
		
		
		--Enable sliding
		local ItemsPanel = self.Items.Panel
		local ClickArea = self.CategoryPanel
		local ButtonSize = 64 + ButtonSpace
		local ListSpace = 500 --ActiveForeground:GetContentHeight()
		local ChangedFunc = function(NewActive)
			--if (self.ActiveItemList == self.Items_Cars) then
				--self:UpdateArrows((not self.Items_Cars:OnTop()), (not self.Items_Cars:OnBottom()))
				--Garage_ItemList_Cars_Active = self.Items_Cars.Active
			--end
		end
		
		self.MouseOver = 0
		self.CategoryPanel:SetActivateFunc(function()
			self.MouseOver = self.MouseOver + 1
		end)
		self.CategoryPanel:SetDeactivateFunc(function()
			self.MouseOver = self.MouseOver - 1
		end)
		
		self.Items.Active = 0
		self.Items:EnableSliding(ItemsPanel, ClickArea, ButtonSize, ListSpace, false, nil, nil, ChangedFunc)
		--self.Items:SnapSliding(true)
		
		
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				--self:Goto(self.PreviousMenu)
				--self:Goto(MainMenu)
				self:Goto(FreeGoodsMenu)
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.Items:GetSelection() ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
	end)
end)

function FriendsMenu:Goto(Target)
	if (ScoresUser ~= nil) then
		ScoresUser:Cancel()
	end

	ActiveMenu = Target(FriendsMenu)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function FriendsMenu:Active()
	return ActiveMenu == self
end

function FriendsMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = FriendsMenu(PreviousMenu)
end

function FriendsMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function FriendsMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function FriendsMenu:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function FriendsMenu:Back()
	self:Goto(FreeGoodsMenu)
end

-- ==============


function FriendsMenu:GetFriendsPlayedStats()
	print("FriendsMenu:GetFriendsPlayedStats")

	-- GetFriendsPlayedStats
	
	local FailureFunction = function(Data)
		print("Error getting friends played stats")
	end
	
	local SuccessFunction = function(Data)
		print('GetFriendsPlayedStats')
		
		if (Data ~= nil and Data['FriendsPlayed'] ~= nil) then
			self.Data_FriendsPlayed = Data['FriendsPlayed']
			
			if (ActiveMenu ~= nil and ActiveMenu.OnReceiveResults ~= nil) then
				ActiveMenu:OnReceiveResults()
			end
		else
			FailureFunction()
		end
	end
	
	local UserID = 0
	if (FBManager:IsLoginValid()) then
		UserID = FBManager.UserinfoTable['HighscoresID']
	else
		--UserID = Scores.UserID
	end
	
	if (UserID ~= nil and FBManager:IsLoginValid()) then			--Only connect to highscore server when we have a valid FacebookID
		print('Get friend stats for UserID: ' .. tostring(UserID))
		self.Data_FriendsPlayed = nil
		ScoresUser:GetFriendsPlayed(UserID, SuccessFunction, FailureFunction)
	end
end

function FriendsMenu:OnReceiveResults()
	
	if (self.Data_FriendsPlayed ~= nil) then
		
		for f, FriendButton in pairs(self.Items.Items) do
			if (FriendButton.Friend ~= nil) then
				local FacebookID = FriendButton.Friend['id']
				
				FriendButton:Disable()
				
				for i, Entry in ipairs(self.Data_FriendsPlayed) do
					if (FacebookID == Entry.FacebookID) then
						print(Entry.Played)
						
						local NextCollectPlayed = nil
						
						for i, FriendPlayed in pairs(FBManager.FriendsPlayed_Collected) do
							if (FriendPlayed['id'] == FacebookID) then
								NextCollectPlayed = FriendPlayed['collected']
								break
							end
						end
						
						if (NextCollectPlayed == nil) then
							NextCollectPlayed = Entry.Played + 50
							
							local Friend = {}
							Friend['id'] = Entry.FacebookID
							Friend['collected'] = NextCollectPlayed
		
							table.insert(FBManager.FriendsPlayed_Collected, Friend)
						end
						
						FriendButton.CurrentPlayed = Entry.Played
						FriendButton.NextCollectPlayed = NextCollectPlayed
						FriendButton:Disable()
						
						if (Entry.Played >= NextCollectPlayed) then
							FriendButton:Enable()
						end
						
						break
					end
				end
			end
		end
		
		WriteGameSettings()
	end
end