GameModeSelect = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	AnalyticsSendScreenName("GameModeSelect")
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("GameModeSelect", nil, function()
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		ActiveForeground:HideInfoText()
		--self.Items = NewItemList(self, UpButtons, DownButtons, function() self:UpdateInfoText() end)
		self.Items = NewItemList(self, nil, nil)
		self.Items_GameModes = NewItemList(self, LeftButtons, RightButtons) --, function() self:UpdateInfoText() end)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ItemsArrows = self.Menu:GetChild("ItemsArrows")
		
		self.ButtonTemplate = "Elements\\GameModeSelect_Template.dcMenu"
		
		-- Add Normal buttons
		self.TotalNormalButtons = 0	
		
		for i, GameMode in ipairs(GameModes) do	
			-- Only the enabled gamemodes
			if (not GameMode.Locked) then
				local LocationName = "menu_gametype_" .. GameMode.Name .. "_Theme".. tostring(MONSTERJAM_THEME_SETTING) .."_Location"
				local GameModeScore = 0
				
				if (GameMode.Chapters[1].Races[1].HighScores[1] ~= nil) then
					GameModeScore = GameMode.Chapters[1].Races[1].HighScores[1].StarScore
				end
				
				self.Element = self.Items_GameModes:AddItem(self.ItemsPanel, GameModeSelect_Template(self.Items_GameModes, self.ButtonTemplate, GameMode, "menu_gametype_title_" .. GameMode.Name, LocationName, "menu_gametype_" .. GameMode.Name .. "_description", GameMode.Image, GameModeScore))
				self.Element.OnReleased = function()
					--print("GMRelease")
					if (not self.Items_GameModes:IsSliding()) then
						for i, GameModeElement in ipairs(self.Items_GameModes.Items) do
							GameModeElement.OnReleased = nil
						end
						
						self.BackButton.OnReleased = nil
					
						GameThread:Spawn(function()
							playsound("GameMode_" .. GameMode.Name .. ".wav")
							
							GameThread:Wait(0.1)
						
							Element = GameMode
							ActiveGameMode = Element
							ActiveGameMode.ActiveChapter = ActiveGameMode:GetChapter(0)
							
							--[[ if (not FirstPlayOffer or not PlayerHasCar()) then 
								self:Goto(Garage_Cars)
							else
								self:Goto(Garage)
							end ]]
							
							self:Goto(CarSelect)
						end)
					end
					
					-- if (not self.Element.Enabled) then -->>> Erik, waarvoor is dit? Dit veroorzaakt namelijk fouten (Tanktrap wordt geactiveerd om 1 of andere reden)
						-- print("^3lol")
						-- self.Element:Enable()
					-- end
				end
			--if (GameMode.Locked) then
				--self.Element:Disable()
				--self.Element.InfoButton:Disable()
			end
		end
		
		self.TotalNormalButtons = #self.Items_GameModes.Items
		
		
		-- Add back button
		self.TotalBackButtons = 0
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			print("^3GameModeSelect ^7> ^2MainMenu")
		
			self.BackButton.OnReleased = nil
			self:Goto(MainMenu)
		end
		
		self.TotalProceedButtons = 0
		
		TutorialsEnabled = false
		--[[ self.TutorialSwitch = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonMIddle.dcMenu", "button_tutorialswitch"))
		self.TotalProceedButtons = self.TotalProceedButtons + 1
		table.insert(self.MenuDelItem_Queue, self.TutorialSwitch)
		self.TutorialSwitch.OnReleased = function()
			self.Items.Clicked = false
			-- Tutorial switch
			if (TutorialsEnabled) then
				TutorialsEnabled = false
			else
				TutorialsEnabled = true
			end
			
			WriteGameSettings()
			
			if (TutorialsEnabled) then
				self.TutorialSwitch:SetTextDirect(translate("button_tutorialswitch") .. " " .. translate("button_on"))
			else
				self.TutorialSwitch:SetTextDirect(translate("button_tutorialswitch") .. " " .. translate("button_off"))
			end
		end
		
		if (TutorialsEnabled) then
			self.TutorialSwitch:SetTextDirect(translate("button_tutorialswitch") .. " " .. translate("button_on"))
		else
			self.TutorialSwitch:SetTextDirect(translate("button_tutorialswitch") .. " " .. translate("button_off"))
		end ]]
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items
		local ButtonOffset = 0
		local ButtonSpace = 0 -- op de y as
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items_GameModes:Format(ALIGN_WE, 0, 0, 64, 0, Left, 0, Left, 0, 0, self.TotalNormalButtons)
		
		self.TotalNormalButtons = 0
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Center, Top, Center, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + 1)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Center, Top, Center, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + 1)

		self.Items_GameModes:SetSelection(self.FreestyleFestButton)
		
		
		local ItemsPanel = self.ItemsPanel 
		local ClickArea = self.Menu:GetChild("ClickArea")
		local ButtonSize = 256 + 64
		local ListSpace = SafeFrameWidth 
		local ChangedFunc = function(NewActive)
			self:UpdateArrows((not self.Items_GameModes:OnTop()), (not self.Items_GameModes:OnBottom()))
		end
		local CheckGameModesFunc = function(NewActive)
			for i, GMItem in ipairs(self.Items_GameModes.Items) do
				if (not GMItem.Enabled and not GMItem.GameMode.Locked) then
					GMItem:Enable()
				end
			end
		end
		self.Items_GameModes:EnableSliding(ItemsPanel, ClickArea, ButtonSize, ListSpace, true, nil, CheckGameModesFunc, ChangedFunc)
		
		--Add KeyListeners
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				self:Back()
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.Items_GameModes:GetSelection() ~= nil) then
					self.Items_GameModes:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		playsound("GameMode_GameMode.wav")
		
		--
		ShowSpecialOffer()
	end)
end)

function GameModeSelect:Goto(Target)
	ActiveMenu = Target(GameModeSelect)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function GameModeSelect:Active()
	return ActiveMenu == self
end

function GameModeSelect:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = GameModeSelect(PreviousMenu)
end

function GameModeSelect:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function GameModeSelect:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function GameModeSelect:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
		self.MenuDelItem_Queue = {}
	end)
end

function GameModeSelect:Back()
	self:Goto(MainMenu)
end

-- ==========================================
-- Custom functions below here
-- ==========================================
function GameModeSelect:UpdateInfoText()
	if (ActiveForeground ~= nil) then
		if (ActiveForeground.SetInfoText ~= nil and ActiveForeground.ShowInfoText ~= nil and ActiveForeground.HideInfoText ~= nil) then
			ActiveForeground:ShowInfoText()
			
			local SelectedItem = self.Items_GameModes:GetSelection()
			local Description = SelectedItem.Description
			if (Description ~= nil) then
				ActiveForeground:SetInfoText(Translate(Description))
			else
				ActiveForeground:HideInfoText()
			end
		end
	end
end

function GameModeSelect:StartRace()
	GameThread:Spawn(function()
		self.FadeScreen = self.Menu:GetChild("FadeScreen")
		self.FadeScreen:SetSize(9999, 9999)
		self.FadeScreen:SetColorFade(1, 2)
		self.FadeScreen:SetColorImmediate(color(0,0,0,0))
		self.FadeScreen:SetColor(Black)
		
		GameThread:Wait(1/60)
		
		ActiveMenu = nil
		ClearMenuStack()
		UnloadMenuTextures()
		
		ActiveGameMode.ActiveChapter = ActiveGameMode:GetChapter(0)
		ActiveGameMode.ActiveChapter.ActiveRace = ActiveGameMode.ActiveChapter.Races[2]
	end)
end

function GameModeSelect:AddArrows(ItemList)	
	self.ItemsArrows:Clear()

	self.ArrowUpButtonItem = MenuElements.Label(nil, "Elements\\CoinShop_LeftArrow.dcMenu", "button_back")
	self.ItemsArrows:AddItem(self.ArrowUpButtonItem.Item)
	
	self.ArrowUpButtonItem.Item:SetColorImmediate(Invisible)
	self.ArrowUpButtonItem.Selectable = false

	self.ArrowDownButtonItem = MenuElements.Label(nil, "Elements\\CoinShop_RightArrow.dcMenu", "button_back")
	self.ItemsArrows:AddItem(self.ArrowDownButtonItem.Item)
	
	self.ArrowDownButtonItem.Item:SetColorImmediate(Invisible)
	self.ArrowDownButtonItem.Selectable = false	
end

function GameModeSelect:UpdateArrows(UpArrow_Visible, DownArrow_Visible)
	if (self.ArrowUpButtonItem == nil or self.ArrowDownButtonItem == nil) then
		self:AddArrows(nil)
	end

	if (self.ArrowUpButtonItem ~= nil) then
		self.ArrowUpButtonItem.Item:SetColorFade(1, 10)
		if (UpArrow_Visible) then
			self.ArrowUpButtonItem.Item:SetColor(White)
		else
			self.ArrowUpButtonItem.Item:SetColor(Invisible)
		end
	end
	
	if (self.ArrowDownButtonItem ~= nil) then
		self.ArrowDownButtonItem.Item:SetColorFade(1, 10)
		if (DownArrow_Visible) then
			self.ArrowDownButtonItem.Item:SetColor(White)
		else
			self.ArrowDownButtonItem.Item:SetColor(Invisible)
		end
	end
end