GARAGE_ITEMLIST_CATEGORIES = 1
GARAGE_ITEMLIST_CARS = 2

Garage_ActiveItemList = GARAGE_ITEMLIST_CATEGORIES

Garage_ItemList_Categories_Active = 1
Garage_ItemList_Cars_Active = nil
Garage_ItemList_Wheels_Active = nil
Garage_ItemList_Colors_Active = nil

Garage = class(function(self, PreviousMenu, Car)
	self.PreviousMenu = PreviousMenu
	
	CheckOnlineProgress()
	
	AnalyticsSendScreenName("Garage")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenu("Garage")

	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")
	
	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	--
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	ActiveForeground:HideInfoText()
	
	--Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()
	
	self.CategoryPanel = self.Menu:GetChild("CategoryPanel")
	self.CategoryPanelArrows = self.Menu:GetChild("CategoryPanelArrows")
	self.CategoryItemsPanel = self.Menu:GetChild("CategoryItems")
	self.CarItemsPanel = self.Menu:GetChild("CarItems")
	self.WheelItemsPanel = self.Menu:GetChild("WheelItems")
	self.ColorItemsPanel = self.Menu:GetChild("ColorItems")
	self.ColorRGBItemsPanel = self.Menu:GetChild("ColorRGBItems")
	self.VehicleNameImage = self.Menu:GetChild("VehicleNameImage")
	self.PricePanel = self.Menu:GetChild("PricePanel")
	self.PriceImage = self.Menu:GetChild("PriceImage")
	self.PriceText = self.Menu:GetChild("PriceText")
	self.DeliverTimerPanel = self.Menu:GetChild("DeliverTimerPanel")
	self.DeliverTimeValue = self.Menu:GetChild("DeliverTimeValue")
	self.DeliverTimeValueFlash = self.Menu:GetChild("DeliverTimeValueFlash")
	
	self:SetItemlistSize()
	self.ActiveItemList = nil
	
	--self.CategoryPanel:Clear()
	self.CategoryPanelArrows:Clear()
	self.CategoryItemsPanel:Clear()
	self.CarItemsPanel:Clear()
	self.WheelItemsPanel:Clear()
	self.ColorItemsPanel:Clear()
	self.ColorRGBItemsPanel:Clear()
	
	-- ========================
	
	self:CreateCarRender()
	if (Car ~= nil) then
		self:ShowCar(Car)
	else
		ActiveMission.CarManager:ResetCarSelection()
	end
	self:ShowCategoryButtons()
	
	-- if (Garage_ActiveItemList == GARAGE_ITEMLIST_CATEGORIES) then
		-- --if (PlayerHasCar()) then
			-- ActiveMission.CarManager:ResetCarSelection()
			-- self:ShowCategoryButtons()
		-- --else
			-- --self:ShowCarButtons()
		-- --end
	-- --elseif (Garage_ActiveItemList == GARAGE_ITEMLIST_CARS) then
		-- --self:ShowCarButtons()
	-- else
		-- --if (PlayerHasCar()) then
			-- ActiveMission.CarManager:ResetCarSelection()
			-- self:ShowCategoryButtons()
		-- --else
			-- --self:ShowCarButtons()
		-- --end
	-- end
	
	-- GameThread:Spawn(function()
		-- --FirstPlayOffer = false
		-- if (not FirstPlayOffer) then
			-- FirstPlayOffer = true
			-- local FreeCoins = 7000
			-- ShowConfirm_Intro(FreeCoins)
		-- end
	-- end)
	
	GameThread:Spawn(function()
		if (ActiveMission.CarRender ~= nil) then
			ActiveMission.CarRender:Enable()
		end
		if (ActiveMission.ObjectRender ~= nil) then
			ActiveMission.ObjectRender:Disable()
		end
		
		if (ActiveMission.CarRender ~= nil) then
			ActiveMission.CarRender.CamHelper:Update()
		end
		
		if (ActiveMission.CarManager:GetCarSelection() ~= nil) then
			self:SetCarImageName(ActiveMission.CarManager:GetCarSelection())
		end
	end)
end)

function Garage:InitKeyListeners()
	ClearKeyListeners()

	AddKeyListeners(BackButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.ActiveItemList ~= nil and self.ActiveItemList.BackButton ~= nil) then
				if (self.ActiveItemList.BackButton.OnReleased ~= nil and self.ActiveItemList.BackButton.Enabled) then
					self.ActiveItemList.BackButton:OnReleased()
				end
			end
		else
			DelKeyListeners(Listeners)
		end
	end)

	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.ActiveItemList ~= nil) then
				if (self.ActiveItemList == self.Items_Cars) then
					if (self.Items_Bottom:GetSelection() ~= nil) then
						if (self.Items_Bottom:GetSelection().OnReleased ~= nil) then
							self.Items_Bottom:GetSelection():OnReleased()
						end
					end
				else
					if (self.ActiveItemList:GetSelection() ~= nil) then
						if (self.ActiveItemList:GetSelection().OnReleased ~= nil) then
							self.ActiveItemList:GetSelection():OnReleased()
						end
					end
				end
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(UpButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				self.ActiveItemList:Prev()
				if(self.ActiveItemList == self.Items_Cars) then
					self.ActiveItemList:GetSelection():OnReleased()
				end
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(DownButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				self.ActiveItemList:Next()
				if(self.ActiveItemList == self.Items_Cars) then
					self.ActiveItemList:GetSelection():OnReleased()
				end
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(LeftButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				if(self.ActiveItemList == self.Items_Cars) then
					self.Items_Bottom:Prev()
				end
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(RightButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				if(self.ActiveItemList == self.Items_Cars) then
					self.Items_Bottom:Next()
				end
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
end

function Garage:Goto(Target)
	if (self.DeliveryClockThread ~= nil) then
		GameThread:Stop(self.DeliveryClockThread)
		self.DeliveryClockThread = nil
	end
	
	ActiveMenu = Target(Garage)
	self:HideMenu()
	
	if (self.ActiveItemList ~= nil and self.ActiveItemList.DisableSliding ~= nil) then
		self.ActiveItemList:DisableSliding()
	end
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function Garage:Active()
	return ActiveMenu == self
end

function Garage:Refresh()
	self:Destroy()

	local PreviousMenu = self.PreviousMenu
	ActiveMenu = Garage(PreviousMenu)
end

function Garage:Destroy()
	self:DestroyCarRender()
end

function Garage:ShowMenu()
	print("self:ShowMenu()")
	self.Main:SetColorImmediate(White)
	
	GameThread:Spawn(function()
		if (self.CategoryButton_Hire ~= nil) then
			if (MechanicActiveRaces > 0) then
				self.CategoryButton_Hire:Disable()
			end
		end
	end)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
	
	if(ActiveGameMode:GetSelectedCar() ~= nil and ActiveGameMode:GetSelectedCar().Bought) then
		ActiveForeground:SetCarName(ActiveGameMode:GetSelectedCar().Name, ActiveGameMode:GetSelectedCar().TierNumber)
	else
		ActiveForeground:HideCarName()
	end
	self:InitKeyListeners()
end

function Garage:HideMenu(Force)
	if (Force) then
		self.Main:SetColorImmediate(Invisible)
	else
		self.Main:SetColorFade(1, 4)
		self.Main:SetColor(Invisible)
	end
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		if (Force) then
			MenuItem.Item:SetColorImmediate(Invisible)
		else
			MenuItem.Item:SetColorFade(1, 4)
			MenuItem.Item:SetColor(Invisible)
		end
	end
end

function Garage:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
	
	GameThread:Spawn(function()
		self:Destroy()
	end)
end

-- ==========================================
-- Custom functions below here
-- ==========================================
function Garage:SetItemlistSize()
	local TitleBarHeight = ActiveForeground:GetTitlebarHeight()
	local ContentHeight = ActiveForeground:GetContentHeight()

	self.CategoryPanel:SetSize(256, ContentHeight - 24) -- passend maken
	self.CategoryPanel:SetPos(0, TitleBarHeight) -- op juiste plek zetten
	--self.CategoryPanel:SetPos(0, TitleBarHeight + 24) -- op juiste plek zetten
	
	--local CatSizeX, CatSizeY = self.CategoryPanel:GetSize()
	--self.PricePanel:SetPos(-CatSizeX - 4, ContentHeight + TitleBarHeight - 80)	
end

function Garage:AddArrows(ItemList)
	--print("AddArrows: " .. tostring(self.CategoryPanel:GetItemCount()))
	
	self.CategoryPanelArrows:Clear()

	--if (self.ArrowUpButtonItem == nil) then
		self.ArrowUpButtonItem = MenuElements.Label(nil, "Elements\\Garage_UpArrow.dcMenu", "button_back")
		self.CategoryPanelArrows:AddItem(self.ArrowUpButtonItem.Item)
		
		self.ArrowUpButtonItem.Item:SetColorImmediate(Invisible)
		self.ArrowUpButtonItem.Selectable = false
	--end
	
	--if (self.ArrowDownButtonItem == nil) then
		self.ArrowDownButtonItem = MenuElements.Label(nil, "Elements\\Garage_DownArrow.dcMenu", "button_back")
		self.CategoryPanelArrows:AddItem(self.ArrowDownButtonItem.Item)
		
		self.ArrowDownButtonItem.Item:SetColorImmediate(Invisible)
		self.ArrowDownButtonItem.Selectable = false
	--end
	
end

function Garage:UpdateArrows(UpArrow_Visible, DownArrow_Visible)
	if (self.ArrowUpButtonItem == nil or self.ArrowDownButtonItem == nil) then
		self:AddArrows(nil)
	end

	if (self.ArrowUpButtonItem ~= nil) then
		self.ArrowUpButtonItem.Item:SetColorFade(1, 10)
		if (UpArrow_Visible) then
			self.ArrowUpButtonItem.Item:SetColor(White)
		else
			self.ArrowUpButtonItem.Item:SetColor(Invisible)
		end
	end
	
	if (self.ArrowDownButtonItem ~= nil) then
		self.ArrowDownButtonItem.Item:SetColorFade(1, 10)
		if (DownArrow_Visible) then
			self.ArrowDownButtonItem.Item:SetColor(White)
		else
			self.ArrowDownButtonItem.Item:SetColor(Invisible)
		end
	end
end

--Categories
function Garage:AddCategoryButtons()
	-- Panels leegmaken en lijst aanmaken
	self.Items_Categories = NewItemList(self, nil, nil)
	self.Items_Categories.Wrapping = false
	self.Items_Categories.Panel = self.CategoryItemsPanel
	self.Items_Categories.Panel:Clear()
	self.Items_Categories.TotalNormalButtons = 0
	
	self.CategoryButton_MonsterTruck = self.Items_Categories:AddItem(self.Items_Categories.Panel, MenuElements.CategoryButton(self.Items_Categories, "Elements\\MenuCategory2Lines.dcMenu", nil, "garage_monstertruck"))
	self.CategoryButton_MonsterTruck.OnReleased = function()
		if (not self.Items_Categories:IsSliding() and self.ActiveItemList == self.Items_Categories) then
			--self:HideCategoryButtons()
			--self:ShowCarButtons()
			self:Goto(Garage_Cars)
		end
	end
	
	self.CategoryButton_Hire = self.Items_Categories:AddItem(self.Items_Categories.Panel, MenuElements.CategoryButton(self.Items_Categories, "Elements\\MenuCategory.dcMenu", nil, "garage_hire"))
	self.CategoryButton_Hire.OnReleased = function()
		if (not self.Items_Categories:IsSliding() and self.ActiveItemList == self.Items_Categories) then
			ShowConfirm_Mechanic(1, 3)
		end
	end
	
	self.CategoryButton_Upgrades = self.Items_Categories:AddItem(self.Items_Categories.Panel, MenuElements.CategoryButton(self.Items_Categories, "Elements\\MenuCategory.dcMenu", nil, "garage_upgrades"))
	self.CategoryButton_Upgrades.OnReleased = function()
		if (not self.Items_Categories:IsSliding() and self.ActiveItemList == self.Items_Categories) then
			self:Goto(Garage_Upgrades)
		end
	end
	
	self.Items_Categories.TotalNormalButtons = #self.Items_Categories.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	
	-- Add buy buttons
	--self.PricePanel
	self.PricePanel:Clear()
	self.ProceedButtonGold = self.Items_Categories:AddItem(self.PricePanel, MenuElements.LabelGarageUnlock(self.Items_Categories, "Elements\\Garage_Unlock_Coins_Button.dcMenu", "button_unlock", "0.00"))
	self.ProceedButtonGear = self.Items_Categories:AddItem(self.PricePanel, MenuElements.LabelGarageUnlock(self.Items_Categories, "Elements\\Garage_Unlock_Coins_Button.dcMenu", "button_unlock", "0.00"))
	
	
	-- Add back button
	self.Items_Categories.BackButton = self.Items_Categories:AddItem(self.BottomBarItems, MenuElements.Label(self.Items_Categories, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	--self.Items_Categories.BackButton.Selectable = false
	table.insert(self.MenuDelItem_Queue, self.Items_Categories.BackButton)
	
	-- Add proceed button
	self.Items_Categories.ProceedButton = self.Items_Categories:AddItem(self.BottomBarItems, MenuElements.Label(self.Items_Categories, "Elements\\MenuButtonProceed.dcMenu", "button_proceed"))
	table.insert(self.MenuDelItem_Queue, self.Items_Categories.ProceedButton)
	
	self.Items_Categories.Active = 0
end

function Garage:ShowCategoryButtons()
	if (self.Items_Categories == nil) then
		self:AddCategoryButtons()
	end
	
	--Back button action
	self.Items_Categories.BackButton.OnReleased = function()
		self.Items_Categories.BackButton.OnReleased = nil
		if (self.ActiveItemList == self.Items_Categories) then
			if (not PlayerHasCar()) then
				self:Goto(Garage_Cars)
			else
				if (ActiveMission.CarManager.Car.Bought and ActiveMission.CarManager.Car.Available) then
					ActiveMission.CarManager:SaveCarSelection(ActiveMission.CarManager.Car)
				end
				
				self:Goto(GameModeSelect)
			end
		end
	end
	
	self:UpdateCategoryButtons()
	
	local ButtonSpace = 16
	
	-- Format normal buttons
	self.Items_Categories:Format(ALIGN_NS, 0, 0, 0, ButtonSpace, Left, 0, Right, 0, 0, self.Items_Categories.TotalNormalButtons)
	--self.Items_Categories:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.Items_Categories.TotalNormalButtons)
	self.Items_Categories:FormatList(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.Items_Categories.TotalNormalButtons, EASE_OUT_ELASTIC, 0, 2, false)
	
	
	if (self.ProceedButtonGold ~= nil) then
		if (self.ProceedButtonGold.Enabled) then
			self.ProceedButtonGold:Format(ALIGN_NS, -5, -5, 0, 0, Right, Bottom, Right, Bottom)
			self.ProceedButtonGold:FormatList(ALIGN_NS, -5, -5, 0, 0, Right, Bottom, Right, Bottom, EASE_OUT_ELASTIC, 0.1, 2)
		end
	end
	
	if (self.ProceedButtonGear ~= nil) then
		if (self.ProceedButtonGear.Enabled) then
			self.ProceedButtonGear:Format(ALIGN_NS, 5, -5, 0, 0, Left, Bottom, Left, Bottom)
			self.ProceedButtonGear:FormatList(ALIGN_NS, 5, -5, 0, 0, Left, Bottom, Left, Bottom, EASE_OUT_ELASTIC, 0.1, 2)
		end
	end
	
	if (MechanicActiveRaces > 0) then
		self.CategoryButton_Hire:Disable()
	end
	
	-- Format back button
	self.Items_Categories.BackButton:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top)
	self.Items_Categories.BackButton:FormatList(ALIGN_NS, 0, 0, 0, 0, Left, Top, Left, Top, EASE_OUT_ELASTIC, 0.1, 2)
	
	-- Format proceed button
	self.Items_Categories.ProceedButton:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top)
	if (self.Items_Categories.ProceedButton.Enabled) then
		self.Items_Categories.ProceedButton:FormatList(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, EASE_OUT_ELASTIC, 0.1, 2)
	end
	
	--Enable sliding
	local ItemsPanel = self.Items_Categories.Panel
	local ClickArea = self.CategoryPanel
	local ButtonSize = 70 + ButtonSpace
	local ListSpace = ActiveForeground:GetContentHeight()
	local ChangedFunc = function(NewActive)
		if (self.ActiveItemList == self.Items_Categories) then
			self:UpdateArrows((not self.Items_Categories:OnTop()), (not self.Items_Categories:OnBottom()))
		end
	end
	
	--Set ActiveItemList
	self.ActiveItemList = self.Items_Categories
	Garage_ActiveItemList = GARAGE_ITEMLIST_CATEGORIES
	
	--Activate current selection
	if (PlayerHasCar()) then
		--self.ActiveItemList:ActivateSelection()
	end
	--self.CategoryDecalButton:Disable()
	
	--self.Items_Categories:EnableSliding(ItemsPanel, ClickArea, ButtonSize, ListSpace, false, nil, nil, ChangedFunc)
end

function Garage:UpdateCategoryButtons()
	print("Garage:UpdateCategoryButtons")
	
	self.DeliverTimerPanel:SetColorImmediate(Invisible)
	
	if (self.DeliveryClockThread ~= nil) then
		GameThread:Stop(self.DeliveryClockThread)
		self.DeliveryClockThread = nil
	end
	
	if (self.Items_Categories.ProceedButton ~= nil) then
		local Car = ActiveMission.CarManager:GetCarSelection()
	
		if (Car ~= nil) then
			local Bought = Car.Bought
			local Available = Car.Available
			local Price = Car.ShopPriceCoins
			local GearPrice = Car.ShopPriceSpecialCoins
			--local PayGears = false
			
			--if (Price == 0) then
				--Price = Car.ShopPriceSpecialCoins
				--PayGears = true
			--end
			
			if (not Bought) then
				self.CategoryButton_Hire:Disable()
				self.CategoryButton_Hire:Disappear()
				
				self.CategoryButton_Upgrades:Disable()
				self.CategoryButton_Upgrades:Disappear()
				
				self.Items_Categories.ProceedButton:Disable()
				
				self.PricePanel:SetColorImmediate(White)
				
				if (Price > 0) then
					self.ProceedButtonGold:SetText(Translate("button_unlock"), tostring(Price), false)
					self.ProceedButtonGold:Enable()
					
					self.ProceedButtonGold.OnReleased = function()
						--print("ProceedButtonGold")
						local CoinsPrice = Price
						local genoegcredits = (VirtualCoins:GetCoinCount() >= CoinsPrice)
						if not genoegcredits then																--==== Player has not enough gold, go buy some gold
							local CreditsNeeded = (CoinsPrice - VirtualCoins:GetCoinCount())
							ShowConfirm_NoGold(CreditsNeeded, Garage)
						else																					--==== Player has enough gold, go buy the car
							ShowConfirm_BuyCar(Car, CoinsPrice, false)
						end
					end
				else
					self.ProceedButtonGold:Disable()
					self.ProceedButtonGold:Format(ALIGN_NS, -5, 500, 0, 0, Right, Top, Right, Top)
				end
				
				if (GearPrice > 0) then
					self.ProceedButtonGear:SetText(Translate("button_unlock"), tostring(GearPrice), true)
					self.ProceedButtonGear:Enable()
					
					self.ProceedButtonGear.OnReleased = function()
						print("ProceedButtonGear")
						local CoinsPrice = GearPrice
						local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= CoinsPrice)
						if not genoegcredits then																--==== Player has not enough gold, go buy some gold
							local CreditsNeeded = (CoinsPrice - VirtualCoins:GetGoloCoinCount())
							ShowConfirm_NoGolo(CreditsNeeded, Garage)
						else																					--==== Player has enough gold, go buy the car
							ShowConfirm_BuyCar(Car, CoinsPrice, true)
						end
					end
				else
					self.ProceedButtonGear:Disable()
					self.ProceedButtonGear:Format(ALIGN_NS, 5, 500, 0, 0, Left, Bottom, Left, Bottom)
				end
			elseif (not Available) then
				self.Items_Categories.ProceedButton:SetText(Translate("button_deliverNow"))
				self.PricePanel:SetColorImmediate(Invisible)
				
				self.CategoryButton_Hire:Disable()
				self.CategoryButton_Hire:Disappear()
				
				self.CategoryButton_Upgrades:Disable()
				self.CategoryButton_Upgrades:Disappear()
				
				self.Items_Categories.ProceedButton:Enable()
				
				self.DeliverTimerPanel:SetColor(White)
				
				--- timer
				local DeliveryTime = Car.DeliveryTime
				
				self.DeliveryClockThread = GameThread:Spawn(function()
					local CurrentTime = os.time()
					local WaitTime = DeliveryTime - CurrentTime
					while (WaitTime > 0) do
						local CurrentTime = os.time()
						local WaitTime = DeliveryTime - CurrentTime
						
						self.DeliverTimeValue:SetText(FormatTimeShort(WaitTime))
						
						GameThread:Wait(1)
					end
					
					self:UpdateCategoryButtons()
					
					ActiveMission.CarManager:SaveCarSelection(Car)
					ActiveForeground:SetCarName(ActiveGameMode:GetSelectedCar().Name, ActiveGameMode:GetSelectedCar().TierNumber)
				end)
			--elseif (Car ~= ActiveGameMode:GetSelectedCar() and PlayerHasCar()) then	
				--self.Items_Categories.ProceedButton:SetText(Translate("menu_select"))
				--self.PricePanel:SetColorImmediate(Invisible)
				
				--self.Items_Categories.ProceedButton:Enable()
			else
				self.Items_Categories.ProceedButton:SetText(Translate("menu_start"))
				self.PricePanel:SetColorImmediate(Invisible)
				
				self.CategoryButton_Hire:Enable()
				self.CategoryButton_Upgrades:Enable()
				
				self.Items_Categories.ProceedButton:Enable()
			end
			
			if (self.Items_Categories.ProceedButton.Enabled) then
				self.Items_Categories.ProceedButton:Flash(1, true, true, 0.5)
			end
			
			--Proceed button action
			self.Items_Categories.ProceedButton.OnReleased = function()
				if (self.ActiveItemList == self.Items_Categories) then
					if (not Bought) then
						--[[ if (not PayGears) then
							local CoinsPrice = Price
							local genoegcredits = (VirtualCoins:GetCoinCount() >= CoinsPrice)
							if not genoegcredits then																--==== Player has not enough gold, go buy some gold
								local CreditsNeeded = (CoinsPrice - VirtualCoins:GetCoinCount())
								ShowConfirm_NoGold(CreditsNeeded, Garage)
							else																					--==== Player has enough gold, go buy the car
								ShowConfirm_BuyCar(Car, Price, PayGears)
							end
						else
							local CoinsPrice = Price
							local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= CoinsPrice)
							if not genoegcredits then																--==== Player has not enough gold, go buy some gold
								local CreditsNeeded = (CoinsPrice - VirtualCoins:GetGoloCoinCount())
								ShowConfirm_NoGolo(CreditsNeeded, Garage)
							else																					--==== Player has enough gold, go buy the car
								ShowConfirm_BuyCar(Car, Price, PayGears)
							end
						end ]]
					elseif (Bought and not Available) then
						local HurryUp_GoloPrice = 1 --ClampMax(math.ceil(Price / 1000), 10)
						local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= HurryUp_GoloPrice)
						if not genoegcredits then														--==== Player has not enough Golo Bucks, go buy some golo bucks
							local CreditsNeeded = (HurryUp_GoloPrice - VirtualCoins:GetGoloCoinCount())
							ShowConfirm_NoGolo(CreditsNeeded, Garage)
						else																			--=== Player has enough Golo bucks, go buy the car
							ShowConfirm_CarNotAvailable(Car)
						end				
					elseif (Car ~= ActiveGameMode:GetSelectedCar() and not PlayerHasCar()) then
						ActiveMission.CarManager:SaveCarSelection(Car)
						ActiveForeground:SetCarName(ActiveGameMode:GetSelectedCar().Name, ActiveGameMode:GetSelectedCar().TierNumber)
						--self:EnableCategoryButtons()
					else		
						if (FuelEnergy:IsPowerAvailable() or DebugUnlockAll) then
							local SelectedCar = ActiveGameMode:GetSelectedCar()
							
							if (SelectedCar ~= nil) then
								local StartFunc = function() 
									self.Items_Categories.ProceedButton.OnReleased = nil
									self:HideMenu()
									ActiveForeground = ForegroundMenu(FOREGROUNDSTATE_LOADING)
									
									GameThread:Spawn(function()
										GameThread:Wait(0.5)	-- waarom wachten we per defintie 0.5 seconde?
										
										while (not ActiveMission.CarManager.CarLoaded) do
											GameThread:Wait(0.01)
										end
										
										GameThread:Destroy()
										ActiveMenu = nil
										ClearMenuStack()
										UnloadMenuTextures()
										
										SelectedCar.DriveCount = Inc(SelectedCar.DriveCount)
										WriteGameSettings()
										
										AnalyticsSendScreenName(ActiveGameMode.Name)
										
										ActiveGameMode:StartRace(ActiveGameMode.ActiveChapter.ActiveRace.Name, SelectedCar.Name, "")
									end)
								end
								
								if (false) then	--self:CheckBoringCar(SelectedCar)) then deze shit werkt niet goed bij terug gaan en ik ga het niet fixen
									ShowConfirm_BoringCar(StartFunc)
								else
									StartFunc()
								end
							end
						else
							-- hier melding geven dat men geen power heeft
							ShowConfirm_Refuel()
						end
					end
					self:UpdateCategoryButtons()
				end
			end
			
			if (self.Items_Categories.ProceedButton.Enabled) then
				self.Items_Categories.ProceedButton:FormatList(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, EASE_OUT_ELASTIC, 0.1, 2)
			end
		else
			print("ERROR: Er gaat iets fout want we hebben geen auto!!!!")
		end
	end
end

function Garage:HideCategoryButtons()
	local ButtonSpace = 16
	
	-- Format buttons
	--self.Items_Categories:FormatTween(ALIGN_NS, 0, 0, 0, ButtonSpace, Left, 0, Right, 0, 0, self.Items_Categories.TotalNormalButtons)
	self.Items_Categories:FormatList(ALIGN_NS, 0, 0, 0, ButtonSpace, Left, 0, Right, 0, 0, self.Items_Categories.TotalNormalButtons, EASE_OUT_ELASTIC, 0, 2, false)
	self.Items_Categories.BackButton:FormatList(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, EASE_OUT_ELASTIC, 0, 2)
	self.Items_Categories.ProceedButton:FormatList(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, EASE_OUT_ELASTIC, 0, 2)
	self.Items_Categories:DisableSliding()
	
	--Reset ActiveItemList
	if (self.ActiveItemList == self.Items_Categories) then
		self.ActiveItemList = nil
	end
end

--[[
--Cars
function Garage:AddCarButtons()
	-- Panels leegmaken en lijst aanmaken
	self.Items_Cars = NewItemList(self, nil, nil)
	self.Items_Cars.Wrapping = false
	self.Items_Cars.Panel = self.CarItemsPanel
	self.Items_Cars.Panel:Clear()
	self.Items_Cars.TotalNormalButtons = 0
	
	self.Items_Bottom = NewItemList(self, nil, nil)
	
	self.Cars_Sorted = table.copy(MonsterTruckCars.Cars)
	for i, Car in ipairs(self.Cars_Sorted) do
		Car.OrderIndex = i
	end
	table.sort(self.Cars_Sorted, Cars_Sort)
	
	
	local Index = 1
	for i, Car in ipairs(self.Cars_Sorted) do
		local NewCarButton = self.Items_Cars:AddItem(self.Items_Cars.Panel, MenuElements.CarButton(self.Items_Cars, "Elements\\MenuCar.dcMenu", Car, Index))
		
		NewCarButton.OnReleased = function()
			GameThread:Spawn(function()
				if (not self.Items_Cars:IsSliding() and self.ActiveItemList == self.Items_Cars) then
					if (NewCarButton.Car ~= nil and NewCarButton.Car.Name ~= nil) then
						if (self.Car == nil or self.Car.Car ~= NewCarButton.Car) then
							self:ShowCar(NewCarButton.Car)
							self:SetCarImageName(NewCarButton.Car.Name)
							self:UpdateCarButtons()
						end
					end
				end
			end)
		end
		
		Index = Inc(Index)
	end
	
	self.Items_Cars.TotalNormalButtons = #self.Items_Cars.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	-- Add back button
	self.Items_Cars.BackButton = self.Items_Bottom:AddItem(self.BottomBarItems, MenuElements.Label(self.Items_Bottom, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	--self.Items_Cars.BackButton.Selectable = false
	table.insert(self.MenuDelItem_Queue, self.Items_Cars.BackButton)
	
	-- Add proceed button
	self.Items_Cars.ProceedButton = self.Items_Bottom:AddItem(self.BottomBarItems, MenuElements.Label(self.Items_Bottom, "Elements\\MenuButtonProceed.dcMenu", "button_order"))
	--self.Items_Cars.ProceedButton.Selectable = false
	table.insert(self.MenuDelItem_Queue, self.Items_Cars.ProceedButton)
	
	self.Items_Cars.Active = 0
end

function Garage:ShowCarButtons()
	if (self.Items_Cars == nil) then
		self:AddCarButtons()
	end
	
	--Back button action
	self.Items_Cars.BackButton.OnReleased = function()
		GameThread:Spawn(function()
			if (self.ActiveItemList == self.Items_Cars) then
				self.Items_Cars.BackButton.OnReleased = nil
			
				--Reset car selection
				ActiveMission.CarManager:ResetCarSelection()
				self:SetCarImageName(ActiveMission.CarManager:GetCarSelection().Name)
				self:HideCarButtons()
				self:ShowCategoryButtons()
			end
		end)
	end
	
	--Proceed button action
	self.Items_Cars.ProceedButton.OnReleased = function()
		if (self.ActiveItemList == self.Items_Cars) then
			
			local Car = ActiveMission.CarManager:GetCarSelection()
			local Bought = Car.Bought
			local Available = Car.Available
			local Price = Car.ShopPriceCoins
			
			if ((Bought and Available) or DebugUnlockAll) then	--==== Car is bought and available
				--Apply car selection
				ActiveMission.CarManager:SaveCarSelection(Car)
				ActiveForeground:SetCarName(ActiveGameMode:GetSelectedCar().Name, ActiveGameMode:GetSelectedCar().TierNumber)
				self:UpdateCarButtons()
				
			elseif (Bought and not Available) then				--==== Car is bought but not available (need delivery)
				local HurryUp_GoloPrice = ClampMax(math.ceil(Price / 1000), 10)
				local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= HurryUp_GoloPrice)
				if not genoegcredits then														--==== Player has not enough Golo Bucks, go buy some golo bucks
					local CreditsNeeded = (HurryUp_GoloPrice - VirtualCoins:GetGoloCoinCount())
					ShowConfirm_NoGolo(CreditsNeeded, Garage)
				else																			--=== Player has enough Golo bucks, go buy the car
					ShowConfirm_CarNotAvailable(Car)
				end
			else																					--==== Car is not bought (and not available)
				local CoinsPrice = Price
				local genoegcredits = (VirtualCoins:GetCoinCount() >= CoinsPrice)
				if not genoegcredits then																--==== Player has not enough gold, go buy some gold
					local CreditsNeeded = (CoinsPrice - VirtualCoins:GetCoinCount())
					ShowConfirm_NoGold(CreditsNeeded, Garage)
				else																					--==== Player has enough gold, go buy the car
					ShowConfirm_BuyCar(Car, Price)
				end
			end
		end
	end
	
	local ButtonSpace = 16
	
	-- Format normal buttons
	self.Items_Cars:Format(ALIGN_NS, 0, 0, 0, ButtonSpace, Left, Top, Right, Top, 0, self.Items_Cars.TotalNormalButtons)
	self.Items_Cars:FormatList(ALIGN_NS, 0, 0, 0, ButtonSpace, Left, Top, Left, Top, 0, self.Items_Cars.TotalNormalButtons, EASE_OUT_ELASTIC, 0, 2, false)
	
	-- Format back button
	self.Items_Cars.BackButton:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top)
	self.Items_Cars.BackButton:FormatList(ALIGN_NS, 0, 0, 0, 0, Left, Top, Left, Top, EASE_OUT_ELASTIC, 0.1, 2)
	
	self.Items_Cars.ProceedButton:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top)
	self.Items_Cars.ProceedButton:FormatList(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, EASE_OUT_ELASTIC, 0.1, 2)
	
	--Set ActiveItemList
	self.ActiveItemList = self.Items_Cars
	Garage_ActiveItemList = GARAGE_ITEMLIST_CARS
	
	local Car = nil
	
	if (ActiveMission.CarManager:GetCarSelection() ~= nil) then
		Car = ActiveMission.CarManager:GetCarSelection()
	else
		Car = self.Cars_Sorted[1]	
	end
	
	if (Car ~= nil) then
		self:ShowCar(Car)
	end
	
	
	self.ActiveItemList:DeactivateSelection()
	self.Items_Cars.Active = IndexInTable(self.Cars_Sorted, Car)
	Garage_ItemList_Cars_Active = self.Items_Cars.Active
	self.ActiveItemList:ActivateSelection()
	
	--Enable sliding
	local ItemsPanel = self.Items_Cars.Panel
	local ClickArea = self.CategoryPanel
	local ButtonSize = 80 + ButtonSpace
	local ListSpace = ActiveForeground:GetContentHeight()
	local ChangedFunc = function(NewActive) 
		if (self.ActiveItemList == self.Items_Cars) then
			self:UpdateArrows((not self.Items_Cars:OnTop()), (not self.Items_Cars:OnBottom()))
			Garage_ItemList_Cars_Active = self.Items_Cars.Active
		end
	end
	
	self:UpdateCarButtons()
	self.Items_Cars:EnableSliding(ItemsPanel, ClickArea, ButtonSize, ListSpace, false, nil, nil, ChangedFunc)
	self.Items_Cars:SnapSliding(true)
end

function Garage:UpdateCarButtons()
	if (self.Items_Cars ~= nil) then
		for i, Item in ipairs(self.Items_Cars.Items) do
			if (Item.UpdateInfo ~= nil) then
				Item:UpdateInfo()
			end
		end
		
		if (self.Items_Cars.ProceedButton ~= nil) then
			--local Car = ActiveMission.CarManager:GetCarSelection()
			local Car = self.Items_Cars:GetSelection().Car
			local Bought = Car.Bought
			local Available = Car.Available
			
			if (Car == ActiveGameMode:GetSelectedCar() and PlayerHasCar()) then			--==== Car is already selected/installed and player has bought 
				self.Items_Cars.ProceedButton:Disable()
				self.Items_Cars.ProceedButton:FormatList(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, EASE_OUT_ELASTIC, 0, 2)
				self.Items_Bottom:SetSelection(self.Items_Cars.BackButton)
			else
				self.Items_Cars.ProceedButton:Enable()
				self.Items_Cars.ProceedButton:FormatList(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, EASE_OUT_ELASTIC, 0, 2)
				
				if (not Bought) then
					self.Items_Cars.ProceedButton:SetText(Translate("menu_order"))
				elseif(not Available) then
					self.Items_Cars.ProceedButton:SetText(Translate("button_deliverNow"))
				else
					self.Items_Cars.ProceedButton:SetText(Translate("menu_select"))
				end
				self.Items_Bottom:SetSelection(self.Items_Cars.ProceedButton)
			end
			self:SetCarImageName(Car.Name)
		end
		
		if (not PlayerHasCar()) then
			self.Items_Cars.BackButton:Disable()
		else
			self.Items_Cars.BackButton:Enable()
		end
	end
end

function Garage:HideCarButtons()
	local ButtonSpace = 16
	
	-- Format normal buttons
	self.Items_Cars:FormatList(ALIGN_NS, 0, 0, 0, ButtonSpace, Left, 0, Right, 0, 0, self.Items_Cars.TotalNormalButtons, EASE_OUT_ELASTIC, 0, 2, false)
	self.Items_Cars.BackButton:FormatList(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, EASE_OUT_ELASTIC, 0, 2)
	self.Items_Cars.ProceedButton:FormatList(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, EASE_OUT_ELASTIC, 0, 2)
	
	--Disable sliding
	self.Items_Cars:DisableSliding()
	
	--Reset ActiveItemList
	if (self.ActiveItemList == self.Items_Cars) then
		self.ActiveItemList = nil
	end
end]]

function Garage:SetCategoryPanelSize(Size)
	self.NewCategoryPanelSize = Size
	
	-- temp
	-- self.CategoryPanel:SetWidth(Size) --tijdelijk geen lerp
	-- self.CategoryItems:SetWidth(Size)
	-- end temp
	
	local CurrentWidth = self.CategoryItemsPanel:GetWidth()
	
	if (self.CategorySizeThread ~= nil) then
		GameThread:Stop(self.CategorySizeThread)
		self.CategorySizeThread = nil
	end
	
	self.CategorySizeThread = GameThread:Spawn(function()
		local Steps = 10
		local T = 0
		for i = 1, Steps + 1 do
			local NewWidth = Lerp(CurrentWidth, Size, T)
			self.CategoryPanel:SetWidth(NewWidth)

			T = T + (1 / Steps)
			GameThread:Wait(1 / 120)
		end
		self.CategorySizeThread = nil
	end)
	
end

function Garage:CheckBoringCar(SelectedCar)
	local MaxDiff = 5 + (5 * SelectedCar.BoringCount)
	local MaxDriveCount = 0
	
	for i, Car in ipairs(MonsterTruckCars.Cars) do
		if (Car ~= SelectedCar) then
			MaxDriveCount = Max(MaxDriveCount, Car.DriveCount)
		end
	end
	
	if (MaxDriveCount < SelectedCar.DriveCount) then
		local Diff = SelectedCar.DriveCount - MaxDriveCount
		if (Diff >= MaxDiff) then
			SelectedCar.BoringCount = Inc(SelectedCar.BoringCount)
			return true
		end
	end
	
	return false
	--return true
end


function Garage:CreateCarRender()
	print("Garage:CreateCarRender")
	self.WorldRenderTexture = self.Menu:GetChild("WorldRenderTexture")
	
	local ContentHeight = ActiveForeground:GetContentHeight() 
	local PanelWidth = SafeFrameWidth - self.CategoryPanel:GetWidth() 
	local BorderOffset = 4
	
	local TopBarSize = 128 -- ophalen uit foregroundmenu
	local GaragerenderYpos = TopBarSize + BorderOffset
	
	self.WorldRenderTexture:SetPosData(-4 - self.CategoryPanel:GetWidth() , GaragerenderYpos, Right, Top, Right, Top, 4, Linear, false)
	self.WorldRenderTexture:SetSize(PanelWidth - 2 * BorderOffset, ContentHeight - (2 * BorderOffset))
	
	self.WorldRenderTexture:SetColorImmediate(Invisible)
	PhysicsThread:Spawn(function()
		PhysicsThread:Wait(50)
		if (self.WorldRenderTexture ~= nil) then
			self.WorldRenderTexture:SetColorFade(1, 1)
			self.WorldRenderTexture:SetColor(White)
		end
	end)
	
	if (ActiveMission.CarRender ~= nil) then
		ActiveMission.CarRender:SetMenuImage(self.WorldRenderTexture)
	end
	
	self.WorldRenderTexture:SetClickedFunc(function(Item, X, Y)
		GameThread:Spawn(function()
			while (MouseKeyPressed(0)) do
				if (ActiveMission.CarRender ~= nil) then
					if (PrevMousePos == nil) then
						PrevMousePos = MousePos(0)
					end
					
					local DeltaX = MousePos(0).x - PrevMousePos.x
					local DeltaY = MousePos(0).y - PrevMousePos.y
					PrevMousePos = MousePos(0)
					
					ActiveMission.CarRender.RotationSpeed = ActiveMission.CarRender.RotationSpeed + (-DeltaX / 30)
					ActiveMission.CarRender.LiftSpeed = ActiveMission.CarRender.LiftSpeed + (DeltaY / 30)
				end
				GameThread:Wait(1 / 120)
			end
			PrevMousePos = nil
		end)
	end)
end

function Garage:DestroyCarRender()
	if (self.WorldRenderTexture ~= nil) then
		ActiveMission.CarRender:SetMenuImage(nil)
		ActiveMission.CarRender.ImageReady = false
		self.WorldRenderTexture:SetClickedFunc(nil)
		self.WorldRenderTexture = nil
	end
end


function Garage:ShowCar(Car)
	--GameThread:Spawn(function()
		ActiveMission.CarManager:ShowCar(Car)
	--end)
end

function Garage:SetCarImageName(Car)	
	self.VehicleNameImage:SetImage(Car.LogoImage)
end

