Garage_Cars = class(function(self, PreviousMenu)
	if (PreviousMenu ~= nil) then
		self.PreviousMenu = PreviousMenu
	else
		self.PreviousMenu = Garage
	end
	AnalyticsSendScreenName("Garage_Cars")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenu("Garage_Cars")
	
	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")
	
	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	self.CarItemsMainPanel = self.Menu:GetChild("CarItemsMain")
	self.CarItemsPanel = self.Menu:GetChild("CarItems")

	-- Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()
	
	GameThread:Spawn(function()
		if (not FirstPlayOffer) then
			FirstPlayOffer = true
			local FreeCoins = 7000
			ShowConfirm_Intro(FreeCoins)
		end
	end)
	
	-- All Car Tiles
	self:ShowCarTiles()
end)

function Garage_Cars:Active()
	return ActiveMenu == self
end

function Garage_Cars:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = Garage_Cars(PreviousMenu)
end

function Garage_Cars:Goto(Target, Car)
	ActiveMenu = Target(Garage_Cars, Car)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function Garage_Cars:ShowMenu()
	print("self:ShowMenu()")
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function Garage_Cars:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function Garage_Cars:AddCarTiles()
	self.ItemsCars = NewItemList(self, nil, nil)
	self.ItemsCars.Wrapping = false
	self.ItemsCars.Panel = self.CarItemsPanel
	self.ItemsCars.Panel:Clear()
	self.ItemsCars.TotalNormalButtons = 0
	
	self.ItemsBottom = NewItemList(self, nil, nil)
	
	self.CarsSorted = table.copy(MonsterTruckCars.Cars)
	-- for i, Car in ipairs(self.CarsSorted) do
		-- Car.OrderIndex = i
	-- end
	-- table.sort(self.CarsSorted, Cars_Sort)
	
	local Index = 1
	for i, Car in ipairs(self.CarsSorted) do
		local NewCarButton = self.ItemsCars:AddItem(self.ItemsCars.Panel, MenuElements.TileButton(self.ItemsCars, "Elements\\MenuTileButton.dcMenu", Car, Index, Car.LogoImage))
		
		local Xsize = math.floor((SafeFrameWidth / 4) - (48 / 4))
		--print(Xsize)
		NewCarButton.Item:SetSize(Xsize, (SafeFrameHeight / 4))
		
		NewCarButton.OnReleased = function()
			GameThread:Spawn(function()
				if (not self.ItemsCars:IsSliding()) then
					if (NewCarButton.Car ~= nil and NewCarButton.Car.Name ~= nil) then
						if (self.Car == nil or self.Car.Car ~= NewCarButton.Car) then
							NewCarButton:Flash(2)
							if (NewCarButton.Car.Bought and NewCarButton.Car.Available) then
								ActiveMission.CarManager:SaveCarSelection(NewCarButton.Car)
							end
							
							Garage_ActiveItemList = GARAGE_ITEMLIST_CATEGORIES
							self:Goto(Garage, NewCarButton.Car)
						end
					end
				end
			end)
		end
		
		Index = Inc(Index)
	end
	
	self.ItemsCars.TotalNormalButtons = #self.ItemsCars.Items
	
	-- Add back button
	-- self.ItemsCars.BackButton = self.ItemsBottom:AddItem(self.BottomBarItems, MenuElements.Label(self.ItemsBottom, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	-- table.insert(self.MenuDelItem_Queue, self.ItemsCars.BackButton)
	
	if (not PlayerHasCar()) then
		--self.ItemsCars.BackButton:Disable()
	else
		self.ItemsCars.BackButton = self.ItemsBottom:AddItem(self.BottomBarItems, MenuElements.Label(self.ItemsBottom, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		table.insert(self.MenuDelItem_Queue, self.ItemsCars.BackButton)
	
		self.ItemsCars.BackButton:Enable()
	end
	
	-- Add proceed button
	--self.ItemsCars.ProceedButton = self.ItemsBottom:AddItem(self.BottomBarItems, MenuElements.Label(self.ItemsBottom, "Elements\\MenuButtonProceed.dcMenu", "menu_button_order"))
	--self.ItemsCars.ProceedButton.Selectable = false
	--table.insert(self.MenuDelItem_Queue, self.ItemsCars.ProceedButton)
	
	--self.ItemsCars.Active = 0
end

function Garage_Cars:ShowCarTiles()
	if (self.ItemsCars == nil) then
		self:AddCarTiles()
	end
	
	--Back button action
	if (self.ItemsCars.BackButton ~= nil) then
		self.ItemsCars.BackButton.OnReleased = function()
			GameThread:Spawn(function()
				self.ItemsCars.BackButton.OnReleased = nil
				
				--Reset car selection
				--ActiveMission.CarManager:ResetCarSelection()
				Garage_ActiveItemList = GARAGE_ITEMLIST_CATEGORIES
				self:Goto(Garage)
			end)
		end
	end
	
	-- --Proceed button action
	-- self.ItemsCars.ProceedButton.OnReleased = function()
		-- --Garage_ActiveItemList = GARAGE_ITEMLIST_CARS
		-- --self:Goto(Garage)
		
		-- if (FuelEnergy:IsPowerAvailable() or DebugUnlockAll) then
			-- local SelectedCar = ActiveGameMode:GetSelectedCar()
			
			-- if (SelectedCar ~= nil) then
				-- local StartFunc = function()
					-- self.ItemsCars.ProceedButton.OnReleased = nil
					-- self:HideMenu()
					-- ActiveForeground = ForegroundMenu(FOREGROUNDSTATE_LOADING)
					
					-- GameThread:Spawn(function()
						-- GameThread:Wait(0.5)
						
						-- ActiveMenu = nil
						-- ClearMenuStack()
						-- UnloadMenuTextures()
						
						-- SelectedCar.DriveCount = Inc(SelectedCar.DriveCount)
						-- WriteGameSettings()
				
						-- ActiveGameMode:StartRace(ActiveGameMode.ActiveChapter.ActiveRace.Name, SelectedCar.Name, "")
					-- end)
				-- end
				
				-- if (self:CheckBoringCar(SelectedCar)) then
					-- ShowConfirm_BoringCar(StartFunc)
				-- else
					-- StartFunc()
				-- end
			-- end
		-- else
			-- -- hier melding geven dat men geen power heeft
			-- ShowConfirm_Refuel()
		-- end
	-- end
	
	local ButtonSpace = 14
	
	--local ButtonsToFormat = self.ItemsCars.TotalNormalButtons / 4
	local ButtonsToFormat = 4
	
	-- Format normal buttons
	self.ItemsCars:Format(ALIGN_WE, ButtonSpace / 2, 0, ButtonSpace, 0, 0, 0, 0, 0, 0, ButtonsToFormat)
	self.ItemsCars:Format(ALIGN_WE, ButtonSpace / 2, 200, ButtonSpace, 0, 0, 0, 0, 0, ButtonsToFormat, ButtonsToFormat * 2)
	self.ItemsCars:Format(ALIGN_WE, ButtonSpace / 2, 400, ButtonSpace, 0, 0, 0, 0, 0, ButtonsToFormat * 2, ButtonsToFormat * 3)
	self.ItemsCars:Format(ALIGN_WE, ButtonSpace / 2, 600, ButtonSpace, 0, 0, 0, 0, 0, ButtonsToFormat * 3, ButtonsToFormat * 4)
	self.ItemsCars:Format(ALIGN_WE, ButtonSpace / 2, 800, ButtonSpace, 0, 0, 0, 0, 0, ButtonsToFormat * 4, ButtonsToFormat * 5)
	self.ItemsCars:Format(ALIGN_WE, ButtonSpace / 2, 1000, ButtonSpace, 0, 0, 0, 0, 0, ButtonsToFormat * 5, ButtonsToFormat * 6)
	--self.ItemsCars:FormatList(ALIGN_NS, 0, 0, 0, ButtonSpace, Left, Top, Left, Top, 0, self.ItemsCars.TotalNormalButtons, EASE_OUT_ELASTIC, 0, 2, false)
	
	-- Format back button
	-- self.ItemsCars.BackButton:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top)
	-- self.ItemsCars.BackButton:FormatList(ALIGN_NS, 0, 0, 0, 0, Left, Top, Left, Top, EASE_OUT_ELASTIC, 0.1, 2)
	
	--self.ItemsCars.ProceedButton:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top)
	--self.ItemsCars.ProceedButton:FormatList(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, EASE_OUT_ELASTIC, 0.1, 2)
	
	--Set ActiveItemList
	--self.ActiveItemList = self.ItemsCars
	--Garage_ActiveItemList = GARAGE_ITEMLIST_CARS
	
	local Car = nil
	
	if (ActiveMission.CarManager:GetCarSelection() ~= nil) then
		Car = ActiveMission.CarManager:GetCarSelection()
	else
		Car = self.CarsSorted[1]	
	end
	
	-- if (Car ~= nil) then
		-- self:ShowCar(Car)
	-- end
	
	
	--self.ActiveItemList:DeactivateSelection()
	self.ItemsCars.Active = IndexInTable(self.CarsSorted, Car)
	--Garage_ItemList_Cars_Active = self.ItemsCars.Active
	--self.ActiveItemList:ActivateSelection()
	
	--Enable sliding
	local ItemsPanel = self.ItemsCars.Panel
	local ClickArea = self.CarItemsMainPanel
	local ButtonSize = (SafeFrameHeight / 4) + 14 --200 --+ ButtonSpace
	local Width, Height = ItemsPanel:GetSize()
	--local ListSpace = Height
	
	local ChangedFunc = function(NewActive)
		--Garage_ItemList_Cars_Active = self.ItemsCars.Active
	end
	
	self:UpdateCarTiles()
	self.ItemsCars:EnableSliding(ItemsPanel, ClickArea, ButtonSize, 0, false, nil, nil, ChangedFunc)
	--self.ItemsCars.Active = 0
	--self.ItemsCars:SnapSliding(true)
end

function Garage_Cars:UpdateCarTiles()
	if (self.ItemsCars ~= nil) then
		for i, Item in ipairs(self.ItemsCars.Items) do
			if (Item.UpdateInfo ~= nil) then
				Item:UpdateInfo()
			end
		end
		
		if (self.ItemsCars.ProceedButton ~= nil) then
			local Car = nil
			if (self.ItemsCars:GetSelection().Car ~= nil) then
				Car = self.ItemsCars:GetSelection().Car
			elseif (ActiveMission.CarManager:GetCarSelection() ~= nil) then
				Car = ActiveMission.CarManager:GetCarSelection()
			end
			
			if (Car ~= nil) then
				local Bought = Car.Bought
				local Available = Car.Available
				
				if (Car == self.SelectedCar and PlayerHasCar()) then			--==== Car is already selected/installed and player has bought 
					self.ItemsCars.ProceedButton:Disable()
					self.ItemsCars.ProceedButton:FormatList(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, EASE_OUT_ELASTIC, 0, 2)
					--self.ItemsBottom:SetSelection(self.ItemsCars.BackButton)
				else
					self.ItemsCars.ProceedButton:Enable()
					self.ItemsCars.ProceedButton:FormatList(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, EASE_OUT_ELASTIC, 0, 2)

					self.ItemsBottom:SetSelection(self.ItemsCars.ProceedButton)
				end
				--self:SetCarImageName(Car.Name)
			else
				print("Car is nil")
			end
		end
		
		-- if (not PlayerHasCar()) then
			-- self.ItemsCars.BackButton:Disable()
		-- else
			-- self.ItemsCars.BackButton:Enable()
		-- end
	end
end

function Garage_Cars:CheckBoringCar(SelectedCar)
	local MaxDiff = 5 + (5 * SelectedCar.BoringCount)
	local MaxDriveCount = 0
	
	for i, Car in ipairs(MonsterTruckCars.Cars) do
		if (Car ~= SelectedCar) then
			MaxDriveCount = Max(MaxDriveCount, Car.DriveCount)
		end
	end
	
	if (MaxDriveCount < SelectedCar.DriveCount) then
		local Diff = SelectedCar.DriveCount - MaxDriveCount
		if (Diff >= MaxDiff) then
			SelectedCar.BoringCount = Inc(SelectedCar.BoringCount)
			return true
		end
	end
	
	return false
	--return true
end

function Garage_Cars:ShowCar(Car)
	GameThread:Spawn(function()
		ActiveMission.CarManager:ShowCar(Car)
	end)
end

function Garage_Cars:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end