Garage_Upgrades = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	CheckOnlineProgress()
	
	AnalyticsSendScreenName("Garage_Upgrades")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenu("Garage_Upgrades")
	
	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")

	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	self.UnlockButtonPanelLeft = self.Menu:GetChild("UnlockButtonPanelLeft")
	self.UnlockButtonPanelRight = self.Menu:GetChild("UnlockButtonPanelRight")
	self.UnlockButtonPanelCenter = self.Menu:GetChild("UnlockButtonPanelCenter")
	self.Price_Or_Text = self.Menu:GetChild("Price_Or_Text")
	
	self.Items_Upgrades = self.Menu:GetChild("Items_Upgrades")
	self.Items_Upgrades_Panel = self.Menu:GetChild("Items_Upgrades_Panel")
	self.DeliverTimerPanel = self.Menu:GetChild("DeliverTimerPanel")
	self.DeliverTimeValue = self.Menu:GetChild("DeliverTimeValue")
	self.DeliverTimeValueFlash = self.Menu:GetChild("DeliverTimeValueFlash")
	self.UpgradeImage = self.Menu:GetChild("UpgradeImage")
	self.InstallText = self.Menu:GetChild("InstallText")
	self.DescriptionText = self.Menu:GetChild("DescriptionText")
	
	self.UnlockButtonPanelLeft:Clear()
	self.UnlockButtonPanelRight:Clear()
	self.UnlockButtonPanelCenter:Clear()
	
	-- Load Textures
	self.WeightTexture = texture("Upgrades\\Icon_weight.DCT")
	self.SuspensionTexture = texture("Upgrades\\Icon_Suspension.DCT")
	self.AirShockTexture = texture("Upgrades\\Icon_AirShocks.DCT")
	self.EngineTexture = texture("Upgrades\\Icon_Engine.DCT")
	self.ArmorTexture = texture("Upgrades\\Icon_Armor.DCT")
	self.TiresTexture = texture("Upgrades\\Icon_Tires.DCT")
	
	--Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()
	
	-- Panels leegmaken en lijst aanmaken
	ActiveForeground:HideInfoText()
	self.Items = NewItemList(self, nil, nil)
	self.ItemsPanel = self.Menu:GetChild("Items")
	self.ItemsPanel:Clear()
	
	self.ButtonTemplate = "Elements\\MenuButton.dcMenu"
	
	--- Items_Stats
	self.Items_Stats = self.Menu:GetChild("Items_Stats")
	self.ItemList_Stats = NewItemList(self, nil, nil)
	self.ItemList_Stats.Panel = self.Items_Stats
	self.ItemList_Stats.Panel:Clear()
	
	local Template = "Elements\\MenuSliderStats.dcMenu"
	self.StatsSlider_Acceleration = self.ItemList_Stats:AddItem(self.Items_Stats, MenuElements.SliderStats(self.Items_Stats, Template, translate("menu_upgrade_ACCELERATION")))
	self.StatsSlider_Topspeed = self.ItemList_Stats:AddItem(self.Items_Stats, MenuElements.SliderStats(self.Items_Stats, Template, translate("menu_upgrade_TOPSPEED")))
	self.StatsSlider_Strenght = self.ItemList_Stats:AddItem(self.Items_Stats, MenuElements.SliderStats(self.Items_Stats, Template, translate("menu_upgrade_STRENGTH")))
	self.StatsSlider_Weight = self.ItemList_Stats:AddItem(self.Items_Stats, MenuElements.SliderStats(self.Items_Stats, Template, translate("menu_upgrade_WEIGHT")))
	self.StatsSlider_Grip = self.ItemList_Stats:AddItem(self.Items_Stats, MenuElements.SliderStats(self.Items_Stats, Template, translate("menu_upgrade_GRIP")))
	
	local SpaceY = 10
	self.ItemList_Stats:Format(ALIGN_NS, 0, 0, 0, SpaceY, Left, 0, Left, 0)
	
	
	-- Add Normal buttons
	self.TotalNormalButtons = 0
	
	self.TotalNormalButtons = #self.Items.Items	
	
	self.ItemList_Upgrades = NewItemList(self, nil, nil)
	self.ItemList_Upgrades.Panel = self.Items_Upgrades
	self.ItemList_Upgrades.Panel:Clear()
	self.ItemList_Upgrades.TotalNormalButtons = 0
	
	self.WeightUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.CategoryButton(self.ItemList_Upgrades, "Elements\\MenuUpgrade2.dcMenu", "Weight", "garage_weight", self.WeightTexture))
	self.SuspensionUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.CategoryButton(self.ItemList_Upgrades, "Elements\\MenuUpgrade2.dcMenu", "Suspension", "garage_suspension", self.SuspensionTexture))
	self.AirShocksUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.CategoryButton(self.ItemList_Upgrades, "Elements\\MenuUpgrade2.dcMenu", "AirShocks", "garage_airshocks", self.AirShockTexture))
	self.EngineUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.CategoryButton(self.ItemList_Upgrades, "Elements\\MenuUpgrade2.dcMenu", "Engine", "garage_engine", self.EngineTexture))
	self.ArmorUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.CategoryButton(self.ItemList_Upgrades, "Elements\\MenuUpgrade2.dcMenu", "Armor", "garage_armor", self.ArmorTexture)) 
	self.TiresUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.CategoryButton(self.ItemList_Upgrades, "Elements\\MenuUpgrade2.dcMenu", "Tires", "garage_tires", self.TiresTexture))
	
	self.ItemList_Upgrades:SetSelection(self.WeightUpgrade)
	self.ItemList_Upgrades.TotalNormalButtons = #self.ItemList_Upgrades.Items
	
	-- Add back button
	self.TotalBackButtons = 0
	
	self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	self.TotalBackButtons = self.TotalBackButtons + 1
	table.insert(self.MenuDelItem_Queue, self.BackButton)
	self.BackButton.OnReleased = function()
		self.BackButton.OnReleased = nil
		self:Goto(Garage)
	end
	
	-- Add proceed button
	self.TotalProceedButtons = 0					-- Hoeveel proceed buttons zitten er nu in de lijst? handig te weten voor de formatting!
	self.ProceedButtonGold = self.Items:AddItem(self.UnlockButtonPanelLeft, MenuElements.LabelGarageUnlock(self.Items, "Elements\\Garage_Unlock_Coins_Button.dcMenu", "button_unlock", "0.00"))
	self.ProceedButtonGear = self.Items:AddItem(self.UnlockButtonPanelRight, MenuElements.LabelGarageUnlock(self.Items, "Elements\\Garage_Unlock_Coins_Button.dcMenu", "button_unlock", "0.00"))
	self.ProceedButtonBig = self.Items:AddItem(self.UnlockButtonPanelCenter, MenuElements.LabelGarageUnlock(self.Items, "Elements\\Garage_Unlock_Coins_Button.dcMenu", "button_unlock", "0.00"))
	--self.ProceedButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonProceed.dcMenu", "button_install"))
	self.TotalProceedButtons = self.TotalProceedButtons + 3
	--table.insert(self.MenuDelItem_Queue, self.ProceedButton)
	self.ProceedButtonGold.OnReleased = function()
		self:BuyFunction(false)
	end
	
	self.ProceedButtonGear.OnReleased = function()
		self:BuyFunction(true)
	end
	
	-- Settings voor formatting
	self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 16
	local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	-- Format normal buttons
	self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
	self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
	
	-- Format back button
	self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
	self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
	
	-- Format proceed button
	self.Items:Format(ALIGN_NS, 0, 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
	--self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
	
	self.Items:SetSelection(self.ProceedButtonGold)	

	ActiveGameMode:LoadTextures()
	
	self:SetItemlistSize()
	self:UpdateMenuStats()
	
	local SpaceY = 16
	self.ItemList_Upgrades:Format(ALIGN_NS, 0, 0, 0, SpaceY, Center, 0, Center, 0)
	
	local ItemsPanel = self.ItemList_Upgrades.Panel
	local ClickArea = self.Items_Upgrades_Panel
	if (ItemsPanel:GetHeight() > ClickArea:GetHeight()) then
		local ButtonSize = 128 + 16
		local ListSpace = ActiveForeground:GetContentHeight()
		self.ItemList_Upgrades:EnableSliding(ItemsPanel, ClickArea, ButtonSize, ListSpace, false, nil, nil, nil)
	end
	self.ItemList_Upgrades.Wrapping = false
	
	GameThread:Spawn(function()
		self:CreateObjectRender()
		
		if (ActiveMission.CarRender ~= nil) then
			ActiveMission.CarRender:Disable()
		end
		if (ActiveMission.ObjectRender ~= nil) then
			ActiveMission.ObjectRender:Enable()
		end
		
		if (ActiveMission.ObjectRender ~= nil) then
			ActiveMission.ObjectRender.CamHelper:Update()
		end
	end)
	
	-- Aant begin alles uitzetten! Kutspul dit./
	if (self.ProceedButtonGold ~= nil) then
		self.ProceedButtonGold:Disable()
		self.ProceedButtonGold.Panel:SetColor(Invisible)
	end
	
	if (self.ProceedButtonGear ~= nil) then
		self.ProceedButtonGear:Disable()
		self.ProceedButtonGear.Panel:SetColor(Invisible)
	end
	
	if (self.ProceedButtonBig ~= nil) then
		self.ProceedButtonBig:Disable()
		self.ProceedButtonBig.Panel:SetColor(Invisible)
	end
	
	self.Price_Or_Text:SetColorImmediate(Invisible)
	self.DeliverTimerPanel:SetColorImmediate(Invisible)
end)

function Garage_Upgrades:UpdateMenuStats()
	self:UpdateMesh()
	self:CalcStats()
	self:UpdateButtons()
end

function Garage_Upgrades:UpdateMesh()
	local Selection = self.ItemList_Upgrades:GetSelection()

	-- Gooi object in de scene
	local Object = CreateAdvancedMesh(nil, "Models\\Upgrades\\" .. Selection.MeshName .. ".DCM", "")
	ActiveMission.ObjectManager:ShowObject(Object)
end

function Garage_Upgrades:BuyFunction(useGears)
	if (self.ItemList_Upgrades ~= nil) then
		SelectedUpgrade = self.ItemList_Upgrades:GetSelection()
		
		local UpgradeItem = nil
		if (SelectedUpgrade == self.WeightUpgrade) then
			UpgradeItem = UpgradeItem_Weight
		elseif (SelectedUpgrade == self.SuspensionUpgrade) then
			UpgradeItem = UpgradeItem_Suspension
		elseif (SelectedUpgrade == self.AirShocksUpgrade) then
			UpgradeItem = UpgradeItem_AirShocks
		elseif (SelectedUpgrade == self.EngineUpgrade) then
			UpgradeItem = UpgradeItem_Engine
		elseif (SelectedUpgrade == self.ArmorUpgrade) then
			UpgradeItem = UpgradeItem_Armor
		elseif (SelectedUpgrade == self.TiresUpgrade) then
			UpgradeItem = UpgradeItem_Tires
		end
		
		if (UpgradeItem ~= nil) then
			--if(ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryLevel == 0 and ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime == 0) then
			if(ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime == 0) then
				print("^1 UPGRADE AANKOOP")
				local EnableFastDelivery = true
			
				--Buy via GoloCoins?
				--if (UpgradeItem.GetGoloPrice ~= nil and UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar()) ~= nil) then
				if (useGears) then
					-- met gears betalen
					local CoinsPrice = UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar())
					local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= CoinsPrice)
					if not genoegcredits then
						local CreditsNeeded = (CoinsPrice - VirtualCoins:GetGoloCoinCount())
						ShowConfirm_NoGolo(CreditsNeeded, Garage_Upgrades)
					else
						ShowConfirm_BuyUpgradeItem(UpgradeItem, CoinsPrice, ActiveGameMode:GetSelectedCar(), not EnableFastDelivery, true)
					end
				else
					-- met money betalen
					local CoinsPrice = UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar())
					local genoegcredits = (VirtualCoins:GetCoinCount() >= CoinsPrice)
					if not genoegcredits then
						local CreditsNeeded = (CoinsPrice - VirtualCoins:GetCoinCount())
						ShowConfirm_NoGold(CreditsNeeded, Garage_Upgrades)
					else
						ShowConfirm_BuyUpgradeItem(UpgradeItem, CoinsPrice, ActiveGameMode:GetSelectedCar(), EnableFastDelivery)
					end
				end
			else 
				print("^2 IK DOE NU DUS EEN DELIVERY!")
				--UpgradeItem = GetMinDeliveryTime_UpgradeItem() -- 
				local HurryUp_GoloPrice = UpgradeItem:GetDeliveryGoloPrice(ActiveGameMode:GetSelectedCar())
				
				local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= HurryUp_GoloPrice)
				if not genoegcredits then
					local CreditsNeeded = (HurryUp_GoloPrice - VirtualCoins:GetGoloCoinCount())
					ShowConfirm_NoGolo(CreditsNeeded, Garage_Upgrades)
				else
					
					local CurrentTime = os.time()
					local TimeNeeded = 0
					--[[if (GetMinDeliveryTime() ~= nil) then
						TimeNeeded = GetMinDeliveryTime() - CurrentTime --10 --self.SelectedWheel.DeliveryTime - CurrentTime
					end]]
					TimeNeeded = ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime - CurrentTime
					
					PreviousMenu = ActiveMenu
					ActiveMenu = ConfirmMenu(PreviousMenu)
					ActiveMenu:SetTitle(Translate("confirm_ItemNotAvailable_title"))
					ActiveMenu:SetText(string.format(Translate("confirm_ItemNotAvailable_text"), os.date("%M:%S", TimeNeeded), HurryUp_GoloPrice))
					ActiveMenu:SetCharacter(CharacterTextures["Pete"], Translate("character_Pete"))
					ActiveMenu:SetProceedText(Translate("menu_impatient"))
					ActiveMenu:SetCancelText(Translate("menu_wait"))
					
					local ClockThread = GameThread:Spawn(function()
						while(true)do
							local CurrentTime = os.time()
							TimeNeeded = ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime - CurrentTime --GetMinDeliveryTime() - CurrentTime --10 --self.SelectedWheel.DeliveryTime - CurrentTime
							
							if (TimeNeeded == nil or TimeNeeded <= 0) then
								--self.SelectedWheel.ShowPopup = false
								
								ActiveMenu.YesButtonPanel:Clear()
								local Text = "^3" --.. Translate(self.SelectedWheel.Title)
								ActiveMenu:SetTitle(Translate("confirm_delivery_item_title"))
								ActiveMenu:SetText(string.format(Translate("confirm_delivery_item_shorttext"), Text))
								ActiveMenu:SetCancelText(Translate("button_proceed"))
								if (ClockThread ~= nil) then
									GameThread:Stop(ClockThread)
									ClockThread = nil
								end
							else		
								ActiveMenu:SetText(string.format(Translate("confirm_ItemNotAvailable_text"), os.date("%M:%S", TimeNeeded), HurryUp_GoloPrice))
							end
							GameThread:Wait(1)
						end
					end)
					
					ActiveMenu.CancelAction = function()
						GameThread:Spawn(function()
							if (ClockThread ~= nil) then
								GameThread:Stop(ClockThread)
								ClockThread = nil
							end
						end)
					end
					
					ActiveMenu.ProceedAction = function()
						GameThread:Spawn(function(Button, IsChecked)
							if (ClockThread ~= nil) then
								GameThread:Stop(ClockThread)
								ClockThread = nil
							end
							
							print('fast deliver UpgradeItem ') -- .. UpgradeItem.Name)
	
							local CoinsPrice = HurryUp_GoloPrice
							if (VirtualCoins:BuyGoloProduct(CoinsPrice, function()
							
								--instant delivery code here
								UpgradeItem:BuyDirect(ActiveGameMode:GetSelectedCar())
								UpgradeItem:CheckDeliveries(ActiveGameMode:GetSelectedCar())
								
								self:UpdateButtons()
								self:CalcStats()
								
								WriteGameSettings()
								VirtualCoins:UpdateCoincount()
								self:UpdateMenuStats()
							end)) then
								
							end
						end)
					end
				end
			end
		else
			print("^1Failed to Buy!")
		end
	end
end

function Garage_Upgrades:UpdateButtons()
	local UpgradeItem = nil
	local SelectedUpgrade = self.ItemList_Upgrades:GetSelection() 
	if (SelectedUpgrade == self.WeightUpgrade) then
		UpgradeItem = UpgradeItem_Weight
	elseif (SelectedUpgrade == self.SuspensionUpgrade) then
		UpgradeItem = UpgradeItem_Suspension
	elseif (SelectedUpgrade == self.AirShocksUpgrade) then
		UpgradeItem = UpgradeItem_AirShocks
	elseif (SelectedUpgrade == self.EngineUpgrade) then
		UpgradeItem = UpgradeItem_Engine
	elseif (SelectedUpgrade == self.ArmorUpgrade) then
		UpgradeItem = UpgradeItem_Armor
	elseif (SelectedUpgrade == self.TiresUpgrade) then
		UpgradeItem = UpgradeItem_Tires
	end
	
	self.UpgradeImage:SetImage(texture(UpgradeItem.ItemLevels[ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel].ImageName))
	self.InstallText:SetText(string.format(Translate("garage_upgrades_title"), Translate(UpgradeItem.Name), ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel))
	local descriptionText = UpgradeItem.Name .. "_description"
	self.DescriptionText:SetText(Translate(descriptionText))

	if(UpgradeItem ~= nil) then
		--if(ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryLevel == 0 and ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime == 0) then
		if(ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime == 0) then
			if(self.ProceedButtonGold ~= nil) then
				self.ProceedButtonGold:SetText(Translate("button_unlock"), tostring(UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar())), false)
			end
			
			if(self.ProceedButtonGear ~= nil) then
				local GoloPrice = UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar())
				self.ProceedButtonGear:SetText(Translate("button_unlock"), tostring(GoloPrice), true)
			end
			
			-- if statement in bouwe
			if(UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar()) ~= nil and UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar()) ~= 0) then
				if(self.ProceedButtonBig ~= nil) then
					local Price = UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar())
					self.ProceedButtonBig:SetText(Translate("button_unlock"), tostring(Price), false)
					self.ProceedButtonBig.OnReleased = function()
						self:BuyFunction(false)
					end
				end
			elseif(UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar()) ~= nil and UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar()) ~= 0) then
				if(self.ProceedButtonBig ~= nil) then
					local GoloPrice = UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar())
					self.ProceedButtonBig:SetText(Translate("button_unlock"), tostring(GoloPrice), true)
					self.ProceedButtonBig.OnReleased = function()
						self:BuyFunction(true)
					end
				end
			end
			
			self.DeliverTimerPanel:SetColor(Invisible)
			
			if (self.DeliveryClockThread ~= nil) then
				GameThread:Stop(self.DeliveryClockThread)
				self.DeliveryClockThread = nil
			end
			
			-- layout van button hieronder
			if(UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar()) ~= nil and UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar()) ~= nil and UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar()) ~= 0 and UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar()) ~= 0) then
				--beide buttons
				if(self.ProceedButtonGold ~= nil) then
					self.ProceedButtonGold:Enable()
					self.ProceedButtonGold.Panel:SetColor(White)
					self.Items:SetSelection(self.ProceedButtonGold)
				end
				if(self.ProceedButtonGear ~= nil) then
					self.ProceedButtonGear:Enable()
					self.ProceedButtonGear.Panel:SetColor(White)
				end
				self.Price_Or_Text:SetColor(White)
				
				if(self.ProceedButtonBig ~= nil) then
					self.ProceedButtonBig:Disable()
					self.ProceedButtonBig.Panel:SetColor(Invisible)
				end
				
			elseif(UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar()) ~= nil and UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar()) ~= 0) then
				-- money
				if(self.ProceedButtonGold ~= nil) then
					self.ProceedButtonGold:Disable()
					self.ProceedButtonGold.Panel:SetColor(Invisible)
				end
				if(self.ProceedButtonGear ~= nil) then
					self.ProceedButtonGear:Disable()
					--self.ProceedButtonGear:SetText("", "", nil)
					self.ProceedButtonGear.Panel:SetColor(Invisible)	
				end
				self.Price_Or_Text:SetColor(Invisible)
				
				if(self.ProceedButtonBig ~= nil) then
					self.ProceedButtonBig:Enable()
					self.ProceedButtonBig.Panel:SetColor(White)
					self.ProceedButtonBig.OnReleased = function()
						self:BuyFunction(false)
					end
					self.Items:SetSelection(self.ProceedButtonBig)
				end
				
			elseif(UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar()) ~= nil and UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar()) ~= 0) then	
				-- yolo coins
				if(self.ProceedButtonGear ~= nil) then
					self.ProceedButtonGear:Disable()
					self.ProceedButtonGear.Panel:SetColor(Invisible)
					self.Items:SetSelection(self.ProceedButtonGear)
				end
				if(self.ProceedButtonGold ~= nil) then
					self.ProceedButtonGold:Disable()
					--self.ProceedButtonGold:SetText("", "", nil)
					self.ProceedButtonGold.Panel:SetColor(Invisible)	
				end
				self.Price_Or_Text:SetColor(Invisible)
				
				if(self.ProceedButtonBig ~= nil) then
					self.ProceedButtonBig:Enable()
					self.ProceedButtonBig.Panel:SetColor(White)
					self.ProceedButtonBig.OnReleased = function()
						self:BuyFunction(true)
					end
					self.Items:SetSelection(self.ProceedButtonBig)
				end
			end
			
			-- einde layout van de buttons
			
		elseif(ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryLevel > 0 and ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime > 0) then
			print("dit wordt uitgevoerd?")
			if(self.ProceedButtonBig ~= nil) then
				local GoloPrice = UpgradeItem:GetDeliveryGoloPrice(ActiveGameMode:GetSelectedCar())
				self.ProceedButtonBig:SetText(Translate("button_deliverNow"), tostring(GoloPrice), true)
				
				self.ProceedButtonBig:Enable()
				self.ProceedButtonBig.Panel:SetColor(White)
				self.Items:SetSelection(self.ProceedButtonBig)
				self.Price_Or_Text:SetColor(White)
				self.ProceedButtonBig.OnReleased = function()
					self:BuyFunction(nil)
				end
				
				if(self.ProceedButtonGear ~= nil) then
					self.ProceedButtonGear:Disable()
					self.ProceedButtonGear.Panel:SetColor(Invisible)
				end
				if(self.ProceedButtonGold ~= nil) then
					self.ProceedButtonGold:Disable()
					self.ProceedButtonGold.Panel:SetColor(Invisible)	
				end
			end
			
			self.DeliverTimerPanel:SetColor(White)
			
			print("^2ABOUT TO START TIMER;", UpgradeItem.Name)
			
			--- timer
			if (self.DeliveryClockThread ~= nil) then
				GameThread:Stop(self.DeliveryClockThread)
				self.DeliveryClockThread = nil
			end
		
			local DeliveryTime = ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime
			
			self.DeliveryClockThread = GameThread:Spawn(function()
				local CurrentTime = os.time()
				local WaitTime = DeliveryTime - CurrentTime
			
				print("yolo;", WaitTime, CurrentTime)
			
				while (WaitTime > 0) do				
					local CurrentTime = os.time()
					local WaitTime = DeliveryTime - CurrentTime
						
					self.DeliverTimeValue:SetText(FormatTimeShort(WaitTime))
					
					GameThread:Wait(1)
				end
				
				UpgradeItem:BuyDirect(ActiveGameMode:GetSelectedCar())
				UpgradeItem:CheckDeliveries(ActiveGameMode:GetSelectedCar())
				
				self:UpdateButtons()
				self:CalcStats()
				
				WriteGameSettings()
				VirtualCoins:UpdateCoincount()
				self:UpdateMenuStats()
			end)
			
			--- end timer
		end
		
		
		if(ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel >= #UpgradeItem.ItemLevels and ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryLevel == 0 and ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].DeliveryTime == 0) then
			if(self.ProceedButtonGold ~= nil) then
				self.ProceedButtonGold:Disable()
				self.ProceedButtonGold:SetText("", "", nil)
				self.ProceedButtonGold.Panel:SetColor(Invisible)	
			end
			if(self.ProceedButtonGear ~= nil) then
				self.ProceedButtonGear:Disable()
				self.ProceedButtonGear:SetText("", "", nil)
				self.ProceedButtonGear.Panel:SetColor(Invisible)	
			end
			if(self.ProceedButtonBig ~= nil) then
				self.ProceedButtonBig:Disable()
				self.ProceedButtonBig:SetText("", "", nil)
				self.ProceedButtonBig.Panel:SetColor(Invisible)
			end
			
			self.Price_Or_Text:SetColor(Invisible)
			self.Items:SetSelection(self.BackButton)
		end
	else
		print("^1Failed to update buttons!")
	end
end

function Garage_Upgrades:Goto(Target)
	self.WeightTexture = nil
	self.SuspensionTexture = nil
	self.AirShockTexture = nil
	self.EngineTexture = nil
	self.ArmorTexture = nil
	self.TiresTexture = nil
	
	if (self.DeliveryClockThread ~= nil) then
		GameThread:Stop(self.DeliveryClockThread)
		self.DeliveryClockThread = nil
	end

	ActiveMenu = Target(Garage_Upgrades)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function Garage_Upgrades:Active()
	return ActiveMenu == self
end

function Garage_Upgrades:Refresh()
	local PreviousMenu = self.PreviousMenu
	
	self.WeightTexture = nil
	self.SuspensionTexture = nil
	self.AirShockTexture = nil
	self.EngineTexture = nil
	self.ArmorTexture = nil
	self.TiresTexture = nil
	
	ActiveMenu = Garage_Upgrades(PreviousMenu)
end

function Garage_Upgrades:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
	
	self:InitKeyListeners()
end

function Garage_Upgrades:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function Garage_Upgrades:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

-- ==========================================
-- Custom functions below here
-- ==========================================

function Garage_Upgrades:CalcStats()
	local Acceleration_Current = 0
	local Topspeed_Current = 0
	local Strenght_Current = 0
	local Weight_Current = 0
	local Grip_Current = 0
	
	local Acceleration_Add = 0
	local Topspeed_Add = 0
	local Strenght_Add = 0
	local Weight_Add = 0
	local Grip_Add = 0
	
	local Acceleration_Max = 0
	local Topspeed_Max = 0
	local Strenght_Max = 0
	local Weight_Max = 0
	local Grip_Max = 0
	
	local SelectedUpgrade = nil
	if (self.ItemList_Upgrades ~= nil) then
		SelectedUpgrade = self.ItemList_Upgrades:GetSelection()
	end
	
	local UpgradeItem = UpgradeItem_Weight
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.WeightUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]

	local UpgradeItem = UpgradeItem_Suspension
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.SuspensionUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	local UpgradeItem = UpgradeItem_AirShocks
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.AirShocksUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	local UpgradeItem = UpgradeItem_Engine
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.EngineUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	local UpgradeItem = UpgradeItem_Armor
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.ArmorUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	local UpgradeItem = UpgradeItem_Tires
	for i, ItemLevel in ipairs(UpgradeItem.ItemLevels) do
		if (i <= ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel) then
			Acceleration_Current = Acceleration_Current + ItemLevel.Value[1]
			Topspeed_Current = Topspeed_Current + ItemLevel.Value[2]
			Strenght_Current = Strenght_Current + ItemLevel.Value[3]
			Weight_Current = Weight_Current + ItemLevel.Value[4]
			Grip_Current = Grip_Current + ItemLevel.Value[5]
		elseif (i == ActiveGameMode:GetSelectedCar().Upgrades[UpgradeItem.Name].CurrentLevel + 1 and SelectedUpgrade == self.TiresUpgrade) then
			Acceleration_Add = Acceleration_Add + ItemLevel.Value[1]
			Topspeed_Add = Topspeed_Add + ItemLevel.Value[2]
			Strenght_Add = Strenght_Add + ItemLevel.Value[3]
			Weight_Add = Weight_Add + ItemLevel.Value[4]
			Grip_Add = Grip_Add + ItemLevel.Value[5]
		end
		
		Acceleration_Max = Acceleration_Max + ItemLevel.Value[1]
		Topspeed_Max = Topspeed_Max + ItemLevel.Value[2]
		Strenght_Max = Strenght_Max + ItemLevel.Value[3]
		--Weight_Max = Weight_Max + ItemLevel.Value[4]
		Grip_Max = Grip_Max + ItemLevel.Value[5]
	end
	Weight_Max = Weight_Max + UpgradeItem.ItemLevels[1].Value[4]
	
	self.StatsSlider_Acceleration:SetSlider_Orange(Acceleration_Current / Acceleration_Max)
	self.StatsSlider_Topspeed:SetSlider_Orange(Topspeed_Current / Topspeed_Max)
	self.StatsSlider_Strenght:SetSlider_Orange(Strenght_Current / Strenght_Max)
	self.StatsSlider_Weight:SetSlider_Orange((Weight_Current + Weight_Add) / Weight_Max)
	self.StatsSlider_Grip:SetSlider_Orange(Grip_Current / Grip_Max)
	
	--self.StatsSlider_Specials:SetSlider_Grey(Specials_Allowed / Specials_Max)
	
	self.StatsSlider_Acceleration:SetSlider_Green((Acceleration_Current + Acceleration_Add) / Acceleration_Max)
	self.StatsSlider_Topspeed:SetSlider_Green((Topspeed_Current + Topspeed_Add) / Topspeed_Max)
	self.StatsSlider_Strenght:SetSlider_Green((Strenght_Current + Strenght_Add) / Strenght_Max)
	self.StatsSlider_Weight:SetSlider_Green((Weight_Current) / Weight_Max)
	self.StatsSlider_Grip:SetSlider_Green((Grip_Current + Grip_Add) / Grip_Max)
	
	--Acceleration_Current 
	if (Acceleration_Add > 0) then
		self.StatsSlider_Acceleration:SetText(Acceleration_Current .. " + " .. Acceleration_Add)
	else
		self.StatsSlider_Acceleration:SetText(Acceleration_Current)
	end
	
	if (Topspeed_Add > 0) then
		self.StatsSlider_Topspeed:SetText(Topspeed_Current .. " + " .. Topspeed_Add)
	else
		self.StatsSlider_Topspeed:SetText(Topspeed_Current)
	end
	
	if (Strenght_Add > 0) then
		self.StatsSlider_Strenght:SetText(Strenght_Current .. " + " .. Strenght_Add)
	else
		self.StatsSlider_Strenght:SetText(Strenght_Current)
	end
	
	if (Weight_Add > 0) then
		self.StatsSlider_Weight:SetText(Weight_Current .. " - " .. Weight_Add)
	else
		self.StatsSlider_Weight:SetText(Weight_Current)
	end
	
	if (Grip_Add > 0) then
		self.StatsSlider_Grip:SetText(Grip_Current .. " + " .. Grip_Add)
	else
		self.StatsSlider_Grip:SetText(Grip_Current)
	end
end

function Garage_Upgrades:UpdateCoincount()
	if (ActiveForeground ~= nil and ActiveForeground.UpdateCoincount ~= nil) then
		ActiveForeground:UpdateCoincount()
	end
end

function Garage_Upgrades:InitKeyListeners()
	ClearKeyListeners()

	AddKeyListeners(BackButtons, "Down", function(Listeners)
		if (self:Active()) then
			self:Goto(Garage)
		else
			DelKeyListeners(Listeners)
		end
	end)

	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(UpButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				self.ItemList_Upgrades:Prev()
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(DownButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				self.ItemList_Upgrades:Next()
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(LeftButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				self.Items:Prev()
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(RightButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				self.Items:Next()
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
end

function Garage_Upgrades:SetItemlistSize()
	self.Items_Stats_Panel = self.Menu:GetChild("Items_Stats_Panel")
	self.Items_Image_Panel = self.Menu:GetChild("Items_Image_Panel")
	self.Items_Upgrades_Panel = self.Menu:GetChild("Items_Upgrades_Panel")

	local ContentHeight = ActiveForeground:GetContentHeight()
	local ContentWidth = SafeFrameWidth - (self.Items_Stats_Panel:GetWidth() + self.Items_Upgrades_Panel:GetWidth())

	self.Items_Image_Panel:SetSize(ContentWidth - 32, ContentHeight - 140 )
	
	local TitleBarHeight = ActiveForeground:GetTitlebarHeight()
	local ContentHeight = ActiveForeground:GetContentHeight()

	self.Items_Upgrades_Panel:SetSize(256, ContentHeight) 
	self.Items_Upgrades_Panel:SetPos(0, TitleBarHeight) 
end

function Garage_Upgrades:CreateObjectRender()
	print("Garage_Upgrades:CreateObjectRender")
	self.WorldRenderTexture = self.Menu:GetChild("WorldRenderTexture")
	
	local ContentHeight = ActiveForeground:GetContentHeight() - 100
	local PanelWidth = SafeFrameWidth * 0.7
	local BorderOffset = 4
	
	self.WorldRenderTexture:SetPosData(0, -16, Center, Center, Center, Center, 4, Linear, false)
	self.WorldRenderTexture:SetSize(PanelWidth - 2 * BorderOffset, ContentHeight - (2 * BorderOffset))
	
	self.WorldRenderTexture:SetColorImmediate(Invisible)
	PhysicsThread:Spawn(function()
		PhysicsThread:Wait(50)
		self.WorldRenderTexture:SetColorFade(1, 1)
		self.WorldRenderTexture:SetColor(White)
	end)
	
	if (ActiveMission.ObjectRender ~= nil) then
		ActiveMission.ObjectRender:SetMenuImage(self.WorldRenderTexture)
	end
	
	self.WorldRenderTexture:SetClickedFunc(function(Item, X, Y)
		GameThread:Spawn(function()
			while (MouseKeyPressed(0)) do
				if (ActiveMission.ObjectRender ~= nil) then
					if (PrevMousePos == nil) then
						PrevMousePos = MousePos(0)
					end
					
					local DeltaX = MousePos(0).x - PrevMousePos.x
					local DeltaY = MousePos(0).y - PrevMousePos.y
					PrevMousePos = MousePos(0)
					
					ActiveMission.ObjectRender.RotationSpeed = ActiveMission.ObjectRender.RotationSpeed + (-DeltaX / 30)
					ActiveMission.ObjectRender.LiftSpeed = ActiveMission.ObjectRender.LiftSpeed + (DeltaY / 30)
				end
				GameThread:Wait(1 / 120)
			end
			PrevMousePos = nil
		end)
	end)
end

function Garage_Upgrades:DestroyObjectRender()
	if (self.WorldRenderTexture ~= nil) then
		ActiveMission.ObjectRender:SetMenuImage(nil)
		ActiveMission.ObjectRender.ImageReady = false
		self.WorldRenderTexture:SetClickedFunc(nil)
		self.WorldRenderTexture = nil
	end
end