HUD_CutsceneBars = class(function(self, HumanCarType, AICarType)
	self.HUD = createhud("CutsceneBars.dcMenu")
	
	-- gooi menu er op
	self.Menu = self.HUD:GetRootPanel()
	self.Main = self.Menu:GetChild("Main")
	
	-- Fade in
	self.Main:SetColorImmediate(White)
	self.Menu:SetColorImmediate(White)
	
	local Race = ActiveGameMode.ActiveChapter.ActiveRace
	
	-- Items ophalen en tekst instellen
	self.MainPanel = self.Menu:GetChild("MainPanel")
	self.PlayerPanel = self.Menu:GetChild("PlayerPanel")	
	self.LeftPlayerPanel = self.Menu:GetChild("LeftPlayer")
	self.LeftPlayerImage = self.Menu:GetChild("LeftPlayerImage")
	self.LeftPlayer_WinnerText = self.Menu:GetChild("LeftPlayer_Text")
	self.RightPlayerPanel = self.Menu:GetChild("RightPlayer")
	self.RightPlayerImage = self.Menu:GetChild("RightPlayerImage")	
	self.RightPlayer_WinnerText = self.Menu:GetChild("RightPlayer_Text")
	self.VSText = self.Menu:GetChild("VSText")
	self.GamemodeText = self.Menu:GetChild("GamemodeText")
	
	self.TextPanel = self.Menu:GetChild("TextPanel")
	self.TrackNameText = self.Menu:GetChild("TrackNameText")
	self.StartText = self.Menu:GetChild("StartText")
	self.GoalText = self.Menu:GetChild("GoalText")
	
	--self.TrackNameText:SetText(Translate("Default_TrackName"))
	
	local LocationName = "menu_gametype_" .. ActiveGameMode.Name .. "_Theme".. tostring(MONSTERJAM_THEME_SETTING) .."_Location"
	self.TrackNameText:SetText(Translate(LocationName))
	
	-- Posities zetten
	self.LeftPlayerPanel:SetPosData(0, -50, Center, Center, 0.25, Center, 0, None, false)
	self.LeftPlayer_WinnerText:SetPosData(0, -50, Center, Center, 0.25, Center, 0, None, false)
	self.RightPlayerPanel:SetPosData(0, -50, Center, Center, 0.75, Center, 0, None, false)
	self.RightPlayer_WinnerText:SetPosData(0, -50, Center, Center, 0.75, Center, 0, None, false)
	self.VSText:SetPosData(0, -50, Center, Center, Center, Center, 0, None, false)
	
	local ShowContinueText = false
	if (ShowContinueText) then
		self.StartText:SetColorImmediate(White)
		
		if (GetPlatform() == "Win32") then
			self.StartText:SetText(Translate("press_enter_to_continue"))
		else
			self.StartText:SetText(Translate("tap_to_start_racing"))
		end
	else
		self.StartText:SetColorImmediate(Invisible)
	end
	
	-- Gamemode title
	self.GamemodeText:SetPosData(0, 0, Center, Top, Center, Top, 0, None, false)
	self.GamemodeText:SetColorImmediate(White)
	self.GamemodeText:SetText(Translate("menu_gametype_title_" .. ActiveGameMode.Name))
	
	-- Gamemode description
	self.GoalText:SetColorImmediate(White)
	self.GoalText:SetText(Translate("menu_gametype_" .. ActiveGameMode.Name .. "_cutscene"))
	
	AddKeyListeners(ProceedButtons, "Down", function(Listeners)
		if (self:Active()) then
			self:HideMenu()
			ActiveMission:Start()
			DelKeyListeners(Listeners)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	if (ActiveGameMode == SingleRace) then
		self:SingleRace(HumanCarType, AICarType)
	elseif (ActiveGameMode == DeathMatch) then
		self:DeathMatch(HumanCarType, AICarType)
	elseif (ActiveGameMode == Sandbox) then
		self:Sandbox(HumanCarType, AICarType)
	elseif (ActiveGameMode == SkillGame) then
		self:SkillGame(HumanCarType, AICarType)
	elseif (ActiveGameMode == TowTest) then
		self:TowTest(HumanCarType, AICarType)
	elseif (ActiveGameMode == FreestyleFest) then
		self:Freestyle(HumanCarType, AICarType)
	end
end)

function HUD_CutsceneBars:Destroy()
	self.HUD:Destroy();
end

function HUD_CutsceneBars:Active()
	return CutsceneBars == self
end

function HUD_CutsceneBars:Refresh()
	CutsceneBars = HUD_CutsceneBars()
end

function HUD_CutsceneBars:HideMenu()
	self.Menu:SetColor(Invisible)
	self.Main:setcolor(Invisible)
end

function HUD_CutsceneBars:Update(ElapsedTime)
	--
end

function HUD_CutsceneBars:SingleRace(HumanCarType, AICarType)
	self.PlayerPanel:SetColorImmediate(color(0, 0, 0, 0.6))
	self.LeftPlayerImage:SetColorImmediate(White)
	self.RightPlayerImage:SetColorImmediate(White)
	self.TextPanel:SetColorImmediate(color(0, 0, 0, 0.6))
	self.TrackNameText:SetColorImmediate(White)
	self.GoalText:SetColorImmediate(White)
	self.VSText:SetColorImmediate(White)
	
	self.PlayerPanel:SetSize(0, 60)
	
	self.GoalText:SetText(Translate("menu_gametype_" .. ActiveGameMode.Name .. "_cutscene"))
	
	self.TrackNameText:SetPosData(0, -10, Center, Bottom, Center, Bottom, 0, None, false)
	
	local HumanPlayer = nil
	local AIPlayer = nil
	
	for i, Player in ipairs(ActiveMission.Players) do
		if (Player.Human) then
			HumanPlayer = Player
		else
			AIPlayer = Player
		end
	end

	
	self.LeftPlayerImage:SetImage(MonsterTruckCars:GetCarByName(HumanPlayer.Car:GetType()).LogoImage)
	self.LeftPlayerPanel:SetPosData(0, 0, Right, Top, Right, Top, 0, None, false)
	
	if (AIPlayer ~= nil) then
		if (AIPlayer.Car.GetType ~= nil) then
			self.RightPlayerImage:SetImage(MonsterTruckCars:GetCarByName(AIPlayer.Car:GetType()).LogoImage)
		else
			local Car = MonsterTruckCars:GetCarByName(AIPlayer.Name)
			if (Car ~= nil and Car.LogoImage ~= nil) then
				self.RightPlayerImage:SetImage(Car.LogoImage)
			end
		end
		
		self.RightPlayerPanel:SetPosData(0, 0, Left, Top, Left, Top, 0, None, false)
	end
end

function HUD_CutsceneBars:DeathMatch(HumanCarType, AICarType)
	--
end

function HUD_CutsceneBars:Sandbox(HumanCarType, AICarType)
	--
end

function HUD_CutsceneBars:Freestyle(HumanCarType, AICarType)
	self.PlayerPanel:SetColorImmediate(color(0, 0, 0, 0.6))
	self.LeftPlayerImage:SetColorImmediate(White)
	self.TextPanel:SetColorImmediate(color(0, 0, 0, 0.6))
	self.TrackNameText:SetColorImmediate(White)
	
	--self.TrackNameText:SetText(Translate("Freestyle_Trackname"))
	
	self.LeftPlayerPanel:SetPosData(0, 0, Left, Center, Left, Center, 0, None, false)
	self.TrackNameText:SetPosData(-50, 0, Right, Center, Right, Center, 0, None, false)
	self.LeftPlayer_WinnerText:SetPosData(0, 0, Center, Center, Center, Center, 0, None, false)
	
	local HumanPlayer = ActiveMission.Players[1]
	self.LeftPlayerImage:SetImage(MonsterTruckCars:GetCarByName(HumanPlayer.Car:GetType()).LogoImage)
end

function HUD_CutsceneBars:SkillGame(HumanCarType, AICarType)
	self.PlayerPanel:SetColorImmediate(color(0, 0, 0, 0.6))
	self.LeftPlayerImage:SetColorImmediate(White)
	self.TextPanel:SetColorImmediate(color(0, 0, 0, 0.6))
	self.TrackNameText:SetColorImmediate(White)
	
	--self.TrackNameText:SetText(Translate("SkillGame_Trackname"))
	
	self.LeftPlayerPanel:SetPosData(0, 0, Left, Top, Left, Top, 0, None, false)
	self.TrackNameText:SetPosData(-50, 0, Right, Center, Right, Center, 0, None, false)
	self.LeftPlayer_WinnerText:SetPosData(0, 0, Center, Center, Center, Center, 0, None, false)
	
	local HumanPlayer = ActiveMission.Players[1]
	self.LeftPlayerImage:SetImage(MonsterTruckCars:GetCarByName(HumanPlayer.Car:GetType()).LogoImage)
end

function HUD_CutsceneBars:TowTest(HumanCarType, AICarType)
	self.PlayerPanel:SetColorImmediate(color(0, 0, 0, 0.6))
	self.LeftPlayerImage:SetColorImmediate(White)
	self.TextPanel:SetColorImmediate(color(0, 0, 0, 0.6))
	self.TrackNameText:SetColorImmediate(White)
	
	--self.TrackNameText:SetText(Translate("TowTest_Trackname"))
	
	self.LeftPlayerPanel:SetPosData(0, 0, Left, Center, Left, Center, 0, None, false)
	self.TrackNameText:SetPosData(-50, 0, Right, Center, Right, Center, 0, None, false)
	self.LeftPlayer_WinnerText:SetPosData(0, 0, Center, Center, Center, Center, 0, None, false)
	
	local HumanPlayer = ActiveMission.Players[1]
	self.LeftPlayerImage:SetImage(MonsterTruckCars:GetCarByName(HumanPlayer.Car:GetType()).LogoImage)
end