HUD_CutsceneFinished = class(function(self, ShowSingleResult)
	self.HUD = createhud("CutsceneBars.dcMenu")
	
	-- gooi menu er op
	self.Menu = self.HUD:GetRootPanel()
	self.Main = self.Menu:GetChild("Main")
	
	-- Fade in
	self.Main:SetColorImmediate(White)	
	self.Menu:SetColorFade(1, 10.0)
	self.Menu:SetColorImmediate(White)
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	-- Items ophalen en tekst instellen
	self.CutsceneGametype = self.Menu:GetChild("CutsceneGametype")
	self.GameModeTitle = self.Menu:GetChild("WelcomeText")
	self.GameModeTitle:SetText(Translate("menuname_finished"))
	self.CutsceneTrackName = self.Menu:GetChild("CutsceneTrackName")
	self.Buttons = self.Menu:GetChild("Buttons")
	self.GoalPanel = self.Menu:GetChild("GoalPanel")
	self.GoalText = self.Menu:GetChild("GoalText")
	self.CutsceneText = self.Menu:GetChild("CutsceneText")

	self.NewTrackRecord = self.Menu:GetChild("NewTrackRecord")
	self.NewTrackRecordText = self.NewTrackRecord:GetChild("NewTrackRecordTime")
	self.OldTrackRecordText = self.NewTrackRecord:GetChild("OldTrackRecordTime")

	self.RaceTitle = self.Menu:GetChild("TrackNameText")
	self.StartText = self.Menu:GetChild("StartText")
		
	self.RaceTitle:SetText(Translate(ActiveGameMode.ActiveChapter.ActiveRace.Title))
	self.StartText:SetText(Translate("tap_to_continue"))

	self.GoalPanel:SetColor(White)
	
	-- posities zetten
	self.CutsceneGametype:SetPosData(0, 0, Center, Bottom, Center, Top, 0, None, false)
	self.CutsceneTrackName:SetPosData(0, 0, Center, Bottom, Center, Top, 0, None, false)
	self.CutsceneText:SetPosData(0, SafeFrameOffsetX, Center, Top, Center, Bottom, 0, None, false)
	self.GoalPanel:SetPosData(0, 0, Center, Top, Center, Bottom, 0, None, false)
	
	self.CutsceneGametype:SetPosData(0, 16, Center, Top, Center, Top, 2, Sine, false)
	self.CutsceneTrackName:SetPosData(0, 80, Center, Top, Center, Top, 2, Sine, false)
	self.CutsceneText:SetPosData(0, 0, Center, Bottom, Center, Bottom, 2, Sine, false)
	self.GoalPanel:SetPosData(0, 0, Center, Center, Center, 0.8, 2, Sine, false)
	
	self.Items = NewItemList(self, UpButtons, DownButtons)
	self.Items.Active = 0
	
	self.Buttons:clear()
	
	self.Items:Format(ALIGN_WE, 0, 0, -9, 0, Left, nil, Left, nil)
	self.Items:FormatTween(ALIGN_WE, 0, 0, -9, 0, Right, nil, Center, nil)
	
	self.ShowSingleResult = ShowSingleResult
	
	local KeyPressDelay = false
	if (not KeyPressDelay) then
		GameThread:Spawn(function()
			self:GotoNextMenu()
		end)
	else
		self.Main:SetClickedFunc(function(Item, X, Y)
			if (self:Active()) then
				GameThread:Spawn(function()
					self:GotoNextMenu()
				end)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				GameThread:Spawn(function()
					self:GotoNextMenu()
				end)
				
				if (self.Items:GetSelection() ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
	end
end)

function HUD_CutsceneFinished:Destroy()
	self.HUD:Destroy()
end

function HUD_CutsceneFinished:Active()
	return CutsceneBars == self
end

function HUD_CutsceneFinished:Refresh()
	CutsceneBars = HUD_CutsceneFinished()
end

function HUD_CutsceneFinished:Update(ElapsedTime)
	
end

-- =================================================

function HUD_CutsceneFinished:GotoNextMenu()	
	self.Main:SetColor(Invisible)
	GameThread:Spawn(function()
		CutsceneBars:Destroy()
		CutsceneBars = nil
		
		if (self.ShowSingleResult) then
			ActiveMenu = RaceResultScreenSingle()
		else
			ActiveMenu = RaceResultScreen()
		end
	end)
end

function HUD_CutsceneFinished:SetSubTitle(Text)
	self.GameModeTitle:SetText(Text)
end

function HUD_CutsceneFinished:SetTitle(Text)
	self.RaceTitle:SetText(Text)
end

function HUD_CutsceneFinished:ShowNewTrackRecord(OldRecord, NewRecord)
	self.NewTrackRecord:SetColorImmediate(White)
	
	self.OldTrackRecordText:SetText(OldRecord)
	self.NewTrackRecordText:SetText(NewRecord)
end