IntroMenu = class(function(self, PreviousMenu, DirectLogin)
	self.PreviousMenu = PreviousMenu
	
	AnalyticsSendScreenName("IntroMenu")
	-- Gooi menu er op en pak het hoofdpanel
	self.Menu = ActiveMenu_PushMenu("IntroMenu", FOREGROUNDSTATE_SIMPLE)
	self.Main = self.Menu:GetChild("Main")
	
	
	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	--
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	
	
	--Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()
	
	--Intro
	self.IntroText = self.Menu:GetChild("IntroText")
	self.IntroText:SetColorData(White, 0, None, true)
	self.IntroText:SetColorData(color(1,1,1,0.5), 1, FullSine, true)
	
	--Loading
	self.LoadingPanel = self.Menu:GetChild("LoadingPanel")
	self.LoadingText = self.Menu:GetChild("LoadingText")
	self.LoadingImage = self.Menu:GetChild("LoadingImage")
	
	--Input stuff
	self.EnterNamePanel = self.Menu:GetChild("EnterNamePanel")
	self.HighscoreName = self.Menu:GetChild("HighscoreName")
	self.NameInput = ""
	self.CursorInput = 0
	
	--Login stuff
	--FBManager.SessionStatus = "INIT"
	FBManager.Buttons = {}
	FBManager.UserinfoTable = {}
	FBManager.Images = {}
	FBManager.BestFriends = {}
	
	local UseLogin = true
	
	if (UseLogin) then
		local KeyPressDelay = false
		if (not KeyPressDelay) then
			self:HideIntroText(true)
			self:CheckConnection(DirectLogin)
		else
			AddKeyListeners(ProceedButtons, "Down", function(Listeners)
				GameThread:Spawn(function()
					if (self:Active()) then
						DelKeyListeners(Listeners)
						self:HideIntroText()
						self:CheckConnection()
					else
						DelKeyListeners(Listeners)
					end
				end)
			end)
		end
	else
		GameThread:Spawn(function() 
			self:HideIntroText()
			GameThread:Wait(0.3)
			--self:Goto(MainMenu)
			self:Goto(DailyRewardsMenu)
		end)
	end
	
	
	local Path = "Loading\\Facebook\\"
	LoadingImages = {}
	ReadyImage = texture('Check_128.DCT')
	ErrorImage = texture('UnCheck_128.DCT')
	
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0001.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0002.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0003.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0004.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0005.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0006.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0007.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0008.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0009.DCT'))
	table.insert(LoadingImages, texture(Path ..'facebook_load_32_frame_0010.DCT'))
	
	playsound("AppName.wav")
end)

function IntroMenu:Goto(Target)
	ActiveMenu = Target(nil)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function IntroMenu:Active()
	return ActiveMenu == self
end

function IntroMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = IntroMenu(PreviousMenu)
end

function IntroMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	--[[ if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end ]]
end

function IntroMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	--[[ for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end ]]
end

function IntroMenu:DeleteButtons()
	--[[ for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end) ]]
end

-- =============

function IntroMenu:HideIntroText(Force)
	print("IntroMenu:HideIntroText(Force)")
	
	if (Force) then
		self.IntroText:SetColorImmediate(Invisible)
	else
		self.IntroText:SetColorData(White, 0, None, false)
		self.IntroText:SetColorFade(1, 10)
		self.IntroText:SetColor(Invisible)
	end
end

function IntroMenu:ShowLoadingPanel(Ready)
	self.LoadingPanel:SetColorFade(1, 4)
	self.LoadingPanel:SetColor(White)
	
	if (self.LoadingThread ~= nil) then
		GameThread:Stop(self.LoadingThread);
		self.LoadingThread = nil
	end
	
	if (Ready) then
		self.LoadingImage:SetImage(ReadyImage)
		self.LoadingImage:SetColorData(color(0.25, 1, 0, 1), 0, None, false)
		self.LoadingImage:SetSize(64, 64)
	else
		self.LoadingImage:SetColorData(color(1, 1, 1, 1), 0, None, false)
		self.LoadingImage:SetSize(32, 32)
		self.LoadingThread = GameThread:Spawn(function(Thread)
			local Counter = 1
			while(true) do
				GameThread:Sleep(0.05)
				
				self.LoadingImage:SetImage(LoadingImages[Counter])
				Counter = Inc(Counter)
				if (Counter == 11) then
					Counter = 1
				end
			end
		end)
	end
end

function IntroMenu:SetLoadingText(Text)
	self.LoadingText:SetText(Translate(Text))
end

function IntroMenu:HideLoadingPanel()
	self.LoadingPanel:SetColor(Invisible)
	
	if (self.LoadingThread ~= nil) then
		GameThread:Stop(self.LoadingThread);
		self.LoadingThread = nil
	end
end

-- ===================

function IntroMenu:CheckConnection(DirectLogin)
	self:ShowLoadingPanel()
	self:SetLoadingText("statusmessage_CheckConnection")
	
	local SuccessFunction = function(Data)
		print("Server is online and we have internet connection")
		
		if (DirectLogin) then
			FBManager:Login(nil)
		else
			self:OnUpdateSessionStatus(FBManager.SessionStatus)
			if (FBManager.SessionStatus ~= "CREATED") then
				FBManager:CreateSession()
			end
			--self:ShowLoginButtons()
		end
	end
	
	local FailureFunction = function(Data)
		print("Server is offline or no internet connection")
		ScoresUser:Cancel()
		
		GameThread:Spawn(function(Thread)
			GameThread:Sleep(0.4)
			self:SetLoadingText("statusmessage_ConnectionUnavailable")
			
			if (self.LoadingThread ~= nil) then
				GameThread:Stop(self.LoadingThread);
				self.LoadingThread = nil
			end
			self.LoadingImage:SetImage(ErrorImage)
			self.LoadingImage:SetColorData(color(1, 0, 0, 1), 0, None, false)
			self.LoadingImage:SetSize(64, 64)
			
			GameThread:Sleep(1.4)
			self:ShowOfflineButtons()
		end)
	end
	
	self:StartTimeOut(10, function()
		FailureFunction()
		print("timout")
	end,
	function()
		self:SetLoadingText("statusmessage_ConnectionDelay")
	end)
	
	GameThread:Spawn(function(Thread)
		GameThread:Sleep(0.2)
		ScoresUser:TestConnection(SuccessFunction, FailureFunction)
		--self:ShowOfflineButtons()
		--self:ShowLoginButtons()
	end)
end

function IntroMenu:AddLoginButtons()
	self.Login_Retry = nil
	self.Login_Skip = nil

	self.ItemsPanel = self.Menu:GetChild("Items")
	
	self.Items = NewItemList(self, UpButtons, DownButtons)
	self.Items.Panel = self.ItemsPanel
	self.Items.Panel:Clear()
	self.Items.TotalNormalButtons = 0
	
	self.ButtonTemplate = "Elements\\MenuButton_Login.dcMenu"
	self.ButtonFBTemplate = "Elements\\MenuButtonFB_Login_Big.dcMenu"
	
	--self.Login_Facebook = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonFBTemplate, "button_Facebook_Login_Long"))
	self.Login_Facebook = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonFBTemplate, ""))
	self.Login_Simple = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "button_NoFacebook_Login"))
	
	self.Login_Facebook:Flash(1, true, true, 0.5)
end

function IntroMenu:ShowLoginButtons()
	if (self.Items == nil or self.Login_Facebook == nil or self.Login_Simple == nil) then
		self.LoginButtonsVisible = false
		self:AddLoginButtons()
	end
	
	if (self.LoginButtonsVisible) then
		return
	end
	self.LoginButtonsVisible = true
	
	ActiveForeground:ShowMenu(FOREGROUNDSTATE_SIMPLE)

	self:StopTimeOut()
	self:HideLoadingPanel()
	
	self.ItemsPanel:SetColorFade(1, 10)
	self.ItemsPanel:SetColor(White)
	
	--self.PanelBack:SetColorData(color(0, 0.5, 1, 0.1), 1, Sine, false)
	--self.PanelRand:SetColorData(White, 1, Sine, false)
	
	-- Add Normal buttons
	--self.TotalNormalButtons = 0
	
	self.Login_Facebook.OnReleased = function()
		if (self.ActiveItemList == self.Items) then
			self.Login_Facebook.OnReleased = nil
			self.Login_Simple.OnReleased = nil
			--self.Login_Skip.OnReleased = nil
			
			GameThread:Spawn(function()
				
				self:StartTimeOut(10, function()
					self.Items.Clicked = false
					
					self:SetLoadingText("statusmessage_FacebookUnavailable")
					self:ShowLoginButtons()
					print("timout")
				end) 
				
				self:HideLoginButtons()
				--ActiveForeground:ShowMenu(FOREGROUNDSTATE_SIMPLE)
				self:ShowLoadingPanel()
				self:SetLoadingText("")
				
				FBManager:Login(nil)
			end)
		end
	end
	
	self.Login_Simple.OnReleased = function()
		if (self.ActiveItemList == self.Items) then
			self.Login_Facebook.OnReleased = nil
			self.Login_Simple.OnReleased = nil
			--self.Login_Skip.OnReleased = nil
			
			GameThread:Spawn(function()
				self:HideLoginButtons()
				self:SetLoadingText("")
				
				local UserName = GetPlayername() --"Player"
				--if (Win32() and GetUserName ~= nil) then
					--UserName = GetUserName()
				--end
				
				if (Scores.UserID == nil) then
					--ActiveForeground:ShowMenu(FOREGROUNDSTATE_SIMPLE)
					self:TypeName()
					print("TypeName")
				else
					--ActiveForeground:ShowMenu(FOREGROUNDSTATE_SIMPLE)
					self:ShowLoadingPanel()
					self:DoSimpleLogin(UserName)
				end
			end)
			
			self.Items.Clicked = false
			
			if (self.TypeName_Items ~= nil) then
				self.TypeName_Items.Clicked = false
			end
		end
	end
	
	--[[ self.Login_Skip = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "button_Skip_Login"))
	self.Login_Skip.OnReleased = function()
		self.Login_Facebook.OnReleased = nil
		self.Login_Simple.OnReleased = nil
		self.Login_Skip.OnReleased = nil
	
		self:Goto(MainMenu)
	end ]]
	
	self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 12
	local NormalButtonOffset = self.TotalNormalButtons * ButtonSpace
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	-- Format normal buttons
	self.Items:Format(ALIGN_NS, 0, ButtonSpace + NormalButtonOffset + SafeFrameOffsetY, 0, ButtonSpace, Center, Bottom, Center, Bottom, 0, self.TotalNormalButtons)
	self.Items:FormatTween(ALIGN_NS, 0, 0, 0, ButtonSpace, Center, Center, Center, Center, 0, self.TotalNormalButtons)
	--self.Login_Facebook:FormatTween(ALIGN_NS, 0, 25, 0, 0, Center, 0.4, Center, 0.4)
	--self.Login_Simple:FormatTween(ALIGN_NS, 0, 0, 0, 0, Center, 0.9, Center, 0.9)
	
	self.ActiveItemList = self.Items
end

function IntroMenu:HideLoginButtons()
	if (self.Items == nil or self.Items.Items == nil) then
		print("Er is iets mis. Print nu dat wat er mis is")
		print(self.Items);
		return
	end
	
	self.LoginButtonsVisible = false
	
	self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 96
	local NormalButtonOffset = self.TotalNormalButtons * ButtonSpace
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	--self.Items:Format(ALIGN_NS, 0 , 0, 0, ButtonSpace, Center, Center, Center, Center, 0, self.TotalNormalButtons)
	self.Items:FormatTween(ALIGN_NS, 0, ButtonSpace + NormalButtonOffset + SafeFrameOffsetY, 0, ButtonSpace, Center, Bottom, Center, Bottom, 0, self.TotalNormalButtons, true)
	
	if (self.ActiveItemList == self.Items) then
		self.ActiveItemList = nil
	end
end

function IntroMenu:AddOfflineButtons()
	self.Login_Facebook = nil
	self.Login_Simple = nil

	self.ItemsPanel = self.Menu:GetChild("Items")
	
	self.Items = NewItemList(self, UpButtons, DownButtons)
	self.Items.Panel = self.ItemsPanel
	self.Items.Panel:Clear()
	self.Items.TotalNormalButtons = 0
	
	self.ButtonTemplate = "Elements\\MenuButton_Login.dcMenu"
	--self.ButtonFBTemplate = "Elements\\MenuButtonFB_Login.dcMenu"
	
	self.Login_Retry = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "button_Retry"))
	self.Login_Skip = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "button_Skip_Login"))

end

function IntroMenu:ShowOfflineButtons()
	if (self.Items == nil or self.Login_Retry == nil or self.Login_Skip == nil) then
		self:AddOfflineButtons()
	end

	self:StopTimeOut()
	--self:HideLoadingPanel()
	
	self.ItemsPanel:SetColorFade(1, 10)
	self.ItemsPanel:SetColor(White)
	
	-- Add Normal buttons
	--self.TotalNormalButtons = 0
	
	
	self.Login_Retry.OnReleased = function()
		if (self.ActiveItemList == self.Items) then
			self.Login_Retry.OnReleased = nil
			self.Login_Skip.OnReleased = nil
			
			GameThread:Spawn(function()
				self:HideOfflineButtons()
				self.Items = nil
				GameThread:Sleep(0.3)
				self:CheckConnection()
			end)
		end
	end
	
	self.Login_Skip.OnReleased = function()
		if (self.ActiveItemList == self.Items) then
			self.Login_Retry.OnReleased = nil
			self.Login_Skip.OnReleased = nil
			
			GameThread:Spawn(function()
				if (ScoresUser ~= nil) then
					ScoresUser:Cancel()
				end
				
				self:HideOfflineButtons()
				self:Goto(MainMenu)
			end)
		end
	end
	
	self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 96
	local NormalButtonOffset = self.TotalNormalButtons * ButtonSpace
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	-- Format normal buttons
	self.Items:Format(ALIGN_NS, 0, ButtonSpace + NormalButtonOffset + SafeFrameOffsetY, 0, ButtonSpace, Center, Bottom, Center, Bottom, 0, self.TotalNormalButtons)
	self.Items:FormatTween(ALIGN_NS, 0, 0, 0, ButtonSpace, Center, Center, Center, Center, 0, self.TotalNormalButtons)
	
	self.ActiveItemList = self.Items
end

function IntroMenu:HideOfflineButtons()
	self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 96
	local NormalButtonOffset = self.TotalNormalButtons * ButtonSpace
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	--self.Items:Format(ALIGN_NS, 0 , 0, 0, ButtonSpace, Center, Center, Center, Center, 0, self.TotalNormalButtons)
	self.Items:FormatTween(ALIGN_NS, 0, ButtonSpace + NormalButtonOffset + SafeFrameOffsetY, 0, ButtonSpace, Center, Bottom, Center, Bottom, 0, self.TotalNormalButtons, true)
	
	if (self.ActiveItemList == self.Items) then
		self.ActiveItemList = nil
	end
end

-- ===================

function IntroMenu:OnUpdateSessionStatus(Status)
	print('IntroMenu:OnUpdateSessionStatus: ' .. tostring(Status))
	
	self:StopTimeOut()
	
	if (Status == "CREATED") then
		self:ShowLoginButtons()
	elseif (Status == "CREATED_TOKEN_LOADED") then
		if (not FirstRun) then
			FBManager:Login(nil) --Automatisch inloggen
			FirstRun = true
		end
	elseif (Status == "OPENING") then
		self:SetLoadingText("statusmessage_FacebookOpening")
		
		--EngineTimerStart()
	elseif (Status == "OPENED") then
		self:SetLoadingText("statusmessage_FacebookOpened")
		
		--FBManager:StartAction()
		--self:StartTimeOut()
		--self:Goto(MainMenu)
	elseif (Status == "CLOSED") then
		self:SetLoadingText("statusmessage_FacebookClosed")
		
		GameThread:Spawn(function(Thread)
			if (self.Items ~= nil) then
				self.Items.Clicked = false
			end
			
			--GameThread:Sleep(0.3)
			--FBManager:Logout(nil)
			--GameThread:Sleep(0.3)
			FBManager:CreateSession()
			--self:ShowLoginButtons()
		end)
	elseif (Status == "CLOSED_LOGIN_FAILED") then
		self:SetLoadingText("statusmessage_FacebookClosedLoginFailed")
		
		GameThread:Spawn(function(Thread)
			self.Items.Clicked = false;
			
			GameThread:Sleep(0.3)
			FBManager:Logout(nil)
			GameThread:Sleep(0.3)
			FBManager:CreateSession()
			self:ShowLoginButtons()
		end)
	end
end

function IntroMenu:OnUpdateUserinfo()
	print('facebook is okay, nu checken als we een userid kunnen ophalen')
	
	local FailureFunction = function(Data)
		print("Error retreiving facebook user")
		ScoresUser:Cancel()
		
		self:StopTimeOut()
		
		self.Items.Clicked = false
		
		GameThread:Spawn(function(Thread)
			GameThread:Sleep(0.4)
			self:SetLoadingText("statusmessage_UserLoginError")
			GameThread:Sleep(1.4)
			self:ShowLoginButtons()
			--and also show the skip login button
			
			FBManager:Logout(nil)
			print("timout")
		end)
	end
	
	local SuccessFunction = function(Data)
		print('OnReceiveUser')
		
		self:StopTimeOut()
		
		if (Data['User'] ~= nil and Data['User']['ID'] ~= nil) then
			print('user is okay, nu naar mainmenu')
			GameThread:Spawn(function(Thread)
				FBManager.UserinfoTable['HighscoresID'] = Data['User']['ID']
				if (not VirtualCoins.IsFirst_Facebook) then
					VirtualCoins:AddCoinCount(VirtualCoins.FirstAmount_Facebook)
					VirtualCoins:SendCollectedCoinsStats("FacebookAward", VirtualCoins.FirstAmount_Facebook, 0)
					
					VirtualCoins.IsFirst_Facebook = true
				end
				WriteGameSettings()
				
				self:HideLoginButtons()
				ReadyImage = texture('Check_128.DCT')
				self:ShowLoadingPanel(true)
				self:SetLoadingText("statusmessage_UserLoginSuccess")
				
				GameThread:Sleep(0.3)
					
				AnalyticsSendEvent("Login", "Login", "Facebook", "1")
				--self:Goto(MainMenu)
				self:Goto(DailyRewardsMenu)
				
				FBManager:GetUserFriends(nil)
			end)
		else
			FailureFunction()
		end
	end
	
	self:StartTimeOut(10, function()
		FailureFunction()	-- TODO: Hier de oorspronkelijke request cancellen
		print("timout")
	end)
	
	local UserID = tonumber(Scores.UserID)	--Evt. oude UserID van simple login
	local FacebookID = FBManager.UserinfoTable['id']
	local Name = FBManager.UserinfoTable['name']
	ScoresUser:GetFacebookUser(UserID, FacebookID, Name, SuccessFunction, FailureFunction)
end

function IntroMenu:DoSimpleLogin(UserName)
	local FailureFunction = function(Data)
		print("Error retreiving user")
		ScoresUser:Cancel()
		
		self.Items.Clicked = false
		
		self:StopTimeOut()
		
		GameThread:Spawn(function(Thread)
			GameThread:Sleep(0.4)
			self:SetLoadingText("statusmessage_UserLoginError")
			GameThread:Sleep(1.4)
			self:ShowLoginButtons()
			--and also show the skip login button
			print("timout")
		end)
	end

	local SuccessFunction = function(Data)
		print('OnReceiveUser')
		
		self:StopTimeOut()
		
		if (Data ~= nil and Data['User'] ~= nil and Data['User']['ID'] ~= nil) then
			
			print('user is okay, nu naar mainmenu')
			GameThread:Spawn(function(Thread)
				Scores.UserID = Data['User']['ID']
				local Name = Data['User']['Name']
				SetPlayername(Name);
				WriteGameSettings()
				
				self:HideLoginButtons()
				ReadyImage = texture('Check_128.DCT')
				self:ShowLoadingPanel(true)
				self:SetLoadingText("statusmessage_UserLoginSuccess")
				
				GameThread:Sleep(0.3)
				
				AnalyticsSendEvent("Login", "Login", "Simple", "1")
				--self:Goto(MainMenu)
				self:Goto(DailyRewardsMenu)
			end)
		else
			FailureFunction()
		end
	end

	self:StartTimeOut(10, function()
		FailureFunction()	-- TODO: FIXEN DEZE ROMMEL
		print("timout")
	end)
	
	local UserID = 0
	if(FBManager:IsLoginValid()) then
		UserID = tonumber(FBManager.UserinfoTable['HighscoresID'])
	else
		UserID = tonumber(Scores.UserID)
	end
	
	if (UserID ~= nil) then	-- Saved user
		ScoresUser:GetSimpleUser(UserID, UserName, SuccessFunction, FailureFunction)
	else							-- New user
		ScoresUser:CreateSimpleUser(UserName, SuccessFunction, FailureFunction)
	end
end

function IntroMenu:AddBackButton()
	self.TypeName_Items = NewItemList(self, nil, nil)
	
	--self.ItemsPanel = self.Menu:GetChild("Items")
	--self.ItemsPanel:Clear()
	
	self.TypeName_BackButton = self.TypeName_Items:AddItem(self.ItemsPanel, MenuElements.Label(self.TypeName_Items, "Elements\\MenuButtonProceed.dcMenu", "button_back"))
	self.TypeName_BackButton.OnReleased = function()
		if (self.ActiveItemList == self.TypeName_Items) then
			--self.TypeName_BackButton.OnReleased = nil
			self:KeyboardHidden()
		end
	end
end

function IntroMenu:ShowBackButton()
	if (self.TypeName_Items == nil) then
		self:AddBackButton()
	end
	
	self.TypeName_Items:SetSelection(self.TypeName_BackButton)
	
	self.TypeName_Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, 0, 1)
	self.TypeName_Items:FormatTween(ALIGN_NS, 0, 0, 0, 0, Right, Top, Right, Top, 0, 1)
	
	self.ActiveItemList = self.TypeName_Items
end

function IntroMenu:HideBackButton()
	--self.TypeName_BackButton.OnReleased = nil
	self.TypeName_Items:FormatTween(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, 0, 1)
	
	if (self.ActiveItemList == self.TypeName_Items) then
		self.ActiveItemList = nil
	end
end

function IntroMenu:TypeName(NameSuggestion)
	--if (self.NewHighscore) then
		self.NameInput = ""
		if (NameSuggestion ~= nil) then
			self.NameInput = NameSuggestion
			self.CursorInput = string.len(self.NameInput)
		end
		
		self.HighscoreName:SetText(self.NameInput);

		PhysicsThread:Spawn(function()
			PhysicsThread:Wait(30)

			self.EnterNamePanel:setcolorfade(1, 10.0)
			self.EnterNamePanel:setcolor(White)
			
			-- Back button
			self:ShowBackButton()
		end)

		print('Showing keyboard')
		ShowKeyboard();
		self.KeyboardVisible = true

		-- Kaap de processor
		self.ProcessCharCopy = ProcessChar;

		-- Zet hem op die van ons
		ProcessChar = function(...)
			self:ProcessChar(...);
		end
		
		if (self.CaretThread ~= nil) then
			GameThread:Stop(self.CaretThread);
			self.CaretThread = nil
		end

		self.CaretThread = GameThread:Spawn(function()
			while (true) do
				if (true) then
					local InputLine = self.NameInput;
		
					local InputLine_Head = string.sub(InputLine, 0, self.CursorInput)
					local InputLine_Tail = ""
					if (self.CursorInput < string.len(InputLine)) then
						InputLine_Tail = string.sub(InputLine, self.CursorInput + 1, string.len(InputLine))
					end

					local InputString0 = InputLine_Head .. '_' .. InputLine_Tail
					self.HighscoreName:SetText(InputString0);
				end

				GameThread:Wait(0.5)

				if (true) then
					local InputLine = self.NameInput;
		
					local InputLine_Head = string.sub(InputLine, 0, self.CursorInput)
					local InputLine_Tail = ""
					if (self.CursorInput < string.len(InputLine)) then
						InputLine_Tail = string.sub(InputLine, self.CursorInput + 1, string.len(InputLine))
					end

					local InputString1 = InputLine_Head .. ' ' .. InputLine_Tail
					self.HighscoreName:SetText(InputString1);
				end

				GameThread:Wait(0.5)
			end
		end)
	--end
end

function IntroMenu:ProcessChar(Character)
	if (self.CaretThread ~= nil) then		--Checken op self.CaretThread, aangezien ProcessChar ook naar activemenu wordt verzonden, dus je krijgt opnieuw calls binnen

		-- Dit is een kopie, dus hier kunnen we niet naartoe schrijven.
		local InputLine = self.NameInput;
		
		local InputLine_Head = string.sub(InputLine, 0, self.CursorInput)
		local InputLine_Tail = ""
		if (self.CursorInput < string.len(InputLine)) then
			InputLine_Tail = string.sub(InputLine, self.CursorInput + 1, string.len(InputLine))
		end

		-- Logica
		if (Character == '\b') then -- Backspace
			self.NameInput = string.sub(InputLine_Head, 0, self.CursorInput - 1) .. InputLine_Tail
			self.CursorInput = ClampMin(Dec(self.CursorInput), 0)
		elseif (Character == '\r') then
			if (self.NameInput ~= nil and self.NameInput ~= "") then
		
				-- We hoeven geen input meer
				if (self.ProcessCharCopy ~= nil) then
					-- Zet de boel terug
					ProcessChar = self.ProcessCharCopy;

					-- Ruim op
					self.ProcessCharCopy = nil;
				end

				-- Onze cursor kan ook stoppen
				if (self.CaretThread ~= nil) then
					GameThread:Stop(self.CaretThread);
					self.CaretThread = nil
				end
				
				print('ProcessChar - submit score')
				self:SubmitName()
			end
		else
			if (string.len(InputLine) < 30) then
				self.CursorInput = Inc(self.CursorInput)
				self.NameInput = InputLine_Head .. Character .. InputLine_Tail
			else
				playsound("Audio\\Pickup.WAV")
			end
		end

		self.HighscoreName:SetText(self.NameInput);
	end
end

function IntroMenu:SubmitName()
	self.EnterNamePanel:setcolorfade(1, 10.0)
	self.EnterNamePanel:setcolor(Invisible)
	
	self:HideBackButton()
	
	HideKeyboard();
	self.KeyboardVisible = false
	
	self:DoSimpleLogin(self.NameInput)
	
	print('SubmitName')
end

function IntroMenu:KeyboardHidden()
	self.EnterNamePanel:setcolorfade(1, 10.0)
	self.EnterNamePanel:setcolor(Invisible)
	
	self:HideBackButton()

	HideKeyboard();
	self.KeyboardVisible = false
	
	--FBManager:StopAction()
	
	print('Cancel TypeName')
	
	-- We hoeven geen input meer
	if (self.ProcessCharCopy ~= nil) then
		-- Zet de boel terug
		ProcessChar = self.ProcessCharCopy;

		-- Ruim op
		self.ProcessCharCopy = nil;
	end
	
	-- Onze cursor kan ook stoppen
	if (self.CaretThread ~= nil) then
		GameThread:Stop(self.CaretThread);
		self.CaretThread = nil
	end
	
	GameThread:Spawn(function()
		self:ShowLoginButtons()
	end)
end

function IntroMenu:StartTimeOut(Time, Function, FunctionAlmost)
	self:StopTimeOut()
	print("StartTimeOut")
	
	--if (self.TimeOutThread ~= nil) then
	
		self.TimeOutThread = GameThread:Spawn(function(Thread)
			print("TimeOutThread:Spawn")
			
			local WaitTime = 5.0
			if (Time ~= nil) then
				WaitTime = Time / 2
			end
			
			GameThread:Sleep(WaitTime)
			
			if (FunctionAlmost ~= nil) then
				FunctionAlmost()
			end
			
			GameThread:Sleep(WaitTime)
			
			--FBManager:StopAction()
			Function()
		end)
	--end
end

function IntroMenu:StopTimeOut()
	print("StopTimeOut")

	if (self.TimeOutThread ~= nil) then
		GameThread:Spawn(function()
			GameThread:Stop(self.TimeOutThread)
			self.TimeOutThread = nil
		end)
	end
end