NewsFeedMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("NewsFeedMenu", nil, function()
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		self.NewsPanel = self.Menu:GetChild("NewsPanel")
		self.NewsPanel:SetClickedFunc(function()
			self.NewsPanel:SetClickedFunc(nil)

			openwebsite("http://www.monsterjam.com/")
		end)
		
		-- Panels leegmaken en lijst aanmaken
		self.Items = NewItemList(self, UpButtons, DownButtons)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ButtonTemplate = "Elements\\MenuButton.dcMenu"

		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			--self:Goto(self.PreviousMenu)
			self:Goto(MainMenu)
		end
		
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		self.Items:SetSelection(self.FreeGoodsLikeDevButton)
		
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				--self:Goto(self.PreviousMenu)
				self:Goto(MainMenu)
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		for i = 1,7 do
			local Line = self.Menu:GetChild("Line_" .. i)
			Line:SetText(GetLiveAction("Line_" .. i, "Text"))
			Line:SetFont(GetLiveAction("Line_" .. i, "Font"))
		end
	end)
end)

function NewsFeedMenu:Goto(Target)
	ActiveMenu = Target(NewsFeedMenu)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function NewsFeedMenu:Active()
	return ActiveMenu == self
end

function NewsFeedMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = NewsFeedMenu(PreviousMenu)
end

function NewsFeedMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function NewsFeedMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function NewsFeedMenu:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end