RaceResultHighScore = class(function(self, PreviousMenu, LastHighscorePosted )
	self.PreviousMenu = PreviousMenu
	self.LastHighscorePosted = LastHighscorePosted
	
	AnalyticsSendScreenName("HighScoreMenu")
	-- gooi menu er op
	self.Menu = PushMenu("RaceResultHighScore")

	-- Pak het hoofdpanel en overige panels
	self.Main = self.Menu:GetChild("Main")
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)

	self.HighscorePanel = self.Menu:GetChild("HighscorePanel")
	self.WorldButtonPanel = self.Menu:GetChild("WorldButton")
	self.LocalButtonPanel = self.Menu:GetChild("LocalButton")
	self.FriendsButtonPanel = self.Menu:GetChild("FriendsButton")
	self.HighscoreItems = self.Menu:GetChild("HighscoreItems")
	self.HighscoreItemList = nil
	
	self.Highscores_Title = self.Menu:GetChild("Highscores_Title")
	
	self.ActiveHighscoreList = 2
	
	-- Fade in items
	self.Main:SetColorImmediate(White)
	
	-- Panels leegmaken en lijst aanmaken
	local ButtonItems = NewItemList(self, UpButtons, DownButtons)
	self.ButtonItems = ButtonItems

	local Items = NewItemList(self, LeftButtons, RightButtons)
	self.Items = Items
	
	self.BackButtonPanel = self.Menu:GetChild("BackButton")
	self.CenterButtonPanel = self.Menu:GetChild("CenterButton")
	self.ProceedButtonPanel = self.Menu:GetChild("ProceedButton")

	self.BackButtonPanel:Clear()
	self.CenterButtonPanel:Clear()
	self.ProceedButtonPanel:Clear()
	self.WorldButtonPanel:Clear()
	self.LocalButtonPanel:Clear()
	self.FriendsButtonPanel:Clear()
	
	self.BackButton = Items:AddItem(self.BackButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonBack.dcMenu", "button_restart"))
	self.BackButton.OnReleased = function()
		if (FuelEnergy:IsPowerAvailable() or DebugUnlockAll) then
			CutsceneBars = nil
			self.Menu:SetColor(Invisible)
			
			if (EndRaceCameraThread ~= nil) then
				PhysicsThread:Stop(EndRaceCameraThread)
				
				var('modelerp', 10000)
			end
			
			GameThread:Spawn(function()
				self.FadeScreen = self.Menu:GetChild("FadeScreen")
				self.FadeScreen:SetSize(9999, 9999)
				self.FadeScreen:SetColorFade(1, 2)
				self.FadeScreen:SetColorImmediate(color(0,0,0,0))
				self.FadeScreen:SetColor(Black)
				
				GameThread:Wait(1)
			
				-- if (ActiveMission ~= nil) then
					-- ActiveMission:Destroy()
					-- ActiveMission = nil
				-- end
				
				ClearMenuStack()
				ActiveMenu = nil
				CutsceneBars = nil
				
				if (ScoresUser ~= nil) then
					ScoresUser:Cancel()
				end
			
				var("IntPause", 0)
				reloadscript()
			end)
		else
			-- hier melding geven dat men geen power heeft
			ShowConfirm_Refuel()
		end
	end
	
	--Tijdelijk ff disablen
	if (not FuelEnergy:IsPowerAvailable()) then
		self.BackButton:Disable()
		--self.BackButton:SetText(Translate("button_restartnofuel"))
	end
	
	self.Proceed = Items:AddItem(self.ProceedButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonProceed.dcMenu", "button_proceed"))
	self.Proceed.OnReleased = function()
		GameThread:Spawn(function()
			-- Eerst menu weg
			CutsceneBars = nil
			self.Menu:SetColor(Invisible)
			ClearMenuStack()
			ActiveMenu = nil
			CutsceneBars = nil
			HUD = nil

			-- Dan pauze uit
			var("IntPause", 0)

			-- Dan de prepare functie zetten
			PrepareScript = function()
				ActiveMission = MenuMission()
				
				ActiveMenu = CarSelect(nil)
			end
			
			if (ScoresUser ~= nil) then
				ScoresUser:Cancel()
			end

			-- En dan pas laden
			loadscript("Menu")
		end)
	end
	self.Proceed:Flash(1, true, true)
	
	self.CurrentRace = ActiveGameMode.ActiveChapter.ActiveRace
	self.CurrentMission = ActiveMission
	self.Player = self.CurrentMission.Players[1]
	self.CarName = "MijnAuto" --translate(self.Player.Car:GetType() .. "_Name")
	
	if (ActiveMission.HighscoreClient ~= nil and ActiveMission.HighscoreClient.Results ~= nil) then
		self.WorldButton = ButtonItems:AddItem(self.WorldButtonPanel, MenuElements.Label(ButtonItems, "Elements\\HighScores_MenuButton.dcMenu", "button_world"))
		self.WorldButton.Selectable = false
		self.WorldButton.OnReleased = function()
			ButtonItems.Clicked = false
			self:ShowHighscores(1)
		end
	end
	
	self.LocalButton = ButtonItems:AddItem(self.LocalButtonPanel, MenuElements.Label(ButtonItems, "Elements\\HighScores_MenuButton.dcMenu", "button_local"))
	self.LocalButton.Selectable = false
	self.LocalButton.OnReleased = function()
		ButtonItems.Clicked = false
		self:ShowHighscores(2)
	end
	
	if (ActiveMission.HighscoreClient ~= nil and ActiveMission.HighscoreClient.Results ~= nil) then
		if (FBManager:IsLoginValid() and ActiveMission.HighscoreClient.Results['FriendsScores'] ~= nil) then
			self.FriendsButton = ButtonItems:AddItem(self.FriendsButtonPanel, MenuElements.Label(ButtonItems, "Elements\\HighScores_MenuButton.dcMenu", "button_friends"))
			self.FriendsButton.Selectable = false
			self.FriendsButton.OnReleased = function()
				ButtonItems.Clicked = false
				self:ShowHighscores(3)
			end
		end
	end
	
	local ButtonOffset = 50
	local ProceedButtonOffset = #self.Items.Items - 1
	self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, -ButtonOffset, 0, Left, Bottom, Right, Bottom, ProceedButtonOffset, #self.Items.Items - 1)
	self.Items:FormatTween(ALIGN_NS, 0, 0, -ButtonOffset, 0, Right, Bottom, Right, Bottom, ProceedButtonOffset, #self.Items.Items - 1)
	
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	self:ShowHighscores(2, true)
end)

function RaceResultHighScore:Goto(Target)
	ActiveMenu = Target(RaceResultHighScore)

	self.Main:SetColor(Invisible)
end

function RaceResultHighScore:Active()
	return ActiveMenu == self
end

function RaceResultHighScore:Refresh()
	ActiveMenu = RaceResultHighScore(self.PreviousMenu, self.LastHighscorePosted)
end

function RaceResultHighScore:ToggleList()
	if (self.ShowFriends ~= nil) then
		self.ShowFriends = not self.ShowFriends
	else
		self.ShowFriends = true
	end
	
	if (self.ShowFriends) then
		self:ShowFriendsList()
	else
		self:ShowWorldList()
	end
end

function RaceResultHighScore:ShowHighscores(ActiveList, Force)
	if (self.ActiveHighscoreList ~= ActiveList or Force) then
		self.ActiveHighscoreList = ActiveList
		
		if (self.WorldButton) then
			self.WorldButton:Deactivate()
		end
		if (self.LocalButton) then
			self.LocalButton:Deactivate()
		end
		if (self.FriendsButton) then
			self.FriendsButton:Deactivate()
		end
		
		if (ActiveList == 1) then
			self:ShowWorldList()
			self.WorldButton:Activate()
		elseif (ActiveList == 2) then
			self:ShowLocalList()
			self.LocalButton:Activate()
		elseif (ActiveList == 3) then
			self:ShowFriendsList()
			self.FriendsButton:Activate()
		end
	end
end



function RaceResultHighScore:ShowLocalList() 
	local ItemList = NewItemList(self, UpButtons, DownButtons)
	self.HighscoreItemList = ItemList
	self.HighscoreItems:Clear()
	
	if (self.CurrentRace.HighScores ~= nil and #self.CurrentRace.HighScores > 0) then
		for Key, HighScore in pairs(self.CurrentRace.HighScores) do
			if (Key <= 15) then
				local IsPlayer = HighScore.ID == self.LastHighscorePosted
				ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", Key, HighScore.Name, HighScore.Car, HighScore.Score, IsPlayer))
			end
		end
	else
		local HighScore = self.CurrentRace.HighScores[1]
		ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", 1, HighScore.Name, HighScore.Car, HighScore.Score, true))
	end
	ItemList:Format(ALIGN_NS, 0, 0, 0, 0, 0, 0, 0, 0, 0, #ItemList.Items)
end

function RaceResultHighScore:ShowWorldList()
	local ItemList = NewItemList(self, UpButtons, DownButtons)
	self.HighscoreItemList = ItemList
	self.HighscoreItems:Clear()
	
	if (ActiveMission.HighscoreClient ~= nil) then
		local ShowFriends = false
		local UserID = 0
		if(FBManager:IsLoginValid()) then
			UserID = tonumber(FBManager.UserinfoTable['HighscoresID'])
		else
			UserID = tonumber(Scores.UserID)
		end
		
		if (UserID ~= nil and UserID > 0) then
			local Entries = ActiveMission.HighscoreClient.Results['Scores'];
			if (ShowFriends) then
				Entries = ActiveMission.HighscoreClient.Results['FriendsScores'];
			end
			if (Entries == nil) then
				return
			end
			
			table.sort(Entries, function(a, b)
				if (b.Score < a.Score) then
					return true;
				elseif (b.Score == a.Score and (a.Place ~= nil and b.Place ~= nil)) then
					return a.Place < b.Place;
				else
					return false
				end
			end)
			
			for i, Entry in ipairs(Entries) do
				local UserTable = {}
				UserTable['id'] = Entry.FacebookID
				UserTable['name'] = ''
				UserTable['score'] = math.floor(Entry.Score)
				UserTable['rank'] = 1
				
				if (Entry.FacebookID ~= 0) then
					if (FBManager.UserFriendsTable ~= nil) then
						FacebookUser = FBManager.UserFriendsTable[Entry.FacebookID]
						if (FacebookUser ~= nil) then
							UserTable['picture'] = FacebookUser['picture']
						end
					elseif (FBManager.UserinfoTable ~= nil) then
						if (Entry.FacebookID == FBManager.UserinfoTable['id']) then
							UserTable['picture'] = FBManager.UserinfoTable['picture']
						end
					end
				end
				
				local Place = Entry.Place
				if (ShowFriends) then
					Place = i
				end
				
				local CarName = Translate(MonsterTruckCars.Cars[Entry.CarID].Title)
				ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", Place, Entry.Name, CarName, Entry.Score, Entry.LocalUser))
			end
		end
	end
	
	if (#ItemList.Items == 0) then
		ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", "-", "", "No entries", "-", false))
	end
	
	ItemList:Format(ALIGN_NS, 0, 0, 0, 0, 0, 0, 0, 0, 0, #ItemList.Items)
end

function RaceResultHighScore:ShowFriendsList()
	local ItemList = NewItemList(self, UpButtons, DownButtons)
	self.HighscoreItemList = ItemList
	self.HighscoreItems:Clear()
	
	if (ActiveMission.HighscoreClient ~= nil) then
		local ShowFriends = true
		local UserID = 0
		if(FBManager:IsLoginValid()) then
			UserID = tonumber(FBManager.UserinfoTable['HighscoresID'])
		else
			UserID = tonumber(Scores.UserID)
		end
		
		if (UserID ~= nil and UserID > 0) then
			local Entries = ActiveMission.HighscoreClient.Results['Scores'];
			if (ShowFriends) then
				Entries = ActiveMission.HighscoreClient.Results['FriendsScores'];
			end
			if (Entries == nil) then
				return
			end
			
			table.sort(Entries, function(a, b)
				if (b.Score < a.Score) then
					return true;
				elseif (b.Score == a.Score and (a.Place ~= nil and b.Place ~= nil)) then
					return a.Place < b.Place;
				else
					return false
				end
			end)
			
			for i, Entry in ipairs(Entries) do
				local UserTable = {}
				UserTable['id'] = Entry.FacebookID
				UserTable['name'] = ''
				UserTable['score'] = math.floor(Entry.Score)
				UserTable['rank'] = 1
				
				if (Entry.FacebookID ~= 0) then
					if (FBManager.UserFriendsTable ~= nil) then
						FacebookUser = FBManager.UserFriendsTable[Entry.FacebookID]
						if (FacebookUser ~= nil) then
							UserTable['picture'] = FacebookUser['picture']
						end
					elseif (FBManager.UserinfoTable ~= nil) then
						if (Entry.FacebookID == FBManager.UserinfoTable['id']) then
							UserTable['picture'] = FBManager.UserinfoTable['picture']
						end
					end
				end
				
				local Place = Entry.Place
				if (ShowFriends) then
					Place = i
				end
				
				local CarName = Translate(MonsterTruckCars.Cars[Entry.CarID].Title)
				ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", Place, Entry.Name, CarName, Entry.Score, Entry.LocalUser))
			end
		end
	end
	
	if (#ItemList.Items == 0) then
		ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", "-", "", "No entries", "-", false))
	end
	
	-- if (self.CurrentRace.HighScores ~= nil and #self.CurrentRace.HighScores > 0) then
		-- for Key, HighScore in pairs(self.CurrentRace.HighScores) do
			-- if (Key <= 15) then
				-- ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", Key, HighScore.Name, HighScore.Car, HighScore.Score, HighScore.ID))
			-- end
		-- end
	-- else
		-- local HighScore = self.CurrentRace.HighScores[1]
		-- ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", 1, HighScore.Name, HighScore.Car, HighScore.Score, HighScore.ID))
	-- end
	
	--ItemList:AddItem(self.HighscoreItems, MenuElements.HighScores(ItemList, "elements\\Highscore_Template.dcMenu", "-", "FriendsHighscore", "CarName", "-Score-", false))
	
	ItemList:Format(ALIGN_NS, 0, 0, 0, 0, 0, 0, 0, 0, 0, #ItemList.Items)
end
