RaceResultScreen = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	AnalyticsSendScreenName("RaceResultScreen")
	-- gooi menu er op
	self.Menu = PushMenu("RaceResultScreen")

	-- Pak het hoofdpanel en overige panels
	self.Main = self.Menu:GetChild("Main")
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)

	self.ScorePanel = self.Menu:GetChild("ScorePanel")
	self.CoinPanel = self.Menu:GetChild("CoinPanel")
	self.Text1 = self.Menu:GetChild("Text1")
	self.Text2 = self.Menu:GetChild("Text2")
	self.Text3 = self.Menu:GetChild("Text3")
	self.CoinImage = self.Menu:GetChild("CoinImage")
	self.CoinText = self.Menu:GetChild("CoinText")
	self.CoinTextFade = self.Menu:GetChild("CoinTextFade")
	self.CoinPickupText = self.Menu:GetChild("CoinPickupText")
	self.CoinPickupTextFade = self.Menu:GetChild("CoinPickupTextFade")
	self.Title = self.Menu:GetChild("Title")
	
	self.ScoreItems = 0
	
	self.Skipped = false
	
	GameThread:Spawn(function()
		GameThread:Wait(1)
		self.ScorePanel:SetClickedFunc(function()
			if (not self.Skipped) then
				self.Skipped = true
			
				if (self.FillCoinsThread ~= nil) then
					PhysicsThread:Resume(self.FillCoinsThread)
				end
				
				if (self.ScoreThread) then
					PhysicsThread:Resume(self.ScoreThread)
				end
			end
		end)
	end)
	
	self.CoinTextFadePosX, self.CoinTextFadePosY = self.CoinTextFade:GetPos()
	
	self.CoinImageFlash = self.Menu:GetChild("CoinImageFlash")
	
	self.ScoreStarsPanel = self.Menu:GetChild("ScoreStarsPanel")
	self.ScoreStars = self.Menu:GetChild("ScoreStars")
	
	-- Fade in items
	self.Main:SetColorImmediate(White)
	
	local ScreenWidth = getvar("VirtualRTx")
	local ScreenHeight = getvar("VirtualRTy")
	
	self.ScorePanel:SetPosData(0, 0, Center, Center, Center, Center, 0, None, false)
	
	--self.CoinPanel:SetPosData(0, -12, Center, Bottom, Center, Bottom, 0, None, false)
	
	self.Score = ActiveMission:GetScore()
	self.Multiplier = GetGameMode(ActiveGameMode.Name, "ScoreMultiplier")
	self.CoinMultiplier = GetGameMode(ActiveGameMode.Name, "CoinMultiplier")
	
	AnalyticsSendEvent("GameMode", "CoinsCollected", ActiveGameMode.Name, tostring(Round(self.Score / self.CoinMultiplier)))
	
	local MaxStars = 5
	self.CurrentStarAmount = MaxStars
	
	for i = 0, MaxStars do -- bjoetieful
		local RScore = GetGameMode(ActiveGameMode.Name, "ScoreRating", i + 1)
		if (self.Score >= RScore) then
			self.CurrentStarAmount = i
		end
	end
	
	if (ActiveGameMode == FreestyleFest) then
		self.CurrentStarAmount = ActiveMission.HumanPlayers[1].Total5StarScore
	end
	
	local ScoreResultText = "score_GOOD"
	if self.CurrentStarAmount == 0 then
		ScoreResultText = "score_YOUCANDOBETTER"
		playsound("Result_2.wav")
	elseif self.CurrentStarAmount == 1 then
		ScoreResultText = "score_YOUCANDOBETTER"
		playsound("Result_2.wav")
	elseif self.CurrentStarAmount == 2 then
		ScoreResultText = "score_GOOD"
		playsound("Result_3.wav")
	elseif self.CurrentStarAmount == 3 then
		ScoreResultText = "score_GOOD"
		playsound("Result_3.wav")
	elseif self.CurrentStarAmount == 4 then
		ScoreResultText = "score_GOOD"
		playsound("Result_3.wav")
	elseif self.CurrentStarAmount == 5 then
		ScoreResultText = "score_PERFECT"
		playsound("Result_4.wav")
	end
	
	local NewHighscore = false
	if (NewHighscore) then
		ScoreResultText = "score_HIGHSCORE"
		GameThread:Spawn(function()
			GameThread:Wait(2)
			playsound("Result_HighScore.wav")
		end)
	end
	
	-- HIGHSCHORE DINGETJES
	
	self.CurrentRace = ActiveGameMode.ActiveChapter.ActiveRace
	self.CurrentMission = ActiveMission
	self.Player = self.CurrentMission.HumanPlayers[1]
	self.CarName = translate(self.Player.Car:GetType() .. "_Name")

	self.LastHighscorePosted = self.CurrentRace:AddHighScore(#self.CurrentRace.HighScores + 1, self.Player.Name, self.CarName, math.ceil(self.CurrentMission.Score), self.CurrentMission.StarScore)
	
	-- EINDE HIGHSCHORE DINGETJES
	
	-- ALLE STERRETJES GEHAALD?
	
	self.EarnMonsterjamCoin = true
	
	for i, GameMode in ipairs(GameModes) do
		if(GameMode.Chapters[1].Races[1].HighScores[1] == nil) then
			-- als je uberhaupt die gamemode niet gespeeld hebt
			self.EarnMonsterjamCoin = false
		elseif (GameMode.Chapters[1].Races[1].HighScores[1].StarScore ~= 5) then
			-- als je niet alle sterretjes hebt
			self.EarnMonsterjamCoin = false
		end
	end
	
	if(MJCoinEarned) then
		self.EarnMonsterjamCoin = false
	end
	
	--self.EarnMonsterjamCoin = true -- debug
	
	-- EINDE ALLE STERRETJES GEHAALD?
	
	self.Title:SetText(Translate(ScoreResultText))
	
	self.RankStars = {}
	
	self.ScoreStars:clear()
	
	self.Text1:SetColorImmediate(Invisible)
	self.Text2:SetColorImmediate(Invisible)
	self.Text3:SetColorImmediate(Invisible)
	
	self.ScoreThread = PhysicsThread:Spawn(function()		
		if (self.ScoreItems >= 1) then
			self.Text1:SetColorImmediate(White)
			
			if (not self.Skipped) then
				playsound("Audio\\Score_stars.wav")
				PhysicsThread:Sleep(0.5)
			end
		end
		
		if (self.ScoreItems >= 2) then
			self.Text2:SetColorImmediate(White)
			
			if (not self.Skipped) then
				playsound("Audio\\Score_stars.wav")
				PhysicsThread:Sleep(0.5)
			end
		end
		
		if (self.ScoreItems >= 3) then
			self.Text3:SetColorImmediate(White)
	
			if (not self.Skipped) then
				playsound("Audio\\Score_stars.wav")
				PhysicsThread:Sleep(0.5)
			end
		end
		
		-- Here it calculates the placing of the stars and repeats this to the
		-- total amount of earned stars
		for i = 1, self.CurrentStarAmount do
			local Item = RankStar(self.ScoreStars, "elements\\score_rankstar_template_128_rotate.dcMenu")	
			Item:Activate()
			Item.Item:SetPos(-128 + ((i - 1) * 128), -85) -- 128 is the used spacing between the stars
			table.insert(self.RankStars, Item)
			
			if (not self.Skipped) then
				playsound("Audio\\Score_stars.WAV")
				PhysicsThread:Sleep(0.75)
			end
		end
		
		if (not self.Skipped) then
			PhysicsThread:Sleep(0.5)
		end
		self.CoinImage:SetColorImmediate(White)		
		
		self.ScoreThread = nil
	end)
	
	-- Panels leegmaken en lijst aanmaken
	local Items = NewItemList(self, LeftButtons, RightButtons)
	self.Items = Items
	
	self.BackButtonPanel = self.Menu:GetChild("BackButton")
	self.ProceedButtonPanel = self.Menu:GetChild("ProceedButton")
	self.MiddleButtonPanel = self.Menu:GetChild("MiddleButton")

	self.BackButtonPanel:Clear()
	self.ProceedButtonPanel:Clear()
	self.MiddleButtonPanel:Clear()
	
	local HumanPlayer = ActiveMission.HumanPlayer

	self.BackButton = Items:AddItem(self.BackButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonBack.dcMenu", "button_restart"))
	self.BackButton.OnReleased = function()
		if (FuelEnergy:IsPowerAvailable() or DebugUnlockAll) then
			CutsceneBars = nil
			self.Menu:SetColor(Invisible)
			
			if (ActiveGameMode == SingleRace) then
				ActiveGameMode.RandomizeAIData = true
			end
			
			if (EndRaceCameraThread ~= nil) then
				PhysicsThread:Stop(EndRaceCameraThread)
				
				var('modelerp', 10000)
			end
			
			GameThread:Spawn(function()
				self.FadeScreen = self.Menu:GetChild("FadeScreen")
				self.FadeScreen:SetSize(9999, 9999)
				self.FadeScreen:SetColorFade(1, 2)
				self.FadeScreen:SetColorImmediate(color(0,0,0,0))
				self.FadeScreen:SetColor(Black)
				
				GameThread:Wait(1)
			
				-- if (ActiveMission ~= nil) then
					-- ActiveMission:Destroy()
					-- ActiveMission = nil
				-- end
				
				ClearMenuStack()
				ActiveMenu = nil
				CutsceneBars = nil
			
				var("IntPause", 0)
				reloadscript()
			end)
		else
			-- hier melding geven dat men geen power heeft
			ShowConfirm_Refuel()
		end
	end
	
	--Tijdelijk ff disablen
	if (not FuelEnergy:IsPowerAvailable()) then
		self.BackButton:Disable()
		--self.BackButton:SetText(Translate("button_restartnofuel"))
	end
	
	if (self.CurrentStarAmount > 2) then
		local MomentID = "mj_" .. tostring(self.CurrentStarAmount) .. "_"
		if (ActiveGameMode == SingleRace) then
			MomentID = MomentID .. "racing"
		elseif (ActiveGameMode == SkillGame) then
			MomentID = MomentID .. "hilljumprace"
		elseif (ActiveGameMode == TowTest) then
			MomentID = MomentID .. "towtest"
		elseif (ActiveGameMode == FreestyleFest) then
			MomentID = MomentID .. "freestyle"
		elseif (ActiveGameMode == Destroyer) then
			MomentID = MomentID .. "destroyer"
		elseif (ActiveGameMode == FrameTwister) then
			MomentID = MomentID .. "frametwister"
		elseif (ActiveGameMode == TankTrap) then
			MomentID = MomentID .. "tanktrap"
		end
		print("Kiip:SaveMoment(" .. MomentID .. ")")
		Kiip:SaveMoment(MomentID)
	end
	
	--Kiip.RewardAvailable = true	--tijdelijk
	if (Kiip.RewardAvailable) then
		self.RedeemKiipReward = Items:AddItem(self.MiddleButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonKiipReward.dcMenu", "Redeem Reward"))
		self.RedeemKiipReward.Selectable = false
		self.RedeemKiipReward.Background:SetColorData(color(0.45, 0.3, 0.8, 1), 0, None, false)
		self.RedeemKiipReward.OnReleased = function()
			Kiip:RedeemReward()
			Items.Clicked = false
			
			self.RedeemKiipReward.Item:SetColorFade(1, 6)
			self.RedeemKiipReward.Item:SetColor(Invisible)
		end
	end
	
	
	self.Proceed = Items:AddItem(self.ProceedButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonProceed.dcMenu", "button_proceed"))
	self.Proceed.OnReleased = function()
		GameThread:Spawn(function()
			if (self.FillCoinsThread ~= nil) then
				PhysicsThread:Stop(self.FillCoinsThread)
				self.FillCoinsThread = nil
			end
			
			if (self.ScoreThread) then
				PhysicsThread:Stop(self.ScoreThread)
				self.ScoreThread = nil
			end
			
			if (self.StuntButton ~= nil) then
				self.StuntButton.Item:SetColor(Invisible)
				self.StuntList = nil
				self.StuntButton = nil
			end
			
			self.BackButtonPanel:Clear()
			self.ProceedButtonPanel:Clear()
			self.MiddleButtonPanel:Clear()
		
			self.Main:SetColorImmediate(Invisible)
			
			if (self.EarnMonsterjamCoin) then
				ActiveMenu = RaceResultEarnMonsterJamCoin(RaceResultScreen)
			else
				ActiveMenu = RaceResultHighScore(nil, self.LastHighscorePosted)
			end
		end)
	end
	self.Proceed:Flash(1, true, true)
	
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	-- MJ results
	if (ActiveGameMode == SingleRace) then
		self:SingleRace()
	elseif (ActiveGameMode == DeathMatch) then
		self:DeathMatch()
	elseif (ActiveGameMode == Sandbox) then
		self:Sandbox()
	elseif (ActiveGameMode == SkillGame) then
		self:HillJump()
	elseif (ActiveGameMode == TowTest) then
		self:TowTest()
	elseif (ActiveGameMode == FreestyleFest) then
		self:Freestyle()
	elseif (ActiveGameMode == Destroyer) then
		self:Destroyer()
	elseif (ActiveGameMode == FrameTwister) then
		self:FrameTwister()
	elseif (ActiveGameMode == TankTrap) then
		self:TankTrap()
	end
end)

function RaceResultScreen:SingleRace()	
	local HumanPlayer = nil
	local AIPlayer = nil
	
	for i, Player in ipairs(ActiveMission.Players) do
		if (Player.Human) then
			HumanPlayer = Player
		else
			AIPlayer = Player
		end
	end
	
	self.ScoreItems = 3

	table.sort(ActiveMission.Players, PlayerSort_LapTime)
	local HumanWon = ActiveMission.Players[1].Human
	
	if (HumanWon) then
		self.Title:SetText(Translate("results_humanwon"))
		self.Text1:SetText(string.format(Translate("results_towtest_text4"), tostring(FormatTime(HumanPlayer.LastLapTime))))
		self.Text2:SetText(string.format(Translate("results_towtest_text5"), tostring(FormatTime(AIPlayer.LastLapTime))))
		
		ActiveGameMode.ActiveChapter.ActiveRace.WinCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.WinCount)
	else
		self.Title:SetText(Translate("results_humanlost"))
		if (not HumanPlayer.Failed) then
			self.Text1:SetText(string.format(Translate("results_towtest_text4"), tostring(FormatTime(HumanPlayer.LastLapTime))))
			self.Text2:SetText(string.format(Translate("results_towtest_text5"), tostring(FormatTime(AIPlayer.LastLapTime))))
		else
			self.ScoreItems = self.ScoreItems - 2
		end
		
		ActiveGameMode.ActiveChapter.ActiveRace.LoseCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.LoseCount)
	end
	
	--self.Text3:SetText(string.format(Translate("results_towtest_text2"), tostring(Round(self.Score))))
	self.Text3:SetText(string.format(Translate("results_towtest_text2"), 0))
	
	local TotalScore = self.Score * self.Multiplier
	local Coins = TotalScore / self.CoinMultiplier
	
	self:FillCoins(self.CoinText, Coins, self.Text3, self.Score, "results_towtest_text2")
end

function RaceResultScreen:DeathMatch()
	--
end

function RaceResultScreen:Sandbox()
	--
end

function RaceResultScreen:HillJump()
	self.ScoreItems = 2

	local Player = ActiveMission.HumanPlayers[1]

	self.Text1:SetText(string.format(Translate("results_towtest_text7"), tostring(FormatTime(Player.LastLapTime))))
	--self.Text2:SetText(string.format(Translate("results_towtest_text2"), tostring(Round(self.Score))))
	self.Text2:SetText(string.format(Translate("results_towtest_text2"), 0))
	self.Text3:SetText("   ")
	
	local TotalScore = self.Score * self.Multiplier
	local Coins = TotalScore / self.CoinMultiplier
	
	self:FillCoins(self.CoinText, Coins, self.Text2, self.Score, "results_towtest_text2")
	
	ActiveGameMode.ActiveChapter.ActiveRace.WinCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.WinCount)
end

function RaceResultScreen:Freestyle()
	self.ScoreItems = 2

	--self.Text1:SetText(string.format(Translate("Average: %.0f"), tostring(Round(self.Score / Multiplier))))
	--self.Text2:SetText(string.format(Translate("Score: %.0f"), tostring(Round(self.Score))))
	self.Text2:SetText(string.format(Translate("Score: %.0f"), 0))
	self.Text3:SetText("   ")
	
	local TotalScore = Round((self.Score) * self.Multiplier)
	local TotalCoins = Round((self.Score) / self.CoinMultiplier) -- Hier word een deelsom gebruikt omdat het aantal coins de score / 1000 is.
	
	-- This sets the text to write "Score: " together with the correct value.
	self:FillCoins(self.CoinText, TotalCoins, self.Text2, TotalScore, "results_towtest_text2")
	
	self.ToggleCallback = function()
		if (self.StuntList.IsToggled) then
			self.Main:GetChild("Results"):SetColor(Invisible)
		else
			self.Main:GetChild("Results"):SetColor(White)
		end
	end
	
	ActiveGameMode.ActiveChapter.ActiveRace.WinCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.WinCount)
	
	-- StuntButton
	local LocationData = {0,0,1,0,1,0}
	self.StuntButton = HUD_E_SimpleScreenButton(self, self.SafeFrame, "hud_SimpleScreenButton", LocationData, "DCK_SCREENBUTTON_3")
	self.StuntButton:SetText("!")
	
	-- StuntList
	local LocationData = {0, 0, 0.875, 0, 0.875, 0}
	self.StuntList = HUD_E_StuntList(self, self.SafeFrame, "hud_StuntList", LocationData, nil, nil, self.StuntButton, self.ToggleCallback)
	self.StuntList:UpdateScores()
	
	AddKeyListeners("DCK_SCREENBUTTON_3", "Down", function(Listener)
		GameThread:Spawn(function()
			if (self.StuntList ~= nil and not self.StuntList.IsToggled) then
				self.StuntList:ToggleWindow()
			end
		end)
	end)
end

function RaceResultScreen:TowTest()		
	self.ScoreItems = 2
	
	self.Text1:SetText(string.format(Translate("results_towtest_text1"), tostring(Round(ActiveMission.MaxDistanceTowed))))
	--self.Text2:SetText(string.format(Translate("results_towtest_text2"), tostring(Round(self.Score))))
	self.Text2:SetText(string.format(Translate("results_towtest_text2"), 0))
	self.Text3:SetText("   ")
	
	local TotalScore = self.Score * self.Multiplier
	local Coins = TotalScore / self.CoinMultiplier
	
	self:FillCoins(self.CoinText, Coins, self.Text2, self.Score, "results_towtest_text2")
	
	ActiveGameMode.ActiveChapter.ActiveRace.WinCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.WinCount)
end

function RaceResultScreen:Destroyer()		
	self.ScoreItems = 2
	
	--self.Text1:SetText(string.format(Translate("results_towtest_text1"), tostring(Round(ActiveMission.Score))))
	self.Text2:SetText(string.format(Translate("results_towtest_text2"), 0))
	self.Text3:SetText("   ")
	
	local TotalScore = self.Score * self.Multiplier
	local Coins = TotalScore / self.CoinMultiplier
	
	self:FillCoins(self.CoinText, Coins, self.Text2, self.Score, "results_towtest_text2")
	
	ActiveGameMode.ActiveChapter.ActiveRace.WinCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.WinCount)
end

function RaceResultScreen:FrameTwister()		
	self.ScoreItems = 2
	
	--self.Text1:SetText(string.format(Translate("results_towtest_text1"), tostring(Round(ActiveMission.Score))))
	self.Text2:SetText(string.format(Translate("results_towtest_text2"), 0))
	self.Text3:SetText("   ")
	
	local TotalScore = self.Score * self.Multiplier
	local Coins = TotalScore / self.CoinMultiplier
	
	self:FillCoins(self.CoinText, Coins, self.Text2, self.Score, "results_towtest_text2")
	
	ActiveGameMode.ActiveChapter.ActiveRace.WinCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.WinCount)
end

function RaceResultScreen:TankTrap()
	self.ScoreItems = 2

	local Player = ActiveMission.HumanPlayers[1]

	self.Text1:SetText(string.format(Translate("results_towtest_text7"), tostring(FormatTime(Player.LastLapTime))))
	--self.Text2:SetText(string.format(Translate("results_towtest_text2"), tostring(Round(self.Score))))
	self.Text2:SetText(string.format(Translate("results_towtest_text2"), 0))
	self.Text3:SetText("   ")
	
	local TotalScore = self.Score * self.Multiplier
	local Coins = TotalScore / self.CoinMultiplier
	
	self:FillCoins(self.CoinText, Coins, self.Text2, self.Score, "results_towtest_text2")
	
	ActiveGameMode.ActiveChapter.ActiveRace.WinCount = Inc(ActiveGameMode.ActiveChapter.ActiveRace.WinCount)
end

function RaceResultScreen:Goto(Target)
	ActiveMenu = Target(RaceResultScreen, self.LastHighscorePosted )

	self.Main:SetColor(Invisible)
end

function RaceResultScreen:Active()
	return ActiveMenu == self 
end

function RaceResultScreen:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = RaceResultScreen(PreviousMenu)
end

function RaceResultScreen:FillCoins(MenuElementInc, TotalCoins, MenuElementDec, TotalScore, TextKey)
	local PlayedEndingSound = false
	
	local CoinsGained = Round(TotalCoins)
	VirtualCoins:AddCoinCount(CoinsGained)
	VirtualCoins:SendCollectedCoinsStats("InGame", CoinsGained, 0)
	
	self.FillCoinsThread = PhysicsThread:Spawn(function()
		if (not self.Skipped) then
			local Player = ActiveMission.HumanPlayers[1]
			PhysicsThread:Sleep((self.ScoreItems * 0.5) + (self.CurrentStarAmount * 0.75))
		end
		
		if (not self.Skipped) then
			playsound("Audio\\Bling.wav")
		else
			playsound("Audio\\Score_stars.wav")
			PlayedEndingSound = true
		end
		
		local Length = 120
		local Timer = 0
		local TimerInterfal = 10
		
		local Interfal = ClampMin(TotalCoins / Length, 0)
		
		local Score = 0
		
		for i = 1, Length do
			if (not self.Skipped) then
				PhysicsThread:Wait(1)
			else
				if (not PlayedEndingSound) then
					playsound("Audio\\Score_stars.wav")
				end
			
				break
			end
		
			MenuElementInc:SetText(tostring(Round(i * Interfal)))
			
			if (MenuElementDec ~= nil and TotalScore ~= nil and TextKey ~= nil) then
				MenuElementDec:SetText(string.format(Translate(TextKey), tostring(Round(Lerp(Score, TotalScore, i / Length)))))
			end
			
			if (Timer > TimerInterfal and i * Interfal < TotalCoins) then
				playsound("Audio\\Bling.wav")
				Timer = 0
			else
				Timer = Inc(Timer)
			end
		end
		
		MenuElementInc:SetText(tostring(Round(Length * Interfal)))
		MenuElementDec:SetText(string.format(Translate(TextKey), tostring(Round(TotalScore)))) -- Ook mee bezig
		
		ActiveMission:PowerUpPopup()
		self.FillCoinsThread = nil
		
		if (ActiveMission.PickUpManager.Score > 0) then
			self:FillCoins_Pickup(self.CoinPickupText, ActiveMission.PickUpManager.Score)
		end
	end)
end

function RaceResultScreen:FillCoins_Pickup(MenuElementInc, TotalCoins)
	local PlayedEndingSound = false
	
	local CoinsGained = Round(TotalCoins)
	VirtualCoins:AddCoinCount(CoinsGained)
	VirtualCoins:SendCollectedCoinsStats("InGame", CoinsGained, 0)
	
	self.FillCoins_PickupThread = PhysicsThread:Spawn(function()
		if (not self.Skipped) then
			playsound("Audio\\Bling.wav")
		else
			playsound("Audio\\Score_stars.wav")
			PlayedEndingSound = true
		end
		
		local Length = 120
		local Timer = 0
		local TimerInterfal = 10
		
		local Interfal = ClampMin(TotalCoins / Length, 0)
		
		local Score = 0
		
		for i = 1, Length do
			if (not self.Skipped) then
				PhysicsThread:Wait(1)
			else
				if (not PlayedEndingSound) then
					playsound("Audio\\Score_stars.wav")
				end
			
				break
			end
		
			MenuElementInc:SetText(tostring(Round(i * Interfal)))
			
			if (Timer > TimerInterfal and i * Interfal < TotalCoins) then
				playsound("Audio\\Bling.wav")
				Timer = 0
			else
				Timer = Inc(Timer)
			end
		end
		
		MenuElementInc:SetText(tostring(Round(Length * Interfal)))
		
		self.FillCoins_PickupThread = nil
	end)
end