RaceResultScreenSingle = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	-- gooi menu er op
	self.Menu = PushMenu("RaceResultScreenSingle")

	-- Pak het hoofdpanel en overige panels
	self.Main = self.Menu:GetChild("Main")
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	self.NewTrackRecord = self.Menu:GetChild("NewTrackRecord")
	self.NewTrackRecordText = self.NewTrackRecord:GetChild("NewTrackRecordTime")
	self.OldTrackRecordText = self.NewTrackRecord:GetChild("OldTrackRecordTime")

	self.TrackRecordText = self.NewTrackRecord:GetChild("NewTrackTitleText")
	
	self.RaceTitle = self.Menu:GetChild("TrackNameText")	
	--self.RaceTitle:SetText(Translate(ActiveGameMode.ActiveChapter.ActiveRace.Title))


	self.ResultsItemsParent = self.Menu:GetChild("ResultsItemsParent")
	self.ResultsItems = self.Menu:GetChild("ResultsItems")
	
	-- Fade in items
	self.Main:SetColorImmediate(White)
	
	self.ResultsItemsList = NewItemList(self, nil, nil)
	
	
	local Items = NewItemList(self, LeftButtons, RightButtons)
	self.Items = Items
	
	self.ScoreList = NewItemList(self, nil, nil)
	
	self.BackButtonPanel = self.Menu:GetChild("BackButton")
	self.ProceedButtonPanel = self.Menu:GetChild("ProceedButton")
	self.ScoreListPanel = self.Menu:GetChild("ScoreList")

	self.BackButtonPanel:Clear()
	self.ProceedButtonPanel:Clear()
	self.ScoreListPanel:Clear()
	
	self.ResultsItems:Clear()

	if (FuelEnergy == nil) then
		FuelEnergy = PowerManager()
	end
	
	local HumanPlayer = ActiveMission.HumanPlayer

	if (FuelEnergy.GetTotalRespect) then
		Human_Respect_Multiplier = FuelEnergy:GetTotalRespect()
	end
	
	--local TotalScore = ActiveMission:GetTotalScore(HumanPlayer) * Human_Respect_Multiplier
	--local Human_TotalScore = NumberCommas(TotalScore)
	--local Human_TotalCoins = math.floor((TotalScore) / 1000)	
	
	self.ResultsItemsList:Format(ALIGN_NS, 0, 0, 0, 0, 0.5, 0, 0.5, 0)
	
	self.BackButton = Items:AddItem(self.BackButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonBack.dcMenu", "button_restart"))
	self.BackButton.OnReleased = function()
		CutsceneBars = nil
		self.Menu:SetColor(Invisible)
		
		if (EndRaceCameraThread ~= nil) then
			PhysicsThread:Stop(EndRaceCameraThread)
			
			var('modelerp', 10000)
		end
		
		GameThread:Spawn(function()
			self.FadeScreen = self.Menu:GetChild("FadeScreen")
			self.FadeScreen:SetSize(9999, 9999)
			self.FadeScreen:SetColorFade(1, 2)
			self.FadeScreen:SetColorImmediate(color(0,0,0,0))
			self.FadeScreen:SetColor(Black)
			
			GameThread:Wait(1)
		
			if (ActiveMission ~= nil) then
				ActiveMission:Destroy()
				ActiveMission = nil
			end
			
			ClearMenuStack()
			ActiveMenu = nil
			CutsceneBars = nil
		
			var("IntPause", 0)
			reloadscript()
		end)
	end

	self.Proceed = Items:AddItem(self.ProceedButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonProceed.dcMenu", "button_proceed"))
	self.Proceed.OnReleased = function()
		GameThread:Spawn(function()
		self.Main:SetColorImmediate(Invisible)
		ActiveMenu = RaceResultHighScore()
		
		end)
	end
	
	if( ScreenSize == Resolutions.iphone) then
		self.NameMenuPanel:SetPosData(100, -10, Left, Center, Right, Center, 0, None, false)
		self.NameMenuPanel:SetPosDataTween(-50, -10, Right, Center, Right, Center, 1, None, false, 31, 5,9)
		
		self.Items:Format(ALIGN_NS, -650, 0, -8, 3, nil, nil, nil, nil, 0, #self.Items.Items - 5)
		self.Items:FormatTween(ALIGN_NS, 45, 0, -15, 3, nil, nil, nil, nil, 0, #self.Items.Items - 5)
		
		self.Items:Format(ALIGN_NS, 0, 0, -8, 3, nil, nil, nil, nil, 2, #self.Items.Items - 2)
		self.Items:Format(ALIGN_NS, 30, 0, -8, 3, nil, nil, nil, nil, 2, #self.Items.Items - 2)
		
		self.Items:Format(ALIGN_NS, 310, 0, -9, -2, nil, nil, nil, nil, 6, #self.Items.Items)
		self.Items:FormatTween(ALIGN_NS, 60, 0, -9, -2, nil, nil, nil, nil, 6, #self.Items.Items)
	else	
		local ButtonOffset = 50
		self.ScoreList:Format(ALIGN_NS, 0, 0, ButtonOffset, 5, Left, Top, Right, Top, 0, 3)
		self.ScoreList:Format(ALIGN_NS, 0, 195, 0, 5, Left, Top, Right, Top, 3, #self.ScoreList.Items)
		
		self.ScoreList:FormatTween(ALIGN_NS, 0, 0, ButtonOffset, 5, 0.2, Top, Center, Top, 0, 3)
		self.ScoreList:FormatTween(ALIGN_NS, 150, 195, 0, 5, 0.2, Top, Center, Top, 3, #self.ScoreList.Items)
		
		if (ActiveMission.RaceData.Career == nil or ActiveMission.RaceData.Career == false) then
			local BackButtonOffset = #self.Items.Items - 2
			self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, -ButtonOffset, 0, Right, Bottom, Left, Bottom, BackButtonOffset, #self.Items.Items)
			self.Items:FormatTween(ALIGN_NS, 0, 0, -ButtonOffset, 0, Right, Bottom, Right, Bottom, BackButtonOffset, #self.Items.Items)
		end
		
		local ProceedButtonOffset = #self.Items.Items - 1
		self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, -ButtonOffset, 0, Left, Bottom, Right, Bottom, ProceedButtonOffset, #self.Items.Items)
		self.Items:FormatTween(ALIGN_NS, 0, 0, -ButtonOffset, 0, Right, Bottom, Right, Bottom, ProceedButtonOffset, #self.Items.Items)
	end

	self.Items:SetSelection(self.Proceed)
	
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
end)

function RaceResultScreenSingle:SetNewTrackRecord(Text)
	self.RaceTitle:SetText(Text)
end

function RaceResultScreenSingle:ShowNewTrackRecord(OldRecord, NewRecord)
	self.NewTrackRecord:SetColorImmediate(White)
	
	self.OldTrackRecordText:SetText(OldRecord)
	self.NewTrackRecordText:SetText(NewRecord)
end

function RaceResultScreenSingle:SetTrackText(Text)
	self.TrackRecordText:SetText(Text)
end

function RaceResultScreenSingle:Goto(Target)
	ActiveMenu = Target(RaceResultScreenSingle)

	self.Main:SetColor(Invisible)
end

function RaceResultScreenSingle:Active()
	return ActiveMenu == self
end

function RaceResultScreenSingle:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = RaceResultScreenSingle(PreviousMenu)
end