RedeemMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	AnalyticsSendScreenName("RedeemMenu")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("RedeemMenu", FOREGROUNDSTATE_SIMPLE, function()
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		self.MessageText = self.Main:GetChild("MessageText")
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		self.Items = NewItemList(self, UpButtons, DownButtons)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ButtonTemplate = "Elements\\FreeGoodsButton.dcMenu"

		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		--
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		--[[ self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			--self:Goto(self.PreviousMenu)
			self:Goto(MainMenu)
		end ]]
		
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16 + 32
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Center, 0, Center, 0, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		self.Items:SetSelection(self.FreeGoodsLikeDevButton)
		
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				--self:Goto(self.PreviousMenu)
				self:Goto(MainMenu)
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		--[[ AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.Items:GetSelection() ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end) ]]
		
		--Loading
		self.LoadingPanel = self.Menu:GetChild("LoadingPanel")
		self.LoadingText = self.Menu:GetChild("LoadingText")
		self.LoadingImage = self.Menu:GetChild("LoadingImage")
		
		--Input stuff
		self.EnterNamePanel = self.Menu:GetChild("EnterNamePanel")
		self.HighscoreName = self.Menu:GetChild("HighscoreName")
		self.NameInput = ""
		self.CursorInput = 0
		
		-- Back button
		self:ShowBackButton()
		
		if (not RedeemCodeValid) then
			self:TypeName()
		else
			local ValidText = GetRedeemData("ValidText")
			self:SetLoadingText(ValidText)
			ReadyImage = texture('Check_128.DCT')
			self:ShowLoadingPanel(true)
		end
		
		
		local Enabled = GetRedeemData("Enabled")
		print(Enabled)
		
		local ButtonText = GetRedeemData("ButtonText")
		print(ButtonText)
		
		--print(MessageText)
		
		local RedeemCode = GetRedeemData("RedeemCode")
		print(RedeemCode)
		
		local MessageText = GetRedeemData("MessageText")
		self.MessageText:SetText(MessageText)
	end)
end)

function RedeemMenu:Goto(Target)
	ActiveMenu = Target(nil)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function RedeemMenu:Active()
	return ActiveMenu == self
end

function RedeemMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = RedeemMenu(PreviousMenu)
end

function RedeemMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function RedeemMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function RedeemMenu:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

-- ===================

function RedeemMenu:ShowLoadingPanel(Ready)
	self.LoadingPanel:SetColorFade(1, 4)
	self.LoadingPanel:SetColor(White)
	
	if (self.LoadingThread ~= nil) then
		GameThread:Stop(self.LoadingThread);
		self.LoadingThread = nil
	end
	
	if (Ready) then
		self.LoadingImage:SetImage(ReadyImage)
		self.LoadingImage:SetColorData(color(0.25, 1, 0, 1), 0, None, false)
		self.LoadingImage:SetSize(64, 64)
	else
		self.LoadingImage:SetColorData(color(1, 1, 1, 1), 0, None, false)
		self.LoadingImage:SetSize(32, 32)
		self.LoadingThread = GameThread:Spawn(function(Thread)
			local Counter = 1
			while(true) do
				GameThread:Sleep(0.05)
				
				self.LoadingImage:SetImage(LoadingImages[Counter])
				Counter = Inc(Counter)
				if (Counter == 11) then
					Counter = 1
				end
			end
		end)
	end
end

function RedeemMenu:SetLoadingText(Text)
	self.LoadingText:SetText(Translate(Text))
end

function RedeemMenu:HideLoadingPanel()
	self.LoadingPanel:SetColor(Invisible)
	
	if (self.LoadingThread ~= nil) then
		GameThread:Stop(self.LoadingThread);
		self.LoadingThread = nil
	end
end

-- ===================

function RedeemMenu:AddBackButton()
	self.TypeName_Items = NewItemList(self, nil, nil)
	
	--self.ItemsPanel = self.Menu:GetChild("Items")
	--self.ItemsPanel:Clear()
	
	self.TypeName_BackButton = self.TypeName_Items:AddItem(self.ItemsPanel, MenuElements.Label(self.TypeName_Items, "Elements\\MenuButtonProceed.dcMenu", "button_back"))
	self.TypeName_BackButton.OnReleased = function()
		if (self.ActiveItemList == self.TypeName_Items) then
			--self.TypeName_BackButton.OnReleased = nil
			self:KeyboardHidden()
			self:Goto(MainMenu)
		end
	end
end

function RedeemMenu:ShowBackButton()
	if (self.TypeName_Items == nil) then
		self:AddBackButton()
	end
	
	self.TypeName_Items:SetSelection(self.TypeName_BackButton)
	
	self.TypeName_Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, 0, 1)
	self.TypeName_Items:FormatTween(ALIGN_NS, 0, 0, 0, 0, Right, Top, Right, Top, 0, 1)
	
	self.ActiveItemList = self.TypeName_Items
end

function RedeemMenu:HideBackButton()
	--self.TypeName_BackButton.OnReleased = nil
	self.TypeName_Items:FormatTween(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, 0, 1)
	
	if (self.ActiveItemList == self.TypeName_Items) then
		self.ActiveItemList = nil
	end
end

function RedeemMenu:TypeName(NameSuggestion)
	--if (self.NewHighscore) then
		self.NameInput = ""
		if (NameSuggestion ~= nil) then
			self.NameInput = NameSuggestion
			self.CursorInput = string.len(self.NameInput)
		end
		
		self.HighscoreName:SetText(self.NameInput);

		PhysicsThread:Spawn(function()
			PhysicsThread:Wait(30)

			self.EnterNamePanel:setcolorfade(1, 10.0)
			self.EnterNamePanel:setcolor(White)
		end)

		print('Showing keyboard')
		ShowKeyboard();
		self.KeyboardVisible = true

		-- Kaap de processor
		self.ProcessCharCopy = ProcessChar;

		-- Zet hem op die van ons
		ProcessChar = function(...)
			self:ProcessChar(...);
		end
		
		if (self.CaretThread ~= nil) then
			GameThread:Stop(self.CaretThread);
			self.CaretThread = nil
		end

		self.CaretThread = GameThread:Spawn(function()
			while (true) do
				if (true) then
					local InputLine = self.NameInput;
		
					local InputLine_Head = string.sub(InputLine, 0, self.CursorInput)
					local InputLine_Tail = ""
					if (self.CursorInput < string.len(InputLine)) then
						InputLine_Tail = string.sub(InputLine, self.CursorInput + 1, string.len(InputLine))
					end

					local InputString0 = InputLine_Head .. '_' .. InputLine_Tail
					self.HighscoreName:SetText(InputString0);
				end

				GameThread:Wait(0.5)

				if (true) then
					local InputLine = self.NameInput;
		
					local InputLine_Head = string.sub(InputLine, 0, self.CursorInput)
					local InputLine_Tail = ""
					if (self.CursorInput < string.len(InputLine)) then
						InputLine_Tail = string.sub(InputLine, self.CursorInput + 1, string.len(InputLine))
					end

					local InputString1 = InputLine_Head .. ' ' .. InputLine_Tail
					self.HighscoreName:SetText(InputString1);
				end

				GameThread:Wait(0.5)
			end
		end)
	--end
end

function RedeemMenu:ProcessChar(Character)
	if (self.CaretThread ~= nil) then		--Checken op self.CaretThread, aangezien ProcessChar ook naar activemenu wordt verzonden, dus je krijgt opnieuw calls binnen

		-- Dit is een kopie, dus hier kunnen we niet naartoe schrijven.
		local InputLine = self.NameInput;
		
		local InputLine_Head = string.sub(InputLine, 0, self.CursorInput)
		local InputLine_Tail = ""
		if (self.CursorInput < string.len(InputLine)) then
			InputLine_Tail = string.sub(InputLine, self.CursorInput + 1, string.len(InputLine))
		end

		-- Logica
		if (Character == '\b') then -- Backspace
			self.NameInput = string.sub(InputLine_Head, 0, self.CursorInput - 1) .. InputLine_Tail
			self.CursorInput = ClampMin(Dec(self.CursorInput), 0)
		elseif (Character == '\r') then
			if (self.NameInput ~= nil and self.NameInput ~= "") then
		
				-- We hoeven geen input meer
				if (self.ProcessCharCopy ~= nil) then
					-- Zet de boel terug
					ProcessChar = self.ProcessCharCopy;

					-- Ruim op
					self.ProcessCharCopy = nil;
				end

				-- Onze cursor kan ook stoppen
				if (self.CaretThread ~= nil) then
					GameThread:Stop(self.CaretThread);
					self.CaretThread = nil
				end
				
				print('ProcessChar - submit score')
				self:SubmitName()
			end
		else
			if (string.len(InputLine) < 30) then
				self.CursorInput = Inc(self.CursorInput)
				self.NameInput = InputLine_Head .. Character .. InputLine_Tail
			else
				playsound("Audio\\Pickup.WAV")
			end
		end

		self.HighscoreName:SetText(self.NameInput);
	end
end

function RedeemMenu:SubmitName()
	--self.EnterNamePanel:setcolorfade(1, 10.0)
	--self.EnterNamePanel:setcolor(Invisible)
	
	--self:HideBackButton()
	
	--HideKeyboard();
	--self.KeyboardVisible = false
	
	--self:DoSimpleLogin(self.NameInput)
	self:TestRedeemCode(self.NameInput)
	
	print('SubmitName')
end

function RedeemMenu:KeyboardHidden()
	self.EnterNamePanel:setcolorfade(1, 10.0)
	self.EnterNamePanel:setcolor(Invisible)
	
	self:HideBackButton()

	HideKeyboard();
	self.KeyboardVisible = false
	
	--FBManager:StopAction()
	
	print('Cancel TypeName')
	
	-- We hoeven geen input meer
	if (self.ProcessCharCopy ~= nil) then
		-- Zet de boel terug
		ProcessChar = self.ProcessCharCopy;

		-- Ruim op
		self.ProcessCharCopy = nil;
	end
	
	-- Onze cursor kan ook stoppen
	if (self.CaretThread ~= nil) then
		GameThread:Stop(self.CaretThread);
		self.CaretThread = nil
	end
	
	GameThread:Spawn(function()
		--self:ShowLoginButtons()
	end)
end

function RedeemMenu:TestRedeemCode(CodeInput)
	
	local RedeemCode = GetRedeemData("RedeemCode")
	--print(RedeemCode)
	
	self.EnterNamePanel:setcolorfade(1, 10.0)
	self.EnterNamePanel:setcolor(Invisible)
	HideKeyboard();
	self.KeyboardVisible = false
	
	if (string.upper(RedeemCode) == string.upper(CodeInput)) then
		print("Code okay")
		
		PhysicsThread:Spawn(function()
			self:SetLoadingText("redeemcode_validating")
			self:ShowLoadingPanel()
			
			PhysicsThread:Wait(1 * 60)
			
			if (self:Active()) then
				local ValidText = GetRedeemData("ValidText")
				self:SetLoadingText(ValidText)
				ReadyImage = texture('Check_128.DCT')
				self:ShowLoadingPanel(true)
				
				RedeemCodeValid = true
				WriteGameSettings()
			end
		end)
	else
		print("Code wrong")
		
		PhysicsThread:Spawn(function()
			self:SetLoadingText("redeemcode_validating")
			self:ShowLoadingPanel()
			
			PhysicsThread:Wait(1 * math.random(50, 80))
			
			if (self:Active()) then
				local InvalidText = Translate("redeemcode_invalid")
				self:SetLoadingText(InvalidText)
				ReadyImage = texture('UnCheck_128.DCT')
				self:ShowLoadingPanel(true)
				self.LoadingImage:SetColorData(color(1, 0, 0, 1), 0, None, false)
			end
			
			PhysicsThread:Wait(1 * 60)
			
			if (self:Active()) then
				self:HideLoadingPanel()
				self:TypeName()
			end
		end)
	end
	
end