MenuSpinner = class(function(self, ItemList, Template, Name, Var, VarNames, VarValues)
	self.Item = MenuItem(Template)
	self.Enabled = true
	
	self.Var = Var
	self.VarNames = VarNames
	self.VarValues = VarValues
	
	-- Init
	--self.ValueItem:SetName(translate(Name))

	-- Init
	self.NameItem = self.Item:GetChild("Name")
	self.NameItemFlash = self.Item:GetChild("NameFlash")
	self.NameItem:SetText(translate(Name))
	self.NameItemFlash:SetText(translate(Name))
	self.SliderImage = self.Item:GetChild("SliderImage")

	self.ValueItem = self.Item:GetChild("Value")
	self.ValueItemFlash = self.Item:GetChild("ValueFlash")

	self.Selection_Stars = self.Item:GetChild("Selection_Stars")
	self.Selection_Stars_Flash = self.Item:GetChild("Selection_Stars_Flash")
	
	self.CheckAreaLeftPanel = self.Item:GetChild("CheckArea_Left")
	self.CheckAreaLeftPanelFlash = self.Item:GetChild("CheckArea_LeftFlash")
	self.CheckAreaRightPanel = self.Item:GetChild("CheckArea_Right")
	self.CheckAreaRightPanelFlash = self.Item:GetChild("CheckArea_RightFlash")

	self.CheckAreaLeftPanelFlash:SetColorData(Invisible, 3, Sine, false)
	
	local x, y = self.CheckAreaLeftPanel:GetPos()
	local width, height = self.CheckAreaLeftPanel:GetSize()
	self.LeftAreaP0x = x
	self.LeftAreaP0y = y
	self.LeftAreaP1x = x + width
	self.LeftAreaP1y = y + height
	
	local x, y = self.CheckAreaRightPanel:GetPos()
	local width, height = self.CheckAreaRightPanel:GetSize()
	self.RightAreaP0x = x
	self.RightAreaP0y = y
	self.RightAreaP1x = x + width
	self.RightAreaP1y = y + height

	local VarValue = self:GetValue()
	local ValueIndex = IndexInTable(self.VarValues, VarValue)
	ValueIndex = Mod(ValueIndex, #self.VarValues);
	var(self.Var, self.VarValues[ValueIndex + 1])
	
	self:UpdateSpinner()
	
	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		if (self.Enabled) then
			ItemList:UnsetSelection(self)

			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	end)

	self.CheckAreaLeftPanel:SetClickedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
				self:Left()				
			end
		end
	end)
	
	self.CheckAreaRightPanel:SetClickedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
				self:Right()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuSpinner:DelItem(Index)
	self.Panel:DelItem(self.Item)
end

function MenuSpinner:Left()
	local VarValue = self:GetValue()
	local ValueIndex = IndexInTable(self.VarValues, VarValue)
	ValueIndex = Mod(Dec(ValueIndex), #self.VarValues);
	var(self.Var, self.VarValues[ValueIndex + 1])

	self.CheckAreaLeftPanel:SetPosData(43, 0, Top, Center, Top, Center, 0, None, false)
	self.CheckAreaLeftPanel:SetPosData(55, 0, Top, Center, Top, Center, 3, 1, false)

	--self.CheckAreaLeftPanelFlash:SetColorData(White, 0, None, false)
	--self.CheckAreaLeftPanelFlash:SetColorData(Invisible, 3, Sine, false)

	self.ValueItemFlash:SetColorData(Invisible, 0, None, false)
	self.ValueItemFlash:SetColorData(White, 3, Sine, false)
	
	self:UpdateSpinner()
	--playsound("click.wav")
end

function MenuSpinner:Right()
	local VarValue = self:GetValue()
	local ValueIndex = IndexInTable(self.VarValues, VarValue)
	ValueIndex = Mod(Inc(ValueIndex), #self.VarValues);
	var(self.Var, self.VarValues[ValueIndex + 1])

	self.CheckAreaRightPanel:SetPosData(0, 0, Right, Center, Right, Center, 0, None, false)
	self.CheckAreaRightPanel:SetPosData(-18, 0, Right, Center, Right, Center, 3, 1, false)

	--self.CheckAreaRightPanelFlash:SetColorData(White, 0, None, false)
	--self.CheckAreaRightPanelFlash:SetColorData(Invisible, 3, Sine, false)

	self.ValueItemFlash:SetColorData(Invisible, 0, None, false)
	self.ValueItemFlash:SetColorData(White, 3, Sine, false)	
	
	self:UpdateSpinner()
	--playsound("click.wav")
end

function MenuSpinner:MouseClick(MenuItem, MouseX, MouseY)
	print('^3Mouse Click (MenuSpinner): ^7' .. self.Item:GetIntName())
	
	local MousePosX = MousePos(0):GetX()
	local MousePosY = MousePos(0):GetY()
	self.MouseOffsetX = MousePosX - MouseX
	self.MouseOffsetY = MousePosY - MouseY
	
	self:Right()
	
	--[[ local LeftArea = self:InsideClickLeftArea(MouseX, MouseY)
	local RightArea = self:InsideClickRightArea(MouseX, MouseY)
	
	--if (self:InsideClickArea(MouseX, MouseY) and self.Selected) then
		--if (self.Selected) then
			if (LeftArea) then
				self:Left()
			end
			
			if (RightArea) then
				self:Right()
			end
			
			self:UpdateSpinner()
			
			if (self.Parent:SetSelection(self)) then
				playsound("Clicked.wav")
			end
		--end
	--end ]]--
	
	return false
end

function MenuSpinner:MouseRelease(MenuItem, MouseX, MouseY)
	print('^3Mouse Release (MenuSpinner): ^7' .. self.Item:GetIntName())
	
	return false
end

function MenuSpinner:MouseScroll(MenuItem, MouseZ)
	if (self.Selected) then
		
		if (MouseZ < 0) then
			self:Left()
		elseif (MouseZ > 0) then
			self:Right()
		end
		
		self:UpdateSpinner()
	end
end

function MenuSpinner:MouseActivate()
	print('^3Mouse Activate (MenuSpinner): ^7' .. self.Item:GetIntName())

end

function MenuSpinner:MouseDeactivate()
	print('^3Mouse Deactivate (MenuSpinner): ^7' .. self.Item:GetIntName())
end

function MenuSpinner:Select()
	print('^3Select (MenuSpinner): ^7' .. self.Item:GetIntName())
	self.Selected = true
	
	self.NameItem:SetColorData((color(0, 0, 0, 0.95)), 0.75, FullSine, true)
	
	self.Selection_Stars:SetColorImmediate(White)
	
	self.Selection_Stars_Flash:SetColorImmediate(color(1, 1, 1, 0.8))
	self.Selection_Stars_Flash:SetColorData(Invisible, 2, Sine, false)
end

function MenuSpinner:Deselect()
	print('^3Deselect (MenuSpinner): ^7' .. self.Item:GetIntName())
	self.Selected = false

	self.Selection_Stars:SetColorData(Invisible, 2, Sine, false)
	self.NameItem:SetColorData((color(0, 0, 0, 0.60)), 3, Sine, false)
end

function MenuSpinner:GetValue()
	return getvar(self.Var)
end

function MenuSpinner:GetValueIndex()
	local VarValue = self:GetValue()
	return IndexInTable(self.VarValues, VarValue)
end

function MenuSpinner:UpdateSpinner()
	local VarValue = self:GetValue()
	local ValueIndex = IndexInTable(self.VarValues, VarValue) + 1
	local VarName = self.VarNames[ValueIndex]
	
	self.ValueItem:SetText(Translate(VarName))
	self.ValueItemFlash:SetText(Translate(VarName))
end

function MenuSpinner:InsideClickLeftArea(MouseX, MouseY)
	if (MouseX > self.LeftAreaP0x and MouseX < self.LeftAreaP1x and
		MouseY > self.LeftAreaP0y and MouseY < self.LeftAreaP1y) then
		return true
	end
	
	return false
end

function MenuSpinner:InsideClickRightArea(MouseX, MouseY)
	if (MouseX > self.RightAreaP0x and MouseX < self.RightAreaP1x and
		MouseY > self.RightAreaP0y and MouseY < self.RightAreaP1y) then
		return true
	end
	
	return false
end

function MenuSpinner:Update(ElapsedTime)
	
end