TrackSelect = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenu("TrackSelect")
	
	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")

	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	--
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	self.FlagImage = self.Menu:GetChild("FlagImage")
	
	--Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()
	
	-- Panels leegmaken en lijst aanmaken
	ActiveForeground:HideInfoText()
	self.Items = NewItemList(self, LeftButtons, RightButtons)
	self.ItemsPanel = self.Menu:GetChild("Items")
	self.ItemsPanel:Clear()
	
	-- Add Normal buttons
	self.TotalNormalButtons = 0
	
	--
	
	self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	
	-- Add back button
	self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	self.TotalBackButtons = self.TotalBackButtons + 1
	table.insert(self.MenuDelItem_Queue, self.BackButton)
	self.BackButton.OnReleased = function()
		self.BackButton.OnReleased = nil
		
		if (self.SnapThread ~= nil) then
			GameThread:Stop(self.SnapThread);
			self.SnapThread = nil
		end
		
		if (self.SliderThread ~= nil) then
			GameThread:Stop(self.SliderThread);
			self.SliderThread = nil
		end
	
		self:Goto(GameModeSelect)
	end
	
	
	-- Add proceed button
	self.TotalProceedButtons = 0					-- Hoeveel proceed buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	self.ProceedButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonProceed.dcMenu", "button_proceed"))
	self.TotalProceedButtons = self.TotalProceedButtons + 1
	table.insert(self.MenuDelItem_Queue, self.ProceedButton)
	self.ProceedButton.OnReleased = function()
		local Race = self.Items_Missions:GetSelection().Race
		
		if (Race.Available or DebugUnlockAll) then
		--if (Race.Name == "LO_Chicago") then --Tijdelijk alleen chicago
			if (self.SnapThread ~= nil) then
				GameThread:Stop(self.SnapThread);
				self.SnapThread = nil
			end
			
			if (self.SliderThread ~= nil) then
				GameThread:Stop(self.SliderThread);
				self.SliderThread = nil
			end
			
			ActiveGameMode.ActiveChapter = ActiveGameMode.Chapters[1]
			ActiveGameMode.ActiveChapter.ActiveRace = Race
			
			if (true) then
				self:Goto(Garage)
			else
				GameThread:Spawn(function()
					ActiveMenu = nil
					clearmenustack()
					ActiveGameMode:StartRace(Race.Name, "MonsterTruckCar01", "1")
				end)
			end
		end
	end
	
	
	self.UnlockButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonProceed.dcMenu", "button_unlock"))
	self.TotalProceedButtons = self.TotalProceedButtons + 1
	table.insert(self.MenuDelItem_Queue, self.UnlockButton)
	self.UnlockButton.OnReleased = function()
		local Race = self.Items_Missions:GetSelection().Race
		
		if (Race.Bought and not Race.Available) then				--==== Track is bought but not available (need delivery)
			local HurryUp_GoloPrice = ClampMax(math.ceil(Race.ShopPriceCoins / 1000), 10)
			local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= HurryUp_GoloPrice)
			if not genoegcredits then															--==== Player has not enough Golo Bucks, go buy some golo bucks
				local CreditsNeeded = (HurryUp_GoloPrice - VirtualCoins:GetGoloCoinCount())
				ShowConfirm_NoGolo(CreditsNeeded, TrackSelect)
			else																				--=== Player has enough Golo bucks, go buy the Race
				ShowConfirm_TrackNotAvailable(Race)
			end
		else
			--Buy via GoloCoins?
			if (Race.ShopPriceGoloCoins ~= nil and Race.ShopPriceGoloCoins > 0) then
				local CoinsPrice = Race.ShopPriceGoloCoins
				local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= CoinsPrice)
				if not genoegcredits then
					local CreditsNeeded = (CoinsPrice - VirtualCoins:GetGoloCoinCount())
					ShowConfirm_NoGolo(CreditsNeeded, TrackSelect)
				else
					ShowConfirm_TrackLocked(Race, CoinsPrice, true)
				end
			else
				local CoinsPrice = Race.ShopPriceCoins
				local genoegcredits = (VirtualCoins:GetCoinCount() >= CoinsPrice)
				if not genoegcredits then
					local CreditsNeeded = (CoinsPrice - VirtualCoins:GetCoinCount())
					ShowConfirm_NoGold(CreditsNeeded, TrackSelect)
				else
					ShowConfirm_TrackLocked(Race, CoinsPrice)
				end
			end
		end
	end
	
	
	-- Settings voor formatting
	self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
	local ButtonOffset = 9
	local ButtonSpace = 16
	local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
	local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
	-- Format normal buttons
	self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
	self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
	
	-- Format back button
	self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
	self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
	
	-- Format proceed button
	--self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
	--self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
	
	self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + 1)
	self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + 1)
	
	self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons + 1, self.TotalNormalButtons + self.TotalBackButtons + 2)
	self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons + self.TotalBackButtons + 1, self.TotalNormalButtons + self.TotalBackButtons + 2)
	
	if (self.ProceedButton.Enabled) then
		self.Items:SetSelection(self.ProceedButton)
	elseif (self.UnlockButton.Enabled) then
		self.Items:SetSelection(self.UnlockButton)
	end
	
	
	
	
	
	-- info zetten
	self.InfoTrack = self.Menu:GetChild("InfoTrack")
	self.InfoTrack_LapRecord = self.Menu:GetChild("InfoTrack_LapRecord")
	self.InfoTrack_TrackRecord = self.Menu:GetChild("InfoTrack_TrackRecord")
	
	self.ValueCoin = self.Menu:GetChild("ValueCoin")
	self.GoloCoin = self.Menu:GetChild("GoloCoin")
	self.PriceText = self.Menu:GetChild("PriceText")
	
	self.TrackInfoPanel = self.Menu:GetChild("TrackInfo")
	self.TrackScore = self.Menu:GetChild("TrackScore")

	self.StarScore_Low = self.Menu:GetChild("StarScore_Low")
	self.StarScore_Medium = self.Menu:GetChild("StarScore_Medium")
	self.StarScore_High = self.Menu:GetChild("StarScore_High")

	self.TrackName = self.Menu:GetChild("TrackName")
	self.TrackImage = self.Menu:GetChild("TrackImage")
	self.TrackImageFlag1 = self.Menu:GetChild("TrackImageFlag1")
	self.TrackImageFlag2 = self.Menu:GetChild("TrackImageFlag2")

	-- Panels Aanmaken		
	self.RacesPanel = self.Menu:GetChild("RacesPanel")
	

	self.ChapterRaces = self.Menu:getchild("ChapterItems") -- panel voor chapters
	
	
	
	
	self:AddButtons()
	--self.FakeButton = self.Items:AddItem(self.RacesPanel, MenuElements.FakeButton(self.Items, "Elements\\MenuButtonFake.dcMenu", self.Items_Missions))
	self.FakeButton = MenuElements.FakeButton(self.Items, "Elements\\MenuButtonFake.dcMenu", self.Items_Missions)
	
	
	self.ScrollEnabled = true
	
	
	AddKeyListeners(UpButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			self:PrevTrack()
		else
			DelKeyListeners(Listeners)
		end
	end)

	AddKeyListeners(DownButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			self:NextTrack()
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(BackButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.SnapThread ~= nil) then
				GameThread:Stop(self.SnapThread);
				self.SnapThread = nil
			end
			
			if (self.SliderThread ~= nil) then
				GameThread:Stop(self.SliderThread);
				self.SliderThread = nil
			end
		
			self:Goto(GameModeSelect)
		else
			DelKeyListeners(Listeners)
		end
	end)
			
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= self.BackButton) then
				if (self.ProceedButton ~= nil and self.ProceedButton.OnReleased ~= nil) then
					self.ProceedButton:OnReleased()
				end
			else
				if (self.Items:GetSelection() ~= nil) then
					if (self.Items:GetSelection().OnReleased ~= nil) then
						self.Items:GetSelection():OnReleased()
					end
				end
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	ActiveGameMode:LoadTextures()
	
	self:SetItemlistSize()
end)

function TrackSelect:Goto(Target)
	ActiveMenu = Target(TrackSelect)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function TrackSelect:Active()
	return ActiveMenu == self
end

function TrackSelect:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = TrackSelect(PreviousMenu)
end

function TrackSelect:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	self.FlagImage:SetColorImmediate(Invisible)
	self.FlagImage:SetColorFade(1, 2)
	self.FlagImage:SetColor(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
	
	self:UpdateRaces(true)
end

function TrackSelect:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
	
	if (self.Texture_CountryFlag1 ~= nil) then
		self.Texture_CountryFlag1:Destroy()
		self.Texture_CountryFlag1 = nil
	end
	
	if (self.Texture_CountryFlag2 ~= nil) then
		self.Texture_CountryFlag2:Destroy()
		self.Texture_CountryFlag2 = nil
	end
end

function TrackSelect:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end







function TrackSelect:AddButtons()
	-- Chapters
	self.Items_Missions = NewItemList(self, nil, nil)
	self.Items_Missions.Wrapping = false
	self.Items_Missions.Panel = self.ChapterRaces
	self.Items_Missions.Panel:Clear()
	self.Items_Missions_ButtonSize = 232
	--self.Items_Missions.Active = LapSelectSelection
	
	--ActiveGameMode.ActiveChapter = ActiveGameMode.Chapters[1]
	
	local ChapterItem
	for i, Race in ipairs(ActiveGameMode.ActiveChapter.Races) do
		ChapterItem = self.Items_Missions:AddItem(self.ChapterRaces, MenuElements.Race(self.Items_Missions, "Elements\\MenuRace.dcMenu", Race))
			--self.Items_Missions:SetSelection(self.ChapterItem)
		
		if (Race == ActiveGameMode.ActiveChapter.ActiveRace) then
			self.Items_Missions.Active = i - 1
		end
	end
	
	
	self.ItemOffset = 14
	self.ItemWidth, self.ItemHeight = ChapterItem.Item:GetSize()
	self.Items_Missions_ButtonSize = self.ItemHeight + self.ItemOffset
	--self.Items_Missions.Active = 0
	self.Items_Missions:Format(ALIGN_NS, 0, 0, 0, self.ItemOffset, Center, Center, Center, Center)
	self.Items_Missions:ActivateSelection()
	
	self:SnapActiveItem(true)
	self:UpdateRaces(true)
	
	self.ChapterRaces:SetActivateFunc(function()
		self.Items:SetSelection(self.FakeButton)
		--self.FakeButton.OnActivate()
	end)
	self.ChapterRaces:SetDeactivateFunc(function()
		--self.FakeButton.OnDeactivate()
	end)
	
	self.RacesPanel:SetClickedFunc(function(Item, X, Y)
		if (not self.ScrollEnabled) then
			return false
		end
	
		--local MousePosX = MousePos(0).x
		local MousePosY = MousePos(0).y
		local PanelPosX, PanelPosY = self.ChapterRaces:GetPos()

		self.ChapterRaces:SetPos(PanelPosX, PanelPosY)
		
		if (self.SliderThread ~= nil) then
			GameThread:Stop(self.SliderThread);
			self.SliderThread = nil
		end
		
		self.SliderThread = GameThread:Spawn(function()
			local MouseSpeed = 0
			
			if (self.SnapThread ~= nil) then
				GameThread:Stop(self.SnapThread);
				self.SnapThread = nil
			end
			
			-- Mouse scrolling
			while (MouseKeyPressed(0)) do
				--local DeltaX = MousePos(0).x - MousePosX
				local DeltaY = MousePos(0).y - MousePosY
				--MousePosX = MousePos(0).x
				MousePosY = MousePos(0).y
				--PanelPosX = PanelPosX + DeltaX
				PanelPosY = PanelPosY + DeltaY
				
				--MouseSpeed = DeltaX
				MouseSpeed = DeltaY

				--self.ChapterRaces:SetPosData(PanelPosX, 0, Center, Center, Center, Center, 3.5, 0, false)
				self.ChapterRaces:SetPosData(0, PanelPosY, Center, Center, Center, Center, 3.5, 0, false)

				GameThread:Wait(1 / 120)
			end
			
			if (self.SnapThread ~= nil) then
				GameThread:Stop(self.SnapThread);
				self.SnapThread = nil
			end
			
			--Forward speed
			local Offset = (MouseSpeed * 5)
			--local Offset = 0
			
			--Snapping
			--local Active = math.floor(((-PanelPosX + -Offset) / self.Items_Missions_ButtonSize) + 0.5)
			local Active = math.floor(((-PanelPosY + -Offset) / self.Items_Missions_ButtonSize) + 0.5)
			--print("PanelPosX = " .. PanelPosX)
			--print("Active = " .. Active)

			Active = ClampMinMax(Active, 0, #self.Items_Missions.Items - 1)
			--print(#self.Items_Missions.Items)	
			local Changed = (self.Items_Missions.Active ~= Active)
			
			if (Changed) then
				self.Items_Missions:DeactivateSelection()
				self.Items_Missions.Active = Active
				self.Items_Missions:ActivateSelection()
				self:UpdateRaces()
			end

			local StaticPos = -self.Items_Missions.Active * self.Items_Missions_ButtonSize
			
			
			self.SnapThread = GameThread:Spawn(function()
				for i = 0, 30 do
					MouseSpeed = MouseSpeed * 0.4
					
					--PanelPosX = PanelPosX + MouseSpeed
					PanelPosY = PanelPosY + MouseSpeed

					--local FinalPos = Lerp(PanelPosX, StaticPos, math.sin(i / 60 * math.pi / 2))
					local FinalPos = Lerp(PanelPosY, StaticPos, math.sin(i / 30 * math.pi / 2))

					--self.ChapterRaces:SetPosData(FinalPos, 0, Center, Center, Center, Center, 3.5, 0, false)
					self.ChapterRaces:SetPosData(0, FinalPos, Center, Center, Center, Center, 3.5, 0, false)

					GameThread:Wait(1 / 120)
				end
				self.SnapThread = nil
			end)
			self.SliderThread = nil
		end)
	end)
end

function TrackSelect:SnapActiveItem(Force)
	if (self.SliderThread ~= nil) then
		GameThread:Stop(self.SliderThread)
		self.SliderThread = nil
	end

	local Index = self.Items_Missions.Active
	--local ItemSize = 96
	local Pos = Index * (self.ItemHeight + self.ItemOffset) -- + 100?
	
	if (Force) then
		--self.ChapterRaces:SetPos(-Pos, 0)
		self.ChapterRaces:SetPos(0, -Pos)
	else
		GameThread:Spawn(function()
			if (self.SnapThread ~= nil) then
				GameThread:Stop(self.SnapThread)
				self.SnapThread = nil
			end
			
			self.SnapThread = GameThread:Spawn(function()
				local Index = self.Items_Missions.Active
				local CurPosX, CurPosY = self.ChapterRaces:GetPos()
				local Pos = Index * (self.ItemHeight + self.ItemOffset)
				
				for i = 0, 30 do
					local BlendPos = Lerp(CurPosY, -Pos, math.sin(i / 30 * math.pi / 2))
					self.ChapterRaces:SetPos(0, BlendPos)
					GameThread:Wait(1 / 120)
				end
				self.SnapThread = nil
			end)
		end)
	end
end

function TrackSelect:UpdateRaces(Force)
	if (self.Items_Missions ~= nil) then
		
		if (Force) then
			for i, Item in ipairs(self.Items_Missions.Items) do
				Item:UpdateInfo()
			end
		end
	
		local Race = self.Items_Missions:GetSelection().Race
		if (ActiveGameMode.ActiveChapter.ActiveRace ~= Race or Force) then
			ActiveGameMode.ActiveChapter.ActiveRace = Race
			
			--LapScore
			if Race.LapScores ~= nil then
				local LapScore = "-:--.---"
				if Race.LapScores[#Race.LapScores] ~= nil then
					LapScore = Race.LapScores[#Race.LapScores].VisualScore
				end
			end
			
			--TrackScore
			if (ActiveGameMode.Configuration[2] ~= nil) then
				local LapCount = ActiveGameMode.Configuration[2].Options[ActiveGameMode.Configuration[2].Selection + 1]
				local TrackScore = "-:--.---"
				local TrackScores = Race:GetTrackScores(tostring(LapCount))
				if TrackScores ~= nil then
					if (#TrackScores.Scores > 0 ) then
						local Score = TrackScores.Scores[#TrackScores.Scores]
						if (Score ~= nil) then
							TrackScore = Score.VisualScore
						end
					end
				end
			end
			
			--self.InfoTrack:SetText(Race.Description)
			--self.InfoTrack_LapRecord:SetText(string.format(Translate("lap_record"), LapScore))
			--self.InfoTrack_TrackRecord:SetText(string.format(Translate("track_record"), TrackScore))
			
			if (Race.Available or DebugUnlockAll) then
			--if (Race.Name == "LO_Chicago") then
				--self.ProceedButton:Disable()
				self.ProceedButton.Item:SetColorFade(1, 4)
				self.ProceedButton.Item:SetColor(White)
			else
				--self.ProceedButton:Enable()
				self.ProceedButton.Item:SetColorFade(1, 4)
				self.ProceedButton.Item:SetColor(Invisible)
			end
			
			--TrackImage
			if (Race.Texture ~= nil) then
				self.TrackImage:SetImage(Race.Texture)
			end
			
			--TrackName
			self.TrackName:SetText(translate(ActiveGameMode.ActiveChapter.ActiveRace.Title))
			
			self.ValueCoin:SetColorFade(1, 10)
			self.GoloCoin:SetColorFade(1, 10)
			self.PriceText:SetColorFade(1, 10)
			self.TrackScore:SetColorFade(1, 10)
			
			self.StarScore_Low:SetColorData(color(0, 0, 0, 0.25), 0, None, false)
			self.StarScore_Medium:SetColorData(color(0, 0, 0, 0.25), 0, None, false)
			self.StarScore_High:SetColorData(color(0, 0, 0, 0.25), 0, None, false)
			
			if (Race.Available or DebugUnlockAll) then
				self.ValueCoin:SetColor(Invisible)
				self.GoloCoin:SetColor(Invisible)
				self.PriceText:SetColor(Invisible)
				self.TrackScore:SetColor(White)
				
				--Highscore
				if (ActiveGameMode.ActiveChapter.ActiveRace.HighestScore ~= nil) then
					self.TrackScore:SetText(string.format(Translate("menu_scorerecord"), ActiveGameMode.ActiveChapter.ActiveRace.HighestScore))
					
					local TotalStars = 3
					local MaximumScore = ActiveGameMode.ActiveChapter.ActiveRace.MaximumScore
					local ScoreProgress = ActiveGameMode.ActiveChapter.ActiveRace.HighestScore / (MaximumScore / TotalStars)
					
					if (ScoreProgress > 1) then
						self.StarScore_Low:SetColorData(White, 10, Sine, false)
						if (ScoreProgress > 2) then
							self.StarScore_Medium:SetColorData(White, 10, Sine, false)
							if (ScoreProgress > 3) then
								self.StarScore_High:SetColorData(White, 10, Sine, false)
							end
						end
					end
				else
					self.TrackScore:SetText(0)
				end
				
				self.ProceedButton.Item:SetColorFade(1, 10)
				self.UnlockButton.Item:SetColorFade(1, 4)
				self.ProceedButton.Item:SetColor(White)
				self.UnlockButton.Item:SetColor(Invisible)
				self.ProceedButton:Enable()
				self.UnlockButton:Disable()
				
				if (self.Items:GetSelection() == self.UnlockButton) then
					self.Items:SetSelection(self.ProceedButton)
				end
			else
				--Price
				self.PriceText:SetColor(White)
				self.TrackScore:SetColor(Invisible)
				
				if (Race.Bought) then
					self.ValueCoin:SetColor(Invisible)
					self.GoloCoin:SetColor(White)
					local HurryUp_GoloPrice = ClampMax(math.ceil(Race.ShopPriceCoins / 1000), 10)
					self.PriceText:SetText(string.format(Translate("menu_trackprice"), HurryUp_GoloPrice))
					
					self.UnlockButton:SetText(Translate("button_delivernow"))
				else
					if (Race.ShopPriceGoloCoins ~= nil and Race.ShopPriceGoloCoins > 0) then
						self.ValueCoin:SetColor(Invisible)
						self.GoloCoin:SetColor(White)
						self.PriceText:SetText(string.format(Translate("menu_trackprice"), Race.ShopPriceGoloCoins))
					else
						self.ValueCoin:SetColor(White)
						self.GoloCoin:SetColor(Invisible)
						self.PriceText:SetText(string.format(Translate("menu_trackprice"), Race.ShopPriceCoins))
					end
					
					self.UnlockButton:SetText(Translate("button_unlock"))
				end
				
				self.ProceedButton.Item:SetColorFade(1, 4)
				self.UnlockButton.Item:SetColorFade(1, 10)
				self.ProceedButton.Item:SetColor(Invisible)
				self.UnlockButton.Item:SetColor(White)
				self.ProceedButton:Disable()
				self.UnlockButton:Enable()
				
				if (self.Items:GetSelection() == self.ProceedButton) then
					self.Items:SetSelection(self.UnlockButton)
				end
			end
			
			
			
			--Set CountryFlag
			if (GetFS():Exists("Menu\\Images\\Races\\Flag_" .. Race.Country .. ".DCT")) then
				self.PrevCountryFlag = self.CurCountryFlag
				self.CurCountryFlag = Race.Country
				
				if (self.PrevCountryFlag ~= self.CurCountryFlag) then
					if (self.Texture_CountryFlag1 ~= nil) then
						self.Texture_CountryFlag1:Destroy()
						self.Texture_CountryFlag1 = nil
					end
					
					self.Texture_CountryFlag1 = self.Texture_CountryFlag2
					self.Texture_CountryFlag2 = texture("Menu\\Images\\Races\\Flag_" .. Race.Country .. ".DCT")
					
					if (self.Texture_CountryFlag1 ~= nil) then
						self.TrackImageFlag1:SetImage(self.Texture_CountryFlag1)
						self.TrackImageFlag1:SetColorImmediate(color(1,1,1,0.5))
					end
					
					self.TrackImageFlag1:SetColorFade(1, 4)
					self.TrackImageFlag1:SetColor(color(1,1,1,0))
					
					self.TrackImageFlag2:SetImage(self.Texture_CountryFlag2)
					self.TrackImageFlag2:SetColorImmediate(color(1,1,1,0))
					self.TrackImageFlag2:SetColorFade(1, 4)
					self.TrackImageFlag2:SetColor(color(1,1,1,0.5))
				end
			end
		end
		
		self:SetItemlistSize()
	end
end

--Shop stuff
function TrackSelect:UpdateCoincount()
	if (ActiveForeground ~= nil and ActiveForeground.UpdateCoincount ~= nil) then
		ActiveForeground:UpdateCoincount()
	end
end

function TrackSelect:PrevTrack()
	self.FakeButton:Left()
	self:SnapActiveItem()
	self:UpdateRaces()
end

function TrackSelect:NextTrack()
	self.FakeButton:Right()
	self:SnapActiveItem()
	self:UpdateRaces()
end


-- ==========================================
-- Custom functions below here
-- ==========================================

function TrackSelect:SetItemlistSize()
	local TitleBarHeight = ActiveForeground:GetTitlebarHeight()
	local ContentHeight = ActiveForeground:GetContentHeight()

	self.RacesPanel:SetSize(256, ContentHeight) -- passend maken
	self.RacesPanel:SetPos(0, TitleBarHeight) -- op juiste plek zetten
	
	--FlagSize
	local FlagWidth, FlagHeight = self.FlagImage:GetSize()
	local Ratio = FlagWidth / FlagHeight
	self.FlagImage:SetSize(FlagWidth * Ratio, ContentHeight)
	
	local PanelWidth = SafeFrameWidth - self.RacesPanel:GetWidth()
	local NewPosX = (PanelWidth / 2)
	self.TrackInfoPanel:SetPos(NewPosX, 0)
end