UnlockMenuSelection = 0

UnlockMenu = class(function(self, NextMenu, UnlockedObject)
	-- gooi menu er op
	self.Menu = pushmenu("UnlockMenu")
	
	-- Pak het hoofdpanel en overige panels
	self.Main = self.Menu:GetChild("Main")
	self.Background = self.Menu:GetChild("Background")
	self.Banner = self.Menu:GetChild("Banner")
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	self.NextMenu = NextMenu
	self.UnlockedObject = UnlockedObject
	
	
	self.UnlockText = self.Menu:GetChild("UnlockText")
	self.ItemsPanel = self.Menu:GetChild("Items")
	self.StartText = self.Menu:GetChild("StartText")
	--self.ItemsPanel:Clear()
	
	
	
	self.Items = NewItemList(self, nil, nil)
	self.Items.Panel = self.ItemsPanel
	self.Items.Panel:Clear()
	
	if(self.UnlockedObject:is_a(Mission)) then
		local Race = self.UnlockedObject
		local Text = string.format(Translate('RACE_UNLOCKED'), Translate(Race.Title))
		self.UnlockText:SetText(Text)
		
		Race:LoadTexture()
		self.RaceItem = self.Items:AddItem(self.ItemsPanel, MenuElements.Race(self.Items, "Elements\\MenuRace.dcMenu", Race))
		self.RaceItem:Activate()
	elseif(self.UnlockedObject:is_a(Car)) then
		local Car = self.UnlockedObject
		local Text = string.format(Translate('CAR_UNLOCKED'), Translate(Car.Title))
		self.UnlockText:SetText(Text)
		
		--self.CarItem = self.Items:AddItem(self.ItemsPanel, MenuElements.Car(self.Items, "Elements\\MenuCar.dcMenu", Car))
	elseif(self.UnlockedObject:is_a(CarClass)) then
		--
		print('CarClass unlock menu nog niet gemaakt')
	end
	
	--print(self.UnlockedObject)
	--ListMembers(self.UnlockedObject)
	
	self.Main:SetClickedFunc(function(Item, X, Y)
		self:ShowNextMenu()
	end)
	
	AddKeyListeners(ProceedButtons, "Down", function(Listeners)
		if (self:Active()) then
			self:ShowNextMenu()
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	self:ShowMenu()
end)

function UnlockMenu:Refresh()
	ActiveMenu = UnlockMenu(self.NextMenu, self.UnlockedObject)
	print("function refresh")
end

function UnlockMenu:Active()
	return ActiveMenu == self
end

function UnlockMenu:ShowMenu()
	self.Main:setcolor(White)
	
	self.ItemsPanel:SetColorFade(1 , 4)
	self.UnlockText:SetColorFade(1 , 4)
	
	self.ItemsPanel:SetColor(White)
	self.UnlockText:SetColor(White)
end

function UnlockMenu:HideMenu()
	--self.Main:SetColor(Invisible)
	
	self.ItemsPanel:SetColor(Invisible)
	self.UnlockText:SetColor(Invisible)
end

function UnlockMenu:ShowNextMenu()
	if (#UnlockPopups ~= 0) then
		local Popup = UnlockPopups[1]
		table.remove(UnlockPopups, 1)
		
		GameThread:Spawn(function()
			self:HideMenu()
			GameThread:Wait(0.5)
			
			ActiveMenu = Popup[1](self.NextMenu, Popup[2])
			ActiveMenu:ShowMenu()
		end)
	else
		print('unlock menu weg!')
		ActiveMenu = self.NextMenu()
		self.StartText:SetColorFade(1 , 4)
		self.StartText:SetColor(Invisible)
		self.Banner:SetColorFade(1, 4)
		self.Banner:SetColor(Invisible)
		self:HideMenu()
		UnloadTextures() --???
	end
end