-- TODO: windows 

-- Selection
videomodes = {}
getvideomodes()--{"1920x1080", "1024x576" }

VideoModeNames = deepcopy(videomodes)

if (Windowed) then
	table.insert(videomodes, "Window")
	table.insert(VideoModeNames, "value_Window")

else
	table.insert(videomodes, "Desktop")
	table.insert(VideoModeNames, "value_Desktop")
end

BloomScale = {"value_none", "value_low", "value_medium", "value_high" }
BloomScaleValues = {"0", "0.33", "0.66", "1" }

Presets = {"value_userdefined", "value_verylow", "value_low", "value_medium", "value_high", "value_veryhigh", "value_ultra" }
PresetValues = {"userdefined", "verylow", "low", "medium", "high", "veryhigh", "ultra" }

PixelScale = {"value_Quarter", "value_Half", "value_ThreeQuarter",  "value_Full" }
PixelScaleValues = {"0.25", "0.5", "0.75", "1" }

AlphaScale = {"value_Quarter", "value_Half", "value_ThreeQuarter",  "value_Full" }
AlphaScaleValues = {"0.25", "0.5", "0.75", "1" }

OnOff = {"value_Off", "value_On" }
OnOffValues = {"0", "1"}

ShadowResolution = {"value_Quarter", "value_Half", "value_Full" }
ShadowResolutionValues = {"512", "1024", "2048" }

LowHigh = {"value_Low", "value_High" }
LowHighValues = {"0", "1"}

FoliageRange = {"value_Off", "value_VeryNear", "value_Near", "value_Normal", "value_Far", "value_VeryFar"}
FoliageRangeValues = {"0", "500", "1000", "1500", "2000", "2500"}

TargetFramerate = { "value_Off", "value_15fps", "value_30fps" }
TargetFramerateValues = {"0.1", "0.06666666666666666666666666666667", "0.03333333333333333333333333333333" }

VideoOptions = class(function(self)
	-- gooi menu er op
	self.Menu = pushmenu("VideoOptions")
	
	self.Main = self.Menu:getchild("Main")

	-- safe frame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	self.Safeframe_Bottom = self.Menu:GetChild("Safeframe_Bottom")
	self.Safeframe_Bottom:SetWidth(SafeFrameWidth)
	self.BalkOnder = self.Menu:GetChild("BalkOnder") -- doen we nu nog niks mee
	
	-- Fade in items
	self.Main:SetColorImmediate(White)
	
	var("InternalVideoMode", getvar("VideoMode"))
	
	self.pc = "Elements\\MenuButton.dcMenu"
	self.template = self.pc
	
	local Items = NewItemList(self, UpButtons, DownButtons)
	self.Items = Items
	
	self.ItemsPanel = self.Menu:GetChild("Items")
	self.NameMenuPanel = self.Menu:GetChild("NameMenu")
	self.NameMenuFlashPanel = self.Menu:GetChild("NameMenuFlash")
	self.TitleBarBackGround = self.Menu:GetChild("TitleBarBackGround")
	self.TitleBar = self.Menu:GetChild("TitleBar")
	self.BottomBarItems = self.Menu:GetChild("BottomBarItems") -- deze vervangt de onderstaande 3 losse knopen

	self.ItemsPanel:Clear()
	self.NameMenuPanel:Clear()
	self.BottomBarItems:Clear()
	
	-- Options toevoegen:
	
	self.Videomodes = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_videomodes", VideoModeNames, videomodes, "InternalVideoMode"))
	self.VideoPreset = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_presets", Presets, PresetValues, "VideoPreset"))
	self.PixelScaleself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_pixelscale", PixelScale, PixelScaleValues, "PixelScale"))
	self.AlphaScaleself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_alphascale", AlphaScale, AlphaScaleValues, "AlphaScale"))
	self.DynamicShadowsself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_dynamicshadows_onoff", OnOff, OnOffValues, "DynamicShadows"))
	self.ShadowSizeself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_shadowsize", ShadowResolution, ShadowResolutionValues, "ShadowSize"))
	self.ShadowQualityself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_shadowquality", LowHigh, LowHighValues, "ShadowQuality"))
	--self.Items:Add Item(MenuTextItem_Var(Panel, "Elements\\VideoOption_Template.dcMenu", "menu_reflection_onoff", OnOff, OnOffValues, "ReflectionQuality"))
	self.FoliageQualityself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_foliagequality", LowHigh, LowHighValues, "FoliageQuality"))
	self.FoliageRangeself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_foliagerange", FoliageRange, FoliageRangeValues, "FoliageRange"))
	self.MotionBlurself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_motionblur_onoff", OnOff, OnOffValues, "Motionblur"))
	self.BloomScaleself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_bloomscale", BloomScale, BloomScaleValues, "BloomScale"))
	self.TargetFramerateself = Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButton.dcMenu", "menu_targetframerate", TargetFramerate, TargetFramerateValues, "TargetFramerate"))

	self.ResetToDefault = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(Items, "Elements\\MenuButtonBack.dcMenu", "menu_ResetToDefault"))
	
	-- back button
	
	self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	self.BackButton.OnReleased = function()
		self:Goto(OptionsMenu)
	end

	self.NameMenuPanel:SetPosData(100, -10, Left, Center, Right, Center, 0, None, false)
	self.NameMenuPanel:SetPosDataTween(-50, -10, Right, Center, Right, Center, 1, None, false, 31, 5,9)

	self.Items:Format(ALIGN_NS, -600, 0, 0, -18, Left, Top, Left, Top, 0, #self.Items.Items - 1)
	self.Items:FormatTween(ALIGN_NS, 100, 0, 0, -10, nil, nil, nil, nil, 0, #self.Items.Items - 1)

	self.Items:Format(ALIGN_NS, 300, 0, 0, -18, Left, Top, Left, Top, 13, #self.Items.Items)
	self.Items:FormatTween(ALIGN_NS, 25, 0, 0, -10, nil, nil, nil, nil, 13, #self.Items.Items)
	
	self:AlignTopBar() -- top bar moet "buiten" de safeframe staan..
end)

function VideoOptions:AlignTopBar()
	self.TitleBarBackGround:SetPosData(-SafeFrameOffsetX, 0, left, 0, left, 0, None, false)
end

function VideoOptions:Goto(Target)
	ActiveMenu = Target(VideoOptions)

	self.Main:SetColor(Invisible)

	--ScrapClose()
end

function VideoOptions:Update(ElapsedTime)
	local InternalVideoMode = getvar("InternalVideoMode")
	local VideoMode = getvar("VideoMode")
	
	if (InternalVideoMode ~= VideoMode) then
		if (self.VideoModeTimer == nil or InternalVideoMode ~= self.CachedVideoMode) then
			self.VideoModeTimer = 5
			self.CachedVideoMode = InternalVideoMode
		end
		
		self.VideoModeTimer = self.VideoModeTimer - ElapsedTime
		
		if (self.VideoModeTimer < 0) then
			self.VideoModeTimer = nil
			var("VideoMode", InternalVideoMode)
		end
	else
		self.VideoModeTimer = nil
	end
end

function VideoOptions:Up()
	if (self.NoPerformanceIndex) then
		return;
	end

	self.Items:Prev()

	--playsound("menuclick.wav")
end

function VideoOptions:Down()
	if (self.NoPerformanceIndex) then
		return;
	end
	self.Items:Next()
	
	--playsound("menuclick.wav")
end

function VideoOptions:Left()
	if (self.NoPerformanceIndex) then
		return;
	end
	
	local Selected = self.Items.Active
	self.Items:GetSelectedItem():Left()
	
	if self.Items:GetSelectedItem().CurrentValue == "userdefined" then
		self.Items:GetSelectedItem():Left()
	end
	
	if (Selected == 1) then
		SetVideoOptions();
		
		self:RefreshPanel()
	elseif (Selected < 9) then
		var("VideoPreset", "userdefined")
		self:RefreshPanel()
	end
	
	self.Items.Active = Selected
	self.Items:Format(10, 0, 0, 25)
	
	playsound("Clicked.wav")
end

function VideoOptions:Right()
	if (self.NoPerformanceIndex) then
		return;
	end
	
	local Selected = self.Items.Active
	self.Items:GetSelectedItem():Right()
	
	if self.Items:GetSelectedItem().CurrentValue == "userdefined" then
		self.Items:GetSelectedItem():Right()
	end
	
	if (Selected == 1) then
		SetVideoOptions();
		
		self:RefreshPanel()
	elseif (Selected < 9) then
		var("VideoPreset", "userdefined")
		self:RefreshPanel()
	end
	
	self.Items.Active = Selected
	self.Items:Format(10, 0, 0, 25)
	
	playsound("Clicked.wav")
end

function VideoOptions:Back()
	if (self.NoPerformanceIndex) then
		self.NoPerformanceIndex = false
		
		local NoPerformanceIndex = self.Menu:getchild("NoPerformanceIndex")
		NoPerformanceIndex:SetColorFade(1, 10)
		NoPerformanceIndex:SetColor(Invisible)
		
		return
	end
	
	if (self.VideoModeTimer ~= nil) then
		self.VideoModeTimer = nil
		
		local InternalVideoMode = getvar("InternalVideoMode")
		var("VideoMode", InternalVideoMode)
	end
	
	configsave()

	-- Fade uit
	self.Main:setcolor(Invisible)
	
	ActiveMenu = OptionsMenu()
	
	playsound("Clicked.wav")
end

function VideoOptions:Proceed()
	if (self.NoPerformanceIndex) then
		self.NoPerformanceIndex = false
		
		local NoPerformanceIndex = self.Menu:getchild("NoPerformanceIndex")
		NoPerformanceIndex:SetColorFade(1, 10)
		NoPerformanceIndex:SetColor(Invisible)
		
		return
	end
	
	playsound("Clicked.wav")
	
	
	if (self.Items.Active == 12) then
		DefaultVideoOptions()
		
		self:RefreshPanel()
		
		self.Items.Active = 12
		self.Items:Format(10, 0, 0, 25)
		
		return
	end
	
	if (self.VideoModeTimer ~= nil) then
		self.VideoModeTimer = nil
		
		local InternalVideoMode = getvar("InternalVideoMode")
		var("VideoMode", InternalVideoMode)
	end
	
	configsave()
	
	-- Fade uit
	self.Main:setcolor(Invisible)
	
	ActiveMenu = OptionsMenu()
end

function VideoOptions:Refresh()
	ActiveMenu = VideoOptions()
end

function VideoOptions:Active()
	return ActiveMenu == self
end