--------------------------------
-- Base functions

function LoadGlobalTextures()
	LoadCharacterTextures()
	
	if (CarClasses ~= nil) then
		for i = 1, #CarClasses do
			local CarClass = CarClasses[i]
			if (CarClass ~= nil) then
				CarClass:LoadTextures()
			end
		end
	end
end

--Eigenlijk niet nodig
function UnloadGlobalTextures()
	UnloadCharacterTextures()
	
	if (CarClasses ~= nil) then
		for i = 1, #CarClasses do
			local CarClass = CarClasses[i]
			if (CarClass ~= nil) then
				CarClass:UnloadTextures()
			end
		end
	end
end

function LoadGameTextures()
	
end

function UnloadGameTextures()
	
end

function LoadMenuTextures()
	DelTexDir("Textures\\NonMenuTextures")
	AddTexDir("Textures\\MenuTextures")
	
	CoinTexture = texture("Menu\\Images\\MJCoin.DCT")
	FlatCoinTexture = texture("Menu\\Images\\flat_coin.DCT")
	DeveloperTexture = texture("Intro_T6.dct")

	if (GameModes ~= nil) then
		for i = 1, #GameModes do
			local GameMode = GameModes[i]
			if (GameMode ~= nil) then
				GameMode:LoadTextures()
			end
		end
	end
	
	if (PowerUpItems ~= nil) then
		for i = 1, #PowerUpItems do
			local PowerUpItem = PowerUpItems[i]
			if (PowerUpItem ~= nil) then
				PowerUpItem:LoadTextures()
			end
		end
	end
end

function UnloadMenuTextures()
	AddTexDir("Textures\\NonMenuTextures")
	DelTexDir("Textures\\MenuTextures")
	
	CoinTexture = nil
	FlatCoinTexture = nil
	DeveloperTexture = nil
	StrapATexture = nil
	StrapBTexture = nil

	if (GameModes ~= nil) then
		for i = 1, #GameModes do
			local GameMode = GameModes[i]
			if (GameMode ~= nil) then
				GameMode:UnloadTextures()
			end
		end
	end
	
	if (PowerUpItems ~= nil) then
		for i = 1, #PowerUpItems do
			local PowerUpItem = PowerUpItems[i]
			if (PowerUpItem ~= nil) then
				PowerUpItem:UnloadTextures()
			end
		end
	end
end

--------------------------------

function LoadTextures()
	--[[ LoadCharacterTextures()

	if (CarClasses ~= nil) then
		for i = 1, #CarClasses do
			local CarClass = CarClasses[i]
			if (CarClass ~= nil) then
				CarClass:LoadTextures()
			end
		end
	end ]]
	
	--[[ if (GameModes ~= nil) then
		for i = 1, #GameModes do
			local GameMode = GameModes[i]
			if (GameMode ~= nil) then
				GameMode:LoadTextures()
			end
		end
	end ]]
end

function LoadCharacterTextures()
	CharacterTextures = {}
	
	CharacterTextures["Grace"] = texture("Menu\\Images\\Characters\\Character_Grace.DCT")
	CharacterTextures["Johnny"] = texture("Menu\\Images\\Characters\\Character_Johnny.DCT")
	CharacterTextures["Pete"] = texture("Menu\\Images\\Characters\\Character_Pete.DCT")
end

function UnloadTextures()
	--[[ UnloadCharacterTextures()

	if (CarClasses ~= nil) then
		for i = 1, #CarClasses do
			local CarClass = CarClasses[i]
			if (CarClass ~= nil) then
				CarClass:UnloadTextures()
			end
		end
	end ]]

	--[[ if (GameModes ~= nil) then
		for i = 1, #GameModes do
			local GameMode = GameModes[i]
			if (GameMode ~= nil) then
				GameMode:UnloadTextures()
			end
		end
	end ]]
end

function UnloadCharacterTextures()
	CharacterTextures = {}
end