DestroyerMission = class(BaseMission, function(self, RaceData)
	print("^3DestroyerMission created")
	
	LoadCharacterTextures()
	
	-- Mission Related Variables
	self.MaxLapCount = self.RaceData.LapCount
	self.CurrentLap = 1
	self.Finished = false
	
	-- Time in seconds
	self.RaceTimerStart = 60
	
	self.ReceivedBonusTime = false
	self.BonusTime = 30
	
	self.Finished = false
	
	self.WorldObjectManager = DestroyableObjectsManager()
	
	-- Create player car
	local Player = self:CreateHumanPlayer(self.RaceData.Car, self.RaceData.Skin, "Player 1")
	
	self:SetCarsVolume(0)
	
	PhysicsThread:Spawn(function()
		Player.HUD = nil
		CutsceneBars = nil
		
		local ImmediateStart = false
		
		if (ImmediateStart) then
			self:Start()
		else
			-- Show the Cutscene
			CutsceneBars = HUD_CutsceneBars()
		end
		
		Player.Car:EnableInput()
		Player.Car:Enable()
		
		Player.Car:Brake(1)
		Player.Car:Handbrake(1)
		
		Test_BindForceKeys()
	end)
	
	-- Rear-wheel drive / four-wheel drive toggle
	local Buttons = {"DCK_TAB"}
	AddKeyListeners(Buttons, "Down", function(Listeners)
		local Car = ActiveMission.HumanPlayers[1].Car
		local Type = Car:GetTypeObject()
		Type:SetWheelAccelForce(0,0)
		Type:SetWheelAccelForce(1,0)
	end)
	AddKeyListeners(Buttons, "Up", function(Listeners)
		local Car = ActiveMission.HumanPlayers[1].Car
		local Type = Car:GetTypeObject()
		Type:SetWheelAccelForce(0,4)
		Type:SetWheelAccelForce(1,4)
	end)
	
	self:PostConstruction()
	
	self.StuntManager:Disable()
end)

function DestroyerMission:StartTutorial()
	--[[ local function TutorialEnd()
		PhysicsThread:Spawn(function()
			PhysicsThread:Wait(60 * 1)
			self:StartCountdown()
		end)
	end
	self.HumanPlayers[1].HUD.AccelerateSlider:ShowTutorial(TutorialEnd) ]]
end

function DestroyerMission:CreateCarBuilder(Car, Skin)
	return LuaCarBuilder(Car, Skin, "PC_Race.XML")
end

function DestroyerMission:Start()
	self.Super.Start(self)

	-- Creeer de drivers
	for i, Player in ipairs(self.Players) do
		if (Player.Human) then
			print("Maak een human")
			Player.Driver = HumanDriver(Player.Car, 0)
			Player.InputManager = InputManager(Player, self)
			SetCamIndex(0)
		end

		if (Player.Driver ~= nil) then
			GetEntityScene():AddEntity(Player.Driver)
			Player.Driver:Init()
		end

		Player.Car:EnableInput()
		Player.Car:Enable()
		
		-- Activate the scoring display
		if (Player.HUD ~= nil) then
			Player.HUD:ActivateScore()
			Player.HUD:UpdateScore(Player)
		end
	end
	
	self:SetCarsVolume(1)

	TriggerTarget("SkipIntro")
	
	-- Zet de HUD aan
	for i, Player in ipairs(self.Players) do
		if (Player.HUD ~= nil) then
			Player.HUD:ShowLapCount()
			Player.HUD:SetLapCount(1, self.RaceData.LapCount)
			
			local Race = ActiveGameMode.ActiveChapter.ActiveRace
			local LapRecordTime = Translate('hud_nolaprecord')
			if Race.LapScores[#Race.LapScores] ~= nil then
				LapRecordTime = Race.LapScores[#Race.LapScores].VisualScore
			end
			Player.HUD:SetLapRecord(LapRecordTime)
		
			Player.HUD:ShowRank()
		end
	end

	--[[ if (ActiveGameMode.TutorialEnabled) then
		ActiveGameMode.TutorialEnabled = false
		WriteGameSettings()
		self:StartTutorial()
	else ]]
		self:StartCountdown()
	-- end
end

function DestroyerMission:StartCountdown()
	PhysicsThread:Run(function()
		for i = 3, 1, -1 do
			self:Countdown(i)
			PhysicsThread:Wait(60)
		end 

		-- De GO!
		self:Countdown(0)
		
		self.Finished = false

		for i, Player in ipairs(self.Players) do
			Player.Car:EnableInput()
			Player.Car:Enable()
			
			if (Player.HUD ~= nil) then
				Player.HUD:EnablePowerUps()
			end

			if (Player.Driver ~= nil) then
				if (not Player.Human) then
					Player.Driver:Enable()
				elseif (Player.InputManager ~= nil) then
					Player.InputManager:Enable()
				end
			end
		end
	end)
end

function DestroyerMission:Lap(Player)
	--
end

function DestroyerMission:NextCheckpoint(Car, Checkpoint)
	-- Geen visuele checkpoints in deze mission
end

function DestroyerMission:SetScore()
	self.Score = self.WorldObjectManager:GetTotalScore()
	
	self.Super.SendScore(self, self.Score)
	self.Super.SendStats(self, self.Score)
end

function DestroyerMission:EndGame(HumanWon, Winner)
	self.Finished = true

	self.Super.EndGame(self)
	
	local Player = self.HumanPlayers[1]
	Player.InputManager:Disable()
	--Player.TotalScore = self.WorldObjectManager:GetTotalScore()
	--self.Score = self.WorldObjectManager:GetTotalScore()
	
	if (Player.HUD ~= nil) then
		Player.HUD:Hide()
		Player.HUD = nil
	end
	
	CutsceneBars = HUD_CutsceneFinished()
	self.SliderEnabled = false
		
	local Text = "--"
	local SubText = "--"
	
	if (HumanWon ~= nil and Winner ~= nil) then
		if (HumanWon) then
			Text = Winner.Name .. " has won the race!"
			SubText = "Great job!"
		else
			Text = Winner.Name .. " has won the race."
			SubText = "You can do better than this!"
		end
	end
	
	--print("^3" .. Text)
	--print("^3" .. SubText)

	CutsceneBars:SetTitle(Text)
	CutsceneBars:SetSubTitle(SubText)
end

function DestroyerMission:UpdatePhysics(ElapsedTime)	
	--self.StuntManager:Update(ElapsedTime)

	if (self.RaceTimer ~= nil) then
		self.RaceTimer = self.RaceTimer - ElapsedTime
		if(self.RaceTimer <= 0)then
			self:EndGame(self.Players[1].Human, self.Players[1])
		end
	end
	
	for i, Player in ipairs(self.Players) do
		if (Player.InputManager ~= nil) then
			Player.InputManager:Update(ElapsedTime)
		end	
		
		if (Player.HUD ~= nil) then
			Player.HUD:UpdatePhysics(ElapsedTime)
		
			if (self.RaceTimer ~= nil) then
				--Player.HUD:SetScore(self.RaceTimer, 0, true)
			else
				--Player.HUD:SetScore(self.RaceTimerStart, 0, true)
			end
			
			if (self.WorldObjectManager ~= nil) then
				self.Score = self.WorldObjectManager:GetTotalScore()
				Player.HUD:SetScore(self.Score)
			end
		end
	end
end

function DestroyerMission:Update(ElapsedTime)
	self.Super.Update(self, ElapsedTime)
	
	--self.StuntManager:UpdateScoreMessages(ElapsedTime)
	--self.StuntManager:ChangeCamera()
	
	if (self.PickUpManager ~= nil) then
		self.PickUpManager:Update(ElapsedTime)
	end
	
	if (self.RaceTimer ~= nil and self.RaceTimer < 0 and not self.ReceivedBonusTime) then
		self.RaceTimer = self.RaceTimer + self.BonusTime
		self.ReceivedBonusTime = true
		
		local Player = self.HumanPlayers[1]
		--Player.HUD:DisplayBonusTime()
	elseif (self.RaceTimer ~= nil and self.RaceTimer < 0 and not self.Finished) then
		self.Finished = true
		
		self:EndGame()
	end
end