FreestyleFestMission = class(BaseMission, function(self, RaceData)
	print("^3FreestyleFestMission created")

	LoadCharacterTextures()
	
	-- Mission Related Variables
	self.MaxLapCount = self.RaceData.LapCount
	self.CurrentLap = 1
	self.Finished = false
	
	-- Time in seconds
	self.TotalLapTime = 9999999999
	self.LapTime = self.TotalLapTime
	
	self.RaceTimerStart = 90
	
	self.ReceivedBonusTime = false
	self.BonusTime = 30
	
	self.Finished = false
	
	var("ExtraFrontGeometry", 1)
	
	-- Stel hier in wat de Maximale totale score is die je kan behalen
	self.MaxTotalScore = 1050000
	
	-- Create player car
	local Player = self:CreateHumanPlayer(self.RaceData.Car, self.RaceData.Skin, "Player 1")
	
	self:SetCarsVolume(0)
	
	self:PlayMusic("Music\\RACE_INTRO.ogg")
	
	PhysicsThread:Spawn(function()
		Player.HUD = nil
		CutsceneBars = nil
		
		FinishStart()
		
		local ImmediateStart = false
		
		if (ImmediateStart) then
			self:Start()
		else
			-- Show the Cutscene
			CutsceneBars = HUD_CutsceneBars()
		end
		
		Player.Car:EnableInput()
		Player.Car:Enable()
		
		Player.Car:Brake(1)
		Player.Car:Handbrake(1)
		
		Test_BindForceKeys()
	end)
	
	-- Rear-wheel drive / four-wheel drive toggle
	local Buttons = {"DCK_TAB"}
	AddKeyListeners(Buttons, "Down", function(Listeners)
		local Car = ActiveMission.HumanPlayers[1].Car
		local Type = Car:GetTypeObject()
		Type:SetWheelAccelForce(0,0)
		Type:SetWheelAccelForce(1,0)
	end)
	AddKeyListeners(Buttons, "Up", function(Listeners)
		local Car = ActiveMission.HumanPlayers[1].Car
		local Type = Car:GetTypeObject()
		Type:SetWheelAccelForce(0,4)
		Type:SetWheelAccelForce(1,4)
	end)
	
	AddKeyListeners("DCK_SCREENBUTTON_5", "Down", function(Listener)
		GameThread:Spawn(function()
			local Player = ActiveMission.HumanPlayers[1]
			if (Player ~= nil and Player.HUD ~= nil) then
				if (not ActiveMission.HumanPlayers[1].HUD.StuntList.IsToggled) then
					ActiveMission.HumanPlayers[1].HUD.StuntList:ToggleWindow()
				end
			end
		end)
	end)
	
	self:PostConstruction()
	self.StuntManager:Enable()
end)

function FreestyleFestMission:CreateCarBuilder(Car, Skin)
	return LuaCarBuilder(Car, Skin, "PC_Freestyle.XML")
end

function FreestyleFestMission:SetStuntScore(StuntName, ID, Score)
	if ((StuntName ~= "") and (ActiveMission.HumanPlayers[1].HUD ~= nil)) then
		ActiveMission.HumanPlayers[1].HUD.ScorePopup:ShowPopup(StuntName, "", Score)
		ActiveMission.HumanPlayers[1].HUD.StuntList:SetStuntScore(ID, Score)
	end
end

function FreestyleFestMission:StartTutorial()
	local function TutorialEnd()
		PhysicsThread:Spawn(function()
			PhysicsThread:Wait(60 * 1)
			self:StartCountdown()
		end)
	end
	
	local function StartTutorialPowerups()
		print("TutorialPowerups")
		self.HumanPlayers[1].HUD.FireWorksButton:ShowTutorial(TutorialEnd)
	end
	
	local function StartTutorialStunt()
		print("TutorialStunt")
		self.HumanPlayers[1].HUD.StuntButton:ShowTutorial(StartTutorialPowerups)
	end
	
	local function StartTutorialTimer()
		print("StartTutorialTimer")
		self.HumanPlayers[1].HUD.Timer:ShowTutorial(StartTutorialStunt)
	end
	
	local function StartTutorialAccelerateSlider()
		print("TutorialAccelerateSlider")
		self.HumanPlayers[1].HUD.AccelerateSlider:ShowTutorial(StartTutorialTimer)
	end
	
	self.HumanPlayers[1].HUD:ShowSteerTutorial(StartTutorialAccelerateSlider)
end

function FreestyleFestMission:Start()
	self.Super.Start(self)
	
	self:PlayMusic("Music\\CrowdArena.ogg")

	-- Creeer de drivers
	for i, Player in ipairs(self.Players) do
		if (Player.Human) then
			print("Maak een human")
			Player.Driver = HumanDriver(Player.Car, 0)
			Player.InputManager = InputManager(Player, self)
			SetCamIndex(0)
		end

		if (Player.Driver ~= nil) then
			GetEntityScene():AddEntity(Player.Driver)

			Player.Driver:Init()
		end

		Player.Car:EnableInput()
		Player.Car:Enable()
		
		-- Activate the scoring display
		if (Player.HUD ~= nil) then
			Player.HUD:ActivateScore()
			Player.HUD:UpdateScore(Player)
		end
	end
	
	self:SetCarsVolume(1)
	
	

	TriggerTarget("SkipIntro")
	
	-- Zet de HUD aan
	for i, Player in ipairs(self.Players) do
		if (Player.HUD ~= nil) then
			Player.HUD:ShowLapCount()
			Player.HUD:SetLapCount(1, self.RaceData.LapCount)
			
			local Race = ActiveGameMode.ActiveChapter.ActiveRace
			local LapRecordTime = Translate('hud_nolaprecord')
			if Race.LapScores[#Race.LapScores] ~= nil then
				LapRecordTime = Race.LapScores[#Race.LapScores].VisualScore
			end
			Player.HUD:SetLapRecord(LapRecordTime)
		
			Player.HUD:ShowRank()
		end
	end
end

function FreestyleFestMission:StartCountdown()
	PhysicsThread:Run(function()
		for i = 3, 1, -1 do
			self:Countdown(i)
			PhysicsThread:Wait(60)
		end 

		-- De GO!
		self:Countdown(0)
		
		self.Finished = false

		for i, Player in ipairs(self.Players) do
			Player.Car:EnableInput()
			Player.Car:Enable()
			
			if (Player.HUD ~= nil) then
				Player.HUD:EnablePowerUps()
			end

			if (Player.Driver ~= nil) then
				if (not Player.Human) then
					Player.Driver:Enable()
				elseif (Player.InputManager ~= nil) then
					Player.InputManager:Enable()
				end
			end
		end
	end)
end

function FreestyleFestMission:Lap(Player)
	--
end

function FreestyleFestMission:NextCheckpoint(Car, Checkpoint)
	-- Geen visuele checkpoints in deze mission
end

function FreestyleFestMission:EndGame(HumanWon, Winner)
	self.Finished = true

	self.Super.EndGame(self)
	
	local Player = self.HumanPlayers[1]
	
	Player.InputManager:Disable()
	
	if (Player.HUD ~= nil) then
		Player.HUD:Hide()
		Player.HUD = nil
	end
	
	CutsceneBars = HUD_CutsceneFinished()
	self.SliderEnabled = false
		
	local Text = "--"
	local SubText = "--"
	
	if (HumanWon ~= nil and Winner ~= nil) then
		if (HumanWon) then
			Text = Winner.Name .. " has won the race!"
			SubText = "Great job!"
		else
			Text = Winner.Name .. " has won the race."
			SubText = "You can do better than this!"
		end
	end

	--print("^3" .. Text)
	--print("^3" .. SubText)
	
	CutsceneBars:SetTitle(Text)
	CutsceneBars:SetSubTitle(SubText)
end

function FreestyleFestMission:UpdatePhysics(ElapsedTime)	
	self.StuntManager:Update(ElapsedTime)

	if (self.RaceTimer ~= nil) then
		self.RaceTimer = self.RaceTimer - ElapsedTime
	end
	
	for i, Player in ipairs(self.Players) do
		if (Player.InputManager ~= nil) then
			Player.InputManager:Update(ElapsedTime)
		end	
		
		if (Player.HUD ~= nil) then
			Player.HUD:UpdatePhysics(ElapsedTime)
		
			if (Player.HUD ~= nil and self.RaceTimer ~= nil) then
				Player.HUD:SetScore(self.RaceTimer, 0, true)
			else
				Player.HUD:SetScore(self.RaceTimerStart, 0, true)
			end

			if (self.LapTime >= ElapsedTime) then
				self.LapTime = self.LapTime - ElapsedTime
			elseif (not self.Finished) then
				--print('Non stunting duration: '..tostring(FormatTime( self.TotalLapTime - self.StuntManager:GetTotalDuration()) ))
				
				self:EndGame(self.Players[1].Human, self.Players[1])
			end
		end
	end
end

function FreestyleFestMission:Update(ElapsedTime)
	self.StuntManager:UpdateScoreMessages(ElapsedTime)
	self.StuntManager:ChangeCamera()
	
	if (self.PickUpManager ~= nil) then
		self.PickUpManager:Update(ElapsedTime)
	end
	
	if (self.RaceTimer ~= nil and self.RaceTimer < 0 and not self.ReceivedBonusTime) then
		self.RaceTimer = self.RaceTimer + self.BonusTime
		self.ReceivedBonusTime = true
		
		local Player = self.HumanPlayers[1]
		Player.HUD:DisplayBonusTime()
	elseif (self.RaceTimer ~= nil and self.RaceTimer < 0 and not self.Finished) then
		self.Finished = true
		
		self:EndGame()
	end
	
	if (not self.Finished) then
		for i = 1, #self.Players do
			local Player = self.Players[i]
			
			if (Player.HUD ~= nil) then
				--if (not Player.Finished) then
					local Matrix = Player.Car:GetMatrix()
					local Up = Matrix:GetUp()
					local Vel = Player.Car:GetVelocity()
					
					if (Up.y < 0 and Vel:Magnitude() < 50) then
						if (Player.PowerupManager.RepairPowerup ~= nil and Player.PowerupManager.RepairPowerup.Enabled and not Player.PowerupManager.RepairPowerup.Used) then
							--Player.Finished = true
							if (not Player.Flipped) then
								Player.Flipped = true
								Player.HUD:CarFlipped(5)
							end
						else
							if (Player.RespawnTimer == nil) then
								Player.RespawnTimer = 0	-- signal afgeven?
							else
								Player.RespawnTimer = Player.RespawnTimer + ElapsedTime
								
								if (Player.RespawnTimer > 1) then
									local EndGame = true
									if (EndGame) then
										self:EndGame()
									else
										Player.Car:Respawn()
									end
									
									Player.RespawnTimer = nil
								end
							end
						end
					else
						Player.RespawnTimer = nil
					end
				--end
			end
		end
	end
end

function FreestyleFestMission:CarIsMoving()
	local PlayerCar = ActiveMission.HumanPlayers[1].Car
	local CarSpeed = math.abs(PlayerCar:GetLocalSpeed())

	if(math.floor(CarSpeed) ~= 0)then
		return true
	else
		return false
	end
end

function FreestyleFestMission:CarIsBackingUp()
	local PlayerCar = ActiveMission.HumanPlayers[1].Car
	local CarSpeed = PlayerCar:GetLocalSpeed()
	
	if(CarSpeed > 1)then
		return true
	else
		return false
	end
end

function FreestyleFestMission:SetScore()
	-- print("^3 -- FreestyleFestMission:SetScore()")
	local Player = self.HumanPlayers[1]
	Player:CalculateAllScores()

	self.Score = self:CalculatePoints()

	self.Super.SendScore(self, self.Score)
	self.Super.SendStats(self, self.Score)
end

function FreestyleFestMission:CalculatePoints()
	-- print("^3 -- FreestyleFestMission:CalculatePoints()")
	local Player = self.HumanPlayers[1]
	local TotalPoints = 0
	
	local PointsPerStar = (self.MaxTotalScore / #Player.Scores) / 3 -- For 3 stars

	for i = 1, (#Player.Scores) do
		TotalPoints = TotalPoints + (Player.StarScores[i] * PointsPerStar)
		-- print(tostring(Player.StarScores[i]).." * "..tostring(PointsPerStar).." = "..tostring(Player.StarScores[i] * PointsPerStar))
	end
	
	-- print("TotalPoints = "..tostring(TotalPoints))
	return TotalPoints
end
