HillClimbMission = class(BaseMission, function(self, RaceData)
	print("^3HillClimbMission created")

	-- Create player car
	local CarBuilder = LuaCarBuilder(RaceData.Car, RaceData.Skin)
	local Player = self:CreateHumanPlayer(RaceData.Car, RaceData.Skin, RaceData.Player)
	
	Player.Car:SetForceCamUp(false)

	table.insert(self.HumanPlayers, Player)
	
	self:SetCarsVolume(0)
	
	self.Car_Thread = PhysicsThread:Spawn(function()
		while (true) do
			local Car = self.Players[1].Car;
			local Matrix = Car:GetPhysicsMatrix()
			
			local Pos = Matrix:GetTranslation()
			Pos.z = 0;
			Matrix = Matrix:SetTranslation(Pos);
			
			--[[local Dir = Matrix:GetDirection()
			Dir.z = 0;
			Dir = Dir:Normalize();
			
			local Up = Matrix:GetUp()
			Up.z = 0;
			Up = Up:Normalize();
			
			local Right = Up:Cross(Dir):Normalize()
			
			Dir = Right:Cross(Up):Normalize()
			
			Matrix = Matrix:SetAxii(Right, Up, Dir);
			Car:SetPhysicsMatrix(Matrix)]]
			
			local Vel = Car:GetVelocity();
			Vel.z = 0;
			Car:SetVelocity(Vel)
			
			local Player = self.HumanPlayers[1]
			if (not Player.Finished and Pos.x < -1000) then
				local OldTrackRecord = ActiveGameMode.ActiveChapter.ActiveRace:GetCurrentTrackScore("1")
				local NewTrackRecord = nil

				if (self.RaceTimer ~= nil) then
					if (ActiveGameMode.ActiveChapter.ActiveRace:AddTrackScore(0, Player.Name, "Player.Car:GetName()", self.RaceTimer, FormatTime(self.RaceTimer), "1")) then
						NewTrackRecord = FormatTime(self.RaceTimer)
					end
				end
				self:JamFinished(OldTrackRecord, NewTrackRecord)
				
				break
			end
			
			PhysicsThread:Wait(1)
		end
	end)
	
	-- self.Listeners = AddKeyListeners(ToggleMenuButtons, "Down", function(Listener)
		-- GameThread:Spawn(function()
			-- if (self.IngameMenuEnabled) then
				-- if (ActiveMenu == nil) then
					-- self:ShowIngameMenu()
				-- end
			-- end
		-- end)
	-- end)
	
	-- Test: Super boost
	AddKeyListeners("DCK_Z", "Down", function(Listeners)
		Test_SetSuperBoost(true)
	end)
	AddKeyListeners("DCK_Z", "Up", function(Listeners)
		Test_SetSuperBoost(false)
	end)

	
	PhysicsThread:Spawn(function()
		Player.HUD = nil

		CutsceneBars = nil
	
		self.HumanPlayers[1].HUD = ActiveGameMode:HUD(self, self.HumanPlayers[1])
		TriggerTarget("SkipIntro")
		
		--FinishStart()
		
		self:Start()
	end)
	
	var('modelerp', 10000)
	
	self:PostConstruction()
end)

function HillClimbMission:ResetCar()
	local Player = self.HumanPlayers[1]
	Player.Car:SetMatrix(GetScriptMatrix("Player 1"))
end

function HillClimbMission:Start()
	-- Creeër de drivers
	for i, Player in ipairs(self.Players) do
		if (Player.Human) then
			print("Maak een human")
			Player.Driver = HumanDriver(Player.Car, 0)
			SetCamIndex(1)

			Player.Car:Enable()

		end

		if (Player.Driver ~= nil) then
			GetEntityScene():AddEntity(Player.Driver)

			Player.Driver:Init()
		end
	end
	
	self:SetCarsVolume(1)
	
	-- Zet de HUD aan
	for i, Player in ipairs(self.Players) do
		if (Player.HUD ~= nil) then
			local Race = ActiveGameMode.ActiveChapter.ActiveRace
			local LapRecordTime = Translate('hud_nolaprecord')
			
			if(Race.LapScores[#Race.LapScores] ~= nil) then
				LapRecordTime = Race.LapScores[#Race.LapScores].VisualScore
			end
			
			Player.HUD:SetLapRecord(LapRecordTime)			
		end
	end
	
	if (true) then		--Start tutorial or not?
		self.HumanPlayers[1].HUD.AccelerateSlider:ShowTutorial()
	else
		self:StartCountdown()
	end
end

function HillClimbMission:StartCountdown()
	-- Start de thread voor de countdown
	PhysicsThread:Run(function()
		-- Wacht 3 seconden
		for i = 3, 1, -1 do
			-- Zet de counter
			self:Countdown(i)

			-- Wacht 1 seconde
			PhysicsThread:Wait(60)
		end 

		-- De GO!
		self:Countdown(0)
		
		self.CountdownStarted = false
		
		-- Zet de spelers aan
		for i, Player in ipairs(self.Players) do
			-- Dit moet op de driver eigenlijk
			Player.Car:EnableInput()
			Player.Car:Enable()
			
			if (Player.HUD ~= nil) then
				Player.HUD:EnablePowerUps()
			end

			if (Player.Driver ~= nil) then
				Player.Driver:Enable()
			end
			
			if (Player.HUD ~= nil) then
				Player.HUD.SliderEnabled = true
			end
		end
	end)
end

function HillClimbMission:JamFinished(OldTrackRecord, NewTrackRecord)
	-- Show the Cutscene
	if(CutsceneBars == nil)then
		CutsceneBars = HUD_CutsceneFinished(self,true)
		for i, Player in ipairs(self.Players) do
			if(Player.HUD) then
				Player.HUD:Hide(true)
			end
		end
		
	end
	
	local PlayerHasRecord = true
	local Text = ""
	
	if (OldTrackRecord ~= nil) then
		OldTrackRecord = FormatTime(OldTrackRecord)
	else
		OldTrackRecord = FormatTime(0)
	end
	
	if (NewTrackRecord == nil) then
		NewTrackRecord = FormatTime(self.RaceTimer)
		PlayerHasRecord = false
	end
	
	if(PlayerHasRecord)then
		Text = "New track record!"
		ActiveMenu:ShowNewTrackRecord("Old lap record: "..tostring(OldTrackRecord), "New lap record: "..tostring(NewTrackRecord))
	else
		Text = "Sorry, not a new record!"
		ActiveMenu:ShowNewTrackRecord("Old lap record: "..tostring(OldTrackRecord), "New lap: "..tostring(NewTrackRecord))
	end
	
	ActiveMenu:SetTrackText(Text)
end

function HillClimbMission:UpdatePhysics(ElapsedTime)
	--
end

function HillClimbMission:Update(ElapsedTime)
	if (self.PickUpManager ~= nil) then
		self.PickUpManager:Update(ElapsedTime)
	end
end