MenuMission = class(function(self)
	LoadMenuTextures()
	
	-- Photoshoot vars
	self.NormalColor = color(1,1,1,1)
	self.NormalIntensity = 0
	self.NormalGrayValue = 0
	
	self.PhotoColor = color(0,0,0,1)
	self.PhotoIntensity = 0
	self.PhotoGrayValue = 0.75
	
	SetShaderVar("ColorOverlay", self.NormalColor * self.NormalIntensity)
	SetShaderVar("InvGreyValue", 1 - self.NormalGrayValue)
	SetShaderVar("GreyScale", Vector(0.222, 0.707, 0.071) * self.NormalGrayValue)

	print("^3MENUMISSION ACTIVE")
	
	table.insert(ResetFuncs, function()
		self:Destroy()
	end)
	
	-- Set referentie
	ActiveMission = self		--WTF!? Waarom dit hier zo doen?
	ActiveBackground = nil
	ActiveForeground = nil

	--Check Performance
	local LowPerformance = false
	
	if (LowPerformance) then
		self.ObjectRender = ObjectRender(512, 512)
	else
		self.ObjectRender = ObjectRender(1024, 1024)
	end
	
	if (LowPerformance) then
		self.CarRender = CarRender(512, 512)
	else
		self.CarRender = CarRender(1024, 1024)
	end
	
	self.ColorWheelPicker = LuaColorPicker(64, 64, 0)
	self.ColorWheelPickerTexture = self.ColorWheelPicker:GetTexture()
	self.CarManager = CarManager()
	self.ObjectManager = ObjectManager()
	
	if (FuelEnergy == nil) then
		FuelEnergy = PowerManager()
	end
	
	--ReadGameSettings()	-- Nee joren. niet hier.
	
	--[[if ((ActiveGameMode:GetSelectedCar().Bought and ActiveGameMode:GetSelectedCar().Available) or DebugUnlockAll) then
		--self.CarManager:ShowCar(ActiveGameMode:GetSelectedCar())
	end]]
end)

GameRenders = {}

function GameRenderCallback()
	for i = 1, #GameRenders do
		GameRenders[i]()
	end
end

function RenderGame(Function)
	SetGameRenderCallback(GameRenderCallback)

	table.insert(GameRenders, Function)
end

function MenuMission:Destroy()
	GameRenders = {}

	if (ActiveMenu ~= nil and ActiveMenu.Destroy ~= nil) then
		ActiveMenu:Destroy()
	end
	
	self.CarManager:Destroy()
	self.CarRender:Destroy()
	
	self.ObjectManager:Destroy()
	self.ObjectRender:Destroy()
	
	self.ColorWheelPicker:Destroy()
	
	clearmenustack()
	
	ActiveBackground = nil
	ActiveMenu = nil
	ActiveForeground = nil
	
	UnloadMenuTextures()
end

function MenuMission:Refresh()	
	if (ActiveBackground ~= nil) then
		ActiveBackground:Refresh()
	end
	
	if (ActiveMenu ~= nil) then
		ActiveMenu:Refresh()
	end
	
	if (ActiveForeground ~= nil) then
		ActiveForeground:Refresh()
	end
	
	FuelEnergy = PowerManager()
end

function MenuMission:GetTotalScore()
	print('Got the score!')
end