TestMission = class(BaseMission, function(self, RaceData)
	print("^3Testmission created")

	-- Create player car
	local Player = self:CreateHumanPlayer(self.RaceData.Car, self.RaceData.Skin, "Player 1")
	
	self:SetCarsVolume(0)
	
	PhysicsThread:Spawn(function()
		Player.HUD = nil

		CutsceneBars = nil
		self.IngameMenuEnabled = true
	
		self.HumanPlayers[1].HUD = ActiveGameMode:HUD(self, self.HumanPlayers[1])
		TriggerTarget("SkipIntro")
		
		FinishStart()
		
		self:Start()
		
		self:PlaceTestCars()
	end)
	
	self:PostConstruction()
end)


function TestMission:PlaceTestCars()
	for i, Truck in pairs(MonsterTruckCars.Cars) do
		CarScriptMatrix = GetScriptMatrix("TruckLocation"..(i))

		local StaticMesh = false
		if (StaticMesh) then
			local CarMesh = CreateAdvancedMesh(nil, "Vehicles\\"..(Truck.Name).."\\Chassis1.DCM", "")
			GetEntityScene():AddEntity(CarMesh)
			CarMesh:Update(CarScriptMatrix, VectorZero, VectorZero)
		else
			local Player = self:CreateHumanPlayer(Truck.Name, 0, "TruckLocation" .. i)
			Player.Car:SetMatrix(CarScriptMatrix)
		end
		
		--print((i)..".  Name = "..(Truck.Name)..", new matrix = "..tostring(self.CarScriptMatrix[i]))
	end
end

function TestMission:Start()
	self.Super.Start(self)

	-- Creeer de drivers
	for i, Player in ipairs(self.Players) do
		if (Player.Human) then
			print("Maak een human")
			Player.Driver = HumanDriver(Player.Car, 0)
			Player.InputManager = InputManager(Player, self)
		end

		if (Player.Driver ~= nil) then
			GetEntityScene():AddEntity(Player.Driver)
			
			Player.Driver:Init()
		end

		Player.Car:EnableInput()
		Player.Car:Enable()

		if (Player.Driver ~= nil) then
			Player.Driver:Enable()
		end
	end
	
	self:SetCarsVolume(1)
	
	-- Zet de HUD aan
	for i, Player in ipairs(self.Players) do
		if (Player.HUD ~= nil) then
			Player.HUD:ShowLapCount()
			Player.HUD:SetLapCount(1, self.RaceData.LapCount)
			
			local Race = ActiveGameMode.ActiveChapter.ActiveRace
			local LapRecordTime = Translate('hud_nolaprecord')
			if Race.LapScores[#Race.LapScores] ~= nil then
				LapRecordTime = Race.LapScores[#Race.LapScores].VisualScore
			end
			Player.HUD:SetLapRecord(LapRecordTime)
		
			Player.HUD:ShowRank()
		end
	end

		
	CutsceneBars = HUD_CutsceneBars()
	self:StartCountdown()
end

function TestMission:StartCountdown()
	for i, Player in ipairs(self.Players) do
		-- Dit moet op de driver eigenlijk
		Player.Car:EnableInput()
		Player.Car:Enable()
		
		if (Player.HUD ~= nil) then
			Player.HUD:EnablePowerUps()
		end
		
		if (Player.Driver ~= nil) then
			Player.Driver:Enable()
		end
		
		if (Player.Driver ~= nil) then
			if (not Player.Human) then
				Player.Driver:Enable()
			elseif (Player.InputManager ~= nil) then
				Player.InputManager:Enable()
			end
		end
	end
end