TowTestMission = class(BaseMission, function(self, RaceData)
	print("^3TowTestMission created")
	
	-- Instel waarden
	self.TorqueScale = 800
	self.MaxWheelTorque = 1800000 --1800000
	
	self.SlipSeconds = 99999999999
	
	self.StartMass = 5000
	self.MaxMass = 180000
	
	self.StartFriction = 20000
	self.MaxFriction = 2000000
	
	self.SlipPoint = 1.1
	
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME4) then
		self.StartFriction = 20000
		self.MaxFriction = 400000
	
		self.StartMass = 100
		self.MaxMass = 2000
	elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME3) then
		print("^4Theme 3 mass")
		self.StartFriction = 300000
		self.MaxFriction = 380000
	
		self.StartMass = 15000
		self.MaxMass = 20000
	elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
		print("^5Theme 5 mass")
		self.TorqueScale = 1500
		self.MaxWheelTorque = 2500000
	
		self.StartFriction = 200000
		self.MaxFriction = 1
	
		self.StartMass = 20000
		self.MaxMass = 20000
	end
	
	self.Friction = self.StartFriction
	--
	
	var("extrageometry", 0)

	-- Create player
	local Player = self:CreateHumanPlayer(RaceData.Car, RaceData.Skin, "Player 1")
	
	local Y = -20
	local XDistance = 18
	local Z = 25
	
	-- Create slip effects
	self.SlipEffectRight = CreateEffectSystem("FX\\Slip.xml", true) -- Right
		GetEntityScene():AddEntity(self.SlipEffectRight)
		self.SlipEffectRight:SetOffsetPos(Vector(XDistance,Y,Z))
		Player.Car:GetMesh():AddPlugin(self.SlipEffectRight, "", 1)
	self.SlipEffectRight:SetAmountVar("Slip", 0)
		
	self.SlipEffectLeft = CreateEffectSystem("FX\\Slip.xml", true) -- Left
		GetEntityScene():AddEntity(self.SlipEffectLeft)
		self.SlipEffectLeft:SetOffsetPos(Vector(-XDistance,Y,Z))
		Player.Car:GetMesh():AddPlugin(self.SlipEffectLeft, "", 1)
	self.SlipEffectLeft:SetAmountVar("Slip", 0)	
	
	-- Set the proper torquescalar, specific for this mission alone
	self.CarBuilder:GetEngine():SetTorqueScale(self.TorqueScale)
	self.CarBuilder:GetEngine():SetMaxWheelTorque(self.MaxWheelTorque)
	
	self.UnitConverter = 3.28084
	
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
	self.DistanceToTow = 200 * self.UnitConverter
	else 
	self.DistanceToTow = 200 * self.UnitConverter
	end
	
	self.DistanceTowed = 0
	self.MaxDistanceTowed = 0
	self.CountdownTimer = 0
	
	self.Car_Thread = PhysicsThread:Spawn(function()
		local Perc = 0
		local PercMult = 1
		local WaitTime = 3
		
		local WarningTimer = 0
		local IsShowingWarning = false
		
		local CountdownThread = nil
		
		local Car = self.Players[1].Car
		
		local StartPosZ = Car:GetMatrix():GetTranslation().z

		while (self.Car_Thread ~= nil) do
			local Matrix = Car:GetPhysicsMatrix()
			
			local Velocity = Car:GetVelocity()
			Velocity.z = 0
			Car:SetVelocity(Velocity)
			
			local Dir = -Vector(0,0, Matrix:GetTranslation().z - StartPosZ)
			local Mult = 1000000
			--Dir = -Dir
			Car:AddForce(Dir * Mult)
			
			local Player = self.HumanPlayers[1]
			local ObjectPos = self.TowTestObject:GetMatrix():GetTranslation()
			
			Perc = self.DistanceTowed / self.DistanceToTow			
			
			Perc = math.sign(Perc) * math.pow(math.abs(Perc), 2)
			
			if (self.TowTestObject ~= nil and not self.Finished) then
				self.TowTestObject.Friction = Lerp(self.StartFriction, self.MaxFriction, Perc)
			end
			
			self.TowTestObject:SetOffset(Lerp(VectorZero, Vector(0,-10,0), ClampMinMax(Perc, 0, 1)))
			self.TowTestObject:SetEffectOffset(Lerp(Vector(-120,0,0), Vector(-170,15,0), ClampMinMax(Perc, 0, 1)))
			
			local XOffset = 30
			
			local DistanceDevider = 10
			
			if (self.DistanceTowed + DistanceDevider < self.MaxDistanceTowed) then
				self:EndGame()
			end
			
			if (not self.Finished) then
				if (self.StartingPos ~= nil) then
					self.DistanceTowed = Round((self.StartingPos:DistanceTo(ObjectPos) / DistanceDevider) * self.UnitConverter)
					self.MaxDistanceTowed = Max(self.MaxDistanceTowed, self.DistanceTowed)
				else
					self.DistanceTowed = 0
				end
			end
			
			PhysicsThread:Wait(1)
		end
	end)
	
	self.MusicThread = PhysicsThread:Spawn(function()
		self:PlayMusic("Music\\TowTest.ogg")
		
		PhysicsThread:Sleep(22)
		
		self:StopMusic()
	end)
	
	-- Test: Super boost
	local EnableSuperBoost = false
	if (EnableSuperBoost) then
		AddKeyListeners("DCK_U", "Down", function(Listeners)
			Test_SetSuperBoost(true)
		end)
		AddKeyListeners("DCK_U", "Up", function(Listeners)
			Test_SetSuperBoost(false)
		end)
	end
	
	local EnableChainBreak = true
	
	if (EnableChainBreak) then
		AddKeyListeners("DCK_U", "Up", function(Listeners)
			self.Chain:BreakChain(false)
		end)
	end
	
	PhysicsThread:Spawn(function()
		Player.HUD = nil

		CutsceneBars = nil
		
		FinishStart()
		
		local ImmediateStart = false
		
		if (ImmediateStart) then
			self:Start()
		else
			-- Show the Cutscene
			CutsceneBars = HUD_CutsceneBars()
		end
		
		Player.Car:EnableInput()
		Player.Car:Enable()
		
		Player.Car:Brake(1)
		Player.Car:Handbrake(1)
	end)
	
	-- Hackin yo
	local FileName = "Models\\Space_Shuttle.DCM"
	local StartPos = Vector(300, 18, 0)
	local EndPos = Vector(-120,0,0)
	local TowObjectHookPos = Vector(-145,5,0)
	
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME4) then
		FileName = "Models\\LvWelcome.DCM"
		StartPos = Vector(300, 18, 0)
		EndPos = Vector(-120,0,0)
		TowObjectHookPos = Vector(-132,10,7)
	elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME3) then
		FileName = "Models\\Submarine.DCM"
		StartPos = Vector(300, 18, 0)
		EndPos = Vector(-120,0,0)
		TowObjectHookPos = Vector(-157,17,0)
	elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
		FileName = "Models\\Boomstam.DCM"
		StartPos = Vector(300, 18, 0)
		EndPos = Vector(-120,0,0)
		TowObjectHookPos = Vector(-47,20,0)
	end
	
	-- Make the chain
	self.TowTestObject = TowCarObject(FileName, self.StartFriction, self.MaxFriction, StartPos, EndPos)
	self.TowTestObject:Update()
	self.TowTestObject.Body:SetVelocity(Vector(0,0,0))
	
	local Body1 = {}
	Body1.Type = "Car"
	Body1.Object = Player.Car
	
	local Body2 = {}
	Body2.Type = "Body"
	Body2.Object = self.TowTestObject.Body
	
	self.Chain = Chain(12, GetScriptMatrix("ChainStart"), Vector(1,0,0), Body1, Body2, Vector(36,12,0), TowObjectHookPos)
	
	self.IsSlipping = false
	
	self:PostConstruction()
end)

function TowTestMission:Destroy()
	self.Super.Destroy(self)
	
	if (self.Car_Thread ~= nil) then
		PhysicsThread:Spawn(function()
			PhysicsThread:Stop(self.Car_Thread)
			self.Car_Thread = nil
		end)
	end
end

function TowTestMission:StartTutorial()
	local function TutorialEnd()
		print("TutorialEnd")
		
		PhysicsThread:Spawn(function()
			PhysicsThread:Wait(60 * 1)
			self:StartCountdown()
		end)
	end
	
	local function StartTutorialPowerups()
		print("TutorialPowerups")
		self.HumanPlayers[1].HUD.FireWorksButton:ShowTutorial(TutorialEnd)
	end
	
	local function StartTutorialCountdown()
		print("TutorialCountdown")
		self.HumanPlayers[1].HUD.WarningPopup:ShowTutorial(StartTutorialPowerups)
	end
	
	local function StartTutorialScore()
		print("StartTutorialDiffTimer")
		self.HumanPlayers[1].HUD.ScoreElement:ShowTutorial(StartTutorialCountdown)
	end
	
	self.HumanPlayers[1].HUD.AccelerateSlider:ShowTutorial(StartTutorialScore)
end

function TowTestMission:Start()
	self.Super.Start(self)

function TowTestMission:CreateCarBuilder(Car, Skin)
	print("^5Functie werkt")
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
		print("^5thema 5 settings hilljump")
		return LuaCarBuilder(Car, Skin, "PC_TowTest_Theme5.XML")
	else
		print("^5Normale settings")
		return LuaCarBuilder(Car, Skin, "PC.XML")
	end
end
	
	
	-- Creeer de drivers
	for i, Player in ipairs(self.Players) do
		if (Player.Human) then
			print("Maak een human")
			Player.Driver = HumanDriver(Player.Car, 0)
			Player.InputManager = InputManager(Player, self)
			Player.InputManager:DisableSteering()
			SetCamIndex(2)
		end

		if (Player.Driver ~= nil) then
			GetEntityScene():AddEntity(Player.Driver)

			Player.Driver:Init()
		end
		
		Player.Car:EnableInput()
		Player.Car:Enable()
	end
	
	self:SetCarsVolume(1)
	
	local BreakChainAtStart = false
	if (BreakChainAtStart) then
		PhysicsThread:Spawn(function()
			self.Chain:BreakChain(false)
		end)
	end

	-- Zet de HUD aan
	for i, Player in ipairs(self.Players) do
		if (Player.HUD ~= nil) then		
			Player.HUD:ShowRank()
		end
	end
end

function TowTestMission:StartCountdown()
	PhysicsThread:Run(function()
		for i = 3, 1, -1 do
			self:Countdown(i)
			PhysicsThread:Wait(60)
		end 

		-- De GO!
		self:Countdown(0)
		self.Finished = false
		
		for i, Player in ipairs(self.Players) do
			Player.Car:EnableInput()
			Player.Car:Enable()
			
			if (Player.HUD ~= nil) then
				Player.HUD:EnablePowerUps()
			end

			if (Player.Driver ~= nil) then
				if (not Player.Human) then
					Player.Driver:Enable()
				elseif (Player.InputManager ~= nil) then
					Player.InputManager:Enable()
				end
			end
		end
		
		self.StartingPos = self.TowTestObject:GetMatrix():GetTranslation()
	end)
end

function TowTestMission:EndGame()		
	if (self.Finished) then
		return
	end

	self.Super.EndGame(self)
	
	self.Finished = true

	local Camera = EntityCamera(0)
	Camera:SetMode(13)
	
	DailyMissionsManager:StartChecking(self, "Challenge_11")
	DailyMissionsManager:StartChecking(self, "Challenge_12")
	
	local Player = self.HumanPlayers[1]
	
	GameThread:Spawn(function()
		GameThread:Wait(1)
		
		self:EndingMove(function()		
			if (not Player.Finished) then
				Player.Finished = true
				local Car = Player.Car
				
				if (Player.HUD ~= nil) then
					Player.HUD.SliderEnabled = false
					Player.HUD.CarAccel = 0
					Player.HUD.CarReverse = 0
					
					Player.HUD:Hide()
					Player.HUD = nil
				end
				
				ActiveMenu = RaceResultScreen()
				
				while (ActiveMenu ~= nil) do
					Car:Accelerate(0)
					Car:ChangeGear(0)
					Car:Brake(1)
					Player.Car:Handbrake(1)
					GameThread:Wait(1/60)
				end
			end
		end)
	end)
end

function TowTestMission:UpdatePhysics(ElapsedTime, AccelForce, MaxWheelTorque, OverPower)
	self.Super.UpdatePhysics(self, ElapsedTime)
	
	local Player = self.HumanPlayers[1]
	local PlayerCar = Player.Car
	
	if (Player.HUD ~= nil and self.RaceTimer ~= nil) then
		Player.HUD:SetScore(self.MaxDistanceTowed, 0)
	elseif (Player.HUD ~= nil) then
		Player.HUD:SetScore(0)
	end

	if (self.Chain.StressMeasured < self.SlipPoint) then
		self.IsSlipping = false
		self.SlipEffectRight:SetAmountVar("Slip", 0)
		self.SlipEffectLeft:SetAmountVar("Slip", 0)
	end
	
	if (self.BackCollider ~= nil and not self.Finished) then
		self.BackCollider:Update()
	end
end

function TowTestMission:MaySlip(Car, AccelForce, MaxWheelTorque, OverPower)
	local Player = self:GetPlayer(Car)
	
	local Slipping = self.Chain.StressMeasured > self.SlipPoint
	
	if (Player.Human and Player.HUD ~= nil and Slipping) then
		self.IsSlipping = true
		local SlipAmount = ClampMinMax(OverPower * 3, 0, 2)
		self.SlipEffectRight:SetAmountVar("Slip", SlipAmount)
		self.SlipEffectLeft:SetAmountVar("Slip", SlipAmount)
	end
	
	local Debug = false
	if (Debug) then
		local Text = ""
		if (Slipping) then
			Text = "^2"
		else
			Text = "^1"
		end
		print(Text .. tostring(Slipping) .. " ^7AccelForce; " .. tostring(AccelForce) .. " MaxWheelTorque; " .. tostring(MaxWheelTorque) .. " OverPower; " .. tostring(OverPower))
	end
 
	return Slipping
end

function TowTestMission:EndingMove(Callback)
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME1) then
		self:Fly(Callback)
	else
		Callback()
	end
end
	
function TowTestMission:Fly(Callback)
	local XPos = 270

	local OneThrust = true

	if (not OneThrust) then
		local Effect1 = CreateEffectSystem("FX\\SpaceShuttleFlame.xml", true)
		GetEntityScene():AddEntity(Effect1)
		Effect1:SetOffsetPos(Vector(XPos,70,0))
		self.TowTestObject.Mesh:AddPlugin(Effect1, "", 1)
		
		local Effect2 = CreateEffectSystem("FX\\SpaceShuttleFlame.xml", true)
		GetEntityScene():AddEntity(Effect2)
		Effect2:SetOffsetPos(Vector(XPos,35,30))
		self.TowTestObject.Mesh:AddPlugin(Effect2, "", 1)
		
		local Effect3 = CreateEffectSystem("FX\\SpaceShuttleFlame.xml", true)
		GetEntityScene():AddEntity(Effect3)
		Effect3:SetOffsetPos(Vector(XPos,35,-30))
		self.TowTestObject.Mesh:AddPlugin(Effect3, "", 1)
	else
		local Effect = CreateEffectSystem("FX\\SpaceShuttleFlame.xml", true)
		GetEntityScene():AddEntity(Effect)
		Effect:SetOffsetPos(Vector(XPos,40,0))
		self.TowTestObject.Mesh:AddPlugin(Effect, "", 1)
	end

	local Camera = EntityCamera(0)
	local CamPos = Camera:GetMatrix():GetTranslation()
	local CamMatrix = Camera:GetMatrix()
	local CamLerpMatrix = CamMatrix
	local CamStartMatrix = Camera:GetMatrix()
	
	Camera:SetMode(13)
	
	if (self.HumanPlayers[1].Driver ~= nil) then
		self.HumanPlayers[1].Car:KillDriver()
	end

	PhysicsThread:Spawn(function()		
		local Matrix = GetScriptMatrix("EndingMoveCam1")		
		for i = 1, 2*60 do
			if (Matrix == nil) then
				break
			end
		
			Camera:SetMatrix(Matrix:RotateLocal(Vector(0,1,0), math.rad(90)))
			
			PhysicsThread:Wait(1)
		end
		
		local Length = 5*60
		local TotalForce = 300000
		
		self.TowTestObject.Body:SetMass(Lerp(self.StartMass, self.MaxMass, 0))
		
		self.TowTestObject.Geometry:SetType(0)
		self.TowTestObject.Geometry:SetCollision(0)
		
		for i = 1, Length do
			self.TowTestObject.Body:AddForce(Vector(-1,1 - (i / (Length / 1.6)),0) * (i * TotalForce))
			
			if (i < Length / 10) then
				local Mult = 1 - (i / (Length * 10))
				self.TowTestObject.Body:AddTorque(Vector(0,0,-TotalForce * 250 * Mult))
			end
			
			local CamDir = Vector(0,0,0)
			if (i < Length / 2) then
				CamDir = (Camera:GetMatrix():GetTranslation() - self.TowTestObject:GetMatrix():GetTranslation()):Normalize() * -1
			else
				CamDir = (Camera:GetMatrix():GetTranslation() - self.HumanPlayers[1].Car:GetMatrix():GetTranslation()):Normalize() * -1						
			end
		
			CamDir.x = CamDir.x * -1
			CamMatrix = CamMatrix:LookAt(Vector(0,0,0), CamDir, 0)
			
			CamMatrix = CamMatrix:Rotate(Vector(1,0,0), math.rad(180)):Inverse()
			CamMatrix = CamMatrix:Rotate(Vector(0,0,1), math.rad(180))
			
			CamMatrix = CamMatrix:Translate(CamPos)
			CamMatrix = Camera:GetMatrix():Lerp(CamMatrix, 0.7)
			
			if (i < (Length / 2) / 3) then
				CamMatrix = CamStartMatrix:Lerp(CamMatrix, 0.1)
			else
				CamMatrix = CamStartMatrix:Lerp(CamMatrix, 0.78)
			end
			
			CamLerpMatrix = CamLerpMatrix:Lerp(CamMatrix, 0.1)
			
			Camera:SetMatrix(CamLerpMatrix)
			
			PhysicsThread:Wait(1)
		end
		
		Callback()
	end)
end

function TowTestMission:ReturnSlipRotationValue() -- Default 1
	return 1
end 

function TowTestMission:DebugBla(Bla, Bla2, Bla3)
	--print("lala; " .. tostring(Round(math.deg(Bla))) .. "           lala; " .. tostring(Round(math.deg(Bla2))) .. "        lala; " .. tostring(Round(math.deg(Bla3))))
end

function TowTestMission:SetScore(Score)
	if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME3) then
		self.Score = Round(self.MaxDistanceTowed * (700000 / self.DistanceToTow /2.1))
		print("^2Theme3 SetScore; " .. tostring(self.Score))
	
		self.Super.SendScore(self, self.Score)
		self.Super.SendStats(self, self.Score)
	
	elseif (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME5) then
		self.Score = Round(self.DistanceTowed * (700000 / self.DistanceToTow /1.8))
		print("^2Theme5 SetScore; " .. tostring(self.Score))
	
		self.Super.SendScore(self, self.Score)
		self.Super.SendStats(self, self.Score)
	
	else
		self.Score = Round(self.MaxDistanceTowed * (700000 / self.DistanceToTow))
		print("SetScore; " .. tostring(self.Score))
	
		self.Super.SendScore(self, self.Score)
		self.Super.SendStats(self, self.Score)
	end
end

function InitBackCollider(WorldObject)
	local Collider = BackCollider(WorldObject)
	PhysicsThread:Spawn(function()
		ActiveMission.BackCollider = Collider
	end)
	
	return Collider
end

BackCollider = class(function(self, WorldObject)	
	self.WorldObject = WorldObject
	self.Name = WorldObject:GetName()
	self.Matrix = WorldObject:GetMatrix()		
end)

function BackCollider:Update() 
	if (ActiveMission.TowTestObject ~= nil and ActiveMission.TowTestObject.Body:GetVelocity().x < -10) then
		local TargetPos = ActiveMission.TowTestObject:GetMatrix():GetTranslation()
		local XPos = TargetPos.x + 440
		self.Matrix = self.Matrix:SetTranslation(Vector(XPos + 1, self.Matrix:GetTranslation().y, self.Matrix:GetTranslation().z))
	end
	self.WorldObject:SetMatrix(self.Matrix)
end