-- Game modes
MonsterTruckCarAxis = class(function(self, Car, Name, Object1, Object2)
	self.Car = Car
	self.Object1 = Object1
	self.Object2 = Object2
	
	-- Get object
	--print("Getting object " .. Name)
	self.Object = Car.Mesh:GetObject(Name)

	-- Get data
	self.OffsetMatrix = self.Object:GetOffsetMatrix() * Car.OffsetMatrix
	self.Object1Offset = MatrixIdentity--Object1:GetMatrix() / self.OffsetMatrix
	self.Object2Offset = MatrixIdentity--Object2:GetMatrix() / self.OffsetMatrix
	
	--OffsetMatrix = self.Object:GetOffsetMatrix():Translate(-AttachedObject:GetMatrix():GetTranslation())-- / Matrix34(AttachedObject:GetMatrix():GetTranslation());
	self.Object.ParentMultiply = false
end)

function MonsterTruckCarAxis:Destroy()
	--
end

function MonsterTruckCarAxis:SetMatrix()
	local Object1Matrix = self.Object1Offset * self.Object1:GetMatrix()
	local Object2Matrix = self.Object2Offset * self.Object2:GetMatrix()
	
	local Right = (Object1Matrix:GetTranslation() - Object2Matrix:GetTranslation()):Normalize()
	local Dir = self.Car:GetMatrix():GetDirection()
	local Up = -Dir:Cross(Right):Normalize();

	Right = Up:Cross(Dir):Normalize();
	
	local FinalMatrix = MatrixIdentity:SetAxii(Right, Up, Dir);
	FinalMatrix = FinalMatrix:SetTranslation((Object1Matrix:GetTranslation() + Object2Matrix:GetTranslation()) / 2)
	--FinalMatrix = FinalMatrix:SetRotation(self.Car:GetMatrix())
	
	FinalMatrix = FinalMatrix-- * self.Car:GetMatrix();
	
	-- dit is voor single attachments
	--local FinalMatrix = self.OffsetMatrix * self.AttachedObject:GetMatrix();

	self.Object:SetOffsetMatrix(FinalMatrix)
end 

function MonsterTruckCarAxis:GetMatrix()
	return self.Object:GetOffsetMatrix()
end

function MonsterTruckCarAxis:Update()
	self:SetMatrix()
end

function MonsterTruckCarAxis:Render()
	--
end