-- Game modes
MonsterTruckCarElement = class(function(self, Car, Name, Object1, OffsetMatrix)
	self.Car = Car
	self.Object1 = Object1
	
	if (OffsetMatrix == nil) then
		OffsetMatrix = MatrixIdentity
	end
	
	-- Get object
	print("Getting object " .. Name)
	self.Object = Car.Mesh:GetObject(Name)
	print(self.Object)
	
	local ObjectOffsetMatrix = self.Object:GetOffsetMatrix()
	if (ObjectOffsetMatrix == nil) then
		ObjectOffsetMatrix = MatrixIdentity
	end
	
	-- Get data
	self.OffsetMatrix = ObjectOffsetMatrix * OffsetMatrix / self.Object1:GetMatrix();
	self.Object.ParentMultiply = false
end)

function MonsterTruckCarElement:Destroy()
	--
end

function MonsterTruckCarElement:SetMatrix()
	local FinalMatrix = self.OffsetMatrix * self.Object1:GetMatrix();

	self.Object:SetOffsetMatrix(FinalMatrix)
end 

function MonsterTruckCarElement:GetMatrix()
	return self.Object:GetOffsetMatrix() / self.Car.OffsetMatrix
end

function MonsterTruckCarElement:Update()
	self:SetMatrix()
end

function MonsterTruckCarElement:Render()
	--
end