-- Game modes
MonsterTruckCarSlidingElement = class(function(self, Car, Name, Object1, Object2)
	self.Car = Car
	self.Object1 = Object1
	self.Object2 = Object2
	
	-- Get object
	--print("Getting object " .. Name)
	self.Object = Car.Mesh:GetObject(Name)
	
	local ObjectOffsetMatrix = self.Object:GetOffsetMatrix()
	if (ObjectOffsetMatrix == nil) then
		ObjectOffsetMatrix = MatrixIdentity
	end
 
	-- Get data
	self.OffsetMatrix1 = --[[Car.OffsetMatrix * ]]ObjectOffsetMatrix / self.Object1:GetMatrix();
	self.OffsetMatrix2 = Car.OffsetMatrix * ObjectOffsetMatrix / self.Object2:GetMatrix();
	self.Object.ParentMultiply = false
end)

function MonsterTruckCarSlidingElement:Destroy()
	--
end

function MonsterTruckCarSlidingElement:SetMatrix()
	local FinalMatrix1 = self.OffsetMatrix1 * self.Object1:GetMatrix();
	local FinalMatrix2 = self.OffsetMatrix2 * self.Object2:GetMatrix();
	
	local FinalMatrix = FinalMatrix1:Lerp(FinalMatrix2, 0.5);

	self.Object:SetOffsetMatrix(FinalMatrix)
end 

function MonsterTruckCarSlidingElement:GetMatrix()
	return self.Object:GetOffsetMatrix()-- / self.Car.OffsetMatrix
end

function MonsterTruckCarSlidingElement:Update()
	self:SetMatrix()
end

function MonsterTruckCarSlidingElement:Render()
	--
end