PhysicsConfig = {}
PhysicsConfig.CFM = 0.000001
PhysicsConfig.ERP = 0.999

-- Game modes
MonsterTruckCarWheel = class(function(self, Car, Index)
	self.Car = Car
	--self.LimitIndex = math.ceil(Index / 2);
	--print(self.LimitIndex)
	
	self.LimitIndex = Index
	if (Index == 3 or Index == 4) then
		self.LimitIndex = 3
	end
	
	-- Get object
	self.Object = Car.Mesh:GetObject("Wheel_" .. Index)
	self.OffsetMatrix = self.Object:GetOffsetMatrix() * Car.OffsetMatrix
	--Car.Mesh:HideObject("Wheel_" .. Index)
	
	if (Index == 2) then
		self.DiscBrake_Object = Car.Mesh:GetObject("remschijf01")
	elseif (Index == 1) then
		self.DiscBrake_Object = Car.Mesh:GetObject("remschijf02")
	elseif (Index == 4) then
		self.DiscBrake_Object = Car.Mesh:GetObject("remschijf03")
	elseif (Index == 3) then
		self.DiscBrake_Object = Car.Mesh:GetObject("remschijf04")
	end
	if (self.DiscBrake_Object ~= nil) then
		self.DiscBrake_Object.ParentMultiply = false
	end
	
	-- Create Wheel mesh
	--[[ self.Mesh = CreateAdvancedMesh(nil, "Models\\Wheels\\Wheel_1.DCM", "")
	GetEntityScene():AddEntity(self.Mesh)
	self.Object = self.Mesh:GetObject("Wheel_1")

	-- Get data
	--self.OffsetMatrix = self.Object:GetOffsetMatrix() * Car.OffsetMatrix
	self.Object.ParentMultiply = false ]]
	--self:ChangeMesh("Wheel_1")
	self:ChangeMesh(self.Car.Car.WheelConfig.Model)
	
	if (self.Car.Car.WheelConfig.Scale == nil) then
		self.Car.Car.WheelConfig.Scale = 1
	end
	
	-- Physics
	self.Body = Body(GetPhysicsScene())
	self.Body:SetMass(50);
	self.Body:SetInertiaTensor(self.Object:GetExtents() * 5);
	self.Body:SetMatrix(self.OffsetMatrix);
	self.Body:Enable()
	
	-- Collision
	--self.Geometry = RayGeometry()
	--self.Geometry = BoxGeometry()
	self.Geometry = SphereGeometry()
	self.Geometry:SetOffsetMatrix(MatrixIdentity)
	--self.Geometry:SetOffsetMatrix(self.OffsetMatrix)
	self.Geometry:SetEntity(self.Mesh)
	self.Geometry:SetBody(self.Body)
	--self.Geometry:SetLength(self.Object:GetExtents().y * 2)
	--self.Geometry:SetExtents(self.Object:GetExtents())
	self.Geometry:SetRadius(self.Object:GetExtents().y * self.Car.Car.WheelConfig.Scale)
	
	self.Geometry:SetType(bit32.bor(DCGF_CARWHEEL, DCGF_REAL))
	self.Geometry:SetCollision(bit32.bor(DCGF_WORLD))
	self.Geometry:SetContactCallback(function(...)
		return self:OnContact(...)
	end)

	self.Geometry:Enable()
	GetPhysicsScene():AddGeometry(self.Geometry)


	-- Joint
	self.Joint = SliderJoint(GetPhysicsScene())
	self.Joint:Attach(Car.Body, self.Body)
	
	self.Joint:Enable()

	--self.Joint:SetAxis(Vector(0, -1, 0))
	if (Index == 1 or Index == 2) then
		self.Joint:SetAxis(Vector(0, 1, 0.0):Normalize())
	else
		self.Joint:SetAxis(Vector(0, 1, -0.3):Normalize())
	end
	self.Joint:SetBounciness(self.Car.WheelConfig.Bounciness);
	--self.Joint:SetForce(self.Car.WheelConfig.Force);
	self.Joint:SetLimitCFM(self.Car.WheelConfig.LimitCFM);
	self.Joint:SetLimitERP(self.Car.WheelConfig.LimitERP);
	self.Joint:SetLimits(self.Car.WheelConfig.Limits[self.LimitIndex][1], self.Car.WheelConfig.Limits[self.LimitIndex][2]);
	self.Joint:SetSliderCFM(self.Car.WheelConfig.SliderCFM);
	--self.Joint:SetVelocity(self.Car.WheelConfig.Velocity);
	self.Joint:SetFudgeFactor(self.Car.WheelConfig.FudgeFactor);
	
	self.Force = 0;
	self.KeyCode = GetKeyCode("DCK_" .. Index);
	--print("DCK_" .. Index)
	self.ContactTimer = 0;
	self.Contact = {}
	
	--self.WheelEffect = CreateEffectSystem("FX\\WheelEffect.xml")
	--self.WheelEffect:SetMatrix(self:GetMatrix())
	--self.Mesh:AddPlugin(self.WheelEffect, "", 1)
end)

function MonsterTruckCarWheel:Destroy()
	--self.Joint:Destroy()
	
	if (self.Joint ~= nil) then
		self.Joint:Destroy()
	end
	
	if (self.Geometry ~= nil) then
		self.Geometry:Destroy()
		self.Geometry = nil
	end
	
	if (self.Body ~= nil) then
		self.Body:Destroy()
		self.Body = nil
	end
	
	if (self.Mesh ~= nil) then
		--GetEntityScene():DelEntity(self.Mesh)
		--GetEntityScene():DestroyEntity(self.Mesh)	-- Crash! :(
		self.Mesh:Destroy()
		self.Mesh = nil
	end

	--self.Geometry:SetContactCallback(nil)
	--self.Body:Destroy()
	--self.Geometry:Destroy()
	
	--self.Mesh:Destroy()
end

function MonsterTruckCarWheel:DestroyInternal()
	if (self.Geometry ~= nil) then
		--self.Geometry:SetContactCallback(nil)
		--self.Geometry:Destroy()
		--self.Geometry = nil
	end
	
	if (self.Body ~= nil) then
		--self.Body:Destroy()
		--self.Body = nil
	end
end

function MonsterTruckCarWheel:SetMatrix(Matrix)
	local FinalMatrix = self.OffsetMatrix:Translate(Vector(0, -self.Car.WheelConfig.Limits[self.LimitIndex][1], 0)) * Matrix
	--local FinalMatrix = self.OffsetMatrix:Translate(Vector(0, -self.Car.WheelConfig.Limits[1][1], 0)) * Matrix
	--local FinalMatrix = MatrixIdentity:Translate(Vector(0, -self.Car.WheelConfig.Limits[1][1], 0)) * Matrix
	
	self.Body:SetMatrix(FinalMatrix)
	self.Object:SetOffsetMatrix(FinalMatrix)
	
	if (self.DiscBrake_Object ~= nil) then
		self.DiscBrake_Object:SetOffsetMatrix(FinalMatrix)
	end
	
	--if (self.WheelEffect ~= nil) then
		--self.WheelEffect:SetMatrix(FinalMatrix)
	--end
end

function MonsterTruckCarWheel:GetMatrix()
	return self.Body:GetMatrix()
end

function MonsterTruckCarWheel:IsWheelLoose()
	return (self.ContactTimer > 8)
end

function MonsterTruckCarWheel:ChangeMesh(Modelname)
	if (self.Mesh ~= nil) then
		--GetEntityScene():DelEntity(self.Mesh)
		--GetEntityScene():DestroyEntity(self.Mesh)
		self.Mesh:Destroy()
	end

	self.Mesh = CreateAdvancedMesh(nil, "Models\\Wheels\\" .. Modelname .. ".DCM", "")
	if (self.Mesh.DisableVisTest ~= nil) then
		self.Mesh:DisableVisTest()
	end
	GetEntityScene():AddEntity(self.Mesh)
	--self.Object = self.Mesh:GetObject("Wheel_2")
	self.Object = self.Mesh:GetObject(Modelname)
	
	self.Mesh:SetDestroyCallback(function(...)
		self:DestroyInternal(...)
	end)

	-- Get data
	--self.OffsetMatrix = self.Object:GetOffsetMatrix() * Car.OffsetMatrix
	self.Object.ParentMultiply = false
	
	if (self.Geometry ~= nil) then
		self.Geometry:SetEntity(self.Mesh)
	end
end

function MonsterTruckCarWheel:Update()
	local Matrix = self.Body:GetMatrix()
	local OrigMatrix = Matrix;
	--print(Matrix)
	--ListFunctions(Matrix)
	
	--if (self.Car.Car.WheelConfig.ScaleVector ~= nil) then
		Matrix = Matrix:ScaleLocal(VectorOne * self.Car.Car.WheelConfig.Scale)
	--end
	
	if (self.MotorForce ~= nil) then
		local MotorForce = 0    --self.Car.WheelConfig.MotorForce[self.LimitIndex]
		if (self.LimitIndex == 1 or self.LimitIndex == 2) then
			MotorForce = self.Car.WheelConfig.MotorForce[1]
		else
			MotorForce = self.Car.WheelConfig.MotorForce[2]
		end
	
		self.Force = Lerp(self.Force, self.MotorForce * MotorForce, self.Car.WheelConfig.MotorAttack);
	else
		self.Force = Lerp(self.Force, 0, self.Car.WheelConfig.MotorRelease);
	end
	
	if (win32()) then
		if (KeyPressed(GetKeyCode("DCK_UP"))) then
			self.Body:AddForce(self.Car:GetMatrix():GetDirection() * -self.Car.WheelConfig.AccelForce)
		end
		
		if (KeyPressed(GetKeyCode("DCK_DOWN"))) then
			self.Body:AddForce(self.Car:GetMatrix():GetDirection() * self.Car.WheelConfig.BrakeFace)
		end
	end
	
	--local InverseMatrix = Matrix:GetRotation():Inverse()
	--InverseMatrix:RotateLocal(VectorX, math.pi / 2);
	--self.Geometry:SetOffsetMatrix(InverseMatrix)
	
	if (not self:IsWheelLoose() and self.Force > 1) then
		
		if (self.Car.CenterForce) then
			--Try out for special move stuff
			local Pos = OrigMatrix:GetTranslation()
			Pos.z = Pos.z - (self.Object:GetExtents()).z
			--self.Body:AddForce(Vector(0, self.Force / 2, 0), Pos);
		
			self.Body:AddForce(Vector(0, self.Force * 1.4, 0), Matrix:GetTranslation() + VectorZero);
		else
			-- TODO: kan dit, ivm matrix scale hierboven?
			--self.Car.Body:AddForce(Vector(0, self.Force / 2, 0), Matrix:GetTranslation());
			
			self.Car.Body:AddForce(Vector(0, self.Force / 2, 0), OrigMatrix:GetTranslation());
		end
	end
	
	self.ContactTimer = self.ContactTimer + 1
	
	self.Object:SetOffsetMatrix(Matrix)
	
	if (self.DiscBrake_Object ~= nil) then
		self.DiscBrake_Object:SetOffsetMatrix(Matrix)
	end

	-- Debug
	if (win32() or self.Car.UpdateWheelConfig) then
		if (self.Joint:Enabled()) then
			self.Joint:SetBounciness(self.Car.WheelConfig.Bounciness);
			self.Joint:SetForce(self.Car.WheelConfig.Force);
			self.Joint:SetLimitCFM(self.Car.WheelConfig.LimitCFM);
			self.Joint:SetLimitERP(self.Car.WheelConfig.LimitERP);
			self.Joint:SetLimits(self.Car.WheelConfig.Limits[self.LimitIndex][1], self.Car.WheelConfig.Limits[self.LimitIndex][2]);
			self.Joint:SetSliderCFM(self.Car.WheelConfig.SliderCFM);
			self.Joint:SetVelocity(self.Car.WheelConfig.Velocity);
			self.Joint:SetFudgeFactor(self.Car.WheelConfig.FudgeFactor);
		end
	end
	
	GetPhysicsScene():SetCFM(PhysicsConfig.CFM);
	GetPhysicsScene():SetERP(PhysicsConfig.ERP);
	
	--if (self.Joint:GetPosition() > 8) then
		--print(self.Joint:GetPosition())
	--end
	
	if (self.Joint:Enabled()) then
		if (self.Joint:GetPosition() > 9.5) then
			self.Joint:SetForce(0)
			self.Joint:SetVelocity(0)
		end
	end
	
	
	self.Mesh:Update(Matrix, self.Body:GetVelocity(), self.Body:GetAngularVelocity())	--TODO
end

function MonsterTruckCarWheel:Render()
	self.Geometry:Render(color(0, 1, 0, 1))

	self.Joint:Render(color(0, 0, 1, 1))
end

function MonsterTruckCarWheel:AddForce(Force)
	self.Body:AddForce(Force)
end

function MonsterTruckCarWheel:OnContact(Entity, Pos, Normal, Depth)
	if (self.ContactTimer > 12) then
		self.Car:PlaySuspensionSound()
	end
	
	self.ContactTimer = 0;
	
	--TODO: waarden op het juiste moment setten ipv hier
	local Contact = self.Contact
	Contact.CFM = self.Car.WheelConfig.Contact.CFM;
	Contact.ERP = self.Car.WheelConfig.Contact.ERP
	Contact.Friction1 = self.Car.WheelConfig.Contact.Friction1
	Contact.Friction2 = self.Car.WheelConfig.Contact.Friction2
	Contact.Restitution = 1
	Contact.RestitutionThreshold = 0

	local FrictionRight = Normal:Cross(self.Car:GetMatrix():GetDirection() * -1):Normalize()
	Contact.FrictionDir = FrictionRight:Cross(Normal):Normalize();

	return Contact;
end