Names_Male = {"Jacob", "Mason", "William", "Jayden", "Noah", "Michael", "Ethan", "Alexander", "Aiden", "Daniel", "Anthony", "Matthew", "Elijah", "Bash", "Cyrus", "Tommy", "Evan", "Francesco", "Guy", "Henk", "Ian", "Jared", "Kurt", "Harry", "Phil"}
Names_Female = {"Sophia", "Isabella", "Emma", "Olivia", "Ava", "Emily", "Madison", "Mia", "Chloe", "Elizabeth", "Ella", "Addison", "Natalie", "Abby", "Keila", "Nysa", "Betsy"}
NamesPool_Male = {}
NamesPool_Female = {}

function GetRandomName(IsFemale)
	if (IsFemale) then
		if (#NamesPool_Male == 0) then
			NamesPool_Male = FillNamesPool(IsFemale)
		end
	else
		if (#NamesPool_Female == 0) then
			NamesPool_Female = FillNamesPool(IsFemale)
		end
	end
	
	local Name = ''
	
	if (IsFemale) then
		local Index = math.random(#NamesPool_Male)
		Name = NamesPool_Male[Index];
		table.remove(NamesPool_Male, Index)
	else
		local Index = math.random(#NamesPool_Female)
		Name = NamesPool_Female[Index];
		table.remove(NamesPool_Female, Index)
	end
	
	return Name
end


function FillNamesPool(IsFemale)
	local Pool = {}

	if (IsFemale) then
		for i, Name in ipairs(Names_Female) do
			table.insert(Pool, Name)
		end
	else
		for i, Name in ipairs(Names_Male) do
			table.insert(Pool, Name)
		end
	end
	
	return Pool
end