PickUpObject = class(function(self, WorldObject)
	self.WorldObject = WorldObject
	self.ObjectName = self.WorldObject:GetName();
	self.ObjectScoreValue = self.WorldObject:GetScore();
	
	--self.ObjectTime = self.WorldObject:GetTime();
	self.Destroyed = false
	
	-- Print initialized object names
	--print(self.WorldObject:GetName())
	
	--self.Thread = PhysicsThread:Spawn(function()
		-- Spawn stuff
	--end)
end)

InitPickupObjects = {}
PickUpObjectsManager = class(function(self)
	self.Objects = {} 			-- Each object name/type saved separately.
	
	for i, Object in ipairs(InitPickupObjects) do
		self:AddObject(Object)
	end
	InitPickupObjects = {}
	
	self.Score = 0
	
	--self.ObjectCount = {}		-- The amount of times each vehicle is hit, saved separately.
	--self.ScoreValues = {} 		-- The amount of points for each vehicle type.
	--self.Scores = {}			-- The total score for each destroyed vehicle type saved separately.
	--self.TotalScore = 0 		-- The total score of all scores added up
	--self.TotalObjectCount = 0	-- The total amount of objects that have been hit of all scores added up
end)

function PickUpObjectsManager:AddObject(Object)
	table.insert(self.Objects, Object)
end

function PickUpObjectsManager:Update(ElapsedTime)
	--print(ElapsedTime)
	--print(#self.Objects)
	
	for i, Object in ipairs(self.Objects) do
		--local Coin = self.Objects[1]
		
		--print(Object)
		if (Object ~= nil) then
			local ObjectMatrix = Object.WorldObject:GetMatrix()
			ObjectMatrix = ObjectMatrix:RotateLocal(Vector(0, 1, 0), 1.5 * ElapsedTime)
			Object.WorldObject:SetMatrix(ObjectMatrix)
		end
	end
end



function InitPickUpObject(WorldObject)
	print("InitPickUpObject")
	local Object = PickUpObject(WorldObject)
	
	table.insert(InitPickupObjects, Object)
	
	--if (ActiveMission ~= nil and ActiveMission.PickUpManager ~= nil) then
		--ActiveMission.PickUpManager:AddObject(Object)		
	--end
	
	return Object
end

function CollidePickUpObject(LuaObject, Entity)
	if(LuaObject.Destroyed == false)then
		local Name = LuaObject.ObjectName
		local Score = LuaObject.ObjectScoreValue
		
		if (ActiveMission ~= nil and ActiveMission.PickUpManager ~= nil) then
			ActiveMission.PickUpManager.Score = ActiveMission.PickUpManager.Score + Score
		end
		
		--local Time = LuaObject.ObjectTime
		
		print("Name = "..Name)
		print("Score = "..Score)
		--print("Name = "..(Name)..", score = "..(Score).." , time = "..(Time))
		
		LuaObject.Destroyed = true
		
		PhysicsThread:Spawn(function()
			PhysicsThread:Sleep(3)
			LuaObject.WorldObject:Hide()
		end)
	end
end