PowerManager = class(function(self)
	--print("PowerManager created")
	self.TotalCapacity = 10
	self.LastChargeTime = os.time()
	--self.Threshold = 10
	self.Threshold = 60 * GetFuelThreshold()
	self.Debug = false
	
	self.CurrentCapacity = self:GetTotalCapacity()
	
	self.LastRateDialog = 0
	
	self.LastOfferTime = os.time()
	--self.OfferThreshold = 10
	self.OfferThreshold = 60 * 60 --ieder uur?
	
	self.Stats_FreeFuelCounter = 0
	
	self.Thread = EngineThread:Spawn(function()
		while (true) do
			self:Update()
			--GameThread:Wait(30)
			EngineThread:Wait(1)
		end
		self.Thread = nil
	end)
end)

function PowerManager:Destroy()
	--print("PowerManager:Destroy()")
	if (self.Thread ~= nil) then
		EngineThread:Stop(self.Thread)
		self.Thread = nil
	end
end

function PowerManager:GetCurrentCapacity()
	return self.CurrentCapacity
end

function PowerManager:SetCurrentCapacity(amount)
	self.CurrentCapacity = amount
end

function PowerManager:GetTotalCapacity()
	return self.TotalCapacity
end

function PowerManager:SetTotalCapacity(amount)
	self.TotalCapacity = amount
end

function PowerManager:GetWaitTime()
	local CurrentTime = os.time()
	local NextChargeTime = (self.LastChargeTime + self.Threshold)
	local WaitTime = ClampMin((NextChargeTime - CurrentTime), 0)
	return WaitTime
end

function PowerManager:TotalRecharge()
	self.CurrentCapacity = self:GetTotalCapacity()
	
	if (ActiveForeground ~= nil and ActiveForeground.UpdateFuel ~= nil) then
		ActiveForeground:UpdateFuel()
	end
	
	WriteGameSettings()
end

function PowerManager:AddFuel(amount)
	self.CurrentCapacity = self:GetCurrentCapacity() + amount
	self:Update()

	print("Mijn fuel capacity is nu" .. tostring(self.CurrentCapacity))
	
	if (ActiveForeground ~= nil and ActiveForeground.UpdateFuel ~= nil) then
		ActiveForeground:UpdateFuel()
	end
	
	-- Is dit wel een goed idee?
	WriteGameSettings()
	
	return self.CurrentCapacity
end

function PowerManager:DecreaseFuel(amount)
	self.CurrentCapacity = self:GetCurrentCapacity() - amount

	if (self.CurrentCapacity < 0) then
		print("We restarten ondanks dat er geen fuel was!! Geforceerd via reloadscript oid?")
		self.CurrentCapacity = 0
	end

	self:Update()
	
	if (ActiveForeground ~= nil and ActiveForeground.UpdateFuel ~= nil) then
		ActiveForeground:UpdateFuel()
	end
	
	WriteGameSettings()
	
	return self.CurrentCapacity
end

function PowerManager:AddTimeCharge(ChargeTime)
	self.LastChargeTime = ChargeTime --os.time()

	print("We moeten nu gratis fuel krijgen")
	
	if (self.CurrentCapacity < self:GetTotalCapacity()) then
		print("Als er capacity is tenminste")
	
		local Amount = 1
		self.CurrentCapacity = ClampMinMax((self.CurrentCapacity + Amount), 0, self:GetTotalCapacity())
		self.Stats_FreeFuelCounter = self.Stats_FreeFuelCounter + Amount
		
		if (ActiveForeground ~= nil and ActiveForeground.UpdateFuel ~= nil) then
			ActiveForeground:UpdateFuel()
		end
		
		WriteGameSettings()
		
		if (self.Debug) then
			--print("^5Free Charge!")
		end
	end
end

function PowerManager:CheckTimeCharge()
	local CurrentTime = os.time()
	local NextChargeTime = (self.LastChargeTime + self.Threshold)
	
	if (self.Debug) then
		--print("PowerManager:CheckTimeCharge: ")
		--print("CurrentTime: " .. os.date("%d/%m/%Y %H:%M:%S", CurrentTime) .. " (" .. CurrentTime .. ")")
		--print("NextChargeTime: " .. os.date("%d/%m/%Y %H:%M:%S", NextChargeTime) .. " (" .. NextChargeTime .. ")")
	end
	
	while (CurrentTime > NextChargeTime) do
		print("PowerManager: Let op, we gaan nu een charge toevoegen zogenaamd ")
		print("CurrentTime: " .. os.date("%d/%m/%Y %H:%M:%S", CurrentTime) .. " (" .. CurrentTime .. ")")
		print("NextChargeTime: " .. os.date("%d/%m/%Y %H:%M:%S", NextChargeTime) .. " (" .. NextChargeTime .. ")")

		self:AddTimeCharge(NextChargeTime)
		NextChargeTime = (self.LastChargeTime + self.Threshold)
		
		if (self.CurrentCapacity == self:GetTotalCapacity()) then
			--Full capacity
			self.LastChargeTime = CurrentTime
			break
		end
		
		if (self.Debug) then
			--print("NextChargeTime: " .. os.date("%d/%m/%Y %H:%M:%S", NextChargeTime) .. " (" .. NextChargeTime .. ")")
		end
	end
end

function PowerManager:CheckRateGame()
	if (ActiveMenu ~= nil) then
		local TotalGamesPlayed = 0
		for i, GameMode in ipairs(GameModes) do
			for j, Chapter in ipairs(GameMode.Chapters) do
				for k, Race in ipairs(Chapter.Races) do
					TotalGamesPlayed = TotalGamesPlayed + Race.WinCount + Race.LoseCount
				end
			end
		end
		
		if (self.LastRateDialog ~= TotalGamesPlayed) then
			if (TotalGamesPlayed >= 5 and TotalGamesPlayed >= self.LastRateDialog + 5) then
				self.LastRateDialog = TotalGamesPlayed
				
				GameThread:Spawn(function()
					GameThread:Sleep(0.3)
					if (GetPlatform() == "Android" or GetPlatform() == "Win32") then
						ShowConfirm_GoogleRateGame()
					elseif (GetPlatform() == "IOS") then
						ShowConfirm_iOSRateGame()
					end
				end)
			end
		end
	end
end

function PowerManager:Check5DaysOffer()
	if (LastTimePlayed ~= nil) then
		local Diff = os.time() - LastTimePlayed
		
		local Day = (60 * 60 * 24)
		--local Day = 5
		local OfferDayLimit = 5
		
		if (ActiveMenu ~= nil) then
			if (ActiveMission:is_a(MenuMission) and ActiveMenu ~= nil and not ActiveMenu:is_a(ConfirmMenu) and not ActiveMenu:is_a(IntroMenu) and not ActiveMenu:is_a(LogoMenu)) then
				if (Diff > (Day * OfferDayLimit)) then
					print("Show 5 days offer")
					LastTimePlayed = os.time()
					
					if (true) then
						LastTimePlayed = LastTimePlayed + (60 * 60 * 24 * 1000)
					end
					
					local FreeCoins = 1000
					ShowConfirm_5DaysIdle(FreeCoins)
				end
			end
		end
	end
end

function PowerManager:CheckTimeSpecialOffer()
	local CurrentTime = os.time()
	local NextOfferTime = (self.LastOfferTime + self.OfferThreshold)
	
	if (self.Debug) then
		print("PowerManager:CheckTimeSpecialOffer: ")
		print("CurrentTime: " .. os.date("%d/%m/%Y %H:%M:%S", CurrentTime) .. " (" .. CurrentTime .. ")")
		print("NextOfferTime: " .. os.date("%d/%m/%Y %H:%M:%S", NextOfferTime) .. " (" .. NextOfferTime .. ")")
	end
	
	while (CurrentTime > NextOfferTime) do
		self:ShowSpecialOffer(NextOfferTime)
		NextOfferTime = (self.LastOfferTime + self.OfferThreshold)
		
		if (self.Debug) then
			print("NextOfferTime: " .. os.date("%d/%m/%Y %H:%M:%S", NextOfferTime) .. " (" .. NextOfferTime .. ")")
		end
	end
end

function PowerManager:ShowSpecialOffer(OfferTime)
	self.LastOfferTime = OfferTime
	
	if (self.Debug) then
		--print("ShowSpecialOffer")
	end
	
	local Rand = math.random(0, 100)
	if (Rand <= 40) then		--40% kans op auto
		if (self.Debug) then
			--print("ShowSpecialOffer: Car")
		end
		
		local Car = self:GetRandomDiscountedCar()
		local Discount = 0.25
		local FinalPrice = Car.ShopPriceCoins * (1 - ClampMinMax(Discount, 0, 1))
		
		if (FinalPrice > 0 and VirtualCoins:GetCoinCount() >= FinalPrice) then
			Car.DiscountOffered = true
			ShowConfirm_SpecialOffer_Car(Car, Discount, FinalPrice)
		end
	elseif (Rand <= 80) then	--40% kans op track
		if (self.Debug) then
			--print("ShowSpecialOffer: Track")
		end
		
		--[[local Track = self:GetRandomDiscountedTrack()
		local Discount = 0.25
		local FinalPrice = Track.ShopPriceCoins * (1 - ClampMinMax(Discount, 0, 1))
		
		if (FinalPrice > 0 and VirtualCoins:GetCoinCount() >= FinalPrice) then
			Track.DiscountOffered = true
			ShowConfirm_SpecialOffer_Track(Track, Discount, FinalPrice)
		end]]
	else						--Overige 20% kans op wheel/accu/suspension
		if (self.Debug) then
			--print("ShowSpecialOffer: Other")
		end
		
		local RandItem = math.random(0, 2)
		--[[
		if (RandItem == 0) then	--Wheel
			local Wheel = GetRandomDiscountedWheel
			local Discount = 0.25
			local FinalPrice = Wheel.ShopPriceCoins * (1 - ClampMinMax(Discount, 0, 1))
			
			if (FinalPrice > 0 and VirtualCoins:GetCoinCount() >= FinalPrice) then
				Wheel.DiscountOffered = true
				ShowConfirm_SpecialOffer_Wheel(Wheel, Discount, FinalPrice)
			end
		elseif (RandItem == 1) then	--Battery
			if (UpgradeItem_Battery:Available() and #UpgradeItem_Battery.Deliveries == 0 and not UpgradeItem_Battery.DiscountOffered) then
				local Price = UpgradeItem_Battery:GetPrice()
				local Discount = 0.25
				local FinalPrice = Price * (1 - ClampMinMax(Discount, 0, 1))
				
				if (FinalPrice > 0 and VirtualCoins:GetCoinCount() >= FinalPrice) then
					UpgradeItem_Battery.DiscountOffered = true
					ShowConfirm_SpecialOffer_UpgradeItem(UpgradeItem_Battery, Discount, FinalPrice)
				end
			end
		elseif (RandItem == 2) then --Suspension
			if (UpgradeItem_Hydraulics:Available() and #UpgradeItem_Hydraulics.Deliveries == 0 and not UpgradeItem_Hydraulics.DiscountOffered) then
				local Price = UpgradeItem_Hydraulics:GetPrice()
				local Discount = 0.25
				local FinalPrice = Price * (1 - ClampMinMax(Discount, 0, 1))
				
				if (FinalPrice > 0 and VirtualCoins:GetCoinCount() >= FinalPrice) then
					UpgradeItem_Hydraulics.DiscountOffered = true
					ShowConfirm_SpecialOffer_UpgradeItem(UpgradeItem_Hydraulics, Discount, FinalPrice)
				end
			end
		end]]
	end
end

function PowerManager:GetRandomDiscountedCar(Attempt)
	if (Attempt == nil) then
		Attempt = 0
	end

	if (Attempt < 5) then
		local RandIndex = math.random(1, #MonsterTruckCars.Cars)
		local Car = MonsterTruckCars.Cars[RandIndex]
		if (not Car.DiscountOffered and not Car.Bought) then
			return Car
		else
			return self:GetRandomDiscountedCar(Attempt + 1)
		end
	end
	
	return nil
end

function PowerManager:GetRandomDiscountedTrack(Attempt)
	if (Attempt == nil) then
		Attempt = 0
	end

	if (Attempt < 5) then
		local Races = ActiveGameMode.ActiveChapter.Races
	
		local RandIndex = math.random(1, #Races)
		local Track = Races[RandIndex]
		if (not Track.DiscountOffered and not Track.Bought) then
			return Track
		else
			return self:GetRandomDiscountedTrack(Attempt + 1)
		end
	end
	
	return nil
end

function PowerManager:GetRandomDiscountedWheel(Attempt)
	if (Attempt == nil) then
		Attempt = 0
	end

	if (Attempt < 5) then
		local RandIndex = math.random(1, #MonsterTruckCars.Wheels)
		local Wheel = MonsterTruckCars.Cars[RandIndex]
		if (not Wheel.DiscountOffered and not Wheel.Bought) then
			return Wheel
		else
			return self:GetRandomDiscountedWheel(Attempt + 1)
		end
	end
	
	return nil
end

function PowerManager:Update()
	if (self.Debug) then
		--print("PowerManager:Update: " .. FuelPower)
	end
	
	self:CheckTimeCharge()
	
	if (PlayerHasCar()) then
		if (ActiveMission ~= nil and ActiveMenu ~= nil and not VirtualCoins.IsRated) then
			--if (ActiveMission:is_a(MenuMission) and not ActiveMenu:is_a(ConfirmMenu) and not ActiveMenu:is_a(IntroMenu) and not ActiveMenu:is_a(LogoMenu)) then
			if (ActiveMission:is_a(MenuMission) and ActiveMenu:is_a(CarSelect)) then
				self:CheckRateGame()
				--self:Check5DaysOffer()
				--self:CheckTimeSpecialOffer()
			end
		end
	end
	
	FuelPower = (self:GetTotalCapacity() / self:GetCurrentCapacity())
	
	--Check deliveryTime - Track
	for i, Race in ipairs(ActiveGameMode.ActiveChapter.Races) do
		if (Race.Bought and not Race.Available) then
				
			----print(Race.Name)
			
			local CurrentTime = os.time()
			if (Race.DeliveryTime ~= nil) then
				local WaitTime = Race.DeliveryTime - CurrentTime
				
				if (WaitTime <= 0) then
					Race.Available = true
					
					if (Race.ShowPopup) then
						print("show popup, Race is beschikbaar nu")	
						local Popup = {ConfirmMenu, Race}
						table.insert(UnlockPopups, Popup)
					end
				end
				----print(WaitTime)
			end
		end
	end
	
	--Check deliveryTime - Car
	for i, CarClass in ipairs(ActiveGameMode.CarClasses) do
		for j, Car in ipairs(CarClass.Cars) do
			if (Car.Bought and not Car.Available) then
				
				--print(Car.Name)
				
				local CurrentTime = os.time()
				if (Car.DeliveryTime ~= nil) then
					local WaitTime = Car.DeliveryTime - CurrentTime
					
					if (WaitTime <= 0) then
						Car.Available = true
						
						if (Car.ShowPopup) then
							print("show popup, car is beschikbaar nu")	
							local Popup = {ConfirmMenu, Car}
							table.insert(UnlockPopups, Popup)
						end
					end
					--print(WaitTime)
				end
			elseif (Car.Bought and Car.Available) then
				--Check deliveryTime - UpgradeItems
				for i, ShopUpgradeItem in ipairs(ShopUpgradeItems) do
					ShopUpgradeItem:CheckDeliveries(Car)
				end
			end
		end
	end
	
	--Check deliveryTime - Wheel
	for i, CarClass in ipairs(ActiveGameMode.CarClasses) do
		for i, Wheel in ipairs(CarClass.Wheels) do
			if (Wheel.Bought and not Wheel.Available) then
				--print(Wheel.Name)
				
				local CurrentTime = os.time()
				if (Wheel.DeliveryTime ~= nil) then
					local WaitTime = Wheel.DeliveryTime - CurrentTime
					
					if (WaitTime <= 0) then
						Wheel.Available = true
						
						if (Wheel.ShowPopup) then
							print("show popup, wheel is beschikbaar nu")	
							local Popup = {ConfirmMenu, Wheel}
							table.insert(UnlockPopups, Popup)
						end
					end
					--print(WaitTime)
				end
			end
		end
	end
	
	
	
	--Show UnlockPopups
	if (ActiveMission:is_a(MenuMission) and #UnlockPopups ~= 0 and not ActiveMenu:is_a(ConfirmMenu) and not ActiveMenu:is_a(IntroMenu) and not ActiveMenu:is_a(LogoMenu)) then
		local Popup = UnlockPopups[1]
		table.remove(UnlockPopups, 1)
		
		if (Popup and Popup[1] ~= nil and Popup[2] ~= nil) then
			PreviousMenu = ActiveMenu
			
			if (Popup[2]:is_a(Mission)) then
				local Race = Popup[2]
				if (Race.ShowPopup) then
					local Text = "^3" .. Translate(Race.Title)
					
					--print("hier track popup laten zien")
					--print(Text)
				
					ActiveMenu = Popup[1](PreviousMenu)
					ActiveMenu:SetTitle(Translate("confirm_delivery_track_title"))
					ActiveMenu:SetText(string.format(Translate("confirm_delivery_track_shorttext"), Text))
					ActiveMenu:SetCharacter(CharacterTextures["Johnny"], Translate("Character_Johnny"))
					ActiveMenu:SetProceedText(Translate("menu_showme"))
					ActiveMenu:SetCancelText(Translate("menu_thanks"))
					
					ActiveMenu.YesButtonPanel:Clear()
					
					ActiveMenu.CancelAction = function()
						GameThread:Spawn(function()
							--[[ if (ActiveMenu:is_a(TrackSelect)) then
								local Item = ActiveMenu.Items_Missions:GetSelection()
								if (Item ~= nil and Item.UpdateInfo ~= nil) then
									ActiveMenu.Items_Missions:GetSelection():UpdateInfo()
								end
								
								ActiveMenu:UpdateRaces()
							end ]]
						end)
					end
					
					ActiveMenu.ProceedAction = function()
						GameThread:Spawn(function()
							--[[ if (ActiveMenu:is_a(TrackSelect)) then
								local Item = ActiveMenu.Items_Missions:GetSelection()
								if (Item ~= nil and Item.UpdateInfo ~= nil) then
									ActiveMenu.Items_Missions:GetSelection():UpdateInfo()
								end
								
								ActiveMenu:UpdateRaces()
							end ]]
							
							--
						end)
					end
				end
			elseif (Popup[2]:is_a(Car)) then
				local Car = Popup[2]
				local CarAlreadyShowing = false
				
				if (ActiveMenu:is_a(Garage) or ActiveMenu:is_a(CarSelect)) then
					CarAlreadyShowing = true
				end
				
				--if (ActiveMenu:is_a(Garage)) then
					--local ShowingCar = ActiveMission.CarManager:GetCarSelection()
					--if (Car == ShowingCar) then
						--CarAlreadyShowing = true
					--end
				--end
				
				if (Car.ShowPopup and not CarAlreadyShowing) then
					local Text = "^3" .. Translate(Car.Title)
					
					--print(Text)
				
					ActiveMenu = Popup[1](PreviousMenu)
					ActiveMenu:SetTitle(Translate("confirm_delivery_car_title"))
					ActiveMenu:SetText(string.format(Translate("confirm_delivery_car_text"), Text))
					ActiveMenu:SetCharacter(CharacterTextures["Johnny"], Translate("Character_Johnny"))
					ActiveMenu:SetProceedText(Translate("menu_showme"))
					ActiveMenu:SetCancelText(Translate("menu_nothanks"))
					
					ActiveMenu.CancelAction = function()
						GameThread:Spawn(function()
							if (ActiveMenu:is_a(CarSelect)) then
								Active:ShowMenu()
							end
						end)
					end
					
					ActiveMenu.ProceedAction = function()
						GameThread:Spawn(function()
							ActiveMission.CarManager:SaveCarSelection(Car)
							
							ActiveMenu = CarSelect(GameModeSelect, Car)
							PreviousMenu:HideMenu()
						
							if (PreviousMenu.DeleteButtons ~= nil) then
								PreviousMenu:DeleteButtons()
							end
						end)
					end
					
					
					--[[ ActiveMenu.CancelAction = function()
						GameThread:Spawn(function()
							if (ActiveMenu:is_a(Garage)) then
								--ActiveMenu:ShowCategoryButtons()
								ActiveMenu:UpdateCategoryButtons()
							end
						end)
					end
					
					ActiveMenu.ProceedAction = function()
						GameThread:Spawn(function()
							ActiveMission.CarManager:SaveCarSelection(Car)
							
							if (ActiveMenu:is_a(Garage)) then
								ActiveMenu:ShowCategoryButtons()
								
								ActiveMenu:ShowCar(Car)
							end
							
							if (not ActiveMenu:is_a(Garage)) then
								ActiveMenu = Garage(GameModeSelect, Car)
								PreviousMenu:HideMenu()
							
								if (PreviousMenu.DeleteButtons ~= nil) then
									PreviousMenu:DeleteButtons()
								end
							end
						end)
					end ]]
				end
			elseif (Popup[2]:is_a(Wheel)) then
				local Wheel = Popup[2]
				if (Wheel.ShowPopup) then
					local Text = "^3" .. Translate(Wheel.Title)
					
					--print(Text)
					
					ActiveMenu = Popup[1](PreviousMenu)
					ActiveMenu:SetTitle(Translate("confirm_delivery_wheel_title"))
					ActiveMenu:SetText(string.format(Translate("confirm_delivery_wheel_text"), Text))
					ActiveMenu:SetCharacter(CharacterTextures["Johnny"], Translate("Character_Johnny"))
					ActiveMenu:SetProceedText(Translate("menu_showme"))
					ActiveMenu:SetCancelText(Translate("menu_nothanks"))
					--ActiveMenu:SetCancelText(Translate("menu_thanks"))
					--ActiveMenu.YesButtonPanel:Clear()
					
					ActiveMenu.CancelAction = function()
						GameThread:Spawn(function()
							if (ActiveMenu:is_a(Garage)) then
								if (ActiveMenu.UpdateCarButtons ~= nil) then
									ActiveMenu:UpdateCarButtons()
								end
								if (ActiveMenu.UpdateWheelButtons ~= nil) then
									ActiveMenu:UpdateWheelButtons()
								end
							end
						end)
					end
					
					ActiveMenu.ProceedAction = function()
						GameThread:Spawn(function()
							if (ActiveMenu:is_a(Garage)) then
								local BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
								
								local MenuItem = ActiveMenu.Items_Wheels.BackButton
								BottomBarItems:DelItem(MenuItem.Item)
								MenuItem.Item:Destroy()
								
								local MenuItem = ActiveMenu.Items_Wheels.ProceedButton
								BottomBarItems:DelItem(MenuItem.Item)
								MenuItem.Item:Destroy()
								
								ActiveMenu.Items_Wheels = nil
							end
						
							if (not ActiveMenu:is_a(Garage)) then
								ActiveMenu = Garage(MainMenu)
								PreviousMenu:HideMenu()
							
								if (PreviousMenu.DeleteButtons ~= nil) then
									PreviousMenu:DeleteButtons()
								end
							end
							
							if (ActiveMenu.Items_Categories ~= nil) then
								ActiveMenu:HideCategoryButtons()
							end
							ActiveMenu:ShowWheelButtons()
							
							ActiveMenu:ChangeWheel(Wheel)
							
							local Wheels_Sorted = table.copy(MonsterTruckCars.Wheels)
							for i, Wheel in ipairs(Wheels_Sorted) do
								Wheel.OrderIndex = i
							end
							table.sort(Wheels_Sorted, Cars_Sort)
							
							ActiveMenu.ActiveItemList:DeactivateSelection()
							ActiveMenu.Items_Wheels.Active = IndexInTable(Wheels_Sorted, Wheel)
							ActiveMenu.ActiveItemList:ActivateSelection()
							
							if (ActiveMenu.UpdateCarButtons ~= nil) then
								ActiveMenu:UpdateCarButtons()
							end
							if (ActiveMenu.UpdateWheelButtons ~= nil) then
								ActiveMenu:UpdateWheelButtons()
							end
						end)
					end
				end
			elseif (Popup[2]:is_a(ShopUpgradeItem)) then
				
				--print("^2----------------------------------------")
				--print("^2ShopUpgradeItem popup")
				
				local Name = Popup[2].Name
				local Level = Popup[3]
				local ExtraBoughtText = Popup[4]
				--print(Name .. ": - Level: " .. Level)
				--print(ExtraBoughtText)
				--print("^2----------------------------------------")
				
				local Text = Translate(Name) .. " " .. Translate(Popup[2]:GetItemLevel(Level).Name) .. Translate("newline") .. ExtraBoughtText
				--local Text = Translate(Name) .. " " .. Translate(Popup[2]:GetItemLevel(Level).Name) .. Translate("newline")
				
				ActiveMenu = Popup[1](PreviousMenu)
				ActiveMenu:SetTitle(Translate("confirm_delivery_item_title"))
				ActiveMenu:SetText(string.format(Translate("confirm_delivery_item_text"), Text))
				ActiveMenu:SetCharacter(CharacterTextures["Johnny"], Translate("Character_Johnny"))
				ActiveMenu:SetProceedText(Translate("menu_showme"))
				ActiveMenu:SetCancelText(Translate("menu_thanks"))
				
				if (Popup[2].Name == "upgrade_hydraulics") then
					if (PreviousMenu:is_a(Garage_Hydraulics)) then
						ActiveMenu.YesButtonPanel:Clear()
					end
				else
					if (PreviousMenu:is_a(Garage_Battery)) then
						ActiveMenu.YesButtonPanel:Clear()
					end
				end
				
				ActiveMenu.CancelAction = function()
					GameThread:Spawn(function()
						--if (ActiveMenu:is_a(Garage)) then
							--ActiveMenu:UpdateCarButtons()
							--ActiveMenu:UpdateWheelButtons()
						--end
						
						if (ActiveMenu.UpdateButtons ~= nil) then
							ActiveMenu:UpdateButtons()
						end
						
						if (ActiveMenu.CalcStats ~= nil) then
							ActiveMenu:CalcStats()
						end
					end)
				end
				
				if (Popup[2].Name == "upgrade_hydraulics") then
					ActiveMenu.ProceedAction = function()
						GameThread:Spawn(function()
							if (not PreviousMenu:is_a(Garage_Hydraulics)) then
								ActiveMenu = Garage_Hydraulics(Garage)
								PreviousMenu:HideMenu()
							
								if (PreviousMenu.DeleteButtons ~= nil) then
									PreviousMenu:DeleteButtons()
								end
							end
							
							if (ActiveMenu.UpdateButtons ~= nil) then
								ActiveMenu:UpdateButtons()
							end
							
							if (ActiveMenu.CalcStats ~= nil) then
								ActiveMenu:CalcStats()
							end
						end)
					end
				else
					ActiveMenu.ProceedAction = function()
						GameThread:Spawn(function()
							if (not PreviousMenu:is_a(Garage_Battery)) then
								ActiveMenu = Garage_Battery(Garage)
								PreviousMenu:HideMenu()
							
								if (PreviousMenu.DeleteButtons ~= nil) then
									PreviousMenu:DeleteButtons()
								end
							end
							
							if (ActiveMenu.UpdateButtons ~= nil) then
								ActiveMenu:UpdateButtons()
							end
							
							if (ActiveMenu.CalcStats ~= nil) then
								ActiveMenu:CalcStats()
							end
						end)
					end
				end
			else
				ActiveMenu = Popup[1](PreviousMenu, Popup[2])
				ActiveMenu:ShowMenu()
			end
		end
	end
end

function PowerManager:IsPowerAvailable()
	if (self:GetCurrentCapacity() > 0) then
		return true
	else
		return false
	end
end

function PowerManager:SendFuelStats(BoughtFuel, FreeFuel, CoinsUsed, GearsUsed)
	print("PowerManager:SendFuelStats")

	-- Send Fuel Stats
	
	local FailureFunction = function(Data)
		print("Error sending fuel stats")
	end
	
	local SuccessFunction = function(Data)
		print('OnAddFuelStats')
	end
	
	local UserID = 0
	if (FBManager:IsLoginValid()) then
		UserID = FBManager.UserinfoTable['HighscoresID']
	else
		UserID = Scores.UserID
	end
	
	ScoresUser:AddFuelStats(UserID, BoughtFuel, FreeFuel, CoinsUsed, GearsUsed, SuccessFunction, FailureFunction)
end

-- ============

