FileVersion = 9
OnlineVersion = 1
Playername = "Player"
FirstPlayOffer = false
FirstCarBought = false
MechanicActiveRaces = 0
LastTimePlayed = nil
TutorialsEnabled = true
FxVolume = getvar("fxvolume")
MusicVolume = getvar("musicvolume")
StartTime = os.time()
DailyMissionsManager.CurrentMission = 1
RedeemCodeValid = false


LastTimeReward = nil
DayCounter = 0

function GetPlayername()
	--if (GetPlatform() == "IOS" or GetPlatform() == "Android") then
		return Playername
	--[[ else
		return "Player"
	end ]]--
end

function SetPlayername(Name)
	--if (GetPlatform() == "IOS" or GetPlatform() == "Android") then
		Playername = Name
		
		--print("Setting playername")
	--[[ else
		
	end ]]--
end

function ReadGameSettings()
	local File = CreateFile("Progress.DAT", "Read")
	
	if (File == nil) then
		ReadOnlineProgress()
		return
	end
	
	local Version = File:ReadInt()
	if (Version ~= FileVersion) then
		local Message = "Progress.DAT is old"
		--MessageBox("Warning", Message)
		
		--return
	end
	
	if (Version > 4) then
		OnlineVersion = File:ReadInt()
	end
	
	FirstPlayOffer = File:ReadBoolean()
	FirstCarBought = File:ReadBoolean()
	MechanicActiveRaces = File:ReadInt()
	
	local Time = File:ReadInt()
	if (LastTimePlayed == nil) then
		LastTimePlayed = Time
	end
	--print("READ LastTimePlayed: " .. os.date("%d/%m/%Y %H:%M:%S", LastTimePlayed))
	
	StartTime = File:ReadInt()
	if (StartTime == nil) then
		StartTime = os.time()
	end
	
	DailyMissionsManager.CurrentMission = File:ReadInt()
	
	local CoinCount = File:ReadInt()
	local GoloCoinCount = File:ReadInt()
	VirtualCoins:SetCoinCount(CoinCount)
	VirtualCoins:SetGoloCoinCount(GoloCoinCount)
	VirtualCoins.IsRated = File:ReadBoolean()
	VirtualCoins.IsLiked_Game = File:ReadBoolean()
	VirtualCoins.IsLiked_Developer = File:ReadBoolean()
	VirtualCoins.IsVisited_Website = File:ReadBoolean()
	
	if (Version > 4) then
		VirtualCoins.IsFirst_Facebook = File:ReadBoolean()
	end
	
	MJCoinEarned = File:ReadBoolean()
	
	if (Version > 5) then
		RedeemCodeValid = File:ReadBoolean()
	end
	
	--Daily Rewards
	if (Version > 8) then
		LastTimeReward = File:ReadInt()
		DayCounter = File:ReadInt()
	end
	
	local TotalCapacity = File:ReadInt()
	local CurrentCapacity = File:ReadInt()
	local LastChargeTime = File:ReadInt()
	local LastRateDialog = File:ReadInt()
	local Stats_FreeFuelCounter = 0
	if (Version > 5) then
		Stats_FreeFuelCounter = File:ReadInt()
	end
	
	local ZogenaamdeChargeTijd = os.date("%d/%m/%Y %H:%M:%S", LastChargeTime)
	
	--print("De laatste keer dat we hebben opgeladen volgens de savegame is " .. ZogenaamdeChargeTijd)
	
	if (FuelEnergy == nil) then
		FuelEnergy = PowerManager()
	end
	
	if (FuelEnergy ~= nil) then
		FuelEnergy.TotalCapacity = TotalCapacity
		FuelEnergy.CurrentCapacity = ClampMin(CurrentCapacity, 0)
		FuelEnergy.LastChargeTime = LastChargeTime
		FuelEnergy.LastRateDialog = LastRateDialog
		FuelEnergy.Stats_FreeFuelCounter = Stats_FreeFuelCounter
		
		--print("Read fuel; " .. tostring(FuelEnergy.CurrentCapacity))
	end
	
	TutorialsEnabled = File:ReadBoolean()
	FxVolume = File:ReadFloat()
	MusicVolume = File:ReadFloat()

	ShopUpgrades_Read(File, Version)
	DailyMissions_Read(File, Version)
	FBManager:Read(File, Version)
	PowerUps_Read(File, Version)
	
	Scores:Read(File, Version)
	
	SetPlayername(File:ReadString())
	
	local CarClassCount = File:ReadInt()
	for i = 1, #CarClasses do
		CarClasses[i]:Read(File, Version)
	end
	
	
	for i = 1, #GameModes do
		if (GameModes[i] ~= nil) then
			GameModes[i]:Read(File, Version)
		end
	end
	
	--SelectedCharacter = Characters[File:ReadInt() + 1]
	
	File:Close();
	
	ReadOnlineProgress()
end

function WriteGameSettings(SendProgress)
	if (SendProgress == nil) then
		SendProgress = true
		OnlineVersion = OnlineVersion + 1
	end

	print("WriteGameSettings")
	local File = CreateFile("Progress.DAT", "Write")
	
	if (File == nil) then
		return
	end
	
	File:WriteInt(FileVersion)
	
	File:WriteInt(OnlineVersion)
	
	File:WriteBoolean(FirstPlayOffer)
	File:WriteBoolean(FirstCarBought)
	File:WriteInt(MechanicActiveRaces)
	
	--LastTimePlayed = os.time()
	--File:WriteInt(os.time())	--LastTimePlayed
	
	local Time = os.time()
	if (LastTimePlayed ~= nil) then
		Time = Max(Time, LastTimePlayed)
	end
	File:WriteInt(Time)	--LastTimePlayed
	
	print("WRITE LastTimePlayed: " .. os.date("%d/%m/%Y %H:%M:%S", os.time()))
	
	File:WriteInt(StartTime)
	File:WriteInt(DailyMissionsManager.CurrentMission);
	
	local CoinCount = VirtualCoins.CoinCount
	local GoloCoinCount = VirtualCoins.GoloCoinCount
	File:WriteInt(CoinCount)
	File:WriteInt(GoloCoinCount)
	File:WriteBoolean(VirtualCoins.IsRated)
	File:WriteBoolean(VirtualCoins.IsLiked_Game)
	File:WriteBoolean(VirtualCoins.IsLiked_Developer)
	File:WriteBoolean(VirtualCoins.IsVisited_Website)
	File:WriteBoolean(VirtualCoins.IsFirst_Facebook)
	
	File:WriteBoolean(MJCoinEarned)
	
	File:WriteBoolean(RedeemCodeValid)
	
	--Daily Rewards
	File:WriteInt(LastTimeReward)
	File:WriteInt(DayCounter)
	
	local TotalCapacity = 0
	local CurrentCapacity = 0
	local LastChargeTime = os.time()
	local LastRateDialog = 0
	local Stats_FreeFuelCounter = 0
	
	if (FuelEnergy ~= nil) then
		TotalCapacity = FuelEnergy.TotalCapacity
		CurrentCapacity = FuelEnergy.CurrentCapacity
		LastChargeTime = FuelEnergy.LastChargeTime		
		LastRateDialog = FuelEnergy.LastRateDialog		
		Stats_FreeFuelCounter = FuelEnergy.Stats_FreeFuelCounter		
	end
	
	File:WriteInt(TotalCapacity)
	File:WriteInt(CurrentCapacity)
	File:WriteInt(LastChargeTime)
	File:WriteInt(LastRateDialog)
	File:WriteInt(Stats_FreeFuelCounter)
	
	File:WriteBoolean(TutorialsEnabled)
	File:WriteFloat(FxVolume)
	File:WriteFloat(MusicVolume)
	
	ShopUpgrades_Write(File)
	DailyMissions_Write(File)
	FBManager:Write(File)
	PowerUps_Write(File)
	
	Scores:Write(File, FileVersion)
	
	File:WriteString(GetPlayername())
	
	File:WriteInt(#CarClasses)
	for i = 1, #CarClasses do
		CarClasses[i]:Write(File)
	end
	
	for i = 1, #GameModes do
		if (GameModes[i] ~= nil) then
			GameModes[i]:Write(File)
		end
	end
	
	--File:WriteInt(IndexInTable(Characters, SelectedCharacter));
	
	File:Close();
	print("/WriteGameSettings")
	
	if (SendProgress) then
		SendOnlineProgress()
	end
end

if (GetKeychainValue == nil) then
	function GetKeychainValue(Key)
		--return 5
		
		local OutFile = CreateFile("KeychainIOS.txt", "Read")
		if (OutFile ~= nil) then
			local Key = OutFile:ReadString()
			local Value = OutFile:ReadString()
			OutFile:Close()
			return Value
		end
		return nil
	end
end

if (CreateKeychainValue == nil) then
	function CreateKeychainValue(Key, Value)
		local OutFile = CreateFile("KeychainIOS.txt", "Write")
		OutFile:WriteString(Key)
		OutFile:WriteString(Value)
		OutFile:Close() 
	end
end

function CheckOnlineProgress(SuccesFunc)
	local UserID = nil
	
	if(FBManager:IsLoginValid()) then
		UserID = tonumber(FBManager.UserinfoTable['HighscoresID'])
	else
		UserID = tonumber(Scores.UserID)
	end
	
	if (UserID ~= nil) then
		CreateKeychainValue("UserID", UserID)
	else
		UserID = GetKeychainValue("UserID")
	end
	
	if (UserID == nil) then
		return
	end
	
	local FailureFunction = function(Data)
		print("Error retreiving progressVersion")
		--self:StopTimeOut()
	end
	
	local SuccessFunction = function(Data)
		print('OnReceiveProgressVersion')
		--self:StopTimeOut()
		
		if (Data ~= nil) then
			GameThread:Spawn(function(Thread)
				local Value = tonumber(Data['ProgressVersion'])
				
				if (Value ~= nil) then
					print("Server ProgressVersion: ^2" .. tostring(Value))
					print("Local ProgressVersion: ^2" .. tostring(OnlineVersion))
					
					if (Value >= OnlineVersion) then
						--OnlineVersion = Value
						ReadOnlineProgress()
					end
				end
			end)
		end
	end
	
	if (SuccesFunc ~= nil) then
		SuccessFunction = SuccesFunc
	end
	
	ScoresUser:GetOnlineProgressVersion(UserID, SuccessFunction, FailureFunction)
end

function ReadOnlineProgress()
	local UserID = nil
	
	if(FBManager:IsLoginValid()) then
		UserID = tonumber(FBManager.UserinfoTable['HighscoresID'])
	else
		UserID = tonumber(Scores.UserID)
	end
	
	if (UserID ~= nil) then
		CreateKeychainValue("UserID", UserID)
	else
		UserID = GetKeychainValue("UserID")
	end
	
	if (UserID == nil) then
		return
	end
	
	local FailureFunction = function(Data)
		print("Error retreiving progress")
		--self:StopTimeOut()
	end

	local SuccessFunction = function(Data)
		print('OnReceiveProgress')
		--self:StopTimeOut()
		
		if (Data ~= nil) then
			
			GameThread:Spawn(function(Thread)
				Scores.UserID = UserID
				
				local Value = Data['ProgressVersion']
				if (Value ~= nil) then
					if (Value >= OnlineVersion) then
						OnlineVersion = Value
					else
						print("Error 1, wrong version number")
						print("Server ProgressVersion: ^2" .. tostring(Value))
						print("Local ProgressVersion: ^2" .. tostring(OnlineVersion))
						return
					end
				else
					print("Error 2, wrong version number")
					print("Server ProgressVersion: ^2" .. tostring(Value))
					print("Local ProgressVersion: ^2" .. tostring(OnlineVersion))
					return
				end
				
				local Value = Data['FirstPlayOffer']
				if (Value ~= nil) then
					FirstPlayOffer = Value
				end
				
				if (Data['VirtualCoins'] ~= nil) then
					local Value = tonumber(Data['VirtualCoins']['CoinCount'])
					if (Value ~= nil) then
						VirtualCoins:SetCoinCount(Value)
					end
					
					local Value = tonumber(Data['VirtualCoins']['GoloCoinCount'])
					if (Value ~= nil) then
						VirtualCoins:SetGoloCoinCount(Value)
					end
					
					local Value = Data['VirtualCoins']['IsRated']
					if (Value ~= nil and Value == true) then
						VirtualCoins.IsRated = Value
					end
					
					local Value = Data['VirtualCoins']['IsLiked_Game']
					if (Value ~= nil and Value == true) then
						VirtualCoins.IsLiked_Game = Value
					end
					
					local Value = Data['VirtualCoins']['IsLiked_Developer']
					if (Value ~= nil and Value == true) then
						VirtualCoins.IsLiked_Developer = Value
					end
					
					local Value = Data['VirtualCoins']['IsVisited_Website']
					if (Value ~= nil and Value == true) then
						VirtualCoins.IsVisited_Website = Value
					end
				end
				
				if (Data['PowerUpItems'] ~= nil) then
					local Value = Data['PowerUpItems']['Powerup_InstantRepair_Bought']
					if (Value ~= nil and Value == true) then
						Powerup_InstantRepair.Bought = Value
					end
					
					local Value = Data['PowerUpItems']['Powerup_SuperNitro_Bought']
					if (Value ~= nil and Value == true) then
						Powerup_SuperNitro.Bought = Value
					end
					
					local Value = Data['PowerUpItems']['Powerup_UltraBumpers_Bought']
					if (Value ~= nil and Value == true) then
						Powerup_UltraBumpers.Bought = Value
					end
					
					local Value = Data['PowerUpItems']['Powerup_SuperJump_Bought']
					if (Value ~= nil and Value == true) then
						Powerup_SuperJump.Bought = Value
					end
					
					local Value = Data['PowerUpItems']['Powerup_Fireworks_Bought']
					if (Value ~= nil and Value == true) then
						Powerup_Fireworks.Bought = Value
					end
				end
				
				if (Data['Cars'] ~= nil) then
					GetOnlineProgress_Car(Madusa, Data)
					GetOnlineProgress_Car(Crusader, Data)
					GetOnlineProgress_Car(ElDiablo, Data)
					GetOnlineProgress_Car(BlueThunder, Data)
					GetOnlineProgress_Car(CaptainsCurse, Data)
					GetOnlineProgress_Car(NorthernNightmare, Data)
					GetOnlineProgress_Car(MonsterMutt, Data)
					GetOnlineProgress_Car(MonsterMuttRottweiler, Data)
					GetOnlineProgress_Car(MonsterMuttDalmatian, Data)
					GetOnlineProgress_Car(GraveDiggerTheLegend, Data)
					GetOnlineProgress_Car(SonUvaDigger, Data)
					GetOnlineProgress_Car(Zombie, Data)
					GetOnlineProgress_Car(MohawkWarrior, Data)
					GetOnlineProgress_Car(ElToroLoco, Data)
					GetOnlineProgress_Car(GraveDigger, Data)
					GetOnlineProgress_Car(Max_D, Data)
					
					if (FileVersion > 6) then
						GetOnlineProgress_Car(Avenger, Data)
						GetOnlineProgress_Car(ElDiablo2014, Data)
						GetOnlineProgress_Car(ElToroLocoBlack, Data)
						GetOnlineProgress_Car(ElToroLocoYellow, Data)
						GetOnlineProgress_Car(NEAPolice, Data)
						GetOnlineProgress_Car(StoneCrusher, Data)
						GetOnlineProgress_Car(BountyHunter, Data)
						GetOnlineProgress_Car(MetalMulisha, Data)
					end
				end
				
				WriteGameSettings(false)
			end)
		else
			FailureFunction()
		end
	end
	
	ScoresUser:GetOnlineProgress(UserID, SuccessFunction, FailureFunction)
end

function GetOnlineProgress_Car(Car, Data)
	if (Car.Bought == Car.Available) then
		if (Data['Cars'][Car.Name] ~= nil) then
			local Data_Bought = Data['Cars'][Car.Name]['Bought']
			if (Data_Bought == true and Car.Bought == false) then
				Car.Bought = true
				Car.Available = true
			end
		else
			print("^1"..Car.Name.." not found in Progress Data")
			return
		end
	end
	
	if (Data['Cars'][Car.Name] ~= nil and Data['Cars'][Car.Name]['MechanicBought'] ~= nil and Data['Cars'][Car.Name]['MechanicBought'] == true) then
		Car.MechanicActiveRaces = 1
	end
	
	local UpgradeName = "garage_weight"
	local Data_CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
	if (Car.Upgrades[UpgradeName].BoughtLevel < Data_CurrentLevel) then
		Car.Upgrades[UpgradeName].CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
		Car.Upgrades[UpgradeName].BoughtLevel = Car.Upgrades[UpgradeName].CurrentLevel
		--Car.Upgrades[UpgradeName].DeliveryLevel = Car.Upgrades[UpgradeName].CurrentLevel
	end
	
	local UpgradeName = "garage_suspension"
	local Data_CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
	if (Car.Upgrades[UpgradeName].BoughtLevel < Data_CurrentLevel) then
		Car.Upgrades[UpgradeName].CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
		Car.Upgrades[UpgradeName].BoughtLevel = Car.Upgrades[UpgradeName].CurrentLevel
		--Car.Upgrades[UpgradeName].DeliveryLevel = Car.Upgrades[UpgradeName].CurrentLevel
	end
	
	local UpgradeName = "garage_airshocks"
	local Data_CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
	if (Car.Upgrades[UpgradeName].BoughtLevel < Data_CurrentLevel) then
		Car.Upgrades[UpgradeName].CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
		Car.Upgrades[UpgradeName].BoughtLevel = Car.Upgrades[UpgradeName].CurrentLevel
		--Car.Upgrades[UpgradeName].DeliveryLevel = Car.Upgrades[UpgradeName].CurrentLevel
	end
	
	local UpgradeName = "garage_engine"
	local Data_CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
	if (Car.Upgrades[UpgradeName].BoughtLevel < Data_CurrentLevel) then
		Car.Upgrades[UpgradeName].CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
		Car.Upgrades[UpgradeName].BoughtLevel = Car.Upgrades[UpgradeName].CurrentLevel
		--Car.Upgrades[UpgradeName].DeliveryLevel = Car.Upgrades[UpgradeName].CurrentLevel
	end
	
	local UpgradeName = "garage_armor"
	local Data_CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
	if (Car.Upgrades[UpgradeName].BoughtLevel < Data_CurrentLevel) then
		Car.Upgrades[UpgradeName].CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
		Car.Upgrades[UpgradeName].BoughtLevel = Car.Upgrades[UpgradeName].CurrentLevel
		--Car.Upgrades[UpgradeName].DeliveryLevel = Car.Upgrades[UpgradeName].CurrentLevel
	end
	
	local UpgradeName = "garage_tires"
	local Data_CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
	if (Car.Upgrades[UpgradeName].BoughtLevel < Data_CurrentLevel) then
		Car.Upgrades[UpgradeName].CurrentLevel = tonumber(Data['Cars'][Car.Name]['Upgrades'][UpgradeName]['CurrentLevel'])
		Car.Upgrades[UpgradeName].BoughtLevel = Car.Upgrades[UpgradeName].CurrentLevel
		--Car.Upgrades[UpgradeName].DeliveryLevel = Car.Upgrades[UpgradeName].CurrentLevel
	end
end


function SendOnlineProgress()
	local UserID = nil
	
	if (GetKeychainValue("UserID") == nil) then
		if(FBManager:IsLoginValid()) then
			UserID = tonumber(FBManager.UserinfoTable['HighscoresID'])
		else
			UserID = tonumber(Scores.UserID)
		end
		
		if (UserID ~= nil) then
			CreateKeychainValue("UserID", UserID)
		end
	else
		UserID = GetKeychainValue("UserID")
	end
	
	if (UserID == nil) then
		return
	end
	
	local FailureFunction = function(Data)
		print("Error retreiving progressVersion")
		--self:StopTimeOut()
	end
	
	local SuccessFunction = function(Data)
		print('OnReceiveProgressVersion')
		
		local FailureFunction_Progress = function(Data)
			print("Error sending progress")
			--self:StopTimeOut()
		end

		local SuccessFunction_Progress = function(Data)
			print('OnSendProgress')
			--self:StopTimeOut()
			
			if (Data ~= nil) then
				GameThread:Spawn(function(Thread)
					--
				end)
			else
				FailureFunction()
			end
		end
		
		
		local PostData = {}
		
		PostData['FirstPlayOffer'] = FirstPlayOffer
		
		--VirtualCoins
		PostData['CoinCount'] = VirtualCoins.CoinCount
		PostData['GoloCoinCount'] = VirtualCoins.GoloCoinCount
		PostData['IsRated'] = VirtualCoins.IsRated
		PostData['IsLiked_Game'] = VirtualCoins.IsLiked_Game
		PostData['IsLiked_Developer'] = VirtualCoins.IsLiked_Developer
		PostData['IsVisited_Website'] = VirtualCoins.IsVisited_Website
		
		--PowerUpItems
		PostData['Powerup_InstantRepair_Bought'] = Powerup_InstantRepair.Bought
		PostData['Powerup_SuperNitro_Bought'] = Powerup_SuperNitro.Bought
		PostData['Powerup_UltraBumpers_Bought'] = Powerup_UltraBumpers.Bought
		PostData['Powerup_SuperJump_Bought'] = Powerup_SuperJump.Bought
		PostData['Powerup_Fireworks_Bought'] = Powerup_Fireworks.Bought
		
		--Cars
		SendOnlineProgress_Car(Madusa, PostData)
		SendOnlineProgress_Car(Crusader, PostData)
		SendOnlineProgress_Car(ElDiablo, PostData)
		SendOnlineProgress_Car(BlueThunder, PostData)
		SendOnlineProgress_Car(CaptainsCurse, PostData)
		SendOnlineProgress_Car(NorthernNightmare, PostData)
		SendOnlineProgress_Car(MonsterMutt, PostData)
		SendOnlineProgress_Car(MonsterMuttRottweiler, PostData)
		SendOnlineProgress_Car(MonsterMuttDalmatian, PostData)
		SendOnlineProgress_Car(GraveDiggerTheLegend, PostData)
		SendOnlineProgress_Car(SonUvaDigger, PostData)
		SendOnlineProgress_Car(Zombie, PostData)
		SendOnlineProgress_Car(MohawkWarrior, PostData)
		SendOnlineProgress_Car(ElToroLoco, PostData)
		SendOnlineProgress_Car(GraveDigger, PostData)
		SendOnlineProgress_Car(Max_D, PostData)
		
		if (FileVersion > 6) then
			SendOnlineProgress_Car(Avenger, PostData)
			SendOnlineProgress_Car(ElDiablo2014, PostData)
			SendOnlineProgress_Car(ElToroLocoBlack, PostData)
			SendOnlineProgress_Car(ElToroLocoYellow, PostData)
			SendOnlineProgress_Car(NEAPolice, PostData)
			SendOnlineProgress_Car(StoneCrusher, PostData)
			SendOnlineProgress_Car(BountyHunter, PostData)
			SendOnlineProgress_Car(MetalMulisha, PostData)
		end
		
		
		local Value = tonumber(Data['ProgressVersion'])
				
		if (Value ~= nil or Value <= OnlineVersion) then
			print("Server ProgressVersion: ^2" .. tostring(Value))
			print("Local ProgressVersion: ^2" .. tostring(OnlineVersion))
		
			ScoresUser:AddOnlineProgress(UserID, PostData, SuccessFunction_Progress, FailureFunction_Progress)
		end
	end
	
	ScoresUser:GetOnlineProgressVersion(UserID, SuccessFunction, FailureFunction)
end

function SendOnlineProgress_Car(Car, Data)
	Data[Car.Name..'_Bought'] = Car.Bought
	
	Data[Car.Name..'_MechanicBought'] = false
	if (Car.MechanicActiveRaces > 0) then
		Data[Car.Name..'_MechanicBought'] = true
	end
	
	local UpgradeName = "garage_weight"
	Data[Car.Name..'_'..UpgradeName..'_CurrentLevel'] = Car.Upgrades[UpgradeName].BoughtLevel
	
	local UpgradeName = "garage_suspension"
	Data[Car.Name..'_'..UpgradeName..'_CurrentLevel'] = Car.Upgrades[UpgradeName].BoughtLevel
	
	local UpgradeName = "garage_airshocks"
	Data[Car.Name..'_'..UpgradeName..'_CurrentLevel'] = Car.Upgrades[UpgradeName].BoughtLevel
	
	local UpgradeName = "garage_engine"
	Data[Car.Name..'_'..UpgradeName..'_CurrentLevel'] = Car.Upgrades[UpgradeName].BoughtLevel
	
	local UpgradeName = "garage_armor"
	Data[Car.Name..'_'..UpgradeName..'_CurrentLevel'] = Car.Upgrades[UpgradeName].BoughtLevel
	
	local UpgradeName = "garage_tires"
	Data[Car.Name..'_'..UpgradeName..'_CurrentLevel'] = Car.Upgrades[UpgradeName].BoughtLevel
end