RotatingBeam = class(function(self, WorldObject)
	self.WorldObject = WorldObject
	self.Matrix = self.WorldObject:GetMatrix()
	self.OriginalMatrix = self.WorldObject:GetMatrix()
	
	self.WorldObject:SetCollision(false)
	
	self.Thread = PhysicsThread:Spawn(function()	
		local Direction = 1
	
		while (self ~= nil) do
			local Length = math.random(1,3) * 60			
			local MaxRotation = 45
			
			local NewMatrix = Matrix34():Translate(self.OriginalMatrix:GetTranslation())
			NewMatrix = NewMatrix:SetRotation(self.OriginalMatrix:GetRotation())
			NewMatrix = NewMatrix:RotateLocal(Vector(1,0,0), math.rad(math.random(-MaxRotation, MaxRotation)))
			NewMatrix = NewMatrix:RotateLocal(Vector(0,1,0), math.rad(math.random(-MaxRotation, MaxRotation)))
			
			for i = 1, Length do 
				local Animator = math.sin(math.pi * (i/Length))
				
				self.WorldObject:SetMatrix(self.Matrix:Lerp(NewMatrix, i/Length))
				
				PhysicsThread:Wait(1) 
			end
			
			self.Matrix = NewMatrix
			
			PhysicsThread:Wait(1) 
		end
	end)
end)

function InitRotatingBeam(WorldObject)
	local Beam = RotatingBeam(WorldObject)
	
	return Beam
end