ShopUpgradeItem = class(function(self, Name, DialogText)
	self.Name = Name
	--self.CurrentLevel = 0
	
	--self.Deliveries = {}		-- {Level, TimeStamp}  >>> {1, 4546944}
	--self.BoughtLevel = self.CurrentLevel		--BoughtLevel gebruiken bij GetBoughtItemLevel
	
	self.ItemLevels = {}
	self.DialogText = DialogText
	self.ShowInShop = true;
	
	self.DiscountOffered = false
end)

function ShopUpgradeItem:AddItemLevel(Name, ImageName, Value, CoinsPrice, GoloCoinsPrice, DeliveryGoloCoinsPrice, Requirements, Extras)
	local ItemLevel = {}
	ItemLevel.Name = Name
	ItemLevel.ImageName = ImageName
	ItemLevel.Value = Value
	ItemLevel.CoinsPrice = CoinsPrice
	ItemLevel.GoloCoinsPrice = GoloCoinsPrice
	ItemLevel.DeliveryGoloCoinsPrice = DeliveryGoloCoinsPrice
	ItemLevel.ShowInShop = true;
	ItemLevel.Requirements = Requirements
	ItemLevel.Extras = Extras
	
	table.insert(self.ItemLevels, ItemLevel)
	
	return ItemLevel;
end

function ShopUpgradeItem:GetPrevItemLevel(car)
	return self:GetItemLevel(car.Upgrades[self.Name].CurrentLevel)
end

function ShopUpgradeItem:GetCurrentItemLevel(car)
	return self:GetItemLevel(car.Upgrades[self.Name].CurrentLevel + 1)
end

function ShopUpgradeItem:GetBoughtItemLevel(car)
	return self:GetItemLevel(car.Upgrades[self.Name].BoughtLevel + 1)
end

function ShopUpgradeItem:GetItemLevel(Level)
	local Level = ClampMinMax(Level, 1, #self.ItemLevels)
	local ItemLevel = self.ItemLevels[Level]
	return ItemLevel
end

function ShopUpgradeItem:GetPrice(car)
	--local NextLevel = self.ItemLevels[self.CurrentLevel + 1]
	local NextLevel = self.ItemLevels[car.Upgrades[self.Name].BoughtLevel + 1]
	if (NextLevel ~= nil and NextLevel.ShowInShop) then
		return NextLevel.CoinsPrice
	else
		--local CurrentLevel = self:GetCurrentItemLevel()
		local BoughtLevel = self:GetBoughtItemLevel(car)
		
		return 0
	end
end

function ShopUpgradeItem:GetGoloPrice(car)
	--local NextLevel = self.ItemLevels[self.CurrentLevel + 1]
	local NextLevel = self.ItemLevels[car.Upgrades[self.Name].BoughtLevel + 1]
	if (NextLevel ~= nil and NextLevel.ShowInShop) then
		return NextLevel.GoloCoinsPrice
	else
		--local CurrentLevel = self:GetCurrentItemLevel()
		local BoughtLevel = self:GetBoughtItemLevel(car)
		
		return 0
	end
end

function ShopUpgradeItem:GetDeliveryGoloPrice(car)
	--local NextLevel = self.ItemLevels[self.CurrentLevel + 1]
	local NextLevel = self.ItemLevels[car.Upgrades[self.Name].CurrentLevel + 1]
	if (NextLevel ~= nil and NextLevel.ShowInShop) then
		return NextLevel.DeliveryGoloCoinsPrice
	else
		--local CurrentLevel = self:GetCurrentItemLevel()
		local BoughtLevel = self:GetBoughtItemLevel(car)
		
		return 0
	end
end

function ShopUpgradeItem:GetCurrentValue(car)
	local CurrentItem = self.ItemLevels[car.Upgrades[self.Name].CurrentLevel]
	if (CurrentItem ~= nil) then
		return CurrentItem.Value
	else
		return 0
	end
end

function ShopUpgradeItem:GetNextValue(car)
	--local CurrentItem = self.ItemLevels[self.CurrentLevel + 1]
	local CurrentItem = self.ItemLevels[car.Upgrades[self.Name].BoughtLevel + 1]
	if (CurrentItem ~= nil) then
		return CurrentItem.Value
	else
		return 0
	end
end

function ShopUpgradeItem:Available(car)
	--local CurrentItem = self:GetCurrentItemLevel()
	local CurrentItem = self:GetBoughtItemLevel(car)
	if (CurrentItem ~= nil) then
		if (CurrentItem.Requirements ~= nil) then
			for i, Requirement in ipairs(CurrentItem.Requirements) do
				--if (Requirement[1].CurrentLevel < Requirement[2]) then
				if (Requirement[1].BoughtLevel < Requirement[2]) then
					return false
				end
			end
		end
		
		--if (self.CurrentLevel == #self.ItemLevels) then
		if (car.Upgrades[self.Name].BoughtLevel == #self.ItemLevels) then
			return false
		else
			return true
		end
	end
	
	return false
end

function ShopUpgradeItem:Buy(AddDelivery, car)
	if (AddDelivery == nil) then
		AddDelivery = true
	end

	if (self:Available(car)) then
		--if (self.CurrentLevel < #self.ItemLevels) then
		if (car.Upgrades[self.Name].BoughtLevel < #self.ItemLevels) then
			
			local Price = self:GetPrice(car)
			
			local PrevItem = self:GetCurrentItemLevel(car)
			--local NextLevel = ClampMax(Inc(self.CurrentLevel), #self.ItemLevels)
			local NextLevel = ClampMax(Inc(car.Upgrades[self.Name].BoughtLevel), #self.ItemLevels)
			
			if (AddDelivery) then
				--local delivery = {NextLevel, os.time() + (5)}
				--local delivery = {NextLevel, os.time() + GlobalDeliveryTime_UpgradeItem}
				--local delivery = {NextLevel, os.time() + CalcDeliveryTime(Price)}
				--table.insert(car.Upgrades[self.Name].Deliveries, delivery)
				car.Upgrades[self.Name].DeliveryLevel = NextLevel
				car.Upgrades[self.Name].DeliveryTime = os.time() + CalcDeliveryTime(Price)
				
			end
			
			if (NextLevel > car.Upgrades[self.Name].BoughtLevel) then
				car.Upgrades[self.Name].BoughtLevel = NextLevel
			end
			
			print("Buy: " .. self.Name .. ": " .. car.Upgrades[self.Name].BoughtLevel)
			
			--[[ local PrevItem = self:GetCurrentItemLevel()
		
			self.CurrentLevel = ClampMax(Inc(self.CurrentLevel), #self.ItemLevels)
			
			if (PrevItem ~= nil) then
				if (PrevItem.Extras ~= nil) then
					for i, Extra in ipairs(PrevItem.Extras) do
						local UpgradeItem = Extra[1]
						local NewLevel = Extra[2]
						
						while(UpgradeItem:Available(car) and UpgradeItem.CurrentLevel < NewLevel) do
							UpgradeItem:Buy()
						end
					end
				end
			end ]]
			
			self:BuyExtras(PrevItem, car)
		end
	end
end

function ShopUpgradeItem:BuyDirect(car)
	if (car.Upgrades[self.Name].BoughtLevel > car.Upgrades[self.Name].CurrentLevel) then
		car.Upgrades[self.Name].CurrentLevel = car.Upgrades[self.Name].BoughtLevel
	end
end

function ShopUpgradeItem:BuyExtras(ItemLevel, car)
	if (ItemLevel ~= nil) then
		if (ItemLevel.Extras ~= nil) then
			for i, Extra in ipairs(ItemLevel.Extras) do
				local UpgradeItem = Extra[1]
				local NewLevel = Extra[2]
				
				print("-------------------------------")
				print(car.Upgrades[self.Name].CurrentLevel)
				print(car.Upgrades[self.Name].BoughtLevel)
				print(NewLevel)
				--while(UpgradeItem:Available(car) and UpgradeItem.CurrentLevel < NewLevel) do
				while(UpgradeItem:Available(car) and car.Upgrades[self.Name].BoughtLevel < NewLevel) do
					UpgradeItem:Buy(false, car)
					--UpgradeItem:BuyDirect()
					
					print(car.Upgrades[self.Name].CurrentLevel)
					print(NewLevel)
				end
			end
		end
	end
end

function ShopUpgradeItem:BuyDirectExtras(ItemLevel, car)
	local BoughtExtra = {}

	if (ItemLevel ~= nil) then
		if (ItemLevel.Extras ~= nil) then
			for i, Extra in ipairs(ItemLevel.Extras) do
				local UpgradeItem = Extra[1]
				local NewLevel = Extra[2]
				local PrevLevel = car.Upgrades[self.Name].CurrentLevel
				
				print("BuyDirectExtras: " .. UpgradeItem.Name .. " - " .. car.Upgrades[self.Name].CurrentLevel .. " to " .. car.Upgrades[self.Name].BoughtLevel)
				--UpgradeItem.CurrentLevel = UpgradeItem.BoughtLevel
				
				if (NewLevel > car.Upgrades[self.Name].CurrentLevel) then
					car.Upgrades[self.Name].CurrentLevel = NewLevel
				end
				if (NewLevel > car.Upgrades[self.Name].BoughtLevel) then
					car.Upgrades[self.Name].BoughtLevel = NewLevel
				end
				
				if (NewLevel > PrevLevel) then
					local Extra = {UpgradeItem, PrevLevel}
					table.insert(BoughtExtra, Extra)
				end
			end
		end
	end
	
	return BoughtExtra
end

function ShopUpgradeItem:CheckDeliveries(car)
	local CurrentTime = os.time()

	--for i, Delivery in ipairs(car.Upgrades[self.Name].Deliveries) do
		
	local DeliveryLevel = car.Upgrades[self.Name].DeliveryLevel
	local DeliveryTime = car.Upgrades[self.Name].DeliveryTime
	
	if (DeliveryLevel ~= nil and DeliveryTime ~= nil and DeliveryLevel ~= 0 and DeliveryTime ~= 0) then
	
		--print("CheckDeliveries: " .. self.Name .. " from: " .. self.CurrentLevel .. " to " .. DeliveryLevel)
		
		if (DeliveryLevel > car.Upgrades[self.Name].CurrentLevel) then
			local WaitTime = DeliveryTime - CurrentTime
			--print("CheckDeliveries: " .. self.Name .. " " .. CurrentTime .. " - " .. DeliveryTime .. " - " .. WaitTime)
			--print("CheckDeliveries: " .. self.Name .. " WaitTime: " .. WaitTime)
			if (WaitTime <= 0) then
				--print(self.Name .. ": " .. DeliveryLevel)
				
				if (DeliveryLevel > car.Upgrades[self.Name].CurrentLevel) then
					car.Upgrades[self.Name].CurrentLevel = DeliveryLevel
					--BuyExtras
				end
				
				local ItemLevel = self:GetItemLevel(DeliveryLevel)
				--print("ItemLevel: " .. ItemLevel)
				--self:BuyExtras(ItemLevel)
				local BoughtExtra = self:BuyDirectExtras(ItemLevel, car)
				
				local ExtraBoughtText = " "
				for i, Extra in ipairs(BoughtExtra) do
					local UpgradeItem = Extra[1]
					local Name = UpgradeItem.Name
					local PrevLevel = Extra[2]
					local NewLevel = car.Upgrades[self.Name].CurrentLevel
					
					if (PrevLevel < NewLevel) then
						--ExtraBoughtText = ExtraBoughtText .. Translate("newline") .. "+ " .. Translate(Name) .. " - from:" .. PrevLevel .. " to: " .. NewLevel
						ExtraBoughtText = ExtraBoughtText .. Translate("newline") .. "+ " .. Translate(Name) .. " " .. Translate(UpgradeItem:GetItemLevel(NewLevel).Name)
					end
				end
				
				--print(ExtraBoughtText)
				
				--local Popup = {ConfirmMenu, self, DeliveryLevel, ExtraBoughtText}
				--table.insert(UnlockPopups, Popup)
				
				--UpdateButtons
				if (ActiveMenu.UpdateButtons ~= nil) then
					ActiveMenu:UpdateButtons()
				end
				
				if (ActiveMenu.CalcStats ~= nil) then
					ActiveMenu:CalcStats()
				end
				
				if (ActiveMenu.ShowMenu ~= nil) then
					ActiveMenu:ShowMenu()
				end
				
				car.Upgrades[self.Name].DeliveryLevel = 0
				car.Upgrades[self.Name].DeliveryTime = 0
			end
		else
			--UpdateButtons
			if (ActiveMenu.UpdateButtons ~= nil) then
				ActiveMenu:UpdateButtons()
			end
			
			if (ActiveMenu.CalcStats ~= nil) then
				ActiveMenu:CalcStats()
			end
			
			if (ActiveMenu.ShowMenu ~= nil) then
				ActiveMenu:ShowMenu()
			end
		
			car.Upgrades[self.Name].DeliveryLevel = 0
			car.Upgrades[self.Name].DeliveryTime = 0
			
		end
	end
		
	--end
end

function ShopUpgradeItem:Read(File, Version)
	
	self.DiscountOffered = File:ReadBoolean()
end

function ShopUpgradeItem:Write(File)
	
	File:WriteBoolean(self.DiscountOffered)
	
end

function ShopUpgradeItem:GetStats(car)
	local Stats = {}
	
	Stats.Name = self.Name
	Stats.Bought = car.Upgrades[self.Name].CurrentLevel
	
	return Stats
end

function ShopUpgradeItem:LoadTexture()
	for i, ItemLevel in ipairs(self.ItemLevels) do
		ItemLevel.Texture = texture(ItemLevel.ImageName)
	end
end

function ShopUpgradeItem:UnloadTexture()
	for i, ItemLevel in ipairs(self.ItemLevels) do
		ItemLevel.Texture = nil
	end
end

GlobalDeliveryTime_UpgradeItem = (60 * 12)	--12 Min.

ShopUpgradeItems = {}

UpgradeItem_Weight = ShopUpgradeItem("garage_weight", nil)
UpgradeItem_Suspension = ShopUpgradeItem("garage_suspension", nil)
UpgradeItem_AirShocks = ShopUpgradeItem("garage_airshocks", nil)
UpgradeItem_Engine = ShopUpgradeItem("garage_engine", nil)
UpgradeItem_Armor = ShopUpgradeItem("garage_armor", nil)
UpgradeItem_Tires = ShopUpgradeItem("garage_tires", nil)

--let op, de 4e value is speciaal (weight). hij mag alleen in de min

--Acceleratie: Nitro, Tires, Engine
--Top speed: Nitro, Engine
--Strength: Armor
--Weight: Weight Reduction, Armor
--Grip: Suspension, Tires
--(Name, ImageName, Value, CoinsPrice, GoloCoinsPrice, DeliveryGoloCoinsPrice, Requirements, Extras)
local UpgradeItem = UpgradeItem_Weight
UpgradeItem:AddItemLevel("ItemLevel_1", "Upgrades\\Weight\\Weight_01.dct", {2000,52,40,5000,1200}, GetUpgradePrice("Weight", "Gold", 1), GetUpgradePrice("Weight", "MJ", 1), 0)
UpgradeItem:AddItemLevel("ItemLevel_2", "Upgrades\\Weight\\Weight_01.dct", {0,0,0,-150,0}, GetUpgradePrice("Weight", "Gold", 2), GetUpgradePrice("Weight", "MJ", 2), 1)
UpgradeItem:AddItemLevel("ItemLevel_3", "Upgrades\\Weight\\Weight_01.dct", {0,0,0,-150,0}, GetUpgradePrice("Weight", "Gold", 3), GetUpgradePrice("Weight", "MJ", 3), 1)
UpgradeItem:AddItemLevel("ItemLevel_4", "Upgrades\\Weight\\Weight_01.dct", {0,0,0,-150,0}, GetUpgradePrice("Weight", "Gold", 4), GetUpgradePrice("Weight", "MJ", 4), 1)
UpgradeItem:AddItemLevel("ItemLevel_5", "Upgrades\\Weight\\Weight_01.dct", {0,0,0,-150,0}, GetUpgradePrice("Weight", "Gold", 5), GetUpgradePrice("Weight", "MJ", 5), 1)
UpgradeItem:AddItemLevel("ItemLevel_6", "Upgrades\\Weight\\Weight_01.dct", {0,0,0,-150,0}, GetUpgradePrice("Weight", "Gold", 6), GetUpgradePrice("Weight", "MJ", 6), 1)
table.insert(ShopUpgradeItems, UpgradeItem)

local UpgradeItem = UpgradeItem_Suspension
UpgradeItem:AddItemLevel("ItemLevel_1", "Upgrades\\Suspension\\Suspension_01.dct", {0,0,0,0,0}, GetUpgradePrice("Suspension", "Gold", 1), GetUpgradePrice("Suspension", "MJ", 1), 0 )
UpgradeItem:AddItemLevel("ItemLevel_2", "Upgrades\\Suspension\\Suspension_01.dct", {0,0,0,0,80}, GetUpgradePrice("Suspension", "Gold", 2), GetUpgradePrice("Suspension", "MJ", 2), 1)
UpgradeItem:AddItemLevel("ItemLevel_3", "Upgrades\\Suspension\\Suspension_01.dct", {0,0,0,0,80}, GetUpgradePrice("Suspension", "Gold", 3), GetUpgradePrice("Suspension", "MJ", 3), 1)
UpgradeItem:AddItemLevel("ItemLevel_4", "Upgrades\\Suspension\\Suspension_01.dct", {0,0,0,0,85}, GetUpgradePrice("Suspension", "Gold", 4), GetUpgradePrice("Suspension", "MJ", 4), 1)
UpgradeItem:AddItemLevel("ItemLevel_5", "Upgrades\\Suspension\\Suspension_01.dct", {0,0,0,0,90}, GetUpgradePrice("Suspension", "Gold", 5), GetUpgradePrice("Suspension", "MJ", 5), 1)
UpgradeItem:AddItemLevel("ItemLevel_6", "Upgrades\\Suspension\\Suspension_01.dct", {0,0,0,0,90}, GetUpgradePrice("Suspension", "Gold", 6), GetUpgradePrice("Suspension", "MJ", 6), 1)
table.insert(ShopUpgradeItems, UpgradeItem)

local UpgradeItem = UpgradeItem_AirShocks
UpgradeItem:AddItemLevel("ItemLevel_1", "Upgrades\\AirShocks\\AirShocks_01.dct", {0,0,0,0,0}, GetUpgradePrice("AirShocks", "Gold", 1), GetUpgradePrice("AirShocks", "MJ", 1), 0)
UpgradeItem:AddItemLevel("ItemLevel_2", "Upgrades\\AirShocks\\AirShocks_01.dct", {100,2,0,0,0}, GetUpgradePrice("AirShocks", "Gold", 2), GetUpgradePrice("AirShocks", "MJ", 2), 1)
UpgradeItem:AddItemLevel("ItemLevel_3", "Upgrades\\AirShocks\\AirShocks_01.dct", {400,3,0,0,0}, GetUpgradePrice("AirShocks", "Gold", 3), GetUpgradePrice("AirShocks", "MJ", 3), 1)
UpgradeItem:AddItemLevel("ItemLevel_4", "Upgrades\\AirShocks\\AirShocks_01.dct", {400,4,0,0,0}, GetUpgradePrice("AirShocks", "Gold", 4), GetUpgradePrice("AirShocks", "MJ", 4), 1)
UpgradeItem:AddItemLevel("ItemLevel_5", "Upgrades\\AirShocks\\AirShocks_01.dct", {400,4,0,0,0}, GetUpgradePrice("AirShocks", "Gold", 5), GetUpgradePrice("AirShocks", "MJ", 5), 1)
UpgradeItem:AddItemLevel("ItemLevel_6", "Upgrades\\AirShocks\\AirShocks_01.dct", {400,5,0,0,0}, GetUpgradePrice("AirShocks", "Gold", 6), GetUpgradePrice("AirShocks", "MJ", 6), 1)
table.insert(ShopUpgradeItems, UpgradeItem)

local UpgradeItem = UpgradeItem_Engine
UpgradeItem:AddItemLevel("ItemLevel_1", "Upgrades\\Engine\\Engine_01.dct", {0,0,0,0,0}, GetUpgradePrice("Engine", "Gold", 1), GetUpgradePrice("Engine", "MJ", 1), 0)
UpgradeItem:AddItemLevel("ItemLevel_2", "Upgrades\\Engine\\Engine_01.dct", {100,2,0,0,0}, GetUpgradePrice("Engine", "Gold", 2), GetUpgradePrice("Engine", "MJ", 2), 1)
UpgradeItem:AddItemLevel("ItemLevel_3", "Upgrades\\Engine\\Engine_01.dct", {400,3,0,0,0}, GetUpgradePrice("Engine", "Gold", 3), GetUpgradePrice("Engine", "MJ", 3), 1)
UpgradeItem:AddItemLevel("ItemLevel_4", "Upgrades\\Engine\\Engine_01.dct", {400,4,0,0,0}, GetUpgradePrice("Engine", "Gold", 4), GetUpgradePrice("Engine", "MJ", 4), 1)
UpgradeItem:AddItemLevel("ItemLevel_5", "Upgrades\\Engine\\Engine_01.dct", {400,5,0,0,0}, GetUpgradePrice("Engine", "Gold", 5), GetUpgradePrice("Engine", "MJ", 5), 1)
UpgradeItem:AddItemLevel("ItemLevel_6", "Upgrades\\Engine\\Engine_01.dct", {400,5,0,0,0}, GetUpgradePrice("Engine", "Gold", 6), GetUpgradePrice("Engine", "MJ", 6), 1)
table.insert(ShopUpgradeItems, UpgradeItem)

local UpgradeItem = UpgradeItem_Armor

UpgradeItem:AddItemLevel("ItemLevel_1", "Upgrades\\Armor\\Armor_01.dct", {0,0,0,0,0}, GetUpgradePrice("Armor", "Gold", 1), GetUpgradePrice("Armor", "MJ", 1), 0)
UpgradeItem:AddItemLevel("ItemLevel_2", "Upgrades\\Armor\\Armor_01.dct", {0,0,8,-100,0}, GetUpgradePrice("Armor", "Gold", 2), GetUpgradePrice("Armor", "MJ", 2), 1)
UpgradeItem:AddItemLevel("ItemLevel_3", "Upgrades\\Armor\\Armor_01.dct", {0,0,8,-100,0}, GetUpgradePrice("Armor", "Gold", 3), GetUpgradePrice("Armor", "MJ", 3), 1)
UpgradeItem:AddItemLevel("ItemLevel_4", "Upgrades\\Armor\\Armor_01.dct", {0,0,10,-100,0}, GetUpgradePrice("Armor", "Gold", 4), GetUpgradePrice("Armor", "MJ", 4), 1)
UpgradeItem:AddItemLevel("ItemLevel_5", "Upgrades\\Armor\\Armor_01.dct", {0,0,10,-100,0}, GetUpgradePrice("Armor", "Gold", 5), GetUpgradePrice("Armor", "MJ", 5), 1)
UpgradeItem:AddItemLevel("ItemLevel_6", "Upgrades\\Armor\\Armor_01.dct", {0,0,10,-100,0}, GetUpgradePrice("Armor", "Gold", 6), GetUpgradePrice("Armor", "MJ", 6), 1)
table.insert(ShopUpgradeItems, UpgradeItem)

local UpgradeItem = UpgradeItem_Tires

UpgradeItem:AddItemLevel("ItemLevel_1", "Upgrades\\Tires\\Tires_01.dct", {0,0,0,0,0}, GetUpgradePrice("Tires", "Gold", 1), GetUpgradePrice("Tires", "MJ", 1), 0)
UpgradeItem:AddItemLevel("ItemLevel_2", "Upgrades\\Tires\\Tires_01.dct", {100,0,0,0,80}, GetUpgradePrice("Tires", "Gold", 2), GetUpgradePrice("Tires", "MJ", 2), 1)
UpgradeItem:AddItemLevel("ItemLevel_3", "Upgrades\\Tires\\Tires_01.dct", {400,0,0,0,80}, GetUpgradePrice("Tires", "Gold", 3), GetUpgradePrice("Tires", "MJ", 3), 1)
UpgradeItem:AddItemLevel("ItemLevel_4", "Upgrades\\Tires\\Tires_01.dct", {400,0,0,0,85}, GetUpgradePrice("Tires", "Gold", 4), GetUpgradePrice("Tires", "MJ", 4), 1)
UpgradeItem:AddItemLevel("ItemLevel_5", "Upgrades\\Tires\\Tires_01.dct", {400,0,0,0,90}, GetUpgradePrice("Tires", "Gold", 5), GetUpgradePrice("Tires", "MJ", 5), 1)
UpgradeItem:AddItemLevel("ItemLevel_6", "Upgrades\\Tires\\Tires_01.dct", {400,0,0,0,90}, GetUpgradePrice("Tires", "Gold", 6), GetUpgradePrice("Tires", "MJ", 6), 1)
table.insert(ShopUpgradeItems, UpgradeItem)


function ShopUpgrades_Read(File, Version)
	local ShopUpgradeItemsCount = File:ReadInt()
	for i = 1, ShopUpgradeItemsCount do
		ShopUpgradeItems[i]:Read(File, Version)
	end
end

function ShopUpgrades_Write(File)
	File:WriteInt(#ShopUpgradeItems);
	for i = 1, #ShopUpgradeItems do
		ShopUpgradeItems[i]:Write(File, Version)
	end
end