SpecialOffer_Chance = 10

--Special Offer A
SpecialOffer_Cars = {GraveDiggerTheLegend, SonUvaDigger, MonsterMuttRottweiler}
SpecialOffer_FullUpgradeCars = true
SpecialOffer_GoloPrice = 14
SpecialOffer_OfferImage = texture("SpecialOffers\\AanbiedingA.DCT")

function ShowSpecialOffer()
	
	local SpecialOfferData = GetSpecialOffer()
	if (SpecialOfferData ~= nil) then
		if (SpecialOfferData["Chance"] ~= nil) then
			SpecialOffer_Chance = SpecialOfferData["Chance"]
		end
		if (SpecialOfferData["Cars"] ~= nil) then
			SpecialOffer_Cars = {}
			for i, CarName in ipairs(SpecialOfferData["Cars"]) do
				for j, Car in ipairs(MonsterTruckCars.Cars) do
					if (Car.Name == CarName) then
						table.insert(SpecialOffer_Cars, Car)
					end
				end
			end
		end
		if (SpecialOfferData["FullUpgradeCars"] ~= nil) then
			SpecialOffer_FullUpgradeCars = SpecialOfferData["FullUpgradeCars"]
		end
		if (SpecialOfferData["GoloPrice"] ~= nil) then
			SpecialOffer_GoloPrice = SpecialOfferData["GoloPrice"]
		end
		if (SpecialOfferData["OfferImage"] ~= nil) then
			local FileName = "Menu\\Images\\SpecialOffers\\"..SpecialOfferData["OfferImage"]
			if (GetFS():Exists(FileName)) then
				SpecialOffer_OfferImage = texture(FileName)
			else
				print(FileName .. "does not exist!")
				return --Abort
			end
		end
	end

	local RandomValue = math.random(1, SpecialOffer_Chance)
	if (RandomValue <= 1 or ReDirected) then -- = 10 % kans of teruggekomen van Golocoins kopen
		GameThread:Spawn(function()				
			-- Check if the cars are already bought and thus, if the offer is applicable
			local AlreadyBought = true
			for i, Car in ipairs(SpecialOffer_Cars) do
				if (not Car.Bought or not Car.Available) then
					AlreadyBought = false
				end
			end
			
			if (not AlreadyBought) then
				ShowSpecialOffer_Base(SpecialOffer_Cars, SpecialOffer_GoloPrice, SpecialOffer_OfferImage)
			end
		end)
	end
end

function ShowSpecialOffer_Base(Cars, GoloPrice, OfferImage)
	PreviousMenu = ActiveMenu
	ActiveMenu = ConfirmMenu(PreviousMenu, false, "SpecialPopup", "Empty", "Empty")
	
	ActiveMenu.Main:GetChild("Image"):SetImage(OfferImage)
	
	ActiveMenu.CancelAction = function()
		AnalyticsSendEvent("SpecialOffer", "Clicking", "Closed", "1")
	end
	
	ActiveMenu.ProceedAction = function()
		AnalyticsSendEvent("SpecialOffer", "Clicking", "Continue", "1")
		
		local SufficientCredits = (VirtualCoins:GetGoloCoinCount() >= GoloPrice)
		if (not SufficientCredits) then
			GameThread:Spawn(function()
				PreviousMenu:HideMenu(true)
				if (PreviousMenu.DeleteButtons ~= nil) then
					PreviousMenu:DeleteButtons()
				end
				
				ActiveMenu = CoinShop_Golo(GameModeSelect, PreviousMenu)
			end)
		else
			local BuyFunction = function()
				-- All upgrades
				local Upgrades = {UpgradeItem_Weight, UpgradeItem_Suspension, UpgradeItem_AirShocks, UpgradeItem_Engine, UpgradeItem_Armor, UpgradeItem_Tires}
				
				for i = 1, #Cars do
					local Car = Cars[i]
					Car.Bought = true
					Car.Available = true
					Car.DeliveryTime = os.time()
					
					if (SpecialOffer_FullUpgradeCars) then
						for i = 1, #Upgrades do
							local Upgrade = Car.Upgrades[Upgrades[i].Name]
							local MaxLevel = #Upgrades[i].ItemLevels
							Upgrade.CurrentLevel = MaxLevel
							Upgrade.BoughtLevel = MaxLevel
						end
					end
				end
			end
			
			if (VirtualCoins:BuyGoloProduct(GoloPrice, BuyFunction)) then
				WriteGameSettings()
				VirtualCoins:UpdateCoincount()
				
				ShowConfirm_ThanksForPurchase()
			end
		end
	end
end