-- Helpers (move later)
function steam_getfriendbyname(Name)
	local FriendCount = steam_getfriendcount()
	
	for i = 0, FriendCount - 1 do 
		local Friend = steam_getfriend(i)
		local FriendName = steam_getusername(Friend)
		
		if (FriendName == Name) then
			return Friend;
		end
	end
	
	print(string.format("Friend %s not found", Name));
	
	return steamid();
end

function steam_invitefriend(Lobby, Name)
	local Friend = steam_getfriendbyname(Name)
	
	steam_inviteuser(Lobby, Friend);
end

function steam_joinlistedlobby(Index)
	local Lobby = steam_getlobby(Index)
	
	steam_joinlobby(Lobby)
end	

function steam_onjoinlobby(JoinedLobby)
	if (InGame) then
		-- terug naar menu eerst
	end
	
	--ActiveLobby = JoinedLobby
	
	if (ActiveMenu ~= nil) then
		-- Fade uit
		if (ActiveMenu.Main ~= nil) then
			ActiveMenu.Main:SetColor(Invisible)
		end
		
		if (ActiveMenu.Dirt ~= nil) then
			ActiveMenu.Dirt:SetColorImmediate(Invisible)
		end
		ScrapClose()
	end
	
	steam_joinlobby(JoinedLobby)
	ActiveMenu = Lobby_Connecting()
end

-- Core
ActiveLobby = nil
LobbyCount = 0;
Activeserver = nil

function steam_onlobbystart(Lobby, Server)
	LoadingScreen = nil
	
	steam_addplayerdata(ActiveLobby, "Ready", "0")
	if (Steam_GetLobbyOwner(ActiveLobby) == steam_getsteamid()) then
		steam_addlobbydata(ActiveLobby, "Starting", "0")
	end
	
	-- Stack leegmaken
	ClearMenuStack()
		
	-- Weg met het menu
	ActiveMenu = nil
	CutsceneBars = nil
	HUD = nil
	
	ActiveServer = Server;
	
	local Game = {}
	
	Game.Lobby = Lobby
	Game.Server = Server
	Game.GameType = IndexInTable(MPGameModes, ActiveGameMode) + 1
	Game.Track = steam_getlobbydata(Lobby, "Race")
	Game.LapCount = tonumber(steam_getlobbydata(Lobby, "LapCount"))
	
	Game.DamageMultiplier = tonumber(steam_getlobbydata(Lobby, "DamageMultiplier"))
	Game.BoostHealing = steam_getlobbydata(Lobby, "BoostHealing") == "1"
	Game.PhysicsSpeed = tonumber(steam_getlobbydata(Lobby, "PhysicsSpeed"))
	
	Game.PlayerCount = steam_getlobbyplayercount(Lobby);
	
	Game.Players = {}

	for i = 0, Game.PlayerCount - 1 do
		local Player = steam_getlobbyplayer(Lobby, i);
		
		Game.Players[i + 1] = {}
		
		local Entry = Game.Players[i + 1];
		Entry.ID = Player;
		Entry.Name = steam_getusername(Player)
		Entry.Car = steam_getplayerdata(Lobby, Player, "Car");
		Entry.Skin = tonumber(steam_getplayerdata(Lobby, Player, "Skin"))
		Entry.Tuning = steam_getplayerdata(Lobby, Player, "Tuning")
		Entry.Character = steam_getplayerdata(Lobby, Player, "Character");
	end
	
	RaceConfig.LapCount = steam_getlobbydata(Lobby, "LapCount")
	RaceConfig.Win = function(Place, Score)
		--
	end
	
	RaceConfig.Career = false
	RaceConfig.MP = true
	RaceConfig.GoalText = ActiveGameMode.ActiveChapter.ActiveRace.GoalText
	RaceConfig.GoalText2 = ActiveGameMode.ActiveChapter.ActiveRace.GoalText2
	StartMPGame(Game);
	
	Steam_SetAchievement("Connected")
	
	Steam_UpdateLobby_UserEnter = HUD_UserEnter
	Steam_UpdateLobby_UserLeave = HUD_UserLeave
	Steam_UpdateLobby_UserDisconnect = HUD_UserLeave
	Steam_UpdateLobby_UserKick = HUD_UserLeave
	Steam_UpdateLobby_UserBan = HUD_UserLeave
end

function Steam_UpdateUser(User)
	print("Steam_UpdateUser")
end