StuntResult = class(function(self, ParentStunt)
	-- Misc
	self.ParentStunt = ParentStunt
	self.Message = ""
	self.Duration = 0.0
	self.Distance = 0
	self.Rotations = 0
	self.Bounces = 0
	self.ObjectsDestroyed = 0
	self.Saved = false
	self.AirDuration = 0.0
	self.AirHeight = 0.0
end)

function StuntResult:GetStuntScreenName()
	return self.ParentStunt.ScreenName
end

function StuntResult:GetStuntID()
	return self.ParentStunt.ID
end

function StuntResult:__add(op1)
	local Result = StuntResult()
	Result.Duration = self.Duration + op1.Duration
	Result.Rotations = self.Rotations + op1.Rotations
	Result.Bounces = self.Bounces + op1.Bounces
	Result.AirDuration = self.AirDuration + op1.AirDuration
	
	return Result
end

function StuntResult:__tostring()
	local ReturnString =  "{ Duration: " ..self.Duration
		.."; Distance: " ..self.Distance
		.."; Rotations: " ..self.Rotations
		.."; Bounces: " ..self.Bounces
		.."; ObjectsDestroyed: " ..self.ObjectsDestroyed
		.."; Saved: " ..(self.Saved and "true" or "false")
	if(self.AirDuration > 0) then
		ReturnString = ReturnString .."; AirDuration: " ..Round(self.AirDuration, 2)
		.."; AirHeight: " ..Round(self.AirHeight, 2)
	end
	ReturnString = ReturnString .." } "
	
	return ReturnString
end