AirStunt = class(BaseStunt, function(self)
	self.ScreenName = "stunt_title_airstunt"
	self.ActivationDelay = 1
	
	-- Set the deactivation delay. This is required for DestroyableObject collision
	-- to be registered before the stunt is deactivated.
	self.DeactivationDelay = 0.1
	--self.Type = StuntTypes.Air
	
	-- Set up the WheelsState that indicates we're doing an air stunt
	local ActivationState = WheelsState()
	ActivationState.Wheels[0] = false
	ActivationState.Wheels[1] = false
	ActivationState.Wheels[2] = false
	ActivationState.Wheels[3] = false
	
	self:AddActivationState(ActivationState)
end)

function AirStunt:OnDeactivated()
	-- If any stunts are running, don't post a score for this stunt. This stunt will only
	-- post a score when no other stunt is being performed. This is because all stunts
	-- already have a built-in airtime for airtime scoring.
	
	DailyMissionsManager:StartChecking(self, "Challenge_3")
	DailyMissionsManager:StartChecking(self, "Challenge_4")
	
	local ActiveStunts = self.StuntManager:GetActiveStunts()
	if(#ActiveStunts > 0) then
		return
	end
	
	local Result = self:CreateResult()
	Result.Message = "AirTime (" ..self.Duration .." sec)"
	
	self:CalculateScore()
	self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
	
	self:AddResult(Result)
	--playsound("Moves\\AirTime.wav")
end

function AirStunt:CalculateScore()
	self.Score = self.Player.MaxScorePerStunt
	--print(self.Player.Scores[self.ID])
end