BackflipStunt = class(BaseRotationStunt, function(self)
	-- Misc
	self.ScreenName = "stunt_title_backflip"
	self.ActivationAngle = 90
	self.DeactivationAngle = -25
	self.RotationAxis = VectorX
	self.RotationSign = 1
end)

function BackflipStunt:OnDeactivated()
	if(self.Rotations > 0) then
		local Result = self:CreateResult()
		Result.Rotations = self.Rotations
		
		
		self:CalculateScore()
		self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
		
		-- Determine the onscreen message
		if(self.Rotations == 1) then
			Result.Message = "Backflip"
			playsound("Moves\\BackFlip.wav")
		elseif(self.Rotations == 2) then
			Result.Message = "Double backflip"
			playsound("Moves\\DoubleBackFlip.wav")
		elseif(self.Rotations == 3) then
			Result.Message = "Triple backflip"
			playsound("Moves\\TripleBackFlip.wav")
		else
			Result.Message = "Backflip (x" ..self.Rotations ..")"
			playsound("Moves\\InsaneBackFlip.wav")
		end
		
		self:AddResult(Result)
	end
end

function BackflipStunt:CalculateScore()	
	self.Score = self.Player.MaxScorePerStunt
	--print(self.Player.Scores[self.ID] )
end
