CycloneDonutStunt = class(BaseDonutStunt, function(self)
	-- Misc
	self.ScreenName = "stunt_title_cyclone_donut"
	self.ActivationDelay = 1
	self.DeactivationDelay = 0.5
	
	-- Determine how quickly the player should rotate before the stunt is activated
	-- A higher value means quicker yaw-rotation
	self.YawDiffMin = 3.00
	self.YawDiffMax = 15.00

	self.DonutActivatedAmount = 0
end)

function CycloneDonutStunt:OnActivated()
	print("^2CycloneDonut activated")
	self.StuntManager.NewCamPos = nil
	self.StuntManager.ChangeCamPos = true
end

function CycloneDonutStunt:OnDeactivated()
	print("^2CycloneDonut deactivated")
	
	if(self.Rotations > 0) then
		self.DonutActivatedAmount = self.DonutActivatedAmount + 1
		
		local Result = self:CreateResult()
		Result.Rotations = self.Rotations
		Result.Message = "Cyclone donut x" ..self.Rotations
		
		self:CalculateScore()
		self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])

		self:AddResult(Result)
		playsound("Moves\\Cyclone.wav")
	end
	
	self.StuntManager.ChangeCamPos = false
end

function CycloneDonutStunt:CalculateScore()
	if(self.Score == 0)then
		self.Score = self.Player.MaxScorePerStunt * 2
	else
		self.Score = self.Score / 2
	end
	--print(self.Player.Scores[self.ID])
end