FrontflipStunt = class(BaseRotationStunt, function(self)
	-- Misc
	--self.ID = SCORE_FRONTFLIP
	self.ScreenName = "stunt_title_frontflip"
	self.ActivationAngle = 90
	self.DeactivationAngle = -25
	self.RotationAxis = VectorX
	self.RotationSign = -1
end)

function FrontflipStunt:OnDeactivated()
	if(self.Rotations > 0) then
		local Result = self:CreateResult()
		Result.Rotations = self.Rotations
		
		self:CalculateScore()
		self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
		
		-- Determine the onscreen message
		local Sound = "FrontFlip"
		if(self.Rotations == 1) then
			Result.Message = "Frontflip"
		elseif(self.Rotations == 2) then
			Result.Message = "Double frontflip"
			Sound = "DoubleFrontFlip"
		elseif(self.Rotations == 3) then
			Result.Message = "Triple frontflip"
		else
			Result.Message = "Frontlip (x" ..self.Rotations ..")"
		end
		
		self:AddResult(Result)
		playsound("Moves\\" .. Sound .. ".wav")
	end
end

function FrontflipStunt:CalculateScore()
	self.Score = self.Player.MaxScorePerStunt
	--print(self.Player.Scores[self.ID] )
end