OneTireStoppieStunt = class(BaseStunt, function(self)
	--self.ID = SCORE_ONETIRE_STOPPIE
	self.ScreenName = "stunt_title_onetire_stoppie"
	self.ActivationDelay = 0.5
	self.DeactivationDelay = 1.0
	
	-- Set up the WheelsState that indicates we're doing a stoppie stunt
	local FrontLeftState = WheelsState()
	FrontLeftState.Wheels[0] = true
	FrontLeftState.Wheels[1] = false
	FrontLeftState.Wheels[2] = false
	FrontLeftState.Wheels[3] = false
	
	local FrontRightState = WheelsState()
	FrontRightState.Wheels[0] = false
	FrontRightState.Wheels[1] = true
	FrontRightState.Wheels[2] = false
	FrontRightState.Wheels[3] = false
	
	self:AddActivationState(FrontLeftState)
	self:AddActivationState(FrontRightState)
end)

function OneTireStoppieStunt:OnDeactivated()
	local Result = self:CreateResult()
	Result.Message = "One-tire stoppie (" ..self.Duration .." sec)"
	
	self:CalculateScore()
	self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
	
	self:AddResult(Result)
	playsound("Moves\\OneTireStoppie.wav")
end

function OneTireStoppieStunt:CalculateScore()
	self.Score = self.Player.MaxScorePerStunt
	--print(self.Player.Scores[self.ID])
end