OneTireWheelieStunt = class(BaseStunt, function(self)
	self.ScreenName = "stunt_title_onetire_wheelie"
	self.ActivationDelay = 0.5
	self.DeactivationDelay = 1.0
	
	-- Set up the WheelsState that indicates we're doing a wheelie stunt
	local FrontLeftActivationState = WheelsState()
	FrontLeftActivationState.Wheels[0] = true
	FrontLeftActivationState.Wheels[1] = false
	FrontLeftActivationState.Wheels[2] = false
	FrontLeftActivationState.Wheels[3] = false
	
	local FrontRightActivationState = WheelsState()
	FrontRightActivationState.Wheels[0] = false
	FrontRightActivationState.Wheels[1] = true
	FrontRightActivationState.Wheels[2] = false
	FrontRightActivationState.Wheels[3] = false	
	
	local FrontLeftDeactivationState = WheelsState()
	FrontLeftDeactivationState.Wheels[0] = true
	FrontLeftDeactivationState.Wheels[1] = false
	FrontLeftDeactivationState.Wheels[2] = false
	FrontLeftDeactivationState.Wheels[3] = false
	
	local FrontRightDeactivationState = WheelsState()
	FrontRightDeactivationState.Wheels[0] = false
	FrontRightDeactivationState.Wheels[1] = true
	FrontRightDeactivationState.Wheels[2] = false
	FrontRightDeactivationState.Wheels[3] = false	
	
	self:AddActivationState(FrontLeftActivationState)
	self:AddActivationState(FrontRightActivationState)
	self:AddDeactivationState(FrontLeftDeactivationState)
	self:AddDeactivationState(FrontRightDeactivationState)
	
	self.MinDistance = 15000
	self.MaxDistance = 65000
end)

function OneTireWheelieStunt:OnDeactivated()
	DailyMissionsManager:StartChecking(self.Duration)
	
	local Result = self:CreateResult()
	Result.Message = "One-tire wheelie (" ..self.Duration .." sec)"

	self:CalculateScore()
	self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
	
	self:AddResult(Result)
	playsound("Moves\\OneTireWheelie.wav")
end

function OneTireWheelieStunt:CalculateScore()
	if(math.floor(self.Distance) < self.MinDistance)then
		self.Score = 2 + (self.Distance / 10000)
	elseif(math.floor(self.Distance) < self.MaxDistance)then
		self.Score = 5 + ((self.Distance - self.MinDistance) / 10000)
	else
		self.Score = 10
	end
	
	--print(self.Player.Scores[self.ID] )
end
