SidewaysWheelieStunt = class(BaseStunt, function(self)
	self.ScreenName = "stunt_title_sideways_wheelie"
	self.ActivationDelay = 0.5
	self.DeactivationDelay = 1.0
	
	-- Set up the WheelsState that indicates we're doing a wheelie stunt
	local LeanLeftState = WheelsState()
	LeanLeftState.Wheels[0] = false
	LeanLeftState.Wheels[1] = true
	LeanLeftState.Wheels[2] = false
	LeanLeftState.Wheels[3] = true
	
	local LeanRightState = WheelsState()
	LeanRightState.Wheels[0] = true
	LeanRightState.Wheels[1] = false
	LeanRightState.Wheels[2] = true
	LeanRightState.Wheels[3] = false
	
	self:AddActivationState(LeanLeftState)
	self:AddActivationState(LeanRightState)
		
	self.MinDistance = 90000
	self.MaxDistance = 140000
end)

function SidewaysWheelieStunt:OnDeactivated()
	DailyMissionsManager:StartChecking(self, "Challenge_2")
	DailyMissionsManager:StartChecking(self, "Challenge_15")
	DailyMissionsManager:StartChecking(self.Duration)
	
	local Result = self:CreateResult()
	Result.Message = "Sideways wheelie (" ..self.Duration .." sec)"

	self:CalculateScore()
	self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
	
	self:AddResult(Result)
	playsound("Moves\\SideWayWheelie.wav")
end

function SidewaysWheelieStunt:CalculateScore()
	if(math.floor(self.Distance) < self.MaxDistance)then
		self.Score = (self.Player.MaxScorePerStunt / self.MaxDistance) * self.Distance
	else
		self.Score = self.Player.MaxScorePerStunt
	end
	--print("Distance = "..(self.Distance)..", score = "..(self.Score))
	--print(self.Player.Scores[self.ID])
end
