SkyWheelieStunt = class(BaseStunt, function(self)
	self.ScreenName = "stunt_title_sky_wheelie"
	self.ActivationDelay = 0.5
	self.DeactivationDelay = 0.2
	
	-- Set up the WheelsState that indicates we're doing a wheelie stunt
	local ActivationState = WheelsState()
	ActivationState.Wheels[0] = false
	ActivationState.Wheels[1] = false
	ActivationState.Wheels[2] = true
	ActivationState.Wheels[3] = true
	
	local DeactivationState = WheelsState()
	DeactivationState.Wheels[0] = true
	DeactivationState.Wheels[1] = true
	DeactivationState.Wheels[2] = true
	DeactivationState.Wheels[3] = true
	
	self:AddActivationState(ActivationState)
	self:AddDeactivationState(DeactivationState)

	self.MinDistance = 40000
	self.MaxDistance = 90000
	self.MinAirDistance = 30000
	self.MaxAirDistance = 60000
end)

function SkyWheelieStunt:OnDeactivated()
	--print("^2Wheelie Deactivated")
	if(self.AirDuration > 0)then
		DailyMissionsManager:StartChecking(self, "Challenge_2")
		DailyMissionsManager:StartChecking(self, "Challenge_15")
		
		local Result = self:CreateResult()
		
		Result.Message = "Sky wheelie (" ..self.Duration .." sec)"
		
		self:CalculateScore()
		self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
		
		self:AddResult(Result)
		playsound("Moves\\Wheelie.wav")
	end
end

function SkyWheelieStunt:CalculateScore()
	local RoundedDistance = math.floor(self.Distance)
 
	if(self.AirDuration > 0)then
		if(RoundedDistance < self.MinAirDistance)then
			self.Score = (self.Distance/10000) + (self.AirDuration/3)
		elseif(RoundedDistance < self.MaxAirDistance)then
			self.Score = (self.Distance/10000) + (self.AirDuration/2)
		else
			self.Score = 10
		end
	end
	
	self.Score = self.Score * (self.Player.MaxScorePerStunt/10)
	self.Score = (ClampMinMax(self.Score, 0, self.Player.MaxScorePerStunt))
	--print("AirDuration = "..(self.AirDuration)..", duration = "..(self.Duration)..", distance = "..(self.Distance))
	--print(self.Player.Scores[self.ID] )
end