function testMC()
	local Player = ActiveMission.HumanPlayers[1]
	
	--New teleport
	local CarPos = Player.Car:GetMatrix():GetTranslation()
	local CarDir = Player.Car:GetMatrix():GetDirection()
	local Matrix = Matrix34():Translate(CarPos)
	
	local Up = Player.Car:GetMatrix():GetUp()
	if (Up.y < 0) then
		CarDir = CarDir * -1
	end
	
	Matrix = Matrix:LookAt(CarPos, CarPos + CarDir, 0)
	
	Matrix = Matrix:Translate(Vector(0,30,0))
	Player.Car:SetMatrix(Matrix)
	
	Player.Car:SetVelocity(VectorZero)
end

function Test_Teleport_1()
	local Car = ActiveMission.HumanPlayers[1].Car
	
	-- Rotate, then translate the Car
	--local TeleDest = Vector(1500, 10, -875)
	local TeleDest = Vector(-3566, 348, 2980)
	local RotatedMatrix = Matrix34():Rotate(Vector(0,1,0), 1.57079633) -- 90 degrees = 1.57079633 radians
	local CarMatrix = RotatedMatrix:SetTranslation(TeleDest)

	Car:SetVelocity(Vector(0,0,0))
	Car:SetMatrix(CarMatrix)
end

function Test_HideChassis()
	local Car = ActiveMission.HumanPlayers[1].Car
	Car:GetMesh():GetObject("Car_Chassis").Show = false
end

function Test_Autodrive()
	PhysicsThread:Spawn(function()
		local Player = ActiveMission:GetHumanPlayer(1)
		while (true) do
			Player.Car:Accelerate(5)
			Player.Car:ChangeGear(Player.Car:GetBestGear())
			Player.Car:Brake(0)
			
			Player.Car:Handbrake(0)
			
			PhysicsThread:Wait(15)
		end
	end)
end

function Test_SetSuperBrake(Enable)
	if(Enable) then
		IsSuperBraking = true
		local Car = ActiveMission.HumanPlayers[1].Car
		PhysicsThread:Spawn(function()
			while(IsSuperBraking) do
				Car:SetVelocity(Car:GetVelocity() / 1.5)
				PhysicsThread:Wait(10)
			end
		end)
	else
		IsSuperBraking = false -- Stops the above thread
	end
end

function Test_SuperBrake()
	PhysicsThread:Spawn(function()
		local Car = ActiveMission.HumanPlayers[1].Car
		local PhysicsMatrix = Car:GetPhysicsMatrix()
		local CarMatrix = Car:GetMatrix()
		teleport()
		Car:SetMatrix(CarMatrix)
		Car:SetPhysicsMatrix(PhysicsMatrix)
	end)
end

function Test_SetSuperBoost(Enable)
	if(Enable) then
		IsSuperBoosting = true
		local Car = ActiveMission.HumanPlayers[1].Car
		PhysicsThread:Spawn(function()
			while(IsSuperBoosting) do
				local ForceMultiplier = 10
				local DirectionVector = Car:GetMatrix():GetDirection() * (ForceMultiplier * -10000000)
				Car:AddForce(DirectionVector)
				PhysicsThread:Wait(1)
			end
		end)
	else
		IsSuperBoosting = false -- Stops the above thread
	end
end

function Test_ForceUserControl()
	local Player = ActiveMission.HumanPlayers[1]
	local Car = Player.Car

	Player.Driver:Enable()
	Car:Enable()
	Car:EnableInput()
end

function Test_SuspensionEnable()
	dofile("Lua\\SuspensionManager.lua")
	
	if(Suspension == nil) then
		Suspension = SuspensionManager(ActiveMission)
	end
	
	if(Suspension ~= nil) then
		Suspension:Enable()
	end
end

function Test_SuspensionDisable()
	if(Suspension ~= nil) then
		Suspension:Disable()
	end
end

function Test_SuspensionLift()
	local Buttons = {"DCK_KP8"}
	AddKeyListeners(Buttons, "Down", function(Listeners)
		local AxleOffsets = ActiveMission.HumanPlayers[1].Suspension.AxleOffsets
		AxleOffsets[0].y = AxleOffsets[0].y + 1
	end)
	
	local Buttons = {"DCK_KP5"}
	AddKeyListeners(Buttons, "Down", function(Listeners)
		local AxleOffsets = ActiveMission.HumanPlayers[1].Suspension.AxleOffsets
		AxleOffsets[0].y = AxleOffsets[0].y - 1
	end)
end

function Test_BindForceKeys()
	local Player = ActiveMission.HumanPlayers[1]
	
	AddKeyListeners("DCK_KP8", "Down", function(Listeners)
		PhysicsThread:Spawn(function()
			for i = 1, 10 do
				Player:CarAddPitchForce(4e+6)
				PhysicsThread:Wait(1)
			end
		end)
	end)
	
	AddKeyListeners("DCK_KP5", "Down", function(Listeners)
		PhysicsThread:Spawn(function()
			for i = 1, 10 do
				Player:CarAddPitchForce(-4e+6)
				PhysicsThread:Wait(1)
			end
		end)
	end)
	
	AddKeyListeners("DCK_KP4", "Down", function(Listeners)
		PhysicsThread:Spawn(function()
			for i = 1, 10 do
				Player:CarAddRollForce(-4e+6)
				PhysicsThread:Wait(1)
			end
		end)
	end)
	
	AddKeyListeners("DCK_KP6", "Down", function(Listeners)
		PhysicsThread:Spawn(function()
			for i = 1, 10 do
				Player:CarAddRollForce(4e+6)
				PhysicsThread:Wait(1)
			end
		end)
	end)
	
	AddKeyListeners("DCK_KP7", "Down", function(Listeners)
		PhysicsThread:Spawn(function()
			for i = 1, 25 do
				Player:CarAddYawForce(-5e+6)
				PhysicsThread:Wait(1)
			end
		end)
	end)
	
	AddKeyListeners("DCK_KP9", "Down", function(Listeners)
		PhysicsThread:Spawn(function()
			for i = 1, 25 do
				Player:CarAddYawForce(5e+6)
				PhysicsThread:Wait(1)
			end
		end)
	end)
end

function Test_PushCar()
	local Car = ActiveMission.HumanPlayers[1].Car
	local ForceMultiplier = 80
	local Direction = Car:GetMatrix():GetRight() * (ForceMultiplier * 10000000)
	
	Car:AddForce(Direction)
end

function Test_GetAngle()
	local Car = ActiveMission.HumanPlayers[1].Car
	local Angle = Car:GetMatrix():GetAxisAngle()
	
	local DegX = Angle.X * (180.0 / math.pi);
	local DegY = Angle.Y * (180.0 / math.pi);
	local DegZ = Angle.Z * (180.0 / math.pi);
	local DegVector = Vector(DegX, DegY, DegZ)
	print(DegVector)
end

function Test_GetAngle2()
	local Car = ActiveMission.HumanPlayers[1].Car
	local Up = Car:GetMatrix():GetUp()
	
	local PitchAngleRad = math.acos(Up:Dot(VectorY))
	local PitchAngleDeg = PitchAngleRad * (180.0 / math.pi)
	print("Angle: " ..PitchAngleDeg)
	
	local Cross = Up:Cross(VectorY)
	print(Cross)
end

dofile("Lua\\Utils\\Queue.lua")
function Test_StressQueue()
	if(ActiveMission.Queue == nil) then
		ActiveMission.Queue = Queue()
	end
	
	for i = 0, 1000 do
		ActiveMission.Queue:PushRight("Test")
		ActiveMission.Queue:PopLeft()
	end
end

function Test_StressQueueEnd()
	ActiveMission.Queue = nil
end

function Test_SpawnDemoTrucks()
	local DemoTruckNames = {
		"GraveDigger",
		"MohawkWarrior",
		"Max_D",
		"ElToroLoco"
	}
	local DemoTrucks = {}
	
	PhysicsThread:Spawn(function()
		for i = 1, #DemoTruckNames do
			local TruckName = DemoTruckNames[i]
			print("^2Spawning: " ..TruckName)
			local Car = LuaCar(TruckName, 0)
			GetEntityScene():AddEntity(Car)
			
			local CarMatrix = Matrix34()
			CarMatrix = CarMatrix:Rotate(Vector(0,1,0), math.rad(180))
			CarMatrix = CarMatrix:Translate(Vector(-175  + (70 * i), -21, -396))
			Car:SetMatrix(CarMatrix)
			
			-- Wait, otherwise the cars will stack before translating and rotating
			PhysicsThread:Wait(10)
			
			table.insert(DemoTrucks, Car)
		end
	end)
	
	AddKeyListeners("DCK_KP3", "Down", function(Listeners)
		for i = 1, #DemoTrucks do
			local Car = DemoTrucks[i]
			local Dir = Car:GetMatrix():GetDirection()
			
			local Magnitude = math.random(9, 10) * 1e+7
			local Force = Vector(0, 0, Magnitude)
			
			PhysicsThread:Spawn(function()
				for i = 1, 10 do
					Car:AddForce(Force)
					PhysicsThread:Wait(1)
				end
			end)
		end
	end)
	
	AddKeyListeners("DCK_KP4", "Down", function(Listeners)
		for i = 1, #DemoTrucks do
			local Car = DemoTrucks[i]
			local CarMatrix = Matrix34()
			CarMatrix = CarMatrix:Rotate(Vector(0,1,0), math.rad(180))
			CarMatrix = CarMatrix:Translate(Vector(-175  + (70 * i), -21, -396))
			Car:SetMatrix(CarMatrix)
		end
	end)
end

function Test_Write()
	local File = CreateFile("C:\\MCTest\\Test.dat", "Write", 50000)
	local Blob = Blob()
	
	local Car = ActiveMission.HumanPlayers[1].Car
	Blob:WriteMatrix(Car:GetMatrix())
	Blob:WriteFile(File)
end

function Test_Read()
	local File = CreateFile("C:\\MCTest\\Test.dat")
	local Blob = Blob()
	
	Blob:ReadFile(File)
	local Matrix = Blob:ReadMatrix(0)
	
	print(Matrix:__tostring())
end