ArmorUpgrade = class(BaseUpgrade, function(self)
	self.Type = UpgradeTypes.Armor
	
	self.MenuUpgrade = self.Upgrader:GetMenuCarUpgrade("garage_armor")
	self:SetLevel(self.MenuUpgrade.CurrentLevel)
end)

function ArmorUpgrade:Apply(CarBuilder)
	local HealthIncreaseFactor = 0.07
	
	-- Determine the new health
	local CurrentHealth = CarBuilder:GetMaxHP()
	local MultFactor = self:GetMultiplicationFactor()
	local HealthIncrease = CurrentHealth * (HealthIncreaseFactor * MultFactor)
	local NewHealth = CurrentHealth + HealthIncrease
	
	if(self.Debug) then
		self:AddDebugMessage("Upgraded health from " ..CurrentHealth .." to " ..NewHealth ..".")
	end
	
	-- Set the new health
	CarBuilder:SetMaxHP(NewHealth)
	
	self.Super.Apply(self)
	print("^2ArmorUpgrade applied (level " ..self.Level .."). Upgraded HP from " ..CurrentHealth .." to " ..NewHealth ..".")
end