EngineUpgrade = class(BaseUpgrade, function(self)
	self.Type = UpgradeTypes.Engine
	
	self.MenuUpgrade = self.Upgrader:GetMenuCarUpgrade("garage_engine")
	self:SetLevel(self.MenuUpgrade.CurrentLevel)
end)

function EngineUpgrade:Apply(CarBuilder)
	local TorqueScaleIncreaseFactor = 0.05

	-- Fetch the engine
	local Engine = CarBuilder:GetEngine()
	
	-- Determine the new torque scale
	local MultFactor = self:GetMultiplicationFactor()
	local CurrentTorqueScale = Engine:GetTorqueScale()
	local TorqueScaleIncrease = CurrentTorqueScale * (TorqueScaleIncreaseFactor * MultFactor)
	local NewTorqueScale = CurrentTorqueScale + TorqueScaleIncrease
	
	if(self.Debug) then
		self:AddDebugMessage("Upgraded torque scale from " ..CurrentTorqueScale .." to " ..NewTorqueScale ..".")
	end
	
	-- Set the new torque scale
	Engine:SetTorqueScale(NewTorqueScale)
	
	print("^2EngineUpgrade applied (level " ..self.Level ..").")
end