FrameUpgrade = class(BaseUpgrade, function(self)
	self.Type = UpgradeTypes.Frame
	
	self.MenuUpgrade = self.Upgrader:GetMenuCarUpgrade("garage_weight") -- "Frame weight"
	self:SetLevel(self.MenuUpgrade.CurrentLevel)
end)

function FrameUpgrade:Apply(CarBuilder)
	print("^2FrameUpgrade applied (level " ..self.Level ..").")
end

function FrameUpgrade:GetTerrainDamageReduction(Damage)
	local DamageReductionFactor = 0.1--03 -- 3% damage reduction per level
	
	local MultFactor = self:GetMultiplicationFactor()
	local DamageReduction = Damage * (MultFactor * DamageReductionFactor)
	
	if(self.Debug) then
		self:AddDebugMessage("Reducing terrain damage of " ..Round(Damage, 2) .." by " ..Round(DamageReduction, 2)
			.." (" ..(DamageReductionFactor * 100) .."%).")
	end
	
	return DamageReduction
end