MechanicBoostUpgrade = class(BaseUpgrade, function(self)
	self.Type = UpgradeTypes.MechanicBoost
	
	--if (MechanicActiveRaces > 0) then
	if (self.Upgrader.MenuCar.MechanicActiveRaces > 0) then
		print("^2MechanicBoostUpgrade activated")
		self:SetLevel(5)
	end
end)

function MechanicBoostUpgrade:Apply(CarBuilder)
	local BoostForceIncreaseFactor = 0.7
	local BoostFrictionIncreaseFactor = 0.2
	
	local MultFactor = self:GetMultiplicationFactor()
	
	--local BoostForceIncrease = 25000 -- Default 175000
	--local BoostFrictionIncrease = 0
	
	-- Apply boost increase to all wheels
	for i = 0, 3 do
		local Wheel = CarBuilder:GetWheel(i)
		local CurrentBoostForce = Wheel:GetBoostForce()
		local CurrentBoostFriction = Wheel:GetBoostFriction()
		
		local BoostForceIncrease = CurrentBoostForce * (BoostForceIncreaseFactor * MultFactor)
		local BoostFrictionIncrease = CurrentBoostFriction * (BoostFrictionIncreaseFactor * MultFactor)
		
		local NewBoostForce = CurrentBoostForce + BoostForceIncrease
		local NewBoostFriction = CurrentBoostFriction + BoostFrictionIncrease
		
		if(self.Debug) then
			self:AddDebugMessage("Upgraded boost force of wheel #" ..i .." from " ..CurrentBoostForce .." to " ..NewBoostForce ..".")
			self:AddDebugMessage("Upgraded boost friction of wheel #" ..i .." from " ..CurrentBoostFriction .." to " ..NewBoostFriction ..".")
		end
		
		Wheel:SetBoostForce(NewBoostForce)
		Wheel:SetBoostFriction(NewBoostFriction)
	end
	
	print("^2MechanicBoostUpgrade applied (level " ..self.Level ..").")
end