MechanicGearboxUpgrade = class(BaseUpgrade, function(self)
	self.Type = UpgradeTypes.MechanicGearbox
	
	--if (MechanicActiveRaces > 0) then
	if (self.Upgrader.MenuCar.MechanicActiveRaces > 0) then
		print("^2MechanicGearboxUpgrade activated")
		self:SetLevel(5)
	end
end)

function MechanicGearboxUpgrade:Apply(CarBuilder)
	local TorqueIncreaseFactor = 0.1 -- 0.03 -- 50 / 2000
	local HealthIncreaseFactor = 0.1--02 -- 100 / 7500
	local ErpDecreaseFactor = 0.03 -- 0.02 / 0.7
	local CfmDecreaseFactor = 0.04 -- 0.000002 / 0.00005
	
	local MultFactor = self:GetMultiplicationFactor()
	local Engine = CarBuilder:GetEngine()
	local CurrentTorqueScale = Engine:GetTorqueScale()
	local CurrentHealth = CarBuilder:GetMaxHP()
	
	--local TorqueIncrease = 50
	--local HealthIncrease = 100
	--local ErpIncrease = -0.02 -- Hoe diep de auto kan doorzakken op zijn wielen op impact. (minder = minder zakken) Default = 0.7
	--local CfmIncrease = -0.000002 -- Bounciness wielen op impact (minder = minder bounciness). Default = 0.00005
	
	-- Tweak the torque scale
	local TorqueScaleIncrease = CurrentTorqueScale * (MultFactor * TorqueIncreaseFactor)
	local NewTorqueScale = CurrentTorqueScale + TorqueScaleIncrease
	if(self.Debug) then
		self:AddDebugMessage("Upgraded torque scale from " ..CurrentTorqueScale .." to " ..NewTorqueScale ..".")
	end
	Engine:SetTorqueScale(NewTorqueScale)
	
	-- Tweak the health
	local HealthIncrease = CurrentHealth * (HealthIncreaseFactor * MultFactor)
	local NewHealth = CurrentHealth + HealthIncrease
	if(self.Debug) then
		self:AddDebugMessage("Upgraded health from " ..CurrentHealth .." to " ..NewHealth ..".")
	end
	CarBuilder:SetMaxHP(NewHealth)
	
	-- Tweak the suspension
	self:SetSuspension(CarBuilder, ErpDecreaseFactor, CfmDecreaseFactor)
	
	print("^2MechanicGearboxUpgrade applied (level " ..self.Level .."). Upgraded HP from "
		..CurrentHealth .." to " ..NewHealth ..".")
end