function MyClass(Arg1, Arg2)
	-- New class
	local Class = {}
	
	-- Arg parsing
	local Constructor = nil
	if (Arg1 ~= nil and Arg2 ~= nil) then
		-- Copy all members of the baseclass
		local Super = Arg1;
		
		-- Creeer een constructor die eerst de baseclass init
		Constructor = function(Object, ...)
			-- Init eerst de baseclass
			Super.Constructor(Object, ...)
			
			-- Init daarna jezelf
			Arg2(Object, ...);
		end
		
		for i,v in pairs(Super) do
			Class[i] = v
		end
		
		Class.Super = Arg1;

	else
		Constructor = Arg1;
	end
	
	-- Set de index functie
	Class.__index = Class;
	
	-- Maak de metatable
	local MetaTable = {}
	
	-- Maak de constructor
	MetaTable.__call = function(class_tbl, ...)
		local Object = {}

		-- Set de metatable
		setmetatable(Object, Class)
		
		-- Call de constructor van deze class
		Class.Constructor(Object,...)
		
		Object._Class = Class
		
		return Object
	end
	
	Class.Constructor = Constructor
	
	Class.is_a = function(self, klass)
		local m = getmetatable(self)
		while m do 
			if m == klass then
				return true
			end
			m = m.Super
		end
		
		return false
	end
	
	setmetatable(Class, MetaTable)
	
	return Class
end

class = MyClass