Event = class(function(self)
	self.Signaled = false
	self.Listeners = {}
end)

function Event:AddListener(Listener)
	if (not self.Signaled) then
		table.insert(self.Listeners, Listener)
	else
		Listener()
	end
end

function Event:DelListener(Listener)
	table.removeobject(self.Listeners, Listener)
end

function Event:Signal()
	self.Signaled = true
	
	for i, Listener in ipairs(self.Listeners) do
		Listener();
	end

	self.Listeners = {}	-- table.empty?
end

function Event:Reset()
	self.Signaled = false
end