-- Bonus object
BonusValue = class(function(self, ShowTreshold, ValueMult, Context, StartFunction, UpdateFunction, SucceedFunction, FailFunction)
	self.Active = false
	self.Value = 0
	self.ShowTreshold = ShowTreshold
	self.ValueMult = ValueMult
	self.Context = Context
	self.StartFunction = StartFunction
	self.UpdateFunction = UpdateFunction
	self.SucceedFunction = SucceedFunction
	self.FailFunction = FailFunction
end)

function BonusValue:Start()
	self.Active = true
	self.Value = 0;
end

function BonusValue:IsActive()
	return self.Active and self.Value > self.ShowTreshold
end

function BonusValue:Update(Value)
	if self.Active then
		local OldValue = self.Value;
		self.Value = Value;
		
		if OldValue <= self.ShowTreshold and Value > self.ShowTreshold then
			self.StartFunction(self.Context)
		end
		
		if (self:IsActive()) then
			self.UpdateFunction(self.Context, self.Value * self.ValueMult);
		end
	end
end

function BonusValue:Succeed()
	if (self.Active) then
		if (self:IsActive()) then
			self.SucceedFunction(self.Context, self.Value * self.ValueMult)
		end
		
		self.Active = false
		self.Value = 0;
	end
end

function BonusValue:Fail()
	if (self.Active) then
		if (self:IsActive()) then
			self.FailFunction(self.Context, self.Value * self.ValueMult)
		end
		
		self.Active = false
		self.Value = 0;
	end
end