Queue = class(function(self)
	self.First = 0
	self.Last = -1
	self.Count = 0
end)

function Queue:GetLeft()
	return self[self.First]
end

function Queue:GetRight()
	return self[self.Last]
end

function Queue:PushLeft(Value)
	local First = self.First - 1
	self.First = First
	self[First] = Value
	self.Count = self.Count + 1
end

function Queue:PushRight(Value)
	local Last = self.Last + 1
	self.Last = Last
	self[Last] = Value
	self.Count = self.Count + 1
end

function Queue:PopLeft()
	local First = self.First
	if First > self.Last then error("queue is empty") end
	local Value = self[First]
	self[First] = nil        -- to allow garbage collection
	self.First = First + 1
	self.Count = self.Count - 1
	return Value
end

function Queue:PopRight()
	local Last = self.Last
	if self.First > Last then error("queue is empty") end
	local Value = self[Last]
	self[Last] = nil         -- to allow garbage collection
	self.Last = Last - 1
	self.Count = self.Count - 1
	return Value
end