uniform vec4 World[3];
uniform vec4 ViewProj[4];

attribute vec4 Position;

vec3 mul3x4(vec4 V, vec4 M[3]){
	vec3 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	
	return ret;
}

vec4 mul4x4(vec4 V, vec4 M[4]){
	vec4 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	ret.w = dot(V, M[3]);
	
	return ret;
}

void main(){
	gl_Position.xyz = mul3x4(Position, World);
	gl_Position = mul4x4(vec4(gl_Position.xyz, 1.0), ViewProj);
}
