#ifndef WIN32
#extension GL_EXT_shadow_samplers : enable
#extension GL_NV_shadow : enable
#endif

#ifdef WIN32
highp float shadow2DEXT(sampler2DShadow Texture, highp vec4 Input){
	return shadow2DProj(Texture, Input).x;
}
#endif

uniform sampler2D Tex0;
uniform sampler2DShadow DepthTex;

varying lowp vec4 fColor;
varying highp vec2 fTex;
varying highp vec4 Vertex;

void main(){	
	//Get depth from depth texture
	highp float depthVal = shadow2DEXT(DepthTex, Vertex);
	
	//Set color
	gl_FragColor = texture2D(Tex0, fTex) * fColor * depthVal;
}