uniform vec4 World[3];
uniform vec4 ViewProj[4];

attribute vec4 Position;
attribute vec2 TexCoord0;

varying vec2 fTexCoord;

vec3 mul4x3(vec4 V, vec4 M[3]){
	vec3 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	
	return ret;
}

vec4 mul4x4(vec4 V, vec4 M[4]){
	vec4 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	ret.w = dot(V, M[3]);
	
	return ret;
}

void main(){
	vec3 Pos = mul4x3(Position, World);
	
	gl_Position = mul4x4(vec4(Pos, 1.0), ViewProj);
	fTexCoord = TexCoord0;
}
