uniform sampler2D Tex0;

uniform lowp vec4 BloomColor;

uniform lowp vec4 ColorOverlay; 
uniform lowp float InvGreyValue; 
uniform lowp vec3 GreyScale; 

varying mediump vec2 fTexCoord;

lowp vec4 DoColorOverlay(lowp vec4 Output){
	Output.xyz += ColorOverlay.xyz;
	
	lowp float OutputCopy = dot(Output.xyz, GreyScale);
	Output.xyz = Output.xyz * InvGreyValue + OutputCopy;
	return Output;
}

void main(){
    lowp vec4 Output = texture2D(Tex0, fTexCoord, -2.5);
	
#ifdef ALPHATEST
	if (Output.a < 0.5){
		discard;
	}
#endif
	//Output = DoColorOverlay(Output);
    
    gl_FragColor = Output * vec4(BloomColor.xyz, 1.0);
	//gl_FragColor.a = 0.0;
}

