uniform vec4 World[3];
uniform vec4 View[3];
uniform vec4 ViewProj[4];
uniform vec3 CamDir;
uniform vec3 CamPos;
uniform float FogNearSq;
uniform float InvFogRangeSq;
uniform lowp vec4 LerpFogColor;
uniform float Timer;

uniform vec4 AmbientColor;
uniform vec4 LightData[6];

/*struct Object{
	vec3 Scale;
	vec4 TexData;
};
uniform Object Objects[32];*/

uniform vec4 Objects[64];

attribute vec4 Position;
attribute vec3 Normal;
attribute vec2 TexCoord0;
attribute vec4 TexCoord1;
attribute vec4 TexCoord2;

varying vec2 fTexCoord;

vec4 mul4x3(vec4 V, vec4 M[3]){
	vec4 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	ret.w = 1.0;
	
	return ret;
}

vec4 mul4x4(vec4 V, vec4 M[4]){
	vec4 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	ret.w = dot(V, M[3]);
	
	return ret;
}

uniform vec3 TerrainOffset;
uniform vec3 TerrainSize;

float lengthsq(vec3 x){
	return dot(x, x);
}

void main(){
	vec4 InstanceData = TexCoord1;
	vec4 InstanceData2 = TexCoord2;

    vec3 InputPos = Position.xyz;
    
	InputPos.x += sin(InputPos.y * (Timer)) * 0.1;
	
	int ScaleIndex = int(InstanceData2.w) * 2;
	int TexCoordIndex = (int(InstanceData2.w) * 2) + 1;

	vec3 InstancePos = TerrainOffset + (InstanceData.xyz * TerrainSize);
	//Object InstanceObject = Objects[InstanceData2.w];
	
	vec3 Dir = CamPos - InstancePos;
	Dir.y = 0.0;
	Dir = normalize(Dir);
	
	mat3 Matrix;
	Matrix[0].xyz = cross(vec3(0, 1, 0), Dir) * Objects[ScaleIndex].x;
	Matrix[1].xyz = vec3(0, 1, 0) * Objects[ScaleIndex].y;
	Matrix[2].xyz = Dir * Objects[ScaleIndex].z;

	
	vec4 Pos;
	Pos.xyz = Matrix * InputPos;
	Pos.xyz += InstancePos;
	Pos.w = 1.0;

	gl_Position = mul4x4(Pos, ViewProj);
	fTexCoord = TexCoord0;
	
	fTexCoord = Objects[TexCoordIndex].xy + (TexCoord0 * Objects[TexCoordIndex].zw);
}
