#ifndef WIN32
#extension GL_EXT_shadow_samplers : enable
#endif

#ifdef WIN32
float shadow2DEXT(sampler2DShadow Texture, vec3 Input){
	return shadow2D(Texture, Input).x;
}
#endif

uniform sampler2D Tex0;
uniform lowp vec4 LerpFogColor;

uniform lowp vec4 FoliageAmbient;

uniform sampler2DShadow ShadowTex;

varying highp vec2 fTexCoord;

varying mediump vec3 fShadowPos;

void main(){
	lowp vec4 Diffuse = texture2D(Tex0, fTexCoord);
	
	lowp float Shadow = shadow2DEXT(ShadowTex, fShadowPos);

	lowp vec4 Output = Diffuse * (FoliageAmbient + (FoliageAmbient * Shadow));	// Let op: 2x ambient ipv 1x ambient en 1x diffuse

	gl_FragColor = Output;
}

