uniform vec4 World[3];
uniform vec4 View[3];

uniform vec4 ViewProj[4];

uniform lowp float ColorFade;

attribute vec4 Position;
attribute vec2 TexCoord0;

varying vec2 fTexCoord;

vec4 mul4x3(vec4 V, vec4 M[3]){
	vec4 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	ret.w = 1.0;
	
	return ret;
}


vec4 mul4x4(vec4 V, vec4 M[4]){
	vec4 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	ret.w = dot(V, M[3]);
	
	return ret;
}

void main(){
	vec4 WorldCopy[3];
	WorldCopy[0] = vec4(View[0].x, View[1].x, View[2].x, World[0].w);
	WorldCopy[1] = vec4(View[0].y, View[1].y, View[2].y, World[1].w);
	WorldCopy[2] = vec4(View[0].z, View[1].z, View[2].z, World[2].w);

	vec4 Pos = mul4x3(Position, WorldCopy);

	gl_Position = mul4x4(Pos, ViewProj);
	fTexCoord = TexCoord0;
}
