uniform vec4 ViewProj[4];
uniform vec3 CamPos;
uniform float FogNear;
uniform float InvFogRange;
uniform lowp vec4 LerpFogColor;

attribute vec3 Position;
attribute vec4 Color0;
attribute vec2 TexCoord0;

varying vec4 fColor;
varying vec2 fTexCoord;
varying float fFog;

vec4 mul4x4(vec4 V, vec4 M[4]) {
	vec4 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	ret.w = dot(V, M[3]);
	
	return ret;
}

void main() {
	fColor = Color0;
	fTexCoord = TexCoord0;
    
    vec3 CamDistance = CamPos - Position;
    fFog = clamp((length(CamDistance) - FogNear) * InvFogRange, 0.0, 1.0) * LerpFogColor.a;
    
	gl_Position = mul4x4(vec4(Position, 1), ViewProj);
}
