uniform sampler2D Tex0;
uniform sampler2D DepthTex;

varying highp vec2 fTexCoord;
varying highp vec4 fShadowSamples[4];

uniform highp float DepthTreshold;
uniform highp float DepthMultiplier;

highp float ComputeOutline(){
	highp vec4 Depth = texture2D(DepthTex, fTexCoord).xxxx;
	
	highp vec4 ShadowSamples[2];
	ShadowSamples[0].x = texture2D(DepthTex, fShadowSamples[0].xy).x;
	ShadowSamples[0].y = texture2D(DepthTex, fShadowSamples[0].zw).x;
	ShadowSamples[0].z = texture2D(DepthTex, fShadowSamples[1].xy).x;
	ShadowSamples[0].w = texture2D(DepthTex, fShadowSamples[1].zw).x;
	
	ShadowSamples[1].x = texture2D(DepthTex, fShadowSamples[2].xy).x;
	ShadowSamples[1].y = texture2D(DepthTex, fShadowSamples[2].zw).x;
	ShadowSamples[1].z = texture2D(DepthTex, fShadowSamples[3].xy).x;
	ShadowSamples[1].w = texture2D(DepthTex, fShadowSamples[3].zw).x;
	
	mediump vec4 AbsDiff[2];
	AbsDiff[0] = abs(Depth - ShadowSamples[0]);
	AbsDiff[1] = abs(Depth - ShadowSamples[1]);
	
	lowp vec4 Result[2];
	Result[0] = step(DepthTreshold, AbsDiff[0]);
	Result[1] = step(DepthTreshold, AbsDiff[1]);	
		
	mediump float Output = dot(Result[0], Result[0]) + dot(Result[1], Result[1]);
		
	return Output;// / 8;
}

void main(){
	lowp vec4 Color = texture2D(Tex0, fTexCoord);

	gl_FragColor = Color;

	highp float Outline = 1.0 - clamp(ComputeOutline() * DepthMultiplier * (Color.a), 0.0, 1.0);

	gl_FragColor.rgb *= Outline;
	gl_FragColor.a = 1.0;
}