uniform vec4 World[3];

attribute vec2 Position;
attribute vec2 TexCoord0;

varying vec2 fTexCoord;
varying vec4 fShadowSamples[4];

uniform highp vec2 InvRes;
uniform highp float Thickness;

void main(){
    vec2 InputPos = Position;
    
    vec2 P;
    P.x = InputPos.x * World[0].x + InputPos.y * World[0].y + World[0].w;
    P.y = InputPos.x * World[1].x + InputPos.y * World[1].y + World[1].w;
   
    fTexCoord.x = TexCoord0.x;
	fTexCoord.y = 1.0 - TexCoord0.y;
	
	fShadowSamples[0].xy = fTexCoord + vec2(-1.0 * InvRes.x * Thickness, -1.0 * InvRes.y * Thickness);
	fShadowSamples[0].zw = fTexCoord + vec2( 0.0 * InvRes.x * Thickness, -1.0 * InvRes.y * Thickness);
	fShadowSamples[1].xy = fTexCoord + vec2( 1.0 * InvRes.x * Thickness, -1.0 * InvRes.y * Thickness);
	
	fShadowSamples[1].zw = fTexCoord + vec2(-1.0 * InvRes.x * Thickness,  0.0 * InvRes.y * Thickness);
	fShadowSamples[2].xy = fTexCoord + vec2( 1.0 * InvRes.x * Thickness,  0.0 * InvRes.y * Thickness);
	
	fShadowSamples[2].zw = fTexCoord + vec2(-1.0 * InvRes.x * Thickness,  1.0 * InvRes.y * Thickness);
	fShadowSamples[3].xy = fTexCoord + vec2( 0.0 * InvRes.x * Thickness,  1.0 * InvRes.y * Thickness);
	fShadowSamples[3].zw = fTexCoord + vec2( 1.0 * InvRes.x * Thickness,  1.0 * InvRes.y * Thickness);

    gl_Position = vec4(P, 0, 1);
}
