uniform sampler2D Tex0;

varying lowp vec4 fColor;
varying highp vec2 fTexCoord;

void main(){
    lowp vec4 Color = texture2D(Tex0, fTexCoord);
	
	lowp vec2 ShadowOffset0 = vec2(0.004, 0.004);
	lowp vec2 ShadowOffset1 = vec2(0.005, 0.004);
	lowp vec2 ShadowOffset2 = vec2(0.004, 0.005);
	lowp vec2 ShadowOffset3 = vec2(0.005, 0.005);
	lowp vec4 ShadowColor = vec4(0.0, 0.0, 0.0, 0.75);
    
#ifdef WHITE
	Color.rgb = vec3(1.0, 1.0, 1.0);
#endif

	lowp vec4 Shadow0 = texture2D(Tex0, fTexCoord - ShadowOffset0);
	lowp vec4 Shadow1 = texture2D(Tex0, fTexCoord - ShadowOffset1);
	lowp vec4 Shadow2 = texture2D(Tex0, fTexCoord - ShadowOffset2);
	lowp vec4 Shadow3 = texture2D(Tex0, fTexCoord - ShadowOffset3);
	
	lowp vec4 Shadow = (Shadow0 + Shadow1 + Shadow2 + Shadow3) / 4.0;
	
	Color = mix(Shadow * ShadowColor, Color, Color.a);
	
	//Color.a = 1;

    gl_FragColor = Color * fColor;
}

